<?php
/** Start the engine */
require_once( TEMPLATEPATH . '/lib/init.php' );

/** Child theme (do not remove) */
define( 'CHILD_THEME_NAME', 'Modern Blogger Theme' );
define( 'CHILD_THEME_URL', 'http://market.studiopress.com/themes/modernblogger' );

/** Add new image sizes */
add_image_size('blog-excerpt', 567, 150, TRUE);
add_image_size('sidebar-featured', 245, 100, TRUE);

/** Add support for custom background */
add_custom_background();

/** Add support for custom header */
add_theme_support( 'genesis-custom-header', array( 'width' => 960, 'height' => 225 ) );

/** Modify speak your mind text in comments */
add_filter('genesis_comment_form_args', 'modernblogger_comment_form_args');
function modernblogger_comment_form_args($args) {
    $args['title_reply'] = 'join the conversation';
    return $args;
}

/** Modify post navigation */
add_action('genesis_before_comments', 'modernblogger_post_nav');
function modernblogger_post_nav(){

    echo '<div class="post-nav">';
    echo '<div class="next-post-nav">';
    echo '<span class="next">';
    echo 'Next Post';
    echo '</span>';
    echo next_post_link('%link', '%title');
    echo '</div>';
    echo '<div class="prev-post-nav">';
    echo '<span class="prev">';
    echo 'Previous Post';
    echo '</span>';
    echo previous_post_link('%link', '%title');
    echo '</div>';
    echo '</div>';

}

/** Add comment numbering */
add_action( 'genesis_before_comment', 'modernblogger_numbered_comments' );
function modernblogger_numbered_comments () {
    if (function_exists( 'gtcn_comment_numbering' ))
    echo gtcn_comment_numbering($comment->comment_ID, $args);
}  

/** Modify the excerpt more text */
add_filter( 'excerpt_more', 'modernblogger_excerpt_more' );
function modernblogger_excerpt_more($more) {
    return '<a href="'.get_permalink().'" rel="nofollow">  [Read On] </a>';
}

/** Customize the footer */
remove_action( 'genesis_footer', 'genesis_do_footer' );
add_action( 'genesis_footer', 'child_do_footer' );
function child_do_footer() {
    ?>
    <p>&copy; Copyright 2011 &middot; All Rights Reserved &middot; <a href="http://market.studiopress.com/themes/modernblogger">Modern Blogger Theme</a> on <a href="http://www.studiopress.com/themes/genesis">Genesis Framework</a></p>
    <?php
}

/** Register widget areas */
genesis_register_sidebar( array(
	'id'			=> 'slider',
	'name'			=> __( 'Slider', 'modernblogger' ),
	'description'	=> __( 'This is the slider section.', 'modernblogger' ),
) );
genesis_register_sidebar( array(
	'id'			=> 'homepage',
	'name'			=> __( 'Homepage', 'modernblogger' ),
	'description'	=> __( 'This is the homepage section.', 'modernblogger' ),
) );