/* DUPLICATOR MYSQL SCRIPT CREATED ON : October 25, 2013, 9:28 pm */

SET FOREIGN_KEY_CHECKS = 0;

CREATE TABLE `wp_commentmeta` (
  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `comment_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) DEFAULT NULL,
  `meta_value` longtext,
  PRIMARY KEY (`meta_id`),
  KEY `comment_id` (`comment_id`),
  KEY `meta_key` (`meta_key`)
) ENGINE=MyISAM AUTO_INCREMENT=19 DEFAULT CHARSET=utf8;

CREATE TABLE `wp_comments` (
  `comment_ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `comment_post_ID` bigint(20) unsigned NOT NULL DEFAULT '0',
  `comment_author` tinytext NOT NULL,
  `comment_author_email` varchar(100) NOT NULL DEFAULT '',
  `comment_author_url` varchar(200) NOT NULL DEFAULT '',
  `comment_author_IP` varchar(100) NOT NULL DEFAULT '',
  `comment_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `comment_date_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `comment_content` text NOT NULL,
  `comment_karma` int(11) NOT NULL DEFAULT '0',
  `comment_approved` varchar(20) NOT NULL DEFAULT '1',
  `comment_agent` varchar(255) NOT NULL DEFAULT '',
  `comment_type` varchar(20) NOT NULL DEFAULT '',
  `comment_parent` bigint(20) unsigned NOT NULL DEFAULT '0',
  `user_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`comment_ID`),
  KEY `comment_post_ID` (`comment_post_ID`),
  KEY `comment_approved_date_gmt` (`comment_approved`,`comment_date_gmt`),
  KEY `comment_date_gmt` (`comment_date_gmt`),
  KEY `comment_parent` (`comment_parent`)
) ENGINE=MyISAM AUTO_INCREMENT=11 DEFAULT CHARSET=utf8;

CREATE TABLE `wp_duplicator` (
  `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `token` varchar(25) NOT NULL,
  `packname` varchar(250) NOT NULL,
  `zipname` varchar(250) NOT NULL,
  `zipsize` int(11) DEFAULT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `owner` varchar(60) NOT NULL,
  `settings` longtext NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=latin1;

CREATE TABLE `wp_links` (
  `link_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `link_url` varchar(255) NOT NULL DEFAULT '',
  `link_name` varchar(255) NOT NULL DEFAULT '',
  `link_image` varchar(255) NOT NULL DEFAULT '',
  `link_target` varchar(25) NOT NULL DEFAULT '',
  `link_description` varchar(255) NOT NULL DEFAULT '',
  `link_visible` varchar(20) NOT NULL DEFAULT 'Y',
  `link_owner` bigint(20) unsigned NOT NULL DEFAULT '1',
  `link_rating` int(11) NOT NULL DEFAULT '0',
  `link_updated` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `link_rel` varchar(255) NOT NULL DEFAULT '',
  `link_notes` mediumtext NOT NULL,
  `link_rss` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`link_id`),
  KEY `link_visible` (`link_visible`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `wp_options` (
  `option_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `option_name` varchar(64) NOT NULL DEFAULT '',
  `option_value` longtext NOT NULL,
  `autoload` varchar(20) NOT NULL DEFAULT 'yes',
  PRIMARY KEY (`option_id`),
  UNIQUE KEY `option_name` (`option_name`)
) ENGINE=MyISAM AUTO_INCREMENT=4574 DEFAULT CHARSET=utf8;

CREATE TABLE `wp_postmeta` (
  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `post_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) DEFAULT NULL,
  `meta_value` longtext,
  PRIMARY KEY (`meta_id`),
  KEY `post_id` (`post_id`),
  KEY `meta_key` (`meta_key`)
) ENGINE=MyISAM AUTO_INCREMENT=1560 DEFAULT CHARSET=utf8;

CREATE TABLE `wp_posts` (
  `ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `post_author` bigint(20) unsigned NOT NULL DEFAULT '0',
  `post_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_date_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_content` longtext NOT NULL,
  `post_title` text NOT NULL,
  `post_excerpt` text NOT NULL,
  `post_status` varchar(20) NOT NULL DEFAULT 'publish',
  `comment_status` varchar(20) NOT NULL DEFAULT 'open',
  `ping_status` varchar(20) NOT NULL DEFAULT 'open',
  `post_password` varchar(20) NOT NULL DEFAULT '',
  `post_name` varchar(200) NOT NULL DEFAULT '',
  `to_ping` text NOT NULL,
  `pinged` text NOT NULL,
  `post_modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_modified_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_content_filtered` longtext NOT NULL,
  `post_parent` bigint(20) unsigned NOT NULL DEFAULT '0',
  `guid` varchar(255) NOT NULL DEFAULT '',
  `menu_order` int(11) NOT NULL DEFAULT '0',
  `post_type` varchar(20) NOT NULL DEFAULT 'post',
  `post_mime_type` varchar(100) NOT NULL DEFAULT '',
  `comment_count` bigint(20) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`),
  KEY `post_name` (`post_name`),
  KEY `type_status_date` (`post_type`,`post_status`,`post_date`,`ID`),
  KEY `post_parent` (`post_parent`),
  KEY `post_author` (`post_author`)
) ENGINE=MyISAM AUTO_INCREMENT=449 DEFAULT CHARSET=utf8;

CREATE TABLE `wp_term_relationships` (
  `object_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `term_taxonomy_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `term_order` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`object_id`,`term_taxonomy_id`),
  KEY `term_taxonomy_id` (`term_taxonomy_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `wp_term_taxonomy` (
  `term_taxonomy_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `term_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `taxonomy` varchar(32) NOT NULL DEFAULT '',
  `description` longtext NOT NULL,
  `parent` bigint(20) unsigned NOT NULL DEFAULT '0',
  `count` bigint(20) NOT NULL DEFAULT '0',
  PRIMARY KEY (`term_taxonomy_id`),
  UNIQUE KEY `term_id_taxonomy` (`term_id`,`taxonomy`),
  KEY `taxonomy` (`taxonomy`)
) ENGINE=MyISAM AUTO_INCREMENT=52 DEFAULT CHARSET=utf8;

CREATE TABLE `wp_terms` (
  `term_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(200) NOT NULL DEFAULT '',
  `slug` varchar(200) NOT NULL DEFAULT '',
  `term_group` bigint(10) NOT NULL DEFAULT '0',
  PRIMARY KEY (`term_id`),
  UNIQUE KEY `slug` (`slug`),
  KEY `name` (`name`)
) ENGINE=MyISAM AUTO_INCREMENT=51 DEFAULT CHARSET=utf8;

CREATE TABLE `wp_usermeta` (
  `umeta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) DEFAULT NULL,
  `meta_value` longtext,
  PRIMARY KEY (`umeta_id`),
  KEY `user_id` (`user_id`),
  KEY `meta_key` (`meta_key`)
) ENGINE=MyISAM AUTO_INCREMENT=21 DEFAULT CHARSET=utf8;

CREATE TABLE `wp_users` (
  `ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `user_login` varchar(60) NOT NULL DEFAULT '',
  `user_pass` varchar(64) NOT NULL DEFAULT '',
  `user_nicename` varchar(50) NOT NULL DEFAULT '',
  `user_email` varchar(100) NOT NULL DEFAULT '',
  `user_url` varchar(100) NOT NULL DEFAULT '',
  `user_registered` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `user_activation_key` varchar(60) NOT NULL DEFAULT '',
  `user_status` int(11) NOT NULL DEFAULT '0',
  `display_name` varchar(250) NOT NULL DEFAULT '',
  PRIMARY KEY (`ID`),
  KEY `user_login_key` (`user_login`),
  KEY `user_nicename` (`user_nicename`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;

CREATE TABLE `wp_woocommerce_attribute_taxonomies` (
  `attribute_id` bigint(20) NOT NULL AUTO_INCREMENT,
  `attribute_name` varchar(200) NOT NULL,
  `attribute_label` longtext,
  `attribute_type` varchar(200) NOT NULL,
  `attribute_orderby` varchar(200) NOT NULL,
  PRIMARY KEY (`attribute_id`),
  KEY `attribute_name` (`attribute_name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `wp_woocommerce_downloadable_product_permissions` (
  `download_id` varchar(32) NOT NULL,
  `product_id` bigint(20) NOT NULL,
  `order_id` bigint(20) NOT NULL DEFAULT '0',
  `order_key` varchar(200) NOT NULL,
  `user_email` varchar(200) NOT NULL,
  `user_id` bigint(20) DEFAULT NULL,
  `downloads_remaining` varchar(9) DEFAULT NULL,
  `access_granted` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `access_expires` datetime DEFAULT NULL,
  `download_count` bigint(20) NOT NULL DEFAULT '0',
  PRIMARY KEY (`product_id`,`order_id`,`order_key`,`download_id`),
  KEY `download_order_product` (`download_id`,`order_id`,`product_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `wp_woocommerce_order_itemmeta` (
  `meta_id` bigint(20) NOT NULL AUTO_INCREMENT,
  `order_item_id` bigint(20) NOT NULL,
  `meta_key` varchar(255) DEFAULT NULL,
  `meta_value` longtext,
  PRIMARY KEY (`meta_id`),
  KEY `order_item_id` (`order_item_id`),
  KEY `meta_key` (`meta_key`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `wp_woocommerce_order_items` (
  `order_item_id` bigint(20) NOT NULL AUTO_INCREMENT,
  `order_item_name` longtext NOT NULL,
  `order_item_type` varchar(200) NOT NULL DEFAULT '',
  `order_id` bigint(20) NOT NULL,
  PRIMARY KEY (`order_item_id`),
  KEY `order_id` (`order_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `wp_woocommerce_tax_rate_locations` (
  `location_id` bigint(20) NOT NULL AUTO_INCREMENT,
  `location_code` varchar(255) NOT NULL,
  `tax_rate_id` bigint(20) NOT NULL,
  `location_type` varchar(40) NOT NULL,
  PRIMARY KEY (`location_id`),
  KEY `location_type` (`location_type`),
  KEY `location_type_code` (`location_type`,`location_code`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `wp_woocommerce_tax_rates` (
  `tax_rate_id` bigint(20) NOT NULL AUTO_INCREMENT,
  `tax_rate_country` varchar(200) NOT NULL DEFAULT '',
  `tax_rate_state` varchar(200) NOT NULL DEFAULT '',
  `tax_rate` varchar(200) NOT NULL DEFAULT '',
  `tax_rate_name` varchar(200) NOT NULL DEFAULT '',
  `tax_rate_priority` bigint(20) NOT NULL,
  `tax_rate_compound` int(1) NOT NULL DEFAULT '0',
  `tax_rate_shipping` int(1) NOT NULL DEFAULT '1',
  `tax_rate_order` bigint(20) NOT NULL,
  `tax_rate_class` varchar(200) NOT NULL DEFAULT '',
  PRIMARY KEY (`tax_rate_id`),
  KEY `tax_rate_country` (`tax_rate_country`),
  KEY `tax_rate_state` (`tax_rate_state`),
  KEY `tax_rate_class` (`tax_rate_class`),
  KEY `tax_rate_priority` (`tax_rate_priority`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `wp_woocommerce_termmeta` (
  `meta_id` bigint(20) NOT NULL AUTO_INCREMENT,
  `woocommerce_term_id` bigint(20) NOT NULL,
  `meta_key` varchar(255) DEFAULT NULL,
  `meta_value` longtext,
  PRIMARY KEY (`meta_id`),
  KEY `woocommerce_term_id` (`woocommerce_term_id`),
  KEY `meta_key` (`meta_key`)
) ENGINE=MyISAM AUTO_INCREMENT=28 DEFAULT CHARSET=utf8;


/* INSERT TABLE DATA: wp_commentmeta */
INSERT INTO `wp_commentmeta` VALUES("2", "8", "akismet_history", "a:4:{s:4:\"time\";d:1380626578.4245970249176025390625;s:7:\"message\";s:92:\"Akismet was unable to check this comment (response: ), will automatically retry again later.\";s:5:\"event\";s:11:\"check-error\";s:4:\"user\";s:0:\"\";}");
INSERT INTO `wp_commentmeta` VALUES("4", "8", "akismet_history", "a:4:{s:4:\"time\";d:1380668195.5890510082244873046875;s:7:\"message\";s:46:\"healthydog changed the comment status to trash\";s:5:\"event\";s:12:\"status-trash\";s:4:\"user\";s:10:\"healthydog\";}");
INSERT INTO `wp_commentmeta` VALUES("5", "8", "_wp_trash_meta_status", "0");
INSERT INTO `wp_commentmeta` VALUES("6", "8", "_wp_trash_meta_time", "1380668195");
INSERT INTO `wp_commentmeta` VALUES("8", "9", "akismet_history", "a:4:{s:4:\"time\";d:1381147639.720715999603271484375;s:7:\"message\";s:92:\"Akismet was unable to check this comment (response: ), will automatically retry again later.\";s:5:\"event\";s:11:\"check-error\";s:4:\"user\";s:0:\"\";}");
INSERT INTO `wp_commentmeta` VALUES("10", "9", "akismet_history", "a:4:{s:4:\"time\";d:1381173546.360002040863037109375;s:7:\"message\";s:46:\"healthydog changed the comment status to trash\";s:5:\"event\";s:12:\"status-trash\";s:4:\"user\";s:10:\"healthydog\";}");
INSERT INTO `wp_commentmeta` VALUES("11", "9", "_wp_trash_meta_status", "0");
INSERT INTO `wp_commentmeta` VALUES("12", "9", "_wp_trash_meta_time", "1381173546");
INSERT INTO `wp_commentmeta` VALUES("14", "10", "akismet_history", "a:4:{s:4:\"time\";d:1381189491.355907917022705078125;s:7:\"message\";s:92:\"Akismet was unable to check this comment (response: ), will automatically retry again later.\";s:5:\"event\";s:11:\"check-error\";s:4:\"user\";s:0:\"\";}");
INSERT INTO `wp_commentmeta` VALUES("16", "10", "akismet_history", "a:4:{s:4:\"time\";d:1381868611.12987804412841796875;s:7:\"message\";s:46:\"healthydog changed the comment status to trash\";s:5:\"event\";s:12:\"status-trash\";s:4:\"user\";s:10:\"healthydog\";}");
INSERT INTO `wp_commentmeta` VALUES("17", "10", "_wp_trash_meta_status", "0");
INSERT INTO `wp_commentmeta` VALUES("18", "10", "_wp_trash_meta_time", "1381868611");

/* INSERT TABLE DATA: wp_comments */
INSERT INTO `wp_comments` VALUES("2", "91", "Brian Gardner", "brian@briangardner.com", "", "76.29.60.137", "2013-01-01 19:13:54", "2013-01-01 19:13:54", "This is an example of a comment made on a post. You can either edit the comment, delete the comment or reply to the comment. Use this as a place to respond to the post or to share what you are thinking.", "0", "post-trashed", "", "", "0", "1");
INSERT INTO `wp_comments` VALUES("3", "91", "Brian Gardner", "brian@briangardner.com", "", "76.29.60.137", "2013-01-01 19:14:04", "2013-01-01 19:14:04", "This is an example of a nested threaded comment which is new in WordPress 2.7. This is where you can reply to a comment that was previously made, and visually makes reading comments to much easier.", "0", "post-trashed", "", "", "2", "1");
INSERT INTO `wp_comments` VALUES("4", "91", "Brian Gardner", "brian@briangardner.com", "", "76.29.60.137", "2013-01-01 19:14:11", "2013-01-01 19:14:11", "This is an example of a comment made on a post. You can either edit the comment, delete the comment or reply to the comment. Use this as a place to respond to the post or to share what you are thinking.", "0", "post-trashed", "", "", "0", "1");
INSERT INTO `wp_comments` VALUES("5", "91", "Brian Gardner", "brian@briangardner.com", "", "76.29.60.137", "2013-01-01 19:14:19", "2013-01-01 19:14:19", "This is an example of a nested threaded comment which is new in WordPress 2.7. This is where you can reply to a comment that was previously made, and visually makes reading comments to much easier.", "0", "post-trashed", "", "", "4", "1");
INSERT INTO `wp_comments` VALUES("6", "91", "Brian Gardner", "brian@briangardner.com", "", "76.29.60.137", "2013-01-01 19:14:25", "2013-01-01 19:14:25", "This is an example of a nested threaded comment which is new in WordPress 2.7. This is where you can reply to a comment that was previously made, and visually makes reading comments to much easier.", "0", "post-trashed", "", "", "5", "1");
INSERT INTO `wp_comments` VALUES("7", "91", "Brian Gardner", "brian@briangardner.com", "", "76.29.60.137", "2013-01-01 19:14:38", "2013-01-01 19:14:38", "This is an example of a comment made on a post. You can either edit the comment, delete the comment or reply to the comment. Use this as a place to respond to the post or to share what you are thinking.", "0", "post-trashed", "", "", "0", "1");
INSERT INTO `wp_comments` VALUES("8", "89", "Tweleirrelt", "galina.neznaikina@yandex.com", "http://light.prosto50.ru/?ref=EJKXD", "89.178.229.121", "2013-10-01 11:22:58", "2013-10-01 11:22:58", "Сегодня 01.10.2013 открылся новый проект Просто Лайт!!! \r\n \r\nПодробная информация и регистрация: http://light.prosto50.ru/?ref=EJKXD \r\n \r\nХотите зарабатывать деньги в интернете, но не знаете как? Наверняка Вы мечтаете обрести финансовую свободу? \r\nМы Вам поможем! Кстати, свой первый шаг к успеху Вы уже сделали - Вы на нашем сайте! Теперь Вам осталось решить: \r\nХотите ли Вы зарабатывать РЕАЛЬНЫЕ деньги и быть финансово независимым. Или оставить все как прежде? \r\n \r\nПреимущества проекта: \r\n \r\nВсе расчеты осуществляются через систему QIWI (без процентов и комиссий), только между участниками, что гарантирует \r\nсохранность Ваших денег. Нет ограничения по рефералам на 1 уровне, а следовательно и на уровнях выше может быть любое \r\nколичество рефералов. Нет лимита продаж уровней. Очень удобная короткая матрица и стоимость уровней ниже, что позволяет \r\nбыстро и легко заработать много денег!!! \r\n \r\nОтличия проекта Лайт от Просто50 \r\n \r\nНет ограничения по рефералам на 1 уровне, а следовательно и на уровнях выше может быть любое количество рефералов. \r\nНет лимита продаж уровней. Очень удобная короткая матрица и стоимость уровней ниже, что позволяет быстро и легко \r\nзаработать много денег!!! \r\n \r\nСтоимость уровней: \r\n \r\nУровень	  Цена	     Рефералы \r\n1.	  50 Руб     Неограниченно \r\n2.	  150 Руб    Неограниченно \r\n3.	  300 Руб    Неограниченно \r\n4.	  600 Руб    Неограниченно \r\n5.	  900 Руб    Неограниченно", "0", "post-trashed", "Mozilla/5.0 (Windows NT 5.1; rv:16.0) Gecko/20121026 Firefox/16.0 SeaMonkey/2.13.2", "", "0", "0");
INSERT INTO `wp_comments` VALUES("9", "89", "Tweleirrelt", "lina.alina-galckina@yandex.com", "http://light.prosto50.ru/?ref=schemer", "128.69.238.43", "2013-10-07 12:07:19", "2013-10-07 12:07:19", "Всем привет!!! Открылся новый проект Просто Лайт!!! Этой осенью, исполняется год проекту Просто50. На протяжении всего года в нем приняло участие более 8 тысяч человек, \r\nкоторые улучшили свое материальное положение. Была проведена огромная работа и получен бесценный опыт, которые позволили \r\nразработать инновационный маркетинг, лишенный недостатков обычных матриц, получивший название Лайт. Любители матриц по \r\nдостоинству оценят новый проект Лайт, где стоимость уровней дешевле, а доход больше. Зарабатывать станет еще легче! \r\n \r\nРегистрация тут: http://light.prosto50.ru/?ref=EJKXD", "0", "post-trashed", "Mozilla/5.0 (Windows NT 5.1; rv:17.0) Gecko/20100101 Firefox/17.0", "", "0", "0");
INSERT INTO `wp_comments` VALUES("10", "89", "Google", "", "http://www.google.com/pnnbjrpq", "178.32.229.155", "2013-10-07 23:44:51", "2013-10-07 23:44:51", "<strong>Google</strong>\n\nJust beneath, are numerous entirely not associated web-sites to ours, having said that, they\'re surely really worth going over.", "0", "post-trashed", "Opera/9.80 (S60; SymbOS; Opera Mobi/1209; U; sk) Presto/2.5.28 Version/10.1", "trackback", "0", "0");

/* INSERT TABLE DATA: wp_duplicator */
INSERT INTO `wp_duplicator` VALUES("1", "5268173faa5523416", "20131023_healthydogheadquarters", "5268173faa5523416_20131023_healthydogheadquarters_package.zip", "26368231", "2013-10-23 18:37:41", "healthydog", "a:4:{s:14:\"plugin_version\";s:5:\"0.4.6\";s:4:\"type\";s:6:\"Manual\";s:6:\"status\";s:4:\"Pass\";s:5:\"notes\";s:0:\"\";}");
INSERT INTO `wp_duplicator` VALUES("2", "526ae28deea113956", "20131025_healthydogheadquarters", "526ae28deea113956_20131025_healthydogheadquarters_package.zip", "0", "2013-10-25 21:28:45", "healthydog", "a:4:{s:14:\"plugin_version\";s:5:\"0.4.6\";s:4:\"type\";s:6:\"Manual\";s:6:\"status\";s:5:\"Error\";s:5:\"notes\";s:0:\"\";}");

/* INSERT TABLE DATA: wp_options */
INSERT INTO `wp_options` VALUES("1", "siteurl", "http://healthydoghq.com", "yes");
INSERT INTO `wp_options` VALUES("2", "blogname", "Healthy Dog Headquarters", "yes");
INSERT INTO `wp_options` VALUES("3", "blogdescription", "Healthy Dog Headquarters", "yes");
INSERT INTO `wp_options` VALUES("4", "users_can_register", "0", "yes");
INSERT INTO `wp_options` VALUES("5", "admin_email", "admin@healthydoghq.com", "yes");
INSERT INTO `wp_options` VALUES("6", "start_of_week", "1", "yes");
INSERT INTO `wp_options` VALUES("7", "use_balanceTags", "0", "yes");
INSERT INTO `wp_options` VALUES("8", "use_smilies", "1", "yes");
INSERT INTO `wp_options` VALUES("9", "require_name_email", "", "yes");
INSERT INTO `wp_options` VALUES("10", "comments_notify", "", "yes");
INSERT INTO `wp_options` VALUES("11", "posts_per_rss", "10", "yes");
INSERT INTO `wp_options` VALUES("12", "rss_use_excerpt", "1", "yes");
INSERT INTO `wp_options` VALUES("13", "mailserver_url", "mail.example.com", "yes");
INSERT INTO `wp_options` VALUES("14", "mailserver_login", "login@example.com", "yes");
INSERT INTO `wp_options` VALUES("15", "mailserver_pass", "password", "yes");
INSERT INTO `wp_options` VALUES("16", "mailserver_port", "110", "yes");
INSERT INTO `wp_options` VALUES("17", "default_category", "1", "yes");
INSERT INTO `wp_options` VALUES("18", "default_comment_status", "closed", "yes");
INSERT INTO `wp_options` VALUES("19", "default_ping_status", "closed", "yes");
INSERT INTO `wp_options` VALUES("20", "default_pingback_flag", "", "yes");
INSERT INTO `wp_options` VALUES("21", "posts_per_page", "10", "yes");
INSERT INTO `wp_options` VALUES("22", "date_format", "F j, Y", "yes");
INSERT INTO `wp_options` VALUES("23", "time_format", "g:i a", "yes");
INSERT INTO `wp_options` VALUES("24", "links_updated_date_format", "F j, Y g:i a", "yes");
INSERT INTO `wp_options` VALUES("25", "links_recently_updated_prepend", "<em>", "yes");
INSERT INTO `wp_options` VALUES("26", "links_recently_updated_append", "</em>", "yes");
INSERT INTO `wp_options` VALUES("27", "links_recently_updated_time", "120", "yes");
INSERT INTO `wp_options` VALUES("28", "comment_moderation", "", "yes");
INSERT INTO `wp_options` VALUES("29", "moderation_notify", "", "yes");
INSERT INTO `wp_options` VALUES("30", "permalink_structure", "/%postname%/", "yes");
INSERT INTO `wp_options` VALUES("31", "gzipcompression", "0", "yes");
INSERT INTO `wp_options` VALUES("32", "hack_file", "0", "yes");
INSERT INTO `wp_options` VALUES("33", "blog_charset", "UTF-8", "yes");
INSERT INTO `wp_options` VALUES("34", "moderation_keys", "", "no");
INSERT INTO `wp_options` VALUES("35", "active_plugins", "a:13:{i:0;s:19:\"akismet/akismet.php\";i:1;s:25:\"duplicator/duplicator.php\";i:2;s:59:\"genesis-connect-woocommerce/genesis-connect-woocommerce.php\";i:3;s:33:\"genesis-enews-extended/plugin.php\";i:4;s:28:\"genesis-grid-loop/plugin.php\";i:5;s:55:\"genesis-responsive-slider/genesis-responsive-slider.php\";i:6;s:29:\"image-widget/image-widget.php\";i:7;s:19:\"jetpack/jetpack.php\";i:8;s:47:\"regenerate-thumbnails/regenerate-thumbnails.php\";i:9;s:43:\"simple-social-icons/simple-social-icons.php\";i:10;s:27:\"woocommerce/woocommerce.php\";i:11;s:41:\"wordpress-importer/wordpress-importer.php\";i:12;s:24:\"wordpress-seo/wp-seo.php\";}", "yes");
INSERT INTO `wp_options` VALUES("36", "home", "http://healthydoghq.com", "yes");
INSERT INTO `wp_options` VALUES("37", "category_base", "", "yes");
INSERT INTO `wp_options` VALUES("38", "ping_sites", "http://rpc.pingomatic.com/", "yes");
INSERT INTO `wp_options` VALUES("39", "advanced_edit", "0", "yes");
INSERT INTO `wp_options` VALUES("40", "comment_max_links", "2", "yes");
INSERT INTO `wp_options` VALUES("41", "gmt_offset", "0", "yes");
INSERT INTO `wp_options` VALUES("42", "default_email_category", "1", "yes");
INSERT INTO `wp_options` VALUES("43", "recently_edited", "a:5:{i:0;s:67:\"/home/healthyd/public_html/wp-content/themes/healthydoghq/style.css\";i:2;s:71:\"/home/healthyd/public_html/wp-content/themes/healthydoghq/functions.php\";i:3;s:74:\"/home/healthyd/public_html/wp-content/plugins/genesis-grid-loop/plugin.php\";i:4;s:62:\"/home/healthyd/public_html/wp-content/themes/genesis/style.css\";i:5;s:66:\"/home/healthyd/public_html/wp-content/themes/healthydoghq/home.php\";}", "no");
INSERT INTO `wp_options` VALUES("44", "template", "genesis", "yes");
INSERT INTO `wp_options` VALUES("45", "stylesheet", "healthydoghq", "yes");
INSERT INTO `wp_options` VALUES("46", "comment_whitelist", "", "yes");
INSERT INTO `wp_options` VALUES("47", "blacklist_keys", "", "no");
INSERT INTO `wp_options` VALUES("48", "comment_registration", "", "yes");
INSERT INTO `wp_options` VALUES("49", "html_type", "text/html", "yes");
INSERT INTO `wp_options` VALUES("50", "use_trackback", "0", "yes");
INSERT INTO `wp_options` VALUES("51", "default_role", "subscriber", "yes");
INSERT INTO `wp_options` VALUES("52", "db_version", "25824", "yes");
INSERT INTO `wp_options` VALUES("53", "uploads_use_yearmonth_folders", "1", "yes");
INSERT INTO `wp_options` VALUES("54", "upload_path", "", "yes");
INSERT INTO `wp_options` VALUES("55", "blog_public", "1", "yes");
INSERT INTO `wp_options` VALUES("56", "default_link_category", "2", "yes");
INSERT INTO `wp_options` VALUES("57", "show_on_front", "posts", "yes");
INSERT INTO `wp_options` VALUES("58", "tag_base", "", "yes");
INSERT INTO `wp_options` VALUES("59", "show_avatars", "", "yes");
INSERT INTO `wp_options` VALUES("60", "avatar_rating", "G", "yes");
INSERT INTO `wp_options` VALUES("61", "upload_url_path", "", "yes");
INSERT INTO `wp_options` VALUES("62", "thumbnail_size_w", "150", "yes");
INSERT INTO `wp_options` VALUES("63", "thumbnail_size_h", "150", "yes");
INSERT INTO `wp_options` VALUES("64", "thumbnail_crop", "1", "yes");
INSERT INTO `wp_options` VALUES("65", "medium_size_w", "300", "yes");
INSERT INTO `wp_options` VALUES("66", "medium_size_h", "300", "yes");
INSERT INTO `wp_options` VALUES("67", "avatar_default", "mystery", "yes");
INSERT INTO `wp_options` VALUES("68", "large_size_w", "1024", "yes");
INSERT INTO `wp_options` VALUES("69", "large_size_h", "1024", "yes");
INSERT INTO `wp_options` VALUES("70", "image_default_link_type", "file", "yes");
INSERT INTO `wp_options` VALUES("71", "image_default_size", "", "yes");
INSERT INTO `wp_options` VALUES("72", "image_default_align", "", "yes");
INSERT INTO `wp_options` VALUES("73", "close_comments_for_old_posts", "", "yes");
INSERT INTO `wp_options` VALUES("74", "close_comments_days_old", "14", "yes");
INSERT INTO `wp_options` VALUES("75", "thread_comments", "", "yes");
INSERT INTO `wp_options` VALUES("76", "thread_comments_depth", "5", "yes");
INSERT INTO `wp_options` VALUES("77", "page_comments", "", "yes");
INSERT INTO `wp_options` VALUES("78", "comments_per_page", "50", "yes");
INSERT INTO `wp_options` VALUES("79", "default_comments_page", "newest", "yes");
INSERT INTO `wp_options` VALUES("80", "comment_order", "asc", "yes");
INSERT INTO `wp_options` VALUES("81", "sticky_posts", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("82", "widget_categories", "a:4:{i:2;a:4:{s:5:\"title\";s:0:\"\";s:5:\"count\";i:0;s:12:\"hierarchical\";i:0;s:8:\"dropdown\";i:0;}i:3;a:4:{s:5:\"title\";s:10:\"Categories\";s:5:\"count\";i:0;s:12:\"hierarchical\";i:0;s:8:\"dropdown\";i:1;}i:4;a:4:{s:5:\"title\";s:10:\"Categories\";s:5:\"count\";i:0;s:12:\"hierarchical\";i:1;s:8:\"dropdown\";i:0;}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("83", "widget_text", "a:3:{i:5;a:3:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:275:\"<center>\r\n<img src=\"http://prettydarncute.com/demos/modernbloggerpro/wp-content/uploads/2013/07/space.png\">\r\n<br>\r\n<a href=\"http://www.bowsiewowsie.com\" target=\"_blank\">\r\n <img src=\"http://healthydoghq.com/wp-content/uploads/2013/10/bowsiewowsie-ad.jpg\" />\r\n</a>\r\n\r\n</center>\";s:6:\"filter\";b:0;}i:6;a:3:{s:5:\"title\";s:32:\"This is text above the portfolio\";s:4:\"text\";s:14:\"Text text text\";s:6:\"filter\";b:0;}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("84", "widget_rss", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("85", "uninstall_plugins", "a:1:{s:25:\"duplicator/duplicator.php\";s:20:\"duplicator_uninstall\";}", "no");
INSERT INTO `wp_options` VALUES("86", "timezone_string", "", "yes");
INSERT INTO `wp_options` VALUES("87", "page_for_posts", "0", "yes");
INSERT INTO `wp_options` VALUES("88", "page_on_front", "0", "yes");
INSERT INTO `wp_options` VALUES("89", "default_post_format", "0", "yes");
INSERT INTO `wp_options` VALUES("90", "link_manager_enabled", "0", "yes");
INSERT INTO `wp_options` VALUES("91", "initial_db_version", "24448", "yes");
INSERT INTO `wp_options` VALUES("92", "wp_user_roles", "a:7:{s:13:\"administrator\";a:2:{s:4:\"name\";s:13:\"Administrator\";s:12:\"capabilities\";a:115:{s:13:\"switch_themes\";b:1;s:11:\"edit_themes\";b:1;s:16:\"activate_plugins\";b:1;s:12:\"edit_plugins\";b:1;s:10:\"edit_users\";b:1;s:10:\"edit_files\";b:1;s:14:\"manage_options\";b:1;s:17:\"moderate_comments\";b:1;s:17:\"manage_categories\";b:1;s:12:\"manage_links\";b:1;s:12:\"upload_files\";b:1;s:6:\"import\";b:1;s:15:\"unfiltered_html\";b:1;s:10:\"edit_posts\";b:1;s:17:\"edit_others_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:10:\"edit_pages\";b:1;s:4:\"read\";b:1;s:8:\"level_10\";b:1;s:7:\"level_9\";b:1;s:7:\"level_8\";b:1;s:7:\"level_7\";b:1;s:7:\"level_6\";b:1;s:7:\"level_5\";b:1;s:7:\"level_4\";b:1;s:7:\"level_3\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:17:\"edit_others_pages\";b:1;s:20:\"edit_published_pages\";b:1;s:13:\"publish_pages\";b:1;s:12:\"delete_pages\";b:1;s:19:\"delete_others_pages\";b:1;s:22:\"delete_published_pages\";b:1;s:12:\"delete_posts\";b:1;s:19:\"delete_others_posts\";b:1;s:22:\"delete_published_posts\";b:1;s:20:\"delete_private_posts\";b:1;s:18:\"edit_private_posts\";b:1;s:18:\"read_private_posts\";b:1;s:20:\"delete_private_pages\";b:1;s:18:\"edit_private_pages\";b:1;s:18:\"read_private_pages\";b:1;s:12:\"delete_users\";b:1;s:12:\"create_users\";b:1;s:17:\"unfiltered_upload\";b:1;s:14:\"edit_dashboard\";b:1;s:14:\"update_plugins\";b:1;s:14:\"delete_plugins\";b:1;s:15:\"install_plugins\";b:1;s:13:\"update_themes\";b:1;s:14:\"install_themes\";b:1;s:11:\"update_core\";b:1;s:10:\"list_users\";b:1;s:12:\"remove_users\";b:1;s:9:\"add_users\";b:1;s:13:\"promote_users\";b:1;s:18:\"edit_theme_options\";b:1;s:13:\"delete_themes\";b:1;s:6:\"export\";b:1;s:18:\"manage_woocommerce\";b:1;s:24:\"view_woocommerce_reports\";b:1;s:12:\"edit_product\";b:1;s:12:\"read_product\";b:1;s:14:\"delete_product\";b:1;s:13:\"edit_products\";b:1;s:20:\"edit_others_products\";b:1;s:16:\"publish_products\";b:1;s:21:\"read_private_products\";b:1;s:15:\"delete_products\";b:1;s:23:\"delete_private_products\";b:1;s:25:\"delete_published_products\";b:1;s:22:\"delete_others_products\";b:1;s:21:\"edit_private_products\";b:1;s:23:\"edit_published_products\";b:1;s:20:\"manage_product_terms\";b:1;s:18:\"edit_product_terms\";b:1;s:20:\"delete_product_terms\";b:1;s:20:\"assign_product_terms\";b:1;s:15:\"edit_shop_order\";b:1;s:15:\"read_shop_order\";b:1;s:17:\"delete_shop_order\";b:1;s:16:\"edit_shop_orders\";b:1;s:23:\"edit_others_shop_orders\";b:1;s:19:\"publish_shop_orders\";b:1;s:24:\"read_private_shop_orders\";b:1;s:18:\"delete_shop_orders\";b:1;s:26:\"delete_private_shop_orders\";b:1;s:28:\"delete_published_shop_orders\";b:1;s:25:\"delete_others_shop_orders\";b:1;s:24:\"edit_private_shop_orders\";b:1;s:26:\"edit_published_shop_orders\";b:1;s:23:\"manage_shop_order_terms\";b:1;s:21:\"edit_shop_order_terms\";b:1;s:23:\"delete_shop_order_terms\";b:1;s:23:\"assign_shop_order_terms\";b:1;s:16:\"edit_shop_coupon\";b:1;s:16:\"read_shop_coupon\";b:1;s:18:\"delete_shop_coupon\";b:1;s:17:\"edit_shop_coupons\";b:1;s:24:\"edit_others_shop_coupons\";b:1;s:20:\"publish_shop_coupons\";b:1;s:25:\"read_private_shop_coupons\";b:1;s:19:\"delete_shop_coupons\";b:1;s:27:\"delete_private_shop_coupons\";b:1;s:29:\"delete_published_shop_coupons\";b:1;s:26:\"delete_others_shop_coupons\";b:1;s:25:\"edit_private_shop_coupons\";b:1;s:27:\"edit_published_shop_coupons\";b:1;s:24:\"manage_shop_coupon_terms\";b:1;s:22:\"edit_shop_coupon_terms\";b:1;s:24:\"delete_shop_coupon_terms\";b:1;s:24:\"assign_shop_coupon_terms\";b:1;}}s:6:\"editor\";a:2:{s:4:\"name\";s:6:\"Editor\";s:12:\"capabilities\";a:34:{s:17:\"moderate_comments\";b:1;s:17:\"manage_categories\";b:1;s:12:\"manage_links\";b:1;s:12:\"upload_files\";b:1;s:15:\"unfiltered_html\";b:1;s:10:\"edit_posts\";b:1;s:17:\"edit_others_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:10:\"edit_pages\";b:1;s:4:\"read\";b:1;s:7:\"level_7\";b:1;s:7:\"level_6\";b:1;s:7:\"level_5\";b:1;s:7:\"level_4\";b:1;s:7:\"level_3\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:17:\"edit_others_pages\";b:1;s:20:\"edit_published_pages\";b:1;s:13:\"publish_pages\";b:1;s:12:\"delete_pages\";b:1;s:19:\"delete_others_pages\";b:1;s:22:\"delete_published_pages\";b:1;s:12:\"delete_posts\";b:1;s:19:\"delete_others_posts\";b:1;s:22:\"delete_published_posts\";b:1;s:20:\"delete_private_posts\";b:1;s:18:\"edit_private_posts\";b:1;s:18:\"read_private_posts\";b:1;s:20:\"delete_private_pages\";b:1;s:18:\"edit_private_pages\";b:1;s:18:\"read_private_pages\";b:1;}}s:6:\"author\";a:2:{s:4:\"name\";s:6:\"Author\";s:12:\"capabilities\";a:10:{s:12:\"upload_files\";b:1;s:10:\"edit_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:4:\"read\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:12:\"delete_posts\";b:1;s:22:\"delete_published_posts\";b:1;}}s:11:\"contributor\";a:2:{s:4:\"name\";s:11:\"Contributor\";s:12:\"capabilities\";a:5:{s:10:\"edit_posts\";b:1;s:4:\"read\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:12:\"delete_posts\";b:1;}}s:10:\"subscriber\";a:2:{s:4:\"name\";s:10:\"Subscriber\";s:12:\"capabilities\";a:2:{s:4:\"read\";b:1;s:7:\"level_0\";b:1;}}s:8:\"customer\";a:2:{s:4:\"name\";s:8:\"Customer\";s:12:\"capabilities\";a:3:{s:4:\"read\";b:1;s:10:\"edit_posts\";b:0;s:12:\"delete_posts\";b:0;}}s:12:\"shop_manager\";a:2:{s:4:\"name\";s:12:\"Shop Manager\";s:12:\"capabilities\";a:92:{s:7:\"level_9\";b:1;s:7:\"level_8\";b:1;s:7:\"level_7\";b:1;s:7:\"level_6\";b:1;s:7:\"level_5\";b:1;s:7:\"level_4\";b:1;s:7:\"level_3\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:4:\"read\";b:1;s:18:\"read_private_pages\";b:1;s:18:\"read_private_posts\";b:1;s:10:\"edit_users\";b:1;s:10:\"edit_posts\";b:1;s:10:\"edit_pages\";b:1;s:20:\"edit_published_posts\";b:1;s:20:\"edit_published_pages\";b:1;s:18:\"edit_private_pages\";b:1;s:18:\"edit_private_posts\";b:1;s:17:\"edit_others_posts\";b:1;s:17:\"edit_others_pages\";b:1;s:13:\"publish_posts\";b:1;s:13:\"publish_pages\";b:1;s:12:\"delete_posts\";b:1;s:12:\"delete_pages\";b:1;s:20:\"delete_private_pages\";b:1;s:20:\"delete_private_posts\";b:1;s:22:\"delete_published_pages\";b:1;s:22:\"delete_published_posts\";b:1;s:19:\"delete_others_posts\";b:1;s:19:\"delete_others_pages\";b:1;s:17:\"manage_categories\";b:1;s:12:\"manage_links\";b:1;s:17:\"moderate_comments\";b:1;s:15:\"unfiltered_html\";b:1;s:12:\"upload_files\";b:1;s:6:\"export\";b:1;s:6:\"import\";b:1;s:18:\"manage_woocommerce\";b:1;s:24:\"view_woocommerce_reports\";b:1;s:12:\"edit_product\";b:1;s:12:\"read_product\";b:1;s:14:\"delete_product\";b:1;s:13:\"edit_products\";b:1;s:20:\"edit_others_products\";b:1;s:16:\"publish_products\";b:1;s:21:\"read_private_products\";b:1;s:15:\"delete_products\";b:1;s:23:\"delete_private_products\";b:1;s:25:\"delete_published_products\";b:1;s:22:\"delete_others_products\";b:1;s:21:\"edit_private_products\";b:1;s:23:\"edit_published_products\";b:1;s:20:\"manage_product_terms\";b:1;s:18:\"edit_product_terms\";b:1;s:20:\"delete_product_terms\";b:1;s:20:\"assign_product_terms\";b:1;s:15:\"edit_shop_order\";b:1;s:15:\"read_shop_order\";b:1;s:17:\"delete_shop_order\";b:1;s:16:\"edit_shop_orders\";b:1;s:23:\"edit_others_shop_orders\";b:1;s:19:\"publish_shop_orders\";b:1;s:24:\"read_private_shop_orders\";b:1;s:18:\"delete_shop_orders\";b:1;s:26:\"delete_private_shop_orders\";b:1;s:28:\"delete_published_shop_orders\";b:1;s:25:\"delete_others_shop_orders\";b:1;s:24:\"edit_private_shop_orders\";b:1;s:26:\"edit_published_shop_orders\";b:1;s:23:\"manage_shop_order_terms\";b:1;s:21:\"edit_shop_order_terms\";b:1;s:23:\"delete_shop_order_terms\";b:1;s:23:\"assign_shop_order_terms\";b:1;s:16:\"edit_shop_coupon\";b:1;s:16:\"read_shop_coupon\";b:1;s:18:\"delete_shop_coupon\";b:1;s:17:\"edit_shop_coupons\";b:1;s:24:\"edit_others_shop_coupons\";b:1;s:20:\"publish_shop_coupons\";b:1;s:25:\"read_private_shop_coupons\";b:1;s:19:\"delete_shop_coupons\";b:1;s:27:\"delete_private_shop_coupons\";b:1;s:29:\"delete_published_shop_coupons\";b:1;s:26:\"delete_others_shop_coupons\";b:1;s:25:\"edit_private_shop_coupons\";b:1;s:27:\"edit_published_shop_coupons\";b:1;s:24:\"manage_shop_coupon_terms\";b:1;s:22:\"edit_shop_coupon_terms\";b:1;s:24:\"delete_shop_coupon_terms\";b:1;s:24:\"assign_shop_coupon_terms\";b:1;}}}", "yes");
INSERT INTO `wp_options` VALUES("93", "widget_search", "a:3:{i:2;a:1:{s:5:\"title\";s:0:\"\";}i:3;a:1:{s:5:\"title\";s:22:\"Looking for Something?\";}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("94", "widget_recent-posts", "a:2:{i:2;a:2:{s:5:\"title\";s:0:\"\";s:6:\"number\";i:5;}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("95", "widget_recent-comments", "a:2:{i:2;a:2:{s:5:\"title\";s:0:\"\";s:6:\"number\";i:5;}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("96", "widget_archives", "a:3:{i:2;a:3:{s:5:\"title\";s:0:\"\";s:5:\"count\";i:0;s:8:\"dropdown\";i:0;}i:3;a:3:{s:5:\"title\";s:8:\"Archives\";s:5:\"count\";i:0;s:8:\"dropdown\";i:0;}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("97", "widget_meta", "a:2:{i:2;a:1:{s:5:\"title\";s:0:\"\";}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("98", "sidebars_widgets", "a:11:{s:19:\"wp_inactive_widgets\";a:11:{i:0;s:10:\"archives-2\";i:1;s:32:\"genesisresponsiveslider-widget-4\";i:2;s:6:\"meta-2\";i:3;s:8:\"search-2\";i:4;s:12:\"categories-2\";i:5;s:14:\"recent-posts-2\";i:6;s:17:\"recent-comments-2\";i:7;s:32:\"genesisresponsiveslider-widget-3\";i:8;s:14:\"user-profile-2\";i:9;s:15:\"featured-page-3\";i:10;s:15:\"featured-post-2\";}s:12:\"header-right\";a:1:{i:0;s:11:\"enews-ext-2\";}s:7:\"sidebar\";a:7:{i:0;s:21:\"simple-social-icons-2\";i:1;s:15:\"featured-page-2\";i:2;s:15:\"featured-post-3\";i:3;s:6:\"text-5\";i:4;s:12:\"categories-4\";i:5;s:11:\"tag_cloud-3\";i:6;s:10:\"archives-3\";}s:11:\"sidebar-alt\";a:2:{i:0;s:11:\"tag_cloud-2\";i:1;s:7:\"pages-2\";}s:14:\"portfolioblurb\";a:1:{i:0;s:6:\"text-6\";}s:6:\"slider\";a:0:{}s:7:\"adspace\";a:1:{i:0;s:17:\"widget_sp_image-4\";}s:8:\"footer-1\";a:1:{i:0;s:8:\"search-3\";}s:8:\"footer-2\";a:1:{i:0;s:10:\"nav_menu-2\";}s:8:\"footer-3\";a:1:{i:0;s:12:\"categories-3\";}s:13:\"array_version\";i:3;}", "yes");
INSERT INTO `wp_options` VALUES("99", "cron", "a:11:{i:1382737134;a:1:{s:32:\"woocommerce_cancel_unpaid_orders\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:0:{}}}}i:1382738622;a:1:{s:20:\"jetpack_clean_nonces\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:6:\"hourly\";s:4:\"args\";a:0:{}s:8:\"interval\";i:3600;}}}i:1382745600;a:1:{s:27:\"woocommerce_scheduled_sales\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1382761853;a:3:{s:16:\"wp_version_check\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}s:17:\"wp_update_plugins\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}s:16:\"wp_update_themes\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}}i:1382770800;a:1:{s:20:\"wp_maybe_auto_update\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}}i:1382775296;a:1:{s:28:\"woocommerce_cleanup_sessions\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}}i:1382786578;a:1:{s:24:\"akismet_scheduled_delete\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1382805226;a:1:{s:19:\"wp_scheduled_delete\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1382815809;a:1:{s:30:\"wp_scheduled_auto_draft_delete\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1383087823;a:1:{s:17:\"jetpack_heartbeat\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:14:\"jetpack_weekly\";s:4:\"args\";a:0:{}s:8:\"interval\";i:604800;}}}s:7:\"version\";i:2;}", "yes");
INSERT INTO `wp_options` VALUES("192", "_site_transient_update_themes", "O:8:\"stdClass\":3:{s:12:\"last_checked\";i:1382714277;s:7:\"checked\";a:5:{s:7:\"genesis\";s:5:\"2.0.1\";s:12:\"healthydoghq\";s:3:\"1.0\";s:13:\"modernblogger\";s:3:\"1.0\";s:14:\"twentythirteen\";s:3:\"1.0\";s:12:\"twentytwelve\";s:3:\"1.2\";}s:8:\"response\";a:0:{}}", "yes");
INSERT INTO `wp_options` VALUES("4572", "_site_transient_timeout_theme_roots", "1382738307", "yes");
INSERT INTO `wp_options` VALUES("4573", "_site_transient_theme_roots", "a:5:{s:7:\"genesis\";s:7:\"/themes\";s:12:\"healthydoghq\";s:7:\"/themes\";s:13:\"modernblogger\";s:7:\"/themes\";s:14:\"twentythirteen\";s:7:\"/themes\";s:12:\"twentytwelve\";s:7:\"/themes\";}", "yes");
INSERT INTO `wp_options` VALUES("109", "dashboard_widget_options", "a:4:{s:25:\"dashboard_recent_comments\";a:1:{s:5:\"items\";i:5;}s:24:\"dashboard_incoming_links\";a:5:{s:4:\"home\";s:23:\"http://healthydoghq.com\";s:4:\"link\";s:99:\"http://blogsearch.google.com/blogsearch?scoring=d&partner=wordpress&q=link:http://healthydoghq.com/\";s:3:\"url\";s:132:\"http://blogsearch.google.com/blogsearch_feeds?scoring=d&ie=utf-8&num=10&output=rss&partner=wordpress&q=link:http://healthydoghq.com/\";s:5:\"items\";i:10;s:9:\"show_date\";b:0;}s:17:\"dashboard_primary\";a:7:{s:4:\"link\";s:26:\"http://wordpress.org/news/\";s:3:\"url\";s:31:\"http://wordpress.org/news/feed/\";s:5:\"title\";s:14:\"WordPress Blog\";s:5:\"items\";i:2;s:12:\"show_summary\";i:1;s:11:\"show_author\";i:0;s:9:\"show_date\";i:1;}s:19:\"dashboard_secondary\";a:7:{s:4:\"link\";s:28:\"http://planet.wordpress.org/\";s:3:\"url\";s:33:\"http://planet.wordpress.org/feed/\";s:5:\"title\";s:20:\"Other WordPress News\";s:5:\"items\";i:5;s:12:\"show_summary\";i:0;s:11:\"show_author\";i:0;s:9:\"show_date\";i:0;}}", "yes");
INSERT INTO `wp_options` VALUES("4437", "_transient_timeout_feed_ac0b00fe65abe10e0c5b588f3ed8c7ca", "1382751089", "no");
INSERT INTO `wp_options` VALUES("4438", "_transient_feed_ac0b00fe65abe10e0c5b588f3ed8c7ca", "a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n\n\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:51:\"\n	\n	\n	\n	\n	\n	\n		\n		\n	\n	\n		\n		\n		\n		\n		\n		\n		\n		\n		\n	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:3:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"WordPress News\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:25:\"http://wordpress.org/news\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"WordPress News\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:13:\"lastBuildDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 24 Oct 2013 22:40:34 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"en-US\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:9:\"generator\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/?v=3.8-alpha\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:10:{i:0;a:6:{s:4:\"data\";s:42:\"\n		\n		\n		\n		\n		\n				\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:25:\"WordPress 3.7 “Basie”\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:40:\"http://wordpress.org/news/2013/10/basie/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:49:\"http://wordpress.org/news/2013/10/basie/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 24 Oct 2013 22:35:10 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=2736\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:357:\"Version 3.7 of WordPress, named &#8220;Basie&#8221; in honor of Count Basie, is available for download or update in your WordPress dashboard. This release features some of the most important architectural updates we&#8217;ve made to date. Here are the big ones: Updates while you sleep: With WordPress 3.7, you don&#8217;t have to lift a finger to [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:17229:\"<p>Version 3.7 of WordPress, named &#8220;Basie&#8221; in honor of <a href=\"http://en.wikipedia.org/wiki/Count_basie\">Count Basie</a>, is available <a href=\"http://wordpress.org/download/\">for download</a> or update in your WordPress dashboard. This release features some of the most important architectural updates we&#8217;ve made to date. Here are the big ones:</p>\n<ul>\n<li><strong>Updates while you sleep</strong>: With WordPress 3.7, you don&#8217;t have to lift a finger to apply maintenance and security updates. Most sites are now able to automatically apply these updates in the background. The update process also has been made even more reliable and secure, with dozens of new checks and safeguards.</li>\n<li><strong>Stronger password recommendations</strong>: Your password is your site&#8217;s first line of defense. It&#8217;s best to create passwords that are complex, long, and unique. To that end, our password meter has been updated in WordPress 3.7 to recognize common mistakes that can weaken your password: dates, names, keyboard patterns (123456789), and even pop culture references.</li>\n<li><strong>Better global support</strong>: Localized versions of WordPress will receive faster and more complete translations. WordPress 3.7 adds support for automatically installing the right language files and keeping them up to date, a boon for the many millions who use WordPress in a language other than English.</li>\n</ul>\n<p>For developers there are lots of options around how to control the new updates feature, including allowing it to handle major upgrades as well as minor ones, more sophisticated date query support, and multisite improvements. As always, if you&#8217;re hungry for more <a href=\"http://codex.wordpress.org/Version_3.7\">dive into the Codex</a> or browse the <a href=\"http://core.trac.wordpress.org/query?status=closed&amp;group=resolution&amp;milestone=3.7\">over 400 closed tickets on Trac</a>.</p>\n<h3>A New Wave</h3>\n<p>This release was led by Andrew Nacin, backed up by Dion Hulse and Jon Cave. This is our first release using the new plugin-first development process, with a much shorter timeframe than in the past. (3.6 was released in August.) The 3.8 release, due in December, will continue this plugin-led development cycle that gives much more autonomy to plugin leads and allows us to decouple feature development from a release. You can follow this grand experiment, and what we&#8217;re learning from it, <a href=\"http://make.wordpress.org/core/\">on the make/core blog</a>. There are 211 contributors with props in this release:</p>\n<p><a href=\"http://profiles.wordpress.org/technosailor\">Aaron Brazell</a>, <a href=\"http://profiles.wordpress.org/aaroncampbell\">Aaron D. Campbell</a>, <a href=\"http://profiles.wordpress.org/aaronholbrook\">Aaron Holbrook</a>, <a href=\"http://profiles.wordpress.org/jorbin\">Aaron Jorbin</a>, <a href=\"http://profiles.wordpress.org/adamsilverstein\">adamsilverstein</a>, <a href=\"http://profiles.wordpress.org/ahoereth\">Alexander Hoereth</a>, <a href=\"http://profiles.wordpress.org/viper007bond\">Alex Mills (Viper007Bond)</a>, <a href=\"http://profiles.wordpress.org/sabreuse\">Amy Hendrix (sabreuse)</a>, <a href=\"http://profiles.wordpress.org/andg\">andg</a>, <a href=\"http://profiles.wordpress.org/nacin\">Andrew Nacin</a>, <a href=\"http://profiles.wordpress.org/norcross\">Andrew Norcross</a>, <a href=\"http://profiles.wordpress.org/azaozz\">Andrew Ozz</a>, <a href=\"http://profiles.wordpress.org/andrewspittle\">Andrew Spittle</a>, <a href=\"http://profiles.wordpress.org/askapache\">askapache</a>, <a href=\"http://profiles.wordpress.org/atimmer\">atimmer</a>, <a href=\"http://profiles.wordpress.org/barry\">Barry</a>, <a href=\"http://profiles.wordpress.org/beaulebens\">Beau Lebens</a>, <a href=\"http://profiles.wordpress.org/benmoody\">ben.moody</a>, <a href=\"http://profiles.wordpress.org/bhengh\">Ben Miller</a>, <a href=\"http://profiles.wordpress.org/neoxx\">Bernhard Riedl</a>, <a href=\"http://profiles.wordpress.org/bftrick\">BFTrick</a>, <a href=\"http://profiles.wordpress.org/bananastalktome\">Billy (bananastalktome)</a>, <a href=\"http://profiles.wordpress.org/bmb\">bmb</a>, <a href=\"http://profiles.wordpress.org/kraftbj\">Brandon Kraft</a>, <a href=\"http://profiles.wordpress.org/brianhogg\">brianhogg</a>, <a href=\"http://profiles.wordpress.org/rzen\">Brian Richards</a>, <a href=\"http://profiles.wordpress.org/bpetty\">Bryan Petty</a>, <a href=\"http://profiles.wordpress.org/carldanley\">Carl Danley</a>, <a href=\"http://profiles.wordpress.org/charlesclarkson\">CharlesClarkson</a>, <a href=\"http://profiles.wordpress.org/chipbennett\">Chip Bennett</a>, <a href=\"http://profiles.wordpress.org/chouby\">Chouby</a>, <a href=\"http://profiles.wordpress.org/c3mdigital\">Chris Olbekson</a>, <a href=\"http://profiles.wordpress.org/chrisrudzki\">Chris Rudzki</a>, <a href=\"http://profiles.wordpress.org/aeg0125\">coderaaron</a>, <a href=\"http://profiles.wordpress.org/coenjacobs\">Coen Jacobs</a>, <a href=\"http://profiles.wordpress.org/crrobi01\">Colin Robinson</a>, <a href=\"http://profiles.wordpress.org/andreasnrb\">cyonite</a>, <a href=\"http://profiles.wordpress.org/daankortenbach\">Daan Kortenbach</a>, <a href=\"http://profiles.wordpress.org/danielbachhuber\">Daniel Bachhuber</a>, <a href=\"http://profiles.wordpress.org/convissor\">Daniel Convissor</a>, <a href=\"http://profiles.wordpress.org/dartiss\">dartiss</a>, <a href=\"http://profiles.wordpress.org/koop\">Daryl Koopersmith</a>, <a href=\"http://profiles.wordpress.org/csixty4\">Dave Ross</a>, <a href=\"http://profiles.wordpress.org/davidjlaietta\">David Laietta</a>, <a href=\"http://profiles.wordpress.org/dd32\">Dion Hulse</a>, <a href=\"http://profiles.wordpress.org/dllh\">dllh</a>, <a href=\"http://profiles.wordpress.org/ocean90\">Dominik Schilling (ocean90)</a>, <a href=\"http://profiles.wordpress.org/dpash\">dpash</a>, <a href=\"http://profiles.wordpress.org/drewapicture\">Drew Jaynes</a>, <a href=\"http://profiles.wordpress.org/drprotocols\">DrProtocols</a>, <a href=\"http://profiles.wordpress.org/dustyf\">Dustin Filippini</a>, <a href=\"http://profiles.wordpress.org/dzver\">dzver</a>, <a href=\"http://profiles.wordpress.org/cais\">Edward Caissie</a>, <a href=\"http://profiles.wordpress.org/enej\">enej</a>, <a href=\"http://profiles.wordpress.org/ericlewis\">Eric Andrew Lewis</a>, <a href=\"http://profiles.wordpress.org/ericmann\">Eric Mann</a>, <a href=\"http://profiles.wordpress.org/evansolomon\">Evan Solomon</a>, <a href=\"http://profiles.wordpress.org/faishal\">faishal</a>, <a href=\"http://profiles.wordpress.org/faison\">Faison</a>, <a href=\"http://profiles.wordpress.org/foofy\">Foofy</a>, <a href=\"http://profiles.wordpress.org/fjarrett\">Frankie Jarrett</a>, <a href=\"http://profiles.wordpress.org/frank-klein\">Frank Klein</a>, <a href=\"http://profiles.wordpress.org/garyc40\">Gary Cao</a>, <a href=\"http://profiles.wordpress.org/pento\">Gary Pendergast</a>, <a href=\"http://profiles.wordpress.org/gayadesign\">Gaya Kessler</a>, <a href=\"http://profiles.wordpress.org/georgestephanis\">George Stephanis</a>, <a href=\"http://profiles.wordpress.org/gizburdt\">Gizburdt</a>, <a href=\"http://profiles.wordpress.org/goldenapples\">goldenapples</a>, <a href=\"http://profiles.wordpress.org/gradyetc\">gradyetc</a>, <a href=\"http://profiles.wordpress.org/gcorne\">Gregory Cornelius</a>, <a href=\"http://profiles.wordpress.org/webord\">Gustavo Bordoni</a>, <a href=\"http://profiles.wordpress.org/hakre\">hakre</a>, <a href=\"http://profiles.wordpress.org/helen\">Helen Hou-Sandi</a>, <a href=\"http://profiles.wordpress.org/iandunn\">Ian Dunn</a>, <a href=\"http://profiles.wordpress.org/ipstenu\">Ipstenu (Mika Epstein)</a>, <a href=\"http://profiles.wordpress.org/creativeinfusion\">itinerant</a>, <a href=\"http://profiles.wordpress.org/jdgrimes\">J.D. Grimes</a>, <a href=\"http://profiles.wordpress.org/jakubtyrcha\">jakub.tyrcha</a>, <a href=\"http://profiles.wordpress.org/jamescollins\">James Collins</a>, <a href=\"http://profiles.wordpress.org/jenmylo\">Jen Mylo</a>, <a href=\"http://profiles.wordpress.org/buffler\">Jeremy Buller</a>, <a href=\"http://profiles.wordpress.org/jeremyfelt\">Jeremy Felt</a>, <a href=\"http://profiles.wordpress.org/jayjdk\">Jesper Johansen (jayjdk)</a>, <a href=\"http://profiles.wordpress.org/joehoyle\">Joe Hoyle</a>, <a href=\"http://profiles.wordpress.org/jkudish\">Joey Kudish</a>, <a href=\"http://profiles.wordpress.org/johnnyb\">John Beales</a>, <a href=\"http://profiles.wordpress.org/johnbillion\">John Blackbourn (johnbillion)</a>, <a href=\"http://profiles.wordpress.org/johnafish\">John Fish</a>, <a href=\"http://profiles.wordpress.org/johnjamesjacoby\">John James Jacoby</a>, <a href=\"http://profiles.wordpress.org/johnpbloch\">John P. Bloch</a>, <a href=\"http://profiles.wordpress.org/jond3r\">Jonas Bolinder (jond3r)</a>, <a href=\"http://profiles.wordpress.org/jchristopher\">Jonathan Christopher</a>, <a href=\"http://profiles.wordpress.org/desrosj\">Jonathan Desrosiers</a>, <a href=\"http://profiles.wordpress.org/duck_\">Jon Cave</a>, <a href=\"http://profiles.wordpress.org/jonlynch\">Jon Lynch</a>, <a href=\"http://profiles.wordpress.org/joostdevalk\">Joost de Valk</a>, <a href=\"http://profiles.wordpress.org/josephscott\">Joseph Scott</a>, <a href=\"http://profiles.wordpress.org/betzster\">Josh Betz</a>, <a href=\"http://profiles.wordpress.org/devesine\">Justin de Vesine</a>, <a href=\"http://profiles.wordpress.org/justinsainton\">Justin Sainton</a>, <a href=\"http://profiles.wordpress.org/kadamwhite\">K.Adam White</a>, <a href=\"http://profiles.wordpress.org/trepmal\">Kailey (trepmal)</a>, <a href=\"http://profiles.wordpress.org/ketwaroo\">Ketwaroo</a>, <a href=\"http://profiles.wordpress.org/kevinb\">kevinB</a>, <a href=\"http://profiles.wordpress.org/kpdesign\">Kim Parsell</a>, <a href=\"http://profiles.wordpress.org/kitchin\">kitchin</a>, <a href=\"http://profiles.wordpress.org/kovshenin\">Konstantin Kovshenin</a>, <a href=\"http://profiles.wordpress.org/obenland\">Konstantin Obenland</a>, <a href=\"http://profiles.wordpress.org/koopersmith\">koopersmith</a>, <a href=\"http://profiles.wordpress.org/kurtpayne\">Kurt Payne</a>, <a href=\"http://profiles.wordpress.org/lancewillett\">Lance Willett</a>, <a href=\"http://profiles.wordpress.org/leewillis77\">Lee Willis (leewillis77)</a>, <a href=\"http://profiles.wordpress.org/lessbloat\">lessbloat</a>, <a href=\"http://profiles.wordpress.org/layotte\">Lew Ayotte</a>, <a href=\"http://profiles.wordpress.org/lgedeon\">Luke Gedeon</a>, <a href=\"http://profiles.wordpress.org/iworks\">Marcin Pietrzak</a>, <a href=\"http://profiles.wordpress.org/cimmo\">Marco Cimmino</a>, <a href=\"http://profiles.wordpress.org/marco_teethgrinder\">Marco Galasso</a>, <a href=\"http://profiles.wordpress.org/markjaquith\">Mark Jaquith</a>, <a href=\"http://profiles.wordpress.org/markmcwilliams\">Mark McWilliams</a>, <a href=\"http://profiles.wordpress.org/markoheijnen\">Marko Heijnen</a>, <a href=\"http://profiles.wordpress.org/melchoyce\">Mel Choyce</a>, <a href=\"http://profiles.wordpress.org/tw2113\">Michael Beckwith</a>, <a href=\"http://profiles.wordpress.org/mikehansenme\">Mike Hansen</a>, <a href=\"http://profiles.wordpress.org/mikeschinkel\">Mike Schinkel</a>, <a href=\"http://profiles.wordpress.org/dh-shredder\">Mike Schroder</a>, <a href=\"http://profiles.wordpress.org/dimadin\">Milan Dinic</a>, <a href=\"http://profiles.wordpress.org/mitchoyoshitaka\">mitcho (Michael Yoshitaka Erlewine)</a>, <a href=\"http://profiles.wordpress.org/usermrpapa\">Mr Papa</a>, <a href=\"http://profiles.wordpress.org/Nao\">Naoko Takano</a>, <a href=\"http://profiles.wordpress.org/naomicbush\">Naomi</a>, <a href=\"http://profiles.wordpress.org/alex-ye\">Nashwan Doaqan</a>, <a href=\"http://profiles.wordpress.org/natejacobs\">NateJacobs</a>, <a href=\"http://profiles.wordpress.org/nathanrice\">nathanrice</a>, <a href=\"http://profiles.wordpress.org/niallkennedy\">Niall Kennedy</a>, <a href=\"http://profiles.wordpress.org/nickdaugherty\">Nick Daugherty</a>, <a href=\"http://profiles.wordpress.org/celloexpressions\">Nick Halsey</a>, <a href=\"http://profiles.wordpress.org/nickmomrik\">Nick Momrik</a>, <a href=\"http://profiles.wordpress.org/nikv\">Nikhil Vimal (NikV)</a>, <a href=\"http://profiles.wordpress.org/nbachiyski\">Nikolay Bachiyski</a>, <a href=\"http://profiles.wordpress.org/noahsilverstein\">noahsilverstein</a>, <a href=\"http://profiles.wordpress.org/nofearinc\">nofearinc</a>, <a href=\"http://profiles.wordpress.org/nukaga\">nukaga</a>, <a href=\"http://profiles.wordpress.org/nullvariable\">nullvariable</a>, <a href=\"http://profiles.wordpress.org/butuzov\">Oleg Butuzov</a>, <a href=\"http://profiles.wordpress.org/paolal\">Paolo Belcastro</a>, <a href=\"http://profiles.wordpress.org/xparham\">Parham</a>, <a href=\"http://profiles.wordpress.org/pbiron\">Paul Biron</a>, <a href=\"http://profiles.wordpress.org/pauldewouters\">Paul de Wouters</a>, <a href=\"http://profiles.wordpress.org/pavelevap\">pavelevap</a>, <a href=\"http://profiles.wordpress.org/peterjaap\">peterjaap</a>, <a href=\"http://profiles.wordpress.org/westi\">Peter Westwood</a>, <a href=\"http://profiles.wordpress.org/philiparthurmoore\">Philip Arthur Moore</a>, <a href=\"http://profiles.wordpress.org/mordauk\">Pippin Williamson</a>, <a href=\"http://profiles.wordpress.org/plocha\">plocha</a>, <a href=\"http://profiles.wordpress.org/pollett\">Pollett</a>, <a href=\"http://profiles.wordpress.org/ptahdunbar\">Ptah Dunbar</a>, <a href=\"http://profiles.wordpress.org/ramiy\">Rami Yushuvaev</a>, <a href=\"http://profiles.wordpress.org/rasheed\">Rasheed Bydousi</a>, <a href=\"http://profiles.wordpress.org/raybernard\">RayBernard</a>, <a href=\"http://profiles.wordpress.org/rboren\">rboren</a>, <a href=\"http://profiles.wordpress.org/greuben\">Reuben Gunday</a>, <a href=\"http://profiles.wordpress.org/rfair404\">rfair404</a>, <a href=\"http://profiles.wordpress.org/iamfriendly\">Richard Tape</a>, <a href=\"http://profiles.wordpress.org/r3df\">Rick Radko</a>, <a href=\"http://profiles.wordpress.org/miqrogroove\">Robert Chapin</a>, <a href=\"http://profiles.wordpress.org/rdall\">Robert Dall</a>, <a href=\"http://profiles.wordpress.org/rodrigosprimo\">Rodrigo Primo</a>, <a href=\"http://profiles.wordpress.org/wpmuguru\">Ron Rennick</a>, <a href=\"http://profiles.wordpress.org/rpattillo\">rpattillo</a>, <a href=\"http://profiles.wordpress.org/ryan\">Ryan Boren</a>, <a href=\"http://profiles.wordpress.org/rmccue\">Ryan McCue</a>, <a href=\"http://profiles.wordpress.org/hotchkissconsulting\">Sam Hotchkiss</a>, <a href=\"http://profiles.wordpress.org/coffee2code\">Scott Reilly</a>, <a href=\"http://profiles.wordpress.org/scottsweb\">scottsweb</a>, <a href=\"http://profiles.wordpress.org/wonderboymusic\">Scott Taylor</a>, <a href=\"http://profiles.wordpress.org/scribu\">scribu</a>, <a href=\"http://profiles.wordpress.org/scruffian\">scruffian</a>, <a href=\"http://profiles.wordpress.org/tenpura\">Seisuke Kuraishi (tenpura)</a>, <a href=\"http://profiles.wordpress.org/sergeybiryukov\">Sergey Biryukov</a>, <a href=\"http://profiles.wordpress.org/shinichin\">ShinichiN</a>, <a href=\"http://profiles.wordpress.org/pross\">Simon Prosser</a>, <a href=\"http://profiles.wordpress.org/simonwheatley\">Simon Wheatley</a>, <a href=\"http://profiles.wordpress.org/siobhan\">Siobhan</a>, <a href=\"http://profiles.wordpress.org/siobhyb\">Siobhan Bamber (siobhyb)</a>, <a href=\"http://profiles.wordpress.org/sirzooro\">sirzooro</a>, <a href=\"http://profiles.wordpress.org/solarissmoke\">solarissmoke</a>, <a href=\"http://profiles.wordpress.org/sillybean\">Stephanie Leary</a>, <a href=\"http://profiles.wordpress.org/netweb\">Stephen Edgar (@netweb)</a>, <a href=\"http://profiles.wordpress.org/stephenharris\">Stephen Harris</a>, <a href=\"http://profiles.wordpress.org/strangerstudios\">strangerstudios</a>, <a href=\"http://profiles.wordpress.org/sweetie089\">sweetie089</a>, <a href=\"http://profiles.wordpress.org/swissspidy\">swissspidy</a>, <a href=\"http://profiles.wordpress.org/miyauchi\">Takayuki Miyauchi</a>, <a href=\"http://profiles.wordpress.org/tmtoy\">Takuma Morikawa</a>, <a href=\"http://profiles.wordpress.org/tlovett1\">Taylor Lovett</a>, <a href=\"http://profiles.wordpress.org/tivnet\">tivnet</a>, <a href=\"http://profiles.wordpress.org/tobiasbg\">TobiasBg</a>, <a href=\"http://profiles.wordpress.org/tomauger\">Tom Auger</a>, <a href=\"http://profiles.wordpress.org/toscho\">toscho</a>, <a href=\"http://profiles.wordpress.org/wpsmith\">Travis Smith</a>, <a href=\"http://profiles.wordpress.org/sorich87\">Ulrich Sossou</a>, <a href=\"http://profiles.wordpress.org/vericgar\">vericgar</a>, <a href=\"http://profiles.wordpress.org/vinod-dalvi\">Vinod Dalvi</a>, <a href=\"http://profiles.wordpress.org/westonruter\">Weston Ruter</a>, <a href=\"http://profiles.wordpress.org/wikicms\">wikicms</a>, <a href=\"http://profiles.wordpress.org/willnorris\">Will Norris</a>, <a href=\"http://profiles.wordpress.org/wojtekszkutnik\">Wojtek Szkutnik</a>, <a href=\"http://profiles.wordpress.org/wycks\">wycks</a>, <a href=\"http://profiles.wordpress.org/yoavf\">Yoav Farhi</a>, and <a href=\"http://profiles.wordpress.org/yurivictor\">Yuri Victor</a>.</p>\n<p>Enjoy what may be one of your last few manual updates. See you soon for version 3.8!</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:45:\"http://wordpress.org/news/2013/10/basie/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"WordPress 3.7 Release Candidate 2\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:68:\"http://wordpress.org/news/2013/10/wordpress-3-7-release-candidate-2/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:77:\"http://wordpress.org/news/2013/10/wordpress-3-7-release-candidate-2/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 23 Oct 2013 00:05:30 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=2729\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:417:\"The second release candidate of WordPress 3.7 is now available for testing! Those of you already testing WordPress 3.7 will be updated automatically to RC2. (Nice.) If you&#8217;d like to start testing, there&#8217;s no time like the present! Try the WordPress Beta Tester plugin (you’ll want “bleeding edge nightlies”) or download the release candidate here (zip). Please post to the Alpha/Beta [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Andrew Nacin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:1183:\"<p>The second release candidate of WordPress 3.7 is now available for testing!</p>\n<p>Those of you already testing WordPress 3.7 will be updated automatically to RC2. (<em>Nice.</em>) If you&#8217;d like to start testing, there&#8217;s no time like the present! Try the <a href=\"http://wordpress.org/extend/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin (you’ll want “bleeding edge nightlies”) or <a href=\"http://wordpress.org/wordpress-3.7-RC2.zip\">download the release candidate here</a> (zip). Please post to the <a href=\"http://wordpress.org/support/forum/alphabeta/\">Alpha/Beta area in the support forums</a> if you think you&#8217;ve found a bug, and if any known issues are raised, you’ll be able to <a href=\"http://core.trac.wordpress.org/report/5\">find them here</a>.</p>\n<p>Developers, please test your plugins and themes against WordPress 3.7. If there is a compatibility issue, let us know as soon as possible so we can deal with it before the final release.</p>\n<p>For more on WordPress 3.7, check out the <a href=\"http://wordpress.org/news/2013/10/wordpress-3-7-release-candidate/\">announcement post for Release Candidate 1</a>.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:73:\"http://wordpress.org/news/2013/10/wordpress-3-7-release-candidate-2/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:18:\"Upcoming WordCamps\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"http://wordpress.org/news/2013/10/upcoming-wordcamps-4/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:64:\"http://wordpress.org/news/2013/10/upcoming-wordcamps-4/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 22 Oct 2013 19:25:26 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:9:\"Community\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"WordCamp\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=2723\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:368:\"WordCamps are casual, locally-organized conferences that celebrate everything related to WordPress, and are a great opportunity to meet other WordPress users and professionals in your community. This has been a great year for WordCamps &#8212; there have been 56 so far in more than 20 countries, and there another 15 on the calendar before the year&#8217;s [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"Jen Mylo\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:3584:\"<p><a href=\"http://central.wordcamp.org/\">WordCamps</a> are casual, locally-organized conferences that celebrate everything related to WordPress, and are a great opportunity to meet other WordPress users and professionals in your community. This has been a great year for WordCamps &#8212; there have been 56 so far in more than 20 countries, and there another 15 on the calendar before the year&#8217;s over. If there&#8217;s one near you, check it out! In addition to getting to know your local WordPress community, most WordCamps attract some traveling visitors a well, giving you the chance to meet contributors to the WordPress open source project and <a href=\"http://make.wordpress.org/\">get involved</a> yourself.</p>\n<p>Here are the WordCamps on the schedule for the rest of this year.</p>\n<p>October 25-27: <strong><a href=\"http://2013.boston.wordcamp.org/\">WordCamp Boston</a></strong>, Boston, MA, USA<br />\nOctober 25-26: <strong><a href=\"http://2013.malaga.wordcamp.org/\">WordCamp Malaga</a></strong>, Spain<br />\nOctober 26: <strong><a href=\"http://2013.nepal.wordcamp.org/\">WordCamp Nepal</a></strong>, Kathmandu, Nepal<br />\nOctober 26: <strong><a href=\"http://2013.sofia.wordcamp.org/\">WordCamp Sofia</a></strong>, Bulgaria<br />\nNovember 7: <strong><a href=\"http://2013.capetown.wordcamp.org/\">WordCamp Cape Town</a></strong>, South Africa<br />\nNovember 9: <strong><a href=\"http://2013.porto.wordcamp.org/\">WordCamp Porto</a></strong>, Portugal<br />\nNovember 9-10: <strong><a href=\"http://2013.kenya.wordcamp.org/\">WordCamp Kenya</a></strong>, Nairobi, Kenya<br />\nNovember 15: <strong><a href=\"http://2013.edmonton.wordcamp.org/\">WordCamp Edmonton</a></strong>, AB, Canada<br />\nNovember 16-17: <strong><a href=\"http://2013.orlando.wordcamp.org/\">WordCamp Orlando</a></strong>, FL, USA<br />\nNovember 16: <strong><a href=\"http://2013.denver.wordcamp.org/\">WordCamp Denver</a></strong>, CO, USA<br />\nNovember 23-24: <strong><a href=\"http://2013.london.wordcamp.org/\">WordCamp London</a></strong>, UK<br />\nNovember 23-24: <strong><a href=\"http://2013.raleigh.wordcamp.org/\">WordCamp Raleigh</a></strong>, NC, USA<br />\nNovember 23: <strong><a href=\"http://2013.saopaulo.wordcamp.org/\">WordCamp São Paulo</a></strong>, Brazil<br />\nDecember 14: <strong><a href=\"http://2013.vegas.wordcamp.org/\">WordCamp Las Vegas</a></strong>, NV, USA<br />\nDecember 14-15: <strong><a href=\"http://2013.sevilla.wordcamp.org/\">WordCamp Sevilla</a></strong>, Spain</p>\n<p>No WordCamps on this list in your area? Not to worry! There are thriving <a href=\"http://wordpress.meetup.com/\">WordPress meetups</a> all over the world where you can meet like-minded people, and we maintain a library of <a href=\"http://wordpress.tv/category/wordcamptv/\">WordCamp videos</a> at <a href=\"http://wordpress.tv/\">WordPress.tv</a>.</p>\n<h3>Get Involved</h3>\n<ul>\n<li>If you&#8217;re interested in organizing a WordCamp in your area, check out our <a href=\"http://plan.wordcamp.org/\">WordCamp planning</a> site.</li>\n<li>If you&#8217;re interested in <a href=\"http://make.wordpress.org/community/meetup-interest-form/\">starting a WordPress meetup</a> in your area, let us know and we can set up a group on meetup.com for you.</li>\n<li>And speaking of WordCamp videos, we&#8217;ve recently enabled volunteer-generated subtitles/closed captioning of the videos on WordPress.tv to make them more accessible. Interested in helping? Check out the <a href=\"http://wordpress.tv/using-amara-org-to-caption-or-subtitle-a-wordpress-tv-video/\">WordPress.tv subtitling instructions</a>.</li>\n</ul>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"http://wordpress.org/news/2013/10/upcoming-wordcamps-4/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"WordPress 3.7 Release Candidate\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:66:\"http://wordpress.org/news/2013/10/wordpress-3-7-release-candidate/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:75:\"http://wordpress.org/news/2013/10/wordpress-3-7-release-candidate/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 18 Oct 2013 19:52:14 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=2718\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:331:\"The first release candidate for WordPress 3.7 is now available! In RC 1, we&#8217;ve made some adjustments to the update process to make it more reliable than ever. We hope to ship WordPress 3.7 next week, but we need your help to get there. If you haven’t tested 3.7 yet, there’s no time like the present. (Please, [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Andrew Nacin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:2237:\"<p>The first release candidate for WordPress 3.7 is now available!</p>\n<p>In RC 1, we&#8217;ve made some adjustments to the update process to make it more reliable than ever. We hope to ship WordPress 3.7 <em>next week</em>, but we need your help to get there. If you haven’t tested 3.7 yet, there’s no time like the present. (Please, not on a production site, unless you’re adventurous.)</p>\n<p>WordPress 3.7 introduces <strong>automatic background updates</strong> for security and minor releases (like updating from 3.7 to 3.7.1). These are really easy to test  — RC 1 will update every 12 hours or so to the latest development version, and then email you the results. (You may get two emails: one for debugging, and one all users of 3.7 will receive.) If something went wrong, you can report it.</p>\n<p><strong>Think you’ve found a bug? </strong>Please post to the <a href=\"http://wordpress.org/support/forum/alphabeta/\">Alpha/Beta area in the support forums</a>. If any known issues come up, you’ll be able to <a href=\"http://core.trac.wordpress.org/report/5\">find them here</a>.</p>\n<p>To test WordPress 3.7 RC1, try the <a href=\"http://wordpress.org/extend/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin (you’ll want “bleeding edge nightlies”). Or you can <a href=\"http://wordpress.org/wordpress-3.7-RC1.zip\">download the release candidate here</a> (zip). If you’d like to learn more about what&#8217;s new in WordPress 3.7, visit the awesome About screen in your dashboard (<strong><img alt=\"\" src=\"http://core.svn.wordpress.org/branches/3.6/wp-content/themes/twentyten/images/wordpress.png\" /> → About</strong> in the toolbar). There, you can also see if your install is eligible for background updates. WordPress won’t automatically update, for example, if you’re using version control like Subversion or Git.</p>\n<p><strong>Developers,</strong> please test your plugins and themes against WordPress 3.7, so that if there is a compatibility issue, we can figure it out before the final release. Make sure you post any issues to the support forums.</p>\n<p><em>WordPress three seven</em><br />\n<em>A self-updating engine</em><br />\n<em>Lies beneath the hood</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:71:\"http://wordpress.org/news/2013/10/wordpress-3-7-release-candidate/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:20:\"WordPress 3.7 Beta 2\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"http://wordpress.org/news/2013/10/wordpress-3-7-beta-2/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:64:\"http://wordpress.org/news/2013/10/wordpress-3-7-beta-2/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 10 Oct 2013 21:28:06 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=2706\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:357:\"WordPress 3.7 Beta 2 is now available for download and testing. This is software still in development, so we don&#8217;t recommend that you run it on a production site. This has been a quiet beta period. We&#8217;re hoping to get some more testers for automatic background updates, which will occur for security and minor releases (like updating [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Andrew Nacin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:2108:\"<p>WordPress 3.7 Beta 2 is now available for download and testing. This is software still in development, so we don&#8217;t recommend that you run it on a production site.</p>\n<p>This has been a quiet beta period. We&#8217;re hoping to get some more testers for <strong>automatic background updates</strong>, which will occur for security and minor releases (like updating from 3.7 to 3.7.1). It&#8217;s really easy to test this, as Beta 2 will update each day to the latest development version and then email you the results. If something goes wrong, you can report it — it&#8217;s that simple. To get the beta, try the <a href=\"http://wordpress.org/extend/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin (you&#8217;ll want &#8220;bleeding edge nightlies&#8221;). Or you can <a href=\"http://wordpress.org/wordpress-3.7-beta2.zip\">download the beta here</a> (zip). Check out <strong>Dashboard → Updates</strong> to see if your install is eligible for background updates. WordPress won&#8217;t update if, for example, you&#8217;re using version control like SVN or Git.</p>\n<p>For more of what&#8217;s new in version 3.7, <a title=\"WordPress 3.7 Beta 1\" href=\"http://wordpress.org/news/2013/09/wordpress-3-7-beta-1/\">check out the Beta 1 blog post</a>. In Beta 2, we further increased the stability of background updates and also added about 50 bug fixes, including a fix for Internet Explorer 11 in the visual editor.</p>\n<p>If you think you’ve found a bug, you can post to the <a href=\"http://wordpress.org/support/forum/alphabeta\">Alpha/Beta area</a> in the support forums. Or, if you’re comfortable writing a bug report, <a href=\"http://core.trac.wordpress.org/\">file one on the WordPress Trac</a>. There, you can also find <a href=\"http://core.trac.wordpress.org/report/5\">a list of known bugs</a> and <a href=\"http://core.trac.wordpress.org/query?status=closed&amp;group=component&amp;milestone=3.7\">everything we’ve fixed</a>.</p>\n<p>Happy testing!</p>\n<p><em>Beta 2 released<br />\nDotting i&#8217;s and crossing t&#8217;s</em><br />\n<em>Expect RC next</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"http://wordpress.org/news/2013/10/wordpress-3-7-beta-2/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:5;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:20:\"WordPress 3.7 Beta 1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"http://wordpress.org/news/2013/09/wordpress-3-7-beta-1/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:64:\"http://wordpress.org/news/2013/09/wordpress-3-7-beta-1/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 28 Sep 2013 07:25:44 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=2688\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:339:\"I&#8217;m pleased to announce the availability of WordPress 3.7 Beta 1. For WordPress 3.7 we decided to shorten the development cycle and focus on a few key improvements. We plan to release the final product in October, and then follow it in December with a jam-packed WordPress 3.8 release, which is already in development. Some [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Andrew Nacin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:3684:\"<p>I&#8217;m pleased to announce the availability of WordPress 3.7 Beta 1.</p>\n<p>For WordPress 3.7 we decided to shorten the development cycle and focus on a few key improvements. We plan to release the final product in October, and then follow it in December with a jam-packed WordPress 3.8 release, which is already in development. Some of the best stuff in WordPress 3.7 is subtle &#8212; by design! So let&#8217;s walk through what we&#8217;d love for you to test, just in time for the weekend.</p>\n<p><strong>Automatic, background updates.</strong> 3.7 Beta 1 will keep itself updated. That&#8217;s right &#8212; you&#8217;ll be updated each night to the newest development build, and eventually to Beta 2. We&#8217;re working to provide as many installs as possible with fast updates to security releases of WordPress &#8212; and you can help us test by just installing Beta 1 on your server and seeing how it works!</p>\n<p>When you go to <strong>Dashboard → Updates</strong>, you&#8217;ll see a note letting you know whether your install is working for automatic updates. There are a few situations where WordPress can&#8217;t reliably and securely update itself. But if it can, you&#8217;ll get an email (sent to the &#8216;Admin Email&#8217; on the General Settings page) after each update letting you know what worked and what didn&#8217;t. If it worked, great! If something failed, the email will suggest you make a post in the support forums or create a bug report.</p>\n<p>Here are some other things you should test out:</p>\n<ul>\n<li>If you&#8217;re running <strong>WordPress in another language</strong>, we&#8217;ll automatically download any available translations for official WordPress importers and the default themes. (More to come here.)</li>\n<li>Our <strong>password meter</strong> got a whole lot better, thanks to Dropbox&#8217;s <a href=\"https://tech.dropbox.com/2012/04/zxcvbn-realistic-password-strength-estimation/\">zxcvbn</a> library. Again, subtle but effective. Strong passwords are very important!</li>\n<li><strong>Search results</strong> are now <a href=\"http://core.trac.wordpress.org/changeset/25632\">ordered by relevance</a>, rather than just by date. When your keywords match post titles and not just content, they&#8217;ll be pushed to the top.</li>\n<li>Developers should check out the new <strong>advanced date queries</strong> in <code>WP_Query</code>. (<a href=\"http://core.trac.wordpress.org/ticket/18694\">#18694</a>)</li>\n</ul>\n<p><strong>This software is still in development</strong>, so we don&#8217;t recommend you run it on a production site. I&#8217;d suggest setting up a test site just to play with the new version. To test WordPress 3.7, try the <a href=\"http://wordpress.org/extend/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin (you&#8217;ll want &#8220;bleeding edge nightlies&#8221;). Or you can <a href=\"http://wordpress.org/wordpress-3.7-beta1.zip\">download the beta here</a> (zip).</p>\n<p>As always, <strong>if you think you’ve found a bug</strong>, you can post to the <a href=\"http://wordpress.org/support/forum/alphabeta\">Alpha/Beta area</a> in the support forums. Or, if you’re comfortable writing a reproducible bug report, <a href=\"http://core.trac.wordpress.org/\">file one on the WordPress Trac</a>. There, you can also find <a href=\"http://core.trac.wordpress.org/report/5\">a list of known bugs</a> and <a href=\"http://core.trac.wordpress.org/query?status=closed&amp;group=component&amp;milestone=3.7\">everything we’ve fixed</a> so far.</p>\n<p>Happy testing!</p>\n<p><em>WordPress three seven<br />\nSaves your weary hand a click<br />\nUpdates while you sleep</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"http://wordpress.org/news/2013/09/wordpress-3-7-beta-1/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:6;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"WordPress 3.6.1 Maintenance and Security Release\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:50:\"http://wordpress.org/news/2013/09/wordpress-3-6-1/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"http://wordpress.org/news/2013/09/wordpress-3-6-1/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 11 Sep 2013 20:48:23 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Security\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=2675\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:353:\"After nearly 7 million downloads of WordPress 3.6, we are pleased to announce the availability of version 3.6.1. This maintenance release fixes 13 bugs in version 3.6, which was a very smooth release. WordPress 3.6.1 is also a security release for all previous WordPress versions and we strongly encourage you to update your sites immediately. [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Andrew Nacin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:2033:\"<p>After <a href=\"http://wordpress.org/download/counter/\">nearly 7 million downloads</a> of WordPress 3.6, we are pleased to announce the availability of version 3.6.1. This maintenance release <a href=\"http://core.trac.wordpress.org/query?status=closed&amp;group=resolution&amp;milestone=3.6.1\">fixes 13 bugs</a> in version 3.6, which was a very smooth release.</p>\n<p><strong>WordPress 3.6.1 is also a security release for all previous WordPress versions</strong> and we strongly encourage you to update your sites immediately. It addresses three issues fixed by the WordPress security team:</p>\n<ul>\n<li>Block unsafe PHP unserialization that could occur in limited situations and setups, which can lead to remote code execution. Reported by <a href=\"http://vagosec.org/\" rel=\"nofollow\">Tom Van Goethem</a>.</li>\n<li>Prevent a user with an Author role, using a specially crafted request, from being able to create a post &#8220;written by&#8221; another user. Reported by <a href=\"http://anakornk.wordpress.com/\" rel=\"nofollow\">Anakorn Kyavatanakij</a>.</li>\n<li>Fix insufficient input validation that could result in redirecting or leading a user to another website. Reported by Dave Cummo, a Northrup Grumman subcontractor for the <a href=\"http://www.cdc.gov/\" rel=\"nofollow\">U.S. Centers for Disease Control and Prevention</a>.</li>\n</ul>\n<p>Additionally, we&#8217;ve adjusted security restrictions around file uploads to mitigate the potential for cross-site scripting.</p>\n<p>We appreciated <a href=\"http://codex.wordpress.org/FAQ_Security\">responsible disclosure</a> of these issues directly to our security team. For more information on the changes, see the <a href=\"http://codex.wordpress.org/Version_3.6.1\">release notes</a> or consult <a href=\"http://core.trac.wordpress.org/log/branches/3.6?stop_rev=24972&amp;rev=25345\">the list of changes</a>.</p>\n<p><a href=\"http://wordpress.org/wordpress-3.6.1.zip\">Download WordPress 3.6.1</a> or update now from the Dashboard → Updates menu in your site&#8217;s admin area.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"http://wordpress.org/news/2013/09/wordpress-3-6-1/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:7;a:6:{s:4:\"data\";s:42:\"\n		\n		\n		\n		\n		\n				\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:25:\"WordPress 3.6 “Oscar”\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:40:\"http://wordpress.org/news/2013/08/oscar/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:49:\"http://wordpress.org/news/2013/08/oscar/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 01 Aug 2013 21:43:22 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=2661\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:368:\"The latest and greatest WordPress, version 3.6, is now live to the world and includes a beautiful new blog-centric theme, bullet-proof autosave and post locking, a revamped revision browser, native support for audio and video embeds, and improved integrations with Spotify, Rdio, and SoundCloud. Here&#8217;s a video that shows off some of the features using [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:18626:\"<p>The latest and greatest WordPress, version 3.6, is now <a href=\"http://wordpress.org/download/\">live to the world</a> and includes a beautiful new blog-centric theme, bullet-proof autosave and post locking, a revamped revision browser, native support for audio and video embeds, and improved integrations with Spotify, Rdio, and SoundCloud. Here&#8217;s a video that shows off some of the features using our cast of professional actors:</p>\n<div id=\"v-UmhwbWJH-1\" class=\"video-player\"><embed id=\"v-UmhwbWJH-1-video\" src=\"http://s0.videopress.com/player.swf?v=1.03&amp;guid=UmhwbWJH&amp;isDynamicSeeking=true\" type=\"application/x-shockwave-flash\" width=\"692\" height=\"388\" title=\"Introducing WordPress 3.6 &quot;Oscar&quot;\" wmode=\"direct\" seamlesstabbing=\"true\" allowfullscreen=\"true\" allowscriptaccess=\"always\" overstretch=\"true\"></embed></div>\n<p>We&#8217;re calling this release &#8220;Oscar&#8221; in honor of the great jazz pianist <a href=\"http://en.wikipedia.org/wiki/Oscar_Peterson\">Oscar Peterson</a>. Here&#8217;s a bit more about some of the new features, which you can also find on the about page in your dashboard after you upgrade.</p>\n<h3>User Features</h3>\n<p><img class=\"alignright\" alt=\"\" src=\"https://wordpress.org/images/core/3.6/twentythirteen.png\" width=\"300\" /></p>\n<ul>\n<li>The <strong>new Twenty Thirteen theme</strong> inspired by modern art puts focus on your content with a colorful, single-column design made for media-rich blogging.</li>\n<li><strong>Revamped Revisions</strong> save every change and the new interface allows you to scroll easily through changes to see line-by-line who changed what and when.</li>\n<li><strong>Post Locking</strong> and <strong>Augmented Autosave</strong> will especially be a boon to sites where more than a single author is working on a post. Each author now has their own autosave stream, which stores things locally as well as on the server (so much harder to lose something) and there&#8217;s an interface for taking over editing of a post, as demonstrated beautifully by our bearded buddies in the video above.</li>\n<li><strong>Built-in HTML5 media player</strong> for native audio and video embeds with no reliance on external services.</li>\n<li>The <strong>Menu Editor</strong> is now much easier to understand and use.</li>\n</ul>\n<h3>Developer features</h3>\n<ul>\n<li>A new audio/video API gives you access to metadata like ID3 tags.</li>\n<li>You can now choose HTML5 markup for things like comment and search forms, and comment lists.</li>\n<li>Better filters for how revisions work, so you can store a different amount of history for different post types.</li>\n<li>Tons more <a href=\"http://codex.wordpress.org/Version_3.6\">listed on the Codex</a>, and of course you can always <a href=\"http://core.trac.wordpress.org/query?status=closed&amp;group=resolution&amp;milestone=3.6\">browse the over 700 closed tickets</a>.</li>\n</ul>\n<h3>The Band</h3>\n<p>This release was led by <a href=\"http://markjaquith.com/\">Mark Jaquith</a> and <a href=\"http://geekreprieve.com/\">Aaron Campbell</a>, and included contributions from the following fine folks. Pull up some Oscar Peterson on your music service of choice, or vinyl if you have it, and check out some of their profiles:</p>\n<p><a href=\"http://profiles.wordpress.org/technosailor\">Aaron Brazell</a>, <a href=\"http://profiles.wordpress.org/aaroncampbell\">Aaron D. Campbell</a>, <a href=\"http://profiles.wordpress.org/aaronholbrook\">Aaron Holbrook</a>, <a href=\"http://profiles.wordpress.org/jorbin\">Aaron Jorbin</a>, <a href=\"http://profiles.wordpress.org/kawauso\">Adam Harley</a>, <a href=\"http://profiles.wordpress.org/adamsilverstein\">adamsilverstein</a>, <a href=\"http://profiles.wordpress.org/akted\">AK Ted</a>, <a href=\"http://profiles.wordpress.org/xknown\">Alex Concha</a>, <a href=\"http://profiles.wordpress.org/alexkingorg\">Alex King</a>, <a href=\"http://profiles.wordpress.org/viper007bond\">Alex Mills (Viper007Bond)</a>, <a href=\"http://profiles.wordpress.org/momo360modena\">Amaury Balmer</a>, <a href=\"http://profiles.wordpress.org/sabreuse\">Amy Hendrix (sabreuse)</a>, <a href=\"http://profiles.wordpress.org/anatolbroder\">Anatol Broder</a>, <a href=\"http://profiles.wordpress.org/nacin\">Andrew Nacin</a>, <a href=\"http://profiles.wordpress.org/azaozz\">Andrew Ozz</a>, <a href=\"http://profiles.wordpress.org/andrewryno\">Andrew Ryno</a>, <a href=\"http://profiles.wordpress.org/andy\">Andy Skelton</a>, <a href=\"http://profiles.wordpress.org/gorgoglionemeister\">Antonio</a>, <a href=\"http://profiles.wordpress.org/apimlott\">apimlott</a>, <a href=\"http://profiles.wordpress.org/awellis13\">awellis13</a>, <a href=\"http://profiles.wordpress.org/barry\">Barry</a>, <a href=\"http://profiles.wordpress.org/beaulebens\">Beau Lebens</a>, <a href=\"http://profiles.wordpress.org/belloswan\">BelloSwan</a>, <a href=\"http://profiles.wordpress.org/bilalcoder\">bilalcoder</a>, <a href=\"http://profiles.wordpress.org/bananastalktome\">Billy (bananastalktome)</a>, <a href=\"http://profiles.wordpress.org/bobbingwide\">bobbingwide</a>, <a href=\"http://profiles.wordpress.org/bobbravo2\">Bob Gregor</a>, <a href=\"http://profiles.wordpress.org/bradparbs\">bradparbs</a>, <a href=\"http://profiles.wordpress.org/bradyvercher\">Brady Vercher</a>, <a href=\"http://profiles.wordpress.org/kraftbj\">Brandon Kraft</a>, <a href=\"http://profiles.wordpress.org/brianlayman\">Brian Layman</a>, <a href=\"http://profiles.wordpress.org/beezeee\">Brian Zeligson</a>, <a href=\"http://profiles.wordpress.org/bpetty\">Bryan Petty</a>, <a href=\"http://profiles.wordpress.org/chmac\">Callum Macdonald</a>, <a href=\"http://profiles.wordpress.org/carldanley\">Carl Danley</a>, <a href=\"http://profiles.wordpress.org/caspie\">Caspie</a>, <a href=\"http://profiles.wordpress.org/charlestonsw\">Charleston Software Associates</a>, <a href=\"http://profiles.wordpress.org/cheeserolls\">cheeserolls</a>, <a href=\"http://profiles.wordpress.org/chipbennett\">Chip Bennett</a>, <a href=\"http://profiles.wordpress.org/c3mdigital\">Chris Olbekson</a>, <a href=\"http://profiles.wordpress.org/cochran\">Christopher Cochran</a>, <a href=\"http://profiles.wordpress.org/cfinke\">Christopher Finke</a>, <a href=\"http://profiles.wordpress.org/chriswallace\">Chris Wallace</a>, <a href=\"http://profiles.wordpress.org/corvannoorloos\">Cor van Noorloos</a>, <a href=\"http://profiles.wordpress.org/crazycoders\">crazycoders</a>, <a href=\"http://profiles.wordpress.org/danielbachhuber\">Daniel Bachhuber</a>, <a href=\"http://profiles.wordpress.org/mzaweb\">Daniel Dvorkin (MZAWeb)</a>, <a href=\"http://profiles.wordpress.org/redsweater\">Daniel Jalkut (Red Sweater)</a>, <a href=\"http://profiles.wordpress.org/daniloercoli\">daniloercoli</a>, <a href=\"http://profiles.wordpress.org/dannydehaan\">Danny de Haan</a>, <a href=\"http://profiles.wordpress.org/csixty4\">Dave Ross</a>, <a href=\"http://profiles.wordpress.org/dfavor\">David Favor</a>, <a href=\"http://profiles.wordpress.org/jdtrower\">David Trower</a>, <a href=\"http://profiles.wordpress.org/davidwilliamson\">David Williamson</a>, <a href=\"http://profiles.wordpress.org/dd32\">Dion Hulse</a>, <a href=\"http://profiles.wordpress.org/dllh\">dllh</a>, <a href=\"http://profiles.wordpress.org/ocean90\">Dominik Schilling (ocean90)</a>, <a href=\"http://profiles.wordpress.org/dovyp\">dovyp</a>, <a href=\"http://profiles.wordpress.org/drewapicture\">Drew Jaynes (DrewAPicture)</a>, <a href=\"http://profiles.wordpress.org/dvarga\">dvarga</a>, <a href=\"http://profiles.wordpress.org/cais\">Edward Caissie</a>, <a href=\"http://profiles.wordpress.org/elfin\">elfin</a>, <a href=\"http://profiles.wordpress.org/empireoflight\">Empireoflight</a>, <a href=\"http://profiles.wordpress.org/ericlewis\">Eric Andrew Lewis</a>, <a href=\"http://profiles.wordpress.org/ethitter\">Erick Hitter</a>, <a href=\"http://profiles.wordpress.org/ericmann\">Eric Mann</a>, <a href=\"http://profiles.wordpress.org/evansolomon\">Evan Solomon</a>, <a href=\"http://profiles.wordpress.org/faishal\">faishal</a>, <a href=\"http://profiles.wordpress.org/feedmeastraycat\">feedmeastraycat</a>, <a href=\"http://profiles.wordpress.org/frank-klein\">Frank Klein</a>, <a href=\"http://profiles.wordpress.org/f-j-kaiser\">Franz Josef Kaiser</a>, <a href=\"http://profiles.wordpress.org/fstop\">FStop</a>, <a href=\"http://profiles.wordpress.org/mintindeed\">Gabriel Koen</a>, <a href=\"http://profiles.wordpress.org/garyc40\">Gary Cao</a>, <a href=\"http://profiles.wordpress.org/garyj\">Gary Jones</a>, <a href=\"http://profiles.wordpress.org/gcorne\">gcorne</a>, <a href=\"http://profiles.wordpress.org/geertdd\">GeertDD</a>, <a href=\"http://profiles.wordpress.org/soulseekah\">Gennady Kovshenin</a>, <a href=\"http://profiles.wordpress.org/georgestephanis\">George Stephanis</a>, <a href=\"http://profiles.wordpress.org/gish\">gish</a>, <a href=\"http://profiles.wordpress.org/tivnet\">Gregory Karpinsky</a>, <a href=\"http://profiles.wordpress.org/hakre\">hakre</a>, <a href=\"http://profiles.wordpress.org/hbanken\">hbanken</a>, <a href=\"http://profiles.wordpress.org/hebbet\">hebbet</a>, <a href=\"http://profiles.wordpress.org/helen\">Helen Hou-Sandi</a>, <a href=\"http://profiles.wordpress.org/helgatheviking\">helgatheviking</a>, <a href=\"http://profiles.wordpress.org/hirozed\">hirozed</a>, <a href=\"http://profiles.wordpress.org/hurtige\">hurtige</a>, <a href=\"http://profiles.wordpress.org/hypertextranch\">hypertextranch</a>, <a href=\"http://profiles.wordpress.org/iandunn\">Ian Dunn</a>, <a href=\"http://profiles.wordpress.org/ipstenu\">Ipstenu (Mika Epstein)</a>, <a href=\"http://profiles.wordpress.org/jakub\">jakub</a>, <a href=\"http://profiles.wordpress.org/h4ck3rm1k3\">James Michael DuPont</a>, <a href=\"http://profiles.wordpress.org/jbutkus\">jbutkus</a>, <a href=\"http://profiles.wordpress.org/jeremyfelt\">Jeremy Felt</a>, <a href=\"http://profiles.wordpress.org/jerrysarcastic\">Jerry Bates (JerrySarcastic)</a>, <a href=\"http://profiles.wordpress.org/jayjdk\">Jesper Johansen (Jayjdk)</a>, <a href=\"http://profiles.wordpress.org/joehoyle\">Joe Hoyle</a>, <a href=\"http://profiles.wordpress.org/joen\">Joen Asmussen</a>, <a href=\"http://profiles.wordpress.org/jkudish\">Joey Kudish</a>, <a href=\"http://profiles.wordpress.org/johnbillion\">John Blackbourn (johnbillion)</a>, <a href=\"http://profiles.wordpress.org/johnjamesjacoby\">John James Jacoby</a>, <a href=\"http://profiles.wordpress.org/jond3r\">Jonas Bolinder (jond3r)</a>, <a href=\"http://profiles.wordpress.org/desrosj\">Jonathan Desrosiers</a>, <a href=\"http://profiles.wordpress.org/jonbishop\">Jon Bishop</a>, <a href=\"http://profiles.wordpress.org/duck_\">Jon Cave</a>, <a href=\"http://profiles.wordpress.org/jcastaneda\">Jose Castaneda</a>, <a href=\"http://profiles.wordpress.org/josephscott\">Joseph Scott</a>, <a href=\"http://profiles.wordpress.org/jvisick77\">Josh Visick</a>, <a href=\"http://profiles.wordpress.org/jrbeilke\">jrbeilke</a>, <a href=\"http://profiles.wordpress.org/jrf\">jrf</a>, <a href=\"http://profiles.wordpress.org/devesine\">Justin de Vesine</a>, <a href=\"http://profiles.wordpress.org/justinsainton\">Justin Sainton</a>, <a href=\"http://profiles.wordpress.org/kadamwhite\">kadamwhite</a>, <a href=\"http://profiles.wordpress.org/trepmal\">Kailey (trepmal)</a>, <a href=\"http://profiles.wordpress.org/karmatosed\">karmatosed</a>, <a href=\"http://profiles.wordpress.org/ryelle\">Kelly Dwan</a>, <a href=\"http://profiles.wordpress.org/keoshi\">keoshi</a>, <a href=\"http://profiles.wordpress.org/kovshenin\">Konstantin Kovshenin</a>, <a href=\"http://profiles.wordpress.org/obenland\">Konstantin Obenland</a>, <a href=\"http://profiles.wordpress.org/ktdreyer\">ktdreyer</a>, <a href=\"http://profiles.wordpress.org/kurtpayne\">Kurt Payne</a>, <a href=\"http://profiles.wordpress.org/kwight\">kwight</a>, <a href=\"http://profiles.wordpress.org/lancewillett\">Lance Willett</a>, <a href=\"http://profiles.wordpress.org/leewillis77\">Lee Willis (leewillis77)</a>, <a href=\"http://profiles.wordpress.org/lessbloat\">lessbloat</a>, <a href=\"http://profiles.wordpress.org/settle\">Mantas Malcius</a>, <a href=\"http://profiles.wordpress.org/maor\">Maor Chasen</a>, <a href=\"http://profiles.wordpress.org/macbrink\">Marcel Brinkkemper</a>, <a href=\"http://profiles.wordpress.org/marcuspope\">MarcusPope</a>, <a href=\"http://profiles.wordpress.org/mark-k\">Mark-k</a>, <a href=\"http://profiles.wordpress.org/markjaquith\">Mark Jaquith</a>, <a href=\"http://profiles.wordpress.org/markmcwilliams\">Mark McWilliams</a>, <a href=\"http://profiles.wordpress.org/markoheijnen\">Marko Heijnen</a>, <a href=\"http://profiles.wordpress.org/mjbanks\">Matt Banks</a>, <a href=\"http://profiles.wordpress.org/mboynes\">Matthew Boynes</a>, <a href=\"http://profiles.wordpress.org/matthewruddy\">MatthewRuddy</a>, <a href=\"http://profiles.wordpress.org/mattwiebe\">Matt Wiebe</a>, <a href=\"http://profiles.wordpress.org/maxcutler\">Max Cutler</a>, <a href=\"http://profiles.wordpress.org/melchoyce\">Mel Choyce</a>, <a href=\"http://profiles.wordpress.org/mgibbs189\">mgibbs189</a>, <a href=\"http://profiles.wordpress.org/fanquake\">Michael</a>, <a href=\"http://profiles.wordpress.org/mdawaffe\">Michael Adams (mdawaffe)</a>, <a href=\"http://profiles.wordpress.org/tw2113\">Michael Beckwith</a>, <a href=\"http://profiles.wordpress.org/mfields\">Michael Fields</a>, <a href=\"http://profiles.wordpress.org/mikehansenme\">Mike Hansen</a>, <a href=\"http://profiles.wordpress.org/dh-shredder\">Mike Schroder</a>, <a href=\"http://profiles.wordpress.org/dimadin\">Milan Dinic</a>, <a href=\"http://profiles.wordpress.org/mitchoyoshitaka\">mitcho (Michael Yoshitaka Erlewine)</a>, <a href=\"http://profiles.wordpress.org/batmoo\">Mohammad Jangda</a>, <a href=\"http://profiles.wordpress.org/najamelan\">najamelan</a>, <a href=\"http://profiles.wordpress.org/Nao\">Naoko Takano</a>, <a href=\"http://profiles.wordpress.org/alex-ye\">Nashwan Doaqan</a>, <a href=\"http://profiles.wordpress.org/niallkennedy\">Niall Kennedy</a>, <a href=\"http://profiles.wordpress.org/nickdaugherty\">Nick Daugherty</a>, <a href=\"http://profiles.wordpress.org/celloexpressions\">Nick Halsey</a>, <a href=\"http://profiles.wordpress.org/ninnypants\">ninnypants</a>, <a href=\"http://profiles.wordpress.org/norcross\">norcross</a>, <a href=\"http://profiles.wordpress.org/paradiseporridge\">ParadisePorridge</a>, <a href=\"http://profiles.wordpress.org/pauldewouters\">Paul</a>, <a href=\"http://profiles.wordpress.org/pdclark\">Paul Clark</a>, <a href=\"http://profiles.wordpress.org/pavelevap\">pavelevap</a>, <a href=\"http://profiles.wordpress.org/petemall\">Pete Mall</a>, <a href=\"http://profiles.wordpress.org/westi\">Peter Westwood</a>, <a href=\"http://profiles.wordpress.org/phill_brown\">Phill Brown</a>, <a href=\"http://profiles.wordpress.org/mordauk\">Pippin Williamson</a>, <a href=\"http://profiles.wordpress.org/pollett\">Pollett</a>, <a href=\"http://profiles.wordpress.org/nprasath002\">Prasath Nadarajah</a>, <a href=\"http://profiles.wordpress.org/programmin\">programmin</a>, <a href=\"http://profiles.wordpress.org/rachelbaker\">rachelbaker</a>, <a href=\"http://profiles.wordpress.org/ramiy\">Rami Yushuvaev</a>, <a href=\"http://profiles.wordpress.org/redpixelstudios\">redpixelstudios</a>, <a href=\"http://profiles.wordpress.org/reidburke\">reidburke</a>, <a href=\"http://profiles.wordpress.org/retlehs\">retlehs</a>, <a href=\"http://profiles.wordpress.org/greuben\">Reuben Gunday</a>, <a href=\"http://profiles.wordpress.org/rlerdorf\">rlerdorf</a>, <a href=\"http://profiles.wordpress.org/rodrigosprimo\">Rodrigo Primo</a>, <a href=\"http://profiles.wordpress.org/roulandf\">roulandf</a>, <a href=\"http://profiles.wordpress.org/rovo89\">rovo89</a>, <a href=\"http://profiles.wordpress.org/ryanduff\">Ryan Duff</a>, <a href=\"http://profiles.wordpress.org/ryanhellyer\">Ryan Hellyer</a>, <a href=\"http://profiles.wordpress.org/rmccue\">Ryan McCue</a>, <a href=\"http://profiles.wordpress.org/zeo\">Safirul Alredha</a>, <a href=\"http://profiles.wordpress.org/saracannon\">sara cannon</a>, <a href=\"http://profiles.wordpress.org/scholesmafia\">scholesmafia</a>, <a href=\"http://profiles.wordpress.org/sc0ttkclark\">Scott Kingsley Clark</a>, <a href=\"http://profiles.wordpress.org/coffee2code\">Scott Reilly</a>, <a href=\"http://profiles.wordpress.org/wonderboymusic\">Scott Taylor</a>, <a href=\"http://profiles.wordpress.org/scribu\">scribu</a>, <a href=\"http://profiles.wordpress.org/tenpura\">Seisuke Kuraishi (tenpura)</a>, <a href=\"http://profiles.wordpress.org/sergej\">Sergej</a>, <a href=\"http://profiles.wordpress.org/sergeybiryukov\">Sergey Biryukov</a>, <a href=\"http://profiles.wordpress.org/sim\">Simon Hampel</a>, <a href=\"http://profiles.wordpress.org/simonwheatley\">Simon Wheatley</a>, <a href=\"http://profiles.wordpress.org/siobhan\">Siobhan</a>, <a href=\"http://profiles.wordpress.org/sirzooro\">sirzooro</a>, <a href=\"http://profiles.wordpress.org/slene\">slene</a>, <a href=\"http://profiles.wordpress.org/solarissmoke\">solarissmoke</a>, <a href=\"http://profiles.wordpress.org/srinig\">SriniG</a>, <a href=\"http://profiles.wordpress.org/stephenh1988\">Stephen Harris</a>, <a href=\"http://profiles.wordpress.org/storkontheroof\">storkontheroof</a>, <a href=\"http://profiles.wordpress.org/sunnyratilal\">Sunny Ratilal</a>, <a href=\"http://profiles.wordpress.org/sweetie089\">sweetie089</a>, <a href=\"http://profiles.wordpress.org/tar\">Tar</a>, <a href=\"http://profiles.wordpress.org/tlovett1\">Taylor Lovett</a>, <a href=\"http://profiles.wordpress.org/thomasvanderbeek\">Thomas van der Beek</a>, <a href=\"http://profiles.wordpress.org/n7studios\">Tim Carr</a>, <a href=\"http://profiles.wordpress.org/tjsingleton\">tjsingleton</a>, <a href=\"http://profiles.wordpress.org/tobiasbg\">TobiasBg</a>, <a href=\"http://profiles.wordpress.org/toscho\">toscho</a>, <a href=\"http://profiles.wordpress.org/taupecat\">Tracy Rotton</a>, <a href=\"http://profiles.wordpress.org/travishoffman\">TravisHoffman</a>, <a href=\"http://profiles.wordpress.org/uuf6429\">uuf6429</a>, <a href=\"http://profiles.wordpress.org/lightningspirit\">Vitor Carvalho</a>, <a href=\"http://profiles.wordpress.org/wojtek\">wojtek</a>, <a href=\"http://profiles.wordpress.org/wpewill\">wpewill</a>, <a href=\"http://profiles.wordpress.org/wraithkenny\">WraithKenny</a>, <a href=\"http://profiles.wordpress.org/wycks\">wycks</a>, <a href=\"http://profiles.wordpress.org/xibe\">Xavier Borderie</a>, <a href=\"http://profiles.wordpress.org/yoavf\">Yoav Farhi</a>, <a href=\"http://profiles.wordpress.org/thelastcicada\">Zachary Brown</a>, <a href=\"http://profiles.wordpress.org/tollmanz\">Zack Tollman</a>, <a href=\"http://profiles.wordpress.org/zekeweeks\">zekeweeks</a>, <a href=\"http://profiles.wordpress.org/ziegenberg\">ziegenberg</a>, and <a href=\"http://profiles.wordpress.org/viniciusmassuchetto\">viniciusmassuchetto</a>.</p>\n<p>Time to upgrade!</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:45:\"http://wordpress.org/news/2013/08/oscar/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:8;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"WordPress 3.6 Release Candidate 2\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:68:\"http://wordpress.org/news/2013/07/wordpress-3-6-release-candidate-2/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:77:\"http://wordpress.org/news/2013/07/wordpress-3-6-release-candidate-2/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 24 Jul 2013 07:25:10 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:7:\"Testing\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=2649\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:341:\"The second release candidate for WordPress 3.6 is now available for download and testing. We&#8217;re down to only a few remaining issues, and the final release should be available in a matter of days. In RC2, we&#8217;ve tightened up some aspects of revisions, autosave, and the media player, and fixed some bugs that were spotted [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Mark Jaquith\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:1325:\"<p>The second release candidate for WordPress 3.6 is now available for download and testing.</p>\n<p>We&#8217;re down to only a few remaining issues, and the final release should be available in a matter of days. In RC2, we&#8217;ve tightened up some aspects of revisions, autosave, and the media player, and fixed some bugs that were spotted in RC1. Please test this release candidate as much as you can, so we can deliver a smooth final release!</p>\n<p><strong>Think you&#8217;ve found a bug?</strong> Please post to the <a href=\"http://wordpress.org/support/forum/alphabeta/\">Alpha/Beta area in the support forums</a>.</p>\n<p><strong>Developers,</strong> please continue to test your plugins and themes, so that if there is a compatibility issue, we can figure it out before the final release. You can find our <a href=\"http://core.trac.wordpress.org/report/6\">list of known issues here</a>.</p>\n<p>To test WordPress 3.6, try the <a href=\"http://wordpress.org/extend/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin (you&#8217;ll want &#8220;bleeding edge nightlies&#8221;). Or you can <a href=\"http://wordpress.org/wordpress-3.6-RC2.zip\">download the release candidate here (zip)</a>.</p>\n<p><em>Revisions so smooth</em><br />\n<em>We autosave your changes</em><br />\n<em>Data loss begone!</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:73:\"http://wordpress.org/news/2013/07/wordpress-3-6-release-candidate-2/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:9;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"WordPress 3.6 Release Candidate\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:66:\"http://wordpress.org/news/2013/07/wordpress-3-6-release-candidate/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:75:\"http://wordpress.org/news/2013/07/wordpress-3-6-release-candidate/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 13 Jul 2013 03:23:17 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:7:\"Testing\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=2639\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:344:\"The first release candidate for WordPress 3.6 is now available. We hope to ship WordPress 3.6 in a couple weeks. But to do that, we really need your help! If you haven&#8217;t tested 3.6 yet, there&#8217;s no time like the present. (But please: not on a live production site, unless you&#8217;re feeling especially adventurous.) Think [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Mark Jaquith\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:1504:\"<p>The first release candidate for WordPress 3.6 is now available.</p>\n<p>We hope to ship WordPress 3.6 in a couple weeks. But to do that, we really need your help! If you haven&#8217;t tested 3.6 yet, there&#8217;s no time like the present. (But please: not on a live production site, unless you&#8217;re feeling especially adventurous.)</p>\n<p><strong>Think you&#8217;ve found a bug?</strong> Please post to the <a href=\"http://wordpress.org/support/forum/alphabeta/\">Alpha/Beta area in the support forums</a>. If any known issues come up, you’ll be able to <a href=\"http://core.trac.wordpress.org/report/6\">find them here</a>. <strong>Developers,</strong> please test your plugins and themes, so that if there is a compatibility issue, we can sort it out before the final release.</p>\n<p>To test WordPress 3.6, try the <a href=\"http://wordpress.org/extend/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin (you&#8217;ll want &#8220;bleeding edge nightlies&#8221;). Or you can <a href=\"http://wordpress.org/wordpress-3.6-RC1.zip\">download the release candidate here (zip)</a>.</p>\n<p>As you may have heard, we backed the Post Format UI feature out of the release. On the other hand, our slick new revisions browser had some extra time to develop. You should see it with 200+ revisions loaded — scrubbing back and forth at lightning speed is a thing of beauty.</p>\n<p><em>Delayed, but still loved</em><br />\n<em>The release will be out soon</em><br />\n<em>Test it, por favor</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:71:\"http://wordpress.org/news/2013/07/wordpress-3-6-release-candidate/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}s:27:\"http://www.w3.org/2005/Atom\";a:1:{s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:3:{s:4:\"href\";s:31:\"http://wordpress.org/news/feed/\";s:3:\"rel\";s:4:\"self\";s:4:\"type\";s:19:\"application/rss+xml\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:44:\"http://purl.org/rss/1.0/modules/syndication/\";a:2:{s:12:\"updatePeriod\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"hourly\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:15:\"updateFrequency\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";a:8:{s:6:\"server\";s:5:\"nginx\";s:4:\"date\";s:29:\"Fri, 25 Oct 2013 13:31:29 GMT\";s:12:\"content-type\";s:23:\"text/xml; charset=UTF-8\";s:10:\"connection\";s:5:\"close\";s:4:\"vary\";s:15:\"Accept-Encoding\";s:10:\"x-pingback\";s:36:\"http://wordpress.org/news/xmlrpc.php\";s:13:\"last-modified\";s:29:\"Thu, 24 Oct 2013 22:40:34 GMT\";s:4:\"x-nc\";s:11:\"HIT lax 249\";}s:5:\"build\";s:14:\"20130708231016\";}", "no");
INSERT INTO `wp_options` VALUES("4449", "_transient_timeout_feed_867bd5c64f85878d03a060509cd2f92c", "1382751090", "no");
INSERT INTO `wp_options` VALUES("4450", "_transient_feed_867bd5c64f85878d03a060509cd2f92c", "a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n\n\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:61:\"\n	\n	\n	\n	\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"WordPress Planet\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://planet.wordpress.org/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:2:\"en\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:47:\"WordPress Planet - http://planet.wordpress.org/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:50:{i:0;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:62:\"WPTavern: WordPress 3.7 Released: WordPress Now Updates Itself\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"http://www.wptavern.com/?p=10414\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:113:\"http://feedproxy.google.com/~r/WordpressTavern/~3/l-3I_2jNRJ4/wordpress-3-7-released-wordpress-now-updates-itself\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4510:\"<p>WordPress 3.7 has been <a href=\"http://wordpress.org/news/2013/10/basie/\" target=\"_blank\">released</a> and the big news is that WordPress now has the ability to update itself. This begins a new era of automatic background updates for security and minor releases. Web hosts around the world have been eagerly awaiting this release and are cheering its arrival. The upgrade process has been greatly improved and boy is it ever solid:</p>\n<blockquote class=\"twitter-tweet\" width=\"550\"><p>We ended the WordPress 3.7 beta cycle with 112,434 automatic background updates attempted and not a single critical failure.</p>\n<p>&mdash; Andrew Nacin (@nacin) <a href=\"https://twitter.com/nacin/statuses/393547010801803264\">October 25, 2013</a></p></blockquote>\n<p></p>\n<p><strong>Not a single critical failure.</strong> Try blaming Nacin for that, folks. </p>\n<p>WordPress 3.7 is dubbed Basie, after <a href=\"http://en.wikipedia.org/wiki/Count_basie\" target=\"_blank\">Count Basie</a>, an American jazz pianist with an unparalleled talent for improvisation. He learned to improvise while playing along to silent films for a local movie theater. Before he was famous, Basie sharpened his improv skills by playing jazz piano at parties and resorts. He went on to create his own jazz orchestra and mentor many other musicians along the way.<span id=\"more-10414\"></span></p>\n<p><div id=\"attachment_10421\" class=\"wp-caption alignright\"><a href=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/10/basie.jpg\" rel=\"thumbnail\"><img src=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/10/basie.jpg?resize=234%2C300\" alt=\"Count Basie\" class=\"size-medium wp-image-10421\" /></a><p class=\"wp-caption-text\">Count Basie</p></div>It seems fitting that this release honors Basie. The web is full of hackers who seek to exploit any vulnerability they can find in WordPress. Users have to be quick to improvise and secure our sites as soon as minor releases are shipped out. Automatic background updates give millions of users the ability to stay current with each security update. The beautiful thing is that it&#8217;s totally effortless on the part of the user.</p>\n<p>On the surface you won&#8217;t see too many flashy UI improvements, but under the hood you&#8217;ll find a better engine. When you search WordPress you&#8217;ll see better and more relevant results. Developers will be happy to find improved support for multisite, <a href=\"http://www.wptavern.com/wordpress-3-7-introduces-advanced-date-queries\" target=\"_blank\">advanced date queries</a> and a ton of new functions to play with. You can review every last detail on the dedicated <a href=\"http://codex.wordpress.org/Version_3.7\" target=\"_blank\">3.7 release page</a>.</p>\n<p><div id=\"attachment_10415\" class=\"wp-caption alignleft\"><a href=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/10/about.jpg\" rel=\"thumbnail\"><img src=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/10/about.jpg?resize=284%2C300\" alt=\"wp-admin/about.php\" class=\"size-medium wp-image-10415\" /></a><p class=\"wp-caption-text\">wp-admin/about.php</p></div>WordPress 3.7 has a beautiful about.php page that you can only see if you upgrade. <em>Hint, hint.</em> It includes a live demo of the <a href=\"http://www.wptavern.com/ridiculously-smart-password-meter-coming-to-wordpress-3-7\" target=\"_blank\">new password strength meter</a> that will help you to create stronger passwords.</p>\n<p>This release also includes better global support for translations, meaning that it will automatically install language files and silently keep them up to date. There&#8217;s a trend here: WordPress is doing a lot more for you in the background so that you can focus on creating content. This sets the bar pretty high for what users can expect from their publishing software in the future.</p>\n<p>Now that WordPress can update itself, I am once again reminded that this software is a living, breathing thing. Andrew Nacin, Dion Hulse and Jon Cave had the help of 211 contributors in shipping 3.7. Hats off to these folks &#8211; they&#8217;ve worked hard and done well. </p>\n<p>Time to celebrate with a few tunes from Count Basie and his jazz orchestra to kick off your upgrades. By the way, if you&#8217;re configuring automatic updates for everything, this is the last time you&#8217;ll ever have to update WordPress manually. </p>\n<p><span class=\"embed-youtube\"></span></p>\n<img src=\"http://feeds.feedburner.com/~r/WordpressTavern/~4/l-3I_2jNRJ4\" height=\"1\" width=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 25 Oct 2013 05:09:31 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"Dev Blog: WordPress 3.7 “Basie”\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=2736\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:40:\"http://wordpress.org/news/2013/10/basie/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:17220:\"<p>Version 3.7 of WordPress, named &#8220;Basie&#8221; in honor of <a href=\"http://en.wikipedia.org/wiki/Count_basie\">Count Basie</a>, is available <a href=\"http://wordpress.org/download/\">for download</a> or update in your WordPress dashboard. This release features some of the most important architectural updates we&#8217;ve made to date. Here are the big ones:</p>\n<ul>\n<li><strong>Updates while you sleep</strong>: With WordPress 3.7, you don&#8217;t have to lift a finger to apply maintenance and security updates. Most sites are now able to automatically apply these updates in the background. The update process also has been made even more reliable and secure, with dozens of new checks and safeguards.</li>\n<li><strong>Stronger password recommendations</strong>: Your password is your site&#8217;s first line of defense. It&#8217;s best to create passwords that are complex, long, and unique. To that end, our password meter has been updated in WordPress 3.7 to recognize common mistakes that can weaken your password: dates, names, keyboard patterns (123456789), and even pop culture references.</li>\n<li><strong>Better global support</strong>: Localized versions of WordPress will receive faster and more complete translations. WordPress 3.7 adds support for automatically installing the right language files and keeping them up to date, a boon for the many millions who use WordPress in a language other than English.</li>\n</ul>\n<p>For developers there are lots of options around how to control the new updates feature, including allowing it to handle major upgrades as well as minor ones, more sophisticated date query support, and multisite improvements. As always, if you&#8217;re hungry for more <a href=\"http://codex.wordpress.org/Version_3.7\">dive into the Codex</a> or browse the <a href=\"http://core.trac.wordpress.org/query?status=closed&group=resolution&milestone=3.7\">over 400 closed tickets on Trac</a>.</p>\n<h3>A New Wave</h3>\n<p>This release was led by Andrew Nacin, backed up by Dion Hulse and Jon Cave. This is our first release using the new plugin-first development process, with a much shorter timeframe than in the past. (3.6 was released in August.) The 3.8 release, due in December, will continue this plugin-led development cycle that gives much more autonomy to plugin leads and allows us to decouple feature development from a release. You can follow this grand experiment, and what we&#8217;re learning from it, <a href=\"http://make.wordpress.org/core/\">on the make/core blog</a>. There are 211 contributors with props in this release:</p>\n<p><a href=\"http://profiles.wordpress.org/technosailor\">Aaron Brazell</a>, <a href=\"http://profiles.wordpress.org/aaroncampbell\">Aaron D. Campbell</a>, <a href=\"http://profiles.wordpress.org/aaronholbrook\">Aaron Holbrook</a>, <a href=\"http://profiles.wordpress.org/jorbin\">Aaron Jorbin</a>, <a href=\"http://profiles.wordpress.org/adamsilverstein\">adamsilverstein</a>, <a href=\"http://profiles.wordpress.org/ahoereth\">Alexander Hoereth</a>, <a href=\"http://profiles.wordpress.org/viper007bond\">Alex Mills (Viper007Bond)</a>, <a href=\"http://profiles.wordpress.org/sabreuse\">Amy Hendrix (sabreuse)</a>, <a href=\"http://profiles.wordpress.org/andg\">andg</a>, <a href=\"http://profiles.wordpress.org/nacin\">Andrew Nacin</a>, <a href=\"http://profiles.wordpress.org/norcross\">Andrew Norcross</a>, <a href=\"http://profiles.wordpress.org/azaozz\">Andrew Ozz</a>, <a href=\"http://profiles.wordpress.org/andrewspittle\">Andrew Spittle</a>, <a href=\"http://profiles.wordpress.org/askapache\">askapache</a>, <a href=\"http://profiles.wordpress.org/atimmer\">atimmer</a>, <a href=\"http://profiles.wordpress.org/barry\">Barry</a>, <a href=\"http://profiles.wordpress.org/beaulebens\">Beau Lebens</a>, <a href=\"http://profiles.wordpress.org/benmoody\">ben.moody</a>, <a href=\"http://profiles.wordpress.org/bhengh\">Ben Miller</a>, <a href=\"http://profiles.wordpress.org/neoxx\">Bernhard Riedl</a>, <a href=\"http://profiles.wordpress.org/bftrick\">BFTrick</a>, <a href=\"http://profiles.wordpress.org/bananastalktome\">Billy (bananastalktome)</a>, <a href=\"http://profiles.wordpress.org/bmb\">bmb</a>, <a href=\"http://profiles.wordpress.org/kraftbj\">Brandon Kraft</a>, <a href=\"http://profiles.wordpress.org/brianhogg\">brianhogg</a>, <a href=\"http://profiles.wordpress.org/rzen\">Brian Richards</a>, <a href=\"http://profiles.wordpress.org/bpetty\">Bryan Petty</a>, <a href=\"http://profiles.wordpress.org/carldanley\">Carl Danley</a>, <a href=\"http://profiles.wordpress.org/charlesclarkson\">CharlesClarkson</a>, <a href=\"http://profiles.wordpress.org/chipbennett\">Chip Bennett</a>, <a href=\"http://profiles.wordpress.org/chouby\">Chouby</a>, <a href=\"http://profiles.wordpress.org/c3mdigital\">Chris Olbekson</a>, <a href=\"http://profiles.wordpress.org/chrisrudzki\">Chris Rudzki</a>, <a href=\"http://profiles.wordpress.org/aeg0125\">coderaaron</a>, <a href=\"http://profiles.wordpress.org/coenjacobs\">Coen Jacobs</a>, <a href=\"http://profiles.wordpress.org/crrobi01\">Colin Robinson</a>, <a href=\"http://profiles.wordpress.org/andreasnrb\">cyonite</a>, <a href=\"http://profiles.wordpress.org/daankortenbach\">Daan Kortenbach</a>, <a href=\"http://profiles.wordpress.org/danielbachhuber\">Daniel Bachhuber</a>, <a href=\"http://profiles.wordpress.org/convissor\">Daniel Convissor</a>, <a href=\"http://profiles.wordpress.org/dartiss\">dartiss</a>, <a href=\"http://profiles.wordpress.org/koop\">Daryl Koopersmith</a>, <a href=\"http://profiles.wordpress.org/csixty4\">Dave Ross</a>, <a href=\"http://profiles.wordpress.org/davidjlaietta\">David Laietta</a>, <a href=\"http://profiles.wordpress.org/dd32\">Dion Hulse</a>, <a href=\"http://profiles.wordpress.org/dllh\">dllh</a>, <a href=\"http://profiles.wordpress.org/ocean90\">Dominik Schilling (ocean90)</a>, <a href=\"http://profiles.wordpress.org/dpash\">dpash</a>, <a href=\"http://profiles.wordpress.org/drewapicture\">Drew Jaynes</a>, <a href=\"http://profiles.wordpress.org/drprotocols\">DrProtocols</a>, <a href=\"http://profiles.wordpress.org/dustyf\">Dustin Filippini</a>, <a href=\"http://profiles.wordpress.org/dzver\">dzver</a>, <a href=\"http://profiles.wordpress.org/cais\">Edward Caissie</a>, <a href=\"http://profiles.wordpress.org/enej\">enej</a>, <a href=\"http://profiles.wordpress.org/ericlewis\">Eric Andrew Lewis</a>, <a href=\"http://profiles.wordpress.org/ericmann\">Eric Mann</a>, <a href=\"http://profiles.wordpress.org/evansolomon\">Evan Solomon</a>, <a href=\"http://profiles.wordpress.org/faishal\">faishal</a>, <a href=\"http://profiles.wordpress.org/faison\">Faison</a>, <a href=\"http://profiles.wordpress.org/foofy\">Foofy</a>, <a href=\"http://profiles.wordpress.org/fjarrett\">Frankie Jarrett</a>, <a href=\"http://profiles.wordpress.org/frank-klein\">Frank Klein</a>, <a href=\"http://profiles.wordpress.org/garyc40\">Gary Cao</a>, <a href=\"http://profiles.wordpress.org/pento\">Gary Pendergast</a>, <a href=\"http://profiles.wordpress.org/gayadesign\">Gaya Kessler</a>, <a href=\"http://profiles.wordpress.org/georgestephanis\">George Stephanis</a>, <a href=\"http://profiles.wordpress.org/gizburdt\">Gizburdt</a>, <a href=\"http://profiles.wordpress.org/goldenapples\">goldenapples</a>, <a href=\"http://profiles.wordpress.org/gradyetc\">gradyetc</a>, <a href=\"http://profiles.wordpress.org/gcorne\">Gregory Cornelius</a>, <a href=\"http://profiles.wordpress.org/webord\">Gustavo Bordoni</a>, <a href=\"http://profiles.wordpress.org/hakre\">hakre</a>, <a href=\"http://profiles.wordpress.org/helen\">Helen Hou-Sandi</a>, <a href=\"http://profiles.wordpress.org/iandunn\">Ian Dunn</a>, <a href=\"http://profiles.wordpress.org/ipstenu\">Ipstenu (Mika Epstein)</a>, <a href=\"http://profiles.wordpress.org/creativeinfusion\">itinerant</a>, <a href=\"http://profiles.wordpress.org/jdgrimes\">J.D. Grimes</a>, <a href=\"http://profiles.wordpress.org/jakubtyrcha\">jakub.tyrcha</a>, <a href=\"http://profiles.wordpress.org/jamescollins\">James Collins</a>, <a href=\"http://profiles.wordpress.org/jenmylo\">Jen Mylo</a>, <a href=\"http://profiles.wordpress.org/buffler\">Jeremy Buller</a>, <a href=\"http://profiles.wordpress.org/jeremyfelt\">Jeremy Felt</a>, <a href=\"http://profiles.wordpress.org/jayjdk\">Jesper Johansen (jayjdk)</a>, <a href=\"http://profiles.wordpress.org/joehoyle\">Joe Hoyle</a>, <a href=\"http://profiles.wordpress.org/jkudish\">Joey Kudish</a>, <a href=\"http://profiles.wordpress.org/johnnyb\">John Beales</a>, <a href=\"http://profiles.wordpress.org/johnbillion\">John Blackbourn (johnbillion)</a>, <a href=\"http://profiles.wordpress.org/johnafish\">John Fish</a>, <a href=\"http://profiles.wordpress.org/johnjamesjacoby\">John James Jacoby</a>, <a href=\"http://profiles.wordpress.org/johnpbloch\">John P. Bloch</a>, <a href=\"http://profiles.wordpress.org/jond3r\">Jonas Bolinder (jond3r)</a>, <a href=\"http://profiles.wordpress.org/jchristopher\">Jonathan Christopher</a>, <a href=\"http://profiles.wordpress.org/desrosj\">Jonathan Desrosiers</a>, <a href=\"http://profiles.wordpress.org/duck_\">Jon Cave</a>, <a href=\"http://profiles.wordpress.org/jonlynch\">Jon Lynch</a>, <a href=\"http://profiles.wordpress.org/joostdevalk\">Joost de Valk</a>, <a href=\"http://profiles.wordpress.org/josephscott\">Joseph Scott</a>, <a href=\"http://profiles.wordpress.org/betzster\">Josh Betz</a>, <a href=\"http://profiles.wordpress.org/devesine\">Justin de Vesine</a>, <a href=\"http://profiles.wordpress.org/justinsainton\">Justin Sainton</a>, <a href=\"http://profiles.wordpress.org/kadamwhite\">K.Adam White</a>, <a href=\"http://profiles.wordpress.org/trepmal\">Kailey (trepmal)</a>, <a href=\"http://profiles.wordpress.org/ketwaroo\">Ketwaroo</a>, <a href=\"http://profiles.wordpress.org/kevinb\">kevinB</a>, <a href=\"http://profiles.wordpress.org/kpdesign\">Kim Parsell</a>, <a href=\"http://profiles.wordpress.org/kitchin\">kitchin</a>, <a href=\"http://profiles.wordpress.org/kovshenin\">Konstantin Kovshenin</a>, <a href=\"http://profiles.wordpress.org/obenland\">Konstantin Obenland</a>, <a href=\"http://profiles.wordpress.org/koopersmith\">koopersmith</a>, <a href=\"http://profiles.wordpress.org/kurtpayne\">Kurt Payne</a>, <a href=\"http://profiles.wordpress.org/lancewillett\">Lance Willett</a>, <a href=\"http://profiles.wordpress.org/leewillis77\">Lee Willis (leewillis77)</a>, <a href=\"http://profiles.wordpress.org/lessbloat\">lessbloat</a>, <a href=\"http://profiles.wordpress.org/layotte\">Lew Ayotte</a>, <a href=\"http://profiles.wordpress.org/lgedeon\">Luke Gedeon</a>, <a href=\"http://profiles.wordpress.org/iworks\">Marcin Pietrzak</a>, <a href=\"http://profiles.wordpress.org/cimmo\">Marco Cimmino</a>, <a href=\"http://profiles.wordpress.org/marco_teethgrinder\">Marco Galasso</a>, <a href=\"http://profiles.wordpress.org/markjaquith\">Mark Jaquith</a>, <a href=\"http://profiles.wordpress.org/markmcwilliams\">Mark McWilliams</a>, <a href=\"http://profiles.wordpress.org/markoheijnen\">Marko Heijnen</a>, <a href=\"http://profiles.wordpress.org/melchoyce\">Mel Choyce</a>, <a href=\"http://profiles.wordpress.org/tw2113\">Michael Beckwith</a>, <a href=\"http://profiles.wordpress.org/mikehansenme\">Mike Hansen</a>, <a href=\"http://profiles.wordpress.org/mikeschinkel\">Mike Schinkel</a>, <a href=\"http://profiles.wordpress.org/dh-shredder\">Mike Schroder</a>, <a href=\"http://profiles.wordpress.org/dimadin\">Milan Dinic</a>, <a href=\"http://profiles.wordpress.org/mitchoyoshitaka\">mitcho (Michael Yoshitaka Erlewine)</a>, <a href=\"http://profiles.wordpress.org/usermrpapa\">Mr Papa</a>, <a href=\"http://profiles.wordpress.org/Nao\">Naoko Takano</a>, <a href=\"http://profiles.wordpress.org/naomicbush\">Naomi</a>, <a href=\"http://profiles.wordpress.org/alex-ye\">Nashwan Doaqan</a>, <a href=\"http://profiles.wordpress.org/natejacobs\">NateJacobs</a>, <a href=\"http://profiles.wordpress.org/nathanrice\">nathanrice</a>, <a href=\"http://profiles.wordpress.org/niallkennedy\">Niall Kennedy</a>, <a href=\"http://profiles.wordpress.org/nickdaugherty\">Nick Daugherty</a>, <a href=\"http://profiles.wordpress.org/celloexpressions\">Nick Halsey</a>, <a href=\"http://profiles.wordpress.org/nickmomrik\">Nick Momrik</a>, <a href=\"http://profiles.wordpress.org/nikv\">Nikhil Vimal (NikV)</a>, <a href=\"http://profiles.wordpress.org/nbachiyski\">Nikolay Bachiyski</a>, <a href=\"http://profiles.wordpress.org/noahsilverstein\">noahsilverstein</a>, <a href=\"http://profiles.wordpress.org/nofearinc\">nofearinc</a>, <a href=\"http://profiles.wordpress.org/nukaga\">nukaga</a>, <a href=\"http://profiles.wordpress.org/nullvariable\">nullvariable</a>, <a href=\"http://profiles.wordpress.org/butuzov\">Oleg Butuzov</a>, <a href=\"http://profiles.wordpress.org/paolal\">Paolo Belcastro</a>, <a href=\"http://profiles.wordpress.org/xparham\">Parham</a>, <a href=\"http://profiles.wordpress.org/pbiron\">Paul Biron</a>, <a href=\"http://profiles.wordpress.org/pauldewouters\">Paul de Wouters</a>, <a href=\"http://profiles.wordpress.org/pavelevap\">pavelevap</a>, <a href=\"http://profiles.wordpress.org/peterjaap\">peterjaap</a>, <a href=\"http://profiles.wordpress.org/westi\">Peter Westwood</a>, <a href=\"http://profiles.wordpress.org/philiparthurmoore\">Philip Arthur Moore</a>, <a href=\"http://profiles.wordpress.org/mordauk\">Pippin Williamson</a>, <a href=\"http://profiles.wordpress.org/plocha\">plocha</a>, <a href=\"http://profiles.wordpress.org/pollett\">Pollett</a>, <a href=\"http://profiles.wordpress.org/ptahdunbar\">Ptah Dunbar</a>, <a href=\"http://profiles.wordpress.org/ramiy\">Rami Yushuvaev</a>, <a href=\"http://profiles.wordpress.org/rasheed\">Rasheed Bydousi</a>, <a href=\"http://profiles.wordpress.org/raybernard\">RayBernard</a>, <a href=\"http://profiles.wordpress.org/rboren\">rboren</a>, <a href=\"http://profiles.wordpress.org/greuben\">Reuben Gunday</a>, <a href=\"http://profiles.wordpress.org/rfair404\">rfair404</a>, <a href=\"http://profiles.wordpress.org/iamfriendly\">Richard Tape</a>, <a href=\"http://profiles.wordpress.org/r3df\">Rick Radko</a>, <a href=\"http://profiles.wordpress.org/miqrogroove\">Robert Chapin</a>, <a href=\"http://profiles.wordpress.org/rdall\">Robert Dall</a>, <a href=\"http://profiles.wordpress.org/rodrigosprimo\">Rodrigo Primo</a>, <a href=\"http://profiles.wordpress.org/wpmuguru\">Ron Rennick</a>, <a href=\"http://profiles.wordpress.org/rpattillo\">rpattillo</a>, <a href=\"http://profiles.wordpress.org/ryan\">Ryan Boren</a>, <a href=\"http://profiles.wordpress.org/rmccue\">Ryan McCue</a>, <a href=\"http://profiles.wordpress.org/hotchkissconsulting\">Sam Hotchkiss</a>, <a href=\"http://profiles.wordpress.org/coffee2code\">Scott Reilly</a>, <a href=\"http://profiles.wordpress.org/scottsweb\">scottsweb</a>, <a href=\"http://profiles.wordpress.org/wonderboymusic\">Scott Taylor</a>, <a href=\"http://profiles.wordpress.org/scribu\">scribu</a>, <a href=\"http://profiles.wordpress.org/scruffian\">scruffian</a>, <a href=\"http://profiles.wordpress.org/tenpura\">Seisuke Kuraishi (tenpura)</a>, <a href=\"http://profiles.wordpress.org/sergeybiryukov\">Sergey Biryukov</a>, <a href=\"http://profiles.wordpress.org/shinichin\">ShinichiN</a>, <a href=\"http://profiles.wordpress.org/pross\">Simon Prosser</a>, <a href=\"http://profiles.wordpress.org/simonwheatley\">Simon Wheatley</a>, <a href=\"http://profiles.wordpress.org/siobhan\">Siobhan</a>, <a href=\"http://profiles.wordpress.org/siobhyb\">Siobhan Bamber (siobhyb)</a>, <a href=\"http://profiles.wordpress.org/sirzooro\">sirzooro</a>, <a href=\"http://profiles.wordpress.org/solarissmoke\">solarissmoke</a>, <a href=\"http://profiles.wordpress.org/sillybean\">Stephanie Leary</a>, <a href=\"http://profiles.wordpress.org/netweb\">Stephen Edgar (@netweb)</a>, <a href=\"http://profiles.wordpress.org/stephenharris\">Stephen Harris</a>, <a href=\"http://profiles.wordpress.org/strangerstudios\">strangerstudios</a>, <a href=\"http://profiles.wordpress.org/sweetie089\">sweetie089</a>, <a href=\"http://profiles.wordpress.org/swissspidy\">swissspidy</a>, <a href=\"http://profiles.wordpress.org/miyauchi\">Takayuki Miyauchi</a>, <a href=\"http://profiles.wordpress.org/tmtoy\">Takuma Morikawa</a>, <a href=\"http://profiles.wordpress.org/tlovett1\">Taylor Lovett</a>, <a href=\"http://profiles.wordpress.org/tivnet\">tivnet</a>, <a href=\"http://profiles.wordpress.org/tobiasbg\">TobiasBg</a>, <a href=\"http://profiles.wordpress.org/tomauger\">Tom Auger</a>, <a href=\"http://profiles.wordpress.org/toscho\">toscho</a>, <a href=\"http://profiles.wordpress.org/wpsmith\">Travis Smith</a>, <a href=\"http://profiles.wordpress.org/sorich87\">Ulrich Sossou</a>, <a href=\"http://profiles.wordpress.org/vericgar\">vericgar</a>, <a href=\"http://profiles.wordpress.org/vinod-dalvi\">Vinod Dalvi</a>, <a href=\"http://profiles.wordpress.org/westonruter\">Weston Ruter</a>, <a href=\"http://profiles.wordpress.org/wikicms\">wikicms</a>, <a href=\"http://profiles.wordpress.org/willnorris\">Will Norris</a>, <a href=\"http://profiles.wordpress.org/wojtekszkutnik\">Wojtek Szkutnik</a>, <a href=\"http://profiles.wordpress.org/wycks\">wycks</a>, <a href=\"http://profiles.wordpress.org/yoavf\">Yoav Farhi</a>, and <a href=\"http://profiles.wordpress.org/yurivictor\">Yuri Victor</a>.</p>\n<p>Enjoy what may be one of your last few manual updates. See you soon for version 3.8!</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 24 Oct 2013 22:35:10 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:83:\"WPTavern: Disrupting The WordPress Commercial Theme Market – A 3themes Experiment\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"http://www.wptavern.com/?p=10398\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:121:\"http://feedproxy.google.com/~r/WordpressTavern/~3/w5xTWijIX1o/disrupting-the-commercial-theme-market-a-3themes-experiment\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3501:\"<p><a href=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/10/3themessplashpage.jpg\" rel=\"thumbnail\"><img src=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/10/3themessplashpage.jpg?resize=173%2C300\" alt=\"3 themes splash page\" class=\"alignright size-medium wp-image-10399\" /></a>The questions are simple but the answers are not. <em>Can a theme that is built for developers using best practices be successful in the commercial space? Can a commercial theme add value without adding functionality and bloat?</em> Those are the questions that a trio of WordPress developers are going to try to answer with their <a href=\"http://3them.es/\" title=\"http://3them.es/\">3them.es experiment</a>. </p>\n<p>Michelle Schulp of Marktimemedia has <a href=\"http://marktimemedia.com/disrupting-wordpress-commercial-theme-marketplace/\" title=\"http://marktimemedia.com/disrupting-wordpress-commercial-theme-marketplace/\">published her experience</a> at <a href=\"http://pressnomics.com/\" title=\"http://pressnomics.com/\">Pressnomics 2013</a> and the reasoning behind the new experiment. While at the event, she attended the<a href=\"http://pressnomics.com/schedule/\" title=\"http://pressnomics.com/schedule/\"> Commercialization in the WordPress ecosystem</a> panel session featuring business owners Pippin Williamson, Carl Hancock, Cory Miller, and Helen Souness. In that discussion, the following question was asked. <em>How do you build a commercial digital product, especially one built using the GPL, that adds value in a way that is distinguishable from its competitors?</em> According to Michelle, the panel was quick to dismiss commercial themes as being easily commoditized.  <span id=\"more-10398\"></span></p>\n<p>After talking with a number of people at the conference, Michelle decided to partner with <a href=\"https://twitter.com/kikodoran\" title=\"https://twitter.com/kikodoran\">Kiko Doran</a>, and <a href=\"https://twitter.com/joshbroton\" title=\"https://twitter.com/joshbroton\">Josh Broton</a> to start the 3themes experiment.</p>\n<blockquote><p>3themes is a unique collaboration because we will also be documenting it every step of the way: recording our weekly meetings on Google Hangout in the form of a podcast, blogging about our process on the website, hosting code on GitHub, voicing our thoughts on Twitter, etc. We want this not only to be a case study in the commercial theme marketplace, but in working as a small distributed team and problem solving just as we would for a client. The hope is to create some dialogue in the WordPress community, as well as just have some fun and see what great things we can build together.</p></blockquote>\n<p>If you&#8217;re interested to see where this goes, check out the live <a href=\"http://www.youtube.com/user/3themesWP\" title=\"http://www.youtube.com/user/3themesWP\">Google hangout at 8:30 PM CST</a> on Tuesday nights as they begin the process of experimentation by first building their website and brand. </p>\n<p>This is going to be an excellent experiment and I bet many are curious as to what the end result will be. If you remember, Justin Tadlock <a href=\"http://www.wptavern.com/justin-tadlock-publishes-the-results-of-his-themeforest-experiment\" title=\"http://www.wptavern.com/justin-tadlock-publishes-the-results-of-his-themeforest-experiment\">performed a similar experiment</a> via ThemeForest with mildly successful results. </p>\n<img src=\"http://feeds.feedburner.com/~r/WordpressTavern/~4/w5xTWijIX1o\" height=\"1\" width=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 24 Oct 2013 21:21:11 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Jeffro\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:105:\"WordPress.tv: Brian Krogsgard and Pippin Williamson: WordPress Plugins, Code And The Ecosystem In General\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=24111\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:121:\"http://wordpress.tv/2013/10/24/brian-krogsgard-and-pippin-williamson-wordpress-plugins-code-and-the-ecosystem-in-general/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:759:\"<div id=\"v-htWbPDZb-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/24111/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/24111/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=24111&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/10/24/brian-krogsgard-and-pippin-williamson-wordpress-plugins-code-and-the-ecosystem-in-general/\"><img alt=\"Brian Krogsgard and Pippin Williamson: WordPress Plugins, Code And The Ecosystem In General\" src=\"http://videos.videopress.com/htWbPDZb/video-181ade0280_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 24 Oct 2013 20:37:15 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:78:\"WPTavern: Add Your Meetup Group to the Central WordPress Account on Meetup.com\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"http://www.wptavern.com/?p=10313\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:130:\"http://feedproxy.google.com/~r/WordpressTavern/~3/o_k5yMGxjF4/add-your-meetup-group-to-the-central-wordpress-account-on-meetup-com\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2127:\"<p><a href=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/10/meetups.jpg\" rel=\"thumbnail\"><img src=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/10/meetups.jpg?resize=282%2C300\" alt=\"meetups\" class=\"alignright size-medium wp-image-10389\" /></a>If you run a local WordPress meetup, you&#8217;re invited to move it under the <a href=\"http://www.meetup.com/wordpress/\" target=\"_blank\">central WordPress account</a> on meetup.com. Jen Mylo <a href=\"http://make.wordpress.org/community/2013/10/22/new-meetups/\" target=\"_blank\">created a form</a> where meetup coordinators can submit their meetup to be included. The awesome benefit is that WordPress will cover the meetup.com dues for your listing.  </p>\n<p>Jen posted a number of simple guidelines that were created by active meetup group volunteers. Your group will have to fulfill these before submitting to the central account. I won&#8217;t list them all here, but this is a summary: Essentially, you can&#8217;t use your local meetup to pimp out your business or yourself. Leave Mr. Salesman at home and join a meetup to connect with other WordPress fans. Meetups are for the benefit of the community and polite and respectful behavior is expected. If you organize a meetup that qualifies, use the form to get in touch with Jen Mylo.<span id=\"more-10313\"></span></p>\n<p>A some point in the future, meetup group listings will most likely switch over to using SupportPress, as they do for WordCamps. For now, they&#8217;ll be consolidating all the meetups on meetup.com. Please note that the <a href=\"http://make.wordpress.org/community/meetup-interest-form/\" target=\"_blank\">meetup interest form</a> is not just for new meetup groups but is also available for existing WordPress meetups that want to transfer the group over to the central account.</p>\n<p>It&#8217;s very cool that WordPress is supporting local meetups by covering their meetup.com dues. Help spread the word to get this information out there to local meetup organizers that you know. </p>\n<img src=\"http://feeds.feedburner.com/~r/WordpressTavern/~4/o_k5yMGxjF4\" height=\"1\" width=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 24 Oct 2013 19:33:57 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:5;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:69:\"WPTavern: Jarvis: A Free Quicksearch Tool for the WordPress Dashboard\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"http://www.wptavern.com/?p=10359\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:120:\"http://feedproxy.google.com/~r/WordpressTavern/~3/ntFV7bakzqY/jarvis-a-free-quicksearch-tool-for-the-wordpress-dashboard\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3233:\"<p>If you&#8217;ve ever used a WordPress site with thousands of posts and/or hundreds of pages, you might have found it a challenge to quickly navigate to the content you&#8217;re looking for. <a href=\"http://wpjarvis.com/\" title=\"Jarvis WordPress Dashboard Quicksearch Plugin\" target=\"_blank\">Jarvis</a> is a new dashboard quicksearch plugin that addresses this very problem. </p>\n<p><a href=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/10/jarvis.png\" rel=\"thumbnail\"><img src=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/10/jarvis.png?resize=560%2C225\" alt=\"jarvis\" class=\"aligncenter size-full wp-image-10372\" /></a></p>\n<p>Created by the folks at <a href=\"http://www.webdevelopmentgroup.com/\" target=\"_blank\">The Web Development Group</a>, the Jarvis plugin lets you easily search anything that you&#8217;re looking for inside the WordPress admin area, including plugins, themes, content, settings pages and everything else. <span id=\"more-10359\"></span></p>\n<p>Jarvis is available on <a href=\"http://wordpress.org/plugins/jarvis/\" target=\"_blank\">WordPress.org</a> but it also has its own homepage where you can find a demo that shows how it works:</p>\n<p><a href=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/10/jarvis-preview.gif\" rel=\"thumbnail\"><img src=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/10/jarvis-preview.gif?resize=460%2C259\" alt=\"jarvis-preview\" class=\"aligncenter size-full wp-image-10362\" /></a></p>\n<p>While different areas of the WordPress dashboard do include a search option, i.e. installed plugins or post content, there is no centralized search form to search everything. Ever install a plugin and then can&#8217;t, for the life of you, find its settings page? The Jarvis search helps you to instantly locate it. I can see how this could be very useful for a new user. For example, one might not know that the import feature is located under Tools. Using Jarvis he can quickly search and navigate to the import screen. </p>\n<p>There&#8217;s another similar tool out there called <a href=\"http://wpbutler.com/\" target=\"_blank\">WP Butler</a>, which also launches from the admin bar. I don&#8217;t know if Jarvis grabbed some inspiration from its code or not but the tools seem somewhat similar in that they both make it easier to get to pages in the WordPress admin.</p>\n<p>Beyond just helping you find things, the Jarvis plugin allows you to quickly zoom through the WordPress dashboard. For many, typing in a search box is second nature and much quicker than mousing around to the correct menu. Jarvis search appears to be lightning fast. This is one plugin that seems to be universally beneficial to both new and experienced WordPress users.</p>\n<p>The folks at <a href=\"http://www.webdevelopmentgroup.com/\" target=\"_blank\">The Web Development Group</a> created Jarvis to fill a need they saw in the WordPress admin area. This tool is the first of many that they plan to release. You can download it for free at the <a href=\"http://wpjarvis.com/\" target=\"_blank\">WP Jarvis</a> homepage or via the Add New plugins page within the WordPress admin.</p>\n<img src=\"http://feeds.feedburner.com/~r/WordpressTavern/~4/ntFV7bakzqY\" height=\"1\" width=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 24 Oct 2013 17:35:19 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:6;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:77:\"WordPress.tv: Daniel Espinoza: Creating and Selling Premium WordPress Plugins\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=23010\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:94:\"http://wordpress.tv/2013/10/24/daniel-espinoza-creating-and-selling-premium-wordpress-plugins/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:710:\"<div id=\"v-7cL5XX5Y-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/23010/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/23010/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=23010&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/10/24/daniel-espinoza-creating-and-selling-premium-wordpress-plugins/\"><img alt=\"Daniel Espinoza: Creating and Selling Premium WordPress Plugins\" src=\"http://videos.videopress.com/7cL5XX5Y/video-cb631cc3cc_scruberthumbnail_0.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 24 Oct 2013 14:33:43 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:7;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:68:\"WPTavern: Pulse: An Example WordPress Plugin Using the Heartbeat API\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"http://www.wptavern.com/?p=10304\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:119:\"http://feedproxy.google.com/~r/WordpressTavern/~3/HuYeePJabQ4/pulse-an-example-wordpress-plugin-using-the-heartbeat-api\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3401:\"<p>I&#8217;ve long been a fan of WordPress developer Jeffrey Pearce, better known online as <a href=\"http://www.jeffikus.com/\" target=\"_blank\">Jeffikus</a>. He&#8217;s created several educational resources for WordPress over the past few years. Today he released Pulse on github. <a href=\"https://github.com/jeffikus/pulse\" target=\"_blank\">Pulse</a> is an open source plugin that will help developers get started with Heartbeat API development.</p>\n<p><div id=\"attachment_10317\" class=\"wp-caption aligncenter\"><a href=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/10/origin_4365641577.jpg\" rel=\"thumbnail\"><img src=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/10/origin_4365641577.jpg?resize=560%2C315\" alt=\"photo credit: Lars P. via photopin cc\" class=\"size-full wp-image-10317\" /></a><p class=\"wp-caption-text\">photo credit: <a href=\"http://www.flickr.com/photos/lars_p/4365641577/\">Lars P.</a> via <a href=\"http://photopin.com\">photopin</a> <a href=\"http://creativecommons.org/licenses/by/2.0/\">cc</a></p></div><span id=\"more-10304\"></span></p>\n<h3>What is the WordPress Heartbeat API?</h3>\n<p>The <a href=\"http://core.trac.wordpress.org/ticket/23216\" target=\"_blank\">Heartbeat API</a> was a new feature as of WordPress 3.6. It currently powers the autosave, post locking and log-in expiration warning that users receive while writing posts. This API works in the background to manage communication between a user&#8217;s browser and the server, enabling the creation of WordPress-powered asynchronous apps.</p>\n<p>Jeffikus&#8217; Pulse plugin example demonstrates how to do two simple things:</p>\n<ul>\n<li>Outputs console data for a logged in user &#8211; the object will state that the user is logged in:<br />\n<a href=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/10/output.png\" rel=\"thumbnail\"><img src=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/10/output.png?resize=560%2C61\" alt=\"output\" class=\"alignleft size-full wp-image-10310\" /></a></li>\n<li>Outputs console data for a non logged in user &#8211; the object will state that the user is not logged in:<br />\n<a href=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/10/output-not-logged-in.png\" rel=\"thumbnail\"><img src=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/10/output-not-logged-in.png?resize=560%2C54\" alt=\"output-not-logged-in\" class=\"alignleft size-full wp-image-10311\" /></a>\n</li>\n</ul>\n<p>This plugin doesn&#8217;t actually perform any specific function, except to show you how you can interact with the WordPress Heartbeat API. It&#8217;s a learning tool to help developers get started building their own plugins. </p>\n<p>At the bottom of the <a href=\"https://github.com/jeffikus/pulse\" target=\"_blank\">Pulse plugin readme file</a> on github Jeffikus includes a list of all the tutorials on the Heartbeat API that helped him to learn about it in the first place. If it wasn&#8217;t for other developers writing about what they are learning, he probably wouldn&#8217;t have had the inspiration to create this handy starter plugin. Hopefully, developers can use it to build something cool and help contribute back to the Heartbeat API <a href=\"http://codex.wordpress.org/Function_Reference/wp_heartbeat_settings\" target=\"_blank\">documentation</a>.</p>\n<img src=\"http://feeds.feedburner.com/~r/WordpressTavern/~4/HuYeePJabQ4\" height=\"1\" width=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 23 Oct 2013 22:04:46 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:8;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:73:\"WPTavern: Your Members Plugin Closes Its Doors, Releases Assets Under GPL\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"http://www.wptavern.com/?p=10307\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:124:\"http://feedproxy.google.com/~r/WordpressTavern/~3/YCmv-tDNTiU/your-members-plugin-closes-its-doors-releases-assets-under-gpl\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3069:\"<p><a href=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/10/YourMembersLogo.jpg\" rel=\"thumbnail\"><img src=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/10/YourMembersLogo.jpg?resize=300%2C99\" alt=\"Your Members Logo\" class=\"alignright size-medium wp-image-10342\" /></a>The membership plugin <a href=\"http://blog.yourmembers.co.uk/2013/end-of-your-members/\" title=\"http://blog.yourmembers.co.uk/2013/end-of-your-members/\">Your Members has announced</a> that they are ceasing operations. Your Members, which has been around since 2008, was one of the early successful commercial plugins in the membership space. The tale of the plugin&#8217;s demise is an interesting one because it has more to do with development than anything else. <span id=\"more-10307\"></span></p>\n<blockquote><p>We started work on YM13 early this year and it became clear the new version wasn’t going to work with our current codebase. Indeed it reached the stage where even little changes are causing massive issues. So in August it was decided that we needed to make YM13 the last release on the current codebase and start on YMv2. I was rereading the blog posts that are sitting in drafts explaining where we were going and why, we never published them.</p>\n<p>It became clear it was just not financially feasible to build YMv2 we estimated it was 6 to 9 months work to do what we wanted to do properly and to do it we need to do it properly. We also believe we can’t continue to support and update the existing codebase. </p></blockquote>\n<p>While the developers of Your Members received offers to be purchased, they declined them as they didn&#8217;t feel the buyer would provide the community with genuine support and were after their email list instead. Thus, it was decided that Your Members be withdrawn from the market and would no longer be for sale. </p>\n<p>One of the unique aspects of Your Members is that it contained a sunset clause. Now that the plugin has been withdrawn from the market, that clause has been invoked meaning everything in the Your Members download, including assets are available under the GPL license. Prior to closing, Your Members operated under a split license with the PHP licensed under the GPL and all other files under a different license. The <a href=\"https://github.com/YourMembers/yourmembers\" title=\"https://github.com/YourMembers/yourmembers\">plugin</a> as well as the <a href=\"https://github.com/YourMembers/yourmembers/wiki/Your-Members-Documentation\" title=\"https://github.com/YourMembers/yourmembers/wiki/Your-Members-Documentation\">documentation</a> will now live on Github. </p>\n<h3>Is This The Way To Close a Business?</h3>\n<p>It&#8217;s disappointing to see any business fold but I have to hand it to the folks behind Your Members. They are making everything open source and laying the ground work for anyone else who wants to try to pick up where they left off. How do you feel about the way they closed up shop?</p>\n<img src=\"http://feeds.feedburner.com/~r/WordpressTavern/~4/YCmv-tDNTiU\" height=\"1\" width=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 23 Oct 2013 21:00:22 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Jeffro\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:9;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:80:\"WPTavern: WordPress Host WP Engine Will Not Support Automatic Background Updates\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"http://www.wptavern.com/?p=10293\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:132:\"http://feedproxy.google.com/~r/WordpressTavern/~3/1vIBBXFTK7M/wordpress-host-wp-engine-will-not-support-automatic-background-updates\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:5152:\"<p><a href=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/10/wpengine.png\" rel=\"thumbnail\"><img src=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/10/wpengine.png?resize=216%2C55\" alt=\"wpengine\" class=\"alignright size-full wp-image-10333\" /></a>Managed updates have always been one of the main selling points for WP Engine&#8217;s WordPress <a href=\"http://wpengine.com/plans/\" target=\"_blank\">hosting packages</a>. Customers have the luxury of never having to update their own sites because WP Engine keeps them on the cutting edge:</p>\n<blockquote><p>We keep your site secure without you having to think about it. Whenever WordPress issues a security update, we test it, and then proactively apply it to your site.</p></blockquote>\n<p>However, the company <a href=\"http://wpengine.com/2013/10/22/wordpress-3-7-will-drop-soon-heres-need-know/\" target=\"_blank\">announced</a> today that it will not be offering support for WordPress&#8217; new ability to update itself. </p>\n<blockquote><p>WP Engine will not be supporting the background updates for WordPress. We will continue managing the updates for your installs, testing each release on our infrastructure, and fully managing the releases of the minor updates. For example, when there is a security update to WordPress, as soon as the patch is released, we’ll update all customer sites to ensure we continue to keep your sites safe and sound.</p></blockquote>\n<p><span id=\"more-10293\"></span></p>\n<p>I asked WP Engine to clarify this statement. Does this mean that customers cannot enable automatic updates via the <strong>WP_AUTO_UPDATE_CORE</strong> define in <em>wp-config.php</em>? It seems that is the case. Their official policy is that automatic background updates will be disabled and customers will not be able to turn them on:</p>\n<blockquote><p>The function will be disabled because when we update we also automatically create site backups for you.</p></blockquote>\n<p>WP Engine will still continue to update customer sites as they always have. There&#8217;s no change here, but it is always interesting to note when a company restricts access to something that will soon be native to WordPress.</p>\n<h3>Playing it Safe</h3>\n<p>One huge advantage of enabling automatic background updates for WordPress is that a site can get those security improvements the very same day they are released with no waiting time. The same applies with major releases, plugins and themes, if one wants to live adventurously. However, if you host with WP Engine, you&#8217;ll have to settle with living on the safe side.</p>\n<p>WP Engine customers will either need to manually update their sites through the dashboard or wait for WP Engine to initiate those updates. The company tries to ship security updates out as soon as possible and these updates are usually applied within the same day. The reason for this is to keep customers from accidentally breaking their own sites without backing them up. WP Engine customers will be upgraded within a week or two of the 3.7 release, as per their announcement today. For many customers, this is exactly why they have chosen WP Engine. Not having to worry about testing major updates is a huge relief for WordPress site admins.</p>\n<h3>The Future of Managed WordPress Hosting: A Growing List of Restrictions</h3>\n<p>I am surprised that this popular WordPress hosting company is preventing its customers from taking advantage of one of the most exciting new features of WordPress 3.7. Although customers always have the freedom to manually update their sites early, they will not be permitted to allow WordPress to update itself. This makes sense as a company policy, but as a developer I can&#8217;t help but see it as a limitation. </p>\n<p>Why not allow developers to override the WP Engine restrictions via WP_AUTO_UPDATE_CORE in wp-config.php? Your average user isn&#8217;t likely to venture into this file to make any modifications, so it would be safe to assume that anyone who applied those settings knew what they were doing. The WP Engine infrastructure, however, does not allow for this.</p>\n<p>WP Engine does a lot of things right when it comes to speed and prioritizing the customer&#8217;s ability to have a development environment. The company is a proven and reliable WordPress host that I would recommend to anyone.  For many customers, trading freedom for security is well worth it in order to have their sites fully &#8220;managed.&#8221; </p>\n<p>But what about the others who may want the freedom to let WordPress update itself? The company has very good reasons for limiting developers from doing this. But will the number of <a href=\"http://wpengine.com/support/disallowed-plugins/\" target=\"_blank\">restrictions</a> continue to grow? Managed WordPress hosts are a relatively new development in the marketplace of WordPress services. It will be interesting to see how their policies develop in relationship to WordPress core enhancements, which more often than not err on the side of giving more freedom to the user. </p>\n<img src=\"http://feeds.feedburner.com/~r/WordpressTavern/~4/1vIBBXFTK7M\" height=\"1\" width=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 23 Oct 2013 19:13:05 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:10;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:63:\"WPTavern: How To Navigate The WordPress Ecosystem As a New User\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"http://www.wptavern.com/?p=10237\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:115:\"http://feedproxy.google.com/~r/WordpressTavern/~3/gJiQc_Kl5ZA/how-to-navigate-the-wordpress-ecosystem-as-a-new-user\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:6305:\"<p>The WordPress ecosystem is made up of thousands of websites, code repositories, blogs, forums, etc. To a new WordPress user, it can be intimidating or downright frustrating figuring out where to go. My goal with this post is to provide a map for those who are brand new to the world of WordPress to be able to navigate with confidence. I&#8217;ve personally experienced being in a city I&#8217;ve never been to before and not knowing which direction to travel to reach my destination. It&#8217;s a frustrating experience. This guide ought to alleviate those frustrations for WordPress first timers. <span id=\"more-10237\"></span></p>\n<h3>Themes</h3>\n<p>So the default theme isn&#8217;t your cup of tea. Before going to Google and searching for &#8220;<em>free WordPress themes</em>&#8221; head over to the <a href=\"http://wordpress.org/themes/\" title=\"http://wordpress.org/themes/\">WordPress Theme Repository</a>. It&#8217;s the safest place to obtain a new design for your site. Themes that are added to the repository are scanned and go through a <a href=\"http://codex.wordpress.org/Theme_Review\" title=\"http://codex.wordpress.org/Theme_Review\">thorough checklist</a> before they are accepted. All of the themes hosted on the repository are free of charge. If you want to know the reasons why using Google to find free WordPress themes is bad, watch this video by <a href=\"http://www.themelab.com/\" title=\"http://www.themelab.com/\">Leland of Themelab.com</a>. </p>\n<div class=\"aligncenter\"></div>\n<h3>Plugins</h3>\n<p>Much like the theme repository, WordPress has its own <a href=\"http://wordpress.org/plugins/\" title=\"http://wordpress.org/plugins/\">plugin repository</a> filled to the brim with plugins to add functionality to your WordPress powered website. The WordPress plugin repository is the safest place to get code to add features to your website. Plugins are scanned and reviewed by volunteers before they are accepted into the repository. However, this does not guarantee that the code will function properly or is 100% secure for your website. </p>\n<h3>Support</h3>\n<p>The <a href=\"http://wordpress.org/support/\" title=\"http://wordpress.org/support/\">WordPress.org support forums</a> enable the community to help each other. Creating an account is free of charge as is the support. The forums are staffed by volunteer moderators that do their best to help as many people as possibly every day. With so many people seeking help, you should exercise patience when using the forums. </p>\n<h3>Documentation</h3>\n<p>If you feel a little adventurous and want to try helping yourself first, you can <a href=\"http://codex.wordpress.org/Main_Page\" title=\"http://codex.wordpress.org/Main_Page\">visit the Codex</a>. This Codex is like a repository for all of the detailed information for how WordPress works, inside and out. The main page of the Codex provides a number of great links to those starting out with WordPress. </p>\n<h3>Learning WordPress Through Video</h3>\n<p>While there is no official classroom to learn WordPress material, WordPress.org has the next best thing in <a href=\"http://wordpress.tv/\" title=\"http://wordpress.tv/\">WordPress.tv</a>. WordPress.tv is the official website dedicated to WordPress that contains recorded sessions from <a href=\"http://central.wordcamp.org/\" title=\"http://central.wordcamp.org/\">WordCamps</a> held all over the world. In fact, there is an entire <a href=\"http://wordpress.tv/category/how-to/\" title=\"http://wordpress.tv/category/how-to/\">how to section</a> on the website dedicated to tutorial type videos. </p>\n<div class=\"aligncenter\"></div>\n<h3>Creative Inspiration</h3>\n<p>If you&#8217;re not sure what WordPress is capable of or have run into a creative block, you should browse through the <a href=\"http://wordpress.org/showcase/\" title=\"http://wordpress.org/showcase/\">WordPress showcase</a>. The showcase is a collection of websites that have taken WordPress to the next level. There are a lot of great looking designs as well to help provide inspiration. </p>\n<p><a href=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/10/BBCOnTheWPShowcase.jpg\" rel=\"thumbnail\"><img src=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/10/BBCOnTheWPShowcase.jpg?resize=500%2C207\" alt=\"bbc on the WordPress showcase\" class=\"aligncenter size-large wp-image-10299\" /></a></p>\n<h3>WordPress Face to Face</h3>\n<p>While not officially a part of the WordPress.org project, <a href=\"http://www.meetup.com/\" title=\"http://www.meetup.com/\">Meetup.com</a> is used by WordPress users all across the world to put together local meetups that bring like-minded people together. I&#8217;ve attended multiple WordPress meetups in my area and I&#8217;ve helped a lot of new WordPress users find their way. It&#8217;s one of the best forms of learning and getting WordPress help that I can imagine. </p>\n<h3>Keeping Tabs On WordPress Development</h3>\n<p>While there are not many posts on the <a href=\"http://wordpress.org/news/\" title=\"http://wordpress.org/news/\">official WordPress blog</a>, it is where official news of releases are published. </p>\n<h3>Installing WordPress On Your Phone</h3>\n<p>There is an official WordPress app for most of the smart phone devices currently out on the market such as iOS devices, BlackBerry, and Android. If you&#8217;d like to install WordPress on your phone, be sure to check out the <a href=\"http://wordpress.org/mobile/\" title=\"http://wordpress.org/mobile/\">mobile section of the WordPress.org website</a> to see if there is one available for your device.</p>\n<h2>Wrap Up</h2>\n<p>Now you might be wondering, why didn&#8217;t I include this site or that site when putting this guide together. The purpose of the guide is to provide a map that contains the essential information new users need to know. Using this knowledge as your foundation, you should find yourself more comfortable in the WordPress ecosystem. After getting to grips with WordPress, new users will expand beyond these pillars and discover the other resources that are on the web dedicated to WordPress. It doesn&#8217;t make sense to point new users into different directions when the above information is all they really need to get started. </p>\n<img src=\"http://feeds.feedburner.com/~r/WordpressTavern/~4/gJiQc_Kl5ZA\" height=\"1\" width=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 23 Oct 2013 16:59:54 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Jeffro\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:11;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:100:\"WordPress.tv: Greg Douglas: Designing Awesome WordPress Websites For Small To Medium Size Businesses\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=23212\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:117:\"http://wordpress.tv/2013/10/23/greg-douglas-designing-awesome-wordpress-websites-for-small-to-medium-size-businesses/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:750:\"<div id=\"v-uJnUBEdM-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/23212/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/23212/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=23212&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/10/23/greg-douglas-designing-awesome-wordpress-websites-for-small-to-medium-size-businesses/\"><img alt=\"Greg Douglas: Designing Awesome WordPress Websites For Small To Medium Size Businesses\" src=\"http://videos.videopress.com/uJnUBEdM/video-bee4dba11d_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 23 Oct 2013 13:37:54 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:12;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:65:\"WordPress.tv: Ben Lobaugh: Taking Flight With JetPack Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=24051\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:82:\"http://wordpress.tv/2013/10/23/ben-lobaugh-taking-flight-with-jetpack-development/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:680:\"<div id=\"v-PDJy3p13-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/24051/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/24051/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=24051&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/10/23/ben-lobaugh-taking-flight-with-jetpack-development/\"><img alt=\"Ben Lobaugh: Taking Flight With JetPack Development\" src=\"http://videos.videopress.com/PDJy3p13/video-3e622857d6_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 23 Oct 2013 13:24:07 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:13;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:51:\"WPTavern: Monitor WordCamps Online with WP Armchair\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"http://www.wptavern.com/?p=10260\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:103:\"http://feedproxy.google.com/~r/WordpressTavern/~3/fDHtRUBVmHs/monitor-wordcamps-online-with-wp-armchair\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:7386:\"<p><a href=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/10/wcsf.png\" rel=\"thumbnail\"><img src=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/10/wcsf.png?resize=278%2C300\" alt=\"WordCamp San Francisco on WP Armchair\" class=\"alignright size-medium wp-image-10267\" /></a><a href=\"http://www.davidbisset.com/\" target=\"_blank\">David Bisset</a> may have been the first person to coin the term “Armchair WordCampers”, referring to those who live vicariously through WordCamp attendees via Twitter. The concept sparked an idea for him and he decided to create <a href=\"http://wparmchair.com\" title=\"WP Armchair\" target=\"_blank\">WP Armchair</a> for this very audience. </p>\n<p>His first version was actually created for the <a href=\"http://wp10.wordpress.net\" target=\"_blank\">WordPress 10th Anniversary</a>, a site he collaborated on with the WordPress Foundation.</p>\n<p>Bisset is a WordPress and BuddyPress developer. He also helps to organize WordCamp Miami. The inspiration for creating WP Armchair came from his experiences as an organizer and an attendee at WordCamps.<span id=\"more-10260\"></span></p>\n<blockquote><p>I monitor WordCamps and conferences via Twitter hashtags and simply thought there was a better way. I notice that a lot of people are interested in monitoring conference activity as well. Even those that attend conferences &#8211; I see many of them with their laptops open to Tweetdeck or some Twitter client. I figured there should be a better way, especially since social networks like Instagram are becoming more popular.</p>\n<p>On top of that, as a WordPress developer, I wanted the solution running on WordPress. And instead of passively showing pictures and tweets, the site would naturally store these as custom post types. So it serves as an archive of the conference.</p></blockquote>\n<p>In a way, the WP Armchair websites are chronicling the history of these WordPress events as seen through their respective hashtags on Twitter, Instagram, Vine and Flickr. Right now, each event is a separate site but Bisset said that he&#8217;s likely to combine them all into a multisite installation somewhere in the near future.</p>\n<p><div id=\"attachment_10277\" class=\"wp-caption alignleft\"><a href=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/10/wceu.png\" rel=\"thumbnail\"><img src=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/10/wceu.png?resize=300%2C268\" alt=\"WP Armchair Monitoring WordCamp Europe\" class=\"size-medium wp-image-10277\" /></a><p class=\"wp-caption-text\">WP Armchair Monitoring WordCamp Europe</p></div>When <a href=\"http://wcsf.wparmchair.com/\" target=\"_blank\">WP Armchair monitored WordCamp San Francisco</a> the site was able to aggregate 1,600 tweets and 1,020 photos. For <a href=\"http://wceu.wparmchair.com/\" target=\"_blank\">WordCamp Europe</a>, the site captured even more &#8211; in the end it was 4,223 tweets and 1,500 photos. WordPress fans monitoring from afar were able to get a taste of how awesome these events were and perhaps even resolve to attend next year.</p>\n<h3>What Plugins Make WP Armchair Work?</h3>\n<p>If you visit any of the WP Armchair sites you&#8217;ll see support for videos, pictures, embedded tweets, post favoriting and more. There&#8217;s a lot going on behind the scenes to bring all of this event information into the site.</p>\n<p>I asked Bisset to tell me about some of the important plugins he uses to make WP Armchair work and he gave us a look behind the scenes. </p>\n<blockquote><p>I wrote three plugins that scanned Twitter, Instagram, and Flickr for tweets, photos, and videos based on a hashtag and saved them as custom post types. These make up the bulk of the site, but I also used the following plugins:</p>\n<p><a href=\"http://wordpress.org/plugins/bulk-delete/\" target=\"_blank\">Bulk Delete</a> &#8211; comes in handy when you want to get rid of alot of tweets or instragram posts that aren&#8217;t related to the conference (maybe you used a bad keyword or hashtag). Since tweets can come in 30 or 40 at a time, this plugin does save a little bit of time.</p>\n<p><a href=\"http://pippinsplugins.com/love-it-pro/\" target=\"_blank\">Love It Pro</a> &#8211; was great to drop in and give site visitors the ability to mark posts as favorites. It was a fun experiment during WordCamp San Francisco. </p>\n<p><a href=\"http://www.gravityforms.com/\" target=\"_blank\">Gravity Forms</a> &#8211; on some installs, it allows us to quickly get forms (surprise!) in place for user registration, so some people could upload their own photos to the site via the WordPress Mobile app or a custom form.</p>\n<p><a href=\"http://wordpress.org/plugins/search-everything/\" target=\"_blank\">Search Everything</a> &#8211; allowed the cool ability to search for tweets, instagram photos, etc that were created by a specific user or via keyword. As an example, you could search for your own name and see if anyone mentioned you on whatever social networks the WPArmchair site was scanning. Unfortunately, it looks like Search Everything isn&#8217;t being supported as of now, so I recommend switching over to SearchWP.com.</p></blockquote>\n<h3>WP Armchair Theme and Plugins are GPL and Available on github</h3>\n<p>Bisset has made both the <a href=\"https://github.com/dimensionmedia/WPArmchair\" target=\"_blank\">WP Armchair Theme</a> and plugins available on his <a href=\"https://github.com/dimensionmedia\" target=\"_blank\">github</a> account. He invites contribution to the project. &#8220;There are no doubt better and different ways to do what the site does, and I welcome anyone who wants to improve it,&#8221; he said.</p>\n<p>The <a href=\"http://wordpressfoundation.org/\" target=\"_blank\">WordPress Foundation</a> has also made some of the WP Armchair functionality available to its officially hosted WordCamp site using a new plugin called <a href=\"http://plugins.trac.wordpress.org/browser/tagregator/trunk\" target=\"_blank\">Tagregator</a>, which is also open to contribution.</p>\n<p>Bisset believes that WP Armchair is a valuable resource for both those at home and those who are attending WordCamp events. It has even been used by <a href=\"http://frontendconference.conferenceme.in/\" target=\"_blank\">The Front-End Design Conference</a>, a non-WordPress event, to aggregate the references to the event on social media.  Ultimately, WP Armchair is about bringing people and ideas together.</p>\n<blockquote><p> Even if you did go to the conference, you would be able to see everyone&#8217;s photos there instead of a gallery of a smaller group of photos the site admin posted a few days later. You also get to see who authored interesting tweets and potentially find new people to follow this way… people that are in theory just as motivated by WordPress as you are.</p></blockquote>\n<p>Monitoring posts from WordCamps online is by no means a replacement for actually attending the event. Realistically, you won&#8217;t be able to attend every WordCamp in the world, but WP Armchair gives you a better way to monitor online from wherever you may be. Many thanks to <a href=\"http://www.davidbisset.com/\" title=\"David Bisset\" target=\"_blank\">David Bisset</a> for taking us behind the scenes and for creating a way for WordPress fans around the world to join in on events together.</p>\n<img src=\"http://feeds.feedburner.com/~r/WordpressTavern/~4/fDHtRUBVmHs\" height=\"1\" width=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 23 Oct 2013 13:01:04 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:14;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:27:\"Donncha: WP Super Cache 1.4\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"http://ocaoimh.ie/?p=89498597\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"http://ocaoimh.ie/2013/10/23/wp-super-cache-1-4/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1932:\"<p><a href=\"http://wordpress.org/plugins/wp-super-cache/\">WP Super Cache</a> version 1.4 is out now. This release finally removes the mfunc, mclude and dynamic-cached-content tags as <a href=\"http://wordpress.org/support/topic/mfunc-is-going-away-in-the-next-version?replies=27\">I warned about</a> three months ago. </p>\n<p>If your site uses that dynamic cached content functionality do not upgrade yet. There is a replacement <a href=\"http://ocaoimh.ie/2013/10/21/shiny-new-dynamic-content-wp-super-cache/\">dynamic cached content system</a> but it&#8217;s not compatible so you&#8217;ll need to update your themes and helper plugins. It&#8217;s not difficult but there&#8217;s a lot to take in. I hope the example plugin and explanation in that post gets you most of the way there.</p>\n<p>If you don&#8217;t use mfunc and it&#8217;s friends then you should upgrade immediately and it should be painless.</p>\n<p>This release also has a few bug fixes and other features. It will now try to repair broken installs after a site migrates. It will update the wp-config.php and rebuild wp-content/advanced-cache.php. It will also delete tags and category cache files when a post publish status changes.</p>\n\n<p><strong>Related Posts</strong><ul><li> <a href=\"http://ocaoimh.ie/2008/10/24/wp-super-cache-084-the-garbage-collector/\" rel=\"bookmark\" title=\"Permanent Link: WP Super Cache 0.8.4, the garbage collector\">WP Super Cache 0.8.4, the garbage collector</a></li><li> <a href=\"http://ocaoimh.ie/2009/01/09/wp-super-cache-087/\" rel=\"bookmark\" title=\"Permanent Link: WP Super Cache 0.8.7\">WP Super Cache 0.8.7</a></li><li> <a href=\"http://ocaoimh.ie/2010/02/08/wp-super-cache-099/\" rel=\"bookmark\" title=\"Permanent Link: WP Super Cache 0.9.9\">WP Super Cache 0.9.9</a></li></ul></p><p><a href=\"http://ocaoimh.ie/2013/10/23/wp-super-cache-1-4/\">WP Super Cache 1.4</a> originally appeared on <a href=\"http://ocaoimh.ie\">Holy Shmoly!</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 23 Oct 2013 11:14:09 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:7:\"Donncha\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:15;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:43:\"Dev Blog: WordPress 3.7 Release Candidate 2\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=2729\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:68:\"http://wordpress.org/news/2013/10/wordpress-3-7-release-candidate-2/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1182:\"<p>The second release candidate of WordPress 3.7 is now available for testing!</p>\n<p>Those of you already testing WordPress 3.7 will be updated automatically to RC2. (<em>Nice.</em>) If you&#8217;d like to start testing, there&#8217;s no time like the present! Try the <a href=\"http://wordpress.org/extend/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin (you’ll want “bleeding edge nightlies”) or <a href=\"http://wordpress.org/wordpress-3.7-RC2.zip\">download the release candidate here</a> (zip). Please post to the <a href=\"http://wordpress.org/support/forum/alphabeta/\">Alpha/Beta area in the support forums</a> if you think you&#8217;ve found a bug, and if any known issues are raised, you’ll be able to <a href=\"http://core.trac.wordpress.org/report/5\">find them here</a>.</p>\n<p>Developers, please test your plugins and themes against WordPress 3.7. If there is a compatibility issue, let us know as soon as possible so we can deal with it before the final release.</p>\n<p>For more on WordPress 3.7, check out the <a href=\"http://wordpress.org/news/2013/10/wordpress-3-7-release-candidate/\">announcement post for Release Candidate 1</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 23 Oct 2013 00:05:30 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Andrew Nacin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:16;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"WPTavern: WordPress 3.7 Introduces Advanced Date Queries\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"http://www.wptavern.com/?p=10239\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:108:\"http://feedproxy.google.com/~r/WordpressTavern/~3/SBf0LiyU_A4/wordpress-3-7-introduces-advanced-date-queries\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3933:\"<p>WordPress 3.7 should be arriving any day now. Everyone is excited about WordPress&#8217; new ability to <a href=\"http://www.wptavern.com/wordpress-3-7-automatic-upgrades-proving-to-be-reliable\" target=\"_blank\">update itself</a> for security and minor releases (and even themes and plugins, if you&#8217;re adventurous). The <a href=\"http://www.wptavern.com/ridiculously-smart-password-meter-coming-to-wordpress-3-7\" target=\"_blank\">new password strength meter</a> is highlighted on the About page for the release with a live demo that users can play with after they upgrade. But there&#8217;s one cool new feature that hasn&#8217;t received as much fanfare: <strong><em>advanced date queries</em></strong>. </p>\n<p><div id=\"attachment_10244\" class=\"wp-caption aligncenter\"><a href=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/10/advanced-date-queries.jpg\" rel=\"thumbnail\"><img src=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/10/advanced-date-queries.jpg?resize=560%2C302\" alt=\"photo credit: Andrew Morrell Photography via photopin cc\" class=\"size-full wp-image-10244\" /></a><p class=\"wp-caption-text\">photo credit: <a href=\"http://www.flickr.com/photos/andrewmorrell/61613238/\">Andrew Morrell Photography</a> via <a href=\"http://photopin.com\">photopin</a> <a href=\"http://creativecommons.org/licenses/by-nd/2.0/\">cc</a></p></div> <span id=\"more-10239\"></span></p>\n<p>You might be wondering what&#8217;s so exciting about advanced date queries. Alex Mills, better known online as &#8220;<a href=\"http://www.viper007bond.com/\" target=\"_blank\">Viper007Bond</a>&#8221; was the originator of the <a href=\"http://core.trac.wordpress.org/ticket/18694\" target=\"_blank\">patch</a> to improve date arguments for <a href=\"http://codex.wordpress.org/Class_Reference/WP_Query\" target=\"_blank\">WP_Query</a>, a class for querying the database for specific content. Up until now, WordPress had no easy way to get a set of posts that fall within a specific date range.</p>\n<p>A few months ago, Alex introduced a patch that adds the ability to get complex date-based queries when fetching both posts and comments from the WordPress database. Code examples can be found on his <a href=\"http://www.viper007bond.com/2013/08/27/date-queries-in-wordpress-3-point-7/\" target=\"_blank\">post</a> where he roughly outlines a few ways one might implement date-based queries. </p>\n<p>There are virtually unlimited combinations. Here are a few examples of what is possible with the new advanced date queries:</p>\n<ul>\n<li>Query all posts written on a specific day over the years, ie. the author&#8217;s birhtday</li>\n<li>Query all the posts written before or after a certain date</li>\n<li>Query all posts written on Monday mornings</li>\n<li>Query 5 most recent posts made after midnight but before 5am</li>\n</ul>\n<p>You can check out all the <a href=\"http://codex.wordpress.org/Class_Reference/WP_Query#Date_Parameters\" target=\"_blank\">date parameters</a> in the codex and browse a few of the examples. Imagine all the fun that could be had here! The advanced date queries should enable developers to do some interesting things with displaying timelines, custom archives, selectively random post widgets and anything else imaginable with date ranges.  </p>\n<p>Advanced date queries replaces <a href=\"http://wordpress.org/support/topic/posts_where-filter-doesnt-work-in-a-class?replies=1#post-4634263\" target=\"_blank\">bulkier methods</a> used in the past, such as adding a filter to <em><a href=\"http://codex.wordpress.org/Plugin_API/Filter_Reference/posts_where\" target=\"_blank\">posts_where</a></em>. How did we ever live without it? Check out the canonical discussion on <a href=\"http://core.trac.wordpress.org/ticket/18694\" target=\"_blank\">Trac</a> to explore the evolution of this feature and put it to good use in WordPress 3.7.</p>\n<img src=\"http://feeds.feedburner.com/~r/WordpressTavern/~4/SBf0LiyU_A4\" height=\"1\" width=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 22 Oct 2013 23:28:08 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:17;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"WordPress.tv: Topher DeRosia: Intro To Plugin Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=23066\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:74:\"http://wordpress.tv/2013/10/22/topher-derosia-intro-to-plugin-development/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:670:\"<div id=\"v-WunjullW-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/23066/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/23066/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=23066&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/10/22/topher-derosia-intro-to-plugin-development/\"><img alt=\"Topher DeRosia: Intro To Plugin Development\" src=\"http://videos.videopress.com/WunjullW/video-b108849284_scruberthumbnail_0.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 22 Oct 2013 21:43:20 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:18;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"WordPress.tv: Tharon Rodriguez: Getting Familiar With PODS\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=23060\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:75:\"http://wordpress.tv/2013/10/22/tharon-rodriguez-getting-familiar-with-pods/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:666:\"<div id=\"v-Dz9C2pZ5-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/23060/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/23060/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=23060&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/10/22/tharon-rodriguez-getting-familiar-with-pods/\"><img alt=\"Tharon Rodriguez: Getting Familiar With PODS\" src=\"http://videos.videopress.com/Dz9C2pZ5/video-6c73184008_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 22 Oct 2013 21:20:42 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:19;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:72:\"WPTavern: ForumEngine Turns WordPress Into a Forum Via Custom Post Types\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"http://www.wptavern.com/?p=10158\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:124:\"http://feedproxy.google.com/~r/WordpressTavern/~3/5-EF68Mw45g/forumengine-turns-wordpress-into-a-forum-via-custom-post-types\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4745:\"<p><a href=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/10/EnginethemesLogo.jpg\" rel=\"thumbnail\"><img class=\"alignright size-full wp-image-10164\" alt=\"EngineThemes Logo\" src=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/10/EnginethemesLogo.jpg?resize=211%2C47\" /></a> <a title=\"http://www.enginethemes.com/\" href=\"http://www.enginethemes.com/\">EngineThemes.com</a> recently released version 1.0 of their latest project, <a title=\"http://www.enginethemes.com/themes/forumengine/\" href=\"http://www.enginethemes.com/themes/forumengine/\">ForumEngine</a>. ForumEngine is a theme that uses Custom Post Types to turn WordPress into a forum. I caught wind of this new theme via a <a title=\"http://wplift.com/wordpress-forum-theme\" href=\"http://wplift.com/wordpress-forum-theme\">review published on WPLift</a> by Joe Fylan. It&#8217;s nice to finally see theme companies thinking outside the box for once instead of whipping up the next boring portfolio theme. I have not had the opportunity to try out the theme but based on Joe&#8217;s review, there is one thing in particular that may be a showstopper for a lot of people.<span id=\"more-10158\"></span></p>\n<p><a href=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/10/ForumEngine1.jpg\" rel=\"thumbnail\"><img class=\"aligncenter size-large wp-image-10168\" alt=\"Writing A Post In ForumEngine\" src=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/10/ForumEngine1.jpg?resize=500%2C302\" /></a></p>\n<p>Unfortunately, in order to use this theme, you&#8217;ll either need a brand new WordPress install, separate WordPress install, or be willing to see your existing content disappear.</p>\n<blockquote><p>With ForumEngine installed on your site, the site now functions as a forum, which the threads accessed directly from the homepage. Any existing posts that might’ve been on the site or those you create afterward activating the theme will now no longer be accessible, essentially removing the main functionality of WordPress: creating posts so bare that in mind if you wish to use this alongside a regular blog – you would need a separate installation. &#8211; Joe Fylan</p></blockquote>\n<p>I remember when the discussion around bbPress 2.0 was taking place. It was <a title=\"http://justintadlock.com/archives/2010/07/16/a-wordpress-forum-plugin-using-custom-post-types\" href=\"http://justintadlock.com/archives/2010/07/16/a-wordpress-forum-plugin-using-custom-post-types\">suggested that using a plugin that utilizes custom post types</a> be used. At the time, bbPress was transitioning from being stand alone software into a WordPress plugin. Now we have a theme that is using custom post types and if I remember correctly, community members like <a title=\"http://justintadlock.com/archives/2013/09/14/why-custom-post-types-belong-in-plugins\" href=\"http://justintadlock.com/archives/2013/09/14/why-custom-post-types-belong-in-plugins\">Justin Tadlock frown on this practice</a>. I reached out to John James Jacoby to get his thoughts on this theme as well as how its implementation compares with bbPress.</p>\n<blockquote><p>bbPress 2.x does use custom post types, and actually uses three of them. Forums is only a post type because of a lack of taxonomy term meta, otherwise it would be a custom taxonomy. CPT&#8217;s are fine, though it&#8217;s too bad it completely overrides the blog. Seems pretty pointless to make users decide to have either a blog or a forum, and not both.</p>\n<p>bbPress takes other things into consideration, like forum profiles VS blog author archives, separate roles for the forums VS the blog, and goes the extra mile so forums only intersect with the blog when you want it to. If a theme was really going to do this “correctly” it should probably use a CPT for topics, and comments (with a custom comment form template) for replies; that way the behavior is familiar.</p>\n<p>Forums are such an integral part of online communities, if I were looking for forums inside of WordPress, baking it into a commercial theme that won&#8217;t work with my existing blog doesn&#8217;t sound very appealing.</p></blockquote>\n<p>While I like the design and the thinking out of the box idea in this theme, not being able to use it with an existing blog is a huge blow towards it ever becoming a popular alternative to bbPress or other forum solutions. However, thanks to the advice provided by John James Jacoby above, there are ways of going about it that make sense. I hope to see other theme providers give it a shot. At the very least, it would be good to see theme providers list native bbPress support as one of their selling points.</p>\n<img src=\"http://feeds.feedburner.com/~r/WordpressTavern/~4/5-EF68Mw45g\" height=\"1\" width=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 22 Oct 2013 20:30:16 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Jeffro\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:20;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"Dev Blog: Upcoming WordCamps\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=2723\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"http://wordpress.org/news/2013/10/upcoming-wordcamps-4/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3583:\"<p><a href=\"http://central.wordcamp.org/\">WordCamps</a> are casual, locally-organized conferences that celebrate everything related to WordPress, and are a great opportunity to meet other WordPress users and professionals in your community. This has been a great year for WordCamps &#8212; there have been 56 so far in more than 20 countries, and there another 15 on the calendar before the year&#8217;s over. If there&#8217;s one near you, check it out! In addition to getting to know your local WordPress community, most WordCamps attract some traveling visitors a well, giving you the chance to meet contributors to the WordPress open source project and <a href=\"http://make.wordpress.org/\">get involved</a> yourself.</p>\n<p>Here are the WordCamps on the schedule for the rest of this year.</p>\n<p>October 25-27: <strong><a href=\"http://2013.boston.wordcamp.org/\">WordCamp Boston</a></strong>, Boston, MA, USA<br />\nOctober 25-26: <strong><a href=\"http://2013.malaga.wordcamp.org/\">WordCamp Malaga</a></strong>, Spain<br />\nOctober 26: <strong><a href=\"http://2013.nepal.wordcamp.org/\">WordCamp Nepal</a></strong>, Kathmandu, Nepal<br />\nOctober 26: <strong><a href=\"http://2013.sofia.wordcamp.org/\">WordCamp Sofia</a></strong>, Bulgaria<br />\nNovember 7: <strong><a href=\"http://2013.capetown.wordcamp.org/\">WordCamp Cape Town</a></strong>, South Africa<br />\nNovember 9: <strong><a href=\"http://2013.porto.wordcamp.org/\">WordCamp Porto</a></strong>, Portugal<br />\nNovember 9-10: <strong><a href=\"http://2013.kenya.wordcamp.org/\">WordCamp Kenya</a></strong>, Nairobi, Kenya<br />\nNovember 15: <strong><a href=\"http://2013.edmonton.wordcamp.org/\">WordCamp Edmonton</a></strong>, AB, Canada<br />\nNovember 16-17: <strong><a href=\"http://2013.orlando.wordcamp.org/\">WordCamp Orlando</a></strong>, FL, USA<br />\nNovember 16: <strong><a href=\"http://2013.denver.wordcamp.org/\">WordCamp Denver</a></strong>, CO, USA<br />\nNovember 23-24: <strong><a href=\"http://2013.london.wordcamp.org/\">WordCamp London</a></strong>, UK<br />\nNovember 23-24: <strong><a href=\"http://2013.raleigh.wordcamp.org/\">WordCamp Raleigh</a></strong>, NC, USA<br />\nNovember 23: <strong><a href=\"http://2013.saopaulo.wordcamp.org/\">WordCamp São Paulo</a></strong>, Brazil<br />\nDecember 14: <strong><a href=\"http://2013.vegas.wordcamp.org/\">WordCamp Las Vegas</a></strong>, NV, USA<br />\nDecember 14-15: <strong><a href=\"http://2013.sevilla.wordcamp.org/\">WordCamp Sevilla</a></strong>, Spain</p>\n<p>No WordCamps on this list in your area? Not to worry! There are thriving <a href=\"http://wordpress.meetup.com/\">WordPress meetups</a> all over the world where you can meet like-minded people, and we maintain a library of <a href=\"http://wordpress.tv/category/wordcamptv/\">WordCamp videos</a> at <a href=\"http://wordpress.tv/\">WordPress.tv</a>.</p>\n<h3>Get Involved</h3>\n<ul>\n<li>If you&#8217;re interested in organizing a WordCamp in your area, check out our <a href=\"http://plan.wordcamp.org/\">WordCamp planning</a> site.</li>\n<li>If you&#8217;re interested in <a href=\"http://make.wordpress.org/community/meetup-interest-form/\">starting a WordPress meetup</a> in your area, let us know and we can set up a group on meetup.com for you.</li>\n<li>And speaking of WordCamp videos, we&#8217;ve recently enabled volunteer-generated subtitles/closed captioning of the videos on WordPress.tv to make them more accessible. Interested in helping? Check out the <a href=\"http://wordpress.tv/using-amara-org-to-caption-or-subtitle-a-wordpress-tv-video/\">WordPress.tv subtitling instructions</a>.</li>\n</ul>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 22 Oct 2013 19:25:26 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"Jen Mylo\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:21;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:67:\"WPTavern: BuddyPress Theme Development Book Now Available on Amazon\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"http://www.wptavern.com/?p=10213\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:109:\"http://feedproxy.google.com/~r/WordpressTavern/~3/I9fzJHc5q1c/buddypress-theming-book-now-available-on-amazon\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3233:\"<p><a href=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/10/bpthemedev.jpg\" rel=\"thumbnail\"><img src=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/10/bpthemedev.jpg?resize=300%2C394\" alt=\"bpthemedev\" class=\"alignright size-full wp-image-10216\" /></a>If you want to grow in your BuddyPress skills, there&#8217;s a new book on the market that you&#8217;ll want to get your hands on. <a href=\"http://www.amazon.co.uk/BuddyPress-Theme-Development-Tammie-Lister-ebook/dp/B00G395ORG/ref=sr_1_2?ie=UTF8&qid=1382456253&sr=8-2&keywords=tammie+lister\" title=\"BuddyPress Theme Development\" target=\"_blank\">BuddyPress Theme Development</a> has just hit Amazon. The digital version is out now and you&#8217;ll be able to get a printed copy on October 24th, 2013. Packt will also have a version of the book that includes access to code for those who want to &#8220;follow along at home&#8221; with the code examples.</p>\n<p>Written by expert BuddyPress theme developer and contributor, <a href=\"http://logicalbinary.com/\" title=\"Tammie Lister\" target=\"_blank\">Tammie Lister</a>, this book will help you learn how to create BuddyPress themes from start to finish. <em>BuddyPress Theme Development</em> provides a comprehensive guide to BuddyPress theming with practical, hands-on tutorials that will put you on the path to building your own themes. <span id=\"more-10213\"></span></p>\n<p>Tammie walks you through the basics, such as how to use CSS to make changes to themes. She also includes more advanced topics like creating custom templates for BuddyPress components. You&#8217;ll learn how to add functionality to enhance your community, including how to build your own widgets into your theme. Once your theme is finished, Tammie shows you how to run theme-checks to ensure that it&#8217;s ready for launch.</p>\n<p>I checked in with <a href=\"https://twitter.com/karmatosed\" title=\"Tammie Lister on Twitter\" target=\"_blank\">Tammie</a> for a mini Twitter interview on the details of the book. She has been working on it since just after <a href=\"http://2013.miami.wordcamp.org/\" title=\"BuddyCamp Miami\" target=\"_blank\">BuddyCamp Miami</a>, which took place in early April of this year. Many theming books are outdated even before they hit the shelves, but Tammie has made sure that everything in her book is up to date with the upcoming BuddyPress 1.9 release. She is the developer heading up the work on the new template pack that will ship with BuddyPress 1.9. </p>\n<p>If you&#8217;re a BuddyPress developer looking for resources to keep your skills sharp, BuddyPress Theme Development is a good one to add to your collection. Packt Publishing couldn&#8217;t have found a better person to write this book. Get your copy today on <a href=\"http://www.amazon.co.uk/BuddyPress-Theme-Development-Tammie-Lister-ebook/dp/B00G395ORG/ref=sr_1_2?ie=UTF8&qid=1382456253&sr=8-2&keywords=tammie+lister\" target=\"_blank\">Amazon</a> or <a href=\"http://www.packtpub.com/buddypress-theme-development/book\" target=\"_blank\">pre-order the printed edition</a> from Packt Publishing to get the eBook and PacktLib access thrown in for free. </p>\n<img src=\"http://feeds.feedburner.com/~r/WordpressTavern/~4/I9fzJHc5q1c\" height=\"1\" width=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 22 Oct 2013 18:46:45 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:22;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"WPTavern: Seamless Integration for WordPress and Magento\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"http://www.wptavern.com/?p=10189\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:108:\"http://feedproxy.google.com/~r/WordpressTavern/~3/F6uyX3Wt0E8/seamless-integration-for-wordpress-and-magento\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:6448:\"<p>Believe it or not, there are a lot of WordPress fans in the <a href=\"http://www.magentocommerce.com/\" target=\"_blank\">Magento</a> community. While Magento provides supremely robust e-commerce capabilities with support for complex product variations and multiple shipping options, it&#8217;s entirely lacking in CMS features. As a result, many sites merge WordPress and Magento in order to take advantage of each platform&#8217;s unique strengths. </p>\n<p>However, it is unbelievably difficult to make WordPress and Magento work together in a seamless fashion without some sort of bridge. That&#8217;s where <a href=\"http://www.jckemp.com/\" target=\"_blank\">James Kemp</a>&#8216;s Magento WordPress Integration plugin comes in. It does all the fancy footwork necessary to make your Magento store look like part of your WordPress site. </p>\n<p><a href=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/10/mwi.jpg\" rel=\"thumbnail\"><img src=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/10/mwi.jpg?resize=560%2C124\" alt=\"mwi\" class=\"aligncenter size-full wp-image-10193\" /></a><span id=\"more-10189\"></span></p>\n<p>The <a href=\"https://bitbucket.org/jamesckemp/mwi-magento-wordpress-integration/src\" target=\"_blank\">Magento WordPress Integration</a> plugin (MWI), is a solution that Kemp has been developing for several years. It provides the easiest way to get blocks, sessions and products from your Magento store and is capable of doing the following:</p>\n<ul>\n<li>Bring out any of the default Magento Blocks in your WordPress theme</li>\n<li>Bring out any Magento blocks that you have created yourself</li>\n<li>Bring out any static blocks that you have made in your Magento admin area</li>\n<li>Show Magento products on a WordPress post or page by using the shortcode add-on</li>\n<li>Show products from any category using the widget add-on</li>\n</ul>\n<p>Think there&#8217;s no demand for this? Think again. Kemp&#8217;s plugin has been downloaded more than 10,000 times. To celebrate, Kemp has made the code available on <a href=\"https://bitbucket.org/jamesckemp/mwi-magento-wordpress-integration/src\" target=\"_blank\">BitBucket</a>. He&#8217;s hoping that having the code available to the public will help to spark more contribution.</p>\n<p><div id=\"attachment_10196\" class=\"wp-caption alignright\"><a href=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/10/kemp.jpg\" rel=\"thumbnail\"><img src=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/10/kemp.jpg?resize=264%2C300\" alt=\"James Kemp, creator of the Magento WordPress Integration plugin\" class=\"size-medium wp-image-10196\" /></a><p class=\"wp-caption-text\">James Kemp, creator of the Magento WordPress Integration plugin</p></div>I&#8217;ve been following James Kemp&#8217;s work for several years and finally had the chance to chat with him about how the plugin is doing. </p>\n<p>He continues to develop the plugin due to the demand, which comes from both &#8220;light&#8221; users and developers. &#8220;The demand for MWI is fairly consistent,&#8221; he said. &#8220;On a calm day the mwi-plugin site gets ~30 unique visits, and mid-week on a busier day it will get ~100. It&#8217;s a very niche plugin, so I don&#8217;t expect thousands! The core plugin is mainly useful for developers I&#8217;d say, but I also get &#8220;light&#8221; users who are interested in the add-ons, so they can display products within their blogs. The demand for it is fairly steady at the moment.&#8221;</p>\n<p>The Magento and WordPress communities are fairly disconnected, which is understandable. You don&#8217;t see too many developers wanting to specialize in both platforms. Yet many users want them to work together. When building sites with a bridge, Kemp relies on WordPress for the more content-heavy aspects of the site:</p>\n<blockquote><p>Each system has solutions for the other, but none of them are quite as good as WordPress or Magento. I personally prefer to use WP for all aspects of content management; pages, news, callouts &#8211; using Magento for this is a bit of a nightmare. I use Magento for large stores, with complex product set-ups and discount systems, purely for the product catalogue and back-end ecommerce system.</p></blockquote>\n<p>Although he is an expert Magento developer, he has also built many sites using WooCommerce and Jigoshop. I asked him when he might opt for Magento over a WordPress-based e-commerce solution and he replied:</p>\n<blockquote><p> I tend to use Magento for larger sites, where there are thousands of products and likely to be a lot of activity. This is because of the back-end system of Magento; it offers so much more in terms of tax rules, discounts, product set-up, import/export, order history, invoicing, etc. it&#8217;s just a full, heavy-duty, ecommerce system. The WordPress solutions are great, but not for bigger ecommerce store owners who need more control.</p></blockquote>\n<p>The Magento WordPress Integration plugin provides a much needed bridge between the two open source projects and enables them to work together seamlessly. It can also save you from having to do too much theming to Magento, which is quite a pain because all the files are located about 10 directories deep. MWI allows you to feature your categories and products on your WordPress pages, as well as any blocks created within Magento. If you want to synchronize your sites even further, Kemp has also developed a plugin providing <a href=\"http://codecanyon.net/item/single-signon-for-magento-and-wordpress/861453\" target=\"_blank\">Single Sign-On For Magento And WordPress</a>.</p>\n<p>Kemp and his colleague Jay Pick have formed a new WordPress development company called <a href=\"http://madebyplatform.com/\" target=\"_blank\">Platførm</a>, based out of their rural office in Lutterworth, England. He plans to continue supporting the MWI plugin for as long as it&#8217;s needed. You can find documentation at the <a href=\"http://www.mwi-plugin.com/\" target=\"_blank\">Magento WordPress Integration homepage</a> and can <a href=\"http://wordpress.org/plugins/magento-wordpress-integration/\" target=\"_blank\">download the plugin</a> from the WordPress repository. If you want to get involved contributing, check out MWI on <a href=\"https://bitbucket.org/jamesckemp/mwi-magento-wordpress-integration/src\" target=\"_blank\">BitBucket</a>.</p>\n<img src=\"http://feeds.feedburner.com/~r/WordpressTavern/~4/F6uyX3Wt0E8\" height=\"1\" width=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 22 Oct 2013 14:00:10 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:23;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:50:\"WPTavern: New Holiday – Talk Like a Spammer Day!\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"http://www.wptavern.com/?p=10181\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:97:\"http://feedproxy.google.com/~r/WordpressTavern/~3/7J40V67FxqE/new-holiday-talk-like-a-spammer-day\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1683:\"<p><a href=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/10/wpforcelogo.jpg\" rel=\"thumbnail\"><img src=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/10/wpforcelogo.jpg?resize=300%2C62\" alt=\"WPForce Logo\" class=\"alignright size-medium wp-image-10183\" /></a> Jonathan Dingman over at WPForce.com has <a href=\"http://wpforce.com/spammers-come-creative-spam-comments/\" title=\"http://wpforce.com/spammers-come-creative-spam-comments/\">published a funny piece</a> that illustrates how comment spammers are able to be so randomly creative with their posts. One of his spam comments contained the entire template of text used to generate random comments. How many combinations of spam can you make with the following template?</p>\n<blockquote><p>I {want to|wish to|desire to} read {more|even more} things about it!|<br />\n{It is|It’s} {appropriate|perfect|the best} time to make {a few|some} plans<br />\nfor {the future|the longer term|the long run} and {it is|it’s} time to be happy.</p></blockquote>\n<p>Check out the long list of different replies on his post. I think this calls for a new holiday. Talk like a spammer day! We humans have to guess which combination is the correct one! But giving this some more thought, if there was a talk like a spammer day and we were legitimately using templates like the ones presented in the post to generate our comments and those comments were published even though Akismet thinks they are spam, how big of an impact would we have on screwing up the Akismet spam algorithm? Maybe this holiday is not such a good idea!</p>\n<img src=\"http://feeds.feedburner.com/~r/WordpressTavern/~4/7J40V67FxqE\" height=\"1\" width=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 22 Oct 2013 13:00:44 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Jeffro\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:24;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"Donncha: The shiny new dynamic content in WP Super Cache\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"http://ocaoimh.ie/?p=89498568\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:70:\"http://ocaoimh.ie/2013/10/21/shiny-new-dynamic-content-wp-super-cache/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:9301:\"<p>With the next release of WP Super Cache in a day or two <a href=\"http://ocaoimh.ie/2013/05/01/mfunc-in-wp-super-cache-1-4-and-beyond/\">the long awaited</a> move away from mfunc, mclude and friends will be complete.</p>\n<p>This means that if you have been using mfunc, mclude or dynamic-cached-content the dynamic portions of your sites will go blank if you upgrade WP Super Cache without updating that dynamic code. This may seem complicated but there&#8217;s an example script included and detailed explanations below. A lot of effort was made to make this backwards compatible but unfortunately it wasn&#8217;t possible.</p>\n<p>In their place is a new cacheaction filter called wpsc_cachedata and it&#8217;s sidekick wpsc_cachedata_safety. In the future when a site owner using WP Super Cache wants to make part of their website dynamic they will use those filters to modify pre-defined text strings and replace them with the data they want displayed to the end user. There&#8217;s an <a href=\"http://svn.wp-plugins.org/wp-super-cache/trunk/plugins/dynamic-cache-test.php\">example script</a> ready to be ripped apart to help you figure all this out.</p>\n<p>There are two ways of using this:</p>\n<ol>\n<li> The dynamic content is the return value of a simple process, be it <code>date()</code> or any of the numerous get_*() functions in WordPress. That data can simply be slotted in place of the pre-defined text mentioned above.</li>\n<li> The more difficult bit comes when you need to use an output buffer to collect the data for display. Due to a limitation in PHP it&#8217;s impossible to run an output buffer in the callback function of another output buffer, which is when the wpsc_cachedata filter runs. We need to collect that data <em>before</em> the callback function executes.</li>\n</ol>\n<p>The first way above is easy. Simply add a text string of random characters to your theme where you want the dynamic content to appear, then hook a function on to the wpsc_cachedata filter to str_replace() it with your dynamic content. These functions in <a href=\"http://svn.wp-plugins.org/wp-super-cache/trunk/plugins/dynamic-cache-test.php\">this script</a> do that:\n<ul>\n<li>dynamic_cache_test_filter()</li>\n<li>dynamic_cache_test_template_tag()</li>\n<li>dynamic_cache_test_init()</li>\n</ul>\n<p>You&#8217;ll have to hook on to the wpsc_cachedata_safety action and return the numeral 1 to actually run the wpsc_cachedata filter. This is a fail safe used by the plugin to make sure things are ok when the filter runs.</p>\n<p>Unfortunately if you want to use an output buffer it&#8217;s a lot harder. As stated above an output buffer can&#8217;t run in the callback function of another output buffer. This means you have to generate your dynamic content earlier in the PHP process.<br />\nThis could be as easy as calling your dynamic content function (dynamic_output_buffer_test() in the example script) from the wp_footer action, or calling it from any action before shutdown, whichever is appropriate. You&#8217;ll also need to add a template tag of your own choosing to your theme.<br />\nYour dynamic content function will run just fine for cached pages, so after the new page has run it store the output in a constant or global variable that the same function can look for when the wpsc_cacheaction runs it. If it finds that information, it can do the search and replace of your template tag without running the output buffer again.<br />\nSome pages won&#8217;t run the dynamic content function however. This includes feeds and sitemaps. Those pages will generate a PHP error because the output buffer will try to run in the callback!</p>\n<blockquote><p>&#8220;PHP Fatal error:  ob_start(): Cannot use output buffering in output buffering display handlers in&#8230;&#8221;</p></blockquote>\n<p>To stop that happening you must check that there&#8217;s text to shove in the cached page. That&#8217;s what happens in the function dynamic_output_buffer_test_safety() in the example script. It fires on the wpsc_cachedata_safety filter and returns the numeral 1 if successful. </p>\n<h3>Anatomy of an Output Buffer</h3>\n<p>I&#8217;m going to try and explain the output buffer functions in more detail here. They&#8217;re only example functions and if you spot a bug or can suggest improvements please do!</p>\n<pre class=\"brush: php; gutter: false; title: ; notranslate\">define( \'DYNAMIC_OUTPUT_BUFFER_TAG\', \'\' ); // CHANGE THIS!</pre>\n<p>This is the string you add to your theme where your dynamic content will appear. The plugin will replace this string with the code generated by your dynamic content function.</p>\n<pre class=\"brush: php; title: ; notranslate\">function dynamic_output_buffer_test( &amp;$cachedata = 0 ) {\n	if ( defined( \'DYNAMIC_OB_TEXT\' ) )\n		return str_replace( DYNAMIC_OUTPUT_BUFFER_TAG, DYNAMIC_OB_TEXT, $cachedata );\n	ob_start();\n	// call the sidebar function, do something dynamic\n	echo \"&lt;p&gt;This is a test. The current time on the server is: \" . date( \'H:i:s\' ) . \"&lt;/p&gt;\";\n	$text = ob_get_contents();\n	ob_end_clean();\n\n	if ( $cachedata === 0 ) // called directly from the theme so store the output\n		define( \'DYNAMIC_OB_TEXT\', $text );\n	else // called via the wpsc_cachedata filter. We only get here in cached pages in wp-cache-phase1.php\n		return str_replace( DYNAMIC_OUTPUT_BUFFER_TAG, $text, $cachedata );\n\n}\nadd_cacheaction( \'wpsc_cachedata\', \'dynamic_output_buffer_test\' );</pre>\n<ul>\n<li> 1. dynamic_output_buffer_test() is the function that will generate the dynamic content inserted into the cached page.</li>\n<li> 2-3. DYNAMIC_OB_TEXT stores the previous output of this function. If it&#8217;s set that means we&#8217;re in the wpsc_cachedata filter and should insert it into the cached page and return it.</li>\n<li> 4-8. This creates the output buffer, echoes a string with the current time and copies the buffer into a variable called $text before closing the output buffer.</li>\n<li> 10-13. This is how we decide to return data. If $cachedata is 0 that means this function was called from the theme so we should define the constant DYNAMIC_OB_TEXT for later use. Otherwise, we must be dealing with an already cached page so insert the dynamic content into the page and return it.</li>\n<li> 16. Add the dynamic_output_buffer_test() function to the wpsc_cachedata action. &#8220;add_cacheaction&#8221; is used as it loads before the regular WordPress action code loads.</li>\n</ul>\n<pre class=\"brush: php; title: ; notranslate\">function dynamic_output_buffer_test_safety( $safety ) {\n	if ( defined( \'DYNAMIC_OB_TEXT\' ) )\n		return 1; // ready to replace tag with dynamic content.\n	else\n		return 0; // tag cannot be replaced.\n}\nadd_cacheaction( \'wpsc_cachedata_safety\', \'dynamic_output_buffer_test_safety\' );</pre>\n<ul>\n<li>1-6. dynamic_output_buffer_test_safety() is a function that checks if dynamic content was generated correctly. If that constant is not defined the output buffer will run within the callback function of the main WP Super Cache output buffer and generate a PHP error.</li>\n<li> 7. Add the wpsc_cachedata_safety() function to the dynamic_output_buffer_test_safety action.</li>\n</ul>\n<h3>sidebar.php</h3>\n<p>As an example, if I wanted to display my dynamic content in the sidebar of my blog I would load sidebar.php in my theme&#8217;s directory and add the following code. </p>\n<pre class=\"brush: php; title: ; notranslate\">if ( function_exists( \'dynamic_output_buffer_test\' ) )\n    dynamic_output_buffer_test();\n?&gt;WORDPRESS ROCKS THE WORLD&lt;?php</pre>\n<p>I had previously edited the example script, uncommented it and changed the appropriate tag:</p>\n<pre class=\"brush: php; gutter: false; title: ; notranslate\">define( \'DYNAMIC_OUTPUT_BUFFER_TAG\', \'WORDPRESS ROCKS THE WORLD\' ); // CHANGE THIS!</pre>\n<h3>Final Note and Download Link</h3>\n<p>Please grab the <a href=\"http://ocaoimh.ie/the-development-version-of-wp-super-cache/\">development version</a> of the plugin and try it on a staging server before you put it live. Feedback would be appreciated!</p>\n<p>Warning! Keep the tags you use secret. You don&#8217;t want someone leaving a comment on your blog with that string! Do not use the same function names or constant names as in this post or example script. They&#8217;re in this very public post. Someone is bound to use them and cause you problems when you install their plugin.</p>\n<p>Finally, barring any last minute major bugs this version of WP Super Cache will be released on Wednesday. Be careful upgrading. Pass the word around if you know someone is using mfunc as their site will stop working!</p>\n\n<p><strong>Related Posts</strong><ul><li> <a href=\"http://ocaoimh.ie/2013/10/23/wp-super-cache-1-4/\" rel=\"bookmark\" title=\"Permanent Link: WP Super Cache 1.4\">WP Super Cache 1.4</a></li><li> <a href=\"http://ocaoimh.ie/2009/07/17/wp-super-cache-0-9-5/\" rel=\"bookmark\" title=\"Permanent Link: WP Super Cache 0.9.5\">WP Super Cache 0.9.5</a></li><li> <a href=\"http://ocaoimh.ie/2013/04/24/wp-super-cache-1-3-2/\" rel=\"bookmark\" title=\"Permanent Link: WP Super Cache 1.3.2\">WP Super Cache 1.3.2</a></li></ul></p><p><a href=\"http://ocaoimh.ie/2013/10/21/shiny-new-dynamic-content-wp-super-cache/\">The shiny new dynamic content in WP Super Cache</a> originally appeared on <a href=\"http://ocaoimh.ie\">Holy Shmoly!</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 21 Oct 2013 22:06:09 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:7:\"Donncha\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:25;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:45:\"WordPress.tv: WordCamp Europe 2013 Interviews\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=23966\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:63:\"http://wordpress.tv/2013/10/21/wordcamp-europe-2013-interviews/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:641:\"<div id=\"v-jxAPy8J5-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/23966/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/23966/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=23966&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/10/21/wordcamp-europe-2013-interviews/\"><img alt=\"WordCamp Europe 2013 Interviews\" src=\"http://videos.videopress.com/jxAPy8J5/video-9722ba6ba8_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 21 Oct 2013 20:07:31 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:26;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:50:\"WPTavern: Why Are We Paying For GPL Licensed Code?\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"http://www.wptavern.com/?p=10128\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:99:\"http://feedproxy.google.com/~r/WordpressTavern/~3/zYcZG5ycFZE/gpl-ethics-right-wrong-winners-losers\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:5653:\"<p>Kevin Muldoon has published a great post that may change the mindset of both WordPress end users and developers. In his post, he talks about WordPress, GPL, and ethics but further into the post, he mentions that perhaps we should not be thinking about what sites like <a href=\"http://wpavengers.com/\" title=\"http://wpavengers.com/\">GPL Avengers</a> or <a href=\"http://gplclub.org/\" title=\"http://gplclub.org/\">GPL Club</a> are doing as right or wrong but rather, good or bad. </p>\n<blockquote><p>When you start talking about premium GPL products, the line between what is right or wrong gets a little blurred. Perhaps the terms “Right” and “Wrong” should not be used in this debate at all. “Good” and “Bad” are more suitable. GPL is supposed to benefit the WordPress community. So we need to consider what is good and what is bad for the community?</p></blockquote>\n<p>Ethics is subjective so let&#8217;s skip that word. It&#8217;s as bad as saying &#8220;spirit&#8221; when talking about the GPL. What GPL Avengers and GPL CLub are doing is not illegal and I don&#8217;t think anyone will argue that point. Let&#8217;s take the good and bad approach.<span id=\"more-10128\"></span></p>\n<h3>The Good:</h3>\n<p> Both are offering commercial products either for free or for a substantially lower price. This is good because those who don&#8217;t need support can make do with the lower price. It&#8217;s also good in that it exposes the commercial offerings to a larger market segment that perhaps otherwise wouldn&#8217;t be able to afford purchasing from the original developer.</p>\n<h3>The Bad:</h3>\n<p> GPL Club points out that support is only provided by the original product authors. Meanwhile, WP Avengers provides automatic updates and premium support via forums and support credits. I am not sure how this works but their forum is not publicly accessible. In general, the best people to provide support for the product are the people who created it. By acquiring products through either of these two sites, unknowing customers will either be out of luck in getting support, or may not get the best support money can buy. </p>\n<p>There are a number of great comments about this situation that I encourage you to read like, <a href=\"http://www.kevinmuldoon.com/wordpress-gpl-ethics/#comment-5255\" title=\"http://www.kevinmuldoon.com/wordpress-gpl-ethics/#comment-5255\">this one from Paul</a>, or <a href=\"http://www.kevinmuldoon.com/wordpress-gpl-ethics/#comment-5251\" title=\"http://www.kevinmuldoon.com/wordpress-gpl-ethics/#comment-5251\">Andrew</a>. What is boils down to is these two sites have started a race to the bottom but I think that race has been going on for a long time. </p>\n<p>One of the scenarios that Kevin laid out was the following:</p>\n<blockquote><p>With regards to where the buck stops :) WP Avengers and GPL Club are charging money for premium plugins that other people developed. Here’s a thought….what if someone went one step further and released all premium plugins free. For example, a plugin and theme directory that allowed every single premium WordPress theme and plugin to be downloaded free of charge. No malware, no hidden agenda. Simply someone who wanted to share all premium plugins with the world.</p>\n<p>How do you think the WordPress community would react to this? Would it kill the market for premium WordPress products or would developers have to focus on support? &#8211; <a href=\"http://www.kevinmuldoon.com/wordpress-gpl-ethics/#comment-5254\" title=\"http://www.kevinmuldoon.com/wordpress-gpl-ethics/#comment-5254\">Kevin Muldoon</a></p></blockquote>\n<p>I think it would be fantastic. On paper, it seems pretty stupid to pay for GPL code. We hear the phrase &#8220;<em>paying for support and product updates</em>&#8221; repeatedly but it still seems as though we&#8217;re paying for the code first. So let&#8217;s make all code free. If we pay money, we&#8217;re actually paying for upgrades and support of that free code. But I know exactly what this would do to commercial themes and plugins. We&#8217;d end up with free code that only has one purpose. To serve up a prompt asking for an API key. In a way, I&#8217;d be ok with this because it would be less code running on my site but on the flip side, I&#8217;d then be relying on an increasing number of third-party sites to be online to make sure my forms worked. If all commercial themes and plugins were free, it wouldn&#8217;t be the end of the world. We would just rapidly make the transition to purchasing support and upgrades or service add-ons. Also, if commercial themes and plugins were free, sites like GPL Club and WP Avengers suddenly become the losers as they would then be charging for GPL code without the support to back it. </p>\n<h3>A Few Questions For My Commercial WordPress Developer Friends</h2>\n<p>It&#8217;s fascinating to think about all GPL licensed code in themes and plugins being free as in beer. How would this change the way vendors today do business? If the real value is in support and upgrades, then the question I have for commercial plugin and theme developers is why are they charging for their GPL licensed code? The GPL license says you can do it, but what&#8217;s the point? I&#8217;ll guess and say that it would then be too confusing for customers to figure this all out so it&#8217;s easier to bundle everything in one purchase. At the end of the day, WP Avengers, GPL Club and sites like them are not going to put the original vendors out of business. All they are is an inconvenience. </p>\n<img src=\"http://feeds.feedburner.com/~r/WordpressTavern/~4/zYcZG5ycFZE\" height=\"1\" width=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 21 Oct 2013 19:00:52 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Jeffro\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:27;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:65:\"WPTavern: WordPress 3.7 Automatic Upgrades Proving to Be Reliable\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"http://www.wptavern.com/?p=10151\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:117:\"http://feedproxy.google.com/~r/WordpressTavern/~3/4c1b_4P7CE8/wordpress-3-7-automatic-upgrades-proving-to-be-reliable\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2957:\"<p>The first <a href=\"http://wordpress.org/news/2013/10/wordpress-3-7-release-candidate/\" target=\"_blank\">WordPress 3.7 Release Candidate</a> was sent out into the wild last Friday. So far it&#8217;s been testing very well. The flagship feature of this release is the ability for WordPress to automatically update itself, as highlighted in the customary haiku:</p>\n<blockquote><p>\nWordPress three seven<br />\nA self-updating engine<br />\nLies beneath the hood\n</p></blockquote>\n<p>Automatic background updates seems like a daunting feature to launch across millions of blogs, but WordPress 3.7 includes code to roll back a failed automatic upgrade. Even so, Nacin <a href=\"https://twitter.com/nacin/status/392132430129139713\" target=\"_blank\">tweeted</a> yesterday that after 25,000 updates to RC1, there hasn&#8217;t been one single rollback. So far it looks like the automatic background updates for security and minor releases is proving to be remarkably reliable. <span id=\"more-10151\"></span></p>\n<p>Nacin has done everything in his power to determine points of failure within the feature but so far it&#8217;s been holding up nicely:</p>\n<blockquote class=\"twitter-tweet\" width=\"550\"><p>We’ve tried all sorts of things to trip up the updater in WP 3.7, like changing file perms, simulating network issues, having no disk space.</p>\n<p>&mdash; Andrew Nacin (@nacin) <a href=\"https://twitter.com/nacin/statuses/391303056047865856\">October 18, 2013</a></p></blockquote>\n<p></p>\n<blockquote class=\"twitter-tweet\" width=\"550\"><p>Short of unplugging the server halfway through, I’m not actually sure it’s possible for a background update in WP 3.7 to critically fail.</p>\n<p>&mdash; Andrew Nacin (@nacin) <a href=\"https://twitter.com/nacin/statuses/391265227058061312\">October 18, 2013</a></p></blockquote>\n<p></p>\n<p>Currently two emails are being sent out when the automatic upgrades are successful: one for debugging and the other standard email that all users of 3.7 will receive. Once 3.7 is officially released you will no longer get the debugging email. However, there is a <a href=\"https://twitter.com/nacin/status/391620342172504064\" target=\"_blank\">filter</a> that you can use to keep it turned on if you like.</p>\n<p>Jeff recently <a href=\"http://www.wptavern.com/how-will-you-configure-auto-updates-in-wordpress-3-7\" target=\"_blank\">polled Tavern readers</a> to see how they will be implementing the automatic updates on their sites, as many readers previously had expressed reservations. At this time it seems that only 1 in 4 people polled will be disabling automatic updates completely, while the remaining 75% are open to using them to varying degrees. The results of Nacin&#8217;s testing of RC1 should inspire even more confidence. If all goes well, it looks like we should have the official WordPress 3.7 release sometime this week.</p>\n<img src=\"http://feeds.feedburner.com/~r/WordpressTavern/~4/4c1b_4P7CE8\" height=\"1\" width=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 21 Oct 2013 17:56:38 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:28;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:97:\"WordPress.tv: Justin Jones: WordPress Security or Why Google Says You Shouldn’t Visit My Church\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=23080\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:111:\"http://wordpress.tv/2013/10/21/justin-jones-wordpress-security-or-why-google-says-you-shouldnt-visit-my-church/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:747:\"<div id=\"v-yIqcqtwl-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/23080/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/23080/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=23080&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/10/21/justin-jones-wordpress-security-or-why-google-says-you-shouldnt-visit-my-church/\"><img alt=\"Justin Jones: WordPress Security or Why Google Says You Shouldn’t Visit My Church\" src=\"http://videos.videopress.com/yIqcqtwl/video-c9445da87e_scruberthumbnail_1.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 21 Oct 2013 17:19:25 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:29;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:61:\"WPTavern: New Grid View Coming to the WordPress Media Library\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"http://www.wptavern.com/?p=9218\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:113:\"http://feedproxy.google.com/~r/WordpressTavern/~3/qM4VP9q4HBo/new-grid-view-coming-to-the-wordpress-media-library\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3915:\"<p>Your experience in the WordPress media library is about to get a whole lot better. Very soon you&#8217;ll have the option to display media items in a grid view. An exciting project to enhance the media library is well underway and will eventually be added to the WordPress core. The good news is that you don&#8217;t have to wait. This new feature, although still in development, is now available as a plugin.</p>\n<p><a href=\"http://wordpress.org/plugins/media-grid/\" target=\"_blank\">Media Grid</a>, developed by <a href=\"https://twitter.com/shaunandrews\" target=\"_blank\">Shaun Andrews</a>, just showed up in the WordPress plugin repository this weekend. Shaun has been a busy bee lately and he&#8217;s on a roll. The Media Grid plugin is the second plugin he&#8217;s released with improvements for the WordPress core UI. His first was the Widgets Area Chooser plugin that we <a href=\"http://www.wptavern.com/wordpress-widgets-area-chooser-plugin-a-handy-addition-to-mp6\" target=\"_blank\">featured</a> earlier today.<span id=\"more-9218\"></span></p>\n<p>When combined with the <a href=\"http://wordpress.org/plugins/mp6/\" target=\"_blank\">MP6 plugin</a>, the Media Grid plugin currently lets you select between seeing the library displayed in the old list style or with the new grid view: </p>\n<div id=\"attachment_10120\" class=\"wp-caption aligncenter\"><a href=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/10/media-library1.jpg\" rel=\"thumbnail\"><img src=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/10/media-library1.jpg?resize=560%2C316\" alt=\"WordPress Media Library Grid View\" class=\"size-full wp-image-10120\" /></a><p class=\"wp-caption-text\">WordPress Media Library Grid View</p></div>\n<p>What&#8217;s cool about this plugin? It lets you toggle the thumbnails to a larger size for ease of browsing. Pagination is handled beautifully via infinite scroll. The search is also very responsive and returns results instantly as you type, even if you only enter one letter. </p>\n<p>We&#8217;ve seen a lot of changes lately when it comes to WordPress user interface design. These rapid changes have been set in motion to arrange information in a way that is easier to use and understand.</p>\n<p>Scientific <a href=\"http://www.pnas.org/content/95/5/2703.full\" target=\"_blank\">studies of neural memory encoding</a> have shown that the human brain remembers pictures better than words. If you&#8217;re searching for an image you recently uploaded, browsing through thumbnails is likely to be much more helpful than trying to use words to search for your image. An optional grid view makes a lot of sense for this interface and I&#8217;m hoping it will become the default view. </p>\n<h3>When Will We See the Media Grid in the WordPress Core?</h3>\n<p>Of course, the burning question everyone wants to know, is when can we see this added to the WordPress core? The Media Library Grid View project is led by <a href=\"https://twitter.com/helenhousandi\" target=\"_blank\">Helen Hou-Sandi</a>. The plugin is part of the &#8220;Features as Plugins&#8221; initiative that enables developers to propose new features to core in the form of a plugin. Last time I checked with Shaun he said that they would love to have it ready for 3.8 or 3.9 but really it comes down to whenever it&#8217;s ready. </p>\n<p>This plugin is the future of the WordPress media library. I&#8217;m convinced that once you try the grid view you won&#8217;t ever want to go back to the boring list style. Although the Media Grid plugin is still being actively developed, it&#8217;s working quite nicely already. Shaun Andrews welcomes your suggestions and patches. If you&#8217;d like to help test it you can <a href=\"http://wordpress.org/plugins/media-grid/\" target=\"_blank\">download</a> Media Grid from the WordPress plugin repository.</p>\n<img src=\"http://feeds.feedburner.com/~r/WordpressTavern/~4/qM4VP9q4HBo\" height=\"1\" width=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 21 Oct 2013 17:00:28 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:30;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:37:\"Joseph: Books: The Year Without Pants\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"https://josephscott.org/?p=9213\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:70:\"https://josephscott.org/archives/2013/10/books-the-year-without-pants/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:10188:\"<p>I finished reading Scott Berkun&#8217;s book <a href=\"http://scottberkun.com/yearwithoutpants/\">The Year Without Pants</a>.  The book tells the tale of Scott&#8217;s time at <a href=\"http://automattic.com/\">Automattic</a> as the lead of Team Social, which worked on <a href=\"http://wordpress.com/\">WordPress.com</a>.  I&#8217;ve never read a book about a place that I&#8217;ve worked at, so I was curious to see things from his point of view.</p>\n<p>I&#8217;ve worked at Automattic for over six years, well before Scott started there.  We were always on separate teams and I never worked directly with Scott on any projects.  As a result some of the things Scott talks about in the book take on a different angle than my own.  While reading through the book I made notes on things that I wanted to expand on a bit, provide a different point of reference for, or just struck me as interesting.  I&#8217;m including the page number for easy reference.</p>\n<p><strong>Page 10</strong>, talking about how for many people Automattic was the largest company they had ever worked for.  I definitely didn&#8217;t fall into that camp.  Oddly enough I&#8217;ve alternated between large and small companies, though not on purpose.  Before Automattic I worked at a university that had thousands of employees.  Before that I was at small regional ISP that never had more than 10 full time employees.  Going back one more job I was at a large international company with more than 10,000 people across the planet.  And the job before that was at a company with 20 people.  That pretty much covers all of the jobs I&#8217;ve had as an adult.</p>\n<p><strong>Page 15</strong>, about IRC being an ancient chat program.  When I mention to other people that we use IRC I&#8217;ll often describe it as being &#8220;as old as dirt&#8221;, meaning <a href=\"http://www.irc.org/history_docs/jarkko.html\">1988</a>.  Being old doesn&#8217;t change the fact that it is still one of the best solutions to the problem of text based chat.</p>\n<p><strong>Page 16</strong>, about Automattic demanding great communication skills.  In some ways we have to overcommunicate in order to make up for not all being in the same building.</p>\n<p><strong>Page 20</strong>, Caturday.  Long running thing at Automattic from the world of LOLcats.  On page 25 Scott shows a screenshot of some stats, and the week ends with Caturday.  Some time ago a new hire at Automattic &#8220;fixed&#8221; the typo by changing it to Saturday.  We had to explain the joke, then had them revert it back to Caturday :-)</p>\n<p><strong>Page 25</strong>, experts don&#8217;t go back to regular jobs because regular jobs are hard.  This is worth keeping in mind the next time you read an article or book from a professional expert.</p>\n<p><strong>Page 28</strong>, on jamming practices from one culture into another.  This is a hard lesson to learn and I think most who have learned it have only done so through experience.  Culture isn&#8217;t something you can easily transplant.  Culture, like trust, is hard to build and easy to destroy.</p>\n<p><strong>Page 29</strong>, about trust.  Trust is a really big deal in any company culture.  The lack of it usually results in grinding political structures.  High degrees of trust can result in the whole being so much more than the sum of the parts.</p>\n<p><strong>Page 42</strong>, remember how I mentioned that I described IRC being as old as dirt?  I&#8217;m not the only one who thinks that way :-)</p>\n<p><strong>Page 43</strong>, about many things at Automattic being inherited from the open source WordPress project.  I don&#8217;t think it is an overstatement to say that this is one of the core attributes in the formation of Automattic.  In many ways it looks like a group of people working on an open source project that just happens to also involve money, sometimes.</p>\n<p><strong>Page 46</strong>, about the WordPress theme P2. One day I&#8217;ll write a separate post about how P2 came to be.  Naming things can be hard, and sometimes beyond your control.</p>\n<p><strong>Page 48</strong>, on the communication break down between P2, IRC, Skype, and email.  The ratio varies between teams.  For my experience I&#8217;d say P2 and IRC are closer to 50 / 50, Skype and email nearly rounding errors.  IRC was good for talking about something right now ( synchronous ) and P2 was good for things that weren&#8217;t nearly so time sensitive ( asynchronous ) or needed a better way to be tracked.</p>\n<p><strong>Page 54</strong>, about the size of a company being the ultimate goal.  I&#8217;ve had conversations with people about companies that stay intentionally small.  In the technology field it isn&#8217;t often that you come across people who want to have a limit to how big their company gets.  I think there is an idea worth exploring in there.</p>\n<p><strong>Page 61</strong>, regarding killing a project or experiment.  It isn&#8217;t easy to shutdown something that you&#8217;ve put energy into.  That said, we could be better about letting go.</p>\n<p><strong>Page 104</strong>, data-influenced culture versus a data-driven one.  I&#8217;ll give an example of one experience I had that shows how this worked.  A new A / B test was launched around a signup flow and I was fairly certain that the new version was going to do worse because the resulting experience was so bad for the user.  It quickly became clear that the new version resulted in more revenue.  As a team we talked it over and decided against using the new version, even though it meant giving up some of that increase in revenue.  I was happy we were able to agree on that because the user experience in the new version was one I&#8217;d never want to use.  The results of the A / B test were one part of our decision making process, but it wasn&#8217;t the only consideration.</p>\n<p><strong>Page 111</strong>, vision.  Someone having a clear vision of where things are going as a whole is a different dynamic in a company that focuses on individuals being super proactive about coming up with their own ideas on what to work on next.  Not that you can&#8217;t have it, just that at some point you realize everyone can&#8217;t do everything.  See also page 126 regarding clarity vs. quantity of ideas.</p>\n<p><strong>Page 132</strong>, &#8220;Without the time machine, all choices have the possibility of being wrong.&#8221;  I need to put that on a t-shirt.  Sometimes the value of making a decision outweighs any of the potential outcomes of the decision itself.</p>\n<p><strong>Page 134</strong>, on not being tied down too much by a pre-selected process.  I&#8217;ve been asked before if Automattic uses [ insert current trendy methodology here ].  My answer has always been no.  We work out what works best for us as a team, then start moving forward, adjusting along the way as needed.</p>\n<p><strong>Page 136</strong>, &#8220;To start big projects, you must have the capacity for delusion.&#8221;  Probably also worth a t-shirt.  At some point after going through enough big projects you learn that you always underestimate them at the beginning.  Then after even more of them you learn that under estimating them is sometimes a good thing, because if you didn&#8217;t you would never actually start them.</p>\n<p><strong>Page 152</strong>, about work environments.  When I talk with people about Automattic being a distributed company, I usually end up explaining that like most things it is about trade offs.  Distributed vs. non-distributed is often less about which one is better and more about which trade offs you want to work with.  The same is true of individuals.  Not everyone is going to excel in a distributed situation, and that is fine, it doesn&#8217;t make them bad at what they do or who they are.</p>\n<p><strong>Page 171</strong>, talking about Team Social being stretched even further.  When Scott joined Automattic I started working on the Akismet team.  Our team was always stretched, with people in Melbourne ( Australia ), California, Utah, North Carolina, and England.  From UTC that is +11, -7, -6, -4, and +1 for everyone playing along at home.  Not the same broad and even distribution that Team Social ended up with, but not always easy either.  But we made it work.</p>\n<p><strong>Page 198</strong>, a reference to the bike shed problem.  Long time FreeBSD users will remember <a href=\"http://bikeshed.com/\">the bike shed post by PHK</a>.</p>\n<p><strong>Page 200</strong>, on few people being willing to dive in and make changes.  That is pretty much the opposite of my experience.</p>\n<p><strong>Page 200</strong>, about broken windows for good and bad.  I think our ability to fix a bug that came up quickly is a good thing.  There obviously has to be some balance with other things, but I would never want to lose our ability to go from getting a ping from a friend about something on our service being broken, to being able to reply that it has now been fixed, often in a matter of minutes.</p>\n<p><strong>Page 201</strong>, some people being afraid to post on a P2 because they think it is a megaphone and everyone is reading it.  What is funny about reading that is that before we had P2, there was just one internal blog for all of Automattic and it was rarely used.  It was common for it to only get one post per month.  P2 changed that dramatically.</p>\n<p><strong>Page 225</strong>, &#8220;No one should be expected to carry the burden of a secret their peers would love to know.&#8221;  Not worth putting on a t-shirt, but something that every leader should remember.</p>\n<hr />\n<p>I could comment on every page in the book, but these were the points that I noted specifically as I read through it.</p>\n<p>The book itself is an enjoyable read, and easy to get through.  If you&#8217;ve ever wondered what things are like at Automattic, The Year Without Pants, is a pretty good window.  Just keep in mind that it is from one point of view and that each team has a high degree of flexibility in doing things in a way that works best for them.</p>\n<p>If you would rather live it than read about it, <a href=\"http://automattic.com/work-with-us/\">Automattic is hiring</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 21 Oct 2013 15:05:31 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Joseph Scott\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:31;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:61:\"WPTavern: After Four Years – WPShout Is Under New Ownership\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"http://www.wptavern.com/?p=10124\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:109:\"http://feedproxy.google.com/~r/WordpressTavern/~3/sUm_0G9JveY/after-four-years-wpshout-is-under-new-ownership\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2615:\"<p><a href=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/10/wpshoutlogo.jpg\" rel=\"thumbnail\"><img src=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/10/wpshoutlogo.jpg?resize=300%2C46\" alt=\"wpshout logo\" class=\"alignright size-medium wp-image-10125\" /></a>Long time WordPress community member Alex Denning <a href=\"http://wpshout.com/ending-better-beginning/\" title=\"http://wpshout.com/ending-better-beginning/\">has announced</a> that his WordPress centric site <a href=\"http://www.wpshout.com\" title=\"http://www.wpshout.com\">WPShout</a> is now under new ownership. Alex has reached the point where his job combined with his university study work has made it impossible for him to keep the site going. Thankfully, Alex has found a great home for the site. New owners Fred and David of <a href=\"http://pressupinc.com/\" title=\"http://pressupinc.com/\">Press Up</a> will be taking over the site. According to their introductions within the announcement post, they seem to fit in naturally with providing the type of content WPShout readers have come to expect. <span id=\"more-10124\"></span></p>\n<blockquote><p>We’re really excited to be taking over WPShout, and glad that we were able to talk Alex into sticking around in an advising role for the transitional period. He’s built a great resource here, and we’re eager to keep his vision alive and make it even better.</p></blockquote>\n<p>Kudos to Alex for finding the right individuals to take over the site. I know from experience that giving up something that was built from the ground up is not an easy task but handing it over to the right individuals makes the process a lot easier to cope with. For those of you that would like to keep in touch with Alex, you can <a href=\"http://twitter.com/alexdenning\" title=\"http://twitter.com/alexdenning\">follow him on Twitter</a> or keep an eye on his personal site <a href=\"http://sevenironcows.com/\" title=\"http://sevenironcows.com/\">Sevenironcows</a>. </p>\n<p>Before I let you go, please check out Alex Denning&#8217;s <a href=\"http://wpshout.com/hosting-review-results/\" title=\"http://wpshout.com/hosting-review-results/\">Webhosting Review 2013 Results</a> that he published two weeks ago. Also, I&#8217;ll have Alex, Fred, and David on this week&#8217;s episode of WordPress Weekly to discuss the transition of the WPShout website. Considering how busy Alex will be with university, this may be the only opportunity we get to talk to him about his experience in the WordPress community.</p>\n<img src=\"http://feeds.feedburner.com/~r/WordpressTavern/~4/sUm_0G9JveY\" height=\"1\" width=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 21 Oct 2013 15:00:20 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Jeffro\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:32;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:72:\"WPTavern: WordPress Widgets Area Chooser Plugin: A Handy Addition to MP6\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"http://www.wptavern.com/?p=10090\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:123:\"http://feedproxy.google.com/~r/WordpressTavern/~3/mvgunDECZL0/wordpress-widgets-area-chooser-plugin-a-handy-addition-to-mp6\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3160:\"<p>If you&#8217;ve ever worked on a WordPress site with a long list of widget areas and dozens of widgets, then you know how crowded this page can become. In this scenario the drag-and-drop interface becomes virtually useless, as you struggle to drag the widget to the right area while trying to force your browser window to scroll down.</p>\n<p><div id=\"attachment_10101\" class=\"wp-caption alignright\"><a href=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/10/widgets-area-chooser.jpg\" rel=\"thumbnail\"><img src=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/10/widgets-area-chooser.jpg?resize=353%2C250\" alt=\"Widgets Area Chooser\" class=\"size-full wp-image-10101\" /></a><p class=\"wp-caption-text\">Widgets Area Chooser</p></div>While the new widgets page design in MP6 makes it easier to manage widgets, the drag-and-drop doesn&#8217;t always provide the best experience. That&#8217;s where the <a href=\"http://wordpress.org/plugins/widget-area-chooser/\" target=\"_blank\">Widgets Area Chooser</a> plugin comes in handy. <span id=\"more-10090\"></span></p>\n<p>Created by <a href=\"http://wordpress.org/plugins/mp6/\" target=\"_blank\">MP6</a> member <a href=\"https://twitter.com/shaunandrews\" target=\"_blank\">Shaun Andrews</a>, this plugin lets you click a widget in order to choose where it should be placed. According to Shaun, the plugin is really just a bit of CSS and JS, so it would be an easy addition to MP6.</p>\n<p>Here&#8217;s a quick demo of the Widgets Area Chooser in action:</p>\n<div id=\"attachment_10105\" class=\"wp-caption aligncenter\"><a href=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/10/widgets.gif\" rel=\"thumbnail\"><img src=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/10/widgets.gif?resize=560%2C457\" alt=\"(note: The experience is actually not as jumpy as it appears in the screencast)\" class=\"size-full wp-image-10105\" /></a><p class=\"wp-caption-text\">(note: The experience is actually not as jumpy as it appears in the screencast)</p></div>\n<p>After testing this plugin on my desktop as well as mobile devices, I believe there are several merits which should be considered in the discussion about whether or not this should be a part of MP6 and eventually WordPress 3.8:</p>\n<ul>\n<li>Makes it easier to add new widgets &#8211; clicking is easier than drag-and-drop</li>\n<li>Reduces frustration when working with a large number of widget areas</li>\n<li>Makes it easier to manage widgets on a mobile device</li>\n</ul>\n<p>It&#8217;s important to recognize that this doesn&#8217;t actually remove drag-and-drop capabilities. The Widgets Area Chooser simply adds a new way to move widgets around, and users will still have the option of dragging and dropping if they prefer. Please note that you will need to have <a href=\"http://wordpress.org/plugins/mp6/\" target=\"_blank\">MP6</a> installed and activated in order to test this plugin. </p>\n<p>So what do you think? Should the <a href=\"http://wordpress.org/plugins/widget-area-chooser/\" target=\"_blank\">Widgets Area Chooser</a> be included in MP6?</p>\n<img src=\"http://feeds.feedburner.com/~r/WordpressTavern/~4/mvgunDECZL0\" height=\"1\" width=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 21 Oct 2013 13:01:04 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:33;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:44:\"WordPress.tv: Paul Kortman: Stop Selling SEO\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=23072\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:61:\"http://wordpress.tv/2013/10/20/paul-kortman-stop-selling-seo/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:638:\"<div id=\"v-Oc6EhwH0-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/23072/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/23072/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=23072&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/10/20/paul-kortman-stop-selling-seo/\"><img alt=\"Paul Kortman: Stop Selling SEO\" src=\"http://videos.videopress.com/Oc6EhwH0/video-0ca99ba0ff_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 20 Oct 2013 14:17:23 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:34;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:73:\"WordPress.tv: K. Adam White: Building Apps With Backbone.js and WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=23856\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:89:\"http://wordpress.tv/2013/10/20/k-adam-white-building-apps-with-backbone-js-and-wordpress/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:695:\"<div id=\"v-XpFmdpC9-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/23856/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/23856/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=23856&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/10/20/k-adam-white-building-apps-with-backbone-js-and-wordpress/\"><img alt=\"K. Adam White: Building Apps With Backbone.js and WordPress\" src=\"http://videos.videopress.com/XpFmdpC9/video-50bab1e57b_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 20 Oct 2013 13:26:45 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:35;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:100:\"WordPress.tv: Panel Discussion: WordPress Face-to-Face: Fostering Your Local (And Digital) Community\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=23858\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:114:\"http://wordpress.tv/2013/10/19/panel-discussion-wordpress-face-to-face-fostering-your-local-and-digital-community/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:747:\"<div id=\"v-tfytkU2x-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/23858/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/23858/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=23858&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/10/19/panel-discussion-wordpress-face-to-face-fostering-your-local-and-digital-community/\"><img alt=\"Panel Discussion: WordPress Face-to-Face: Fostering Your Local (And Digital) Community\" src=\"http://videos.videopress.com/tfytkU2x/video-dbdba0ac67_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 19 Oct 2013 13:16:54 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:36;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"WordPress.tv: Jeremy Felt: Hi WordPress, Meet Vagrant\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=23872\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:69:\"http://wordpress.tv/2013/10/19/jeremy-felt-hi-wordpress-meet-vagrant/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:655:\"<div id=\"v-7MOIAJbN-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/23872/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/23872/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=23872&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/10/19/jeremy-felt-hi-wordpress-meet-vagrant/\"><img alt=\"Jeremy Felt: Hi WordPress, Meet Vagrant\" src=\"http://videos.videopress.com/7MOIAJbN/video-f84e899acd_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 19 Oct 2013 12:26:32 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:37;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"WPTavern: WPWeekly Episode  124 – The Three WordPressteers\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"http://www.wptavern.com/?p=10085\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:107:\"http://feedproxy.google.com/~r/WordpressTavern/~3/yfRhBSLaWZk/wpweekly-episode-124-the-three-wordpressteers\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3545:\"<p><a href=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/08/WordPressWeekly_albumart2.jpg\" rel=\"thumbnail\"><img src=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/08/WordPressWeekly_albumart2.jpg?resize=150%2C150\" alt=\"WordPress Weekly Cover Art\" class=\"alignright size-thumbnail wp-image-8715\" /></a> For the first time since returning to the airwaves, we had all three contributing authors to WordPress Tavern on the show at once. While we originally scheduled Alex Denning for this episode, we needed to reschedule him for October 25th. So in this episode, we each took turns discussing this weeks headlines. As a bonus, we got a live version of Marcus&#8217; plugin roundup post. I had a blast on this show and hope to do more of these in the future. <span id=\"more-10085\"></span></p>\n<h2>Stories Discussed:</h2>\n<p><a href=\"http://www.wptavern.com/managewp-launches-community-curated-wordpress-news-site\" title=\"http://www.wptavern.com/managewp-launches-community-curated-wordpress-news-site\">ManageWP Launches Community-Curated WordPress News Site</a><br />\n<a href=\"http://www.wptavern.com/buddypress-1-9-will-include-dynamic-menu-links\" title=\"http://www.wptavern.com/buddypress-1-9-will-include-dynamic-menu-links\">BuddyPress 1.9 Will Include Dynamic Menu Links</a><br />\n<a href=\"http://www.wptavern.com/how-will-you-configure-auto-updates-in-wordpress-3-7\" title=\"http://www.wptavern.com/how-will-you-configure-auto-updates-in-wordpress-3-7\">How Will You Configure Auto Updates In WordPress 3.7?</a><br />\n<a href=\"http://www.wptavern.com/book-review-the-year-without-pants\" title=\"http://www.wptavern.com/book-review-the-year-without-pants\">Book Review: The Year Without Pants</a><br />\n<a href=\"http://www.wptavern.com/dashboard-makeover-removes-incoming-links-widget\" title=\"http://www.wptavern.com/dashboard-makeover-removes-incoming-links-widget\">Dashboard Makeover Removes Incoming Links Widget</a><br />\n<a href=\"http://www.wptavern.com/mark-jaquith-on-wordpress-3-6-postmortem-and-post-formats-ui\" title=\"http://www.wptavern.com/mark-jaquith-on-wordpress-3-6-postmortem-and-post-formats-ui\">Mark Jaquith on WordPress 3.6 Postmortem and Post Formats UI</a></p>\n<h2>Plugins Mentioned By Marcus:</h2>\n<p><a href=\"http://wordpress.org/plugins/quick-wp-setup/\" title=\"http://wordpress.org/plugins/quick-wp-setup/\">Quick WP Setup</a><br />\n<a href=\"http://wordpress.org/plugins/preview-posts-everywhere/\" title=\"http://wordpress.org/plugins/preview-posts-everywhere/\">Preview Posts Everywhere</a><br />\n<a href=\"http://wordpress.org/plugins/custom-background-for-post-and-page/\" title=\"http://wordpress.org/plugins/custom-background-for-post-and-page/\">Custom Background for Post and Page</a></p>\n<h2>WPWeekly Meta:</h2>\n<p><strong>Next Episode:</strong> Friday, October 25th 3 P.M. Eastern &#8211; Special Guest Alex Denning Of WPShout.com</p>\n<p><strong>Subscribe To WPWeekly Via Itunes: </strong><a href=\"https://itunes.apple.com/us/podcast/wordpress-weekly/id694849738\" target=\"_blank\">Click here to subscribe</a></p>\n<p><strong>Subscribe To WPWeekly Via RSS: </strong><a href=\"http://www.wptavern.com/feed/podcast\" target=\"_blank\">Click here to subscribe</a></p>\n<p><strong>Subscribe To WPWeekly Via Stitcher Radio: </strong><a href=\"http://www.stitcher.com/podcast/wordpress-weekly-podcast?refid=stpr\" target=\"_blank\">Click here to subscribe</a></p>\n<p><strong>Listen To Episode #124:</strong><br />\n</p>\n<img src=\"http://feeds.feedburner.com/~r/WordpressTavern/~4/yfRhBSLaWZk\" height=\"1\" width=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 19 Oct 2013 06:37:45 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Jeffro\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:38;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Matt: Fast Company on Simperium\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://ma.tt/?p=43141\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:47:\"http://ma.tt/2013/10/fast-company-on-simperium/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:230:\"<p>Fast Company&#8217;s Co.Labs writes a great article on <a href=\"http://www.fastcolabs.com/3020218/why-wordpress-gobbled-up-this-scrappy-icloud-alternative\">Why WordPress[.com] Gobbled Up This Scrappy iCloud Alternative</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 18 Oct 2013 23:56:44 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:39;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:76:\"WPTavern: WordSesh 2013: Live Streaming 24 Hours of Free WordPress Education\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"http://www.wptavern.com/?p=9992\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:127:\"http://feedproxy.google.com/~r/WordpressTavern/~3/HjNrHEFpulo/wordsesh-2013-live-streaming-24-hours-of-free-wordpress-education\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2232:\"<p>Mark your calenders for December 6th and 7th, 2013. <a href=\"http://wordsesh.org/\" target=\"_blank\">WordSesh</a> will be back in session! In case you missed the first WordSesh, the basic idea is very similar to a WordCamp, except everything is streamed live on the web. The event is totally free and anyone can attend by tuning in from home. WordSesh is comprised of 24 sessions that cater to every type of WordPress user. There will be one session every hour, on the hour, for 24 hours. </p>\n<p><a href=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/10/wordsesh.jpg\" rel=\"thumbnail\"><img src=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/10/wordsesh.jpg?resize=560%2C274\" alt=\"wordsesh\" class=\"aligncenter size-full wp-image-10072\" /></a><span id=\"more-9992\"></span></p>\n<p>If you haven&#8217;t been able to make it to as many WordCamps as you&#8217;d like, here&#8217;s your chance to get in on some awesome free WordPress sessions. WordSesh offers a community learning experience that you can enjoy with other WordPress fans around the world. The event utilizes Google Hangouts to broadcast sessions from wherever the speakers are located.</p>\n<p>In case you missed last year&#8217;s event, all of the sessions were recorded and are available on <a href=\"http://www.youtube.com/playlist?list=PL9bmvLB3RpG7zGrbwbd2R9a2tqT-FiYiG\" target=\"_blank\">youtube</a>. This should give you an idea of the high quality speakers you can expect when you tune in.  The <a href=\"http://dradcast.com/\" target=\"_blank\">DradCast podcast</a> will be kicking off WordSesh 2, ushering in &#8220;24 hours of non-stop WordPress knowledge and fun.&#8221; </p>\n<p>WordSesh is still taking applications for speakers and you can submit directly on the <a href=\"http://wordsesh.org/\" target=\"_blank\">website</a>. If you want to join in, make sure to add the dates to your calender, <a href=\"https://twitter.com/WordSesh\" target=\"_blank\">follow WordSesh on Twitter</a>, and subscribe to <a href=\"http://wordsesh.org/\" target=\"_blank\">WordSesh news</a> and announcements. You don&#8217;t want to miss a minute of this awesome event. </p>\n<img src=\"http://feeds.feedburner.com/~r/WordpressTavern/~4/HjNrHEFpulo\" height=\"1\" width=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 18 Oct 2013 21:23:09 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:40;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:41:\"Dev Blog: WordPress 3.7 Release Candidate\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=2718\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:66:\"http://wordpress.org/news/2013/10/wordpress-3-7-release-candidate/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2236:\"<p>The first release candidate for WordPress 3.7 is now available!</p>\n<p>In RC 1, we&#8217;ve made some adjustments to the update process to make it more reliable than ever. We hope to ship WordPress 3.7 <em>next week</em>, but we need your help to get there. If you haven’t tested 3.7 yet, there’s no time like the present. (Please, not on a production site, unless you’re adventurous.)</p>\n<p>WordPress 3.7 introduces <strong>automatic background updates</strong> for security and minor releases (like updating from 3.7 to 3.7.1). These are really easy to test  — RC 1 will update every 12 hours or so to the latest development version, and then email you the results. (You may get two emails: one for debugging, and one all users of 3.7 will receive.) If something went wrong, you can report it.</p>\n<p><strong>Think you’ve found a bug? </strong>Please post to the <a href=\"http://wordpress.org/support/forum/alphabeta/\">Alpha/Beta area in the support forums</a>. If any known issues come up, you’ll be able to <a href=\"http://core.trac.wordpress.org/report/5\">find them here</a>.</p>\n<p>To test WordPress 3.7 RC1, try the <a href=\"http://wordpress.org/extend/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin (you’ll want “bleeding edge nightlies”). Or you can <a href=\"http://wordpress.org/wordpress-3.7-RC1.zip\">download the release candidate here</a> (zip). If you’d like to learn more about what&#8217;s new in WordPress 3.7, visit the awesome About screen in your dashboard (<strong><img alt=\"\" src=\"http://core.svn.wordpress.org/branches/3.6/wp-content/themes/twentyten/images/wordpress.png\" /> → About</strong> in the toolbar). There, you can also see if your install is eligible for background updates. WordPress won’t automatically update, for example, if you’re using version control like Subversion or Git.</p>\n<p><strong>Developers,</strong> please test your plugins and themes against WordPress 3.7, so that if there is a compatibility issue, we can figure it out before the final release. Make sure you post any issues to the support forums.</p>\n<p><em>WordPress three seven</em><br />\n<em>A self-updating engine</em><br />\n<em>Lies beneath the hood</em></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 18 Oct 2013 19:52:14 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Andrew Nacin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:41;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"WordPress.tv: Chad Warner: WordPress Admin: A Guided Tour\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=23082\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:73:\"http://wordpress.tv/2013/10/18/chad-warner-wordpress-admin-a-guided-tour/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:663:\"<div id=\"v-lrHdq3sq-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/23082/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/23082/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=23082&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/10/18/chad-warner-wordpress-admin-a-guided-tour/\"><img alt=\"Chad Warner: WordPress Admin: A Guided Tour\" src=\"http://videos.videopress.com/lrHdq3sq/video-98021c129a_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 18 Oct 2013 16:35:05 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:42;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:78:\"WPTavern: WordPress MP6 Plugin Adds New Widgets Page and Midnight Color Scheme\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"http://www.wptavern.com/?p=10040\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:130:\"http://feedproxy.google.com/~r/WordpressTavern/~3/34x8ppLkyUY/wordpress-mp6-plugin-adds-new-widgets-page-and-midnight-color-scheme\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3425:\"<p>Although <a href=\"http://wordpress.org/plugins/mp6/\" target=\"_blank\">MP6</a> may sound like the code name of a covert spy mission, it&#8217;s actually one of the most exciting WordPress plugins in the repository right now. MP6 is part of the &#8220;features as plugins&#8221; initiative and houses the intended design updates to the WordPress admin. The plan is to include the changes in the core with the  upcoming WordPress 3.8 release. </p>\n<p>Many WordPress sites are already using MP6 to transform their dashboards and there are <a href=\"http://plugins.trac.wordpress.org/log/mp6/?rev=786548&stop_rev=764842\" target=\"_blank\">several dozen reasons</a> to upgrade to the latest version. Here are just a few of the highlights:<span id=\"more-10040\"></span></p>\n<ul>\n<li>A bunch of new dashicons</li>\n<li>A re-designed widgets page by <a href=\"https://twitter.com/shaunandrews\" target=\"_blank\">Shaun Andrews</a> from his Widgets project</li>\n<li>Improvements to customizer, color schemes, menus section and much more</li>\n<li>New Midnight color scheme</li>\n</ul>\n<p>You may have seen a <a href=\"http://polldaddy.com/poll/7437854/\" target=\"_blank\">poll</a> floating around about extra color schemes for MP6. The Midnight color scheme must have proven the most popular, as it has now been included in the latest MP6 update. This bold skin for the dashboard sports red highlights:</p>\n<div id=\"attachment_10043\" class=\"wp-caption aligncenter\"><a href=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/10/midnight-color-scheme.png\" rel=\"thumbnail\"><img src=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/10/midnight-color-scheme.png?resize=560%2C305\" alt=\"MP6 Midnight Color Scheme\" class=\"size-full wp-image-10043\" /></a><p class=\"wp-caption-text\">MP6 Midnight Color Scheme</p></div>\n<p>The new widgets page design is much cleaner, allows you to see more widgets at once and is easier to navigate if you&#8217;re using a theme with many different widgetized areas. </p>\n<div id=\"attachment_10047\" class=\"wp-caption aligncenter\"><a href=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/10/widgets.jpg\" rel=\"thumbnail\"><img src=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/10/widgets.jpg?resize=560%2C349\" alt=\"New widgets page design\" class=\"size-full wp-image-10047\" /></a><p class=\"wp-caption-text\">New widgets page design</p></div>\n<p>In order to achieve this cleaner look, the widgets page had to sacrifice the widget descriptions, which seems to be a main point of concern for those who have already upgraded MP6. Plugin authors can be rather generic in how they name their widgets, so descriptions are helpful for knowing which widget you&#8217;re looking at. The scrollbar within the widgets section is also a point of contention. Overall, the MP6 2.1 updates have been very well received and there&#8217;s still plenty of time to work through any challenges.</p>\n<p>Your feedback is important! If you want to be a part of testing or you&#8217;re just curious about where the WordPress admin is going, <a href=\"http://wordpress.org/plugins/mp6/\" target=\"_blank\">install MP6</a> and put it through the paces of your daily routine. If you&#8217;re already using MP6, you can take advantage of all the new features and bug fixes by upgrading the plugin through your dashboard.</p>\n<img src=\"http://feeds.feedburner.com/~r/WordpressTavern/~4/34x8ppLkyUY\" height=\"1\" width=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 18 Oct 2013 13:21:04 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:43;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:64:\"WordPress.tv: Ross Johnson: The Overlap Of Emotion And Usability\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=23074\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:83:\"http://wordpress.tv/2013/10/18/ross-johnson-the-overlap-of-emotion-and-usability-2/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:686:\"<div id=\"v-K4qaPBBC-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/23074/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/23074/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=23074&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/10/18/ross-johnson-the-overlap-of-emotion-and-usability-2/\"><img alt=\"Ross Johnson: The Overlap Of Emotion And Usability\" src=\"http://videos.videopress.com/K4qaPBBC/video-c523678150_scruberthumbnail_0.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 18 Oct 2013 12:32:09 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:44;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:70:\"WPTavern: Mark Jaquith on WordPress 3.6 Postmortem and Post Formats UI\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"http://www.wptavern.com/?p=10034\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:122:\"http://feedproxy.google.com/~r/WordpressTavern/~3/TrujuHuq6co/mark-jaquith-on-wordpress-3-6-postmortem-and-post-formats-ui\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3783:\"<p>One of the most anticipated features of WordPress 3.6 was the new <a href=\"http://make.wordpress.org/core/2013/01/07/wordpress-3-6-the-post-formats-ui-feature/\" title=\"http://make.wordpress.org/core/2013/01/07/wordpress-3-6-the-post-formats-ui-feature/\">Post Formats UI</a> which would have exposed the feature to users who may not have known of its existence. Unfortunately, near the tail end of development for 3.6, Mark Jaquith <a href=\"http://make.wordpress.org/core/2013/05/29/post-formats-ui-is-exiting-core-will-live-as-a-plugin/\" title=\"http://make.wordpress.org/core/2013/05/29/post-formats-ui-is-exiting-core-will-live-as-a-plugin/\">made the announcement</a> that the feature would be exiting core and that the work involved would most likely end up as a plugin. This generated a lot of mixed reviews from developers. In the midst of all the discussion, <a href=\"http://make.wordpress.org/core/2013/05/29/post-formats-ui-is-exiting-core-will-live-as-a-plugin/#comment-8863\" title=\"http://make.wordpress.org/core/2013/05/29/post-formats-ui-is-exiting-core-will-live-as-a-plugin/#comment-8863\">Mark Jaquith stated</a> that he would publish a postmortem to explain the lessons learned. <span id=\"more-10034\"></span></p>\n<p>WordPress 3.7 is around the corner and we have yet to see the postmortem post, or a post formats UI plugin for that matter. I managed to get in touch with Mark Jaquith, who is an incredibly busy man, to find out what the status was on the post as well as the plugin. Mark tells me that he is working on the blog post that will explain the WordPress 3.6 development cycle, the lessons learned, and the struggles the team had during this time. The post will also cover the new approach to feature development that WordPress is now embracing with features being developed as plugins first. For those that will be attending <a href=\"http://central.wordcamp.org/wordcamps/wordcamp-london/\" title=\"http://central.wordcamp.org/wordcamps/wordcamp-london/\">WordCamp London</a> on November 23 and 24th, Mark will be giving a presentation that shares the lessons learned in 3.6. </p>\n<p><a href=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/05/PostFormatsUI.jpg\" rel=\"thumbnail\"><img src=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/05/PostFormatsUI.jpg?resize=500%2C133\" alt=\"Post Formats UI\" class=\"aligncenter size-large wp-image-6994\" /></a></p>\n<p>The reason for the delay in getting this information out to the public is that Mark is not an employee that gets to work on WordPress full-time. He was the lead developer for 3.6 and while trying to ensure the project stayed on time, he also had to make a living through his consultancy business. Some of his projects were even pushed back to make room for 3.6 development. To put it mildly, the 3.6 development process took a lot out of the man and he&#8217;s been playing catch up ever since. </p>\n<p>Mark concluded the email with his main takeaway of the post formats UI.</p>\n<blockquote><p>With regards to post formats UI, the main takeaway I had was that the approach we took was the wrong approach and I didn&#8217;t really see that until very late in the process. So if or when the post formats UI feature gets taken back up in plugin form (in 3.9 or later), it will be a fresh effort, not one based on the work we did in 3.6. I am also watching the content creation experience efforts to see how that might play in.</p></blockquote>\n<p>We&#8217;ll be keeping an eye out for the post and will link to it once it&#8217;s published. Thanks to Mark Jaquith for not only providing me with this update, but for all the hard work he did to lead the team to get 3.6 out the door. </p>\n<img src=\"http://feeds.feedburner.com/~r/WordpressTavern/~4/TrujuHuq6co\" height=\"1\" width=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 17 Oct 2013 22:53:05 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Jeffro\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:45;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:66:\"WordPress.tv: Dustin Hartzler: Live Podcast Recording With Q&amp;A\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=23068\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:78:\"http://wordpress.tv/2013/10/17/dustin-hartzler-live-podcast-recording-with-qa/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:679:\"<div id=\"v-SrXtLCKn-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/23068/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/23068/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=23068&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/10/17/dustin-hartzler-live-podcast-recording-with-qa/\"><img alt=\"Dustin Hartzler: Live Podcast Recording With Q&A\" src=\"http://videos.videopress.com/SrXtLCKn/video-4d669851e3_scruberthumbnail_1.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 17 Oct 2013 14:42:57 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:46;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"WordPress.tv: Dustin Hartzler: Podcasting With WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=23070\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:73:\"http://wordpress.tv/2013/10/17/dustin-hartzler-podcasting-with-wordpress/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:668:\"<div id=\"v-4cEo2Gdv-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/23070/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/23070/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=23070&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/10/17/dustin-hartzler-podcasting-with-wordpress/\"><img alt=\"Dustin Hartzler: Podcasting With WordPress\" src=\"http://videos.videopress.com/4cEo2Gdv/video-bd448fa7d0_scruberthumbnail_0.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 17 Oct 2013 14:35:57 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:47;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"WPTavern: Dashboard Makeover Removes Incoming Links Widget\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"http://www.wptavern.com/?p=10020\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:110:\"http://feedproxy.google.com/~r/WordpressTavern/~3/Wt8xB-A4x60/dashboard-makeover-removes-incoming-links-widget\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4164:\"<p><a href=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/10/incominglinks.jpg\" rel=\"thumbnail\"><img src=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/10/incominglinks.jpg?resize=172%2C123\" alt=\"Incoming Links In WordPress\" class=\"alignright size-full wp-image-10021\" /></a>When the <a href=\"http://make.wordpress.org/ui/2013/10/11/dash-update-4/\" title=\"http://make.wordpress.org/ui/2013/10/11/dash-update-4/\">dashboard redesign</a> is officially added to WordPress core, it looks like it will be missing a widget that&#8217;s been with the software since 2005 when the Dashboard feature was introduced with <a href=\"http://wordpress.org/news/2005/02/strayhorn/\" title=\"http://wordpress.org/news/2005/02/strayhorn/\">WordPress 1.5 &#8220;Strayhorn&#8221;</a>. In its early days, the incoming links widget used Technorati but due to the service not being able to handle the traffic from WordPress installs, the site was down more than it was up. This prompted the switch from Technorati to Google Blogsearch in a later version of WordPress. <span id=\"more-10020\"></span></p>\n<p>I personally found the Technorati version of the widget much more useful than the Google Blogsearch version. The widget updated on its own and for the most part, the URLs were legitimate sites linking to articles of mine. I remember visiting most of those websites to not only thank them in the comments for the link, but also read what they had to say regarding my blog posts. However, shortly after switching from Technorati to Google Blogsearch, I discovered that my own blog posts were being shown within the widget, cancelling out any links generated from outside sources. While doing some research for this post, I discovered a <a href=\"http://wordpress.org/support/topic/incoming-links-is-buggy\" title=\"http://wordpress.org/support/topic/incoming-links-is-buggy\">WordPress.org support thread</a> created by yours truly, detailing this specific issue.</p>\n<h3>Remove The Widget, Or Fix It?</h3>\n<p>Undoubtedly, some people will be upset to see incoming links disappear. In a <a href=\"https://twitter.com/jeffr0/status/390531986634207232\" title=\"https://twitter.com/jeffr0/status/390531986634207232\">conversation I had on Twitter today</a>, I brought up the idea that pingbacks and trackbacks solve the purpose of incoming links. However, those techniques have been abused by spammers for so long, most sites have them turned off. <a href=\"http://sw-guide.de/wordpress/plugins/simple-trackback-validation/\" title=\"http://sw-guide.de/wordpress/plugins/simple-trackback-validation/\">Simple Trackback Validation</a> suggested by Otto is a plugin that&#8217;s made those technologies useful again. I won&#8217;t dive into the specifics but it&#8217;s worked for me. </p>\n<p>The incoming links widget has been allowed to sit inside the WordPress dashboard broken, for too many years. For example, here is what the widget shows me in WordPress 3.6.1. </p>\n<div id=\"attachment_10024\" class=\"wp-caption aligncenter\"><a href=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/10/IncomingLinksInWP361.jpg\" rel=\"thumbnail\"><img src=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/10/IncomingLinksInWP361.jpg?resize=500%2C252\" alt=\"Incoming Links In WordPress 3.6.1\" class=\"size-large wp-image-10024\" /></a><p class=\"wp-caption-text\">Incoming Links As They Appear In WordPress 3.6.1</p></div>\n<p>How is it useful for me as a site administrator to see the last 10 incoming links are actually the 10 most recent posts published on the site? It&#8217;s not. That&#8217;s why I&#8217;m glad to see a useless widget that no one has time to properly fix be removed from core. If the widget were to be reworked into something useful, my suggestion would be to show the most recent 5-10 referral links. Those types of links are such a pain to find within analytic software, especially recent ones. Something that quickly showed just that information to me would be considered helpful and worthy of taking up a spot on my dashboard.</p>\n<p>What do you think?</p>\n<img src=\"http://feeds.feedburner.com/~r/WordpressTavern/~4/Wt8xB-A4x60\" height=\"1\" width=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 17 Oct 2013 12:00:13 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Jeffro\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:48;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:45:\"WPTavern: Book Review: The Year Without Pants\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"http://www.wptavern.com/?p=9996\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:96:\"http://feedproxy.google.com/~r/WordpressTavern/~3/Is4z4dknb3M/book-review-the-year-without-pants\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:5794:\"<p><a href=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/10/tywp.png\" rel=\"thumbnail\"><img src=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/10/tywp.png?resize=200%2C300\" alt=\"tywp\" class=\"alignright size-medium wp-image-10004\" /></a>While Facebook is busy building a <a href=\"http://online.wsj.com/article/SB10001424052702303492504579111792834660448.html?mod=WSJ_hpp_LEFTTopStories\" target=\"_blank\">$120 million dollar compound</a> to offer more convenient employee housing, Automattic has people working remotely all over the world, totally unsupervised and yet insanely productive at the same time.</p>\n<p>In a more <a href=\"http://www.wired.com/business/2013/10/working-from-home/?cid=co12921794\" target=\"_blank\">recent trend</a>, some of the largest tech companies like Yahoo, Best Buy and Hewlett Packard are moving away from allowing employees the freedom to work from home. Office culture was so firmly ingrained in their employees that collaboration and productivity fell sharply when they attempted a distributed workforce. While these tech giants have been unable to surmount the cultural challenges of having employees work from home, <a href=\"http://automattic.com/\" target=\"_blank\">Automattic</a> has never done it any other way. <span id=\"more-9996\"></span></p>\n<p><em><a href=\"http://www.amazon.com/The-Year-Without-Pants-WordPress-com/dp/1118660633\" target=\"_blank\">The Year Without Pants</a></em> is Scott Berkun&#8217;s account of working for Automattic with <a href=\"http://wordpress.com\" title=\"WordPress.com\" target=\"_blank\">WordPress.com</a>.  As a former Microsoft employee, Scott&#8217;s story is that of a leader entering a new work culture with no offices, no rules and no customary enslavement to email. Scott takes you along for the ride as all of his previous notions of procedure go right out the window.</p>\n<h3>&#8220;Trust is Everything&#8221;</h3>\n<p>Much of the buzz surrounding the book has to do with a prevailing belief that no real work can be done without direct supervision and regular soul-sapping meetings. Those who are new to Automattic&#8217;s distributed style of working are wondering how in the world a company can work without email as a primary tool. Berkun explores why Automattic has been so successful as a distributed company:</p>\n<blockquote><p>&#8220;To anyone who has worked on a large project, this all sounds like madness. How can they work without schedules? How can there be no safeguards? Why wouldn&#8217;t things blow up and collide all the time? A major reason this works at Automattic is belief in a counterintuitive philosophy: <em>safeguards don&#8217;t make you safe; they make you lazy</em>.&#8221;</p></blockquote>\n<p>For Berkun, trust is everything, and much of the book revolves around this concept. At every opportunity Berkun highlights trust as the center point around which all good work is done, as well as the anchor for healthy working relationships. When trust is present in an organization, productivity abounds.</p>\n<blockquote><p>The basic notion is that if people are smart and respect not blowing things up, too many safety measures get in the way. Instead, employees are trusted and empowered to release things fast.</p></blockquote>\n<p><em>The Year Without Pants</em> tells the story of Berkun&#8217;s journey in learning how to build trust with co-workers while working remotely. He also demonstrates how it is possible for a non-programming team leader to build trust with engineers.</p>\n<h3>The Influence of WordPress Culture</h3>\n<p>My favorite parts of the book are where Berkun delves deeper into the culture of WordPress. Its open source values extend beyond the software into the communication that surrounds the work. Berkun found that for the most part, communication within Automattic was public on <a href=\"http://p2theme.com/\" target=\"_blank\">P2</a> blogs, making knowledge freely available to anyone. </p>\n<p>He also found  that the culture of WordPress was influenced both by its open source roots and its co-founder, Matt Mullenweg. As far as open source projects go, the WordPress community is remarkably friendly, open and hospitable. These values are exemplified from the top down and Automattic employees are hand-selected to be a natural fit.  </p>\n<p>Berkun takes quite a bit of time detailing the tools of communication used within the company but reiterates that they were always free to try any tool or method that would help teams work more efficiently.  He found that freedom and trust in the culture encouraged experimentation. </p>\n<blockquote><p>&#8220;Technology does have an impact on behavior, but culture comes first.&#8221;</p></blockquote>\n<p>WordPress.com employees have the freedom to use whatever tools were most efficient for getting things done, regardless of tradition.  This is perhaps one of the most valuable explorations in the book and is especially applicable to any company owner who wants to break out of what they&#8217;ve experienced in modern office culture.</p>\n<p>Berkun has what I like to call &#8220;grandfather glasses&#8221;. He can see the grand picture and knows how to tell a story in a compelling and entertaining way. Ultimately, he arrives at the conclusion that Automattic&#8217;s culture of freedom and trust are restoring meaning to work. This book is not just for WordPress people by any means. <em><a href=\"http://www.amazon.com/The-Year-Without-Pants-WordPress-com/dp/1118660633\" target=\"_blank\">The Year Without Pants</a></em> is for leaders, managers and progressives who are not afraid to break with tradition and experiment with some of the methods that have underscored the success of WordPress.com.  </p>\n<img src=\"http://feeds.feedburner.com/~r/WordpressTavern/~4/Is4z4dknb3M\" height=\"1\" width=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 16 Oct 2013 20:49:01 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:49;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:62:\"WordPress.tv: Lisa Sabin-Wilson: Exploring WordPress Multisite\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=23058\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:79:\"http://wordpress.tv/2013/10/16/lisa-sabin-wilson-exploring-wordpress-multisite/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:680:\"<div id=\"v-WakEP9AH-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/23058/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/23058/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=23058&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/10/16/lisa-sabin-wilson-exploring-wordpress-multisite/\"><img alt=\"Lisa Sabin-Wilson: Exploring WordPress Multisite\" src=\"http://videos.videopress.com/WakEP9AH/video-c4c2130f83_scruberthumbnail_0.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 16 Oct 2013 15:18:56 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";a:9:{s:6:\"server\";s:5:\"nginx\";s:4:\"date\";s:29:\"Fri, 25 Oct 2013 13:31:30 GMT\";s:12:\"content-type\";s:8:\"text/xml\";s:14:\"content-length\";s:6:\"204062\";s:10:\"connection\";s:5:\"close\";s:4:\"vary\";s:15:\"Accept-Encoding\";s:13:\"last-modified\";s:29:\"Fri, 25 Oct 2013 13:15:32 GMT\";s:4:\"x-nc\";s:11:\"HIT lax 249\";s:13:\"accept-ranges\";s:5:\"bytes\";}s:5:\"build\";s:14:\"20130708231016\";}", "no");
INSERT INTO `wp_options` VALUES("4453", "_transient_timeout_dash_aa95765b5cc111c56d5993d476b1c2f0", "1382751090", "no");
INSERT INTO `wp_options` VALUES("4454", "_transient_dash_aa95765b5cc111c56d5993d476b1c2f0", "<div class=\"rss-widget\"><ul><li><a class=\'rsswidget\' href=\'http://feedproxy.google.com/~r/WordpressTavern/~3/l-3I_2jNRJ4/wordpress-3-7-released-wordpress-now-updates-itself\' title=\'WordPress 3.7 has been released and the big news is that WordPress now has the ability to update itself. This begins a new era of automatic background updates for security and minor releases. Web hosts around the world have been eagerly awaiting this release and are cheering its arrival. The upgrade process has been greatly improved and boy is it ever solid: We ended the WordPress 3.7 beta cycle with 112,434 automatic background updates attempted and not a single critical failure. — Andrew Nacin (@nacin) October 25, 2013  Not a single critical failure. Try blaming Nacin for that, folks.  WordPress 3.7 is dubbed Basie, after Count Basie, an American jazz pianist with an unparalleled talent for improvisation. He learned to improvise while playing along to silent films for a local movie theater. Before he was famous, Basie sharpened his improv skills by playing jazz piano at parties and resorts. He went on to create his own jazz orchestra and mentor many other musicians along the way. Count BasieIt seems fitting that this release honors Basie. The web is full of hackers who seek to exploit any vulnerability they can find in WordPress. Users have to be quick to improvise and secure our sites as soon as minor releases are shipped out. Automatic background updates give millions of users the ability to stay current with each security update. The beautiful thing is that it’s totally effortless on the part of the user. On the surface you won’t see too many flashy UI improvements, but under the hood you’ll find a better engine. When you search WordPress you’ll see better and more relevant results. Developers will be happy to find improved support for multisite, advanced date queries and a ton of new functions to play with. You can review every last detail on the dedicated 3.7 release page. wp-admin/about.phpWordPress 3.7 has a beautiful about.php page that you can only see if you upgrade. Hint, hint. It includes a live demo of the new password strength meter that will help you to create stronger passwords. This release also includes better global support for translations, meaning that it will automatically install language files and silently keep them up to date. There’s a trend here: WordPress is doing a lot more for you in the background so that you can focus on creating content. This sets the bar pretty high for what users can expect from their publishing software in the future. Now that WordPress can update itself, I am once again reminded that this software is a living, breathing thing. Andrew Nacin, Dion Hulse and Jon Cave had the help of 211 contributors in shipping 3.7. Hats off to these folks – they’ve worked hard and done well.  Time to celebrate with a few tunes from Count Basie and his jazz orchestra to kick off your upgrades. By the way, if you’re configuring automatic updates for everything, this is the last time you’ll ever have to update WordPress manually.   \'>WPTavern: WordPress 3.7 Released: WordPress Now Updates Itself</a></li><li><a class=\'rsswidget\' href=\'http://wordpress.org/news/2013/10/basie/\' title=\'Version 3.7 of WordPress, named “Basie” in honor of Count Basie, is available for download or update in your WordPress dashboard. This release features some of the most important architectural updates we’ve made to date. Here are the big ones:  Updates while you sleep: With WordPress 3.7, you don’t have to lift a finger to apply maintenance and security updates. Most sites are now able to automatically apply these updates in the background. The update process also has been made even more reliable and secure, with dozens of new checks and safeguards. Stronger password recommendations: Your password is your site’s first line of defense. It’s best to create passwords that are complex, long, and unique. To that end, our password meter has been updated in WordPress 3.7 to recognize common mistakes that can weaken your password: dates, names, keyboard patterns (123456789), and even pop culture references. Better global support: Localized versions of WordPress will receive faster and more complete translations. WordPress 3.7 adds support for automatically installing the right language files and keeping them up to date, a boon for the many millions who use WordPress in a language other than English.  For developers there are lots of options around how to control the new updates feature, including allowing it to handle major upgrades as well as minor ones, more sophisticated date query support, and multisite improvements. As always, if you’re hungry for more dive into the Codex or browse the over 400 closed tickets on Trac. A New Wave This release was led by Andrew Nacin, backed up by Dion Hulse and Jon Cave. This is our first release using the new plugin-first development process, with a much shorter timeframe than in the past. (3.6 was released in August.) The 3.8 release, due in December, will continue this plugin-led development cycle that gives much more autonomy to plugin leads and allows us to decouple feature development from a release. You can follow this grand experiment, and what we’re learning from it, on the make/core blog. There are 211 contributors with props in this release: Aaron Brazell, Aaron D. Campbell, Aaron Holbrook, Aaron Jorbin, adamsilverstein, Alexander Hoereth, Alex Mills (Viper007Bond), Amy Hendrix (sabreuse), andg, Andrew Nacin, Andrew Norcross, Andrew Ozz, Andrew Spittle, askapache, atimmer, Barry, Beau Lebens, ben.moody, Ben Miller, Bernhard Riedl, BFTrick, Billy (bananastalktome), bmb, Brandon Kraft, brianhogg, Brian Richards, Bryan Petty, Carl Danley, CharlesClarkson, Chip Bennett, Chouby, Chris Olbekson, Chris Rudzki, coderaaron, Coen Jacobs, Colin Robinson, cyonite, Daan Kortenbach, Daniel Bachhuber, Daniel Convissor, dartiss, Daryl Koopersmith, Dave Ross, David Laietta, Dion Hulse, dllh, Dominik Schilling (ocean90), dpash, Drew Jaynes, DrProtocols, Dustin Filippini, dzver, Edward Caissie, enej, Eric Andrew Lewis, Eric Mann, Evan Solomon, faishal, Faison, Foofy, Frankie Jarrett, Frank Klein, Gary Cao, Gary Pendergast, Gaya Kessler, George Stephanis, Gizburdt, goldenapples, gradyetc, Gregory Cornelius, Gustavo Bordoni, hakre, Helen Hou-Sandi, Ian Dunn, Ipstenu (Mika Epstein), itinerant, J.D. Grimes, jakub.tyrcha, James Collins, Jen Mylo, Jeremy Buller, Jeremy Felt, Jesper Johansen (jayjdk), Joe Hoyle, Joey Kudish, John Beales, John Blackbourn (johnbillion), John Fish, John James Jacoby, John P. Bloch, Jonas Bolinder (jond3r), Jonathan Christopher, Jonathan Desrosiers, Jon Cave, Jon Lynch, Joost de Valk, Joseph Scott, Josh Betz, Justin de Vesine, Justin Sainton, K.Adam White, Kailey (trepmal), Ketwaroo, kevinB, Kim Parsell, kitchin, Konstantin Kovshenin, Konstantin Obenland, koopersmith, Kurt Payne, Lance Willett, Lee Willis (leewillis77), lessbloat, Lew Ayotte, Luke Gedeon, Marcin Pietrzak, Marco Cimmino, Marco Galasso, Mark Jaquith, Mark McWilliams, Marko Heijnen, Mel Choyce, Michael Beckwith, Mike Hansen, Mike Schinkel, Mike Schroder, Milan Dinic, mitcho (Michael Yoshitaka Erlewine), Mr Papa, Naoko Takano, Naomi, Nashwan Doaqan, NateJacobs, nathanrice, Niall Kennedy, Nick Daugherty, Nick Halsey, Nick Momrik, Nikhil Vimal (NikV), Nikolay Bachiyski, noahsilverstein, nofearinc, nukaga, nullvariable, Oleg Butuzov, Paolo Belcastro, Parham, Paul Biron, Paul de Wouters, pavelevap, peterjaap, Peter Westwood, Philip Arthur Moore, Pippin Williamson, plocha, Pollett, Ptah Dunbar, Rami Yushuvaev, Rasheed Bydousi, RayBernard, rboren, Reuben Gunday, rfair404, Richard Tape, Rick Radko, Robert Chapin, Robert Dall, Rodrigo Primo, Ron Rennick, rpattillo, Ryan Boren, Ryan McCue, Sam Hotchkiss, Scott Reilly, scottsweb, Scott Taylor, scribu, scruffian, Seisuke Kuraishi (tenpura), Sergey Biryukov, ShinichiN, Simon Prosser, Simon Wheatley, Siobhan, Siobhan Bamber (siobhyb), sirzooro, solarissmoke, Stephanie Leary, Stephen Edgar (@netweb), Stephen Harris, strangerstudios, sweetie089, swissspidy, Takayuki Miyauchi, Takuma Morikawa, Taylor Lovett, tivnet, TobiasBg, Tom Auger, toscho, Travis Smith, Ulrich Sossou, vericgar, Vinod Dalvi, Weston Ruter, wikicms, Will Norris, Wojtek Szkutnik, wycks, Yoav Farhi, and Yuri Victor. Enjoy what may be one of your last few manual updates. See you soon for version 3.8!\'>Dev Blog: WordPress 3.7 “Basie”</a></li><li><a class=\'rsswidget\' href=\'http://feedproxy.google.com/~r/WordpressTavern/~3/w5xTWijIX1o/disrupting-the-commercial-theme-market-a-3themes-experiment\' title=\'The questions are simple but the answers are not. Can a theme that is built for developers using best practices be successful in the commercial space? Can a commercial theme add value without adding functionality and bloat? Those are the questions that a trio of WordPress developers are going to try to answer with their 3them.es experiment.  Michelle Schulp of Marktimemedia has published her experience at Pressnomics 2013 and the reasoning behind the new experiment. While at the event, she attended the Commercialization in the WordPress ecosystem panel session featuring business owners Pippin Williamson, Carl Hancock, Cory Miller, and Helen Souness. In that discussion, the following question was asked. How do you build a commercial digital product, especially one built using the GPL, that adds value in a way that is distinguishable from its competitors? According to Michelle, the panel was quick to dismiss commercial themes as being easily commoditized.   After talking with a number of people at the conference, Michelle decided to partner with Kiko Doran, and Josh Broton to start the 3themes experiment. 3themes is a unique collaboration because we will also be documenting it every step of the way: recording our weekly meetings on Google Hangout in the form of a podcast, blogging about our process on the website, hosting code on GitHub, voicing our thoughts on Twitter, etc. We want this not only to be a case study in the commercial theme marketplace, but in working as a small distributed team and problem solving just as we would for a client. The hope is to create some dialogue in the WordPress community, as well as just have some fun and see what great things we can build together. If you’re interested to see where this goes, check out the live Google hangout at 8:30 PM CST on Tuesday nights as they begin the process of experimentation by first building their website and brand.  This is going to be an excellent experiment and I bet many are curious as to what the end result will be. If you remember, Justin Tadlock performed a similar experiment via ThemeForest with mildly successful results.  \'>WPTavern: Disrupting The WordPress Commercial Theme Market – A 3themes Experiment</a></li><li><a class=\'rsswidget\' href=\'http://wordpress.tv/2013/10/24/brian-krogsgard-and-pippin-williamson-wordpress-plugins-code-and-the-ecosystem-in-general/\' title=\'     \'>WordPress.tv: Brian Krogsgard and Pippin Williamson: WordPress Plugins, Code And The Ecosystem In General</a></li><li><a class=\'rsswidget\' href=\'http://feedproxy.google.com/~r/WordpressTavern/~3/o_k5yMGxjF4/add-your-meetup-group-to-the-central-wordpress-account-on-meetup-com\' title=\'If you run a local WordPress meetup, you’re invited to move it under the central WordPress account on meetup.com. Jen Mylo created a form where meetup coordinators can submit their meetup to be included. The awesome benefit is that WordPress will cover the meetup.com dues for your listing.   Jen posted a number of simple guidelines that were created by active meetup group volunteers. Your group will have to fulfill these before submitting to the central account. I won’t list them all here, but this is a summary: Essentially, you can’t use your local meetup to pimp out your business or yourself. Leave Mr. Salesman at home and join a meetup to connect with other WordPress fans. Meetups are for the benefit of the community and polite and respectful behavior is expected. If you organize a meetup that qualifies, use the form to get in touch with Jen Mylo. A some point in the future, meetup group listings will most likely switch over to using SupportPress, as they do for WordCamps. For now, they’ll be consolidating all the meetups on meetup.com. Please note that the meetup interest form is not just for new meetup groups but is also available for existing WordPress meetups that want to transfer the group over to the central account. It’s very cool that WordPress is supporting local meetups by covering their meetup.com dues. Help spread the word to get this information out there to local meetup organizers that you know.  \'>WPTavern: Add Your Meetup Group to the Central WordPress Account on Meetup.com</a></li></ul></div>", "no");
INSERT INTO `wp_options` VALUES("4451", "_transient_timeout_feed_mod_867bd5c64f85878d03a060509cd2f92c", "1382751090", "no");
INSERT INTO `wp_options` VALUES("4452", "_transient_feed_mod_867bd5c64f85878d03a060509cd2f92c", "1382707890", "no");
INSERT INTO `wp_options` VALUES("4135", "_transient_wc_attribute_taxonomies", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("4139", "_wc_session_t6xv9q00nZlUlvPsv5cwsMJE4j2gzxYD", "a:2:{s:6:\"errors\";N;s:8:\"messages\";N;}", "no");
INSERT INTO `wp_options` VALUES("4140", "_wc_session_expires_t6xv9q00nZlUlvPsv5cwsMJE4j2gzxYD", "1382733797", "no");
INSERT INTO `wp_options` VALUES("4187", "_wc_session_expires_eKKWBMdsZY7IJzKzQUolhlg4TjmeEihh", "1382772333", "no");
INSERT INTO `wp_options` VALUES("4188", "_wc_session_XmfeYJRYQj3kxwsGy6hnwCwCMQoP43cY", "a:2:{s:6:\"errors\";N;s:8:\"messages\";N;}", "no");
INSERT INTO `wp_options` VALUES("4189", "_wc_session_expires_XmfeYJRYQj3kxwsGy6hnwCwCMQoP43cY", "1382772498", "no");
INSERT INTO `wp_options` VALUES("4192", "_wc_session_P1RvVsCyx2xnUJxoqi9GFrJh8sbR8ElA", "a:2:{s:6:\"errors\";N;s:8:\"messages\";N;}", "no");
INSERT INTO `wp_options` VALUES("4193", "_wc_session_expires_P1RvVsCyx2xnUJxoqi9GFrJh8sbR8ElA", "1382781585", "no");
INSERT INTO `wp_options` VALUES("4201", "_wc_session_2adTbF2BXi5bdm75oplNagKVmMBOBaXg", "a:20:{s:4:\"cart\";s:6:\"a:0:{}\";s:12:\"coupon_codes\";s:6:\"a:0:{}\";s:14:\"coupon_amounts\";s:6:\"a:0:{}\";s:14:\"shipping_label\";N;s:6:\"errors\";N;s:8:\"messages\";N;s:19:\"cart_contents_total\";i:0;s:20:\"cart_contents_weight\";i:0;s:19:\"cart_contents_count\";i:0;s:17:\"cart_contents_tax\";i:0;s:5:\"total\";i:0;s:8:\"subtotal\";i:0;s:15:\"subtotal_ex_tax\";i:0;s:9:\"tax_total\";i:0;s:14:\"shipping_taxes\";s:6:\"a:0:{}\";s:5:\"taxes\";s:6:\"a:0:{}\";s:13:\"discount_cart\";i:0;s:14:\"discount_total\";i:0;s:14:\"shipping_total\";i:0;s:18:\"shipping_tax_total\";i:0;}", "no");
INSERT INTO `wp_options` VALUES("4196", "_wc_session_6lenLzy0ZkMjWY6c4Z8zK7dUiMkpdGDj", "a:2:{s:6:\"errors\";N;s:8:\"messages\";N;}", "no");
INSERT INTO `wp_options` VALUES("4197", "_wc_session_expires_6lenLzy0ZkMjWY6c4Z8zK7dUiMkpdGDj", "1382786535", "no");
INSERT INTO `wp_options` VALUES("4116", "duplicator_settings", "a:4:{s:7:\"version\";s:5:\"0.4.6\";s:18:\"uninstall_settings\";b:1;s:15:\"uninstall_files\";b:1;s:16:\"uninstall_tables\";b:1;}", "yes");
INSERT INTO `wp_options` VALUES("4117", "duplicator_version_plugin", "0.4.6", "yes");
INSERT INTO `wp_options` VALUES("4118", "duplicator_options", "s:217:\"a:9:{s:6:\"dbhost\";s:9:\"localhost\";s:6:\"dbname\";s:0:\"\";s:6:\"dbuser\";s:0:\"\";s:7:\"url_new\";s:0:\"\";s:8:\"email-me\";s:1:\"0\";s:12:\"email_others\";s:0:\"\";s:10:\"dir_bypass\";s:0:\"\";s:9:\"log_level\";s:1:\"0\";s:8:\"skip_ext\";s:0:\"\";}\";", "yes");
INSERT INTO `wp_options` VALUES("4119", "duplicator_pack_passcount", "1", "yes");
INSERT INTO `wp_options` VALUES("4120", "duplicator_add1_passcount", "1", "yes");
INSERT INTO `wp_options` VALUES("4121", "duplicator_add1_clicked", "0", "yes");
INSERT INTO `wp_options` VALUES("4285", "_wc_session_OReZLOfhj35pWG3mFhSNeawHEa6H2tZf", "a:2:{s:6:\"errors\";N;s:8:\"messages\";N;}", "no");
INSERT INTO `wp_options` VALUES("4274", "_wc_session_LrDOSklISdoLDlgcQU1Z647NJfymSqmj", "a:2:{s:6:\"errors\";N;s:8:\"messages\";N;}", "no");
INSERT INTO `wp_options` VALUES("4275", "_wc_session_expires_LrDOSklISdoLDlgcQU1Z647NJfymSqmj", "1382814444", "no");
INSERT INTO `wp_options` VALUES("4277", "_wc_session_z98OoOQ3h9hLl4z3UIyw38Fvsl8d7wLh", "a:2:{s:6:\"errors\";N;s:8:\"messages\";N;}", "no");
INSERT INTO `wp_options` VALUES("4278", "_wc_session_expires_z98OoOQ3h9hLl4z3UIyw38Fvsl8d7wLh", "1382814452", "no");
INSERT INTO `wp_options` VALUES("4281", "_wc_session_wUcoWf0gI2O4TokKTkDqVYxBb3V791kr", "a:2:{s:6:\"errors\";N;s:8:\"messages\";N;}", "no");
INSERT INTO `wp_options` VALUES("4282", "_wc_session_expires_wUcoWf0gI2O4TokKTkDqVYxBb3V791kr", "1382814452", "no");
INSERT INTO `wp_options` VALUES("4283", "_wc_session_a1wjjW5bDBkVWtfPI68slNP9038xyFlU", "a:2:{s:6:\"errors\";N;s:8:\"messages\";N;}", "no");
INSERT INTO `wp_options` VALUES("4284", "_wc_session_expires_a1wjjW5bDBkVWtfPI68slNP9038xyFlU", "1382814459", "no");
INSERT INTO `wp_options` VALUES("4286", "_wc_session_expires_OReZLOfhj35pWG3mFhSNeawHEa6H2tZf", "1382814465", "no");
INSERT INTO `wp_options` VALUES("4290", "_wc_session_rOPiHL809zAFGYDBYh1wFBISdrhTEXDU", "a:2:{s:6:\"errors\";N;s:8:\"messages\";N;}", "no");
INSERT INTO `wp_options` VALUES("4291", "_wc_session_expires_rOPiHL809zAFGYDBYh1wFBISdrhTEXDU", "1382815033", "no");
INSERT INTO `wp_options` VALUES("4292", "subscription_options", "a:2:{s:10:\"invitation\";s:226:\"Howdy.\r\n\r\nYou recently followed this blog\'s posts. This means you will receive each new post by email.\r\n\r\nTo activate, click confirm below. If you believe this is an error, ignore this message and we\'ll never bother you again.\";s:14:\"comment_follow\";s:239:\"Howdy.\r\n\r\nYou recently followed one of my posts. This means you will receive an email when new comments are posted.\r\n\r\nTo activate, click confirm below. If you believe this is an error, ignore this message and we\'ll never bother you again.\";}", "yes");
INSERT INTO `wp_options` VALUES("4297", "_wc_session_fZAWoiQisS304UCPFmRznfMnhb0tfTyY", "a:2:{s:6:\"errors\";N;s:8:\"messages\";N;}", "no");
INSERT INTO `wp_options` VALUES("4298", "_wc_session_expires_fZAWoiQisS304UCPFmRznfMnhb0tfTyY", "1382815671", "no");
INSERT INTO `wp_options` VALUES("4301", "_wc_session_LS8ppSZ6BgWApjXld3Z1IXhKRbw2ggDo", "a:2:{s:6:\"errors\";N;s:8:\"messages\";N;}", "no");
INSERT INTO `wp_options` VALUES("4302", "_wc_session_expires_LS8ppSZ6BgWApjXld3Z1IXhKRbw2ggDo", "1382815920", "no");
INSERT INTO `wp_options` VALUES("4431", "_wc_session_knMVTtyHygSeHLqu2s2sTT1XBLoFhT57", "a:2:{s:6:\"errors\";N;s:8:\"messages\";N;}", "no");
INSERT INTO `wp_options` VALUES("4432", "_wc_session_expires_knMVTtyHygSeHLqu2s2sTT1XBLoFhT57", "1382880400", "no");
INSERT INTO `wp_options` VALUES("4433", "_wc_session_IWllZir6LZZxmsjLMplIHIsLfoY4wOKh", "a:2:{s:6:\"errors\";N;s:8:\"messages\";N;}", "no");
INSERT INTO `wp_options` VALUES("4434", "_wc_session_expires_IWllZir6LZZxmsjLMplIHIsLfoY4wOKh", "1382880458", "no");
INSERT INTO `wp_options` VALUES("4435", "_wc_session_FzvCAngpEJIRRU9Ac8yii84k3Qet5bSD", "a:2:{s:6:\"errors\";N;s:8:\"messages\";N;}", "no");
INSERT INTO `wp_options` VALUES("4436", "_wc_session_expires_FzvCAngpEJIRRU9Ac8yii84k3Qet5bSD", "1382880677", "no");
INSERT INTO `wp_options` VALUES("4303", "wordpress_api_key", "c9a881ec2147", "yes");
INSERT INTO `wp_options` VALUES("4304", "akismet_discard_month", "true", "yes");
INSERT INTO `wp_options` VALUES("4305", "akismet_show_user_comments_approved", "false", "yes");
INSERT INTO `wp_options` VALUES("4307", "akismet_connectivity_time", "1382643349", "yes");
INSERT INTO `wp_options` VALUES("4337", "_wc_session_lYAlUGU8VoYFUWy9tqs3j9ANYa2ZXMeh", "a:2:{s:6:\"errors\";N;s:8:\"messages\";N;}", "no");
INSERT INTO `wp_options` VALUES("4338", "_wc_session_expires_lYAlUGU8VoYFUWy9tqs3j9ANYa2ZXMeh", "1382822825", "no");
INSERT INTO `wp_options` VALUES("4339", "_wc_session_RKQ2THlUFBgXlDU8pEvZPCWSWUUjSUBp", "a:2:{s:6:\"errors\";N;s:8:\"messages\";N;}", "no");
INSERT INTO `wp_options` VALUES("4340", "_wc_session_expires_RKQ2THlUFBgXlDU8pEvZPCWSWUUjSUBp", "1382822922", "no");
INSERT INTO `wp_options` VALUES("4342", "_wc_session_kK8GmiZPkwlLNwnXchrQ3p5k7ckMmM8k", "a:2:{s:6:\"errors\";N;s:8:\"messages\";N;}", "no");
INSERT INTO `wp_options` VALUES("4343", "_wc_session_expires_kK8GmiZPkwlLNwnXchrQ3p5k7ckMmM8k", "1382823746", "no");
INSERT INTO `wp_options` VALUES("4368", "_wc_session_QJeWSVNbbdXVs5dwYEiRlCluwgQvdg5O", "a:2:{s:6:\"errors\";N;s:8:\"messages\";N;}", "no");
INSERT INTO `wp_options` VALUES("4369", "_wc_session_expires_QJeWSVNbbdXVs5dwYEiRlCluwgQvdg5O", "1382830030", "no");
INSERT INTO `wp_options` VALUES("4374", "_wc_session_tyFCNEewXCDTWaumiLtO0SfYMXkH4qY9", "a:2:{s:6:\"errors\";N;s:8:\"messages\";N;}", "no");
INSERT INTO `wp_options` VALUES("4375", "_wc_session_expires_tyFCNEewXCDTWaumiLtO0SfYMXkH4qY9", "1382830195", "no");
INSERT INTO `wp_options` VALUES("4389", "_wc_session_aH8NwXzR1WtoW62h3ouCts4DxgZ1WfgM", "a:2:{s:6:\"errors\";N;s:8:\"messages\";N;}", "no");
INSERT INTO `wp_options` VALUES("4390", "_wc_session_expires_aH8NwXzR1WtoW62h3ouCts4DxgZ1WfgM", "1382837131", "no");
INSERT INTO `wp_options` VALUES("4391", "_wc_session_3o0lCsMjBOIlTzPgG7WFu5eU673pvALA", "a:2:{s:6:\"errors\";N;s:8:\"messages\";N;}", "no");
INSERT INTO `wp_options` VALUES("4392", "_wc_session_expires_3o0lCsMjBOIlTzPgG7WFu5eU673pvALA", "1382837211", "no");
INSERT INTO `wp_options` VALUES("4395", "_wc_session_YC9uvfhg4bWzL6OytAFP4H9DNDBy6hGD", "a:2:{s:6:\"errors\";N;s:8:\"messages\";N;}", "no");
INSERT INTO `wp_options` VALUES("4396", "_wc_session_expires_YC9uvfhg4bWzL6OytAFP4H9DNDBy6hGD", "1382840715", "no");
INSERT INTO `wp_options` VALUES("4403", "_wc_session_OfLzsuHl78EJT0ieDjQHG17AjRgLGoda", "a:2:{s:6:\"errors\";N;s:8:\"messages\";N;}", "no");
INSERT INTO `wp_options` VALUES("4404", "_wc_session_expires_OfLzsuHl78EJT0ieDjQHG17AjRgLGoda", "1382844382", "no");
INSERT INTO `wp_options` VALUES("4405", "_wc_session_tD8z0qQX9VEolHDCMI8O9LUYeneG4cdI", "a:2:{s:6:\"errors\";N;s:8:\"messages\";N;}", "no");
INSERT INTO `wp_options` VALUES("4406", "_wc_session_expires_tD8z0qQX9VEolHDCMI8O9LUYeneG4cdI", "1382844623", "no");
INSERT INTO `wp_options` VALUES("4407", "_wc_session_6kuBYqFB1t3BqfiYhWS0y9RAdnwFfeXL", "a:2:{s:6:\"errors\";N;s:8:\"messages\";N;}", "no");
INSERT INTO `wp_options` VALUES("4408", "_wc_session_expires_6kuBYqFB1t3BqfiYhWS0y9RAdnwFfeXL", "1382845628", "no");
INSERT INTO `wp_options` VALUES("4413", "_wc_session_UTNTCL9f7wwR3Ze75HZGcvfEOEUPHuvi", "a:2:{s:6:\"errors\";N;s:8:\"messages\";N;}", "no");
INSERT INTO `wp_options` VALUES("4414", "_wc_session_expires_UTNTCL9f7wwR3Ze75HZGcvfEOEUPHuvi", "1382851656", "no");
INSERT INTO `wp_options` VALUES("4415", "_wc_session_gSIIN6Q8eo237XtvI7pl52tAxp2UWaUj", "a:2:{s:6:\"errors\";N;s:8:\"messages\";N;}", "no");
INSERT INTO `wp_options` VALUES("4416", "_wc_session_expires_gSIIN6Q8eo237XtvI7pl52tAxp2UWaUj", "1382851846", "no");
INSERT INTO `wp_options` VALUES("4420", "_wc_session_lPXg4607qweKH5ns1bwvN9Ds6cteRNb8", "a:2:{s:6:\"errors\";N;s:8:\"messages\";N;}", "no");
INSERT INTO `wp_options` VALUES("4421", "_wc_session_expires_lPXg4607qweKH5ns1bwvN9Ds6cteRNb8", "1382861790", "no");
INSERT INTO `wp_options` VALUES("4445", "_transient_timeout_feed_mod_0095f2857e633ab8a1646872b16f15af", "1382751089", "no");
INSERT INTO `wp_options` VALUES("4446", "_transient_feed_mod_0095f2857e633ab8a1646872b16f15af", "1382707889", "no");
INSERT INTO `wp_options` VALUES("4447", "_transient_timeout_dash_20494a3d90a6669585674ed0eb8dcd8f", "1382751089", "no");
INSERT INTO `wp_options` VALUES("4448", "_transient_dash_20494a3d90a6669585674ed0eb8dcd8f", "<p>This dashboard widget queries <a href=\"http://blogsearch.google.com/\">Google Blog Search</a> so that when another blog links to your site it will show up here. It has found no incoming links&hellip; yet. It&#8217;s okay &#8212; there is no rush.</p>\n", "no");
INSERT INTO `wp_options` VALUES("4459", "_transient_timeout_feed_77fa140e07ce53fe8c87136636f83d72", "1382751090", "no");
INSERT INTO `wp_options` VALUES("4460", "_transient_feed_77fa140e07ce53fe8c87136636f83d72", "a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n	\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:72:\"\n		\n		\n		\n		\n		\n		\n				\n\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n\n	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"WordPress Plugins » View: Newest\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:40:\"http://wordpress.org/plugins/browse/new/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"WordPress Plugins » View: Newest\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"en-US\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 25 Oct 2013 13:04:43 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:9:\"generator\";a:1:{i:0;a:5:{s:4:\"data\";s:25:\"http://bbpress.org/?v=1.1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:15:{i:0;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"Content Enhancer\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"http://wordpress.org/plugins/content-enhancer/#post-59181\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 07 Oct 2013 02:16:05 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"59181@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:115:\"This plugin allows you to insert html/javascript code into your post&#039;s content in a variety of different ways.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"gvanto\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"Game Dev Quotes\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"http://wordpress.org/plugins/game-dev-quotes/#post-59736\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 23 Oct 2013 00:09:48 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"59736@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:84:\"Simple shortcodes to style game developer quotes as they are on the developers site.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Tony\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:25:\"Foundation Verify Install\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:66:\"http://wordpress.org/plugins/foundation-verify-install/#post-59734\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 22 Oct 2013 21:11:18 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"59734@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:122:\"This plugin verifies your installed files against a hash to see if any are missing, changed or corrupt. Takes two seconds.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:17:\"foundationdigital\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:73:\"Upcoming Concerts, Sports, and Theater - Content Reader and Ticket Widget\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:84:\"http://wordpress.org/plugins/upcoming-concerts-sports-and-theater-widget/#post-59553\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 17 Oct 2013 16:41:46 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"59553@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:150:\"This plugin finds the artists (bands, singers/songwriters, etc.), sports teams, and theatrical performances in your posts and adds a widget at the end\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"CraigKleila\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"Adfever Monétisation\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:61:\"http://wordpress.org/plugins/adfever-monetisation/#post-59546\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 17 Oct 2013 11:57:40 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"59546@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:75:\"Plugin de monétisation pour les membres de la régie publicitaire AdFever.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:7:\"adfever\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:5;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:44:\"Advanced Custom Fields: Multiple Coordinates\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:84:\"http://wordpress.org/plugins/advanced-custom-fields-multiple-coordinates/#post-59735\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 22 Oct 2013 22:29:43 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"59735@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:90:\"This is an add-on to ACF that adds a field to select multiple Google Map points in a post.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"web111se\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:6;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:37:\"Free SEO Audit Google Speed API Check\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:78:\"http://wordpress.org/plugins/free-seo-audit-google-speed-api-check/#post-59713\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 22 Oct 2013 16:25:16 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"59713@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:144:\"Do a quick audit to check for the necessary elements of SEO. This scores your WordPress site instantly out of 100, check it out completely free!\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"CustomWPNinjas\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:7;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:36:\"IMsupporting Live Chat for WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"http://wordpress.org/plugins/imsupporting/#post-59673\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 21 Oct 2013 09:17:43 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"59673@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"An easy to install live chat plugin for your wordpress site.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:22:\"IMsupporting Live Chat\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:8;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Nano Slider\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:51:\"http://wordpress.org/plugins/nanoslider/#post-59472\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 15 Oct 2013 18:23:49 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"59472@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"image slider to your Wordpress blog\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"nanoslider\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:9;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Name Generator\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"http://wordpress.org/plugins/name-generator/#post-59792\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 23 Oct 2013 22:13:18 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"59792@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:61:\"Create fun random Name Generators for your WordPress website.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"John Regan\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:10;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Just Writing\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"http://wordpress.org/plugins/just-writing/#post-59766\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 23 Oct 2013 12:57:17 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"59766@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:83:\"Adds buttons to the Distraction Free Writing Mode for all kinds of extra functions.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"GregRoss\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:11;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:20:\"Image Gallery Import\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:68:\"http://wordpress.org/plugins/remote-image-gallery-import/#post-59679\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 21 Oct 2013 13:19:50 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"59679@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:95:\"This plugin takes remote page, examines its content and lists all found images for your choice.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:7:\"wptrack\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:12;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:27:\"Image Lazy Load (Unveil.js)\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"http://wordpress.org/plugins/image-lazy-load/#post-59771\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 23 Oct 2013 16:05:56 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"59771@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:86:\"Lazy load content images using the unveil.js jQuery plugin. Improves site performance.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"n7 Studios\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:13;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:17:\"Custom JS and CSS\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:54:\"http://wordpress.org/plugins/custom-js-css/#post-59770\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 23 Oct 2013 16:05:20 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"59770@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:82:\"Allows developers to add CSS and Javascript for inclusion on a WordPress web site.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"n7 Studios\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:14;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:17:\"Wistia Responsive\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"http://wordpress.org/plugins/wistia-responsive/#post-59708\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 22 Oct 2013 14:55:52 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"59708@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"Automatically make your Wistia video embeds responsive!\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:7:\"anderly\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}s:27:\"http://www.w3.org/2005/Atom\";a:1:{s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:3:{s:4:\"href\";s:41:\"http://wordpress.org/plugins/rss/view/new\";s:3:\"rel\";s:4:\"self\";s:4:\"type\";s:19:\"application/rss+xml\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";a:10:{s:6:\"server\";s:5:\"nginx\";s:4:\"date\";s:29:\"Fri, 25 Oct 2013 13:31:30 GMT\";s:12:\"content-type\";s:23:\"text/xml; charset=UTF-8\";s:10:\"connection\";s:5:\"close\";s:4:\"vary\";s:15:\"Accept-Encoding\";s:7:\"expires\";s:29:\"Fri, 25 Oct 2013 13:39:43 GMT\";s:13:\"cache-control\";s:0:\"\";s:6:\"pragma\";s:0:\"\";s:13:\"last-modified\";s:31:\"Fri, 25 Oct 2013 13:04:43 +0000\";s:4:\"x-nc\";s:11:\"HIT lax 249\";}s:5:\"build\";s:14:\"20130708231016\";}", "no");
INSERT INTO `wp_options` VALUES("4108", "_transient_plugin_slugs", "a:16:{i:0;s:19:\"akismet/akismet.php\";i:1;s:25:\"duplicator/duplicator.php\";i:2;s:59:\"genesis-connect-woocommerce/genesis-connect-woocommerce.php\";i:3;s:33:\"genesis-enews-extended/plugin.php\";i:4;s:28:\"genesis-grid-loop/plugin.php\";i:5;s:55:\"genesis-responsive-slider/genesis-responsive-slider.php\";i:6;s:9:\"hello.php\";i:7;s:29:\"image-widget/image-widget.php\";i:8;s:24:\"instapress/instagram.php\";i:9;s:19:\"jetpack/jetpack.php\";i:10;s:47:\"regenerate-thumbnails/regenerate-thumbnails.php\";i:11;s:49:\"responsive-select-menu/responsive-select-menu.php\";i:12;s:43:\"simple-social-icons/simple-social-icons.php\";i:13;s:27:\"woocommerce/woocommerce.php\";i:14;s:41:\"wordpress-importer/wordpress-importer.php\";i:15;s:24:\"wordpress-seo/wp-seo.php\";}", "no");
INSERT INTO `wp_options` VALUES("4107", "_transient_timeout_plugin_slugs", "1382729703", "no");
INSERT INTO `wp_options` VALUES("339", "widget_widget_sp_image", "a:2:{i:4;a:12:{s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:4:\"link\";s:0:\"\";s:10:\"linktarget\";s:5:\"_self\";s:5:\"width\";i:728;s:6:\"height\";i:90;s:4:\"size\";s:4:\"full\";s:5:\"align\";s:4:\"none\";s:3:\"alt\";s:0:\"\";s:8:\"imageurl\";s:61:\"http://healthydoghq.com/wp-content/uploads/2013/09/728x90.png\";s:12:\"aspect_ratio\";d:8.0888888888888885730921174399554729461669921875;s:13:\"attachment_id\";i:21;}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("340", "widget_tag_cloud", "a:3:{i:2;a:2:{s:5:\"title\";s:9:\"Tag Cloud\";s:8:\"taxonomy\";s:8:\"post_tag\";}i:3;a:2:{s:5:\"title\";s:4:\"Tags\";s:8:\"taxonomy\";s:8:\"post_tag\";}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("341", "widget_pages", "a:2:{i:2;a:3:{s:5:\"title\";s:5:\"Pages\";s:6:\"sortby\";s:10:\"post_title\";s:7:\"exclude\";s:0:\"\";}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("4220", "_wc_session_bZEi5FaWFaUdMb30qVllKEnUbVGeIMjJ", "a:2:{s:6:\"errors\";N;s:8:\"messages\";N;}", "no");
INSERT INTO `wp_options` VALUES("399", "_wc_session_expires_1", "1379009942", "yes");
INSERT INTO `wp_options` VALUES("4455", "_transient_timeout_feed_b9388c83948825c1edaef0d856b7b109", "1382751090", "no");
INSERT INTO `wp_options` VALUES("4456", "_transient_feed_b9388c83948825c1edaef0d856b7b109", "a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n	\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:72:\"\n		\n		\n		\n		\n		\n		\n				\n\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n\n	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:39:\"WordPress Plugins » View: Most Popular\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:44:\"http://wordpress.org/plugins/browse/popular/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:39:\"WordPress Plugins » View: Most Popular\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"en-US\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 25 Oct 2013 13:24:21 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:9:\"generator\";a:1:{i:0;a:5:{s:4:\"data\";s:25:\"http://bbpress.org/?v=1.1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:15:{i:0;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Contact Form 7\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:54:\"http://wordpress.org/plugins/contact-form-7/#post-2141\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 02 Aug 2007 12:45:03 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"2141@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:54:\"Just another contact form plugin. Simple but flexible.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"Takayuki Miyoshi\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:19:\"All in One SEO Pack\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"http://wordpress.org/plugins/all-in-one-seo-pack/#post-753\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 30 Mar 2007 20:08:18 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"753@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:126:\"All in One SEO Pack is a WordPress SEO plugin to automatically optimize your Wordpress blog for Search Engines such as Google.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"uberdose\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:19:\"Google XML Sitemaps\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:63:\"http://wordpress.org/plugins/google-sitemap-generator/#post-132\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 09 Mar 2007 22:31:32 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"132@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:105:\"This plugin will generate a special XML sitemap which will help search engines to better index your blog.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"Arnee\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:7:\"Akismet\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:45:\"http://wordpress.org/plugins/akismet/#post-15\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 09 Mar 2007 22:11:30 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"15@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:98:\"Akismet checks your comments against the Akismet web service to see if they look like spam or not.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"WooCommerce - excelling eCommerce\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:52:\"http://wordpress.org/plugins/woocommerce/#post-29860\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 05 Sep 2011 08:13:36 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"29860@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:97:\"WooCommerce is a powerful, extendable eCommerce plugin that helps you sell anything. Beautifully.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"WooThemes\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:5;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"NextGEN Gallery\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"http://wordpress.org/plugins/nextgen-gallery/#post-1169\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 23 Apr 2007 20:08:06 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"1169@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:122:\"The most popular WordPress gallery plugin and one of the most popular plugins of all time with over 7.5 million downloads.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"Alex Rabe\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:6;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:22:\"WordPress SEO by Yoast\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"http://wordpress.org/plugins/wordpress-seo/#post-8321\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 01 Jan 2009 20:34:44 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"8321@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:131:\"Improve your WordPress SEO: Write better content and have a fully optimized WordPress site using the WordPress SEO plugin by Yoast.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Joost de Valk\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:7;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:24:\"Jetpack by WordPress.com\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"http://wordpress.org/plugins/jetpack/#post-23862\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 20 Jan 2011 02:21:38 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"23862@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:104:\"Supercharge your WordPress site with powerful features previously only available to WordPress.com users.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"Tim Moore\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:8;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:18:\"WordPress Importer\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"http://wordpress.org/plugins/wordpress-importer/#post-18101\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 20 May 2010 17:42:45 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"18101@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:101:\"Import posts, pages, comments, custom fields, categories, tags and more from a WordPress export file.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Brian Colinger\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:9;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"WP Super Cache\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:54:\"http://wordpress.org/plugins/wp-super-cache/#post-2572\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 05 Nov 2007 11:40:04 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"2572@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:73:\"A very fast caching engine for WordPress that produces static html files.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"Donncha O Caoimh\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:10;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:19:\"Broken Link Checker\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"http://wordpress.org/plugins/broken-link-checker/#post-2441\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 08 Oct 2007 21:35:04 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"2441@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:131:\"This plugin will check your posts, comments and other content for broken links and missing images, and notify you if any are found.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Janis Elsts\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:11;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:18:\"Wordfence Security\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:50:\"http://wordpress.org/plugins/wordfence/#post-29832\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 04 Sep 2011 03:13:51 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"29832@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:148:\"Wordfence Security is a free enterprise class security plugin that includes a firewall, virus scanning, real-time traffic with geolocation and more.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"Wordfence\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:12;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Contact Form\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"http://wordpress.org/plugins/contact-form-plugin/#post-26890\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 26 May 2011 07:34:58 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"26890@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:43:\"Add Contact Form to your WordPress website.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"bestwebsoft\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:13;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:7:\"Captcha\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"http://wordpress.org/plugins/captcha/#post-26129\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 27 Apr 2011 05:53:50 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"26129@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:79:\"This plugin allows you to implement super security captcha form into web forms.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"bestwebsoft\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:14;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:40:\"Yet Another Related Posts Plugin (YARPP)\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:72:\"http://wordpress.org/plugins/yet-another-related-posts-plugin/#post-2769\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 02 Jan 2008 13:05:03 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"2769@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:122:\"Display a list of related entries on your site and feeds based on a unique algorithm. Now with thumbnail support built-in!\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"mitcho (Michael Yoshitaka Erlewine)\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}s:27:\"http://www.w3.org/2005/Atom\";a:1:{s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:3:{s:4:\"href\";s:45:\"http://wordpress.org/plugins/rss/view/popular\";s:3:\"rel\";s:4:\"self\";s:4:\"type\";s:19:\"application/rss+xml\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";a:10:{s:6:\"server\";s:5:\"nginx\";s:4:\"date\";s:29:\"Fri, 25 Oct 2013 13:31:30 GMT\";s:12:\"content-type\";s:23:\"text/xml; charset=UTF-8\";s:10:\"connection\";s:5:\"close\";s:4:\"vary\";s:15:\"Accept-Encoding\";s:7:\"expires\";s:29:\"Fri, 25 Oct 2013 13:59:21 GMT\";s:13:\"cache-control\";s:0:\"\";s:6:\"pragma\";s:0:\"\";s:13:\"last-modified\";s:31:\"Fri, 25 Oct 2013 13:24:21 +0000\";s:4:\"x-nc\";s:11:\"HIT lax 249\";}s:5:\"build\";s:14:\"20130708231016\";}", "no");
INSERT INTO `wp_options` VALUES("4079", "_site_transient_timeout_browser_d5631f9597daee1932a2825514744c36", "1383158021", "yes");
INSERT INTO `wp_options` VALUES("4080", "_site_transient_browser_d5631f9597daee1932a2825514744c36", "a:9:{s:8:\"platform\";s:9:\"Macintosh\";s:4:\"name\";s:7:\"Firefox\";s:7:\"version\";s:4:\"24.0\";s:10:\"update_url\";s:23:\"http://www.firefox.com/\";s:7:\"img_src\";s:50:\"http://s.wordpress.org/images/browsers/firefox.png\";s:11:\"img_src_ssl\";s:49:\"https://wordpress.org/images/browsers/firefox.png\";s:15:\"current_version\";s:2:\"16\";s:7:\"upgrade\";b:0;s:8:\"insecure\";b:0;}", "yes");
INSERT INTO `wp_options` VALUES("4457", "_transient_timeout_feed_mod_b9388c83948825c1edaef0d856b7b109", "1382751090", "no");
INSERT INTO `wp_options` VALUES("4458", "_transient_feed_mod_b9388c83948825c1edaef0d856b7b109", "1382707890", "no");
INSERT INTO `wp_options` VALUES("323", "genesis-term-meta", "a:4:{i:0;b:0;i:13;a:0:{}i:37;a:0:{}i:1;a:3:{s:8:\"headline\";s:0:\"\";s:10:\"intro_text\";s:0:\"\";s:6:\"layout\";s:0:\"\";}}", "yes");
INSERT INTO `wp_options` VALUES("197", "theme_mods_twentythirteen", "a:1:{s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1378666490;s:4:\"data\";a:3:{s:19:\"wp_inactive_widgets\";a:0:{}s:9:\"sidebar-1\";a:6:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:17:\"recent-comments-2\";i:3;s:10:\"archives-2\";i:4;s:12:\"categories-2\";i:5;s:6:\"meta-2\";}s:9:\"sidebar-2\";a:0:{}}}}", "yes");
INSERT INTO `wp_options` VALUES("147", "current_theme", "Modern Blogger Pro", "yes");
INSERT INTO `wp_options` VALUES("148", "theme_mods_genesis", "a:2:{i:0;b:0;s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1378571676;s:4:\"data\";a:7:{s:19:\"wp_inactive_widgets\";a:0:{}s:12:\"header-right\";a:0:{}s:7:\"sidebar\";a:0:{}s:11:\"sidebar-alt\";N;s:8:\"footer-1\";N;s:8:\"footer-2\";N;s:8:\"footer-3\";N;}}}", "yes");
INSERT INTO `wp_options` VALUES("149", "theme_switched", "", "yes");
INSERT INTO `wp_options` VALUES("150", "genesis-settings", "a:38:{s:13:\"theme_version\";s:5:\"2.0.1\";s:10:\"db_version\";i:2007;s:20:\"update_email_address\";s:0:\"\";s:15:\"style_selection\";s:0:\"\";s:8:\"feed_uri\";s:0:\"\";s:17:\"comments_feed_uri\";s:0:\"\";s:11:\"site_layout\";s:15:\"content-sidebar\";s:10:\"blog_title\";s:5:\"image\";s:10:\"nav_extras\";s:0:\"\";s:21:\"nav_extras_twitter_id\";s:0:\"\";s:23:\"nav_extras_twitter_text\";s:20:\"Follow me on Twitter\";s:15:\"content_archive\";s:4:\"full\";s:21:\"content_archive_limit\";i:630;s:25:\"content_archive_thumbnail\";i:1;s:10:\"image_size\";s:9:\"thumbnail\";s:9:\"posts_nav\";s:9:\"prev-next\";s:8:\"blog_cat\";i:0;s:16:\"blog_cat_exclude\";s:0:\"\";s:12:\"blog_cat_num\";i:5;s:14:\"header_scripts\";s:429:\"<script>\r\n  (function(i,s,o,g,r,a,m){i[\'GoogleAnalyticsObject\']=r;i[r]=i[r]||function(){\r\n  (i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date();a=s.createElement(o),\r\n  m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m)\r\n  })(window,document,\'script\',\'//www.google-analytics.com/analytics.js\',\'ga\');\r\n\r\n  ga(\'create\', \'UA-45087237-1\', \'healthydoghq.com\');\r\n  ga(\'send\', \'pageview\');\r\n\r\n</script>\";s:14:\"footer_scripts\";s:0:\"\";s:21:\"breadcrumb_front_page\";i:0;s:15:\"breadcrumb_home\";i:0;s:17:\"breadcrumb_single\";i:0;s:15:\"breadcrumb_page\";i:0;s:21:\"breadcrumb_posts_page\";i:0;s:18:\"breadcrumb_archive\";i:0;s:14:\"breadcrumb_404\";i:0;s:21:\"breadcrumb_attachment\";i:0;s:14:\"comments_posts\";i:0;s:14:\"comments_pages\";i:0;s:9:\"superfish\";i:0;s:13:\"redirect_feed\";i:0;s:22:\"redirect_comments_feed\";i:0;s:16:\"trackbacks_posts\";i:0;s:16:\"trackbacks_pages\";i:0;s:6:\"update\";i:0;s:12:\"update_email\";i:0;}", "yes");
INSERT INTO `wp_options` VALUES("151", "genesis-seo-settings", "a:30:{s:23:\"append_description_home\";i:1;s:17:\"append_site_title\";i:0;s:12:\"doctitle_sep\";s:3:\"–\";s:20:\"doctitle_seplocation\";s:5:\"right\";s:17:\"semantic_headings\";i:1;s:10:\"home_h1_on\";s:5:\"title\";s:13:\"home_doctitle\";s:0:\"\";s:16:\"home_description\";s:0:\"\";s:13:\"home_keywords\";s:0:\"\";s:12:\"home_noindex\";i:0;s:13:\"home_nofollow\";i:0;s:14:\"home_noarchive\";i:0;s:11:\"home_author\";i:0;s:18:\"canonical_archives\";i:1;s:28:\"head_adjacent_posts_rel_link\";i:0;s:21:\"head_wlwmanifest_link\";i:0;s:14:\"head_shortlink\";i:0;s:19:\"noindex_cat_archive\";i:1;s:19:\"noindex_tag_archive\";i:1;s:22:\"noindex_author_archive\";i:1;s:20:\"noindex_date_archive\";i:1;s:22:\"noindex_search_archive\";i:1;s:21:\"noarchive_cat_archive\";i:0;s:21:\"noarchive_tag_archive\";i:0;s:24:\"noarchive_author_archive\";i:0;s:22:\"noarchive_date_archive\";i:0;s:24:\"noarchive_search_archive\";i:0;s:9:\"noarchive\";i:0;s:5:\"noodp\";i:1;s:6:\"noydir\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("155", "theme_mods_modern-blogger", "a:2:{i:0;b:0;s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1378571683;s:4:\"data\";a:6:{s:19:\"wp_inactive_widgets\";a:6:{i:0;s:10:\"archives-2\";i:1;s:6:\"meta-2\";i:2;s:8:\"search-2\";i:3;s:12:\"categories-2\";i:4;s:14:\"recent-posts-2\";i:5;s:17:\"recent-comments-2\";}s:12:\"header-right\";a:0:{}s:7:\"sidebar\";a:0:{}s:11:\"sidebar-alt\";N;s:6:\"slider\";N;s:8:\"homepage\";N;}}}", "yes");
INSERT INTO `wp_options` VALUES("162", "theme_mods_healthydoghq", "a:4:{i:0;b:0;s:18:\"nav_menu_locations\";a:2:{s:7:\"primary\";i:13;s:9:\"secondary\";i:37;}s:17:\"header_image_data\";a:5:{s:13:\"attachment_id\";i:308;s:3:\"url\";s:60:\"http://healthydoghq.com/wp-content/uploads/2013/10/logo3.png\";s:13:\"thumbnail_url\";s:60:\"http://healthydoghq.com/wp-content/uploads/2013/10/logo3.png\";s:5:\"width\";i:1148;s:6:\"height\";i:183;}s:16:\"header_textcolor\";s:6:\"333333\";}", "yes");
INSERT INTO `wp_options` VALUES("321", "widget_enews-ext", "a:2:{i:2;a:13:{s:5:\"title\";s:26:\"Sign Up for Our Newsletter\";s:4:\"text\";s:0:\"\";s:10:\"after_text\";s:0:\"\";s:2:\"id\";s:0:\"\";s:6:\"action\";s:1:\"#\";s:11:\"email-field\";s:0:\"\";s:11:\"fname-field\";s:0:\"\";s:11:\"lname-field\";s:0:\"\";s:13:\"hidden_fields\";s:0:\"\";s:10:\"fname_text\";s:13:\"First Name...\";s:10:\"lname_text\";s:12:\"Last Name...\";s:10:\"input_text\";s:27:\"Enter your email address...\";s:11:\"button_text\";s:2:\"Go\";}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("205", "recently_activated", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("4533", "_wc_session_ium3yBkLjUN3YGoFbkEsdSSplGSEkDme", "a:2:{s:6:\"errors\";N;s:8:\"messages\";N;}", "no");
INSERT INTO `wp_options` VALUES("4534", "_wc_session_expires_ium3yBkLjUN3YGoFbkEsdSSplGSEkDme", "1382890146", "no");
INSERT INTO `wp_options` VALUES("4549", "_wc_session_expires_tWbmaSaZHWvUXvMHOQVHdOPs5Poqksxn", "1382733180", "no");
INSERT INTO `wp_options` VALUES("210", "genesis-grid", "a:12:{s:12:\"grid_on_home\";i:1;s:16:\"grid_on_category\";i:1;s:11:\"grid_on_tag\";i:1;s:14:\"grid_on_author\";i:1;s:14:\"grid_on_search\";i:1;s:17:\"features_on_front\";s:1:\"5\";s:16:\"teasers_on_front\";s:1:\"0\";s:15:\"features_inside\";s:1:\"5\";s:14:\"teasers_inside\";s:1:\"0\";s:14:\"teaser_columns\";s:1:\"2\";s:18:\"feature_image_size\";s:13:\"grid-featured\";s:17:\"teaser_image_size\";s:6:\"medium\";}", "yes");
INSERT INTO `wp_options` VALUES("212", "genesis_responsive_slider_settings", "a:26:{s:9:\"post_type\";s:4:\"post\";s:10:\"posts_term\";s:0:\"\";s:13:\"exclude_terms\";s:0:\"\";s:15:\"include_exclude\";s:0:\"\";s:7:\"post_id\";s:0:\"\";s:9:\"posts_num\";s:1:\"3\";s:12:\"posts_offset\";s:1:\"0\";s:7:\"orderby\";s:4:\"date\";s:15:\"slideshow_timer\";s:4:\"4000\";s:15:\"slideshow_delay\";s:3:\"800\";s:16:\"slideshow_effect\";s:4:\"fade\";s:15:\"slideshow_width\";s:3:\"900\";s:16:\"slideshow_height\";s:3:\"600\";s:15:\"slideshow_pager\";i:1;s:22:\"slideshow_excerpt_show\";i:1;s:21:\"slideshow_hide_mobile\";i:1;s:25:\"slideshow_excerpt_content\";s:8:\"excerpts\";s:19:\"slideshow_more_text\";s:18:\"[Continue Reading]\";s:31:\"slideshow_excerpt_content_limit\";s:2:\"80\";s:23:\"slideshow_excerpt_width\";s:2:\"80\";s:17:\"location_vertical\";s:6:\"bottom\";s:19:\"location_horizontal\";s:5:\"right\";s:16:\"slideshow_arrows\";i:0;s:20:\"slideshow_title_show\";i:0;s:14:\"slideshow_loop\";i:0;s:17:\"slideshow_no_link\";i:0;}", "yes");
INSERT INTO `wp_options` VALUES("214", "_image_widget_version", "4.0.6", "yes");
INSERT INTO `wp_options` VALUES("870", "_transient_woocommerce_cache_excluded_uris", "a:6:{i:0;s:5:\"/cart\";i:1;s:9:\"/checkout\";i:2;s:11:\"/my-account\";i:3;s:4:\"p=36\";i:4;s:4:\"p=38\";i:5;s:4:\"p=40\";}", "yes");
INSERT INTO `wp_options` VALUES("223", "woocommerce_default_country", "GB", "yes");
INSERT INTO `wp_options` VALUES("224", "woocommerce_currency", "GBP", "yes");
INSERT INTO `wp_options` VALUES("225", "woocommerce_allowed_countries", "all", "yes");
INSERT INTO `wp_options` VALUES("226", "woocommerce_specific_allowed_countries", "", "yes");
INSERT INTO `wp_options` VALUES("227", "woocommerce_demo_store", "no", "yes");
INSERT INTO `wp_options` VALUES("228", "woocommerce_demo_store_notice", "This is a demo store for testing purposes &mdash; no orders shall be fulfilled.", "yes");
INSERT INTO `wp_options` VALUES("229", "woocommerce_enable_coupons", "yes", "yes");
INSERT INTO `wp_options` VALUES("230", "woocommerce_enable_guest_checkout", "yes", "yes");
INSERT INTO `wp_options` VALUES("231", "woocommerce_enable_order_comments", "yes", "yes");
INSERT INTO `wp_options` VALUES("232", "woocommerce_force_ssl_checkout", "no", "yes");
INSERT INTO `wp_options` VALUES("233", "woocommerce_unforce_ssl_checkout", "no", "yes");
INSERT INTO `wp_options` VALUES("234", "woocommerce_enable_signup_and_login_from_checkout", "yes", "yes");
INSERT INTO `wp_options` VALUES("235", "woocommerce_enable_myaccount_registration", "no", "yes");
INSERT INTO `wp_options` VALUES("236", "woocommerce_registration_email_for_username", "no", "yes");
INSERT INTO `wp_options` VALUES("237", "woocommerce_lock_down_admin", "no", "yes");
INSERT INTO `wp_options` VALUES("238", "woocommerce_clear_cart_on_logout", "no", "yes");
INSERT INTO `wp_options` VALUES("239", "woocommerce_allow_customers_to_reorder", "no", "yes");
INSERT INTO `wp_options` VALUES("240", "woocommerce_frontend_css", "yes", "yes");
INSERT INTO `wp_options` VALUES("241", "woocommerce_enable_lightbox", "yes", "yes");
INSERT INTO `wp_options` VALUES("242", "woocommerce_enable_chosen", "yes", "yes");
INSERT INTO `wp_options` VALUES("243", "woocommerce_file_download_method", "force", "yes");
INSERT INTO `wp_options` VALUES("244", "woocommerce_downloads_require_login", "no", "yes");
INSERT INTO `wp_options` VALUES("245", "woocommerce_downloads_grant_access_after_payment", "yes", "yes");
INSERT INTO `wp_options` VALUES("246", "woocommerce_shop_page_id", "34", "yes");
INSERT INTO `wp_options` VALUES("247", "woocommerce_terms_page_id", "", "yes");
INSERT INTO `wp_options` VALUES("248", "woocommerce_cart_page_id", "36", "yes");
INSERT INTO `wp_options` VALUES("249", "woocommerce_checkout_page_id", "38", "yes");
INSERT INTO `wp_options` VALUES("250", "woocommerce_pay_page_id", "47", "yes");
INSERT INTO `wp_options` VALUES("251", "woocommerce_thanks_page_id", "48", "yes");
INSERT INTO `wp_options` VALUES("252", "woocommerce_myaccount_page_id", "40", "yes");
INSERT INTO `wp_options` VALUES("253", "woocommerce_edit_address_page_id", "43", "yes");
INSERT INTO `wp_options` VALUES("254", "woocommerce_view_order_page_id", "44", "yes");
INSERT INTO `wp_options` VALUES("255", "woocommerce_change_password_page_id", "45", "yes");
INSERT INTO `wp_options` VALUES("256", "woocommerce_logout_page_id", "46", "yes");
INSERT INTO `wp_options` VALUES("257", "woocommerce_lost_password_page_id", "42", "yes");
INSERT INTO `wp_options` VALUES("258", "woocommerce_default_catalog_orderby", "title", "yes");
INSERT INTO `wp_options` VALUES("259", "woocommerce_shop_page_display", "", "yes");
INSERT INTO `wp_options` VALUES("260", "woocommerce_category_archive_display", "", "yes");
INSERT INTO `wp_options` VALUES("261", "woocommerce_cart_redirect_after_add", "no", "yes");
INSERT INTO `wp_options` VALUES("262", "woocommerce_enable_ajax_add_to_cart", "yes", "yes");
INSERT INTO `wp_options` VALUES("263", "woocommerce_enable_sku", "yes", "yes");
INSERT INTO `wp_options` VALUES("264", "woocommerce_enable_weight", "yes", "yes");
INSERT INTO `wp_options` VALUES("265", "woocommerce_enable_dimensions", "yes", "yes");
INSERT INTO `wp_options` VALUES("266", "woocommerce_enable_dimension_product_attributes", "yes", "yes");
INSERT INTO `wp_options` VALUES("267", "woocommerce_weight_unit", "kg", "yes");
INSERT INTO `wp_options` VALUES("268", "woocommerce_dimension_unit", "cm", "yes");
INSERT INTO `wp_options` VALUES("269", "woocommerce_enable_review_rating", "yes", "yes");
INSERT INTO `wp_options` VALUES("270", "woocommerce_review_rating_required", "yes", "yes");
INSERT INTO `wp_options` VALUES("271", "woocommerce_review_rating_verification_label", "yes", "yes");
INSERT INTO `wp_options` VALUES("272", "woocommerce_currency_pos", "left", "yes");
INSERT INTO `wp_options` VALUES("273", "woocommerce_price_thousand_sep", ",", "yes");
INSERT INTO `wp_options` VALUES("274", "woocommerce_price_decimal_sep", ".", "yes");
INSERT INTO `wp_options` VALUES("275", "woocommerce_price_num_decimals", "2", "yes");
INSERT INTO `wp_options` VALUES("276", "woocommerce_price_trim_zeros", "yes", "yes");
INSERT INTO `wp_options` VALUES("277", "shop_catalog_image_size", "a:3:{s:5:\"width\";s:3:\"150\";s:6:\"height\";s:3:\"150\";s:4:\"crop\";b:1;}", "yes");
INSERT INTO `wp_options` VALUES("278", "shop_single_image_size", "a:3:{s:5:\"width\";s:3:\"300\";s:6:\"height\";s:3:\"300\";s:4:\"crop\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("279", "shop_thumbnail_image_size", "a:3:{s:5:\"width\";s:2:\"90\";s:6:\"height\";s:2:\"90\";s:4:\"crop\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("280", "woocommerce_manage_stock", "yes", "yes");
INSERT INTO `wp_options` VALUES("281", "woocommerce_hold_stock_minutes", "60", "yes");
INSERT INTO `wp_options` VALUES("282", "woocommerce_notify_low_stock", "yes", "yes");
INSERT INTO `wp_options` VALUES("283", "woocommerce_notify_no_stock", "yes", "yes");
INSERT INTO `wp_options` VALUES("284", "woocommerce_stock_email_recipient", "admin@healthydoghq.com", "yes");
INSERT INTO `wp_options` VALUES("285", "woocommerce_notify_low_stock_amount", "2", "yes");
INSERT INTO `wp_options` VALUES("286", "woocommerce_notify_no_stock_amount", "0", "yes");
INSERT INTO `wp_options` VALUES("287", "woocommerce_hide_out_of_stock_items", "no", "yes");
INSERT INTO `wp_options` VALUES("288", "woocommerce_stock_format", "", "yes");
INSERT INTO `wp_options` VALUES("289", "woocommerce_calc_shipping", "yes", "yes");
INSERT INTO `wp_options` VALUES("290", "woocommerce_enable_shipping_calc", "yes", "yes");
INSERT INTO `wp_options` VALUES("291", "woocommerce_shipping_cost_requires_address", "no", "yes");
INSERT INTO `wp_options` VALUES("292", "woocommerce_shipping_method_format", "", "yes");
INSERT INTO `wp_options` VALUES("293", "woocommerce_ship_to_billing_address_only", "no", "yes");
INSERT INTO `wp_options` VALUES("294", "woocommerce_ship_to_same_address", "yes", "yes");
INSERT INTO `wp_options` VALUES("295", "woocommerce_require_shipping_address", "no", "yes");
INSERT INTO `wp_options` VALUES("296", "woocommerce_calc_taxes", "no", "yes");
INSERT INTO `wp_options` VALUES("297", "woocommerce_prices_include_tax", "no", "yes");
INSERT INTO `wp_options` VALUES("298", "woocommerce_tax_based_on", "shipping", "yes");
INSERT INTO `wp_options` VALUES("299", "woocommerce_default_customer_address", "base", "yes");
INSERT INTO `wp_options` VALUES("300", "woocommerce_shipping_tax_class", "title", "yes");
INSERT INTO `wp_options` VALUES("301", "woocommerce_tax_round_at_subtotal", "no", "yes");
INSERT INTO `wp_options` VALUES("302", "woocommerce_tax_classes", "Reduced Rate\nZero Rate", "yes");
INSERT INTO `wp_options` VALUES("303", "woocommerce_tax_display_cart", "excl", "yes");
INSERT INTO `wp_options` VALUES("304", "woocommerce_email_from_name", "My Blog", "yes");
INSERT INTO `wp_options` VALUES("305", "woocommerce_email_from_address", "admin@healthydoghq.com", "yes");
INSERT INTO `wp_options` VALUES("306", "woocommerce_email_header_image", "", "yes");
INSERT INTO `wp_options` VALUES("307", "woocommerce_email_footer_text", "My Blog - Powered by WooCommerce", "yes");
INSERT INTO `wp_options` VALUES("308", "woocommerce_email_base_color", "#557da1", "yes");
INSERT INTO `wp_options` VALUES("309", "woocommerce_email_background_color", "#f5f5f5", "yes");
INSERT INTO `wp_options` VALUES("310", "woocommerce_email_body_background_color", "#fdfdfd", "yes");
INSERT INTO `wp_options` VALUES("311", "woocommerce_email_text_color", "#505050", "yes");
INSERT INTO `wp_options` VALUES("314", "woocommerce_db_version", "2.0.18", "yes");
INSERT INTO `wp_options` VALUES("313", "_transient_woocommerce_processing_order_count", "0", "yes");
INSERT INTO `wp_options` VALUES("315", "woocommerce_version", "2.0.18", "yes");
INSERT INTO `wp_options` VALUES("4501", "rewrite_rules", "a:136:{s:7:\"shop/?$\";s:27:\"index.php?post_type=product\";s:37:\"shop/feed/(feed|rdf|rss|rss2|atom)/?$\";s:44:\"index.php?post_type=product&feed=$matches[1]\";s:32:\"shop/(feed|rdf|rss|rss2|atom)/?$\";s:44:\"index.php?post_type=product&feed=$matches[1]\";s:24:\"shop/page/([0-9]{1,})/?$\";s:45:\"index.php?post_type=product&paged=$matches[1]\";s:19:\"sitemap_index\\.xml$\";s:19:\"index.php?sitemap=1\";s:31:\"([^/]+?)-sitemap([0-9]+)?\\.xml$\";s:51:\"index.php?sitemap=$matches[1]&sitemap_n=$matches[2]\";s:14:\"sitemap\\.xslt$\";s:16:\"index.php?xslt=1\";s:24:\"([a-z]+)?-?sitemap\\.xsl$\";s:25:\"index.php?xsl=$matches[1]\";s:12:\"portfolio/?$\";s:29:\"index.php?post_type=portfolio\";s:42:\"portfolio/feed/(feed|rdf|rss|rss2|atom)/?$\";s:46:\"index.php?post_type=portfolio&feed=$matches[1]\";s:37:\"portfolio/(feed|rdf|rss|rss2|atom)/?$\";s:46:\"index.php?post_type=portfolio&feed=$matches[1]\";s:29:\"portfolio/page/([0-9]{1,})/?$\";s:47:\"index.php?post_type=portfolio&paged=$matches[1]\";s:47:\"category/(.+?)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:52:\"index.php?category_name=$matches[1]&feed=$matches[2]\";s:42:\"category/(.+?)/(feed|rdf|rss|rss2|atom)/?$\";s:52:\"index.php?category_name=$matches[1]&feed=$matches[2]\";s:35:\"category/(.+?)/page/?([0-9]{1,})/?$\";s:53:\"index.php?category_name=$matches[1]&paged=$matches[2]\";s:32:\"category/(.+?)/wc-api(/(.*))?/?$\";s:54:\"index.php?category_name=$matches[1]&wc-api=$matches[3]\";s:17:\"category/(.+?)/?$\";s:35:\"index.php?category_name=$matches[1]\";s:44:\"tag/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?tag=$matches[1]&feed=$matches[2]\";s:39:\"tag/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?tag=$matches[1]&feed=$matches[2]\";s:32:\"tag/([^/]+)/page/?([0-9]{1,})/?$\";s:43:\"index.php?tag=$matches[1]&paged=$matches[2]\";s:29:\"tag/([^/]+)/wc-api(/(.*))?/?$\";s:44:\"index.php?tag=$matches[1]&wc-api=$matches[3]\";s:14:\"tag/([^/]+)/?$\";s:25:\"index.php?tag=$matches[1]\";s:45:\"type/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?post_format=$matches[1]&feed=$matches[2]\";s:40:\"type/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?post_format=$matches[1]&feed=$matches[2]\";s:33:\"type/([^/]+)/page/?([0-9]{1,})/?$\";s:51:\"index.php?post_format=$matches[1]&paged=$matches[2]\";s:15:\"type/([^/]+)/?$\";s:33:\"index.php?post_format=$matches[1]\";s:55:\"product-category/(.+?)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?product_cat=$matches[1]&feed=$matches[2]\";s:50:\"product-category/(.+?)/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?product_cat=$matches[1]&feed=$matches[2]\";s:43:\"product-category/(.+?)/page/?([0-9]{1,})/?$\";s:51:\"index.php?product_cat=$matches[1]&paged=$matches[2]\";s:25:\"product-category/(.+?)/?$\";s:33:\"index.php?product_cat=$matches[1]\";s:52:\"product-tag/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?product_tag=$matches[1]&feed=$matches[2]\";s:47:\"product-tag/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?product_tag=$matches[1]&feed=$matches[2]\";s:40:\"product-tag/([^/]+)/page/?([0-9]{1,})/?$\";s:51:\"index.php?product_tag=$matches[1]&paged=$matches[2]\";s:22:\"product-tag/([^/]+)/?$\";s:33:\"index.php?product_tag=$matches[1]\";s:35:\"product/[^/]+/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:45:\"product/[^/]+/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:65:\"product/[^/]+/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:60:\"product/[^/]+/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:60:\"product/[^/]+/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:28:\"product/([^/]+)/trackback/?$\";s:34:\"index.php?product=$matches[1]&tb=1\";s:48:\"product/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:46:\"index.php?product=$matches[1]&feed=$matches[2]\";s:43:\"product/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:46:\"index.php?product=$matches[1]&feed=$matches[2]\";s:36:\"product/([^/]+)/page/?([0-9]{1,})/?$\";s:47:\"index.php?product=$matches[1]&paged=$matches[2]\";s:43:\"product/([^/]+)/comment-page-([0-9]{1,})/?$\";s:47:\"index.php?product=$matches[1]&cpage=$matches[2]\";s:33:\"product/([^/]+)/wc-api(/(.*))?/?$\";s:48:\"index.php?product=$matches[1]&wc-api=$matches[3]\";s:39:\"product/[^/]+/([^/]+)/wc-api(/(.*))?/?$\";s:51:\"index.php?attachment=$matches[1]&wc-api=$matches[3]\";s:50:\"product/[^/]+/attachment/([^/]+)/wc-api(/(.*))?/?$\";s:51:\"index.php?attachment=$matches[1]&wc-api=$matches[3]\";s:28:\"product/([^/]+)(/[0-9]+)?/?$\";s:46:\"index.php?product=$matches[1]&page=$matches[2]\";s:24:\"product/[^/]+/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:34:\"product/[^/]+/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:54:\"product/[^/]+/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:49:\"product/[^/]+/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:49:\"product/[^/]+/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:35:\"portfolio/.+?/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:45:\"portfolio/.+?/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:65:\"portfolio/.+?/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:60:\"portfolio/.+?/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:60:\"portfolio/.+?/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:28:\"portfolio/(.+?)/trackback/?$\";s:36:\"index.php?portfolio=$matches[1]&tb=1\";s:48:\"portfolio/(.+?)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:48:\"index.php?portfolio=$matches[1]&feed=$matches[2]\";s:43:\"portfolio/(.+?)/(feed|rdf|rss|rss2|atom)/?$\";s:48:\"index.php?portfolio=$matches[1]&feed=$matches[2]\";s:36:\"portfolio/(.+?)/page/?([0-9]{1,})/?$\";s:49:\"index.php?portfolio=$matches[1]&paged=$matches[2]\";s:43:\"portfolio/(.+?)/comment-page-([0-9]{1,})/?$\";s:49:\"index.php?portfolio=$matches[1]&cpage=$matches[2]\";s:33:\"portfolio/(.+?)/wc-api(/(.*))?/?$\";s:50:\"index.php?portfolio=$matches[1]&wc-api=$matches[3]\";s:39:\"portfolio/.+?/([^/]+)/wc-api(/(.*))?/?$\";s:51:\"index.php?attachment=$matches[1]&wc-api=$matches[3]\";s:50:\"portfolio/.+?/attachment/([^/]+)/wc-api(/(.*))?/?$\";s:51:\"index.php?attachment=$matches[1]&wc-api=$matches[3]\";s:28:\"portfolio/(.+?)(/[0-9]+)?/?$\";s:48:\"index.php?portfolio=$matches[1]&page=$matches[2]\";s:12:\"robots\\.txt$\";s:18:\"index.php?robots=1\";s:48:\".*wp-(atom|rdf|rss|rss2|feed|commentsrss2)\\.php$\";s:18:\"index.php?feed=old\";s:20:\".*wp-app\\.php(/.*)?$\";s:19:\"index.php?error=403\";s:18:\".*wp-register.php$\";s:23:\"index.php?register=true\";s:32:\"feed/(feed|rdf|rss|rss2|atom)/?$\";s:27:\"index.php?&feed=$matches[1]\";s:27:\"(feed|rdf|rss|rss2|atom)/?$\";s:27:\"index.php?&feed=$matches[1]\";s:20:\"page/?([0-9]{1,})/?$\";s:28:\"index.php?&paged=$matches[1]\";s:17:\"wc-api(/(.*))?/?$\";s:29:\"index.php?&wc-api=$matches[2]\";s:41:\"comments/feed/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?&feed=$matches[1]&withcomments=1\";s:36:\"comments/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?&feed=$matches[1]&withcomments=1\";s:26:\"comments/wc-api(/(.*))?/?$\";s:29:\"index.php?&wc-api=$matches[2]\";s:44:\"search/(.+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:40:\"index.php?s=$matches[1]&feed=$matches[2]\";s:39:\"search/(.+)/(feed|rdf|rss|rss2|atom)/?$\";s:40:\"index.php?s=$matches[1]&feed=$matches[2]\";s:32:\"search/(.+)/page/?([0-9]{1,})/?$\";s:41:\"index.php?s=$matches[1]&paged=$matches[2]\";s:29:\"search/(.+)/wc-api(/(.*))?/?$\";s:42:\"index.php?s=$matches[1]&wc-api=$matches[3]\";s:14:\"search/(.+)/?$\";s:23:\"index.php?s=$matches[1]\";s:47:\"author/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?author_name=$matches[1]&feed=$matches[2]\";s:42:\"author/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?author_name=$matches[1]&feed=$matches[2]\";s:35:\"author/([^/]+)/page/?([0-9]{1,})/?$\";s:51:\"index.php?author_name=$matches[1]&paged=$matches[2]\";s:32:\"author/([^/]+)/wc-api(/(.*))?/?$\";s:52:\"index.php?author_name=$matches[1]&wc-api=$matches[3]\";s:17:\"author/([^/]+)/?$\";s:33:\"index.php?author_name=$matches[1]\";s:69:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:80:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&feed=$matches[4]\";s:64:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/(feed|rdf|rss|rss2|atom)/?$\";s:80:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&feed=$matches[4]\";s:57:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/page/?([0-9]{1,})/?$\";s:81:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&paged=$matches[4]\";s:54:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/wc-api(/(.*))?/?$\";s:82:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&wc-api=$matches[5]\";s:39:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/?$\";s:63:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]\";s:56:\"([0-9]{4})/([0-9]{1,2})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:64:\"index.php?year=$matches[1]&monthnum=$matches[2]&feed=$matches[3]\";s:51:\"([0-9]{4})/([0-9]{1,2})/(feed|rdf|rss|rss2|atom)/?$\";s:64:\"index.php?year=$matches[1]&monthnum=$matches[2]&feed=$matches[3]\";s:44:\"([0-9]{4})/([0-9]{1,2})/page/?([0-9]{1,})/?$\";s:65:\"index.php?year=$matches[1]&monthnum=$matches[2]&paged=$matches[3]\";s:41:\"([0-9]{4})/([0-9]{1,2})/wc-api(/(.*))?/?$\";s:66:\"index.php?year=$matches[1]&monthnum=$matches[2]&wc-api=$matches[4]\";s:26:\"([0-9]{4})/([0-9]{1,2})/?$\";s:47:\"index.php?year=$matches[1]&monthnum=$matches[2]\";s:43:\"([0-9]{4})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?year=$matches[1]&feed=$matches[2]\";s:38:\"([0-9]{4})/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?year=$matches[1]&feed=$matches[2]\";s:31:\"([0-9]{4})/page/?([0-9]{1,})/?$\";s:44:\"index.php?year=$matches[1]&paged=$matches[2]\";s:28:\"([0-9]{4})/wc-api(/(.*))?/?$\";s:45:\"index.php?year=$matches[1]&wc-api=$matches[3]\";s:13:\"([0-9]{4})/?$\";s:26:\"index.php?year=$matches[1]\";s:27:\".?.+?/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:37:\".?.+?/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:57:\".?.+?/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\".?.+?/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\".?.+?/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:20:\"(.?.+?)/trackback/?$\";s:35:\"index.php?pagename=$matches[1]&tb=1\";s:40:\"(.?.+?)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:47:\"index.php?pagename=$matches[1]&feed=$matches[2]\";s:35:\"(.?.+?)/(feed|rdf|rss|rss2|atom)/?$\";s:47:\"index.php?pagename=$matches[1]&feed=$matches[2]\";s:28:\"(.?.+?)/page/?([0-9]{1,})/?$\";s:48:\"index.php?pagename=$matches[1]&paged=$matches[2]\";s:35:\"(.?.+?)/comment-page-([0-9]{1,})/?$\";s:48:\"index.php?pagename=$matches[1]&cpage=$matches[2]\";s:25:\"(.?.+?)/wc-api(/(.*))?/?$\";s:49:\"index.php?pagename=$matches[1]&wc-api=$matches[3]\";s:31:\".?.+?/([^/]+)/wc-api(/(.*))?/?$\";s:51:\"index.php?attachment=$matches[1]&wc-api=$matches[3]\";s:42:\".?.+?/attachment/([^/]+)/wc-api(/(.*))?/?$\";s:51:\"index.php?attachment=$matches[1]&wc-api=$matches[3]\";s:20:\"(.?.+?)(/[0-9]+)?/?$\";s:47:\"index.php?pagename=$matches[1]&page=$matches[2]\";s:27:\"[^/]+/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:37:\"[^/]+/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:57:\"[^/]+/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\"[^/]+/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\"[^/]+/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:20:\"([^/]+)/trackback/?$\";s:31:\"index.php?name=$matches[1]&tb=1\";s:40:\"([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?name=$matches[1]&feed=$matches[2]\";s:35:\"([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?name=$matches[1]&feed=$matches[2]\";s:28:\"([^/]+)/page/?([0-9]{1,})/?$\";s:44:\"index.php?name=$matches[1]&paged=$matches[2]\";s:35:\"([^/]+)/comment-page-([0-9]{1,})/?$\";s:44:\"index.php?name=$matches[1]&cpage=$matches[2]\";s:25:\"([^/]+)/wc-api(/(.*))?/?$\";s:45:\"index.php?name=$matches[1]&wc-api=$matches[3]\";s:31:\"[^/]+/([^/]+)/wc-api(/(.*))?/?$\";s:51:\"index.php?attachment=$matches[1]&wc-api=$matches[3]\";s:42:\"[^/]+/attachment/([^/]+)/wc-api(/(.*))?/?$\";s:51:\"index.php?attachment=$matches[1]&wc-api=$matches[3]\";s:20:\"([^/]+)(/[0-9]+)?/?$\";s:43:\"index.php?name=$matches[1]&page=$matches[2]\";s:16:\"[^/]+/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:26:\"[^/]+/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:46:\"[^/]+/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:41:\"[^/]+/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:41:\"[^/]+/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";}", "yes");
INSERT INTO `wp_options` VALUES("4134", "_site_transient_update_plugins", "O:8:\"stdClass\":3:{s:12:\"last_checked\";i:1382714282;s:7:\"checked\";a:16:{s:19:\"akismet/akismet.php\";s:5:\"2.5.9\";s:25:\"duplicator/duplicator.php\";s:5:\"0.4.6\";s:59:\"genesis-connect-woocommerce/genesis-connect-woocommerce.php\";s:5:\"0.9.5\";s:33:\"genesis-enews-extended/plugin.php\";s:5:\"1.3.3\";s:28:\"genesis-grid-loop/plugin.php\";s:3:\"1.1\";s:55:\"genesis-responsive-slider/genesis-responsive-slider.php\";s:5:\"0.9.2\";s:9:\"hello.php\";s:3:\"1.6\";s:29:\"image-widget/image-widget.php\";s:5:\"4.0.8\";s:24:\"instapress/instagram.php\";s:5:\"1.5.3\";s:19:\"jetpack/jetpack.php\";s:3:\"2.5\";s:47:\"regenerate-thumbnails/regenerate-thumbnails.php\";s:5:\"2.2.4\";s:49:\"responsive-select-menu/responsive-select-menu.php\";s:5:\"1.5.2\";s:43:\"simple-social-icons/simple-social-icons.php\";s:5:\"1.0.4\";s:27:\"woocommerce/woocommerce.php\";s:6:\"2.0.18\";s:41:\"wordpress-importer/wordpress-importer.php\";s:5:\"0.6.1\";s:24:\"wordpress-seo/wp-seo.php\";s:6:\"1.4.18\";}s:8:\"response\";a:0:{}}", "yes");
INSERT INTO `wp_options` VALUES("319", "_transient_random_seed", "a942e4399f3bdc814cc48e866f55446b", "yes");
INSERT INTO `wp_options` VALUES("4548", "_wc_session_tWbmaSaZHWvUXvMHOQVHdOPs5Poqksxn", "a:2:{s:6:\"errors\";N;s:8:\"messages\";N;}", "no");
INSERT INTO `wp_options` VALUES("322", "widget_simple-social-icons", "a:2:{i:2;a:23:{s:5:\"title\";s:0:\"\";s:4:\"size\";s:2:\"36\";s:13:\"border_radius\";s:1:\"3\";s:9:\"alignment\";s:9:\"alignleft\";s:10:\"icon_color\";s:7:\"#ffffff\";s:16:\"icon_color_hover\";s:7:\"#ffffff\";s:16:\"background_color\";s:7:\"#999999\";s:22:\"background_color_hover\";s:7:\"#666666\";s:8:\"dribbble\";s:0:\"\";s:5:\"email\";s:0:\"\";s:8:\"facebook\";s:1:\"#\";s:6:\"flickr\";s:0:\"\";s:6:\"github\";s:0:\"\";s:5:\"gplus\";s:0:\"\";s:9:\"instagram\";s:1:\"#\";s:8:\"linkedin\";s:1:\"#\";s:9:\"pinterest\";s:1:\"#\";s:3:\"rss\";s:0:\"\";s:11:\"stumbleupon\";s:0:\"\";s:6:\"tumblr\";s:0:\"\";s:7:\"twitter\";s:1:\"#\";s:5:\"vimeo\";s:0:\"\";s:7:\"youtube\";s:1:\"#\";}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("324", "nav_menu_options", "a:2:{i:0;b:0;s:8:\"auto_add\";a:0:{}}", "yes");
INSERT INTO `wp_options` VALUES("329", "widget_user-profile", "a:2:{i:2;a:8:{s:5:\"title\";s:8:\"About Us\";s:4:\"user\";s:1:\"1\";s:4:\"size\";s:3:\"125\";s:9:\"alignment\";s:5:\"right\";s:11:\"author_info\";s:4:\"text\";s:8:\"bio_text\";s:90:\"Welcome to Modern Blogger Pro! An HTML5, fully responsive WordPress Theme that has it all.\";s:4:\"page\";s:1:\"2\";s:14:\"page_link_text\";s:12:\"Read More…\";}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("330", "widget_featured-post", "a:3:{i:2;a:18:{s:5:\"title\";s:35:\"Welcome to Healthy Dog Headquarters\";s:9:\"posts_cat\";s:2:\"48\";s:9:\"posts_num\";s:1:\"1\";s:12:\"posts_offset\";s:1:\"0\";s:7:\"orderby\";s:4:\"date\";s:5:\"order\";s:4:\"DESC\";s:13:\"gravatar_size\";s:2:\"45\";s:18:\"gravatar_alignment\";s:9:\"alignnone\";s:10:\"show_image\";s:1:\"1\";s:10:\"image_size\";s:15:\"widget-featured\";s:15:\"image_alignment\";s:9:\"alignnone\";s:9:\"post_info\";s:55:\"[post_date] By [post_author_posts_link] [post_comments]\";s:12:\"show_content\";s:7:\"excerpt\";s:13:\"content_limit\";s:3:\"100\";s:9:\"more_text\";s:14:\"[Read More...]\";s:11:\"extra_title\";s:0:\"\";s:9:\"extra_num\";s:0:\"\";s:23:\"more_from_category_text\";s:29:\"More Posts from this Category\";}i:3;a:18:{s:5:\"title\";s:39:\"Golda\'s Story: Saving Our Dog from IMHA\";s:9:\"posts_cat\";s:2:\"50\";s:9:\"posts_num\";s:1:\"1\";s:12:\"posts_offset\";s:1:\"0\";s:7:\"orderby\";s:4:\"date\";s:5:\"order\";s:4:\"DESC\";s:13:\"gravatar_size\";s:2:\"45\";s:18:\"gravatar_alignment\";s:9:\"alignnone\";s:10:\"show_image\";s:1:\"1\";s:10:\"image_size\";s:18:\"portfolio-featured\";s:15:\"image_alignment\";s:9:\"alignnone\";s:9:\"post_info\";s:55:\"[post_date] By [post_author_posts_link] [post_comments]\";s:12:\"show_content\";s:7:\"excerpt\";s:13:\"content_limit\";s:3:\"150\";s:9:\"more_text\";s:14:\"[Read More...]\";s:11:\"extra_title\";s:0:\"\";s:9:\"extra_num\";s:0:\"\";s:23:\"more_from_category_text\";s:29:\"More Posts from this Category\";}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("4527", "_wc_session_NHXfBKhDfj5h45r3dccONpYoLvTcvLNY", "a:20:{s:6:\"errors\";N;s:8:\"messages\";N;s:4:\"cart\";s:6:\"a:0:{}\";s:12:\"coupon_codes\";s:6:\"a:0:{}\";s:14:\"coupon_amounts\";s:6:\"a:0:{}\";s:19:\"cart_contents_total\";i:0;s:20:\"cart_contents_weight\";i:0;s:19:\"cart_contents_count\";i:0;s:17:\"cart_contents_tax\";i:0;s:5:\"total\";i:0;s:8:\"subtotal\";i:0;s:15:\"subtotal_ex_tax\";i:0;s:9:\"tax_total\";i:0;s:14:\"shipping_taxes\";s:6:\"a:0:{}\";s:5:\"taxes\";s:6:\"a:0:{}\";s:13:\"discount_cart\";i:0;s:14:\"discount_total\";i:0;s:14:\"shipping_total\";i:0;s:18:\"shipping_tax_total\";i:0;s:14:\"shipping_label\";N;}", "no");
INSERT INTO `wp_options` VALUES("4149", "_wc_session_nd1Xn60lqpn3zHmecqLWeJvBYqpNneoh", "a:2:{s:6:\"errors\";N;s:8:\"messages\";N;}", "no");
INSERT INTO `wp_options` VALUES("4150", "_wc_session_expires_nd1Xn60lqpn3zHmecqLWeJvBYqpNneoh", "1382736444", "no");
INSERT INTO `wp_options` VALUES("4556", "_transient_timeout_wpcom_subscribers_total", "1382728617", "no");
INSERT INTO `wp_options` VALUES("4557", "_transient_wpcom_subscribers_total", "a:2:{s:6:\"status\";s:7:\"success\";s:5:\"value\";i:0;}", "no");
INSERT INTO `wp_options` VALUES("4168", "_wc_session_9Ls5HKbrirYbKi6QEElXEgnkODbhWJT6", "a:2:{s:6:\"errors\";N;s:8:\"messages\";N;}", "no");
INSERT INTO `wp_options` VALUES("4158", "widget_featured-page", "a:3:{i:2;a:8:{s:5:\"title\";s:35:\"Welcome to Healthy Dog Headquarters\";s:7:\"page_id\";s:3:\"399\";s:10:\"show_image\";s:1:\"1\";s:10:\"image_size\";s:18:\"portfolio-featured\";s:15:\"image_alignment\";s:9:\"alignnone\";s:12:\"show_content\";s:1:\"1\";s:13:\"content_limit\";s:2:\"95\";s:9:\"more_text\";s:12:\"read more...\";}i:3;a:8:{s:5:\"title\";s:35:\"Welcome to Healthy Dog Headquarters\";s:7:\"page_id\";s:3:\"371\";s:10:\"show_image\";s:1:\"1\";s:10:\"image_size\";s:15:\"widget-featured\";s:15:\"image_alignment\";s:9:\"alignnone\";s:12:\"show_content\";s:1:\"1\";s:13:\"content_limit\";s:3:\"200\";s:9:\"more_text\";s:12:\"read more...\";}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("4159", "_wc_session_KYvle3vryoKs2C72oWjwnuMwPNuV3ox3", "a:20:{s:6:\"errors\";N;s:8:\"messages\";N;s:4:\"cart\";s:6:\"a:0:{}\";s:12:\"coupon_codes\";s:6:\"a:0:{}\";s:14:\"coupon_amounts\";s:6:\"a:0:{}\";s:19:\"cart_contents_total\";i:0;s:20:\"cart_contents_weight\";i:0;s:19:\"cart_contents_count\";i:0;s:17:\"cart_contents_tax\";i:0;s:5:\"total\";i:0;s:8:\"subtotal\";i:0;s:15:\"subtotal_ex_tax\";i:0;s:9:\"tax_total\";i:0;s:14:\"shipping_taxes\";s:6:\"a:0:{}\";s:5:\"taxes\";s:6:\"a:0:{}\";s:13:\"discount_cart\";i:0;s:14:\"discount_total\";i:0;s:14:\"shipping_total\";i:0;s:18:\"shipping_tax_total\";i:0;s:14:\"shipping_label\";N;}", "no");
INSERT INTO `wp_options` VALUES("4160", "_wc_session_expires_KYvle3vryoKs2C72oWjwnuMwPNuV3ox3", "1382741208", "no");
INSERT INTO `wp_options` VALUES("4161", "_wc_session_WOrFF5ouLtVGw2WADADQfeKCwABAr3zU", "a:18:{s:4:\"cart\";s:6:\"a:0:{}\";s:12:\"coupon_codes\";s:6:\"a:0:{}\";s:14:\"coupon_amounts\";s:6:\"a:0:{}\";s:19:\"cart_contents_total\";i:0;s:20:\"cart_contents_weight\";i:0;s:19:\"cart_contents_count\";i:0;s:17:\"cart_contents_tax\";i:0;s:5:\"total\";i:0;s:8:\"subtotal\";i:0;s:15:\"subtotal_ex_tax\";i:0;s:9:\"tax_total\";i:0;s:14:\"shipping_taxes\";s:6:\"a:0:{}\";s:5:\"taxes\";s:6:\"a:0:{}\";s:13:\"discount_cart\";i:0;s:14:\"discount_total\";i:0;s:14:\"shipping_total\";i:0;s:18:\"shipping_tax_total\";i:0;s:14:\"shipping_label\";N;}", "no");
INSERT INTO `wp_options` VALUES("4162", "_wc_session_expires_WOrFF5ouLtVGw2WADADQfeKCwABAr3zU", "1382741208", "no");
INSERT INTO `wp_options` VALUES("4165", "_wc_session_uycpa2VnxB80A9ZMNfzrp0MIOhaN3HDm", "a:2:{s:6:\"errors\";N;s:8:\"messages\";N;}", "no");
INSERT INTO `wp_options` VALUES("4166", "_wc_session_expires_uycpa2VnxB80A9ZMNfzrp0MIOhaN3HDm", "1382743608", "no");
INSERT INTO `wp_options` VALUES("2720", "wpseo_permalinks", "a:1:{s:10:\"cleanslugs\";s:2:\"on\";}", "yes");
INSERT INTO `wp_options` VALUES("4500", "db_upgraded", "", "yes");
INSERT INTO `wp_options` VALUES("4503", "can_compress_scripts", "1", "yes");
INSERT INTO `wp_options` VALUES("4504", "_wc_session_HC5UtcNaZhliDQ1Y6BUKchIQeJ2Y5HfJ", "a:2:{s:6:\"errors\";N;s:8:\"messages\";N;}", "no");
INSERT INTO `wp_options` VALUES("4505", "_wc_session_expires_HC5UtcNaZhliDQ1Y6BUKchIQeJ2Y5HfJ", "1382887457", "no");
INSERT INTO `wp_options` VALUES("4506", "_wc_session_hPAsanMUMIbxqQKyvPn3cUrYyA8P7ryZ", "a:2:{s:6:\"errors\";N;s:8:\"messages\";N;}", "no");
INSERT INTO `wp_options` VALUES("4507", "_wc_session_expires_hPAsanMUMIbxqQKyvPn3cUrYyA8P7ryZ", "1382887531", "no");
INSERT INTO `wp_options` VALUES("4530", "_wc_session_expires_fBUboYcdVFwgFAQN4qHY1WUWVOavpc8c", "1382889831", "no");
INSERT INTO `wp_options` VALUES("4359", "category_children", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("885", "product_cat_children", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("886", "product_shipping_class_children", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("889", "widget_genesisresponsiveslider-widget", "a:4:{i:2;a:1:{s:5:\"title\";s:0:\"\";}i:3;a:1:{s:5:\"title\";s:0:\"\";}i:4;a:1:{s:5:\"title\";s:0:\"\";}s:12:\"_multiwidget\";i:0;}", "yes");
INSERT INTO `wp_options` VALUES("890", "widget_nav_menu", "a:2:{i:2;a:2:{s:5:\"title\";s:0:\"\";s:8:\"nav_menu\";i:37;}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("891", "widget_featured-products", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("897", "wpseo", "a:5:{s:20:\"disableadvanced_meta\";s:2:\"on\";s:7:\"version\";s:6:\"1.4.18\";s:11:\"theme_check\";a:1:{s:11:\"description\";b:1;}s:14:\"tracking_popup\";s:4:\"done\";s:11:\"ignore_tour\";s:6:\"ignore\";}", "yes");
INSERT INTO `wp_options` VALUES("898", "wpseo_titles", "a:24:{s:10:\"title-home\";s:42:\"%%sitename%% %%page%% %%sep%% %%sitedesc%%\";s:12:\"title-author\";s:42:\"%%name%%, Author at %%sitename%% %%page%% \";s:13:\"title-archive\";s:38:\"%%date%% %%page%% %%sep%% %%sitename%%\";s:12:\"title-search\";s:63:\"You searched for %%searchphrase%% %%page%% %%sep%% %%sitename%%\";s:9:\"title-404\";s:35:\"Page Not Found %%sep%% %%sitename%%\";s:15:\"noindex-archive\";s:2:\"on\";s:19:\"noindex-post_format\";s:2:\"on\";s:10:\"title-post\";s:39:\"%%title%% %%page%% %%sep%% %%sitename%%\";s:10:\"title-page\";s:39:\"%%title%% %%page%% %%sep%% %%sitename%%\";s:16:\"title-attachment\";s:39:\"%%title%% %%page%% %%sep%% %%sitename%%\";s:13:\"title-product\";s:39:\"%%title%% %%page%% %%sep%% %%sitename%%\";s:23:\"title-ptarchive-product\";s:51:\"%%pt_plural%% Archive %%page%% %%sep%% %%sitename%%\";s:23:\"title-product_variation\";s:39:\"%%title%% %%page%% %%sep%% %%sitename%%\";s:17:\"title-shop_coupon\";s:39:\"%%title%% %%page%% %%sep%% %%sitename%%\";s:15:\"title-portfolio\";s:39:\"%%title%% %%page%% %%sep%% %%sitename%%\";s:25:\"title-ptarchive-portfolio\";s:51:\"%%pt_plural%% Archive %%page%% %%sep%% %%sitename%%\";s:14:\"title-category\";s:53:\"%%term_title%% Archives %%page%% %%sep%% %%sitename%%\";s:14:\"title-post_tag\";s:53:\"%%term_title%% Archives %%page%% %%sep%% %%sitename%%\";s:17:\"title-post_format\";s:53:\"%%term_title%% Archives %%page%% %%sep%% %%sitename%%\";s:18:\"title-product_type\";s:53:\"%%term_title%% Archives %%page%% %%sep%% %%sitename%%\";s:17:\"title-product_cat\";s:53:\"%%term_title%% Archives %%page%% %%sep%% %%sitename%%\";s:17:\"title-product_tag\";s:53:\"%%term_title%% Archives %%page%% %%sep%% %%sitename%%\";s:28:\"title-product_shipping_class\";s:53:\"%%term_title%% Archives %%page%% %%sep%% %%sitename%%\";s:23:\"title-shop_order_status\";s:53:\"%%term_title%% Archives %%page%% %%sep%% %%sitename%%\";}", "yes");
INSERT INTO `wp_options` VALUES("899", "wpseo_xml", "a:2:{s:16:\"enablexmlsitemap\";s:2:\"on\";s:36:\"post_types-attachment-not_in_sitemap\";b:1;}", "yes");
INSERT INTO `wp_options` VALUES("900", "wpseo_social", "a:1:{s:9:\"opengraph\";s:2:\"on\";}", "yes");
INSERT INTO `wp_options` VALUES("901", "wpseo_rss", "a:1:{s:8:\"rssafter\";s:53:\"The post %%POSTLINK%% appeared first on %%BLOGLINK%%.\";}", "yes");
INSERT INTO `wp_options` VALUES("4558", "_wc_session_y0wa5L8pq8aEoirpwnZCngNRXeD3Qjwk", "a:2:{s:6:\"errors\";N;s:8:\"messages\";N;}", "no");
INSERT INTO `wp_options` VALUES("4559", "_wc_session_expires_y0wa5L8pq8aEoirpwnZCngNRXeD3Qjwk", "1382899037", "no");
INSERT INTO `wp_options` VALUES("2127", "stats_cache", "a:2:{s:32:\"ef57d8f4a0357af1b867131e5486ed4b\";a:1:{i:1382707890;a:2:{i:0;a:4:{s:7:\"post_id\";s:3:\"371\";s:10:\"post_title\";s:35:\"Welcome to Healthy Dog Headquarters\";s:14:\"post_permalink\";s:57:\"http://healthydoghq.com/welcome-healthy-dog-headquarters/\";s:5:\"views\";s:1:\"1\";}i:1;a:4:{s:7:\"post_id\";s:1:\"0\";s:10:\"post_title\";s:9:\"Home page\";s:14:\"post_permalink\";s:24:\"http://healthydoghq.com/\";s:5:\"views\";s:1:\"1\";}}}s:32:\"fdfeba5fa96876a68d5f2ff03c96f671\";a:1:{i:1382707890;a:0:{}}}", "yes");
INSERT INTO `wp_options` VALUES("4464", "_transient_dash_de3249c4736ad3bd2cd29147c4a0d43e", "<h4>Most Popular</h4>\n<h5><a href=\'http://wordpress.org/plugins/captcha/\'>Captcha</a></h5>&nbsp;<span>(<a href=\'plugin-install.php?tab=plugin-information&amp;plugin=captcha&amp;_wpnonce=aed756bca1&amp;TB_iframe=true&amp;width=600&amp;height=800\' class=\'thickbox\' title=\'Captcha\'>Install</a>)</span>\n<p>This plugin allows you to implement super security captcha form into web forms.</p>\n<h4>Newest Plugins</h4>\n<h5><a href=\'http://wordpress.org/plugins/name-generator/\'>Name Generator</a></h5>&nbsp;<span>(<a href=\'plugin-install.php?tab=plugin-information&amp;plugin=name-generator&amp;_wpnonce=8984792be8&amp;TB_iframe=true&amp;width=600&amp;height=800\' class=\'thickbox\' title=\'Name Generator\'>Install</a>)</span>\n<p>Create fun random Name Generators for your WordPress website.</p>\n", "no");
INSERT INTO `wp_options` VALUES("4462", "_transient_feed_mod_77fa140e07ce53fe8c87136636f83d72", "1382707890", "no");
INSERT INTO `wp_options` VALUES("4463", "_transient_timeout_dash_de3249c4736ad3bd2cd29147c4a0d43e", "1382751090", "no");
INSERT INTO `wp_options` VALUES("4461", "_transient_timeout_feed_mod_77fa140e07ce53fe8c87136636f83d72", "1382751090", "no");
INSERT INTO `wp_options` VALUES("4147", "_wc_session_FGn1fYfajW7iO1cHGIGPVaNFd4JBl83V", "a:2:{s:6:\"errors\";N;s:8:\"messages\";N;}", "no");
INSERT INTO `wp_options` VALUES("4148", "_wc_session_expires_FGn1fYfajW7iO1cHGIGPVaNFd4JBl83V", "1382736373", "no");
INSERT INTO `wp_options` VALUES("4476", "_wc_session_TIEhVColflFf5dMXCp8CDRYXilx5ytGc", "a:2:{s:6:\"errors\";N;s:8:\"messages\";N;}", "no");
INSERT INTO `wp_options` VALUES("4477", "_wc_session_expires_TIEhVColflFf5dMXCp8CDRYXilx5ytGc", "1382882903", "no");
INSERT INTO `wp_options` VALUES("4439", "_transient_timeout_feed_mod_ac0b00fe65abe10e0c5b588f3ed8c7ca", "1382751089", "no");
INSERT INTO `wp_options` VALUES("4440", "_transient_feed_mod_ac0b00fe65abe10e0c5b588f3ed8c7ca", "1382707889", "no");
INSERT INTO `wp_options` VALUES("4441", "_transient_timeout_dash_4077549d03da2e451c8b5f002294ff51", "1382751089", "no");
INSERT INTO `wp_options` VALUES("4442", "_transient_dash_4077549d03da2e451c8b5f002294ff51", "<div class=\"rss-widget\"><ul><li><a class=\'rsswidget\' href=\'http://wordpress.org/news/2013/10/basie/\' title=\'Version 3.7 of WordPress, named “Basie” in honor of Count Basie, is available for download or update in your WordPress dashboard. This release features some of the most important architectural updates we’ve made to date. Here are the big ones: Updates while you sleep: With WordPress 3.7, you don’t have to lift a finger to […]\'>WordPress 3.7 “Basie”</a> <span class=\"rss-date\">October 24, 2013</span><div class=\'rssSummary\'>Version 3.7 of WordPress, named “Basie” in honor of Count Basie, is available for download or update in your WordPress dashboard. This release features some of the most important architectural updates we’ve made to date. Here are the big ones: Updates while you sleep: With WordPress 3.7, you don’t have to lift a finger to […]</div></li><li><a class=\'rsswidget\' href=\'http://wordpress.org/news/2013/10/wordpress-3-7-release-candidate-2/\' title=\'The second release candidate of WordPress 3.7 is now available for testing! Those of you already testing WordPress 3.7 will be updated automatically to RC2. (Nice.) If you’d like to start testing, there’s no time like the present! Try the WordPress Beta Tester plugin (you’ll want “bleeding edge nightlies”) or download the release candidate here (zip). Please post to the Alpha/Beta […]\'>WordPress 3.7 Release Candidate 2</a> <span class=\"rss-date\">October 23, 2013</span><div class=\'rssSummary\'>The second release candidate of WordPress 3.7 is now available for testing! Those of you already testing WordPress 3.7 will be updated automatically to RC2. (Nice.) If you’d like to start testing, there’s no time like the present! Try the WordPress Beta Tester plugin (you’ll want “bleeding edge nightlies”) or download the release candidate here (zip). Please [&hellip;]</div></li></ul></div>", "no");
INSERT INTO `wp_options` VALUES("4502", "_site_transient_update_core", "O:8:\"stdClass\":4:{s:7:\"updates\";a:1:{i:0;O:8:\"stdClass\":10:{s:8:\"response\";s:6:\"latest\";s:8:\"download\";s:39:\"https://wordpress.org/wordpress-3.7.zip\";s:6:\"locale\";s:5:\"en_US\";s:8:\"packages\";O:8:\"stdClass\":5:{s:4:\"full\";s:39:\"https://wordpress.org/wordpress-3.7.zip\";s:10:\"no_content\";s:50:\"https://wordpress.org/wordpress-3.7-no-content.zip\";s:11:\"new_bundled\";s:51:\"https://wordpress.org/wordpress-3.7-new-bundled.zip\";s:7:\"partial\";b:0;s:8:\"rollback\";b:0;}s:7:\"current\";s:3:\"3.7\";s:7:\"version\";s:3:\"3.7\";s:11:\"php_version\";s:5:\"5.2.4\";s:13:\"mysql_version\";s:3:\"5.0\";s:11:\"new_bundled\";s:3:\"3.6\";s:15:\"partial_version\";s:0:\"\";}}s:12:\"last_checked\";i:1382727627;s:15:\"version_checked\";s:3:\"3.7\";s:12:\"translations\";a:0:{}}", "yes");
INSERT INTO `wp_options` VALUES("4528", "_wc_session_expires_NHXfBKhDfj5h45r3dccONpYoLvTcvLNY", "1382889830", "no");
INSERT INTO `wp_options` VALUES("4529", "_wc_session_fBUboYcdVFwgFAQN4qHY1WUWVOavpc8c", "a:18:{s:4:\"cart\";s:6:\"a:0:{}\";s:12:\"coupon_codes\";s:6:\"a:0:{}\";s:14:\"coupon_amounts\";s:6:\"a:0:{}\";s:19:\"cart_contents_total\";i:0;s:20:\"cart_contents_weight\";i:0;s:19:\"cart_contents_count\";i:0;s:17:\"cart_contents_tax\";i:0;s:5:\"total\";i:0;s:8:\"subtotal\";i:0;s:15:\"subtotal_ex_tax\";i:0;s:9:\"tax_total\";i:0;s:14:\"shipping_taxes\";s:6:\"a:0:{}\";s:5:\"taxes\";s:6:\"a:0:{}\";s:13:\"discount_cart\";i:0;s:14:\"discount_total\";i:0;s:14:\"shipping_total\";i:0;s:18:\"shipping_tax_total\";i:0;s:14:\"shipping_label\";N;}", "no");
INSERT INTO `wp_options` VALUES("4475", "_transient_wc_uf_pid_98445f98e21fece4c092bccf3dc7ac25", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("4240", "_wc_session_I2y3hgRpjR3pQ4gfGQdYHcttJkcuMV2E", "a:2:{s:6:\"errors\";N;s:8:\"messages\";N;}", "no");
INSERT INTO `wp_options` VALUES("4241", "_wc_session_expires_I2y3hgRpjR3pQ4gfGQdYHcttJkcuMV2E", "1382811353", "no");
INSERT INTO `wp_options` VALUES("4237", "_wc_session_aCuWndKuk9TVrgVXJnvdn2F18Rk5vWd8", "a:2:{s:6:\"errors\";N;s:8:\"messages\";N;}", "no");
INSERT INTO `wp_options` VALUES("4238", "_wc_session_expires_aCuWndKuk9TVrgVXJnvdn2F18Rk5vWd8", "1382808492", "no");
INSERT INTO `wp_options` VALUES("4235", "_wc_session_Eoj77umP2DlnABSLlQZWC3cjGo1LuZEa", "a:2:{s:6:\"errors\";N;s:8:\"messages\";N;}", "no");
INSERT INTO `wp_options` VALUES("4236", "_wc_session_expires_Eoj77umP2DlnABSLlQZWC3cjGo1LuZEa", "1382808464", "no");
INSERT INTO `wp_options` VALUES("4226", "_wc_session_expires_URFJbmsqLyQnfF13yHh9n9WgvIxCQ9AT", "1382802518", "no");
INSERT INTO `wp_options` VALUES("4215", "wpseo_taxonomy_meta", "a:1:{s:8:\"category\";a:1:{i:1;a:2:{s:13:\"wpseo_noindex\";s:5:\"index\";s:21:\"wpseo_sitemap_include\";s:6:\"always\";}}}", "yes");
INSERT INTO `wp_options` VALUES("4221", "_wc_session_expires_bZEi5FaWFaUdMb30qVllKEnUbVGeIMjJ", "1382801042", "no");
INSERT INTO `wp_options` VALUES("4222", "_wc_session_pE029warrGOsikggynPNWaDhOPgNOySq", "a:2:{s:6:\"errors\";N;s:8:\"messages\";N;}", "no");
INSERT INTO `wp_options` VALUES("4223", "_wc_session_expires_pE029warrGOsikggynPNWaDhOPgNOySq", "1382801156", "no");
INSERT INTO `wp_options` VALUES("4225", "_wc_session_URFJbmsqLyQnfF13yHh9n9WgvIxCQ9AT", "a:2:{s:6:\"errors\";N;s:8:\"messages\";N;}", "no");
INSERT INTO `wp_options` VALUES("4202", "_wc_session_expires_2adTbF2BXi5bdm75oplNagKVmMBOBaXg", "1382793982", "no");
INSERT INTO `wp_options` VALUES("4203", "_wc_session_xTIAVXXHJU2kLzvjTM7s9ND4MsyCYbQH", "a:2:{s:6:\"errors\";N;s:8:\"messages\";N;}", "no");
INSERT INTO `wp_options` VALUES("4204", "_wc_session_expires_xTIAVXXHJU2kLzvjTM7s9ND4MsyCYbQH", "1382794098", "no");
INSERT INTO `wp_options` VALUES("4205", "_wc_session_viUB079xhgLDhKlGq1fiCUMCVZEZOI1w", "a:2:{s:6:\"errors\";N;s:8:\"messages\";N;}", "no");
INSERT INTO `wp_options` VALUES("4206", "_wc_session_expires_viUB079xhgLDhKlGq1fiCUMCVZEZOI1w", "1382794435", "no");
INSERT INTO `wp_options` VALUES("4169", "_wc_session_expires_9Ls5HKbrirYbKi6QEElXEgnkODbhWJT6", "1382743664", "no");
INSERT INTO `wp_options` VALUES("4173", "_wc_session_2mKviBgAN1Y0I31Z6kzCOs9r6ELy5Pnu", "a:2:{s:6:\"errors\";N;s:8:\"messages\";N;}", "no");
INSERT INTO `wp_options` VALUES("4174", "_wc_session_expires_2mKviBgAN1Y0I31Z6kzCOs9r6ELy5Pnu", "1382750821", "no");
INSERT INTO `wp_options` VALUES("4175", "_wc_session_1yA9iWRqsuCUkStcJHMY5ZwPJj7a6Bwf", "a:2:{s:6:\"errors\";N;s:8:\"messages\";N;}", "no");
INSERT INTO `wp_options` VALUES("4176", "_wc_session_expires_1yA9iWRqsuCUkStcJHMY5ZwPJj7a6Bwf", "1382750866", "no");
INSERT INTO `wp_options` VALUES("4186", "_wc_session_eKKWBMdsZY7IJzKzQUolhlg4TjmeEihh", "a:2:{s:6:\"errors\";N;s:8:\"messages\";N;}", "no");
INSERT INTO `wp_options` VALUES("4443", "_transient_timeout_feed_0095f2857e633ab8a1646872b16f15af", "1382751089", "no");
INSERT INTO `wp_options` VALUES("4444", "_transient_feed_0095f2857e633ab8a1646872b16f15af", "a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:4:\"\n  \n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:33:\"\n    \n    \n    \n    \n    \n    \n  \";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:3:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:50:\"link:http://healthydoghq.com/ - Google Blog Search\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:87:\"http://www.google.com/search?ie=utf-8&q=link:http://healthydoghq.com/&tbm=blg&tbs=sbd:1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:81:\"Your search - <b>link:http://healthydoghq.com/</b> - did not match any documents.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://a9.com/-/spec/opensearch/1.1/\";a:3:{s:12:\"totalResults\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:10:\"startIndex\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:12:\"itemsPerPage\";a:1:{i:0;a:5:{s:4:\"data\";s:2:\"10\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";a:10:{s:12:\"content-type\";s:28:\"text/xml; charset=ISO-8859-1\";s:4:\"date\";s:29:\"Fri, 25 Oct 2013 13:31:29 GMT\";s:7:\"expires\";s:2:\"-1\";s:13:\"cache-control\";s:18:\"private, max-age=0\";s:10:\"set-cookie\";a:2:{i:0;s:143:\"PREF=ID=312bedd508fc760a:FF=0:TM=1382707889:LM=1382707889:S=6Y90Gz3VJTOGAM86; expires=Sun, 25-Oct-2015 13:31:29 GMT; path=/; domain=.google.com\";i:1;s:212:\"NID=67=u2BGLwFXMUqDkD4LuWWZDl7G6Ir844LOgYl-XT1ezl6vSeggUxHCB3pszFj0K2F9fV6PBDyMnO5BdsE5DwPOwRsycuzct3VBh-sJJdUM4QqOeWPyzGHc14W5oBiUOaPj; expires=Sat, 26-Apr-2014 13:31:29 GMT; path=/; domain=.google.com; HttpOnly\";}s:3:\"p3p\";s:122:\"CP=\"This is not a P3P policy! See http://www.google.com/support/accounts/bin/answer.py?hl=en&answer=151657 for more info.\"\";s:6:\"server\";s:3:\"gws\";s:16:\"x-xss-protection\";s:13:\"1; mode=block\";s:15:\"x-frame-options\";s:10:\"SAMEORIGIN\";s:18:\"alternate-protocol\";s:7:\"80:quic\";}s:5:\"build\";s:14:\"20130708231016\";}", "no");
INSERT INTO `wp_options` VALUES("2044", "jetpack_activated", "1", "yes");
INSERT INTO `wp_options` VALUES("2045", "jetpack_options", "a:9:{s:7:\"version\";s:14:\"2.5:1380668563\";s:11:\"old_version\";s:14:\"2.5:1380668563\";s:28:\"fallback_no_verify_ssl_certs\";i:0;s:9:\"time_diff\";i:0;s:2:\"id\";i:58676115;s:10:\"blog_token\";s:65:\"L1ZMcGR!R4OWM*9bn$7$#NNdTz62b)(u.mTSj(2BRW#Qylt7qT0V*I4$pZ*BTmLeN\";s:6:\"public\";i:1;s:11:\"user_tokens\";a:1:{i:1;s:67:\"&blDFlF$RWlSNrR@MxS!^n2%$hwLtdE!.QFq$QbWWf2h#R$00%J@)yF6g*GA!fyFN.1\";}s:11:\"master_user\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("2047", "jetpack_log", "a:2:{i:0;a:4:{s:4:\"time\";i:1380668568;s:7:\"user_id\";i:1;s:7:\"blog_id\";b:0;s:4:\"code\";s:8:\"register\";}i:1;a:4:{s:4:\"time\";i:1380668621;s:7:\"user_id\";i:1;s:7:\"blog_id\";i:58676115;s:4:\"code\";s:9:\"authorize\";}}", "no");
INSERT INTO `wp_options` VALUES("4479", "_transient_timeout_jetpack_https_test", "1382798959", "no");
INSERT INTO `wp_options` VALUES("4480", "_transient_jetpack_https_test", "1", "no");
INSERT INTO `wp_options` VALUES("2053", "jetpack_active_modules", "a:21:{i:0;s:10:\"vaultpress\";i:1;s:10:\"shortlinks\";i:3;s:7:\"widgets\";i:5;s:17:\"widget-visibility\";i:7;s:10:\"custom-css\";i:9;s:16:\"gplus-authorship\";i:11;s:11:\"mobile-push\";i:13;s:5:\"latex\";i:15;s:10:\"omnisearch\";i:17;s:19:\"gravatar-hovercards\";i:19;s:9:\"publicize\";i:21;s:13:\"subscriptions\";i:23;s:12:\"contact-form\";i:25;s:5:\"stats\";i:27;s:21:\"enhanced-distribution\";i:29;s:18:\"after-the-deadline\";i:31;s:8:\"json-api\";i:33;s:10:\"shortcodes\";i:35;s:13:\"post-by-email\";i:37;s:5:\"notes\";i:39;s:10:\"sharedaddy\";}", "yes");
INSERT INTO `wp_options` VALUES("2055", "stats_options", "a:7:{s:9:\"admin_bar\";b:1;s:5:\"roles\";a:1:{i:0;s:13:\"administrator\";}s:11:\"count_roles\";a:0:{}s:7:\"blog_id\";i:58676115;s:12:\"do_not_track\";b:1;s:10:\"hide_smile\";b:0;s:7:\"version\";s:1:\"9\";}", "yes");
INSERT INTO `wp_options` VALUES("2056", "safecss_rev", "69", "yes");
INSERT INTO `wp_options` VALUES("2057", "sharing-options", "a:1:{s:6:\"global\";a:5:{s:12:\"button_style\";s:9:\"icon-text\";s:13:\"sharing_label\";s:11:\"Share this:\";s:10:\"open_links\";s:4:\"same\";s:4:\"show\";a:0:{}s:6:\"custom\";a:0:{}}}", "yes");
INSERT INTO `wp_options` VALUES("2058", "safecss_revision_migrated", "1380668739", "yes");

/* INSERT TABLE DATA: wp_postmeta */
INSERT INTO `wp_postmeta` VALUES("1", "2", "_wp_page_template", "default");
INSERT INTO `wp_postmeta` VALUES("1304", "381", "_yoast_wpseo_sitemap-include", "-");
INSERT INTO `wp_postmeta` VALUES("1303", "381", "_yoast_wpseo_meta-robots-adv", "none");
INSERT INTO `wp_postmeta` VALUES("1302", "381", "_yoast_wpseo_meta-robots-nofollow", "0");
INSERT INTO `wp_postmeta` VALUES("1301", "381", "_yoast_wpseo_meta-robots-noindex", "0");
INSERT INTO `wp_postmeta` VALUES("1300", "381", "_yoast_wpseo_metadesc", "");
INSERT INTO `wp_postmeta` VALUES("17", "2", "_edit_lock", "1382566540:1");
INSERT INTO `wp_postmeta` VALUES("18", "2", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("1376", "399", "_yoast_wpseo_sitemap-html-include", "-");
INSERT INTO `wp_postmeta` VALUES("24", "10", "_edit_lock", "1380912058:1");
INSERT INTO `wp_postmeta` VALUES("23", "10", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("27", "12", "_wp_attached_file", "2013/09/featured-300x200.png");
INSERT INTO `wp_postmeta` VALUES("28", "12", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:300;s:6:\"height\";i:200;s:4:\"file\";s:28:\"2013/09/featured-300x200.png\";s:5:\"sizes\";a:4:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:28:\"featured-300x200-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:15:\"header-featured\";a:4:{s:4:\"file\";s:27:\"featured-300x200-300x80.png\";s:5:\"width\";i:300;s:6:\"height\";i:80;s:9:\"mime-type\";s:9:\"image/png\";}s:14:\"shop_thumbnail\";a:4:{s:4:\"file\";s:26:\"featured-300x200-90x90.png\";s:5:\"width\";i:90;s:6:\"height\";i:90;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"shop_catalog\";a:4:{s:4:\"file\";s:28:\"featured-300x200-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("29", "13", "_wp_attached_file", "2013/09/POST-1024x682.png");
INSERT INTO `wp_postmeta` VALUES("30", "13", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1024;s:6:\"height\";i:682;s:4:\"file\";s:25:\"2013/09/POST-1024x682.png\";s:5:\"sizes\";a:11:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:25:\"POST-1024x682-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:6:\"medium\";a:4:{s:4:\"file\";s:25:\"POST-1024x682-300x199.png\";s:5:\"width\";i:300;s:6:\"height\";i:199;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"home-featured\";a:4:{s:4:\"file\";s:25:\"POST-1024x682-700x400.png\";s:5:\"width\";i:700;s:6:\"height\";i:400;s:9:\"mime-type\";s:9:\"image/png\";}s:15:\"widget-featured\";a:4:{s:4:\"file\";s:25:\"POST-1024x682-300x200.png\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:9:\"image/png\";}s:15:\"header-featured\";a:4:{s:4:\"file\";s:24:\"POST-1024x682-640x80.png\";s:5:\"width\";i:640;s:6:\"height\";i:80;s:9:\"mime-type\";s:9:\"image/png\";}s:18:\"portfolio-featured\";a:4:{s:4:\"file\";s:25:\"POST-1024x682-300x200.png\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"grid-featured\";a:4:{s:4:\"file\";s:25:\"POST-1024x682-320x200.png\";s:5:\"width\";i:320;s:6:\"height\";i:200;s:9:\"mime-type\";s:9:\"image/png\";}s:6:\"slider\";a:4:{s:4:\"file\";s:25:\"POST-1024x682-920x400.png\";s:5:\"width\";i:920;s:6:\"height\";i:400;s:9:\"mime-type\";s:9:\"image/png\";}s:14:\"shop_thumbnail\";a:4:{s:4:\"file\";s:23:\"POST-1024x682-90x90.png\";s:5:\"width\";i:90;s:6:\"height\";i:90;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"shop_catalog\";a:4:{s:4:\"file\";s:25:\"POST-1024x682-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:11:\"shop_single\";a:4:{s:4:\"file\";s:25:\"POST-1024x682-300x300.png\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1375", "399", "_yoast_wpseo_sitemap-prio", "-");
INSERT INTO `wp_postmeta` VALUES("967", "10", "_thumbnail_id", "12");
INSERT INTO `wp_postmeta` VALUES("969", "244", "_edit_lock", "1380912182:1");
INSERT INTO `wp_postmeta` VALUES("43", "19", "_wp_attached_file", "2013/09/ad-space-300x100.png");
INSERT INTO `wp_postmeta` VALUES("44", "19", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:300;s:6:\"height\";i:100;s:4:\"file\";s:28:\"2013/09/ad-space-300x100.png\";s:5:\"sizes\";a:4:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:28:\"ad-space-300x100-150x100.png\";s:5:\"width\";i:150;s:6:\"height\";i:100;s:9:\"mime-type\";s:9:\"image/png\";}s:15:\"header-featured\";a:4:{s:4:\"file\";s:27:\"ad-space-300x100-300x80.png\";s:5:\"width\";i:300;s:6:\"height\";i:80;s:9:\"mime-type\";s:9:\"image/png\";}s:14:\"shop_thumbnail\";a:4:{s:4:\"file\";s:26:\"ad-space-300x100-90x90.png\";s:5:\"width\";i:90;s:6:\"height\";i:90;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"shop_catalog\";a:4:{s:4:\"file\";s:28:\"ad-space-300x100-150x100.png\";s:5:\"width\";i:150;s:6:\"height\";i:100;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("45", "20", "_wp_attached_file", "2013/09/ad-space-300x250.png");
INSERT INTO `wp_postmeta` VALUES("46", "20", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:300;s:6:\"height\";i:250;s:4:\"file\";s:28:\"2013/09/ad-space-300x250.png\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:28:\"ad-space-300x250-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:15:\"widget-featured\";a:4:{s:4:\"file\";s:28:\"ad-space-300x250-300x200.png\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:9:\"image/png\";}s:15:\"header-featured\";a:4:{s:4:\"file\";s:27:\"ad-space-300x250-300x80.png\";s:5:\"width\";i:300;s:6:\"height\";i:80;s:9:\"mime-type\";s:9:\"image/png\";}s:18:\"portfolio-featured\";a:4:{s:4:\"file\";s:28:\"ad-space-300x250-300x200.png\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"grid-featured\";a:4:{s:4:\"file\";s:28:\"ad-space-300x250-300x200.png\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:9:\"image/png\";}s:14:\"shop_thumbnail\";a:4:{s:4:\"file\";s:26:\"ad-space-300x250-90x90.png\";s:5:\"width\";i:90;s:6:\"height\";i:90;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"shop_catalog\";a:4:{s:4:\"file\";s:28:\"ad-space-300x250-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("47", "21", "_wp_attached_file", "2013/09/728x90.png");
INSERT INTO `wp_postmeta` VALUES("48", "21", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:728;s:6:\"height\";i:90;s:4:\"file\";s:18:\"2013/09/728x90.png\";s:5:\"sizes\";a:10:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:17:\"728x90-150x90.png\";s:5:\"width\";i:150;s:6:\"height\";i:90;s:9:\"mime-type\";s:9:\"image/png\";}s:6:\"medium\";a:4:{s:4:\"file\";s:17:\"728x90-300x37.png\";s:5:\"width\";i:300;s:6:\"height\";i:37;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"home-featured\";a:4:{s:4:\"file\";s:17:\"728x90-700x90.png\";s:5:\"width\";i:700;s:6:\"height\";i:90;s:9:\"mime-type\";s:9:\"image/png\";}s:15:\"widget-featured\";a:4:{s:4:\"file\";s:17:\"728x90-300x90.png\";s:5:\"width\";i:300;s:6:\"height\";i:90;s:9:\"mime-type\";s:9:\"image/png\";}s:15:\"header-featured\";a:4:{s:4:\"file\";s:17:\"728x90-640x80.png\";s:5:\"width\";i:640;s:6:\"height\";i:80;s:9:\"mime-type\";s:9:\"image/png\";}s:18:\"portfolio-featured\";a:4:{s:4:\"file\";s:17:\"728x90-300x90.png\";s:5:\"width\";i:300;s:6:\"height\";i:90;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"grid-featured\";a:4:{s:4:\"file\";s:17:\"728x90-320x90.png\";s:5:\"width\";i:320;s:6:\"height\";i:90;s:9:\"mime-type\";s:9:\"image/png\";}s:14:\"shop_thumbnail\";a:4:{s:4:\"file\";s:16:\"728x90-90x90.png\";s:5:\"width\";i:90;s:6:\"height\";i:90;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"shop_catalog\";a:4:{s:4:\"file\";s:17:\"728x90-150x90.png\";s:5:\"width\";i:150;s:6:\"height\";i:90;s:9:\"mime-type\";s:9:\"image/png\";}s:11:\"shop_single\";a:4:{s:4:\"file\";s:17:\"728x90-300x90.png\";s:5:\"width\";i:300;s:6:\"height\";i:90;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("49", "23", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("50", "23", "_edit_lock", "1378670292:1");
INSERT INTO `wp_postmeta` VALUES("51", "23", "_wp_page_template", "default");
INSERT INTO `wp_postmeta` VALUES("52", "24", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("53", "24", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("54", "24", "_menu_item_object_id", "23");
INSERT INTO `wp_postmeta` VALUES("55", "24", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("56", "24", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("57", "24", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("58", "24", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("59", "24", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("60", "26", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("61", "26", "_wp_page_template", "default");
INSERT INTO `wp_postmeta` VALUES("62", "27", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("63", "27", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("64", "27", "_menu_item_object_id", "26");
INSERT INTO `wp_postmeta` VALUES("65", "27", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("66", "27", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("67", "27", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("68", "27", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("69", "27", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("70", "26", "_edit_lock", "1378670329:1");
INSERT INTO `wp_postmeta` VALUES("71", "29", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("72", "29", "_edit_lock", "1378670558:1");
INSERT INTO `wp_postmeta` VALUES("73", "29", "_wp_page_template", "default");
INSERT INTO `wp_postmeta` VALUES("673", "181", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("672", "48", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("671", "47", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("670", "38", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("669", "36", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("668", "2", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("82", "32", "_wp_attached_file", "2013/09/music.mp3");
INSERT INTO `wp_postmeta` VALUES("83", "32", "_wp_attachment_metadata", "a:24:{s:10:\"dataformat\";s:3:\"mp3\";s:8:\"channels\";i:1;s:11:\"sample_rate\";i:22050;s:7:\"bitrate\";i:32000;s:11:\"channelmode\";s:4:\"mono\";s:12:\"bitrate_mode\";s:3:\"cbr\";s:8:\"lossless\";b:0;s:15:\"encoder_options\";s:5:\"CBR32\";s:17:\"compression_ratio\";d:0.0907029478458049875921886950891348533332347869873046875;s:10:\"fileformat\";s:3:\"mp3\";s:8:\"filesize\";i:428881;s:9:\"mime_type\";s:10:\"audio/mpeg\";s:6:\"length\";i:107;s:16:\"length_formatted\";s:4:\"1:47\";s:5:\"title\";s:16:\"Now Is the Start\";s:6:\"artist\";s:13:\"A Fine Frenzy\";s:4:\"band\";s:13:\"A Fine Frenzy\";s:8:\"composer\";s:12:\"Alison Sudol\";s:5:\"album\";s:5:\"Pines\";s:12:\"track_number\";s:5:\"12/13\";s:13:\"part_of_a_set\";s:3:\"1/1\";s:5:\"genre\";s:17:\"Singer/Songwriter\";s:7:\"comment\";s:3:\"0\0\0\";s:10:\"encoded_by\";s:13:\"iTunes 11.0.1\";}");
INSERT INTO `wp_postmeta` VALUES("84", "32", "_edit_lock", "1378993555:1");
INSERT INTO `wp_postmeta` VALUES("684", "92", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("683", "210", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("682", "78", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("681", "44", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("680", "42", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("679", "46", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("630", "237", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("629", "237", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("628", "237", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("627", "237", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("626", "237", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("625", "237", "_menu_item_object_id", "38");
INSERT INTO `wp_postmeta` VALUES("624", "237", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("623", "237", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("621", "236", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("620", "236", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("619", "236", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("618", "236", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("617", "236", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("616", "236", "_menu_item_object_id", "36");
INSERT INTO `wp_postmeta` VALUES("614", "236", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("615", "236", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("719", "243", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:900;s:6:\"height\";i:400;s:4:\"file\";s:52:\"2013/09/Natural-Organic-Beauty-Shoping-Directory.png\";s:5:\"sizes\";a:10:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:52:\"Natural-Organic-Beauty-Shoping-Directory-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:6:\"medium\";a:4:{s:4:\"file\";s:52:\"Natural-Organic-Beauty-Shoping-Directory-300x133.png\";s:5:\"width\";i:300;s:6:\"height\";i:133;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"home-featured\";a:4:{s:4:\"file\";s:52:\"Natural-Organic-Beauty-Shoping-Directory-700x400.png\";s:5:\"width\";i:700;s:6:\"height\";i:400;s:9:\"mime-type\";s:9:\"image/png\";}s:15:\"widget-featured\";a:4:{s:4:\"file\";s:52:\"Natural-Organic-Beauty-Shoping-Directory-300x200.png\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:9:\"image/png\";}s:15:\"header-featured\";a:4:{s:4:\"file\";s:51:\"Natural-Organic-Beauty-Shoping-Directory-640x80.png\";s:5:\"width\";i:640;s:6:\"height\";i:80;s:9:\"mime-type\";s:9:\"image/png\";}s:18:\"portfolio-featured\";a:4:{s:4:\"file\";s:52:\"Natural-Organic-Beauty-Shoping-Directory-300x200.png\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"grid-featured\";a:4:{s:4:\"file\";s:52:\"Natural-Organic-Beauty-Shoping-Directory-320x200.png\";s:5:\"width\";i:320;s:6:\"height\";i:200;s:9:\"mime-type\";s:9:\"image/png\";}s:14:\"shop_thumbnail\";a:4:{s:4:\"file\";s:50:\"Natural-Organic-Beauty-Shoping-Directory-90x90.png\";s:5:\"width\";i:90;s:6:\"height\";i:90;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"shop_catalog\";a:4:{s:4:\"file\";s:52:\"Natural-Organic-Beauty-Shoping-Directory-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:11:\"shop_single\";a:4:{s:4:\"file\";s:52:\"Natural-Organic-Beauty-Shoping-Directory-300x300.png\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("718", "243", "_wp_attached_file", "2013/09/Natural-Organic-Beauty-Shoping-Directory.png");
INSERT INTO `wp_postmeta` VALUES("717", "242", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:900;s:6:\"height\";i:400;s:4:\"file\";s:52:\"2013/09/Pretty-Toxic-Beauty-Ingredients-To-Avoid.png\";s:5:\"sizes\";a:10:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:52:\"Pretty-Toxic-Beauty-Ingredients-To-Avoid-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:6:\"medium\";a:4:{s:4:\"file\";s:52:\"Pretty-Toxic-Beauty-Ingredients-To-Avoid-300x133.png\";s:5:\"width\";i:300;s:6:\"height\";i:133;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"home-featured\";a:4:{s:4:\"file\";s:52:\"Pretty-Toxic-Beauty-Ingredients-To-Avoid-700x400.png\";s:5:\"width\";i:700;s:6:\"height\";i:400;s:9:\"mime-type\";s:9:\"image/png\";}s:15:\"widget-featured\";a:4:{s:4:\"file\";s:52:\"Pretty-Toxic-Beauty-Ingredients-To-Avoid-300x200.png\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:9:\"image/png\";}s:15:\"header-featured\";a:4:{s:4:\"file\";s:51:\"Pretty-Toxic-Beauty-Ingredients-To-Avoid-640x80.png\";s:5:\"width\";i:640;s:6:\"height\";i:80;s:9:\"mime-type\";s:9:\"image/png\";}s:18:\"portfolio-featured\";a:4:{s:4:\"file\";s:52:\"Pretty-Toxic-Beauty-Ingredients-To-Avoid-300x200.png\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"grid-featured\";a:4:{s:4:\"file\";s:52:\"Pretty-Toxic-Beauty-Ingredients-To-Avoid-320x200.png\";s:5:\"width\";i:320;s:6:\"height\";i:200;s:9:\"mime-type\";s:9:\"image/png\";}s:14:\"shop_thumbnail\";a:4:{s:4:\"file\";s:50:\"Pretty-Toxic-Beauty-Ingredients-To-Avoid-90x90.png\";s:5:\"width\";i:90;s:6:\"height\";i:90;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"shop_catalog\";a:4:{s:4:\"file\";s:52:\"Pretty-Toxic-Beauty-Ingredients-To-Avoid-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:11:\"shop_single\";a:4:{s:4:\"file\";s:52:\"Pretty-Toxic-Beauty-Ingredients-To-Avoid-300x300.png\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("716", "242", "_wp_attached_file", "2013/09/Pretty-Toxic-Beauty-Ingredients-To-Avoid.png");
INSERT INTO `wp_postmeta` VALUES("715", "5", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("714", "183", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("713", "86", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("712", "87", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("711", "88", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("710", "89", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("709", "90", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("708", "91", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("1374", "399", "_yoast_wpseo_sitemap-include", "-");
INSERT INTO `wp_postmeta` VALUES("706", "10", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("705", "102", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("704", "34", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("703", "71", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("702", "70", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("701", "74", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("700", "73", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("699", "77", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("698", "76", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("697", "75", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("696", "72", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("695", "69", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("694", "67", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("693", "26", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("692", "101", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("691", "100", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("690", "98", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("689", "95", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("688", "96", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("687", "93", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("686", "97", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("685", "94", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("231", "64", "_menu_item_type", "custom");
INSERT INTO `wp_postmeta` VALUES("232", "64", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("233", "64", "_menu_item_object_id", "64");
INSERT INTO `wp_postmeta` VALUES("234", "64", "_menu_item_object", "custom");
INSERT INTO `wp_postmeta` VALUES("235", "64", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("236", "64", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("237", "64", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("238", "64", "_menu_item_url", "#");
INSERT INTO `wp_postmeta` VALUES("239", "65", "_menu_item_type", "custom");
INSERT INTO `wp_postmeta` VALUES("240", "65", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("241", "65", "_menu_item_object_id", "65");
INSERT INTO `wp_postmeta` VALUES("242", "65", "_menu_item_object", "custom");
INSERT INTO `wp_postmeta` VALUES("243", "65", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("244", "65", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("245", "65", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("246", "65", "_menu_item_url", "#");
INSERT INTO `wp_postmeta` VALUES("247", "66", "_menu_item_type", "custom");
INSERT INTO `wp_postmeta` VALUES("248", "66", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("249", "66", "_menu_item_object_id", "66");
INSERT INTO `wp_postmeta` VALUES("250", "66", "_menu_item_object", "custom");
INSERT INTO `wp_postmeta` VALUES("251", "66", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("252", "66", "_menu_item_classes", "a:1:{i:0;s:19:\"highlight-menu-item\";}");
INSERT INTO `wp_postmeta` VALUES("253", "66", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("254", "66", "_menu_item_url", "http://www.studiopress.com");
INSERT INTO `wp_postmeta` VALUES("663", "241", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("662", "241", "_menu_item_object", "custom");
INSERT INTO `wp_postmeta` VALUES("661", "241", "_menu_item_object_id", "241");
INSERT INTO `wp_postmeta` VALUES("660", "241", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("659", "241", "_menu_item_type", "custom");
INSERT INTO `wp_postmeta` VALUES("263", "67", "_wp_page_template", "default");
INSERT INTO `wp_postmeta` VALUES("264", "67", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("265", "69", "_wp_page_template", "default");
INSERT INTO `wp_postmeta` VALUES("266", "69", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("267", "70", "_wp_page_template", "default");
INSERT INTO `wp_postmeta` VALUES("268", "70", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("269", "71", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("270", "71", "_wp_page_template", "default");
INSERT INTO `wp_postmeta` VALUES("271", "72", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("272", "72", "_wp_page_template", "default");
INSERT INTO `wp_postmeta` VALUES("273", "73", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("274", "73", "_wp_page_template", "default");
INSERT INTO `wp_postmeta` VALUES("275", "74", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("276", "74", "_wp_page_template", "default");
INSERT INTO `wp_postmeta` VALUES("277", "75", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("278", "75", "_wp_page_template", "default");
INSERT INTO `wp_postmeta` VALUES("279", "76", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("280", "76", "_wp_page_template", "default");
INSERT INTO `wp_postmeta` VALUES("281", "77", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("282", "77", "_wp_page_template", "default");
INSERT INTO `wp_postmeta` VALUES("678", "43", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("677", "45", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("676", "40", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("675", "29", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("674", "23", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("665", "241", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("291", "78", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("292", "78", "_wp_page_template", "default");
INSERT INTO `wp_postmeta` VALUES("293", "80", "_menu_item_type", "custom");
INSERT INTO `wp_postmeta` VALUES("294", "80", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("295", "80", "_menu_item_object_id", "80");
INSERT INTO `wp_postmeta` VALUES("296", "80", "_menu_item_object", "custom");
INSERT INTO `wp_postmeta` VALUES("297", "80", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("298", "80", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("299", "80", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("300", "80", "_menu_item_url", "http://twitter.com/bgardner");
INSERT INTO `wp_postmeta` VALUES("301", "81", "_menu_item_type", "custom");
INSERT INTO `wp_postmeta` VALUES("302", "81", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("303", "81", "_menu_item_object_id", "81");
INSERT INTO `wp_postmeta` VALUES("304", "81", "_menu_item_object", "custom");
INSERT INTO `wp_postmeta` VALUES("305", "81", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("306", "81", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("307", "81", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("308", "81", "_menu_item_url", "http://twitter.com/nathanrice");
INSERT INTO `wp_postmeta` VALUES("309", "82", "_menu_item_type", "custom");
INSERT INTO `wp_postmeta` VALUES("310", "82", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("311", "82", "_menu_item_object_id", "82");
INSERT INTO `wp_postmeta` VALUES("312", "82", "_menu_item_object", "custom");
INSERT INTO `wp_postmeta` VALUES("313", "82", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("314", "82", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("315", "82", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("316", "82", "_menu_item_url", "http://twitter.com/sillygrampy");
INSERT INTO `wp_postmeta` VALUES("317", "83", "_menu_item_type", "custom");
INSERT INTO `wp_postmeta` VALUES("318", "83", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("319", "83", "_menu_item_object_id", "83");
INSERT INTO `wp_postmeta` VALUES("320", "83", "_menu_item_object", "custom");
INSERT INTO `wp_postmeta` VALUES("321", "83", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("322", "83", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("323", "83", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("324", "83", "_menu_item_url", "http://twitter.com/rafaltomal");
INSERT INTO `wp_postmeta` VALUES("325", "84", "_menu_item_type", "custom");
INSERT INTO `wp_postmeta` VALUES("326", "84", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("327", "84", "_menu_item_object_id", "84");
INSERT INTO `wp_postmeta` VALUES("328", "84", "_menu_item_object", "custom");
INSERT INTO `wp_postmeta` VALUES("329", "84", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("330", "84", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("331", "84", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("332", "84", "_menu_item_url", "http://twitter.com/nick_thegeek");
INSERT INTO `wp_postmeta` VALUES("333", "85", "_menu_item_type", "custom");
INSERT INTO `wp_postmeta` VALUES("334", "85", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("335", "85", "_menu_item_object_id", "85");
INSERT INTO `wp_postmeta` VALUES("336", "85", "_menu_item_object", "custom");
INSERT INTO `wp_postmeta` VALUES("337", "85", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("338", "85", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("339", "85", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("340", "85", "_menu_item_url", "http://twitter.com/joshbyers");
INSERT INTO `wp_postmeta` VALUES("341", "5", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("342", "5", "_wp_old_slug", "sample-post-with-headlines");
INSERT INTO `wp_postmeta` VALUES("343", "86", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("344", "86", "_wp_old_slug", "sample-post-with-an-ordered-list");
INSERT INTO `wp_postmeta` VALUES("345", "87", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("346", "87", "_wp_old_slug", "sample-post-with-an-unordered-list");
INSERT INTO `wp_postmeta` VALUES("347", "88", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("348", "88", "_wp_old_slug", "sample-post-with-image-centered");
INSERT INTO `wp_postmeta` VALUES("349", "89", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("350", "89", "_wp_old_slug", "sample-post-with-image-aligned-right");
INSERT INTO `wp_postmeta` VALUES("351", "90", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("352", "90", "_wp_old_slug", "sample-post-with-image-aligned-left");
INSERT INTO `wp_postmeta` VALUES("353", "91", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("354", "91", "_wp_old_slug", "sample-post-with-threaded-comments");
INSERT INTO `wp_postmeta` VALUES("355", "92", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("356", "92", "_wp_page_template", "page_blog.php");
INSERT INTO `wp_postmeta` VALUES("357", "92", "_genesis_layout", "content-sidebar");
INSERT INTO `wp_postmeta` VALUES("358", "93", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("359", "93", "_wp_page_template", "page_blog.php");
INSERT INTO `wp_postmeta` VALUES("360", "93", "_genesis_layout", "sidebar-content");
INSERT INTO `wp_postmeta` VALUES("361", "94", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("362", "94", "_wp_page_template", "page_blog.php");
INSERT INTO `wp_postmeta` VALUES("363", "94", "_genesis_layout", "content-sidebar-sidebar");
INSERT INTO `wp_postmeta` VALUES("364", "95", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("365", "95", "_wp_page_template", "page_blog.php");
INSERT INTO `wp_postmeta` VALUES("366", "95", "_genesis_layout", "sidebar-sidebar-content");
INSERT INTO `wp_postmeta` VALUES("367", "96", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("368", "96", "_wp_page_template", "page_blog.php");
INSERT INTO `wp_postmeta` VALUES("369", "96", "_genesis_layout", "sidebar-content-sidebar");
INSERT INTO `wp_postmeta` VALUES("370", "97", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("371", "97", "_wp_page_template", "default");
INSERT INTO `wp_postmeta` VALUES("372", "97", "_genesis_layout", "full-width-content");
INSERT INTO `wp_postmeta` VALUES("666", "241", "_menu_item_url", "http://healthydoghq.com/");
INSERT INTO `wp_postmeta` VALUES("1299", "381", "_yoast_wpseo_title", "");
INSERT INTO `wp_postmeta` VALUES("1297", "381", "_wpas_done_all", "1");
INSERT INTO `wp_postmeta` VALUES("1298", "381", "_yoast_wpseo_focuskw", "");
INSERT INTO `wp_postmeta` VALUES("1296", "381", "_wp_page_template", "default");
INSERT INTO `wp_postmeta` VALUES("1295", "381", "_thumbnail_id", "242");
INSERT INTO `wp_postmeta` VALUES("381", "98", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("382", "98", "_wp_page_template", "default");
INSERT INTO `wp_postmeta` VALUES("383", "100", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("384", "100", "_wp_page_template", "page_archive.php");
INSERT INTO `wp_postmeta` VALUES("385", "101", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("386", "101", "_wp_page_template", "page_blog.php");
INSERT INTO `wp_postmeta` VALUES("1294", "381", "_edit_lock", "1382655332:1");
INSERT INTO `wp_postmeta` VALUES("1293", "381", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("1292", "381", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("664", "241", "_menu_item_classes", "a:1:{i:0;s:4:\"home\";}");
INSERT INTO `wp_postmeta` VALUES("648", "239", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("647", "239", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("395", "102", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("396", "102", "_wp_page_template", "default");
INSERT INTO `wp_postmeta` VALUES("646", "239", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("645", "239", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("644", "239", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("643", "239", "_menu_item_object_id", "100");
INSERT INTO `wp_postmeta` VALUES("642", "239", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("641", "239", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("405", "181", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("406", "181", "_wp_page_template", "default");
INSERT INTO `wp_postmeta` VALUES("407", "181", "_genesis_layout", "full-width-content");
INSERT INTO `wp_postmeta` VALUES("408", "183", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("409", "183", "_wp_old_slug", "sample-post-with-a-blockquote");
INSERT INTO `wp_postmeta` VALUES("410", "210", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("411", "210", "_wp_page_template", "default");
INSERT INTO `wp_postmeta` VALUES("412", "210", "_genesis_title", "The 1152 CSS Grid System");
INSERT INTO `wp_postmeta` VALUES("413", "210", "_genesis_layout", "full-width-content");
INSERT INTO `wp_postmeta` VALUES("414", "211", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("415", "211", "_menu_item_menu_item_parent", "65");
INSERT INTO `wp_postmeta` VALUES("416", "211", "_menu_item_object_id", "100");
INSERT INTO `wp_postmeta` VALUES("417", "211", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("418", "211", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("419", "211", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("420", "211", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("421", "211", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("422", "212", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("423", "212", "_menu_item_menu_item_parent", "65");
INSERT INTO `wp_postmeta` VALUES("424", "212", "_menu_item_object_id", "101");
INSERT INTO `wp_postmeta` VALUES("425", "212", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("426", "212", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("427", "212", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("428", "212", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("429", "212", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("430", "213", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("431", "213", "_menu_item_menu_item_parent", "65");
INSERT INTO `wp_postmeta` VALUES("432", "213", "_menu_item_object_id", "181");
INSERT INTO `wp_postmeta` VALUES("433", "213", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("434", "213", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("435", "213", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("436", "213", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("437", "213", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("438", "214", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("439", "214", "_menu_item_menu_item_parent", "64");
INSERT INTO `wp_postmeta` VALUES("440", "214", "_menu_item_object_id", "92");
INSERT INTO `wp_postmeta` VALUES("441", "214", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("442", "214", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("443", "214", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("444", "214", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("445", "214", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("446", "215", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("447", "215", "_menu_item_menu_item_parent", "64");
INSERT INTO `wp_postmeta` VALUES("448", "215", "_menu_item_object_id", "94");
INSERT INTO `wp_postmeta` VALUES("449", "215", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("450", "215", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("451", "215", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("452", "215", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("453", "215", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("454", "216", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("455", "216", "_menu_item_menu_item_parent", "64");
INSERT INTO `wp_postmeta` VALUES("456", "216", "_menu_item_object_id", "97");
INSERT INTO `wp_postmeta` VALUES("457", "216", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("458", "216", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("459", "216", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("460", "216", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("461", "216", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("462", "217", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("463", "217", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("464", "217", "_menu_item_object_id", "67");
INSERT INTO `wp_postmeta` VALUES("465", "217", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("466", "217", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("467", "217", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("468", "217", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("469", "217", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("470", "218", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("471", "218", "_menu_item_menu_item_parent", "64");
INSERT INTO `wp_postmeta` VALUES("472", "218", "_menu_item_object_id", "93");
INSERT INTO `wp_postmeta` VALUES("473", "218", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("474", "218", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("475", "218", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("476", "218", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("477", "218", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("478", "219", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("479", "219", "_menu_item_menu_item_parent", "64");
INSERT INTO `wp_postmeta` VALUES("480", "219", "_menu_item_object_id", "96");
INSERT INTO `wp_postmeta` VALUES("481", "219", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("482", "219", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("483", "219", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("484", "219", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("485", "219", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("486", "220", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("487", "220", "_menu_item_menu_item_parent", "64");
INSERT INTO `wp_postmeta` VALUES("488", "220", "_menu_item_object_id", "95");
INSERT INTO `wp_postmeta` VALUES("489", "220", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("490", "220", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("491", "220", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("492", "220", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("493", "220", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("494", "221", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("495", "221", "_menu_item_menu_item_parent", "217");
INSERT INTO `wp_postmeta` VALUES("496", "221", "_menu_item_object_id", "69");
INSERT INTO `wp_postmeta` VALUES("497", "221", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("498", "221", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("499", "221", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("500", "221", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("501", "221", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("502", "222", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("503", "222", "_menu_item_menu_item_parent", "217");
INSERT INTO `wp_postmeta` VALUES("504", "222", "_menu_item_object_id", "70");
INSERT INTO `wp_postmeta` VALUES("505", "222", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("506", "222", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("507", "222", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("508", "222", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("509", "222", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("510", "223", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("511", "223", "_menu_item_menu_item_parent", "217");
INSERT INTO `wp_postmeta` VALUES("512", "223", "_menu_item_object_id", "71");
INSERT INTO `wp_postmeta` VALUES("513", "223", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("514", "223", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("515", "223", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("516", "223", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("517", "223", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("518", "224", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("519", "224", "_menu_item_menu_item_parent", "221");
INSERT INTO `wp_postmeta` VALUES("520", "224", "_menu_item_object_id", "72");
INSERT INTO `wp_postmeta` VALUES("521", "224", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("522", "224", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("523", "224", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("524", "224", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("525", "224", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("526", "225", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("527", "225", "_menu_item_menu_item_parent", "221");
INSERT INTO `wp_postmeta` VALUES("528", "225", "_menu_item_object_id", "73");
INSERT INTO `wp_postmeta` VALUES("529", "225", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("530", "225", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("531", "225", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("532", "225", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("533", "225", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("534", "226", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("535", "226", "_menu_item_menu_item_parent", "221");
INSERT INTO `wp_postmeta` VALUES("536", "226", "_menu_item_object_id", "74");
INSERT INTO `wp_postmeta` VALUES("537", "226", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("538", "226", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("539", "226", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("540", "226", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("541", "226", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("542", "227", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("543", "227", "_menu_item_menu_item_parent", "224");
INSERT INTO `wp_postmeta` VALUES("544", "227", "_menu_item_object_id", "75");
INSERT INTO `wp_postmeta` VALUES("545", "227", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("546", "227", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("547", "227", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("548", "227", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("549", "227", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("550", "228", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("551", "228", "_menu_item_menu_item_parent", "224");
INSERT INTO `wp_postmeta` VALUES("552", "228", "_menu_item_object_id", "76");
INSERT INTO `wp_postmeta` VALUES("553", "228", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("554", "228", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("555", "228", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("556", "228", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("557", "228", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("558", "229", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("559", "229", "_menu_item_menu_item_parent", "224");
INSERT INTO `wp_postmeta` VALUES("560", "229", "_menu_item_object_id", "77");
INSERT INTO `wp_postmeta` VALUES("561", "229", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("562", "229", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("563", "229", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("564", "229", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("565", "229", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("566", "230", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("567", "230", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("568", "230", "_menu_item_object_id", "102");
INSERT INTO `wp_postmeta` VALUES("569", "230", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("570", "230", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("571", "230", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("572", "230", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("573", "230", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("574", "231", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("575", "231", "_menu_item_menu_item_parent", "64");
INSERT INTO `wp_postmeta` VALUES("576", "231", "_menu_item_object_id", "210");
INSERT INTO `wp_postmeta` VALUES("577", "231", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("578", "231", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("579", "231", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("580", "231", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("581", "231", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("582", "232", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("583", "232", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("584", "232", "_menu_item_object_id", "67");
INSERT INTO `wp_postmeta` VALUES("585", "232", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("586", "232", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("587", "232", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("588", "232", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("589", "232", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("590", "233", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("591", "233", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("592", "233", "_menu_item_object_id", "101");
INSERT INTO `wp_postmeta` VALUES("593", "233", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("594", "233", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("595", "233", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("596", "233", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("597", "233", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("598", "234", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("599", "234", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("600", "234", "_menu_item_object_id", "102");
INSERT INTO `wp_postmeta` VALUES("601", "234", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("602", "234", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("603", "234", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("604", "234", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("605", "234", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("606", "235", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("607", "235", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("608", "235", "_menu_item_object_id", "100");
INSERT INTO `wp_postmeta` VALUES("609", "235", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("610", "235", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("611", "235", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("612", "235", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("613", "235", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("632", "238", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("633", "238", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("634", "238", "_menu_item_object_id", "40");
INSERT INTO `wp_postmeta` VALUES("635", "238", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("636", "238", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("637", "238", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("638", "238", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("639", "238", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("720", "244", "_wp_attached_file", "2013/09/Beginners-guide-to-clean-beauty-2.png");
INSERT INTO `wp_postmeta` VALUES("721", "244", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:900;s:6:\"height\";i:400;s:4:\"file\";s:45:\"2013/09/Beginners-guide-to-clean-beauty-2.png\";s:5:\"sizes\";a:10:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:45:\"Beginners-guide-to-clean-beauty-2-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:6:\"medium\";a:4:{s:4:\"file\";s:45:\"Beginners-guide-to-clean-beauty-2-300x133.png\";s:5:\"width\";i:300;s:6:\"height\";i:133;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"home-featured\";a:4:{s:4:\"file\";s:45:\"Beginners-guide-to-clean-beauty-2-700x400.png\";s:5:\"width\";i:700;s:6:\"height\";i:400;s:9:\"mime-type\";s:9:\"image/png\";}s:15:\"widget-featured\";a:4:{s:4:\"file\";s:45:\"Beginners-guide-to-clean-beauty-2-300x200.png\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:9:\"image/png\";}s:15:\"header-featured\";a:4:{s:4:\"file\";s:44:\"Beginners-guide-to-clean-beauty-2-640x80.png\";s:5:\"width\";i:640;s:6:\"height\";i:80;s:9:\"mime-type\";s:9:\"image/png\";}s:18:\"portfolio-featured\";a:4:{s:4:\"file\";s:45:\"Beginners-guide-to-clean-beauty-2-300x200.png\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"grid-featured\";a:4:{s:4:\"file\";s:45:\"Beginners-guide-to-clean-beauty-2-320x200.png\";s:5:\"width\";i:320;s:6:\"height\";i:200;s:9:\"mime-type\";s:9:\"image/png\";}s:14:\"shop_thumbnail\";a:4:{s:4:\"file\";s:43:\"Beginners-guide-to-clean-beauty-2-90x90.png\";s:5:\"width\";i:90;s:6:\"height\";i:90;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"shop_catalog\";a:4:{s:4:\"file\";s:45:\"Beginners-guide-to-clean-beauty-2-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:11:\"shop_single\";a:4:{s:4:\"file\";s:45:\"Beginners-guide-to-clean-beauty-2-300x300.png\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1078", "95", "_wp_trash_meta_time", "1382642033");
INSERT INTO `wp_postmeta` VALUES("1077", "95", "_wp_trash_meta_status", "publish");
INSERT INTO `wp_postmeta` VALUES("1045", "183", "_wp_trash_meta_status", "publish");
INSERT INTO `wp_postmeta` VALUES("1046", "183", "_wp_trash_meta_time", "1382623900");
INSERT INTO `wp_postmeta` VALUES("1047", "5", "_wp_trash_meta_status", "publish");
INSERT INTO `wp_postmeta` VALUES("1048", "5", "_wp_trash_meta_time", "1382623900");
INSERT INTO `wp_postmeta` VALUES("1052", "336", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("1053", "337", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("1054", "337", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("1055", "337", "_edit_lock", "1382715906:1");
INSERT INTO `wp_postmeta` VALUES("1056", "337", "_wpas_done_all", "1");
INSERT INTO `wp_postmeta` VALUES("1073", "78", "_wp_trash_meta_status", "publish");
INSERT INTO `wp_postmeta` VALUES("1058", "337", "_yoast_wpseo_focuskw", "");
INSERT INTO `wp_postmeta` VALUES("1059", "337", "_yoast_wpseo_title", "");
INSERT INTO `wp_postmeta` VALUES("1060", "337", "_yoast_wpseo_metadesc", "");
INSERT INTO `wp_postmeta` VALUES("1061", "337", "_yoast_wpseo_meta-robots-noindex", "0");
INSERT INTO `wp_postmeta` VALUES("1062", "337", "_yoast_wpseo_meta-robots-nofollow", "0");
INSERT INTO `wp_postmeta` VALUES("1063", "337", "_yoast_wpseo_meta-robots-adv", "none");
INSERT INTO `wp_postmeta` VALUES("1064", "337", "_yoast_wpseo_sitemap-include", "-");
INSERT INTO `wp_postmeta` VALUES("1065", "337", "_yoast_wpseo_sitemap-prio", "-");
INSERT INTO `wp_postmeta` VALUES("1066", "337", "_yoast_wpseo_sitemap-html-include", "-");
INSERT INTO `wp_postmeta` VALUES("1067", "337", "_yoast_wpseo_canonical", "");
INSERT INTO `wp_postmeta` VALUES("1068", "337", "_yoast_wpseo_redirect", "");
INSERT INTO `wp_postmeta` VALUES("1069", "337", "_yoast_wpseo_opengraph-description", "");
INSERT INTO `wp_postmeta` VALUES("1070", "337", "_yoast_wpseo_google-plus-description", "");
INSERT INTO `wp_postmeta` VALUES("1072", "337", "_wp_old_slug", "goldas-story-saved-dog-immune-mediated-hemolytic-anemia-imha");
INSERT INTO `wp_postmeta` VALUES("1074", "78", "_wp_trash_meta_time", "1382642033");
INSERT INTO `wp_postmeta` VALUES("1075", "96", "_wp_trash_meta_status", "publish");
INSERT INTO `wp_postmeta` VALUES("1076", "96", "_wp_trash_meta_time", "1382642033");
INSERT INTO `wp_postmeta` VALUES("1015", "2", "_thumbnail_id", "12");
INSERT INTO `wp_postmeta` VALUES("1016", "2", "_yoast_wpseo_focuskw", "");
INSERT INTO `wp_postmeta` VALUES("1017", "2", "_yoast_wpseo_title", "");
INSERT INTO `wp_postmeta` VALUES("1018", "2", "_yoast_wpseo_metadesc", "");
INSERT INTO `wp_postmeta` VALUES("1019", "2", "_yoast_wpseo_meta-robots-noindex", "0");
INSERT INTO `wp_postmeta` VALUES("1020", "2", "_yoast_wpseo_meta-robots-nofollow", "0");
INSERT INTO `wp_postmeta` VALUES("1021", "2", "_yoast_wpseo_meta-robots-adv", "none");
INSERT INTO `wp_postmeta` VALUES("1022", "2", "_yoast_wpseo_sitemap-include", "-");
INSERT INTO `wp_postmeta` VALUES("1023", "2", "_yoast_wpseo_sitemap-prio", "-");
INSERT INTO `wp_postmeta` VALUES("1024", "2", "_yoast_wpseo_sitemap-html-include", "-");
INSERT INTO `wp_postmeta` VALUES("1025", "2", "_yoast_wpseo_canonical", "");
INSERT INTO `wp_postmeta` VALUES("1026", "2", "_yoast_wpseo_redirect", "");
INSERT INTO `wp_postmeta` VALUES("1027", "2", "_yoast_wpseo_opengraph-description", "");
INSERT INTO `wp_postmeta` VALUES("1028", "2", "_yoast_wpseo_google-plus-description", "");
INSERT INTO `wp_postmeta` VALUES("1029", "10", "_wp_trash_meta_status", "publish");
INSERT INTO `wp_postmeta` VALUES("1030", "10", "_wp_trash_meta_time", "1382623900");
INSERT INTO `wp_postmeta` VALUES("1031", "91", "_wp_trash_meta_status", "publish");
INSERT INTO `wp_postmeta` VALUES("1032", "91", "_wp_trash_meta_time", "1382623900");
INSERT INTO `wp_postmeta` VALUES("1033", "91", "_wp_trash_meta_comments_status", "a:6:{i:2;s:1:\"1\";i:3;s:1:\"1\";i:4;s:1:\"1\";i:5;s:1:\"1\";i:6;s:1:\"1\";i:7;s:1:\"1\";}");
INSERT INTO `wp_postmeta` VALUES("1034", "90", "_wp_trash_meta_status", "publish");
INSERT INTO `wp_postmeta` VALUES("1035", "90", "_wp_trash_meta_time", "1382623900");
INSERT INTO `wp_postmeta` VALUES("1036", "89", "_wp_trash_meta_status", "publish");
INSERT INTO `wp_postmeta` VALUES("1037", "89", "_wp_trash_meta_time", "1382623900");
INSERT INTO `wp_postmeta` VALUES("1038", "89", "_wp_trash_meta_comments_status", "a:3:{i:8;s:5:\"trash\";i:9;s:5:\"trash\";i:10;s:5:\"trash\";}");
INSERT INTO `wp_postmeta` VALUES("1039", "88", "_wp_trash_meta_status", "publish");
INSERT INTO `wp_postmeta` VALUES("1040", "88", "_wp_trash_meta_time", "1382623900");
INSERT INTO `wp_postmeta` VALUES("1041", "87", "_wp_trash_meta_status", "publish");
INSERT INTO `wp_postmeta` VALUES("1042", "87", "_wp_trash_meta_time", "1382623900");
INSERT INTO `wp_postmeta` VALUES("1043", "86", "_wp_trash_meta_status", "publish");
INSERT INTO `wp_postmeta` VALUES("1044", "86", "_wp_trash_meta_time", "1382623900");
INSERT INTO `wp_postmeta` VALUES("730", "248", "_wpas_done_all", "1");
INSERT INTO `wp_postmeta` VALUES("731", "248", "custom_css_add", "yes");
INSERT INTO `wp_postmeta` VALUES("732", "248", "content_width", "");
INSERT INTO `wp_postmeta` VALUES("733", "248", "custom_css_preprocessor", "");
INSERT INTO `wp_postmeta` VALUES("734", "249", "custom_css_add", "yes");
INSERT INTO `wp_postmeta` VALUES("735", "249", "content_width", "");
INSERT INTO `wp_postmeta` VALUES("736", "249", "custom_css_preprocessor", "");
INSERT INTO `wp_postmeta` VALUES("737", "250", "custom_css_add", "yes");
INSERT INTO `wp_postmeta` VALUES("738", "250", "content_width", "");
INSERT INTO `wp_postmeta` VALUES("739", "250", "custom_css_preprocessor", "");
INSERT INTO `wp_postmeta` VALUES("740", "251", "custom_css_add", "yes");
INSERT INTO `wp_postmeta` VALUES("741", "251", "content_width", "");
INSERT INTO `wp_postmeta` VALUES("742", "251", "custom_css_preprocessor", "");
INSERT INTO `wp_postmeta` VALUES("743", "252", "custom_css_add", "yes");
INSERT INTO `wp_postmeta` VALUES("744", "252", "content_width", "");
INSERT INTO `wp_postmeta` VALUES("745", "252", "custom_css_preprocessor", "");
INSERT INTO `wp_postmeta` VALUES("746", "253", "custom_css_add", "yes");
INSERT INTO `wp_postmeta` VALUES("747", "253", "content_width", "");
INSERT INTO `wp_postmeta` VALUES("748", "253", "custom_css_preprocessor", "");
INSERT INTO `wp_postmeta` VALUES("749", "254", "custom_css_add", "yes");
INSERT INTO `wp_postmeta` VALUES("750", "254", "content_width", "");
INSERT INTO `wp_postmeta` VALUES("751", "254", "custom_css_preprocessor", "");
INSERT INTO `wp_postmeta` VALUES("752", "255", "custom_css_add", "yes");
INSERT INTO `wp_postmeta` VALUES("753", "255", "content_width", "");
INSERT INTO `wp_postmeta` VALUES("754", "255", "custom_css_preprocessor", "");
INSERT INTO `wp_postmeta` VALUES("755", "256", "custom_css_add", "yes");
INSERT INTO `wp_postmeta` VALUES("756", "256", "content_width", "");
INSERT INTO `wp_postmeta` VALUES("757", "256", "custom_css_preprocessor", "");
INSERT INTO `wp_postmeta` VALUES("758", "257", "custom_css_add", "yes");
INSERT INTO `wp_postmeta` VALUES("759", "257", "content_width", "");
INSERT INTO `wp_postmeta` VALUES("760", "257", "custom_css_preprocessor", "");
INSERT INTO `wp_postmeta` VALUES("761", "258", "custom_css_add", "yes");
INSERT INTO `wp_postmeta` VALUES("762", "258", "content_width", "");
INSERT INTO `wp_postmeta` VALUES("763", "258", "custom_css_preprocessor", "");
INSERT INTO `wp_postmeta` VALUES("764", "259", "custom_css_add", "yes");
INSERT INTO `wp_postmeta` VALUES("765", "259", "content_width", "");
INSERT INTO `wp_postmeta` VALUES("766", "259", "custom_css_preprocessor", "");
INSERT INTO `wp_postmeta` VALUES("767", "260", "custom_css_add", "yes");
INSERT INTO `wp_postmeta` VALUES("768", "260", "content_width", "");
INSERT INTO `wp_postmeta` VALUES("769", "260", "custom_css_preprocessor", "");
INSERT INTO `wp_postmeta` VALUES("770", "261", "custom_css_add", "yes");
INSERT INTO `wp_postmeta` VALUES("771", "261", "content_width", "");
INSERT INTO `wp_postmeta` VALUES("772", "261", "custom_css_preprocessor", "");
INSERT INTO `wp_postmeta` VALUES("773", "262", "custom_css_add", "yes");
INSERT INTO `wp_postmeta` VALUES("774", "262", "content_width", "");
INSERT INTO `wp_postmeta` VALUES("775", "262", "custom_css_preprocessor", "");
INSERT INTO `wp_postmeta` VALUES("776", "263", "custom_css_add", "yes");
INSERT INTO `wp_postmeta` VALUES("777", "263", "content_width", "");
INSERT INTO `wp_postmeta` VALUES("778", "263", "custom_css_preprocessor", "");
INSERT INTO `wp_postmeta` VALUES("779", "264", "custom_css_add", "yes");
INSERT INTO `wp_postmeta` VALUES("780", "264", "content_width", "");
INSERT INTO `wp_postmeta` VALUES("781", "264", "custom_css_preprocessor", "");
INSERT INTO `wp_postmeta` VALUES("782", "265", "custom_css_add", "yes");
INSERT INTO `wp_postmeta` VALUES("783", "265", "content_width", "");
INSERT INTO `wp_postmeta` VALUES("784", "265", "custom_css_preprocessor", "");
INSERT INTO `wp_postmeta` VALUES("785", "266", "custom_css_add", "yes");
INSERT INTO `wp_postmeta` VALUES("786", "266", "content_width", "");
INSERT INTO `wp_postmeta` VALUES("787", "266", "custom_css_preprocessor", "");
INSERT INTO `wp_postmeta` VALUES("788", "267", "custom_css_add", "yes");
INSERT INTO `wp_postmeta` VALUES("789", "267", "content_width", "");
INSERT INTO `wp_postmeta` VALUES("790", "267", "custom_css_preprocessor", "");
INSERT INTO `wp_postmeta` VALUES("791", "268", "custom_css_add", "yes");
INSERT INTO `wp_postmeta` VALUES("792", "268", "content_width", "");
INSERT INTO `wp_postmeta` VALUES("793", "268", "custom_css_preprocessor", "");
INSERT INTO `wp_postmeta` VALUES("794", "269", "custom_css_add", "yes");
INSERT INTO `wp_postmeta` VALUES("795", "269", "content_width", "");
INSERT INTO `wp_postmeta` VALUES("796", "269", "custom_css_preprocessor", "");
INSERT INTO `wp_postmeta` VALUES("797", "270", "custom_css_add", "yes");
INSERT INTO `wp_postmeta` VALUES("798", "270", "content_width", "");
INSERT INTO `wp_postmeta` VALUES("799", "270", "custom_css_preprocessor", "");
INSERT INTO `wp_postmeta` VALUES("800", "271", "custom_css_add", "yes");
INSERT INTO `wp_postmeta` VALUES("801", "271", "content_width", "");
INSERT INTO `wp_postmeta` VALUES("802", "271", "custom_css_preprocessor", "");
INSERT INTO `wp_postmeta` VALUES("803", "272", "custom_css_add", "yes");
INSERT INTO `wp_postmeta` VALUES("804", "272", "content_width", "");
INSERT INTO `wp_postmeta` VALUES("805", "272", "custom_css_preprocessor", "");
INSERT INTO `wp_postmeta` VALUES("806", "273", "custom_css_add", "yes");
INSERT INTO `wp_postmeta` VALUES("807", "273", "content_width", "");
INSERT INTO `wp_postmeta` VALUES("808", "273", "custom_css_preprocessor", "");
INSERT INTO `wp_postmeta` VALUES("809", "274", "custom_css_add", "yes");
INSERT INTO `wp_postmeta` VALUES("810", "274", "content_width", "");
INSERT INTO `wp_postmeta` VALUES("811", "274", "custom_css_preprocessor", "");
INSERT INTO `wp_postmeta` VALUES("812", "275", "custom_css_add", "yes");
INSERT INTO `wp_postmeta` VALUES("813", "275", "content_width", "");
INSERT INTO `wp_postmeta` VALUES("814", "275", "custom_css_preprocessor", "");
INSERT INTO `wp_postmeta` VALUES("815", "276", "custom_css_add", "yes");
INSERT INTO `wp_postmeta` VALUES("816", "276", "content_width", "");
INSERT INTO `wp_postmeta` VALUES("817", "276", "custom_css_preprocessor", "");
INSERT INTO `wp_postmeta` VALUES("818", "277", "custom_css_add", "yes");
INSERT INTO `wp_postmeta` VALUES("819", "277", "content_width", "");
INSERT INTO `wp_postmeta` VALUES("820", "277", "custom_css_preprocessor", "");
INSERT INTO `wp_postmeta` VALUES("821", "278", "custom_css_add", "yes");
INSERT INTO `wp_postmeta` VALUES("822", "278", "content_width", "");
INSERT INTO `wp_postmeta` VALUES("823", "278", "custom_css_preprocessor", "");
INSERT INTO `wp_postmeta` VALUES("824", "279", "custom_css_add", "yes");
INSERT INTO `wp_postmeta` VALUES("825", "279", "content_width", "");
INSERT INTO `wp_postmeta` VALUES("826", "279", "custom_css_preprocessor", "");
INSERT INTO `wp_postmeta` VALUES("827", "280", "custom_css_add", "yes");
INSERT INTO `wp_postmeta` VALUES("828", "280", "content_width", "");
INSERT INTO `wp_postmeta` VALUES("829", "280", "custom_css_preprocessor", "");
INSERT INTO `wp_postmeta` VALUES("830", "281", "custom_css_add", "yes");
INSERT INTO `wp_postmeta` VALUES("831", "281", "content_width", "");
INSERT INTO `wp_postmeta` VALUES("832", "281", "custom_css_preprocessor", "");
INSERT INTO `wp_postmeta` VALUES("833", "282", "custom_css_add", "yes");
INSERT INTO `wp_postmeta` VALUES("834", "282", "content_width", "");
INSERT INTO `wp_postmeta` VALUES("835", "282", "custom_css_preprocessor", "");
INSERT INTO `wp_postmeta` VALUES("836", "283", "custom_css_add", "yes");
INSERT INTO `wp_postmeta` VALUES("837", "283", "content_width", "");
INSERT INTO `wp_postmeta` VALUES("838", "283", "custom_css_preprocessor", "");
INSERT INTO `wp_postmeta` VALUES("839", "284", "custom_css_add", "yes");
INSERT INTO `wp_postmeta` VALUES("840", "284", "content_width", "");
INSERT INTO `wp_postmeta` VALUES("841", "284", "custom_css_preprocessor", "");
INSERT INTO `wp_postmeta` VALUES("842", "285", "custom_css_add", "yes");
INSERT INTO `wp_postmeta` VALUES("843", "285", "content_width", "");
INSERT INTO `wp_postmeta` VALUES("844", "285", "custom_css_preprocessor", "");
INSERT INTO `wp_postmeta` VALUES("845", "286", "custom_css_add", "yes");
INSERT INTO `wp_postmeta` VALUES("846", "286", "content_width", "");
INSERT INTO `wp_postmeta` VALUES("847", "286", "custom_css_preprocessor", "");
INSERT INTO `wp_postmeta` VALUES("848", "287", "custom_css_add", "yes");
INSERT INTO `wp_postmeta` VALUES("849", "287", "content_width", "");
INSERT INTO `wp_postmeta` VALUES("850", "287", "custom_css_preprocessor", "");
INSERT INTO `wp_postmeta` VALUES("851", "288", "custom_css_add", "yes");
INSERT INTO `wp_postmeta` VALUES("852", "288", "content_width", "");
INSERT INTO `wp_postmeta` VALUES("853", "288", "custom_css_preprocessor", "");
INSERT INTO `wp_postmeta` VALUES("854", "289", "custom_css_add", "yes");
INSERT INTO `wp_postmeta` VALUES("855", "289", "content_width", "");
INSERT INTO `wp_postmeta` VALUES("856", "289", "custom_css_preprocessor", "");
INSERT INTO `wp_postmeta` VALUES("857", "290", "custom_css_add", "yes");
INSERT INTO `wp_postmeta` VALUES("858", "290", "content_width", "");
INSERT INTO `wp_postmeta` VALUES("859", "290", "custom_css_preprocessor", "");
INSERT INTO `wp_postmeta` VALUES("860", "291", "custom_css_add", "yes");
INSERT INTO `wp_postmeta` VALUES("861", "291", "content_width", "");
INSERT INTO `wp_postmeta` VALUES("862", "291", "custom_css_preprocessor", "");
INSERT INTO `wp_postmeta` VALUES("863", "292", "custom_css_add", "yes");
INSERT INTO `wp_postmeta` VALUES("864", "292", "content_width", "");
INSERT INTO `wp_postmeta` VALUES("865", "292", "custom_css_preprocessor", "");
INSERT INTO `wp_postmeta` VALUES("866", "293", "custom_css_add", "yes");
INSERT INTO `wp_postmeta` VALUES("867", "293", "content_width", "");
INSERT INTO `wp_postmeta` VALUES("868", "293", "custom_css_preprocessor", "");
INSERT INTO `wp_postmeta` VALUES("869", "294", "custom_css_add", "yes");
INSERT INTO `wp_postmeta` VALUES("870", "294", "content_width", "");
INSERT INTO `wp_postmeta` VALUES("871", "294", "custom_css_preprocessor", "");
INSERT INTO `wp_postmeta` VALUES("872", "295", "custom_css_add", "yes");
INSERT INTO `wp_postmeta` VALUES("873", "295", "content_width", "");
INSERT INTO `wp_postmeta` VALUES("874", "295", "custom_css_preprocessor", "");
INSERT INTO `wp_postmeta` VALUES("875", "296", "custom_css_add", "yes");
INSERT INTO `wp_postmeta` VALUES("876", "296", "content_width", "");
INSERT INTO `wp_postmeta` VALUES("877", "296", "custom_css_preprocessor", "");
INSERT INTO `wp_postmeta` VALUES("878", "297", "custom_css_add", "yes");
INSERT INTO `wp_postmeta` VALUES("879", "297", "content_width", "");
INSERT INTO `wp_postmeta` VALUES("880", "297", "custom_css_preprocessor", "");
INSERT INTO `wp_postmeta` VALUES("881", "298", "custom_css_add", "yes");
INSERT INTO `wp_postmeta` VALUES("882", "298", "content_width", "");
INSERT INTO `wp_postmeta` VALUES("883", "298", "custom_css_preprocessor", "");
INSERT INTO `wp_postmeta` VALUES("884", "299", "custom_css_add", "yes");
INSERT INTO `wp_postmeta` VALUES("885", "299", "content_width", "");
INSERT INTO `wp_postmeta` VALUES("886", "299", "custom_css_preprocessor", "");
INSERT INTO `wp_postmeta` VALUES("887", "300", "custom_css_add", "yes");
INSERT INTO `wp_postmeta` VALUES("888", "300", "content_width", "");
INSERT INTO `wp_postmeta` VALUES("889", "300", "custom_css_preprocessor", "");
INSERT INTO `wp_postmeta` VALUES("890", "301", "custom_css_add", "yes");
INSERT INTO `wp_postmeta` VALUES("891", "301", "content_width", "");
INSERT INTO `wp_postmeta` VALUES("892", "301", "custom_css_preprocessor", "");
INSERT INTO `wp_postmeta` VALUES("893", "302", "custom_css_add", "yes");
INSERT INTO `wp_postmeta` VALUES("894", "302", "content_width", "");
INSERT INTO `wp_postmeta` VALUES("895", "302", "custom_css_preprocessor", "");
INSERT INTO `wp_postmeta` VALUES("896", "303", "custom_css_add", "yes");
INSERT INTO `wp_postmeta` VALUES("897", "303", "content_width", "");
INSERT INTO `wp_postmeta` VALUES("898", "303", "custom_css_preprocessor", "");
INSERT INTO `wp_postmeta` VALUES("899", "304", "custom_css_add", "yes");
INSERT INTO `wp_postmeta` VALUES("900", "304", "content_width", "");
INSERT INTO `wp_postmeta` VALUES("901", "304", "custom_css_preprocessor", "");
INSERT INTO `wp_postmeta` VALUES("902", "305", "custom_css_add", "yes");
INSERT INTO `wp_postmeta` VALUES("903", "305", "content_width", "");
INSERT INTO `wp_postmeta` VALUES("904", "305", "custom_css_preprocessor", "");
INSERT INTO `wp_postmeta` VALUES("905", "306", "custom_css_add", "yes");
INSERT INTO `wp_postmeta` VALUES("906", "306", "content_width", "");
INSERT INTO `wp_postmeta` VALUES("907", "306", "custom_css_preprocessor", "");
INSERT INTO `wp_postmeta` VALUES("1111", "94", "_wp_trash_meta_status", "publish");
INSERT INTO `wp_postmeta` VALUES("1112", "94", "_wp_trash_meta_time", "1382642090");
INSERT INTO `wp_postmeta` VALUES("1113", "101", "_edit_lock", "1382643031:1");
INSERT INTO `wp_postmeta` VALUES("1114", "101", "_yoast_wpseo_focuskw", "");
INSERT INTO `wp_postmeta` VALUES("1115", "101", "_yoast_wpseo_title", "");
INSERT INTO `wp_postmeta` VALUES("1116", "101", "_yoast_wpseo_metadesc", "");
INSERT INTO `wp_postmeta` VALUES("1117", "101", "_yoast_wpseo_meta-robots-noindex", "0");
INSERT INTO `wp_postmeta` VALUES("1118", "101", "_yoast_wpseo_meta-robots-nofollow", "0");
INSERT INTO `wp_postmeta` VALUES("1119", "101", "_yoast_wpseo_meta-robots-adv", "none");
INSERT INTO `wp_postmeta` VALUES("1120", "101", "_yoast_wpseo_sitemap-include", "-");
INSERT INTO `wp_postmeta` VALUES("1121", "101", "_yoast_wpseo_sitemap-prio", "-");
INSERT INTO `wp_postmeta` VALUES("1122", "101", "_yoast_wpseo_sitemap-html-include", "-");
INSERT INTO `wp_postmeta` VALUES("1123", "101", "_yoast_wpseo_canonical", "");
INSERT INTO `wp_postmeta` VALUES("1124", "101", "_yoast_wpseo_redirect", "");
INSERT INTO `wp_postmeta` VALUES("1125", "101", "_yoast_wpseo_opengraph-description", "");
INSERT INTO `wp_postmeta` VALUES("1126", "101", "_yoast_wpseo_google-plus-description", "");
INSERT INTO `wp_postmeta` VALUES("1127", "101", "_genesis_layout", "content-sidebar");
INSERT INTO `wp_postmeta` VALUES("1404", "409", "_wp_attached_file", "2013/10/golda-lure-coursing1.jpg");
INSERT INTO `wp_postmeta` VALUES("1405", "409", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:430;s:6:\"height\";i:283;s:4:\"file\";s:32:\"2013/10/golda-lure-coursing1.jpg\";s:5:\"sizes\";a:9:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:32:\"golda-lure-coursing1-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:32:\"golda-lure-coursing1-300x197.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:197;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:15:\"widget-featured\";a:4:{s:4:\"file\";s:32:\"golda-lure-coursing1-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:15:\"header-featured\";a:4:{s:4:\"file\";s:31:\"golda-lure-coursing1-430x80.jpg\";s:5:\"width\";i:430;s:6:\"height\";i:80;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:18:\"portfolio-featured\";a:4:{s:4:\"file\";s:32:\"golda-lure-coursing1-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:13:\"grid-featured\";a:4:{s:4:\"file\";s:32:\"golda-lure-coursing1-320x200.jpg\";s:5:\"width\";i:320;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"shop_thumbnail\";a:4:{s:4:\"file\";s:30:\"golda-lure-coursing1-90x90.jpg\";s:5:\"width\";i:90;s:6:\"height\";i:90;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"shop_catalog\";a:4:{s:4:\"file\";s:32:\"golda-lure-coursing1-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:11:\"shop_single\";a:4:{s:4:\"file\";s:32:\"golda-lure-coursing1-300x283.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:283;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1079", "98", "_wp_trash_meta_status", "publish");
INSERT INTO `wp_postmeta` VALUES("1080", "98", "_wp_trash_meta_time", "1382642033");
INSERT INTO `wp_postmeta` VALUES("1081", "67", "_wp_trash_meta_status", "publish");
INSERT INTO `wp_postmeta` VALUES("1082", "67", "_wp_trash_meta_time", "1382642033");
INSERT INTO `wp_postmeta` VALUES("1083", "69", "_wp_trash_meta_status", "publish");
INSERT INTO `wp_postmeta` VALUES("1084", "69", "_wp_trash_meta_time", "1382642033");
INSERT INTO `wp_postmeta` VALUES("1085", "72", "_wp_trash_meta_status", "publish");
INSERT INTO `wp_postmeta` VALUES("1086", "72", "_wp_trash_meta_time", "1382642033");
INSERT INTO `wp_postmeta` VALUES("1087", "75", "_wp_trash_meta_status", "publish");
INSERT INTO `wp_postmeta` VALUES("1088", "75", "_wp_trash_meta_time", "1382642033");
INSERT INTO `wp_postmeta` VALUES("1089", "76", "_wp_trash_meta_status", "publish");
INSERT INTO `wp_postmeta` VALUES("1090", "76", "_wp_trash_meta_time", "1382642033");
INSERT INTO `wp_postmeta` VALUES("1091", "77", "_wp_trash_meta_status", "publish");
INSERT INTO `wp_postmeta` VALUES("1092", "77", "_wp_trash_meta_time", "1382642033");
INSERT INTO `wp_postmeta` VALUES("1093", "73", "_wp_trash_meta_status", "publish");
INSERT INTO `wp_postmeta` VALUES("1094", "73", "_wp_trash_meta_time", "1382642033");
INSERT INTO `wp_postmeta` VALUES("1095", "74", "_wp_trash_meta_status", "publish");
INSERT INTO `wp_postmeta` VALUES("1096", "74", "_wp_trash_meta_time", "1382642033");
INSERT INTO `wp_postmeta` VALUES("1097", "70", "_wp_trash_meta_status", "publish");
INSERT INTO `wp_postmeta` VALUES("1098", "70", "_wp_trash_meta_time", "1382642033");
INSERT INTO `wp_postmeta` VALUES("1099", "71", "_wp_trash_meta_status", "publish");
INSERT INTO `wp_postmeta` VALUES("1100", "71", "_wp_trash_meta_time", "1382642033");
INSERT INTO `wp_postmeta` VALUES("1101", "97", "_wp_trash_meta_status", "publish");
INSERT INTO `wp_postmeta` VALUES("1102", "97", "_wp_trash_meta_time", "1382642048");
INSERT INTO `wp_postmeta` VALUES("1103", "93", "_wp_trash_meta_status", "publish");
INSERT INTO `wp_postmeta` VALUES("1104", "93", "_wp_trash_meta_time", "1382642048");
INSERT INTO `wp_postmeta` VALUES("1105", "181", "_wp_trash_meta_status", "publish");
INSERT INTO `wp_postmeta` VALUES("1106", "181", "_wp_trash_meta_time", "1382642090");
INSERT INTO `wp_postmeta` VALUES("1107", "210", "_wp_trash_meta_status", "publish");
INSERT INTO `wp_postmeta` VALUES("1108", "210", "_wp_trash_meta_time", "1382642090");
INSERT INTO `wp_postmeta` VALUES("1109", "92", "_wp_trash_meta_status", "publish");
INSERT INTO `wp_postmeta` VALUES("1110", "92", "_wp_trash_meta_time", "1382642090");
INSERT INTO `wp_postmeta` VALUES("916", "309", "custom_css_add", "yes");
INSERT INTO `wp_postmeta` VALUES("917", "309", "content_width", "");
INSERT INTO `wp_postmeta` VALUES("918", "309", "custom_css_preprocessor", "");
INSERT INTO `wp_postmeta` VALUES("919", "91", "_edit_lock", "1380911599:1");
INSERT INTO `wp_postmeta` VALUES("920", "91", "_thumbnail_id", "244");
INSERT INTO `wp_postmeta` VALUES("952", "10", "_yoast_wpseo_focuskw", "");
INSERT INTO `wp_postmeta` VALUES("922", "91", "_yoast_wpseo_focuskw", "");
INSERT INTO `wp_postmeta` VALUES("923", "91", "_yoast_wpseo_title", "");
INSERT INTO `wp_postmeta` VALUES("924", "91", "_yoast_wpseo_metadesc", "");
INSERT INTO `wp_postmeta` VALUES("925", "91", "_yoast_wpseo_meta-robots-noindex", "0");
INSERT INTO `wp_postmeta` VALUES("926", "91", "_yoast_wpseo_meta-robots-nofollow", "0");
INSERT INTO `wp_postmeta` VALUES("927", "91", "_yoast_wpseo_meta-robots-adv", "none");
INSERT INTO `wp_postmeta` VALUES("928", "91", "_yoast_wpseo_sitemap-include", "-");
INSERT INTO `wp_postmeta` VALUES("929", "91", "_yoast_wpseo_sitemap-prio", "-");
INSERT INTO `wp_postmeta` VALUES("930", "91", "_yoast_wpseo_sitemap-html-include", "-");
INSERT INTO `wp_postmeta` VALUES("931", "91", "_yoast_wpseo_canonical", "");
INSERT INTO `wp_postmeta` VALUES("932", "91", "_yoast_wpseo_redirect", "");
INSERT INTO `wp_postmeta` VALUES("933", "91", "_yoast_wpseo_opengraph-description", "");
INSERT INTO `wp_postmeta` VALUES("934", "91", "_yoast_wpseo_google-plus-description", "");
INSERT INTO `wp_postmeta` VALUES("1373", "399", "_yoast_wpseo_meta-robots-adv", "none");
INSERT INTO `wp_postmeta` VALUES("1372", "399", "_yoast_wpseo_meta-robots-nofollow", "0");
INSERT INTO `wp_postmeta` VALUES("1371", "399", "_yoast_wpseo_meta-robots-noindex", "0");
INSERT INTO `wp_postmeta` VALUES("1370", "399", "_yoast_wpseo_metadesc", "");
INSERT INTO `wp_postmeta` VALUES("1369", "399", "_yoast_wpseo_title", "");
INSERT INTO `wp_postmeta` VALUES("1368", "399", "_yoast_wpseo_focuskw", "");
INSERT INTO `wp_postmeta` VALUES("1367", "399", "_wpas_done_all", "1");
INSERT INTO `wp_postmeta` VALUES("1366", "399", "_wp_page_template", "default");
INSERT INTO `wp_postmeta` VALUES("1365", "399", "_thumbnail_id", "398");
INSERT INTO `wp_postmeta` VALUES("1364", "399", "_edit_lock", "1382708403:1");
INSERT INTO `wp_postmeta` VALUES("1363", "399", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("953", "10", "_yoast_wpseo_title", "");
INSERT INTO `wp_postmeta` VALUES("954", "10", "_yoast_wpseo_metadesc", "");
INSERT INTO `wp_postmeta` VALUES("955", "10", "_yoast_wpseo_meta-robots-noindex", "0");
INSERT INTO `wp_postmeta` VALUES("956", "10", "_yoast_wpseo_meta-robots-nofollow", "0");
INSERT INTO `wp_postmeta` VALUES("957", "10", "_yoast_wpseo_meta-robots-adv", "none");
INSERT INTO `wp_postmeta` VALUES("958", "10", "_yoast_wpseo_sitemap-include", "-");
INSERT INTO `wp_postmeta` VALUES("959", "10", "_yoast_wpseo_sitemap-prio", "-");
INSERT INTO `wp_postmeta` VALUES("960", "10", "_yoast_wpseo_sitemap-html-include", "-");
INSERT INTO `wp_postmeta` VALUES("961", "10", "_yoast_wpseo_canonical", "");
INSERT INTO `wp_postmeta` VALUES("962", "10", "_yoast_wpseo_redirect", "");
INSERT INTO `wp_postmeta` VALUES("963", "10", "_yoast_wpseo_opengraph-description", "");
INSERT INTO `wp_postmeta` VALUES("964", "10", "_yoast_wpseo_google-plus-description", "");
INSERT INTO `wp_postmeta` VALUES("970", "244", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("1403", "408", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:400;s:6:\"height\";i:299;s:4:\"file\";s:29:\"2013/10/blood-transfusion.jpg\";s:5:\"sizes\";a:9:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:29:\"blood-transfusion-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:29:\"blood-transfusion-300x224.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:224;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:15:\"widget-featured\";a:4:{s:4:\"file\";s:29:\"blood-transfusion-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:15:\"header-featured\";a:4:{s:4:\"file\";s:28:\"blood-transfusion-400x80.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:80;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:18:\"portfolio-featured\";a:4:{s:4:\"file\";s:29:\"blood-transfusion-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:13:\"grid-featured\";a:4:{s:4:\"file\";s:29:\"blood-transfusion-320x200.jpg\";s:5:\"width\";i:320;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"shop_thumbnail\";a:4:{s:4:\"file\";s:27:\"blood-transfusion-90x90.jpg\";s:5:\"width\";i:90;s:6:\"height\";i:90;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"shop_catalog\";a:4:{s:4:\"file\";s:29:\"blood-transfusion-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:11:\"shop_single\";a:4:{s:4:\"file\";s:29:\"blood-transfusion-300x299.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:299;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1210", "365", "_wp_old_slug", "canine-aihaimha-symptoms");
INSERT INTO `wp_postmeta` VALUES("1212", "100", "_edit_lock", "1382648091:1");
INSERT INTO `wp_postmeta` VALUES("1397", "407", "_wp_attached_file", "2013/10/golda-feature2.jpg");
INSERT INTO `wp_postmeta` VALUES("1398", "407", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:300;s:6:\"height\";i:200;s:4:\"file\";s:26:\"2013/10/golda-feature2.jpg\";s:5:\"sizes\";a:4:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:26:\"golda-feature2-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:15:\"header-featured\";a:4:{s:4:\"file\";s:25:\"golda-feature2-300x80.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:80;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"shop_thumbnail\";a:4:{s:4:\"file\";s:24:\"golda-feature2-90x90.jpg\";s:5:\"width\";i:90;s:6:\"height\";i:90;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"shop_catalog\";a:4:{s:4:\"file\";s:26:\"golda-feature2-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1392", "405", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:430;s:6:\"height\";i:283;s:4:\"file\";s:31:\"2013/10/golda-lure-coursing.jpg\";s:5:\"sizes\";a:9:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:31:\"golda-lure-coursing-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:31:\"golda-lure-coursing-300x197.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:197;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:15:\"widget-featured\";a:4:{s:4:\"file\";s:31:\"golda-lure-coursing-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:15:\"header-featured\";a:4:{s:4:\"file\";s:30:\"golda-lure-coursing-430x80.jpg\";s:5:\"width\";i:430;s:6:\"height\";i:80;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:18:\"portfolio-featured\";a:4:{s:4:\"file\";s:31:\"golda-lure-coursing-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:13:\"grid-featured\";a:4:{s:4:\"file\";s:31:\"golda-lure-coursing-320x200.jpg\";s:5:\"width\";i:320;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"shop_thumbnail\";a:4:{s:4:\"file\";s:29:\"golda-lure-coursing-90x90.jpg\";s:5:\"width\";i:90;s:6:\"height\";i:90;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"shop_catalog\";a:4:{s:4:\"file\";s:31:\"golda-lure-coursing-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:11:\"shop_single\";a:4:{s:4:\"file\";s:31:\"golda-lure-coursing-300x283.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:283;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1171", "363", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("1172", "363", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("1173", "363", "_edit_lock", "1382715684:1");
INSERT INTO `wp_postmeta` VALUES("1174", "363", "_wpas_done_all", "1");
INSERT INTO `wp_postmeta` VALUES("1189", "365", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("1176", "363", "_yoast_wpseo_focuskw", "");
INSERT INTO `wp_postmeta` VALUES("1177", "363", "_yoast_wpseo_title", "");
INSERT INTO `wp_postmeta` VALUES("1178", "363", "_yoast_wpseo_metadesc", "");
INSERT INTO `wp_postmeta` VALUES("1179", "363", "_yoast_wpseo_meta-robots-noindex", "0");
INSERT INTO `wp_postmeta` VALUES("1180", "363", "_yoast_wpseo_meta-robots-nofollow", "0");
INSERT INTO `wp_postmeta` VALUES("1181", "363", "_yoast_wpseo_meta-robots-adv", "none");
INSERT INTO `wp_postmeta` VALUES("1182", "363", "_yoast_wpseo_sitemap-include", "-");
INSERT INTO `wp_postmeta` VALUES("1183", "363", "_yoast_wpseo_sitemap-prio", "-");
INSERT INTO `wp_postmeta` VALUES("1184", "363", "_yoast_wpseo_sitemap-html-include", "-");
INSERT INTO `wp_postmeta` VALUES("1185", "363", "_yoast_wpseo_canonical", "");
INSERT INTO `wp_postmeta` VALUES("1186", "363", "_yoast_wpseo_redirect", "");
INSERT INTO `wp_postmeta` VALUES("1187", "363", "_yoast_wpseo_opengraph-description", "");
INSERT INTO `wp_postmeta` VALUES("1188", "363", "_yoast_wpseo_google-plus-description", "");
INSERT INTO `wp_postmeta` VALUES("1190", "365", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("1191", "365", "_edit_lock", "1382717696:1");
INSERT INTO `wp_postmeta` VALUES("1192", "365", "_wpas_done_all", "1");
INSERT INTO `wp_postmeta` VALUES("1194", "365", "_yoast_wpseo_focuskw", "");
INSERT INTO `wp_postmeta` VALUES("1195", "365", "_yoast_wpseo_title", "");
INSERT INTO `wp_postmeta` VALUES("1196", "365", "_yoast_wpseo_metadesc", "");
INSERT INTO `wp_postmeta` VALUES("1197", "365", "_yoast_wpseo_meta-robots-noindex", "0");
INSERT INTO `wp_postmeta` VALUES("1198", "365", "_yoast_wpseo_meta-robots-nofollow", "0");
INSERT INTO `wp_postmeta` VALUES("1199", "365", "_yoast_wpseo_meta-robots-adv", "none");
INSERT INTO `wp_postmeta` VALUES("1200", "365", "_yoast_wpseo_sitemap-include", "-");
INSERT INTO `wp_postmeta` VALUES("1201", "365", "_yoast_wpseo_sitemap-prio", "-");
INSERT INTO `wp_postmeta` VALUES("1202", "365", "_yoast_wpseo_sitemap-html-include", "-");
INSERT INTO `wp_postmeta` VALUES("1203", "365", "_yoast_wpseo_canonical", "");
INSERT INTO `wp_postmeta` VALUES("1204", "365", "_yoast_wpseo_redirect", "");
INSERT INTO `wp_postmeta` VALUES("1205", "365", "_yoast_wpseo_opengraph-description", "");
INSERT INTO `wp_postmeta` VALUES("1206", "365", "_yoast_wpseo_google-plus-description", "");
INSERT INTO `wp_postmeta` VALUES("1377", "399", "_yoast_wpseo_canonical", "");
INSERT INTO `wp_postmeta` VALUES("1362", "399", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("1391", "405", "_wp_attached_file", "2013/10/golda-lure-coursing.jpg");
INSERT INTO `wp_postmeta` VALUES("1389", "404", "_wp_attached_file", "2013/10/golda-feature.jpg");
INSERT INTO `wp_postmeta` VALUES("1390", "404", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:300;s:6:\"height\";i:200;s:4:\"file\";s:25:\"2013/10/golda-feature.jpg\";s:5:\"sizes\";a:4:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:25:\"golda-feature-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:15:\"header-featured\";a:4:{s:4:\"file\";s:24:\"golda-feature-300x80.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:80;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"shop_thumbnail\";a:4:{s:4:\"file\";s:23:\"golda-feature-90x90.jpg\";s:5:\"width\";i:90;s:6:\"height\";i:90;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"shop_catalog\";a:4:{s:4:\"file\";s:25:\"golda-feature-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1305", "381", "_yoast_wpseo_sitemap-prio", "-");
INSERT INTO `wp_postmeta` VALUES("1306", "381", "_yoast_wpseo_sitemap-html-include", "-");
INSERT INTO `wp_postmeta` VALUES("1307", "381", "_yoast_wpseo_canonical", "");
INSERT INTO `wp_postmeta` VALUES("1308", "381", "_yoast_wpseo_redirect", "");
INSERT INTO `wp_postmeta` VALUES("1309", "381", "_yoast_wpseo_opengraph-description", "");
INSERT INTO `wp_postmeta` VALUES("1310", "381", "_yoast_wpseo_google-plus-description", "");
INSERT INTO `wp_postmeta` VALUES("1311", "383", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("1312", "383", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("1313", "383", "_menu_item_object_id", "381");
INSERT INTO `wp_postmeta` VALUES("1314", "383", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("1315", "383", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("1316", "383", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("1317", "383", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("1318", "383", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("1320", "383", "_wpas_done_all", "1");
INSERT INTO `wp_postmeta` VALUES("1378", "399", "_yoast_wpseo_redirect", "");
INSERT INTO `wp_postmeta` VALUES("1379", "399", "_yoast_wpseo_opengraph-description", "");
INSERT INTO `wp_postmeta` VALUES("1380", "399", "_yoast_wpseo_google-plus-description", "");
INSERT INTO `wp_postmeta` VALUES("1323", "386", "_wp_attached_file", "2013/10/welcome.jpg");
INSERT INTO `wp_postmeta` VALUES("1324", "386", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:350;s:6:\"height\";i:244;s:4:\"file\";s:19:\"2013/10/welcome.jpg\";s:5:\"sizes\";a:9:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:19:\"welcome-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:19:\"welcome-300x209.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:209;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:15:\"widget-featured\";a:4:{s:4:\"file\";s:19:\"welcome-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:15:\"header-featured\";a:4:{s:4:\"file\";s:18:\"welcome-350x80.jpg\";s:5:\"width\";i:350;s:6:\"height\";i:80;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:18:\"portfolio-featured\";a:4:{s:4:\"file\";s:19:\"welcome-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:13:\"grid-featured\";a:4:{s:4:\"file\";s:19:\"welcome-320x200.jpg\";s:5:\"width\";i:320;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"shop_thumbnail\";a:4:{s:4:\"file\";s:17:\"welcome-90x90.jpg\";s:5:\"width\";i:90;s:6:\"height\";i:90;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"shop_catalog\";a:4:{s:4:\"file\";s:19:\"welcome-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:11:\"shop_single\";a:4:{s:4:\"file\";s:19:\"welcome-300x244.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:244;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1402", "408", "_wp_attached_file", "2013/10/blood-transfusion.jpg");
INSERT INTO `wp_postmeta` VALUES("1399", "337", "_thumbnail_id", "407");
INSERT INTO `wp_postmeta` VALUES("1358", "398", "_wp_attached_file", "2013/10/welcome-feature1.jpg");
INSERT INTO `wp_postmeta` VALUES("1395", "337", "_wp_old_slug", "saved-dog-immune-mediated-hemolytic-anemia-imha");
INSERT INTO `wp_postmeta` VALUES("1359", "398", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:300;s:6:\"height\";i:200;s:4:\"file\";s:28:\"2013/10/welcome-feature1.jpg\";s:5:\"sizes\";a:4:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:28:\"welcome-feature1-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:15:\"header-featured\";a:4:{s:4:\"file\";s:27:\"welcome-feature1-300x80.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:80;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"shop_thumbnail\";a:4:{s:4:\"file\";s:26:\"welcome-feature1-90x90.jpg\";s:5:\"width\";i:90;s:6:\"height\";i:90;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"shop_catalog\";a:4:{s:4:\"file\";s:28:\"welcome-feature1-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1003", "324", "_wp_attached_file", "2013/10/logox22.png");
INSERT INTO `wp_postmeta` VALUES("1004", "324", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:728;s:6:\"height\";i:271;s:4:\"file\";s:19:\"2013/10/logox22.png\";s:5:\"sizes\";a:10:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:19:\"logox22-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:6:\"medium\";a:4:{s:4:\"file\";s:19:\"logox22-300x111.png\";s:5:\"width\";i:300;s:6:\"height\";i:111;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"home-featured\";a:4:{s:4:\"file\";s:19:\"logox22-700x271.png\";s:5:\"width\";i:700;s:6:\"height\";i:271;s:9:\"mime-type\";s:9:\"image/png\";}s:15:\"widget-featured\";a:4:{s:4:\"file\";s:19:\"logox22-300x200.png\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:9:\"image/png\";}s:15:\"header-featured\";a:4:{s:4:\"file\";s:18:\"logox22-640x80.png\";s:5:\"width\";i:640;s:6:\"height\";i:80;s:9:\"mime-type\";s:9:\"image/png\";}s:18:\"portfolio-featured\";a:4:{s:4:\"file\";s:19:\"logox22-300x200.png\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"grid-featured\";a:4:{s:4:\"file\";s:19:\"logox22-320x200.png\";s:5:\"width\";i:320;s:6:\"height\";i:200;s:9:\"mime-type\";s:9:\"image/png\";}s:14:\"shop_thumbnail\";a:4:{s:4:\"file\";s:17:\"logox22-90x90.png\";s:5:\"width\";i:90;s:6:\"height\";i:90;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"shop_catalog\";a:4:{s:4:\"file\";s:19:\"logox22-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:11:\"shop_single\";a:4:{s:4:\"file\";s:19:\"logox22-300x271.png\";s:5:\"width\";i:300;s:6:\"height\";i:271;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1410", "413", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:400;s:6:\"height\";i:300;s:4:\"file\";s:25:\"2013/10/Golda-chicken.jpg\";s:5:\"sizes\";a:9:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:25:\"Golda-chicken-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:25:\"Golda-chicken-300x225.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:225;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:15:\"widget-featured\";a:4:{s:4:\"file\";s:25:\"Golda-chicken-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:15:\"header-featured\";a:4:{s:4:\"file\";s:24:\"Golda-chicken-400x80.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:80;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:18:\"portfolio-featured\";a:4:{s:4:\"file\";s:25:\"Golda-chicken-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:13:\"grid-featured\";a:4:{s:4:\"file\";s:25:\"Golda-chicken-320x200.jpg\";s:5:\"width\";i:320;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"shop_thumbnail\";a:4:{s:4:\"file\";s:23:\"Golda-chicken-90x90.jpg\";s:5:\"width\";i:90;s:6:\"height\";i:90;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"shop_catalog\";a:4:{s:4:\"file\";s:25:\"Golda-chicken-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:11:\"shop_single\";a:4:{s:4:\"file\";s:25:\"Golda-chicken-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1412", "415", "_wp_attached_file", "2013/10/golda-acupunture.jpg");
INSERT INTO `wp_postmeta` VALUES("1413", "415", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:300;s:6:\"height\";i:400;s:4:\"file\";s:28:\"2013/10/golda-acupunture.jpg\";s:5:\"sizes\";a:9:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:28:\"golda-acupunture-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:28:\"golda-acupunture-225x300.jpg\";s:5:\"width\";i:225;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:15:\"widget-featured\";a:4:{s:4:\"file\";s:28:\"golda-acupunture-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:15:\"header-featured\";a:4:{s:4:\"file\";s:27:\"golda-acupunture-300x80.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:80;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:18:\"portfolio-featured\";a:4:{s:4:\"file\";s:28:\"golda-acupunture-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:13:\"grid-featured\";a:4:{s:4:\"file\";s:28:\"golda-acupunture-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"shop_thumbnail\";a:4:{s:4:\"file\";s:26:\"golda-acupunture-90x90.jpg\";s:5:\"width\";i:90;s:6:\"height\";i:90;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"shop_catalog\";a:4:{s:4:\"file\";s:28:\"golda-acupunture-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:11:\"shop_single\";a:4:{s:4:\"file\";s:28:\"golda-acupunture-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1007", "324", "_edit_lock", "1382560984:1");
INSERT INTO `wp_postmeta` VALUES("1008", "324", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("1409", "413", "_wp_attached_file", "2013/10/Golda-chicken.jpg");
INSERT INTO `wp_postmeta` VALUES("1011", "326", "_wp_attached_file", "2013/10/logo6.png");
INSERT INTO `wp_postmeta` VALUES("1012", "326", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:360;s:6:\"height\";i:134;s:4:\"file\";s:17:\"2013/10/logo6.png\";s:5:\"sizes\";a:9:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:17:\"logo6-150x134.png\";s:5:\"width\";i:150;s:6:\"height\";i:134;s:9:\"mime-type\";s:9:\"image/png\";}s:6:\"medium\";a:4:{s:4:\"file\";s:17:\"logo6-300x111.png\";s:5:\"width\";i:300;s:6:\"height\";i:111;s:9:\"mime-type\";s:9:\"image/png\";}s:15:\"widget-featured\";a:4:{s:4:\"file\";s:17:\"logo6-300x134.png\";s:5:\"width\";i:300;s:6:\"height\";i:134;s:9:\"mime-type\";s:9:\"image/png\";}s:15:\"header-featured\";a:4:{s:4:\"file\";s:16:\"logo6-360x80.png\";s:5:\"width\";i:360;s:6:\"height\";i:80;s:9:\"mime-type\";s:9:\"image/png\";}s:18:\"portfolio-featured\";a:4:{s:4:\"file\";s:17:\"logo6-300x134.png\";s:5:\"width\";i:300;s:6:\"height\";i:134;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"grid-featured\";a:4:{s:4:\"file\";s:17:\"logo6-320x134.png\";s:5:\"width\";i:320;s:6:\"height\";i:134;s:9:\"mime-type\";s:9:\"image/png\";}s:14:\"shop_thumbnail\";a:4:{s:4:\"file\";s:15:\"logo6-90x90.png\";s:5:\"width\";i:90;s:6:\"height\";i:90;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"shop_catalog\";a:4:{s:4:\"file\";s:17:\"logo6-150x134.png\";s:5:\"width\";i:150;s:6:\"height\";i:134;s:9:\"mime-type\";s:9:\"image/png\";}s:11:\"shop_single\";a:4:{s:4:\"file\";s:17:\"logo6-300x134.png\";s:5:\"width\";i:300;s:6:\"height\";i:134;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1013", "326", "_edit_lock", "1382561017:1");
INSERT INTO `wp_postmeta` VALUES("1014", "326", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("1416", "417", "_wp_attached_file", "2013/10/what-is-imha.jpg");
INSERT INTO `wp_postmeta` VALUES("1417", "417", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:300;s:6:\"height\";i:200;s:4:\"file\";s:24:\"2013/10/what-is-imha.jpg\";s:5:\"sizes\";a:4:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:24:\"what-is-imha-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:15:\"header-featured\";a:4:{s:4:\"file\";s:23:\"what-is-imha-300x80.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:80;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"shop_thumbnail\";a:4:{s:4:\"file\";s:22:\"what-is-imha-90x90.jpg\";s:5:\"width\";i:90;s:6:\"height\";i:90;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"shop_catalog\";a:4:{s:4:\"file\";s:24:\"what-is-imha-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1418", "363", "_thumbnail_id", "417");
INSERT INTO `wp_postmeta` VALUES("1419", "417", "_wp_attachment_image_alt", "What is Canine Immune Mediated Hemolytic Anemia");
INSERT INTO `wp_postmeta` VALUES("1422", "419", "_wp_attached_file", "2013/10/golda-skinny.jpg");
INSERT INTO `wp_postmeta` VALUES("1423", "419", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:400;s:6:\"height\";i:267;s:4:\"file\";s:24:\"2013/10/golda-skinny.jpg\";s:5:\"sizes\";a:9:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:24:\"golda-skinny-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:24:\"golda-skinny-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:15:\"widget-featured\";a:4:{s:4:\"file\";s:24:\"golda-skinny-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:15:\"header-featured\";a:4:{s:4:\"file\";s:23:\"golda-skinny-400x80.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:80;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:18:\"portfolio-featured\";a:4:{s:4:\"file\";s:24:\"golda-skinny-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:13:\"grid-featured\";a:4:{s:4:\"file\";s:24:\"golda-skinny-320x200.jpg\";s:5:\"width\";i:320;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"shop_thumbnail\";a:4:{s:4:\"file\";s:22:\"golda-skinny-90x90.jpg\";s:5:\"width\";i:90;s:6:\"height\";i:90;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"shop_catalog\";a:4:{s:4:\"file\";s:24:\"golda-skinny-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:11:\"shop_single\";a:4:{s:4:\"file\";s:24:\"golda-skinny-300x267.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:267;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1473", "427", "_yoast_wpseo_canonical", "");
INSERT INTO `wp_postmeta` VALUES("1472", "427", "_yoast_wpseo_sitemap-html-include", "-");
INSERT INTO `wp_postmeta` VALUES("1448", "427", "_wp_attached_file", "2013/10/Golda-pale-gums.jpg");
INSERT INTO `wp_postmeta` VALUES("1471", "427", "_yoast_wpseo_sitemap-prio", "-");
INSERT INTO `wp_postmeta` VALUES("1470", "427", "_yoast_wpseo_sitemap-include", "-");
INSERT INTO `wp_postmeta` VALUES("1469", "427", "_yoast_wpseo_meta-robots-adv", "none");
INSERT INTO `wp_postmeta` VALUES("1468", "427", "_yoast_wpseo_meta-robots-nofollow", "0");
INSERT INTO `wp_postmeta` VALUES("1467", "427", "_yoast_wpseo_meta-robots-noindex", "0");
INSERT INTO `wp_postmeta` VALUES("1466", "427", "_yoast_wpseo_metadesc", "");
INSERT INTO `wp_postmeta` VALUES("1465", "427", "_yoast_wpseo_title", "");
INSERT INTO `wp_postmeta` VALUES("1464", "427", "_yoast_wpseo_focuskw", "");
INSERT INTO `wp_postmeta` VALUES("1463", "427", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("1462", "427", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("1449", "427", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:300;s:6:\"height\";i:200;s:4:\"file\";s:27:\"2013/10/Golda-pale-gums.jpg\";s:5:\"sizes\";a:4:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:27:\"Golda-pale-gums-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:15:\"header-featured\";a:4:{s:4:\"file\";s:26:\"Golda-pale-gums-300x80.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:80;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"shop_thumbnail\";a:4:{s:4:\"file\";s:25:\"Golda-pale-gums-90x90.jpg\";s:5:\"width\";i:90;s:6:\"height\";i:90;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"shop_catalog\";a:4:{s:4:\"file\";s:27:\"Golda-pale-gums-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1450", "427", "_wp_attachment_image_alt", "Canine Immune Mediated Hemolytic Anemia Symptoms");
INSERT INTO `wp_postmeta` VALUES("1459", "417", "_edit_lock", "1382717293:1");
INSERT INTO `wp_postmeta` VALUES("1460", "417", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("1461", "427", "_edit_lock", "1382717708:1");
INSERT INTO `wp_postmeta` VALUES("1474", "427", "_yoast_wpseo_redirect", "");
INSERT INTO `wp_postmeta` VALUES("1475", "427", "_yoast_wpseo_opengraph-description", "");
INSERT INTO `wp_postmeta` VALUES("1476", "427", "_yoast_wpseo_google-plus-description", "");
INSERT INTO `wp_postmeta` VALUES("1477", "430", "custom_css_add", "yes");
INSERT INTO `wp_postmeta` VALUES("1478", "430", "content_width", "");
INSERT INTO `wp_postmeta` VALUES("1479", "430", "custom_css_preprocessor", "");
INSERT INTO `wp_postmeta` VALUES("1480", "431", "custom_css_add", "yes");
INSERT INTO `wp_postmeta` VALUES("1481", "431", "content_width", "");
INSERT INTO `wp_postmeta` VALUES("1482", "431", "custom_css_preprocessor", "");
INSERT INTO `wp_postmeta` VALUES("1483", "432", "custom_css_add", "yes");
INSERT INTO `wp_postmeta` VALUES("1484", "432", "content_width", "");
INSERT INTO `wp_postmeta` VALUES("1485", "432", "custom_css_preprocessor", "");
INSERT INTO `wp_postmeta` VALUES("1486", "433", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("1487", "433", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("1488", "433", "_edit_lock", "1382718944:1");
INSERT INTO `wp_postmeta` VALUES("1489", "434", "_wp_attached_file", "2013/10/imha-testing.jpg");
INSERT INTO `wp_postmeta` VALUES("1490", "434", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:300;s:6:\"height\";i:200;s:4:\"file\";s:24:\"2013/10/imha-testing.jpg\";s:5:\"sizes\";a:4:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:24:\"imha-testing-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:15:\"header-featured\";a:4:{s:4:\"file\";s:23:\"imha-testing-300x80.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:80;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"shop_thumbnail\";a:4:{s:4:\"file\";s:22:\"imha-testing-90x90.jpg\";s:5:\"width\";i:90;s:6:\"height\";i:90;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"shop_catalog\";a:4:{s:4:\"file\";s:24:\"imha-testing-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1491", "434", "_wp_attachment_image_alt", "canine-imha-pcv-test");
INSERT INTO `wp_postmeta` VALUES("1492", "433", "_thumbnail_id", "434");
INSERT INTO `wp_postmeta` VALUES("1493", "433", "_wpas_done_all", "1");
INSERT INTO `wp_postmeta` VALUES("1495", "433", "_yoast_wpseo_focuskw", "");
INSERT INTO `wp_postmeta` VALUES("1496", "433", "_yoast_wpseo_title", "");
INSERT INTO `wp_postmeta` VALUES("1497", "433", "_yoast_wpseo_metadesc", "");
INSERT INTO `wp_postmeta` VALUES("1498", "433", "_yoast_wpseo_meta-robots-noindex", "0");
INSERT INTO `wp_postmeta` VALUES("1499", "433", "_yoast_wpseo_meta-robots-nofollow", "0");
INSERT INTO `wp_postmeta` VALUES("1500", "433", "_yoast_wpseo_meta-robots-adv", "none");
INSERT INTO `wp_postmeta` VALUES("1501", "433", "_yoast_wpseo_sitemap-include", "-");
INSERT INTO `wp_postmeta` VALUES("1502", "433", "_yoast_wpseo_sitemap-prio", "-");
INSERT INTO `wp_postmeta` VALUES("1503", "433", "_yoast_wpseo_sitemap-html-include", "-");
INSERT INTO `wp_postmeta` VALUES("1504", "433", "_yoast_wpseo_canonical", "");
INSERT INTO `wp_postmeta` VALUES("1505", "433", "_yoast_wpseo_redirect", "");
INSERT INTO `wp_postmeta` VALUES("1506", "433", "_yoast_wpseo_opengraph-description", "");
INSERT INTO `wp_postmeta` VALUES("1507", "433", "_yoast_wpseo_google-plus-description", "");
INSERT INTO `wp_postmeta` VALUES("1518", "437", "_edit_lock", "1382720215:1");
INSERT INTO `wp_postmeta` VALUES("1519", "437", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("1520", "439", "_wp_attached_file", "2013/10/logo1.png");
INSERT INTO `wp_postmeta` VALUES("1521", "439", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:360;s:6:\"height\";i:129;s:4:\"file\";s:17:\"2013/10/logo1.png\";s:5:\"sizes\";a:9:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:17:\"logo1-150x129.png\";s:5:\"width\";i:150;s:6:\"height\";i:129;s:9:\"mime-type\";s:9:\"image/png\";}s:6:\"medium\";a:4:{s:4:\"file\";s:17:\"logo1-300x107.png\";s:5:\"width\";i:300;s:6:\"height\";i:107;s:9:\"mime-type\";s:9:\"image/png\";}s:15:\"widget-featured\";a:4:{s:4:\"file\";s:17:\"logo1-300x129.png\";s:5:\"width\";i:300;s:6:\"height\";i:129;s:9:\"mime-type\";s:9:\"image/png\";}s:15:\"header-featured\";a:4:{s:4:\"file\";s:16:\"logo1-360x80.png\";s:5:\"width\";i:360;s:6:\"height\";i:80;s:9:\"mime-type\";s:9:\"image/png\";}s:18:\"portfolio-featured\";a:4:{s:4:\"file\";s:17:\"logo1-300x129.png\";s:5:\"width\";i:300;s:6:\"height\";i:129;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"grid-featured\";a:4:{s:4:\"file\";s:17:\"logo1-320x129.png\";s:5:\"width\";i:320;s:6:\"height\";i:129;s:9:\"mime-type\";s:9:\"image/png\";}s:14:\"shop_thumbnail\";a:4:{s:4:\"file\";s:15:\"logo1-90x90.png\";s:5:\"width\";i:90;s:6:\"height\";i:90;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"shop_catalog\";a:4:{s:4:\"file\";s:17:\"logo1-150x129.png\";s:5:\"width\";i:150;s:6:\"height\";i:129;s:9:\"mime-type\";s:9:\"image/png\";}s:11:\"shop_single\";a:4:{s:4:\"file\";s:17:\"logo1-300x129.png\";s:5:\"width\";i:300;s:6:\"height\";i:129;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1522", "439", "_edit_lock", "1382720525:1");
INSERT INTO `wp_postmeta` VALUES("1523", "439", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("1524", "440", "_wp_attached_file", "2013/10/logox21.png");
INSERT INTO `wp_postmeta` VALUES("1525", "440", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:728;s:6:\"height\";i:225;s:4:\"file\";s:19:\"2013/10/logox21.png\";s:5:\"sizes\";a:10:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:19:\"logox21-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:6:\"medium\";a:4:{s:4:\"file\";s:18:\"logox21-300x92.png\";s:5:\"width\";i:300;s:6:\"height\";i:92;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"home-featured\";a:4:{s:4:\"file\";s:19:\"logox21-700x225.png\";s:5:\"width\";i:700;s:6:\"height\";i:225;s:9:\"mime-type\";s:9:\"image/png\";}s:15:\"widget-featured\";a:4:{s:4:\"file\";s:19:\"logox21-300x200.png\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:9:\"image/png\";}s:15:\"header-featured\";a:4:{s:4:\"file\";s:18:\"logox21-640x80.png\";s:5:\"width\";i:640;s:6:\"height\";i:80;s:9:\"mime-type\";s:9:\"image/png\";}s:18:\"portfolio-featured\";a:4:{s:4:\"file\";s:19:\"logox21-300x200.png\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"grid-featured\";a:4:{s:4:\"file\";s:19:\"logox21-320x200.png\";s:5:\"width\";i:320;s:6:\"height\";i:200;s:9:\"mime-type\";s:9:\"image/png\";}s:14:\"shop_thumbnail\";a:4:{s:4:\"file\";s:17:\"logox21-90x90.png\";s:5:\"width\";i:90;s:6:\"height\";i:90;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"shop_catalog\";a:4:{s:4:\"file\";s:19:\"logox21-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:11:\"shop_single\";a:4:{s:4:\"file\";s:19:\"logox21-300x225.png\";s:5:\"width\";i:300;s:6:\"height\";i:225;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1510", "437", "_wp_attached_file", "2013/10/logo.png");
INSERT INTO `wp_postmeta` VALUES("1511", "437", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:360;s:6:\"height\";i:129;s:4:\"file\";s:16:\"2013/10/logo.png\";s:5:\"sizes\";a:9:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:16:\"logo-150x129.png\";s:5:\"width\";i:150;s:6:\"height\";i:129;s:9:\"mime-type\";s:9:\"image/png\";}s:6:\"medium\";a:4:{s:4:\"file\";s:16:\"logo-300x107.png\";s:5:\"width\";i:300;s:6:\"height\";i:107;s:9:\"mime-type\";s:9:\"image/png\";}s:15:\"widget-featured\";a:4:{s:4:\"file\";s:16:\"logo-300x129.png\";s:5:\"width\";i:300;s:6:\"height\";i:129;s:9:\"mime-type\";s:9:\"image/png\";}s:15:\"header-featured\";a:4:{s:4:\"file\";s:15:\"logo-360x80.png\";s:5:\"width\";i:360;s:6:\"height\";i:80;s:9:\"mime-type\";s:9:\"image/png\";}s:18:\"portfolio-featured\";a:4:{s:4:\"file\";s:16:\"logo-300x129.png\";s:5:\"width\";i:300;s:6:\"height\";i:129;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"grid-featured\";a:4:{s:4:\"file\";s:16:\"logo-320x129.png\";s:5:\"width\";i:320;s:6:\"height\";i:129;s:9:\"mime-type\";s:9:\"image/png\";}s:14:\"shop_thumbnail\";a:4:{s:4:\"file\";s:14:\"logo-90x90.png\";s:5:\"width\";i:90;s:6:\"height\";i:90;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"shop_catalog\";a:4:{s:4:\"file\";s:16:\"logo-150x129.png\";s:5:\"width\";i:150;s:6:\"height\";i:129;s:9:\"mime-type\";s:9:\"image/png\";}s:11:\"shop_single\";a:4:{s:4:\"file\";s:16:\"logo-300x129.png\";s:5:\"width\";i:300;s:6:\"height\";i:129;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1512", "438", "_wp_attached_file", "2013/10/logox2.png");
INSERT INTO `wp_postmeta` VALUES("1513", "438", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:728;s:6:\"height\";i:260;s:4:\"file\";s:18:\"2013/10/logox2.png\";s:5:\"sizes\";a:10:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:18:\"logox2-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:6:\"medium\";a:4:{s:4:\"file\";s:18:\"logox2-300x107.png\";s:5:\"width\";i:300;s:6:\"height\";i:107;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"home-featured\";a:4:{s:4:\"file\";s:18:\"logox2-700x260.png\";s:5:\"width\";i:700;s:6:\"height\";i:260;s:9:\"mime-type\";s:9:\"image/png\";}s:15:\"widget-featured\";a:4:{s:4:\"file\";s:18:\"logox2-300x200.png\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:9:\"image/png\";}s:15:\"header-featured\";a:4:{s:4:\"file\";s:17:\"logox2-640x80.png\";s:5:\"width\";i:640;s:6:\"height\";i:80;s:9:\"mime-type\";s:9:\"image/png\";}s:18:\"portfolio-featured\";a:4:{s:4:\"file\";s:18:\"logox2-300x200.png\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"grid-featured\";a:4:{s:4:\"file\";s:18:\"logox2-320x200.png\";s:5:\"width\";i:320;s:6:\"height\";i:200;s:9:\"mime-type\";s:9:\"image/png\";}s:14:\"shop_thumbnail\";a:4:{s:4:\"file\";s:16:\"logox2-90x90.png\";s:5:\"width\";i:90;s:6:\"height\";i:90;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"shop_catalog\";a:4:{s:4:\"file\";s:18:\"logox2-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:11:\"shop_single\";a:4:{s:4:\"file\";s:18:\"logox2-300x260.png\";s:5:\"width\";i:300;s:6:\"height\";i:260;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1517", "438", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("1516", "438", "_edit_lock", "1382720196:1");
INSERT INTO `wp_postmeta` VALUES("1526", "440", "_edit_lock", "1382721147:1");
INSERT INTO `wp_postmeta` VALUES("1527", "440", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("1528", "441", "_wp_attached_file", "2013/10/logo-320.png");
INSERT INTO `wp_postmeta` VALUES("1529", "441", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:320;s:6:\"height\";i:99;s:4:\"file\";s:20:\"2013/10/logo-320.png\";s:5:\"sizes\";a:8:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:19:\"logo-320-150x99.png\";s:5:\"width\";i:150;s:6:\"height\";i:99;s:9:\"mime-type\";s:9:\"image/png\";}s:6:\"medium\";a:4:{s:4:\"file\";s:19:\"logo-320-300x92.png\";s:5:\"width\";i:300;s:6:\"height\";i:92;s:9:\"mime-type\";s:9:\"image/png\";}s:15:\"widget-featured\";a:4:{s:4:\"file\";s:19:\"logo-320-300x99.png\";s:5:\"width\";i:300;s:6:\"height\";i:99;s:9:\"mime-type\";s:9:\"image/png\";}s:15:\"header-featured\";a:4:{s:4:\"file\";s:19:\"logo-320-320x80.png\";s:5:\"width\";i:320;s:6:\"height\";i:80;s:9:\"mime-type\";s:9:\"image/png\";}s:18:\"portfolio-featured\";a:4:{s:4:\"file\";s:19:\"logo-320-300x99.png\";s:5:\"width\";i:300;s:6:\"height\";i:99;s:9:\"mime-type\";s:9:\"image/png\";}s:14:\"shop_thumbnail\";a:4:{s:4:\"file\";s:18:\"logo-320-90x90.png\";s:5:\"width\";i:90;s:6:\"height\";i:90;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"shop_catalog\";a:4:{s:4:\"file\";s:19:\"logo-320-150x99.png\";s:5:\"width\";i:150;s:6:\"height\";i:99;s:9:\"mime-type\";s:9:\"image/png\";}s:11:\"shop_single\";a:4:{s:4:\"file\";s:19:\"logo-320-300x99.png\";s:5:\"width\";i:300;s:6:\"height\";i:99;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1530", "441", "_edit_lock", "1382721503:1");
INSERT INTO `wp_postmeta` VALUES("1531", "441", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("1532", "442", "_wp_attached_file", "2013/10/logo-3201.png");
INSERT INTO `wp_postmeta` VALUES("1533", "442", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:320;s:6:\"height\";i:164;s:4:\"file\";s:21:\"2013/10/logo-3201.png\";s:5:\"sizes\";a:8:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:21:\"logo-3201-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:6:\"medium\";a:4:{s:4:\"file\";s:21:\"logo-3201-300x153.png\";s:5:\"width\";i:300;s:6:\"height\";i:153;s:9:\"mime-type\";s:9:\"image/png\";}s:15:\"widget-featured\";a:4:{s:4:\"file\";s:21:\"logo-3201-300x164.png\";s:5:\"width\";i:300;s:6:\"height\";i:164;s:9:\"mime-type\";s:9:\"image/png\";}s:15:\"header-featured\";a:4:{s:4:\"file\";s:20:\"logo-3201-320x80.png\";s:5:\"width\";i:320;s:6:\"height\";i:80;s:9:\"mime-type\";s:9:\"image/png\";}s:18:\"portfolio-featured\";a:4:{s:4:\"file\";s:21:\"logo-3201-300x164.png\";s:5:\"width\";i:300;s:6:\"height\";i:164;s:9:\"mime-type\";s:9:\"image/png\";}s:14:\"shop_thumbnail\";a:4:{s:4:\"file\";s:19:\"logo-3201-90x90.png\";s:5:\"width\";i:90;s:6:\"height\";i:90;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"shop_catalog\";a:4:{s:4:\"file\";s:21:\"logo-3201-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:11:\"shop_single\";a:4:{s:4:\"file\";s:21:\"logo-3201-300x164.png\";s:5:\"width\";i:300;s:6:\"height\";i:164;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1534", "443", "_wp_attached_file", "2013/10/logo-728.png");
INSERT INTO `wp_postmeta` VALUES("1535", "443", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:728;s:6:\"height\";i:328;s:4:\"file\";s:20:\"2013/10/logo-728.png\";s:5:\"sizes\";a:10:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:20:\"logo-728-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:6:\"medium\";a:4:{s:4:\"file\";s:20:\"logo-728-300x135.png\";s:5:\"width\";i:300;s:6:\"height\";i:135;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"home-featured\";a:4:{s:4:\"file\";s:20:\"logo-728-700x328.png\";s:5:\"width\";i:700;s:6:\"height\";i:328;s:9:\"mime-type\";s:9:\"image/png\";}s:15:\"widget-featured\";a:4:{s:4:\"file\";s:20:\"logo-728-300x200.png\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:9:\"image/png\";}s:15:\"header-featured\";a:4:{s:4:\"file\";s:19:\"logo-728-640x80.png\";s:5:\"width\";i:640;s:6:\"height\";i:80;s:9:\"mime-type\";s:9:\"image/png\";}s:18:\"portfolio-featured\";a:4:{s:4:\"file\";s:20:\"logo-728-300x200.png\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"grid-featured\";a:4:{s:4:\"file\";s:20:\"logo-728-320x200.png\";s:5:\"width\";i:320;s:6:\"height\";i:200;s:9:\"mime-type\";s:9:\"image/png\";}s:14:\"shop_thumbnail\";a:4:{s:4:\"file\";s:18:\"logo-728-90x90.png\";s:5:\"width\";i:90;s:6:\"height\";i:90;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"shop_catalog\";a:4:{s:4:\"file\";s:20:\"logo-728-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:11:\"shop_single\";a:4:{s:4:\"file\";s:20:\"logo-728-300x300.png\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1536", "442", "_edit_lock", "1382722110:1");
INSERT INTO `wp_postmeta` VALUES("1537", "442", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("1538", "443", "_edit_lock", "1382722135:1");
INSERT INTO `wp_postmeta` VALUES("1539", "443", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("1540", "444", "_wp_attached_file", "2013/10/logo3.png");
INSERT INTO `wp_postmeta` VALUES("1541", "444", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:728;s:6:\"height\";i:225;s:4:\"file\";s:17:\"2013/10/logo3.png\";s:5:\"sizes\";a:10:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:17:\"logo3-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:6:\"medium\";a:4:{s:4:\"file\";s:16:\"logo3-300x92.png\";s:5:\"width\";i:300;s:6:\"height\";i:92;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"home-featured\";a:4:{s:4:\"file\";s:17:\"logo3-700x225.png\";s:5:\"width\";i:700;s:6:\"height\";i:225;s:9:\"mime-type\";s:9:\"image/png\";}s:15:\"widget-featured\";a:4:{s:4:\"file\";s:17:\"logo3-300x200.png\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:9:\"image/png\";}s:15:\"header-featured\";a:4:{s:4:\"file\";s:16:\"logo3-640x80.png\";s:5:\"width\";i:640;s:6:\"height\";i:80;s:9:\"mime-type\";s:9:\"image/png\";}s:18:\"portfolio-featured\";a:4:{s:4:\"file\";s:17:\"logo3-300x200.png\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"grid-featured\";a:4:{s:4:\"file\";s:17:\"logo3-320x200.png\";s:5:\"width\";i:320;s:6:\"height\";i:200;s:9:\"mime-type\";s:9:\"image/png\";}s:14:\"shop_thumbnail\";a:4:{s:4:\"file\";s:15:\"logo3-90x90.png\";s:5:\"width\";i:90;s:6:\"height\";i:90;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"shop_catalog\";a:4:{s:4:\"file\";s:17:\"logo3-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:11:\"shop_single\";a:4:{s:4:\"file\";s:17:\"logo3-300x225.png\";s:5:\"width\";i:300;s:6:\"height\";i:225;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1542", "444", "_edit_lock", "1382723463:1");
INSERT INTO `wp_postmeta` VALUES("1543", "444", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("1544", "445", "_wp_attached_file", "2013/10/logo650.png");
INSERT INTO `wp_postmeta` VALUES("1545", "445", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:650;s:6:\"height\";i:210;s:4:\"file\";s:19:\"2013/10/logo650.png\";s:5:\"sizes\";a:9:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:19:\"logo650-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:6:\"medium\";a:4:{s:4:\"file\";s:18:\"logo650-300x96.png\";s:5:\"width\";i:300;s:6:\"height\";i:96;s:9:\"mime-type\";s:9:\"image/png\";}s:15:\"widget-featured\";a:4:{s:4:\"file\";s:19:\"logo650-300x200.png\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:9:\"image/png\";}s:15:\"header-featured\";a:4:{s:4:\"file\";s:18:\"logo650-640x80.png\";s:5:\"width\";i:640;s:6:\"height\";i:80;s:9:\"mime-type\";s:9:\"image/png\";}s:18:\"portfolio-featured\";a:4:{s:4:\"file\";s:19:\"logo650-300x200.png\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"grid-featured\";a:4:{s:4:\"file\";s:19:\"logo650-320x200.png\";s:5:\"width\";i:320;s:6:\"height\";i:200;s:9:\"mime-type\";s:9:\"image/png\";}s:14:\"shop_thumbnail\";a:4:{s:4:\"file\";s:17:\"logo650-90x90.png\";s:5:\"width\";i:90;s:6:\"height\";i:90;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"shop_catalog\";a:4:{s:4:\"file\";s:19:\"logo650-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:11:\"shop_single\";a:4:{s:4:\"file\";s:19:\"logo650-300x210.png\";s:5:\"width\";i:300;s:6:\"height\";i:210;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1546", "445", "_edit_lock", "1382723854:1");
INSERT INTO `wp_postmeta` VALUES("1547", "445", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("1548", "446", "_wp_attached_file", "2013/10/logo600.png");
INSERT INTO `wp_postmeta` VALUES("1549", "446", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:600;s:6:\"height\";i:210;s:4:\"file\";s:19:\"2013/10/logo600.png\";s:5:\"sizes\";a:9:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:19:\"logo600-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:6:\"medium\";a:4:{s:4:\"file\";s:19:\"logo600-300x105.png\";s:5:\"width\";i:300;s:6:\"height\";i:105;s:9:\"mime-type\";s:9:\"image/png\";}s:15:\"widget-featured\";a:4:{s:4:\"file\";s:19:\"logo600-300x200.png\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:9:\"image/png\";}s:15:\"header-featured\";a:4:{s:4:\"file\";s:18:\"logo600-600x80.png\";s:5:\"width\";i:600;s:6:\"height\";i:80;s:9:\"mime-type\";s:9:\"image/png\";}s:18:\"portfolio-featured\";a:4:{s:4:\"file\";s:19:\"logo600-300x200.png\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"grid-featured\";a:4:{s:4:\"file\";s:19:\"logo600-320x200.png\";s:5:\"width\";i:320;s:6:\"height\";i:200;s:9:\"mime-type\";s:9:\"image/png\";}s:14:\"shop_thumbnail\";a:4:{s:4:\"file\";s:17:\"logo600-90x90.png\";s:5:\"width\";i:90;s:6:\"height\";i:90;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"shop_catalog\";a:4:{s:4:\"file\";s:19:\"logo600-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:11:\"shop_single\";a:4:{s:4:\"file\";s:19:\"logo600-300x210.png\";s:5:\"width\";i:300;s:6:\"height\";i:210;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1550", "446", "_edit_lock", "1382724618:1");
INSERT INTO `wp_postmeta` VALUES("1551", "446", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("1552", "447", "_wp_attached_file", "2013/10/logo580.png");
INSERT INTO `wp_postmeta` VALUES("1553", "447", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:580;s:6:\"height\";i:210;s:4:\"file\";s:19:\"2013/10/logo580.png\";s:5:\"sizes\";a:9:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:19:\"logo580-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:6:\"medium\";a:4:{s:4:\"file\";s:19:\"logo580-300x108.png\";s:5:\"width\";i:300;s:6:\"height\";i:108;s:9:\"mime-type\";s:9:\"image/png\";}s:15:\"widget-featured\";a:4:{s:4:\"file\";s:19:\"logo580-300x200.png\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:9:\"image/png\";}s:15:\"header-featured\";a:4:{s:4:\"file\";s:18:\"logo580-580x80.png\";s:5:\"width\";i:580;s:6:\"height\";i:80;s:9:\"mime-type\";s:9:\"image/png\";}s:18:\"portfolio-featured\";a:4:{s:4:\"file\";s:19:\"logo580-300x200.png\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"grid-featured\";a:4:{s:4:\"file\";s:19:\"logo580-320x200.png\";s:5:\"width\";i:320;s:6:\"height\";i:200;s:9:\"mime-type\";s:9:\"image/png\";}s:14:\"shop_thumbnail\";a:4:{s:4:\"file\";s:17:\"logo580-90x90.png\";s:5:\"width\";i:90;s:6:\"height\";i:90;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"shop_catalog\";a:4:{s:4:\"file\";s:19:\"logo580-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:11:\"shop_single\";a:4:{s:4:\"file\";s:19:\"logo580-300x210.png\";s:5:\"width\";i:300;s:6:\"height\";i:210;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1554", "447", "_edit_lock", "1382724709:1");
INSERT INTO `wp_postmeta` VALUES("1555", "447", "_yoast_wpseo_linkdex", "0");
INSERT INTO `wp_postmeta` VALUES("1556", "448", "_wp_attached_file", "2013/10/bowsiewowsie-ad.jpg");
INSERT INTO `wp_postmeta` VALUES("1557", "448", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:300;s:6:\"height\";i:250;s:4:\"file\";s:27:\"2013/10/bowsiewowsie-ad.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:27:\"bowsiewowsie-ad-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:15:\"widget-featured\";a:4:{s:4:\"file\";s:27:\"bowsiewowsie-ad-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:15:\"header-featured\";a:4:{s:4:\"file\";s:26:\"bowsiewowsie-ad-300x80.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:80;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:18:\"portfolio-featured\";a:4:{s:4:\"file\";s:27:\"bowsiewowsie-ad-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:13:\"grid-featured\";a:4:{s:4:\"file\";s:27:\"bowsiewowsie-ad-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"shop_thumbnail\";a:4:{s:4:\"file\";s:25:\"bowsiewowsie-ad-90x90.jpg\";s:5:\"width\";i:90;s:6:\"height\";i:90;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"shop_catalog\";a:4:{s:4:\"file\";s:27:\"bowsiewowsie-ad-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("1558", "448", "_edit_lock", "1382725420:1");
INSERT INTO `wp_postmeta` VALUES("1559", "448", "_yoast_wpseo_linkdex", "0");

/* INSERT TABLE DATA: wp_posts */
INSERT INTO `wp_posts` VALUES("2", "1", "2013-09-07 16:30:53", "2013-09-07 16:30:53", "This is an example page. It\'s different from a blog post because it will stay in one place and will show up in your site navigation (in most themes). Most people start with an About page that introduces them to potential site visitors. It might say something like this:\r\n<blockquote>Hi there! I\'m a bike messenger by day, aspiring actor by night, and this is my blog. I live in Los Angeles, have a great dog named Jack, and I like piña coladas. (And gettin\' caught in the rain.)</blockquote>\r\n...or something like this:\r\n<blockquote>The XYZ Doohickey Company was founded in 1971, and has been providing quality doohickeys to the public ever since. Located in Gotham City, XYZ employs over 2,000 people and does all kinds of awesome things for the Gotham community.</blockquote>\r\nAs a new WordPress user, you should go to <a href=\"http://healthydoghq.com/wp-admin/\">your dashboard</a> to delete this page and create new pages for your content. Have fun!", "About Us", "", "publish", "open", "open", "", "sample-page", "", "", "2013-10-23 22:15:27", "2013-10-23 22:15:27", "", "0", "http://healthydoghq.com/?page_id=2", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("34", "1", "2013-09-19 14:10:33", "2013-09-19 14:10:33", "", "Shop", "", "publish", "closed", "open", "", "shop", "", "", "2013-09-19 14:10:33", "2013-09-19 14:10:33", "", "0", "http://healthydoghq.com/shop/", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("8", "1", "2013-09-08 19:29:39", "2013-09-08 19:29:39", "This is an example page. It\'s different from a blog post because it will stay in one place and will show up in your site navigation (in most themes). Most people start with an About page that introduces them to potential site visitors. It might say something like this:\r\n<blockquote>Hi there! I\'m a bike messenger by day, aspiring actor by night, and this is my blog. I live in Los Angeles, have a great dog named Jack, and I like piña coladas. (And gettin\' caught in the rain.)</blockquote>\r\n...or something like this:\r\n<blockquote>The XYZ Doohickey Company was founded in 1971, and has been providing quality doohickeys to the public ever since. Located in Gotham City, XYZ employs over 2,000 people and does all kinds of awesome things for the Gotham community.</blockquote>\r\nAs a new WordPress user, you should go to <a href=\"http://healthydoghq.com/wp-admin/\">your dashboard</a> to delete this page and create new pages for your content. Have fun!", "About Us", "", "inherit", "open", "open", "", "2-revision-v1", "", "", "2013-09-08 19:29:39", "2013-09-08 19:29:39", "", "2", "http://healthydoghq.com/2-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("10", "1", "2013-09-08 19:30:20", "2013-09-08 19:30:20", "<a href=\"http://healthydoghq.com/wp-content/uploads/2013/09/POST-1024x682.png\"><img class=\" wp-image-13 alignright\" alt=\"POST-1024x682\" src=\"http://healthydoghq.com/wp-content/uploads/2013/09/POST-1024x682.png\" width=\"414\" height=\"276\" /></a>afsdfsdgasg fsdfsdgasg fsdfsdgasg fsdfsdgasg fsdfsdgasg fsdfsdgasg\r\n\r\nThis is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind.\r\n\r\nThis is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind. This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind.", "Second Post", "", "trash", "open", "open", "", "second-post", "", "", "2013-10-24 14:11:40", "2013-10-24 14:11:40", "", "0", "http://healthydoghq.com/?p=10", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("11", "1", "2013-09-08 19:30:20", "2013-09-08 19:30:20", "afsdfsdgasg", "Second Post", "", "inherit", "open", "open", "", "10-revision-v1", "", "", "2013-09-08 19:30:20", "2013-09-08 19:30:20", "", "10", "http://healthydoghq.com/10-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("12", "1", "2013-09-08 19:32:47", "2013-09-08 19:32:47", "", "featured-300x200", "", "inherit", "open", "open", "", "featured-300x200", "", "", "2013-09-08 19:32:47", "2013-09-08 19:32:47", "", "0", "http://healthydoghq.com/wp-content/uploads/2013/09/featured-300x200.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("13", "1", "2013-09-08 19:32:49", "2013-09-08 19:32:49", "", "POST-1024x682", "", "inherit", "open", "open", "", "post-1024x682", "", "", "2013-09-08 19:32:49", "2013-09-08 19:32:49", "", "0", "http://healthydoghq.com/wp-content/uploads/2013/09/POST-1024x682.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("17", "1", "2013-09-08 19:37:01", "2013-09-08 19:37:01", "afsdfsdgasg fsdfsdgasg fsdfsdgasg fsdfsdgasg fsdfsdgasg fsdfsdgasg<a href=\"http://healthydoghq.com/wp-content/uploads/2013/09/POST-1024x682.png\"><img class=\"alignright size-medium wp-image-13\" alt=\"POST-1024x682\" src=\"http://healthydoghq.com/wp-content/uploads/2013/09/POST-1024x682-300x199.png\" width=\"300\" height=\"199\" /></a>", "Second Post", "", "inherit", "open", "open", "", "10-revision-v1", "", "", "2013-09-08 19:37:01", "2013-09-08 19:37:01", "", "10", "http://healthydoghq.com/10-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("18", "1", "2013-09-08 19:38:53", "2013-09-08 19:38:53", "<a href=\"http://healthydoghq.com/wp-content/uploads/2013/09/POST-1024x682.png\"><img class=\"aligncenter size-full wp-image-13\" alt=\"POST-1024x682\" src=\"http://healthydoghq.com/wp-content/uploads/2013/09/POST-1024x682.png\" width=\"1024\" height=\"682\" /></a>afsdfsdgasg fsdfsdgasg fsdfsdgasg fsdfsdgasg fsdfsdgasg fsdfsdgasg", "Second Post", "", "inherit", "open", "open", "", "10-revision-v1", "", "", "2013-09-08 19:38:53", "2013-09-08 19:38:53", "", "10", "http://healthydoghq.com/10-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("19", "1", "2013-09-08 19:44:16", "2013-09-08 19:44:16", "", "ad space 300x100", "", "inherit", "open", "open", "", "ad-space-300x100", "", "", "2013-09-08 19:44:16", "2013-09-08 19:44:16", "", "0", "http://healthydoghq.com/wp-content/uploads/2013/09/ad-space-300x100.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("20", "1", "2013-09-08 19:44:17", "2013-09-08 19:44:17", "", "ad space 300x250", "", "inherit", "open", "open", "", "ad-space-300x250", "", "", "2013-09-08 19:44:17", "2013-09-08 19:44:17", "", "0", "http://healthydoghq.com/wp-content/uploads/2013/09/ad-space-300x250.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("21", "1", "2013-09-08 19:55:52", "2013-09-08 19:55:52", "", "728x90", "", "inherit", "open", "open", "", "728x90", "", "", "2013-09-08 19:55:52", "2013-09-08 19:55:52", "", "0", "http://healthydoghq.com/wp-content/uploads/2013/09/728x90.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("319", "1", "2013-10-23 20:09:47", "0000-00-00 00:00:00", "", "Auto Draft", "", "auto-draft", "closed", "closed", "", "", "", "", "2013-10-23 20:09:47", "0000-00-00 00:00:00", "", "0", "http://healthydoghq.com/?p=319", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("23", "1", "2013-09-08 19:59:55", "2013-09-08 19:59:55", "", "Contact", "", "publish", "open", "open", "", "contact", "", "", "2013-09-08 19:59:56", "2013-09-08 19:59:56", "", "0", "http://healthydoghq.com/?page_id=23", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("24", "1", "2013-09-08 19:59:56", "2013-09-08 19:59:56", " ", "", "", "publish", "open", "closed", "", "24", "", "", "2013-10-24 22:57:58", "2013-10-24 22:57:58", "", "0", "http://healthydoghq.com/24/", "5", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("25", "1", "2013-09-08 19:59:56", "2013-09-08 19:59:56", "", "Contact", "", "inherit", "open", "open", "", "23-revision-v1", "", "", "2013-09-08 19:59:56", "2013-09-08 19:59:56", "", "23", "http://healthydoghq.com/23-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("26", "1", "2013-09-08 20:00:14", "2013-09-08 20:00:14", "", "Products", "", "publish", "open", "open", "", "products", "", "", "2013-09-08 20:00:21", "2013-09-08 20:00:21", "", "0", "http://healthydoghq.com/?page_id=26", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("27", "1", "2013-09-08 20:00:14", "2013-09-08 20:00:14", " ", "", "", "publish", "open", "closed", "", "27", "", "", "2013-10-24 22:57:58", "2013-10-24 22:57:58", "", "0", "http://healthydoghq.com/27/", "3", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("28", "1", "2013-09-08 20:00:14", "2013-09-08 20:00:14", "", "Products", "", "inherit", "open", "open", "", "26-revision-v1", "", "", "2013-09-08 20:00:14", "2013-09-08 20:00:14", "", "26", "http://healthydoghq.com/26-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("29", "1", "2013-09-08 20:02:58", "2013-09-08 20:02:58", "", "Home", "", "publish", "open", "open", "", "home", "", "", "2013-09-08 20:02:58", "2013-09-08 20:02:58", "", "0", "http://healthydoghq.com/?page_id=29", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("242", "1", "2013-09-19 21:38:02", "2013-09-19 21:38:02", "", "Pretty-Toxic-Beauty-Ingredients-To-Avoid", "", "inherit", "open", "open", "", "pretty-toxic-beauty-ingredients-to-avoid", "", "", "2013-09-19 21:38:02", "2013-09-19 21:38:02", "", "0", "http://healthydoghq.com/wp-content/uploads/2013/09/Pretty-Toxic-Beauty-Ingredients-To-Avoid.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("31", "1", "2013-09-08 20:02:58", "2013-09-08 20:02:58", "", "Home", "", "inherit", "open", "open", "", "29-revision-v1", "", "", "2013-09-08 20:02:58", "2013-09-08 20:02:58", "", "29", "http://healthydoghq.com/29-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("32", "1", "2013-09-12 13:41:32", "2013-09-12 13:41:32", "\"Now Is the Start\" from Pines by A Fine Frenzy. Track 12 of 13. Genre: Singer/Songwriter.", "Now Is the Start", "", "inherit", "open", "open", "", "now-is-the-start", "", "", "2013-09-12 13:41:32", "2013-09-12 13:41:32", "", "0", "http://healthydoghq.com/wp-content/uploads/2013/09/music.mp3", "0", "attachment", "audio/mpeg", "0");
INSERT INTO `wp_posts` VALUES("243", "1", "2013-09-19 21:38:04", "2013-09-19 21:38:04", "", "Natural-Organic-Beauty-Shoping-Directory", "", "inherit", "open", "open", "", "natural-organic-beauty-shoping-directory", "", "", "2013-09-19 21:38:04", "2013-09-19 21:38:04", "", "0", "http://healthydoghq.com/wp-content/uploads/2013/09/Natural-Organic-Beauty-Shoping-Directory.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("36", "1", "2013-09-19 14:10:33", "2013-09-19 14:10:33", "[woocommerce_cart]", "Cart", "", "publish", "closed", "open", "", "cart", "", "", "2013-09-19 14:10:33", "2013-09-19 14:10:33", "", "0", "http://healthydoghq.com/cart/", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("238", "1", "2013-09-19 14:29:06", "2013-09-19 14:29:06", " ", "", "", "publish", "open", "open", "", "238", "", "", "2013-09-19 14:29:52", "2013-09-19 14:29:52", "", "0", "http://healthydoghq.com/?p=238", "3", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("38", "1", "2013-09-19 14:10:33", "2013-09-19 14:10:33", "[woocommerce_checkout]", "Checkout", "", "publish", "closed", "open", "", "checkout", "", "", "2013-09-19 14:10:33", "2013-09-19 14:10:33", "", "0", "http://healthydoghq.com/checkout/", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("237", "1", "2013-09-19 14:29:06", "2013-09-19 14:29:06", " ", "", "", "publish", "open", "open", "", "237", "", "", "2013-09-19 14:29:52", "2013-09-19 14:29:52", "", "0", "http://healthydoghq.com/?p=237", "2", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("40", "1", "2013-09-19 14:10:33", "2013-09-19 14:10:33", "[woocommerce_my_account]", "My Account", "", "publish", "closed", "open", "", "my-account", "", "", "2013-09-19 14:10:33", "2013-09-19 14:10:33", "", "0", "http://healthydoghq.com/my-account/", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("236", "1", "2013-09-19 14:29:06", "2013-09-19 14:29:06", " ", "", "", "publish", "open", "open", "", "236", "", "", "2013-09-19 14:29:52", "2013-09-19 14:29:52", "", "0", "http://healthydoghq.com/?p=236", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("42", "1", "2013-09-19 14:10:33", "2013-09-19 14:10:33", "[woocommerce_lost_password]", "Lost Password", "", "publish", "closed", "open", "", "lost-password", "", "", "2013-09-19 14:10:33", "2013-09-19 14:10:33", "", "40", "http://healthydoghq.com/my-account/lost-password/", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("43", "1", "2013-09-19 14:10:33", "2013-09-19 14:10:33", "[woocommerce_edit_address]", "Edit My Address", "", "publish", "closed", "open", "", "edit-address", "", "", "2013-09-19 14:10:33", "2013-09-19 14:10:33", "", "40", "http://healthydoghq.com/my-account/edit-address/", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("44", "1", "2013-09-19 14:10:33", "2013-09-19 14:10:33", "[woocommerce_view_order]", "View Order", "", "publish", "closed", "open", "", "view-order", "", "", "2013-09-19 14:10:33", "2013-09-19 14:10:33", "", "40", "http://healthydoghq.com/my-account/view-order/", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("45", "1", "2013-09-19 14:10:33", "2013-09-19 14:10:33", "[woocommerce_change_password]", "Change Password", "", "publish", "closed", "open", "", "change-password", "", "", "2013-09-19 14:10:33", "2013-09-19 14:10:33", "", "40", "http://healthydoghq.com/my-account/change-password/", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("46", "1", "2013-09-19 14:10:33", "2013-09-19 14:10:33", "", "Logout", "", "publish", "closed", "open", "", "logout", "", "", "2013-09-19 14:10:33", "2013-09-19 14:10:33", "", "40", "http://healthydoghq.com/my-account/logout/", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("47", "1", "2013-09-19 14:10:33", "2013-09-19 14:10:33", "[woocommerce_pay]", "Checkout &rarr; Pay", "", "publish", "closed", "open", "", "pay", "", "", "2013-09-19 14:10:33", "2013-09-19 14:10:33", "", "38", "http://healthydoghq.com/checkout/pay/", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("48", "1", "2013-09-19 14:10:33", "2013-09-19 14:10:33", "[woocommerce_thankyou]", "Order Received", "", "publish", "closed", "open", "", "order-received", "", "", "2013-09-19 14:10:33", "2013-09-19 14:10:33", "", "38", "http://healthydoghq.com/checkout/order-received/", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("253", "1", "2013-10-01 23:13:30", "2013-10-01 23:13:30", "/*\nWelcome to Custom CSS!\n\nCSS (Cascading Style Sheets) is a kind of code that tells the browser how\nto render a web page. You may delete these comments and get started with\nyour customizations.\n\nBy default, your stylesheet will be loaded after the theme stylesheets,\nwhich means that your rules can take precedence and override the theme CSS\nrules. Just write here what you want to change, you don\'t need to copy all\nyour theme\'s stylesheet content.\n*/\nnav-primary {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\n.current-menu-item > a {\n	background-color: #87c440;\n}", "safecss", "Modern Blogger Child Theme", "inherit", "closed", "closed", "", "248-revision-v1", "", "", "2013-10-01 23:13:30", "2013-10-01 23:13:30", "", "248", "http://healthydoghq.com/248-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("252", "1", "2013-10-01 23:12:46", "2013-10-01 23:12:46", "/*\nWelcome to Custom CSS!\n\nCSS (Cascading Style Sheets) is a kind of code that tells the browser how\nto render a web page. You may delete these comments and get started with\nyour customizations.\n\nBy default, your stylesheet will be loaded after the theme stylesheets,\nwhich means that your rules can take precedence and override the theme CSS\nrules. Just write here what you want to change, you don\'t need to copy all\nyour theme\'s stylesheet content.\n*/\nnav-primary {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\n.nav-primary .current-menu-item > a {\n	background-color: #87c440;\n}", "safecss", "Modern Blogger Child Theme", "inherit", "closed", "closed", "", "248-revision-v1", "", "", "2013-10-01 23:12:46", "2013-10-01 23:12:46", "", "248", "http://healthydoghq.com/248-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("254", "1", "2013-10-01 23:14:40", "2013-10-01 23:14:40", "/*\nWelcome to Custom CSS!\n\nCSS (Cascading Style Sheets) is a kind of code that tells the browser how\nto render a web page. You may delete these comments and get started with\nyour customizations.\n\nBy default, your stylesheet will be loaded after the theme stylesheets,\nwhich means that your rules can take precedence and override the theme CSS\nrules. Just write here what you want to change, you don\'t need to copy all\nyour theme\'s stylesheet content.\n*/\nnav-primary {\n	background: none repeat scroll 0 0 #0089d0;\n}", "safecss", "Modern Blogger Child Theme", "inherit", "closed", "closed", "", "248-revision-v1", "", "", "2013-10-01 23:14:40", "2013-10-01 23:14:40", "", "248", "http://healthydoghq.com/248-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("251", "1", "2013-10-01 23:11:47", "2013-10-01 23:11:47", "/*\nWelcome to Custom CSS!\n\nCSS (Cascading Style Sheets) is a kind of code that tells the browser how\nto render a web page. You may delete these comments and get started with\nyour customizations.\n\nBy default, your stylesheet will be loaded after the theme stylesheets,\nwhich means that your rules can take precedence and override the theme CSS\nrules. Just write here what you want to change, you don\'t need to copy all\nyour theme\'s stylesheet content.\n*/\nnav-primary {\n	background: none repeat scroll 0 0 #0089d0;\n}", "safecss", "Modern Blogger Child Theme", "inherit", "closed", "closed", "", "248-revision-v1", "", "", "2013-10-01 23:11:47", "2013-10-01 23:11:47", "", "248", "http://healthydoghq.com/248-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("249", "1", "2013-10-01 23:05:39", "2013-10-01 23:05:39", "/*\nWelcome to Custom CSS!\n\nCSS (Cascading Style Sheets) is a kind of code that tells the browser how\nto render a web page. You may delete these comments and get started with\nyour customizations.\n\nBy default, your stylesheet will be loaded after the theme stylesheets,\nwhich means that your rules can take precedence and override the theme CSS\nrules. Just write here what you want to change, you don\'t need to copy all\nyour theme\'s stylesheet content.\n*/\n.genesis-nav-menu {\n	color: #0089d0;\n}", "safecss", "Modern Blogger Child Theme", "inherit", "closed", "closed", "", "248-revision-v1", "", "", "2013-10-01 23:05:39", "2013-10-01 23:05:39", "", "248", "http://healthydoghq.com/248-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("250", "1", "2013-10-01 23:07:00", "2013-10-01 23:07:00", "/*\nWelcome to Custom CSS!\n\nCSS (Cascading Style Sheets) is a kind of code that tells the browser how\nto render a web page. You may delete these comments and get started with\nyour customizations.\n\nBy default, your stylesheet will be loaded after the theme stylesheets,\nwhich means that your rules can take precedence and override the theme CSS\nrules. Just write here what you want to change, you don\'t need to copy all\nyour theme\'s stylesheet content.\n*/", "safecss", "Modern Blogger Child Theme", "inherit", "closed", "closed", "", "248-revision-v1", "", "", "2013-10-01 23:07:00", "2013-10-01 23:07:00", "", "248", "http://healthydoghq.com/248-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("248", "1", "2013-10-01 23:04:59", "2013-10-01 23:04:59", "/*\nWelcome to Custom CSS!\n\nCSS (Cascading Style Sheets) is a kind of code that tells the browser how\nto render a web page. You may delete these comments and get started with\nyour customizations.\n\nBy default, your stylesheet will be loaded after the theme stylesheets,\nwhich means that your rules can take precedence and override the theme CSS\nrules. Just write here what you want to change, you don\'t need to copy all\nyour theme\'s stylesheet content.\n*/\n.nav-primary {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\n.nav-primary a:hover, .nav-primary .current-menu-item > a {\n	background-color: #b7c71e;\n	color: rgb(255,255,255);\n}\n\na {\n	color: #b7c71e;\n}\n\na:hover {\n	color: #0089d0;\n}\n\n.entry-title {\n	font-family: \'Montserrat\', sans-serif;\n	color: #0089d0;\n	font-size: 2.1rem;\n	font-weight: 300;\n	line-height: 1;\n}\n\n.entry-title a, .sidebar .widgettitle a {\n	color: #0089d0;\n}\n\n.entry-title a:hover {\n	color: #b7c71e;\n}\n\nh1, h2, h3, h4, h5, h6 {\n	color: #0089d0;\n	margin-bottom: 10px;\n	font-family: \'Montserrat\', sans-serif;\n}\n\nh2 {\n	font-size: 2rem;\n}\n\n.entry-content a {\n	color: #0089d0;\n}\n\nbody {\n	color: rgb(84,84,84);\n	font-family: \'Lato\', sans-serif;\n	font-size: 1.6rem;\n	font-weight: 300;\n	line-height: 1.5;\n}\n\n#respond label {\n	color: #0089d0;\n}\n\n#reply-title {\n	border-bottom: medium double;\n	color: #0089d0;\n}\n\nbutton, input[type=\"button\"], input[type=\"reset\"], input[type=\"submit\"] {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\nbutton:hover, input[type=\"button\"]:hover, input[type=\"reset\"]:hover, input[type=\"submit\"]:hover {\n	background: none repeat scroll 0 0 #b7c71e;\n}\n\n.simple-social-icons ul li a, .simple-social-icons ul li a:hover {\n	background-color: #b7c71e !important;\n	border-radius: 300px 300px 300px 300px;\n}\n\n.simple-social-icons ul li a {\n	background: #b7c71e !important;\n}\n\n.simple-social-icons ul li a:hover {\n	background-color: #0089d0 !important;\n}\n\n.user-profile a {\n	display: block;\n	font-family: \'Montserrat\', sans-serif;\n}\n\n.site-container {\n	background: #fff url(\'\') repeat-x;\n	border: 10px solid #fff;\n	border-top-left-radius: 20px;\n	border-top-right-radius: 20px;\n	margin: 20px auto;\n	max-width: 1168px;\n}", "safecss", "Modern Blogger Child Theme", "publish", "closed", "closed", "", "safecss", "", "", "2013-10-25 16:19:17", "2013-10-25 16:19:17", ".nav-primary{background:none repeat scroll 0 0 #0089d0}.nav-primary a:hover,.nav-primary .current-menu-item > a{background-color:#b7c71e;color:#fff}a{color:#b7c71e}a:hover{color:#0089d0}.entry-title{font-family:\'Montserrat\', sans-serif;color:#0089d0;font-size:2.1rem;font-weight:300;line-height:1}.entry-title a,.sidebar .widgettitle a{color:#0089d0}.entry-title a:hover{color:#b7c71e}h1,h2,h3,h4,h5,h6{color:#0089d0;margin-bottom:10px;font-family:\'Montserrat\', sans-serif}h2{font-size:2rem}.entry-content a{color:#0089d0}body{color:#545454;font-family:\'Lato\', sans-serif;font-size:1.6rem;font-weight:300;line-height:1.5}#respond label{color:#0089d0}#reply-title{border-bottom:medium double;color:#0089d0}button,input[type=\"button\"],input[type=\"reset\"],input[type=\"submit\"]{background:none repeat scroll 0 0 #0089d0}button:hover,input[type=\"button\"]:hover,input[type=\"reset\"]:hover,input[type=\"submit\"]:hover{background:none repeat scroll 0 0 #b7c71e}.simple-social-icons ul li a,.simple-social-icons ul li a:hover{background-color:#b7c71e !important;border-radius:300px 300px 300px 300px}.simple-social-icons ul li a{background:#b7c71e !important}.simple-social-icons ul li a:hover{background-color:#0089d0 !important}.user-profile a{display:block;font-family:\'Montserrat\', sans-serif}.site-container{background:#fff url(\'\') repeat-x;border:10px solid #fff;border-top-left-radius:20px;border-top-right-radius:20px;margin:20px auto;max-width:1168px}", "0", "http://healthydoghq.com/?safecss=safecss", "0", "safecss", "", "0");
INSERT INTO `wp_posts` VALUES("327", "1", "2013-10-24 14:11:40", "2013-10-24 14:11:40", "[caption id=\"\" align=\"alignleft\" width=\"142\" caption=\"Here&#39;s a sample caption with an image aligned left.\"]<img alt=\"Heres a sample caption, with a sample image aligned left.\" src=\"http://demo.studiopress.com/images/wordpress.png\" width=\"142\" height=\"142\" />[/caption]\n\nThis is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like.\n\nThis is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind. This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like.\n\nThis is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind.\n\nThis is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind. This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind.", "Sample Post With Image Aligned Left", "", "inherit", "closed", "closed", "", "90-revision-v1", "", "", "2013-10-24 14:11:40", "2013-10-24 14:11:40", "", "90", "http://healthydoghq.com/90-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("244", "1", "2013-09-19 21:38:05", "2013-09-19 21:38:05", "", "Beginners-guide-to-clean-beauty-2", "", "inherit", "open", "open", "", "beginners-guide-to-clean-beauty-2", "", "", "2013-09-19 21:38:05", "2013-09-19 21:38:05", "", "0", "http://healthydoghq.com/wp-content/uploads/2013/09/Beginners-guide-to-clean-beauty-2.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("64", "1", "2013-09-19 14:14:41", "2013-09-19 14:14:41", "", "Page Layouts", "", "publish", "open", "open", "", "page-layouts", "", "", "2013-09-19 14:14:41", "2013-09-19 14:14:41", "", "0", "http://healthydoghq.com/page-layouts/", "11", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("65", "1", "2013-09-19 14:14:41", "2013-09-19 14:14:41", "", "Page Templates", "", "publish", "open", "open", "", "page-templates", "", "", "2013-09-19 14:14:41", "2013-09-19 14:14:41", "", "0", "http://healthydoghq.com/page-templates/", "19", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("66", "1", "2013-09-19 14:14:41", "2013-09-19 14:14:41", "", "Buy Genesis Now", "", "publish", "open", "open", "", "buy-genesis-now", "", "", "2013-09-19 14:14:41", "2013-09-19 14:14:41", "", "0", "http://healthydoghq.com/buy-genesis-now/", "24", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("67", "1", "2010-08-15 19:03:46", "2010-08-15 19:03:46", "This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages as you like and manage all of your content inside of WordPress.", "Sample Page", "", "trash", "open", "closed", "", "sample", "", "", "2013-10-24 19:13:53", "2013-10-24 19:13:53", "", "0", "http://demo.studiopress.com/genesis", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("241", "1", "2013-09-19 14:47:56", "2013-09-19 14:47:56", "", "Home", "", "publish", "open", "closed", "", "home", "", "", "2013-10-24 22:57:58", "2013-10-24 22:57:58", "", "0", "http://healthydoghq.com/?p=241", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("69", "1", "2010-08-15 19:04:08", "2010-08-15 19:04:08", "This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.", "Sub Page 1.1", "", "trash", "open", "closed", "", "sub-page-11", "", "", "2013-10-24 19:13:53", "2013-10-24 19:13:53", "", "67", "http://demo.studiopress.com/genesis", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("70", "1", "2010-08-15 19:04:33", "2010-08-15 19:04:33", "This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.", "Sub Page 1.2", "", "trash", "open", "closed", "", "sub-page-12", "", "", "2013-10-24 19:13:53", "2013-10-24 19:13:53", "", "67", "http://demo.studiopress.com/genesis", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("71", "1", "2010-08-15 19:04:52", "2010-08-15 19:04:52", "This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.", "Sub Page 1.3", "", "trash", "open", "closed", "", "sub-page-13", "", "", "2013-10-24 19:13:53", "2013-10-24 19:13:53", "", "67", "http://demo.studiopress.com/genesis", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("72", "1", "2010-08-15 19:05:12", "2010-08-15 19:05:12", "This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.", "Sub Page 2.1", "", "trash", "open", "closed", "", "sub-page-21", "", "", "2013-10-24 19:13:53", "2013-10-24 19:13:53", "", "69", "http://demo.studiopress.com/genesis", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("73", "1", "2010-08-15 19:05:25", "2010-08-15 19:05:25", "This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.", "Sub Page 2.2", "", "trash", "open", "closed", "", "sub-page-22", "", "", "2013-10-24 19:13:53", "2013-10-24 19:13:53", "", "69", "http://demo.studiopress.com/genesis", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("74", "1", "2010-08-15 19:05:43", "2010-08-15 19:05:43", "This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.", "Sub Page 2.3", "", "trash", "open", "closed", "", "sub-page-23", "", "", "2013-10-24 19:13:53", "2013-10-24 19:13:53", "", "69", "http://demo.studiopress.com/genesis", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("75", "1", "2010-08-15 19:06:00", "2010-08-15 19:06:00", "This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.", "Sub Page 3.1", "", "trash", "open", "closed", "", "sub-page-31", "", "", "2013-10-24 19:13:53", "2013-10-24 19:13:53", "", "72", "http://demo.studiopress.com/genesis", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("76", "1", "2010-08-15 19:06:13", "2010-08-15 19:06:13", "This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.", "Sub Page 3.2", "", "trash", "open", "closed", "", "sub-page-32", "", "", "2013-10-24 19:13:53", "2013-10-24 19:13:53", "", "72", "http://demo.studiopress.com/genesis", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("77", "1", "2010-08-15 19:06:28", "2010-08-15 19:06:28", "This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.", "Sub Page 3.3", "", "trash", "open", "closed", "", "sub-page-33", "", "", "2013-10-24 19:13:53", "2013-10-24 19:13:53", "", "72", "http://demo.studiopress.com/genesis", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("78", "1", "2010-08-15 19:08:02", "2010-08-15 19:08:02", "Below is a list of 6 post/page layouts that come with the Genesis theme framework:\n\n<ul>\n	<li><a href=\"http://demo.studiopress.com/genesis/layouts/cs\">Content/Sidebar</a></li>\n	<li><a href=\"http://demo.studiopress.com/genesis/layouts/sc\">Sidebar/Content</a></li>\n	<li><a href=\"http://demo.studiopress.com/genesis/layouts/css\">Content/Sidebar/Sidebar</a></li>\n	<li><a href=\"http://demo.studiopress.com/genesis/layouts/ssc\">Sidebar/Sidebar/Content</a></li>\n	<li><a href=\"http://demo.studiopress.com/genesis/layouts/scs\">Sidebar/Content/Sidebar</a></li>\n	<li><a href=\"http://demo.studiopress.com/genesis/layouts/fwc\">Full Width Content</a></li>\n</ul>", "Page Layouts", "", "trash", "open", "closed", "", "layouts", "", "", "2013-10-24 19:13:53", "2013-10-24 19:13:53", "", "0", "http://demo.studiopress.com/genesis", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("80", "1", "2013-09-19 14:14:42", "2013-09-19 14:14:42", "", "Brian Gardner", "", "publish", "open", "open", "", "brian-gardner", "", "", "2013-09-19 14:14:42", "2013-09-19 14:14:42", "", "0", "http://healthydoghq.com/brian-gardner/", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("81", "1", "2013-09-19 14:14:42", "2013-09-19 14:14:42", "", "Nathan Rice", "", "publish", "open", "open", "", "nathan-rice", "", "", "2013-09-19 14:14:42", "2013-09-19 14:14:42", "", "0", "http://healthydoghq.com/nathan-rice/", "3", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("82", "1", "2013-09-19 14:14:42", "2013-09-19 14:14:42", "", "Ron Rennick", "", "publish", "open", "open", "", "ron-rennick", "", "", "2013-09-19 14:14:42", "2013-09-19 14:14:42", "", "0", "http://healthydoghq.com/ron-rennick/", "6", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("83", "1", "2013-09-19 14:14:42", "2013-09-19 14:14:42", "", "Rafal Tomal", "", "publish", "open", "open", "", "rafal-tomal", "", "", "2013-09-19 14:14:42", "2013-09-19 14:14:42", "", "0", "http://healthydoghq.com/rafal-tomal/", "5", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("84", "1", "2013-09-19 14:14:42", "2013-09-19 14:14:42", "", "Nick Croft", "", "publish", "open", "open", "", "nick-croft", "", "", "2013-09-19 14:14:42", "2013-09-19 14:14:42", "", "0", "http://healthydoghq.com/nick-croft/", "4", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("85", "1", "2013-09-19 14:14:42", "2013-09-19 14:14:42", "", "Josh Byers", "", "publish", "open", "open", "", "josh-byers", "", "", "2013-09-19 14:14:42", "2013-09-19 14:14:42", "", "0", "http://healthydoghq.com/josh-byers/", "2", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("5", "1", "2013-01-01 01:53:58", "2013-01-01 01:53:58", "<h1>Headline 1</h1>\n<h2>Headline 2</h2>\n<h3>Headline 3</h3>\n<h4>Headline 4</h4>\n<h5>Headline 5</h5>\n<h6>Headline 6</h6>", "Sample Post With Headlines", "", "trash", "open", "open", "", "headlines", "", "", "2013-10-24 14:11:40", "2013-10-24 14:11:40", "", "0", "http://demo.studiopress.com/genesis/?p=5", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("86", "1", "2013-01-01 01:54:32", "2013-01-01 01:54:32", "This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind.\n\n<ol>\n<li>Ordered list item #1</li>\n<li>Ordered list item #2</li>\n<li>Ordered list item #3</li>\n<li>Ordered list item #4</li>\n<li>Ordered list item #5</li>\n</ol>\n\nThis is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind.\n\nThis is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind. This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind.", "Sample Post With an Ordered List", "", "trash", "open", "open", "", "ordered-list", "", "", "2013-10-24 14:11:40", "2013-10-24 14:11:40", "", "0", "http://demo.studiopress.com/genesis/?p=9", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("87", "1", "2013-01-01 01:54:48", "2013-01-01 01:54:48", "This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind.\n\n<ul>\n<li>Unordered list item #1</li>\n<li>Unordered list item #2</li>\n<li>Unordered list item #3</li>\n<li>Unordered list item #4</li>\n<li>Unordered list item #5</li>\n</ul>\n\nThis is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind.\n\nThis is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind. This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind.", "Sample Post With an Unordered List", "", "trash", "open", "open", "", "unordered-list", "", "", "2013-10-24 14:11:40", "2013-10-24 14:11:40", "", "0", "http://demo.studiopress.com/genesis/?p=11", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("88", "1", "2013-01-01 01:55:21", "2013-01-01 01:55:21", "[caption id=\"\" align=\"aligncenter\" width=\"142\" caption=\"Here\'s a sample caption with an image centered.\"]<img alt=\"Here\'s a sample caption with a sample image centered.\" src=\"http://demo.studiopress.com/images/wordpress.png\" width=\"142\" height=\"142\" />[/caption]\n\nThis is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind.\n\nThis is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind. This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind.\n\nThis is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind.\n\nThis is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind. This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind.", "Sample Post With Image Centered", "", "trash", "open", "open", "", "image-centered", "", "", "2013-10-24 14:11:40", "2013-10-24 14:11:40", "", "0", "http://demo.studiopress.com/genesis/?p=13", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("89", "1", "2013-01-01 01:56:30", "2013-01-01 01:56:30", "[caption id=\"\" align=\"alignright\" width=\"142\" caption=\"Here\'s a sample caption with an image aligned right.\"]<img alt=\"Here\'s a sample caption with a sample image aligned right.\" src=\"http://demo.studiopress.com/images/wordpress.png\" width=\"142\" height=\"142\" />[/caption]\n\nThis is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like.\n\nThis is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind. This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like.\n\nThis is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind.\n\nThis is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind. This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind.", "Sample Post With Image Aligned Right", "", "trash", "open", "open", "", "image-aligned-right", "", "", "2013-10-24 14:11:40", "2013-10-24 14:11:40", "", "0", "http://demo.studiopress.com/genesis/?p=16", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("90", "1", "2013-01-01 01:57:05", "2013-01-01 01:57:05", "[caption id=\"\" align=\"alignleft\" width=\"142\" caption=\"Here&#39;s a sample caption with an image aligned left.\"]<img alt=\"Heres a sample caption, with a sample image aligned left.\" src=\"http://demo.studiopress.com/images/wordpress.png\" width=\"142\" height=\"142\" />[/caption]\n\nThis is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like.\n\nThis is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind. This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like.\n\nThis is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind.\n\nThis is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind. This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind.", "Sample Post With Image Aligned Left", "", "trash", "open", "open", "", "image-aligned-left", "", "", "2013-10-24 14:11:40", "2013-10-24 14:11:40", "", "0", "http://demo.studiopress.com/genesis/?p=18", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("91", "1", "2013-01-01 01:57:18", "2013-01-01 01:57:18", "<img alt=\"Sample Image\" src=\"http://www.genesisframework.com/wp-content/uploads/patagonia.jpg\" />\r\n\r\nThis is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind.\r\n\r\nThis is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind. This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind.\r\n\r\nThis is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind.\r\n\r\nThis is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind. This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind.", "Sample Post With Threaded Comments", "", "trash", "open", "open", "", "threaded-comments", "", "", "2013-10-24 14:11:40", "2013-10-24 14:11:40", "", "0", "http://demo.studiopress.com/genesis/?p=20", "0", "post", "", "6");
INSERT INTO `wp_posts` VALUES("92", "1", "2010-08-15 19:09:00", "2010-08-15 19:09:00", "This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.", "Content/Sidebar", "", "trash", "open", "closed", "", "cs", "", "", "2013-10-24 19:14:50", "2013-10-24 19:14:50", "", "78", "http://demo.studiopress.com/genesis", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("93", "1", "2010-08-15 19:09:20", "2010-08-15 19:09:20", "This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.", "Sidebar/Content", "", "trash", "open", "closed", "", "sc", "", "", "2013-10-24 19:14:08", "2013-10-24 19:14:08", "", "78", "http://demo.studiopress.com/genesis", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("94", "1", "2010-08-15 19:09:42", "2010-08-15 19:09:42", "This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.", "Content/Sidebar/Sidebar", "", "trash", "open", "closed", "", "css", "", "", "2013-10-24 19:14:50", "2013-10-24 19:14:50", "", "78", "http://demo.studiopress.com/genesis", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("95", "1", "2010-08-15 19:10:30", "2010-08-15 19:10:30", "This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.", "Sidebar/Sidebar/Content", "", "trash", "open", "closed", "", "ssc", "", "", "2013-10-24 19:13:53", "2013-10-24 19:13:53", "", "78", "http://demo.studiopress.com/genesis", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("96", "1", "2010-08-15 19:10:48", "2010-08-15 19:10:48", "This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.", "Sidebar/Content/Sidebar", "", "trash", "open", "closed", "", "scs", "", "", "2013-10-24 19:13:53", "2013-10-24 19:13:53", "", "78", "http://demo.studiopress.com/genesis", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("97", "1", "2010-08-15 19:11:13", "2010-08-15 19:11:13", "This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.", "Full Width Content", "", "trash", "open", "closed", "", "fwc", "", "", "2013-10-24 19:14:08", "2013-10-24 19:14:08", "", "78", "http://demo.studiopress.com/genesis", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("98", "1", "2010-08-15 19:11:56", "2010-08-15 19:11:56", "This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.", "Page Templates", "", "trash", "open", "closed", "", "templates", "", "", "2013-10-24 19:13:53", "2013-10-24 19:13:53", "", "0", "http://demo.studiopress.com/genesis", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("381", "1", "2013-10-24 22:56:49", "2013-10-24 22:56:49", "My husband, Norman and I, have had the privilege of owning whippets for twenty-five years. Over this space of time, we\'ve had a total of six of these sensitive, loving animals, each one with its own personality and way of doing things. Our first whippet, Devo, ruled the pack. Without a doubt, she was at the top of the pecking order at our house, after my husband. We lost her about ten years ago at the age of 15. Fortunately for us, all of our whippets have enjoyed long and healthy lives -- then we got Golda.\r\n\r\nGolda was originally owned by a good friend who owns and shows whippets. In 1992, our friend brought home a 12-week old red and white spitfire named \"Blue Skies Golden Pony\" and called her \"Golda\". The puppy was a gregarious fence jumper with a big heart and personality to match. Golda and Norman hit it off the first time they met. In many ways, Golda became his dog right from the start, and after retiring from the show ring, Golda came to live with us in 2004.\r\n\r\nFrom the first day we adopted her, life with Golda has been an absolute pleasure. She has always been active, friendly and loving, with no agenda, truly the best dog we\'ve ever known. Golda\'s great love in life was chasing the frisbee. Her speed and agility made her great at jumping to terrific heights and making spectacular catches in mid-air. In 2008, we noticed that she landed a bit funny after a routine jump, but she otherwise seemed fine. The next day, we awoke to find her paralyzed from the neck down. Frantically, we took her to several vets to find out that she had suffered from a Fibrocartilaginous Embolism (Canine FCE) -- a blockage in a blood vessel in the spinal cord. It’s often referred to as a spinal cord stroke. Our vet treated her with steroids and for the next six weeks, we became her legs, carrying her outside and holding her up as she went to the bathroom. Over time, she regained the use of her limbs and was eventually able to resume her favorite pastime of chasing the frisbee, albeit at a much reduced speed and intensity. She wasn\'t quite as coordinated as before, but we felt lucky that she was walking again. Little did we know it at the time, but the experience of dealing with Canine FCE would help prepare us for an equally devastating aliment: Canine Immune Mediated Hemolytic Anemia (IMHA) a few short years later.\r\n\r\nEven after her bout with Canine FCE, Golda\'s quality of life was very good, but in May of 2013, she had a set back. She once again was having trouble walking and maintaining her balance. We immediately assumed she had a reoccurrence of FCE. The symptoms were virtually the same, but this time, she began loosing weight and her gums were very pale in color. We took her to our vet, Dr. Bill Conley at Summer Animal Hospital, who examined her, ran a complete blood count (CBC) and a packed cell volume test (PCV). The results were staggering. The PCV test put her red blood cell count at 8%!!!  He said he had never seen a dog still alive with such a low blood count and that a normal dog\'s red blood cell volume is between 35 and 55%. Dr. Conley immediately recommended a blood transfusion. Needless to say, we were devastated at the news! How could we have missed all of the signs!? How could we have let Golda get into such a weakened state!? We agreed to the transfusion which \"stabilized\" her red blood cell volume to a still low 15%. As we were leaving his office, Dr. Conley prepared us for the worst by informing us that Golda was suffering from Immune Mediated Hemolytic Anemia (IMHA), formerly known as Canine Auto-Immune Hemolytic Anemia (AIHA), and that the recovery for this disease was \"very low\".  With a heavy heart, we thanked him and took Golda home for what we felt would surely be the last few days of her life.\r\n\r\nThe ride home from the vet\'s office seemed unusually long. On the way, we decided that we would do everything we could do, within reason, to give Golda the chance to recover. We owed that to her for all of the love and joy she had brought to us over the years. When we got home, we assessed our situation and began to formulate a plan to give her the opportunity to heal. Fortunately for us, and Golda, we had some great vets and quite a bit of luck on our side!\r\n\r\nGolda\'s Condition\r\n\r\nWeight: 19 pounds, normally 27\r\nRed Blood Cell Volume: 8%, normal is between 35 and 55%\r\nAppetite: None, normally she\'s a chow hound never turning down a meal\r\nAmbulatory: Unable to walk or go to the bathroom on her own\r\nMental &amp; Emotional: Lethargic, extremely low energy level\r\nColor: Pale gums - almost white, skin white, even freckles usually seen on legs &amp; tummy very faded and pale\r\nCoat: Course, red coloring in coat pale\r\nNose: Dry and rough to the touch\r\nEyes: Third eye lid showing\r\n\r\nFormulating a Plan\r\n\r\nOnce we assessed Golda\'s condition, we began to formulate a plan. First, we reached out to Dr. Kathy Mitchener at Angel Care, a veterinary clinic specializing in treating canine cancer to let her know about Golda\'s IMHA diagnosis. Dr. Mitchener had been performing weekly acupuncture sessions on Golda over the past couple of months in order to help her walk and move around better, with very good results. She also tested Golda\'s blood and confirmed Dr. Conley\'s diagnosis. Together, she and Dr. Conley, teamed up to administer a regimen of drugs to hopefully pull our beloved whippet out of the throws of IMHA.\r\n\r\nThe next step was research. I dedicated myself to find every stitch of information available online about IMHA. While there was a lot of information out there, it was a monumental task to compile. And as it turned out, no one had a strategy to combat the condition. That\'s when I decided to combine the information I found online and go with my gut -- of course, with input from our vets. To make matters worse, my husband had just sustained a ruptured achilles tendon, so in many ways, I was on my own in taking care of Golda. His inability to help carry her outside for potty brakes is what pushed me to design and develop the ___________. Without it, I never would have been able to handle the difficult task of taking Golda in and out of the house.\r\n\r\nMy online research lead me to _________ a supplement given to Chernobyl victims to help rebuild their damaged red blood cells. I also tracked down ________ a supplement that mimics mother\'s milk. Coconut water.\r\n\r\nExecuting the Plan\r\n\r\nOnce I had what I thought was the right supplements and nutrition for the battle ahead, I began to give put my plan into action. Golda\'s weight loss and lack of appetite was the number one priority. I had to make her eat and the only thing I could do was force feed her baby food.\r\n\r\nSherry to fill in everyday routine, feeding, etc.\r\n\r\n\r\nThroughout this process, we continued to visit Dr. Mitchener for Golda\'s weekly acupuncture sessions, this time targeting parts of the body to help her body\'s bone marrow generate new red blood cells. For the first two weeks, Golda was still weak and showing no signs of improvement. Dr. Mitchener took another packed cell volume test only to find that her red blood cell count had dropped even further. At this point, we wondered if we were doing the right thing by putting Golda through all of this heartache. But, Norman and I had seen something in Golda that led us to believe she was actually feeling better. Dr. Mitchener said that we should take Golda home and ask her what she wants to do…later that evening, we did just that and Golda gave us her answer: She was not ready to give up and neither were we! We continued on our regimen of drugs, supplements and nutritious food. Six weeks later, her PCV was 23! We were making progress, and are continuing to make progress to this day.\r\n\r\nI sincerely hope Healthy Dog Headquarters will help your dog as you go battle the effects of Canine IMHA. I\'ve worked diligently to provide the best information available, based on our own experience to help your dog fight and recover from this illness. Please look around our website and help make your dog a healthy dog!", "Golda\'s Story: Saving Our Dog from Immune Mediated Hemolytic Anemia (IMHA)", "", "publish", "closed", "closed", "", "saving-our-dog-from-immune-mediated-hemolytic-anemia", "", "", "2013-10-24 22:56:49", "2013-10-24 22:56:49", "", "0", "http://healthydoghq.com/?page_id=381", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("100", "1", "2010-08-15 19:12:26", "2010-08-15 19:12:26", "", "Archive Page", "", "publish", "open", "closed", "", "archive", "", "", "2010-08-15 19:12:26", "2010-08-15 19:12:26", "", "98", "http://demo.studiopress.com/genesis", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("101", "1", "2010-08-15 19:12:43", "2010-08-15 19:12:43", "", "Blog Page", "", "publish", "open", "closed", "", "blog", "", "", "2013-10-24 19:31:15", "2013-10-24 19:31:15", "", "0", "http://demo.studiopress.com/genesis", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("102", "1", "2010-08-15 19:13:33", "2010-08-15 19:13:33", "[gravityform id=1 name=ContactForm title=false description=false]\n\n* This contact form was developed with a third party plugin called <a href=\"http://www.studiopress.com/go/gravity\">Gravity Forms</a> and is not included in the Genesis Framework. It is for display on this demo site - though we highly recommend using it.", "Contact Page", "", "publish", "open", "closed", "", "contact-2", "", "", "2010-08-15 19:13:33", "2010-08-15 19:13:33", "", "0", "http://demo.studiopress.com/genesis", "11", "page", "", "0");
INSERT INTO `wp_posts` VALUES("181", "1", "2011-02-03 18:06:59", "2011-02-03 18:06:59", "Below are examples of column classes that are available in the Genesis Framework style sheet.\n\n<h3>Two-Columns</h3>\n\n<div class=\"one-half first\">\n<p>This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what exactly is on your mind.</p>\n</div>\n\n<div class=\"one-half\">\n<p>This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what exactly is on your mind.</p>\n</div>\n\n<div class=\"clear-line\"></div>\n\n<h3>Three-Columns</h3>\n\n<div class=\"one-third first\">\n<p>This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind.</p>\n</div>\n\n<div class=\"one-third\">\n<p>This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind.</p>\n</div>\n\n<div class=\"one-third\">\n<p>This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind.</p>\n</div>\n\n<div class=\"clear-line\"></div>\n\n<h3>Four-Columns</h3>\n\n<div class=\"one-fourth first\">\n<p>This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what exactly is on your mind.</p>\n</div>\n\n<div class=\"one-fourth\">\n<p>This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what exactly is on your mind.</p>\n</div>\n\n<div class=\"one-fourth\">\n<p>This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what exactly is on your mind.</p>\n</div>\n\n<div class=\"one-fourth\">\n<p>This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what exactly is on your mind.</p>\n</div>\n\n<div class=\"clear-line\"></div>\n\n<h3>Five-Columns</h3>\n\n<div class=\"one-fifth first\">\n<p>This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what exactly is on your mind.</p>\n</div>\n\n<div class=\"one-fifth\">\n<p>This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what exactly is on your mind.</p>\n</div>\n\n<div class=\"one-fifth\">\n<p>This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what exactly is on your mind.</p>\n</div>\n\n<div class=\"one-fifth\">\n<p>This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what exactly is on your mind.</p>\n</div>\n\n<div class=\"one-fifth\">\n<p>This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what exactly is on your mind.</p>\n</div>\n\n<div class=\"clear-line\"></div>\n\n<h3>Six-Columns</h3>\n\n<div class=\"one-sixth first\">\n<p>This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind.</p>\n</div>\n\n<div class=\"one-sixth\">\n<p>This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind.</p>\n</div>\n\n<div class=\"one-sixth\">\n<p>This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind.</p>\n</div>\n\n<div class=\"one-sixth\">\n<p>This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind.</p>\n</div>\n\n<div class=\"one-sixth\">\n<p>This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind.</p>\n</div>\n\n<div class=\"one-sixth\">\n<p>This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind.</p>\n</div>", "Column Classes", "", "trash", "open", "closed", "", "columns", "", "", "2013-10-24 19:14:50", "2013-10-24 19:14:50", "", "0", "http://demo.studiopress.com/genesis/?page_id=181", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("239", "1", "2013-09-19 14:32:41", "2013-09-19 14:32:41", "", "Archives", "", "publish", "open", "closed", "", "archives-2", "", "", "2013-10-24 22:57:58", "2013-10-24 22:57:58", "", "98", "http://healthydoghq.com/?p=239", "4", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("183", "1", "2013-01-01 01:54:12", "2013-01-01 01:54:12", "This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind.\n\n<blockquote>This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what exactly is on your mind.</blockquote>\n\nThis is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind.\n\nThis is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind. This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind.", "Sample Post With a Blockquote", "", "trash", "open", "open", "", "blockquote", "", "", "2013-10-24 14:11:40", "2013-10-24 14:11:40", "", "0", "http://demo.studiopress.com/genesis/?p=7", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("210", "1", "2012-10-29 16:09:15", "2012-10-29 16:09:15", "<div style=\"float:left;margin-right:4.166666666%;width:65.277777777%;\">\n    <p style=\"background-color: #1e1e1e;color: #fff;padding: 24px 0;text-align: center;\">Content (752px)</p>\n</div>\n<div style=\"float:left;width:30.555555555%;\">\n    <p style=\"background-color: #1e1e1e;color: #fff;padding: 24px 0;text-align: center;\">Sidebar (352px)</p>\n</div>\n\n<div class=\"clear\"></div>\n\n<div style=\"float:left;margin-right:4.166666666%;width:30.555555555%;\">\n    <p style=\"background-color: #1e1e1e;color: #fff;padding: 24px 0;text-align: center;\">Sidebar (352px)</p>\n</div>\n<div style=\"float:left;width:65.277777777%;\">\n    <p style=\"background-color: #1e1e1e;color: #fff;padding: 24px 0;text-align: center;\">Content (752px)</p>\n</div>\n\n<div class=\"clear\"></div>\n\n<div style=\"float:left;margin-right:4.166666666%;width:45.833333333%;\">\n    <p style=\"background-color: #1e1e1e;color: #fff;padding: 24px 0;text-align: center;\">Content (528px)</p>\n</div>\n<div style=\"float:left;margin-right:4.166666666%;width:30.555555555%;\">\n    <p style=\"background-color: #1e1e1e;color: #fff;padding: 24px 0;text-align: center;\">Sidebar (352px)</p>\n</div>\n<div style=\"float:left;width:15.277777777%;\">\n    <p style=\"background-color: #1e1e1e;color: #fff;padding: 24px 0;text-align: center;\">Sidebar-Alt (176px)</p>\n</div>\n\n<div class=\"clear\"></div>\n\n<div style=\"float:left;margin-right:4.166666666%;width:15.277777777%;\">\n    <p style=\"background-color: #1e1e1e;color: #fff;padding: 24px 0;text-align: center;\">Sidebar-Alt (176px)</p>\n</div>\n<div style=\"float:left;margin-right:4.166666666%;width:30.555555555%;\">\n    <p style=\"background-color: #1e1e1e;color: #fff;padding: 24px 0;text-align: center;\">Sidebar (352px)</p>\n</div>\n<div style=\"float:left;width:45.833333333%;\">\n    <p style=\"background-color: #1e1e1e;color: #fff;padding: 24px 0;text-align: center;\">Content (528px)</p>\n</div>\n\n<div style=\"float:left;margin-right:4.166666666%;width:15.277777777%;\">\n    <p style=\"background-color: #1e1e1e;color: #fff;padding: 24px 0;text-align: center;\">Sidebar-Alt (176px)</p>\n</div>\n<div style=\"float:left;margin-right:4.166666666%;width:45.833333333%;\">\n    <p style=\"background-color: #1e1e1e;color: #fff;padding: 24px 0;text-align: center;\">Content (528px)</p>\n</div>\n<div style=\"float:left;width:30.555555555%;\">\n    <p style=\"background-color: #1e1e1e;color: #fff;padding: 24px 0;text-align: center;\">Sidebar (352px)</p>\n</div>\n\n<div class=\"clear\"></div>\n\n<div style=\"float:left;width:100%;\">\n    <p style=\"background-color: #1e1e1e;color: #fff;padding: 24px 0;text-align: center;\">Content (1152px)</p>\n</div>\n\n<div class=\"clear\"></div>\n\n<div style=\"float:left;margin-right:4.166666666%;width:30.555555555%;\">\n    <p style=\"background-color: #1e1e1e;color: #fff;padding: 24px 0;text-align: center;\">Footer Widget (352px)</p>\n</div>\n<div style=\"float:left;margin-right:4.166666666%;width:30.555555555%;\">\n    <p style=\"background-color: #1e1e1e;color: #fff;padding: 24px 0;text-align: center;\">Footer Widget (352px)</p>\n</div>\n<div style=\"float:left;width:30.555555555%;\">\n    <p style=\"background-color: #1e1e1e;color: #fff;padding: 24px 0;text-align: center;\">Footer Widget (352px)</p>\n</div>", "", "", "trash", "open", "closed", "", "1152-grid-system", "", "", "2013-10-24 19:14:50", "2013-10-24 19:14:50", "", "78", "http://www.genesisframework.com/?page_id=210", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("211", "1", "2013-09-19 14:14:42", "2013-09-19 14:14:42", " ", "", "", "publish", "open", "open", "", "211", "", "", "2013-09-19 14:14:42", "2013-09-19 14:14:42", "", "98", "http://healthydoghq.com/211/", "20", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("212", "1", "2013-09-19 14:14:42", "2013-09-19 14:14:42", " ", "", "", "publish", "open", "open", "", "212", "", "", "2013-09-19 14:14:42", "2013-09-19 14:14:42", "", "98", "http://healthydoghq.com/212/", "21", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("213", "1", "2013-09-19 14:14:42", "2013-09-19 14:14:42", "Below are examples of column classes that are available with the Genesis Framework parent theme: Two-Columns This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what exactly is on your mind. This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what exactly is on your mind. Three-Columns This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind. This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts…", "Columns Page", "", "publish", "open", "open", "", "columns-page", "", "", "2013-09-19 14:14:42", "2013-09-19 14:14:42", "", "0", "http://healthydoghq.com/columns-page/", "22", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("214", "1", "2013-09-19 14:14:42", "2013-09-19 14:14:42", "This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your…", "", "", "publish", "open", "open", "", "214", "", "", "2013-09-19 14:14:42", "2013-09-19 14:14:42", "", "78", "http://healthydoghq.com/214/", "13", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("215", "1", "2013-09-19 14:14:42", "2013-09-19 14:14:42", "This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your…", "", "", "publish", "open", "open", "", "215", "", "", "2013-09-19 14:14:42", "2013-09-19 14:14:42", "", "78", "http://healthydoghq.com/215/", "15", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("216", "1", "2013-09-19 14:14:42", "2013-09-19 14:14:42", "This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your…", "", "", "publish", "open", "open", "", "216", "", "", "2013-09-19 14:14:42", "2013-09-19 14:14:42", "", "78", "http://healthydoghq.com/216/", "18", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("217", "1", "2013-09-19 14:14:42", "2013-09-19 14:14:42", "This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your…", "", "", "publish", "open", "open", "", "217", "", "", "2013-09-19 14:14:42", "2013-09-19 14:14:42", "", "0", "http://healthydoghq.com/217/", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("218", "1", "2013-09-19 14:14:42", "2013-09-19 14:14:42", "This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your…", "", "", "publish", "open", "open", "", "218", "", "", "2013-09-19 14:14:42", "2013-09-19 14:14:42", "", "78", "http://healthydoghq.com/218/", "14", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("219", "1", "2013-09-19 14:14:42", "2013-09-19 14:14:42", "This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your…", "", "", "publish", "open", "open", "", "219", "", "", "2013-09-19 14:14:42", "2013-09-19 14:14:42", "", "78", "http://healthydoghq.com/219/", "17", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("220", "1", "2013-09-19 14:14:42", "2013-09-19 14:14:42", "This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your…", "", "", "publish", "open", "open", "", "220", "", "", "2013-09-19 14:14:42", "2013-09-19 14:14:42", "", "78", "http://healthydoghq.com/220/", "16", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("221", "1", "2013-09-19 14:14:42", "2013-09-19 14:14:42", "This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your…", "", "", "publish", "open", "open", "", "221", "", "", "2013-09-19 14:14:42", "2013-09-19 14:14:42", "", "67", "http://healthydoghq.com/221/", "2", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("222", "1", "2013-09-19 14:14:42", "2013-09-19 14:14:42", "This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your…", "", "", "publish", "open", "open", "", "222", "", "", "2013-09-19 14:14:42", "2013-09-19 14:14:42", "", "67", "http://healthydoghq.com/222/", "9", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("223", "1", "2013-09-19 14:14:42", "2013-09-19 14:14:42", "This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your…", "", "", "publish", "open", "open", "", "223", "", "", "2013-09-19 14:14:42", "2013-09-19 14:14:42", "", "67", "http://healthydoghq.com/223/", "10", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("224", "1", "2013-09-19 14:14:42", "2013-09-19 14:14:42", "This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your…", "", "", "publish", "open", "open", "", "224", "", "", "2013-09-19 14:14:42", "2013-09-19 14:14:42", "", "69", "http://healthydoghq.com/224/", "3", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("225", "1", "2013-09-19 14:14:42", "2013-09-19 14:14:42", "This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your…", "", "", "publish", "open", "open", "", "225", "", "", "2013-09-19 14:14:42", "2013-09-19 14:14:42", "", "69", "http://healthydoghq.com/225/", "7", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("226", "1", "2013-09-19 14:14:42", "2013-09-19 14:14:42", "This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your…", "", "", "publish", "open", "open", "", "226", "", "", "2013-09-19 14:14:42", "2013-09-19 14:14:42", "", "69", "http://healthydoghq.com/226/", "8", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("227", "1", "2013-09-19 14:14:42", "2013-09-19 14:14:42", "This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your…", "", "", "publish", "open", "open", "", "227", "", "", "2013-09-19 14:14:42", "2013-09-19 14:14:42", "", "72", "http://healthydoghq.com/227/", "4", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("228", "1", "2013-09-19 14:14:42", "2013-09-19 14:14:42", "This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your…", "", "", "publish", "open", "open", "", "228", "", "", "2013-09-19 14:14:42", "2013-09-19 14:14:42", "", "72", "http://healthydoghq.com/228/", "5", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("229", "1", "2013-09-19 14:14:42", "2013-09-19 14:14:42", "This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your…", "", "", "publish", "open", "open", "", "229", "", "", "2013-09-19 14:14:42", "2013-09-19 14:14:42", "", "72", "http://healthydoghq.com/229/", "6", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("230", "1", "2013-09-19 14:14:42", "2013-09-19 14:14:42", "[gravityform id=1 name=ContactForm title=false description=false] * This contact form was developed with a third party plugin called Gravity Forms and is not included in the Genesis Framework. It is for display only here on the demo site – though we highly recommend using it.", "", "", "publish", "open", "open", "", "230", "", "", "2013-09-19 14:14:42", "2013-09-19 14:14:42", "", "0", "http://healthydoghq.com/230/", "23", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("231", "1", "2013-09-19 14:14:42", "2013-09-19 14:14:42", "", "1152 Grid System", "", "publish", "open", "open", "", "1152-grid-system", "", "", "2013-09-19 14:14:42", "2013-09-19 14:14:42", "", "78", "http://healthydoghq.com/1152-grid-system/", "12", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("232", "1", "2013-09-19 14:14:42", "2013-09-19 14:14:42", "", "About", "", "publish", "open", "open", "", "about", "", "", "2013-09-19 14:14:42", "2013-09-19 14:14:42", "", "0", "http://healthydoghq.com/about/", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("233", "1", "2013-09-19 14:14:42", "2013-09-19 14:14:42", "", "Blog", "", "publish", "open", "open", "", "blog", "", "", "2013-09-19 14:14:42", "2013-09-19 14:14:42", "", "98", "http://healthydoghq.com/blog/", "2", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("234", "1", "2013-09-19 14:14:42", "2013-09-19 14:14:42", "", "Contact", "", "publish", "open", "open", "", "contact", "", "", "2013-09-19 14:14:42", "2013-09-19 14:14:42", "", "0", "http://healthydoghq.com/contact/", "4", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("235", "1", "2013-09-19 14:14:43", "2013-09-19 14:14:43", "", "Archives", "", "publish", "open", "open", "", "archives", "", "", "2013-09-19 14:14:43", "2013-09-19 14:14:43", "", "98", "http://healthydoghq.com/archives/", "3", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("255", "1", "2013-10-01 23:16:25", "2013-10-01 23:16:25", "/*\nWelcome to Custom CSS!\n\nCSS (Cascading Style Sheets) is a kind of code that tells the browser how\nto render a web page. You may delete these comments and get started with\nyour customizations.\n\nBy default, your stylesheet will be loaded after the theme stylesheets,\nwhich means that your rules can take precedence and override the theme CSS\nrules. Just write here what you want to change, you don\'t need to copy all\nyour theme\'s stylesheet content.\n*/\n.nav-primary {\n	background: none repeat scroll 0 0 #0089d0;\n}", "safecss", "Modern Blogger Child Theme", "inherit", "closed", "closed", "", "248-revision-v1", "", "", "2013-10-01 23:16:25", "2013-10-01 23:16:25", "", "248", "http://healthydoghq.com/248-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("256", "1", "2013-10-01 23:17:24", "2013-10-01 23:17:24", "/*\nWelcome to Custom CSS!\n\nCSS (Cascading Style Sheets) is a kind of code that tells the browser how\nto render a web page. You may delete these comments and get started with\nyour customizations.\n\nBy default, your stylesheet will be loaded after the theme stylesheets,\nwhich means that your rules can take precedence and override the theme CSS\nrules. Just write here what you want to change, you don\'t need to copy all\nyour theme\'s stylesheet content.\n*/\n.nav-primary {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\n.nav-primary a:hover, .nav-primary .current-menu-item > a {\n	background-color: #87c440;\n	color: rgb(255,255,255);\n}", "safecss", "Modern Blogger Child Theme", "inherit", "closed", "closed", "", "248-revision-v1", "", "", "2013-10-01 23:17:24", "2013-10-01 23:17:24", "", "248", "http://healthydoghq.com/248-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("258", "1", "2013-10-01 23:26:27", "2013-10-01 23:26:27", "/*\nWelcome to Custom CSS!\n\nCSS (Cascading Style Sheets) is a kind of code that tells the browser how\nto render a web page. You may delete these comments and get started with\nyour customizations.\n\nBy default, your stylesheet will be loaded after the theme stylesheets,\nwhich means that your rules can take precedence and override the theme CSS\nrules. Just write here what you want to change, you don\'t need to copy all\nyour theme\'s stylesheet content.\n*/\n.nav-primary {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\n.nav-primary a:hover, .nav-primary .current-menu-item > a {\n	background-color: #87c440;\n	color: rgb(255,255,255);\n}", "safecss", "Modern Blogger Child Theme", "inherit", "closed", "closed", "", "248-revision-v1", "", "", "2013-10-01 23:26:27", "2013-10-01 23:26:27", "", "248", "http://healthydoghq.com/248-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("257", "1", "2013-10-01 23:24:58", "2013-10-01 23:24:58", "/*\nWelcome to Custom CSS!\n\nCSS (Cascading Style Sheets) is a kind of code that tells the browser how\nto render a web page. You may delete these comments and get started with\nyour customizations.\n\nBy default, your stylesheet will be loaded after the theme stylesheets,\nwhich means that your rules can take precedence and override the theme CSS\nrules. Just write here what you want to change, you don\'t need to copy all\nyour theme\'s stylesheet content.\n*/\n.nav-primary {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\n.nav-primary a:hover, .nav-primary .current-menu-item > a {\n	background-color: #87c440;\n	color: rgb(255,255,255);\n}\n\nbody.custom-background {\n	background-color: rgb(253,199,208);\n	background-image: url(\"http://www.glamorganicgoddess.com/wp-content/uploads/2013/08/USING-This-One-tinydotsolidoverlay500x500png.png\");\n}", "safecss", "Modern Blogger Child Theme", "inherit", "closed", "closed", "", "248-revision-v1", "", "", "2013-10-01 23:24:58", "2013-10-01 23:24:58", "", "248", "http://healthydoghq.com/248-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("259", "1", "2013-10-02 13:45:04", "2013-10-02 13:45:04", "/*\nWelcome to Custom CSS!\n\nCSS (Cascading Style Sheets) is a kind of code that tells the browser how\nto render a web page. You may delete these comments and get started with\nyour customizations.\n\nBy default, your stylesheet will be loaded after the theme stylesheets,\nwhich means that your rules can take precedence and override the theme CSS\nrules. Just write here what you want to change, you don\'t need to copy all\nyour theme\'s stylesheet content.\n*/\n.nav-primary {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\n.nav-primary a:hover, .nav-primary .current-menu-item > a {\n	background-color: #87c440;\n	color: rgb(255,255,255);\n}\n\n.entry-title {\n	color: #87c440;\n	font-family: \'Montserrat\', sans-serif;\n	font-size: 2.5rem;\n	font-weight: 300;\n	line-height: 1;\n}", "safecss", "Modern Blogger Child Theme", "inherit", "closed", "closed", "", "248-revision-v1", "", "", "2013-10-02 13:45:04", "2013-10-02 13:45:04", "", "248", "http://healthydoghq.com/248-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("260", "1", "2013-10-02 13:46:08", "2013-10-02 13:46:08", "/*\nWelcome to Custom CSS!\n\nCSS (Cascading Style Sheets) is a kind of code that tells the browser how\nto render a web page. You may delete these comments and get started with\nyour customizations.\n\nBy default, your stylesheet will be loaded after the theme stylesheets,\nwhich means that your rules can take precedence and override the theme CSS\nrules. Just write here what you want to change, you don\'t need to copy all\nyour theme\'s stylesheet content.\n*/\n.nav-primary {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\n.nav-primary a:hover, .nav-primary .current-menu-item > a {\n	background-color: #87c440;\n	color: rgb(255,255,255);\n}\n\n.entry-title {\n	font-family: \'Montserrat\', sans-serif;\n	font-size: 2.5rem;\n	font-weight: 300;\n	line-height: 1;\n}\n\n.entry-title a, .sidebar .widgettitle a {\n	color: #87c440;\n}", "safecss", "Modern Blogger Child Theme", "inherit", "closed", "closed", "", "248-revision-v1", "", "", "2013-10-02 13:46:08", "2013-10-02 13:46:08", "", "248", "http://healthydoghq.com/248-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("261", "1", "2013-10-02 13:46:32", "2013-10-02 13:46:32", "/*\nWelcome to Custom CSS!\n\nCSS (Cascading Style Sheets) is a kind of code that tells the browser how\nto render a web page. You may delete these comments and get started with\nyour customizations.\n\nBy default, your stylesheet will be loaded after the theme stylesheets,\nwhich means that your rules can take precedence and override the theme CSS\nrules. Just write here what you want to change, you don\'t need to copy all\nyour theme\'s stylesheet content.\n*/\n.nav-primary {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\n.nav-primary a:hover, .nav-primary .current-menu-item > a {\n	background-color: #87c440;\n	color: rgb(255,255,255);\n}\n\n.entry-title {\n	font-family: \'Montserrat\', sans-serif;\n	font-size: 2.5rem;\n	font-weight: 300;\n	line-height: 1;\n}\n\n.entry-title a, .sidebar .widgettitle a {\n	color: #0089d0;\n}", "safecss", "Modern Blogger Child Theme", "inherit", "closed", "closed", "", "248-revision-v1", "", "", "2013-10-02 13:46:32", "2013-10-02 13:46:32", "", "248", "http://healthydoghq.com/248-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("262", "1", "2013-10-02 13:47:25", "2013-10-02 13:47:25", "/*\nWelcome to Custom CSS!\n\nCSS (Cascading Style Sheets) is a kind of code that tells the browser how\nto render a web page. You may delete these comments and get started with\nyour customizations.\n\nBy default, your stylesheet will be loaded after the theme stylesheets,\nwhich means that your rules can take precedence and override the theme CSS\nrules. Just write here what you want to change, you don\'t need to copy all\nyour theme\'s stylesheet content.\n*/\n.nav-primary {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\n.nav-primary a:hover, .nav-primary .current-menu-item > a {\n	background-color: #87c440;\n	color: rgb(255,255,255);\n}\n\n.entry-title {\n	font-family: \'Montserrat\', sans-serif;\n	font-size: 2.5rem;\n	font-weight: 300;\n	line-height: 1;\n}\n\n.entry-title a, .sidebar .widgettitle a {\n	color: #0089d0;\n}\n\n.entry-title a:hover {\n	color: #87c440;\n}", "safecss", "Modern Blogger Child Theme", "inherit", "closed", "closed", "", "248-revision-v1", "", "", "2013-10-02 13:47:25", "2013-10-02 13:47:25", "", "248", "http://healthydoghq.com/248-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("267", "1", "2013-10-02 13:51:37", "2013-10-02 13:51:37", "/*\nWelcome to Custom CSS!\n\nCSS (Cascading Style Sheets) is a kind of code that tells the browser how\nto render a web page. You may delete these comments and get started with\nyour customizations.\n\nBy default, your stylesheet will be loaded after the theme stylesheets,\nwhich means that your rules can take precedence and override the theme CSS\nrules. Just write here what you want to change, you don\'t need to copy all\nyour theme\'s stylesheet content.\n*/\n.nav-primary {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\n.nav-primary a:hover, .nav-primary .current-menu-item > a {\n	background-color: #87c440;\n	color: rgb(255,255,255);\n}\n\n.entry-title {\n	font-family: \'Montserrat\', sans-serif;\n	font-size: 2.5rem;\n	font-weight: 300;\n	line-height: 1;\n}\n\n.entry-title a, .sidebar .widgettitle a {\n	color: #0089d0;\n}\n\n.entry-title a:hover {\n	color: #99cc00;\n}", "safecss", "Modern Blogger Child Theme", "inherit", "closed", "closed", "", "248-revision-v1", "", "", "2013-10-02 13:51:37", "2013-10-02 13:51:37", "", "248", "http://healthydoghq.com/248-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("263", "1", "2013-10-02 13:48:19", "2013-10-02 13:48:19", "/*\nWelcome to Custom CSS!\n\nCSS (Cascading Style Sheets) is a kind of code that tells the browser how\nto render a web page. You may delete these comments and get started with\nyour customizations.\n\nBy default, your stylesheet will be loaded after the theme stylesheets,\nwhich means that your rules can take precedence and override the theme CSS\nrules. Just write here what you want to change, you don\'t need to copy all\nyour theme\'s stylesheet content.\n*/\n.nav-primary {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\n.nav-primary a:hover, .nav-primary .current-menu-item > a {\n	background-color: #87c440;\n	color: rgb(255,255,255);\n}\n\n.entry-title {\n	font-family: \'Montserrat\', sans-serif;\n	font-size: 2.5rem;\n	font-weight: 300;\n	line-height: 1;\n}\n\n.entry-title a, .sidebar .widgettitle a {\n	color: #0089d0;\n}\n\n.entry-title a:hover {\n	color: #87c440;\n}\n\na {\n	color: #87c440;\n	text-decoration: none;\n}", "safecss", "Modern Blogger Child Theme", "inherit", "closed", "closed", "", "248-revision-v1", "", "", "2013-10-02 13:48:19", "2013-10-02 13:48:19", "", "248", "http://healthydoghq.com/248-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("264", "1", "2013-10-02 13:48:44", "2013-10-02 13:48:44", "/*\nWelcome to Custom CSS!\n\nCSS (Cascading Style Sheets) is a kind of code that tells the browser how\nto render a web page. You may delete these comments and get started with\nyour customizations.\n\nBy default, your stylesheet will be loaded after the theme stylesheets,\nwhich means that your rules can take precedence and override the theme CSS\nrules. Just write here what you want to change, you don\'t need to copy all\nyour theme\'s stylesheet content.\n*/\n.nav-primary {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\n.nav-primary a:hover, .nav-primary .current-menu-item > a {\n	background-color: #87c440;\n	color: rgb(255,255,255);\n}\n\n.entry-title {\n	font-family: \'Montserrat\', sans-serif;\n	font-size: 2.5rem;\n	font-weight: 300;\n	line-height: 1;\n}\n\n.entry-title a, .sidebar .widgettitle a {\n	color: #0089d0;\n}\n\n.entry-title a:hover {\n	color: #87c440;\n}\n\na {\n	text-decoration: none;\n}", "safecss", "Modern Blogger Child Theme", "inherit", "closed", "closed", "", "248-revision-v1", "", "", "2013-10-02 13:48:44", "2013-10-02 13:48:44", "", "248", "http://healthydoghq.com/248-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("265", "1", "2013-10-02 13:50:39", "2013-10-02 13:50:39", "/*\nWelcome to Custom CSS!\n\nCSS (Cascading Style Sheets) is a kind of code that tells the browser how\nto render a web page. You may delete these comments and get started with\nyour customizations.\n\nBy default, your stylesheet will be loaded after the theme stylesheets,\nwhich means that your rules can take precedence and override the theme CSS\nrules. Just write here what you want to change, you don\'t need to copy all\nyour theme\'s stylesheet content.\n*/\n.nav-primary {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\n.nav-primary a:hover, .nav-primary .current-menu-item > a {\n	background-color: #87c440;\n	color: rgb(255,255,255);\n}\n\n.entry-title {\n	font-family: \'Montserrat\', sans-serif;\n	font-size: 2.5rem;\n	font-weight: 300;\n	line-height: 1;\n}\n\n.entry-title a, .sidebar .widgettitle a {\n	color: #0089d0;\n}\n\n.entry-title a:hover {\n	color: #99cc00;\n}\n\na {\n	text-decoration: none;\n}", "safecss", "Modern Blogger Child Theme", "inherit", "closed", "closed", "", "248-revision-v1", "", "", "2013-10-02 13:50:39", "2013-10-02 13:50:39", "", "248", "http://healthydoghq.com/248-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("266", "1", "2013-10-02 13:50:58", "2013-10-02 13:50:58", "/*\nWelcome to Custom CSS!\n\nCSS (Cascading Style Sheets) is a kind of code that tells the browser how\nto render a web page. You may delete these comments and get started with\nyour customizations.\n\nBy default, your stylesheet will be loaded after the theme stylesheets,\nwhich means that your rules can take precedence and override the theme CSS\nrules. Just write here what you want to change, you don\'t need to copy all\nyour theme\'s stylesheet content.\n*/\n.nav-primary {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\n.nav-primary a:hover, .nav-primary .current-menu-item > a {\n	background-color: #87c440;\n	color: rgb(255,255,255);\n}\n\n.entry-title {\n	font-family: \'Montserrat\', sans-serif;\n	font-size: 2.5rem;\n	font-weight: 300;\n	line-height: 1;\n}\n\n.entry-title a, .sidebar .widgettitle a {\n	color: #0089d0;\n}\n\n.entry-title a:hover {\n	color: #99cc00;\n}\n\na {\n	color: #99cc00;\n	text-decoration: none;\n}", "safecss", "Modern Blogger Child Theme", "inherit", "closed", "closed", "", "248-revision-v1", "", "", "2013-10-02 13:50:58", "2013-10-02 13:50:58", "", "248", "http://healthydoghq.com/248-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("268", "1", "2013-10-02 13:51:52", "2013-10-02 13:51:52", "/*\nWelcome to Custom CSS!\n\nCSS (Cascading Style Sheets) is a kind of code that tells the browser how\nto render a web page. You may delete these comments and get started with\nyour customizations.\n\nBy default, your stylesheet will be loaded after the theme stylesheets,\nwhich means that your rules can take precedence and override the theme CSS\nrules. Just write here what you want to change, you don\'t need to copy all\nyour theme\'s stylesheet content.\n*/\n.nav-primary {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\n.nav-primary a:hover, .nav-primary .current-menu-item > a {\n	background-color: #87c440;\n	color: rgb(255,255,255);\n}\n\n.entry-title {\n	font-family: \'Montserrat\', sans-serif;\n	font-size: 2.5rem;\n	font-weight: 300;\n	line-height: 1;\n}\n\n.entry-title a, .sidebar .widgettitle a {\n	color: #0089d0;\n}\n\n.entry-title a:hover {\n	color: #87c440;\n}", "safecss", "Modern Blogger Child Theme", "inherit", "closed", "closed", "", "248-revision-v1", "", "", "2013-10-02 13:51:52", "2013-10-02 13:51:52", "", "248", "http://healthydoghq.com/248-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("269", "1", "2013-10-02 13:54:16", "2013-10-02 13:54:16", "/*\nWelcome to Custom CSS!\n\nCSS (Cascading Style Sheets) is a kind of code that tells the browser how\nto render a web page. You may delete these comments and get started with\nyour customizations.\n\nBy default, your stylesheet will be loaded after the theme stylesheets,\nwhich means that your rules can take precedence and override the theme CSS\nrules. Just write here what you want to change, you don\'t need to copy all\nyour theme\'s stylesheet content.\n*/\n.nav-primary {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\n.nav-primary a:hover, .nav-primary .current-menu-item > a {\n	background-color: #87c440;\n	color: rgb(255,255,255);\n}\n\n.entry-title {\n	font-family: \'Montserrat\', sans-serif;\n	font-size: 2.5rem;\n	font-weight: 300;\n	line-height: 1;\n}\n\n.entry-title a, .sidebar .widgettitle a {\n	color: #0089d0;\n}\n\n.entry-title a:hover {\n	color: #87c440;\n}\n\nh1, h2, h3, h4, h5, h6 {\n	color: #87c440;\n}", "safecss", "Modern Blogger Child Theme", "inherit", "closed", "closed", "", "248-revision-v1", "", "", "2013-10-02 13:54:16", "2013-10-02 13:54:16", "", "248", "http://healthydoghq.com/248-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("270", "1", "2013-10-02 13:55:17", "2013-10-02 13:55:17", "/*\nWelcome to Custom CSS!\n\nCSS (Cascading Style Sheets) is a kind of code that tells the browser how\nto render a web page. You may delete these comments and get started with\nyour customizations.\n\nBy default, your stylesheet will be loaded after the theme stylesheets,\nwhich means that your rules can take precedence and override the theme CSS\nrules. Just write here what you want to change, you don\'t need to copy all\nyour theme\'s stylesheet content.\n*/\n.nav-primary {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\n.nav-primary a:hover, .nav-primary .current-menu-item > a {\n	background-color: #87c440;\n	color: rgb(255,255,255);\n}\n\n.entry-title {\n	font-family: \'Montserrat\', sans-serif;\n	color: #0089d0;\n	font-size: 2.5rem;\n	font-weight: 300;\n	line-height: 1;\n}\n\n.entry-title a, .sidebar .widgettitle a {\n	color: #0089d0;\n}\n\n.entry-title a:hover {\n	color: #87c440;\n}\n\nh1, h2, h3, h4, h5, h6 {\n	color: #87c440;\n}", "safecss", "Modern Blogger Child Theme", "inherit", "closed", "closed", "", "248-revision-v1", "", "", "2013-10-02 13:55:17", "2013-10-02 13:55:17", "", "248", "http://healthydoghq.com/248-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("271", "1", "2013-10-02 13:56:08", "2013-10-02 13:56:08", "/*\nWelcome to Custom CSS!\n\nCSS (Cascading Style Sheets) is a kind of code that tells the browser how\nto render a web page. You may delete these comments and get started with\nyour customizations.\n\nBy default, your stylesheet will be loaded after the theme stylesheets,\nwhich means that your rules can take precedence and override the theme CSS\nrules. Just write here what you want to change, you don\'t need to copy all\nyour theme\'s stylesheet content.\n*/\n.nav-primary {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\n.nav-primary a:hover, .nav-primary .current-menu-item > a {\n	background-color: #87c440;\n	color: rgb(255,255,255);\n}\n\n.entry-title {\n	font-family: \'Montserrat\', sans-serif;\n	color: #0089d0;\n	font-size: 2.5rem;\n	font-weight: 300;\n	line-height: 1;\n}\n\n.entry-title a, .sidebar .widgettitle a {\n	color: #0089d0;\n}\n\n.entry-title a:hover {\n	color: #87c440;\n}\n\nh1, h2, h3, h4, h5, h6 {\n	color: #87c440;\n}\n\n.entry-content a {\n	color: #0089d0;\n}", "safecss", "Modern Blogger Child Theme", "inherit", "closed", "closed", "", "248-revision-v1", "", "", "2013-10-02 13:56:08", "2013-10-02 13:56:08", "", "248", "http://healthydoghq.com/248-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("272", "1", "2013-10-02 13:56:45", "2013-10-02 13:56:45", "/*\nWelcome to Custom CSS!\n\nCSS (Cascading Style Sheets) is a kind of code that tells the browser how\nto render a web page. You may delete these comments and get started with\nyour customizations.\n\nBy default, your stylesheet will be loaded after the theme stylesheets,\nwhich means that your rules can take precedence and override the theme CSS\nrules. Just write here what you want to change, you don\'t need to copy all\nyour theme\'s stylesheet content.\n*/\n.nav-primary {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\n.nav-primary a:hover, .nav-primary .current-menu-item > a {\n	background-color: #87c440;\n	color: rgb(255,255,255);\n}\n\n.entry-title {\n	font-family: \'Montserrat\', sans-serif;\n	color: #0089d0;\n	font-size: 2.5rem;\n	font-weight: 300;\n	line-height: 1;\n}\n\n.entry-title a, .sidebar .widgettitle a {\n	color: #0089d0;\n}\n\n.entry-title a:hover {\n	color: #87c440;\n}\n\nh1, h2, h3, h4, h5, h6 {\n	color: #87c440;\n}\n\n.entry-content a {\n	color: #0089d0;\n}\n\nbody {\n	color: rgb(84,84,84);\n	font-family: \'Lato\', sans-serif;\n	font-size: 1.6rem;\n	font-weight: 300;\n	line-height: 1.5;\n}", "safecss", "Modern Blogger Child Theme", "inherit", "closed", "closed", "", "248-revision-v1", "", "", "2013-10-02 13:56:45", "2013-10-02 13:56:45", "", "248", "http://healthydoghq.com/248-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("273", "1", "2013-10-02 13:57:07", "2013-10-02 13:57:07", "/*\nWelcome to Custom CSS!\n\nCSS (Cascading Style Sheets) is a kind of code that tells the browser how\nto render a web page. You may delete these comments and get started with\nyour customizations.\n\nBy default, your stylesheet will be loaded after the theme stylesheets,\nwhich means that your rules can take precedence and override the theme CSS\nrules. Just write here what you want to change, you don\'t need to copy all\nyour theme\'s stylesheet content.\n*/\n.nav-primary {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\n.nav-primary a:hover, .nav-primary .current-menu-item > a {\n	background-color: #87c440;\n	color: rgb(255,255,255);\n}\n\n.entry-title {\n	font-family: \'Montserrat\', sans-serif;\n	color: #0089d0;\n	font-size: 2.3rem;\n	font-weight: 300;\n	line-height: 1;\n}\n\n.entry-title a, .sidebar .widgettitle a {\n	color: #0089d0;\n}\n\n.entry-title a:hover {\n	color: #87c440;\n}\n\nh1, h2, h3, h4, h5, h6 {\n	color: #87c440;\n}\n\n.entry-content a {\n	color: #0089d0;\n}\n\nbody {\n	color: rgb(84,84,84);\n	font-family: \'Lato\', sans-serif;\n	font-size: 1.6rem;\n	font-weight: 300;\n	line-height: 1.5;\n}", "safecss", "Modern Blogger Child Theme", "inherit", "closed", "closed", "", "248-revision-v1", "", "", "2013-10-02 13:57:07", "2013-10-02 13:57:07", "", "248", "http://healthydoghq.com/248-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("274", "1", "2013-10-02 13:58:12", "2013-10-02 13:58:12", "/*\nWelcome to Custom CSS!\n\nCSS (Cascading Style Sheets) is a kind of code that tells the browser how\nto render a web page. You may delete these comments and get started with\nyour customizations.\n\nBy default, your stylesheet will be loaded after the theme stylesheets,\nwhich means that your rules can take precedence and override the theme CSS\nrules. Just write here what you want to change, you don\'t need to copy all\nyour theme\'s stylesheet content.\n*/\n.nav-primary {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\n.nav-primary a:hover, .nav-primary .current-menu-item > a {\n	background-color: #87c440;\n	color: rgb(255,255,255);\n}\n\n.entry-title {\n	font-family: \'Montserrat\', sans-serif;\n	color: #0089d0;\n	font-size: 2.3rem;\n	font-weight: 300;\n	line-height: 1;\n	padding-bottom: 0;\n}\n\n.entry-title a, .sidebar .widgettitle a {\n	color: #0089d0;\n}\n\n.entry-title a:hover {\n	color: #87c440;\n}\n\nh1, h2, h3, h4, h5, h6 {\n	color: #87c440;\n}\n\n.entry-content a {\n	color: #0089d0;\n}\n\nbody {\n	color: rgb(84,84,84);\n	font-family: \'Lato\', sans-serif;\n	font-size: 1.6rem;\n	font-weight: 300;\n	line-height: 1.5;\n}", "safecss", "Modern Blogger Child Theme", "inherit", "closed", "closed", "", "248-revision-v1", "", "", "2013-10-02 13:58:12", "2013-10-02 13:58:12", "", "248", "http://healthydoghq.com/248-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("275", "1", "2013-10-02 13:59:46", "2013-10-02 13:59:46", "/*\nWelcome to Custom CSS!\n\nCSS (Cascading Style Sheets) is a kind of code that tells the browser how\nto render a web page. You may delete these comments and get started with\nyour customizations.\n\nBy default, your stylesheet will be loaded after the theme stylesheets,\nwhich means that your rules can take precedence and override the theme CSS\nrules. Just write here what you want to change, you don\'t need to copy all\nyour theme\'s stylesheet content.\n*/\n.nav-primary {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\n.nav-primary a:hover, .nav-primary .current-menu-item > a {\n	background-color: #87c440;\n	color: rgb(255,255,255);\n}\n\n.entry-title {\n	font-family: \'Montserrat\', sans-serif;\n	color: #0089d0;\n	font-size: 2.3rem;\n	font-weight: 300;\n	line-height: 1;\n}\n\n.entry-title a, .sidebar .widgettitle a {\n	color: #0089d0;\n}\n\n.entry-title a:hover {\n	color: #87c440;\n}\n\nh1, h2, h3, h4, h5, h6 {\n	color: #87c440;\n	margin-bottom: 14px;\n}\n\n.entry-content a {\n	color: #0089d0;\n}\n\nbody {\n	color: rgb(84,84,84);\n	font-family: \'Lato\', sans-serif;\n	font-size: 1.6rem;\n	font-weight: 300;\n	line-height: 1.5;\n}", "safecss", "Modern Blogger Child Theme", "inherit", "closed", "closed", "", "248-revision-v1", "", "", "2013-10-02 13:59:46", "2013-10-02 13:59:46", "", "248", "http://healthydoghq.com/248-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("276", "1", "2013-10-02 14:00:00", "2013-10-02 14:00:00", "/*\nWelcome to Custom CSS!\n\nCSS (Cascading Style Sheets) is a kind of code that tells the browser how\nto render a web page. You may delete these comments and get started with\nyour customizations.\n\nBy default, your stylesheet will be loaded after the theme stylesheets,\nwhich means that your rules can take precedence and override the theme CSS\nrules. Just write here what you want to change, you don\'t need to copy all\nyour theme\'s stylesheet content.\n*/\n.nav-primary {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\n.nav-primary a:hover, .nav-primary .current-menu-item > a {\n	background-color: #87c440;\n	color: rgb(255,255,255);\n}\n\n.entry-title {\n	font-family: \'Montserrat\', sans-serif;\n	color: #0089d0;\n	font-size: 2.3rem;\n	font-weight: 300;\n	line-height: 1;\n}\n\n.entry-title a, .sidebar .widgettitle a {\n	color: #0089d0;\n}\n\n.entry-title a:hover {\n	color: #87c440;\n}\n\nh1, h2, h3, h4, h5, h6 {\n	color: #87c440;\n	margin-bottom: 10px;\n}\n\n.entry-content a {\n	color: #0089d0;\n}\n\nbody {\n	color: rgb(84,84,84);\n	font-family: \'Lato\', sans-serif;\n	font-size: 1.6rem;\n	font-weight: 300;\n	line-height: 1.5;\n}", "safecss", "Modern Blogger Child Theme", "inherit", "closed", "closed", "", "248-revision-v1", "", "", "2013-10-02 14:00:00", "2013-10-02 14:00:00", "", "248", "http://healthydoghq.com/248-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("278", "1", "2013-10-02 14:02:23", "2013-10-02 14:02:23", "/*\nWelcome to Custom CSS!\n\nCSS (Cascading Style Sheets) is a kind of code that tells the browser how\nto render a web page. You may delete these comments and get started with\nyour customizations.\n\nBy default, your stylesheet will be loaded after the theme stylesheets,\nwhich means that your rules can take precedence and override the theme CSS\nrules. Just write here what you want to change, you don\'t need to copy all\nyour theme\'s stylesheet content.\n*/\n.nav-primary {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\n.nav-primary a:hover, .nav-primary .current-menu-item > a {\n	background-color: #87c440;\n	color: rgb(255,255,255);\n}\n\n.entry-title {\n	font-family: \'Montserrat\', sans-serif;\n	color: #0089d0;\n	font-size: 2.3rem;\n	font-weight: 300;\n	line-height: 1;\n}\n\n.entry-title a, .sidebar .widgettitle a {\n	color: #0089d0;\n}\n\n.entry-title a:hover {\n	color: #87c440;\n}\n\nh1, h2, h3, h4, h5, h6 {\n	color: #87c440;\n	margin-bottom: 10px;\n}\n\n.entry-content a {\n	color: #0089d0;\n}\n\nbody {\n	color: rgb(84,84,84);\n	font-family: \'Lato\', sans-serif;\n	font-size: 1.6rem;\n	font-weight: 300;\n	line-height: 1.5;\n}", "safecss", "Modern Blogger Child Theme", "inherit", "closed", "closed", "", "248-revision-v1", "", "", "2013-10-02 14:02:23", "2013-10-02 14:02:23", "", "248", "http://healthydoghq.com/248-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("277", "1", "2013-10-02 14:02:07", "2013-10-02 14:02:07", "/*\nWelcome to Custom CSS!\n\nCSS (Cascading Style Sheets) is a kind of code that tells the browser how\nto render a web page. You may delete these comments and get started with\nyour customizations.\n\nBy default, your stylesheet will be loaded after the theme stylesheets,\nwhich means that your rules can take precedence and override the theme CSS\nrules. Just write here what you want to change, you don\'t need to copy all\nyour theme\'s stylesheet content.\n*/\n.nav-primary {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\n.nav-primary a:hover, .nav-primary .current-menu-item > a {\n	background-color: #87c440;\n	color: rgb(255,255,255);\n}\n\n.entry-title {\n	font-family: \'Montserrat\', sans-serif;\n	color: #0089d0;\n	font-size: 2.3rem;\n	font-weight: 300;\n	line-height: 1;\n}\n\n.entry-title a, .sidebar .widgettitle a {\n	color: #0089d0;\n}\n\n.entry-title a:hover {\n	color: #87c440;\n}\n\nh1, h2, h3, h4, h5, h6 {\n	color: #87c440;\n	margin-bottom: 10px;\n}\n\nh1.entry-title {\n	font-size: 2.3rem;\n	margin: 0 0 7px;\n}\n\n.entry-content a {\n	color: #0089d0;\n}\n\nbody {\n	color: rgb(84,84,84);\n	font-family: \'Lato\', sans-serif;\n	font-size: 1.6rem;\n	font-weight: 300;\n	line-height: 1.5;\n}", "safecss", "Modern Blogger Child Theme", "inherit", "closed", "closed", "", "248-revision-v1", "", "", "2013-10-02 14:02:07", "2013-10-02 14:02:07", "", "248", "http://healthydoghq.com/248-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("279", "1", "2013-10-02 14:05:38", "2013-10-02 14:05:38", "/*\nWelcome to Custom CSS!\n\nCSS (Cascading Style Sheets) is a kind of code that tells the browser how\nto render a web page. You may delete these comments and get started with\nyour customizations.\n\nBy default, your stylesheet will be loaded after the theme stylesheets,\nwhich means that your rules can take precedence and override the theme CSS\nrules. Just write here what you want to change, you don\'t need to copy all\nyour theme\'s stylesheet content.\n*/\n.nav-primary {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\n.nav-primary a:hover, .nav-primary .current-menu-item > a {\n	background-color: #87c440;\n	color: rgb(255,255,255);\n}\n\n.entry-title {\n	font-family: \'Montserrat\', sans-serif;\n	color: #0089d0;\n	font-size: 2.3rem;\n	font-weight: 300;\n	line-height: 1;\n}\n\n.entry-title a, .sidebar .widgettitle a {\n	color: #0089d0;\n}\n\n.entry-title a:hover {\n	color: #87c440;\n}\n\nh1, h2, h3, h4, h5, h6 {\n	color: #87c440;\n	margin-bottom: 10px;\n}\n\n.entry-content a {\n	color: #0089d0;\n}\n\nbody {\n	color: rgb(84,84,84);\n	font-family: \'Lato\', sans-serif;\n	font-size: 1.6rem;\n	font-weight: 300;\n	line-height: 1.5;\n}\n\n#respond label {\n	color: #0089d0;\n}", "safecss", "Modern Blogger Child Theme", "inherit", "closed", "closed", "", "248-revision-v1", "", "", "2013-10-02 14:05:38", "2013-10-02 14:05:38", "", "248", "http://healthydoghq.com/248-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("280", "1", "2013-10-02 14:06:30", "2013-10-02 14:06:30", "/*\nWelcome to Custom CSS!\n\nCSS (Cascading Style Sheets) is a kind of code that tells the browser how\nto render a web page. You may delete these comments and get started with\nyour customizations.\n\nBy default, your stylesheet will be loaded after the theme stylesheets,\nwhich means that your rules can take precedence and override the theme CSS\nrules. Just write here what you want to change, you don\'t need to copy all\nyour theme\'s stylesheet content.\n*/\n.nav-primary {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\n.nav-primary a:hover, .nav-primary .current-menu-item > a {\n	background-color: #87c440;\n	color: rgb(255,255,255);\n}\n\n.entry-title {\n	font-family: \'Montserrat\', sans-serif;\n	color: #0089d0;\n	font-size: 2.3rem;\n	font-weight: 300;\n	line-height: 1;\n}\n\n.entry-title a, .sidebar .widgettitle a {\n	color: #0089d0;\n}\n\n.entry-title a:hover {\n	color: #87c440;\n}\n\nh1, h2, h3, h4, h5, h6 {\n	color: #87c440;\n	margin-bottom: 10px;\n}\n\n.entry-content a {\n	color: #0089d0;\n}\n\nbody {\n	color: rgb(84,84,84);\n	font-family: \'Lato\', sans-serif;\n	font-size: 1.6rem;\n	font-weight: 300;\n	line-height: 1.5;\n}\n\n#respond label {\n	color: #0089d0;\n}\n\n#reply-title {\n	border-bottom: medium double;\n	color: #0089d0;\n}", "safecss", "Modern Blogger Child Theme", "inherit", "closed", "closed", "", "248-revision-v1", "", "", "2013-10-02 14:06:30", "2013-10-02 14:06:30", "", "248", "http://healthydoghq.com/248-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("281", "1", "2013-10-02 14:07:37", "2013-10-02 14:07:37", "/*\nWelcome to Custom CSS!\n\nCSS (Cascading Style Sheets) is a kind of code that tells the browser how\nto render a web page. You may delete these comments and get started with\nyour customizations.\n\nBy default, your stylesheet will be loaded after the theme stylesheets,\nwhich means that your rules can take precedence and override the theme CSS\nrules. Just write here what you want to change, you don\'t need to copy all\nyour theme\'s stylesheet content.\n*/\n.nav-primary {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\n.nav-primary a:hover, .nav-primary .current-menu-item > a {\n	background-color: #87c440;\n	color: rgb(255,255,255);\n}\n\n.entry-title {\n	font-family: \'Montserrat\', sans-serif;\n	color: #0089d0;\n	font-size: 2.3rem;\n	font-weight: 300;\n	line-height: 1;\n}\n\n.entry-title a, .sidebar .widgettitle a {\n	color: #0089d0;\n}\n\n.entry-title a:hover {\n	color: #87c440;\n}\n\nh1, h2, h3, h4, h5, h6 {\n	color: #87c440;\n	margin-bottom: 10px;\n}\n\n.entry-content a {\n	color: #0089d0;\n}\n\nbody {\n	color: rgb(84,84,84);\n	font-family: \'Lato\', sans-serif;\n	font-size: 1.6rem;\n	font-weight: 300;\n	line-height: 1.5;\n}\n\n#respond label {\n	color: #0089d0;\n}\n\n#reply-title {\n	border-bottom: medium double;\n	color: #0089d0;\n}\n\nbutton, input[type=\"button\"], input[type=\"reset\"], input[type=\"submit\"] {\n	background: none repeat scroll 0 0 #0089d0;", "safecss", "Modern Blogger Child Theme", "inherit", "closed", "closed", "", "248-revision-v1", "", "", "2013-10-02 14:07:37", "2013-10-02 14:07:37", "", "248", "http://healthydoghq.com/248-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("282", "1", "2013-10-02 14:08:28", "2013-10-02 14:08:28", "/*\nWelcome to Custom CSS!\n\nCSS (Cascading Style Sheets) is a kind of code that tells the browser how\nto render a web page. You may delete these comments and get started with\nyour customizations.\n\nBy default, your stylesheet will be loaded after the theme stylesheets,\nwhich means that your rules can take precedence and override the theme CSS\nrules. Just write here what you want to change, you don\'t need to copy all\nyour theme\'s stylesheet content.\n*/\n.nav-primary {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\n.nav-primary a:hover, .nav-primary .current-menu-item > a {\n	background-color: #87c440;\n	color: rgb(255,255,255);\n}\n\n.entry-title {\n	font-family: \'Montserrat\', sans-serif;\n	color: #0089d0;\n	font-size: 2.3rem;\n	font-weight: 300;\n	line-height: 1;\n}\n\n.entry-title a, .sidebar .widgettitle a {\n	color: #0089d0;\n}\n\n.entry-title a:hover {\n	color: #87c440;\n}\n\nh1, h2, h3, h4, h5, h6 {\n	color: #87c440;\n	margin-bottom: 10px;\n}\n\n.entry-content a {\n	color: #0089d0;\n}\n\nbody {\n	color: rgb(84,84,84);\n	font-family: \'Lato\', sans-serif;\n	font-size: 1.6rem;\n	font-weight: 300;\n	line-height: 1.5;\n}\n\n#respond label {\n	color: #0089d0;\n}\n\n#reply-title {\n	border-bottom: medium double;\n	color: #0089d0;\n}\n\nbutton, input[type=\"button\"], input[type=\"reset\"], input[type=\"submit\"] {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\nbutton:hover, input[type=\"button\"]:hover, input[type=\"reset\"]:hover, input[type=\"submit\"]:hover {\n	background: none repeat scroll 0 0 #87c440;\n}", "safecss", "Modern Blogger Child Theme", "inherit", "closed", "closed", "", "248-revision-v1", "", "", "2013-10-02 14:08:28", "2013-10-02 14:08:28", "", "248", "http://healthydoghq.com/248-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("283", "1", "2013-10-02 14:09:32", "2013-10-02 14:09:32", "/*\nWelcome to Custom CSS!\n\nCSS (Cascading Style Sheets) is a kind of code that tells the browser how\nto render a web page. You may delete these comments and get started with\nyour customizations.\n\nBy default, your stylesheet will be loaded after the theme stylesheets,\nwhich means that your rules can take precedence and override the theme CSS\nrules. Just write here what you want to change, you don\'t need to copy all\nyour theme\'s stylesheet content.\n*/\n.nav-primary {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\n.nav-primary a:hover, .nav-primary .current-menu-item > a {\n	background-color: #87c440;\n	color: rgb(255,255,255);\n}\n\na {\n	color: #0089d0;\n}\n\n.entry-title {\n	font-family: \'Montserrat\', sans-serif;\n	color: #0089d0;\n	font-size: 2.3rem;\n	font-weight: 300;\n	line-height: 1;\n}\n\n.entry-title a, .sidebar .widgettitle a {\n	color: #0089d0;\n}\n\n.entry-title a:hover {\n	color: #87c440;\n}\n\nh1, h2, h3, h4, h5, h6 {\n	color: #87c440;\n	margin-bottom: 10px;\n}\n\n.entry-content a {\n	color: #0089d0;\n}\n\nbody {\n	color: rgb(84,84,84);\n	font-family: \'Lato\', sans-serif;\n	font-size: 1.6rem;\n	font-weight: 300;\n	line-height: 1.5;\n}\n\n#respond label {\n	color: #0089d0;\n}\n\n#reply-title {\n	border-bottom: medium double;\n	color: #0089d0;\n}\n\nbutton, input[type=\"button\"], input[type=\"reset\"], input[type=\"submit\"] {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\nbutton:hover, input[type=\"button\"]:hover, input[type=\"reset\"]:hover, input[type=\"submit\"]:hover {\n	background: none repeat scroll 0 0 #87c440;\n}", "safecss", "Modern Blogger Child Theme", "inherit", "closed", "closed", "", "248-revision-v1", "", "", "2013-10-02 14:09:32", "2013-10-02 14:09:32", "", "248", "http://healthydoghq.com/248-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("284", "1", "2013-10-02 14:09:51", "2013-10-02 14:09:51", "/*\nWelcome to Custom CSS!\n\nCSS (Cascading Style Sheets) is a kind of code that tells the browser how\nto render a web page. You may delete these comments and get started with\nyour customizations.\n\nBy default, your stylesheet will be loaded after the theme stylesheets,\nwhich means that your rules can take precedence and override the theme CSS\nrules. Just write here what you want to change, you don\'t need to copy all\nyour theme\'s stylesheet content.\n*/\n.nav-primary {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\n.nav-primary a:hover, .nav-primary .current-menu-item > a {\n	background-color: #87c440;\n	color: rgb(255,255,255);\n}\n\na {\n	color: #87c440;\n}\n\n.entry-title {\n	font-family: \'Montserrat\', sans-serif;\n	color: #0089d0;\n	font-size: 2.3rem;\n	font-weight: 300;\n	line-height: 1;\n}\n\n.entry-title a, .sidebar .widgettitle a {\n	color: #0089d0;\n}\n\n.entry-title a:hover {\n	color: #87c440;\n}\n\nh1, h2, h3, h4, h5, h6 {\n	color: #87c440;\n	margin-bottom: 10px;\n}\n\n.entry-content a {\n	color: #0089d0;\n}\n\nbody {\n	color: rgb(84,84,84);\n	font-family: \'Lato\', sans-serif;\n	font-size: 1.6rem;\n	font-weight: 300;\n	line-height: 1.5;\n}\n\n#respond label {\n	color: #0089d0;\n}\n\n#reply-title {\n	border-bottom: medium double;\n	color: #0089d0;\n}\n\nbutton, input[type=\"button\"], input[type=\"reset\"], input[type=\"submit\"] {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\nbutton:hover, input[type=\"button\"]:hover, input[type=\"reset\"]:hover, input[type=\"submit\"]:hover {\n	background: none repeat scroll 0 0 #87c440;\n}", "safecss", "Modern Blogger Child Theme", "inherit", "closed", "closed", "", "248-revision-v1", "", "", "2013-10-02 14:09:51", "2013-10-02 14:09:51", "", "248", "http://healthydoghq.com/248-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("285", "1", "2013-10-02 14:10:39", "2013-10-02 14:10:39", "/*\nWelcome to Custom CSS!\n\nCSS (Cascading Style Sheets) is a kind of code that tells the browser how\nto render a web page. You may delete these comments and get started with\nyour customizations.\n\nBy default, your stylesheet will be loaded after the theme stylesheets,\nwhich means that your rules can take precedence and override the theme CSS\nrules. Just write here what you want to change, you don\'t need to copy all\nyour theme\'s stylesheet content.\n*/\n.nav-primary {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\n.nav-primary a:hover, .nav-primary .current-menu-item > a {\n	background-color: #87c440;\n	color: rgb(255,255,255);\n}\n\na {\n	color: #87c440;\n}\n\n.entry-title {\n	font-family: \'Montserrat\', sans-serif;\n	color: #0089d0;\n	font-size: 2.3rem;\n	font-weight: 300;\n	line-height: 1;\n}\n\n.entry-title a, .sidebar .widgettitle a {\n	color: #0089d0;\n}\n\n.entry-title a:hover {\n	color: #99cc33;\n}\n\nh1, h2, h3, h4, h5, h6 {\n	color: #87c440;\n	margin-bottom: 10px;\n}\n\n.entry-content a {\n	color: #0089d0;\n}\n\nbody {\n	color: rgb(84,84,84);\n	font-family: \'Lato\', sans-serif;\n	font-size: 1.6rem;\n	font-weight: 300;\n	line-height: 1.5;\n}\n\n#respond label {\n	color: #0089d0;\n}\n\n#reply-title {\n	border-bottom: medium double;\n	color: #0089d0;\n}\n\nbutton, input[type=\"button\"], input[type=\"reset\"], input[type=\"submit\"] {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\nbutton:hover, input[type=\"button\"]:hover, input[type=\"reset\"]:hover, input[type=\"submit\"]:hover {\n	background: none repeat scroll 0 0 #87c440;\n}", "safecss", "Modern Blogger Child Theme", "inherit", "closed", "closed", "", "248-revision-v1", "", "", "2013-10-02 14:10:39", "2013-10-02 14:10:39", "", "248", "http://healthydoghq.com/248-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("286", "1", "2013-10-02 14:11:18", "2013-10-02 14:11:18", "/*\nWelcome to Custom CSS!\n\nCSS (Cascading Style Sheets) is a kind of code that tells the browser how\nto render a web page. You may delete these comments and get started with\nyour customizations.\n\nBy default, your stylesheet will be loaded after the theme stylesheets,\nwhich means that your rules can take precedence and override the theme CSS\nrules. Just write here what you want to change, you don\'t need to copy all\nyour theme\'s stylesheet content.\n*/\n.nav-primary {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\n.nav-primary a:hover, .nav-primary .current-menu-item > a {\n	background-color: #87c440;\n	color: rgb(255,255,255);\n}\n\na {\n	color: #87c440;\n}\n\na:hover {\n	color: #0089d0;\n}\n\n.entry-title {\n	font-family: \'Montserrat\', sans-serif;\n	color: #0089d0;\n	font-size: 2.3rem;\n	font-weight: 300;\n	line-height: 1;\n}\n\n.entry-title a, .sidebar .widgettitle a {\n	color: #0089d0;\n}\n\n.entry-title a:hover {\n	color: #99cc33;\n}\n\nh1, h2, h3, h4, h5, h6 {\n	color: #87c440;\n	margin-bottom: 10px;\n}\n\n.entry-content a {\n	color: #0089d0;\n}\n\nbody {\n	color: rgb(84,84,84);\n	font-family: \'Lato\', sans-serif;\n	font-size: 1.6rem;\n	font-weight: 300;\n	line-height: 1.5;\n}\n\n#respond label {\n	color: #0089d0;\n}\n\n#reply-title {\n	border-bottom: medium double;\n	color: #0089d0;\n}\n\nbutton, input[type=\"button\"], input[type=\"reset\"], input[type=\"submit\"] {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\nbutton:hover, input[type=\"button\"]:hover, input[type=\"reset\"]:hover, input[type=\"submit\"]:hover {\n	background: none repeat scroll 0 0 #87c440;\n}", "safecss", "Modern Blogger Child Theme", "inherit", "closed", "closed", "", "248-revision-v1", "", "", "2013-10-02 14:11:18", "2013-10-02 14:11:18", "", "248", "http://healthydoghq.com/248-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("287", "1", "2013-10-02 14:12:46", "2013-10-02 14:12:46", "/*\nWelcome to Custom CSS!\n\nCSS (Cascading Style Sheets) is a kind of code that tells the browser how\nto render a web page. You may delete these comments and get started with\nyour customizations.\n\nBy default, your stylesheet will be loaded after the theme stylesheets,\nwhich means that your rules can take precedence and override the theme CSS\nrules. Just write here what you want to change, you don\'t need to copy all\nyour theme\'s stylesheet content.\n*/\n.nav-primary {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\n.nav-primary a:hover, .nav-primary .current-menu-item > a {\n	background-color: #87c440;\n	color: rgb(255,255,255);\n}\n\na {\n	color: #87c440;\n}\n\na:hover {\n	color: #0089d0;\n}\n\n.entry-title {\n	font-family: \'Montserrat\', sans-serif;\n	color: #0089d0;\n	font-size: 2.3rem;\n	font-weight: 300;\n	line-height: 1;\n}\n\n.entry-title a, .sidebar .widgettitle a {\n	color: #0089d0;\n}\n\n.entry-title a:hover {\n	color: #99cc33;\n}\n\nh1, h2, h3, h4, h5, h6 {\n	color: #87c440;\n	margin-bottom: 10px;\n}\n\n.entry-content a {\n	color: #0089d0;\n}\n\nbody {\n	color: rgb(84,84,84);\n	font-family: \'Lato\', sans-serif;\n	font-size: 1.6rem;\n	font-weight: 300;\n	line-height: 1.5;\n}\n\n#respond label {\n	color: #0089d0;\n}\n\n#reply-title {\n	border-bottom: medium double;\n	color: #0089d0;\n}\n\nbutton, input[type=\"button\"], input[type=\"reset\"], input[type=\"submit\"] {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\nbutton:hover, input[type=\"button\"]:hover, input[type=\"reset\"]:hover, input[type=\"submit\"]:hover {\n	background: none repeat scroll 0 0 #87c440;\n}\n\n.simple-social-icons ul li a:hover {\n	background-color: #99cc33 !important;\n	color: rgb(255,255,255) !important;\n}", "safecss", "Modern Blogger Child Theme", "inherit", "closed", "closed", "", "248-revision-v1", "", "", "2013-10-02 14:12:46", "2013-10-02 14:12:46", "", "248", "http://healthydoghq.com/248-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("290", "1", "2013-10-02 14:16:00", "2013-10-02 14:16:00", "/*\nWelcome to Custom CSS!\n\nCSS (Cascading Style Sheets) is a kind of code that tells the browser how\nto render a web page. You may delete these comments and get started with\nyour customizations.\n\nBy default, your stylesheet will be loaded after the theme stylesheets,\nwhich means that your rules can take precedence and override the theme CSS\nrules. Just write here what you want to change, you don\'t need to copy all\nyour theme\'s stylesheet content.\n*/\n.nav-primary {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\n.nav-primary a:hover, .nav-primary .current-menu-item > a {\n	background-color: #87c440;\n	color: rgb(255,255,255);\n}\n\na {\n	color: #87c440;\n}\n\na:hover {\n	color: #0089d0;\n}\n\n.entry-title {\n	font-family: \'Montserrat\', sans-serif;\n	color: #0089d0;\n	font-size: 2.3rem;\n	font-weight: 300;\n	line-height: 1;\n}\n\n.entry-title a, .sidebar .widgettitle a {\n	color: #0089d0;\n}\n\n.entry-title a:hover {\n	color: #99cc33;\n}\n\nh1, h2, h3, h4, h5, h6 {\n	color: #87c440;\n	margin-bottom: 10px;\n}\n\n.entry-content a {\n	color: #0089d0;\n}\n\nbody {\n	color: rgb(84,84,84);\n	font-family: \'Lato\', sans-serif;\n	font-size: 1.6rem;\n	font-weight: 300;\n	line-height: 1.5;\n}\n\n#respond label {\n	color: #0089d0;\n}\n\n#reply-title {\n	border-bottom: medium double;\n	color: #0089d0;\n}\n\nbutton, input[type=\"button\"], input[type=\"reset\"], input[type=\"submit\"] {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\nbutton:hover, input[type=\"button\"]:hover, input[type=\"reset\"]:hover, input[type=\"submit\"]:hover {\n	background: none repeat scroll 0 0 #87c440;\n}\n\n.simple-social-icons ul li a, {\n	background-color: #99cc33 !important;", "safecss", "Modern Blogger Child Theme", "inherit", "closed", "closed", "", "248-revision-v1", "", "", "2013-10-02 14:16:00", "2013-10-02 14:16:00", "", "248", "http://healthydoghq.com/248-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("289", "1", "2013-10-02 14:14:18", "2013-10-02 14:14:18", "/*\nWelcome to Custom CSS!\n\nCSS (Cascading Style Sheets) is a kind of code that tells the browser how\nto render a web page. You may delete these comments and get started with\nyour customizations.\n\nBy default, your stylesheet will be loaded after the theme stylesheets,\nwhich means that your rules can take precedence and override the theme CSS\nrules. Just write here what you want to change, you don\'t need to copy all\nyour theme\'s stylesheet content.\n*/\n.nav-primary {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\n.nav-primary a:hover, .nav-primary .current-menu-item > a {\n	background-color: #87c440;\n	color: rgb(255,255,255);\n}\n\na {\n	color: #87c440;\n}\n\na:hover {\n	color: #0089d0;\n}\n\n.entry-title {\n	font-family: \'Montserrat\', sans-serif;\n	color: #0089d0;\n	font-size: 2.3rem;\n	font-weight: 300;\n	line-height: 1;\n}\n\n.entry-title a, .sidebar .widgettitle a {\n	color: #0089d0;\n}\n\n.entry-title a:hover {\n	color: #99cc33;\n}\n\nh1, h2, h3, h4, h5, h6 {\n	color: #87c440;\n	margin-bottom: 10px;\n}\n\n.entry-content a {\n	color: #0089d0;\n}\n\nbody {\n	color: rgb(84,84,84);\n	font-family: \'Lato\', sans-serif;\n	font-size: 1.6rem;\n	font-weight: 300;\n	line-height: 1.5;\n}\n\n#respond label {\n	color: #0089d0;\n}\n\n#reply-title {\n	border-bottom: medium double;\n	color: #0089d0;\n}\n\nbutton, input[type=\"button\"], input[type=\"reset\"], input[type=\"submit\"] {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\nbutton:hover, input[type=\"button\"]:hover, input[type=\"reset\"]:hover, input[type=\"submit\"]:hover {\n	background: none repeat scroll 0 0 #87c440;\n}\n\n.simple-social-icons ul li a:hover {\n	background-color: #0089d0 !important;\n	color: rgb(255,255,255) !important;\n}\n\n.simple-social-icons ul li a, {\n	background-color: #99cc33 !important;", "safecss", "Modern Blogger Child Theme", "inherit", "closed", "closed", "", "248-revision-v1", "", "", "2013-10-02 14:14:18", "2013-10-02 14:14:18", "", "248", "http://healthydoghq.com/248-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("288", "1", "2013-10-02 14:13:44", "2013-10-02 14:13:44", "/*\nWelcome to Custom CSS!\n\nCSS (Cascading Style Sheets) is a kind of code that tells the browser how\nto render a web page. You may delete these comments and get started with\nyour customizations.\n\nBy default, your stylesheet will be loaded after the theme stylesheets,\nwhich means that your rules can take precedence and override the theme CSS\nrules. Just write here what you want to change, you don\'t need to copy all\nyour theme\'s stylesheet content.\n*/\n.nav-primary {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\n.nav-primary a:hover, .nav-primary .current-menu-item > a {\n	background-color: #87c440;\n	color: rgb(255,255,255);\n}\n\na {\n	color: #87c440;\n}\n\na:hover {\n	color: #0089d0;\n}\n\n.entry-title {\n	font-family: \'Montserrat\', sans-serif;\n	color: #0089d0;\n	font-size: 2.3rem;\n	font-weight: 300;\n	line-height: 1;\n}\n\n.entry-title a, .sidebar .widgettitle a {\n	color: #0089d0;\n}\n\n.entry-title a:hover {\n	color: #99cc33;\n}\n\nh1, h2, h3, h4, h5, h6 {\n	color: #87c440;\n	margin-bottom: 10px;\n}\n\n.entry-content a {\n	color: #0089d0;\n}\n\nbody {\n	color: rgb(84,84,84);\n	font-family: \'Lato\', sans-serif;\n	font-size: 1.6rem;\n	font-weight: 300;\n	line-height: 1.5;\n}\n\n#respond label {\n	color: #0089d0;\n}\n\n#reply-title {\n	border-bottom: medium double;\n	color: #0089d0;\n}\n\nbutton, input[type=\"button\"], input[type=\"reset\"], input[type=\"submit\"] {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\nbutton:hover, input[type=\"button\"]:hover, input[type=\"reset\"]:hover, input[type=\"submit\"]:hover {\n	background: none repeat scroll 0 0 #87c440;\n}\n\n.simple-social-icons ul li a:hover {\n	background-color: #0089d0 !important;\n	color: rgb(255,255,255) !important;\n}\n\n.simple-social-icons ul li a, .simple-social-icons ul li a:hover {\n	background-color: #99cc33 !important;", "safecss", "Modern Blogger Child Theme", "inherit", "closed", "closed", "", "248-revision-v1", "", "", "2013-10-02 14:13:44", "2013-10-02 14:13:44", "", "248", "http://healthydoghq.com/248-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("292", "1", "2013-10-02 14:17:48", "2013-10-02 14:17:48", "/*\nWelcome to Custom CSS!\n\nCSS (Cascading Style Sheets) is a kind of code that tells the browser how\nto render a web page. You may delete these comments and get started with\nyour customizations.\n\nBy default, your stylesheet will be loaded after the theme stylesheets,\nwhich means that your rules can take precedence and override the theme CSS\nrules. Just write here what you want to change, you don\'t need to copy all\nyour theme\'s stylesheet content.\n*/\n.nav-primary {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\n.nav-primary a:hover, .nav-primary .current-menu-item > a {\n	background-color: #87c440;\n	color: rgb(255,255,255);\n}\n\na {\n	color: #87c440;\n}\n\na:hover {\n	color: #0089d0;\n}\n\n.entry-title {\n	font-family: \'Montserrat\', sans-serif;\n	color: #0089d0;\n	font-size: 2.3rem;\n	font-weight: 300;\n	line-height: 1;\n}\n\n.entry-title a, .sidebar .widgettitle a {\n	color: #0089d0;\n}\n\n.entry-title a:hover {\n	color: #99cc33;\n}\n\nh1, h2, h3, h4, h5, h6 {\n	color: #87c440;\n	margin-bottom: 10px;\n}\n\n.entry-content a {\n	color: #0089d0;\n}\n\nbody {\n	color: rgb(84,84,84);\n	font-family: \'Lato\', sans-serif;\n	font-size: 1.6rem;\n	font-weight: 300;\n	line-height: 1.5;\n}\n\n#respond label {\n	color: #0089d0;\n}\n\n#reply-title {\n	border-bottom: medium double;\n	color: #0089d0;\n}\n\nbutton, input[type=\"button\"], input[type=\"reset\"], input[type=\"submit\"] {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\nbutton:hover, input[type=\"button\"]:hover, input[type=\"reset\"]:hover, input[type=\"submit\"]:hover {\n	background: none repeat scroll 0 0 #87c440;\n}\n\n.simple-social-icons ul li a, {\n	background-color: #0089d0 !important;\n}", "safecss", "Modern Blogger Child Theme", "inherit", "closed", "closed", "", "248-revision-v1", "", "", "2013-10-02 14:17:48", "2013-10-02 14:17:48", "", "248", "http://healthydoghq.com/248-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("291", "1", "2013-10-02 14:17:04", "2013-10-02 14:17:04", "/*\nWelcome to Custom CSS!\n\nCSS (Cascading Style Sheets) is a kind of code that tells the browser how\nto render a web page. You may delete these comments and get started with\nyour customizations.\n\nBy default, your stylesheet will be loaded after the theme stylesheets,\nwhich means that your rules can take precedence and override the theme CSS\nrules. Just write here what you want to change, you don\'t need to copy all\nyour theme\'s stylesheet content.\n*/\n.nav-primary {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\n.nav-primary a:hover, .nav-primary .current-menu-item > a {\n	background-color: #87c440;\n	color: rgb(255,255,255);\n}\n\na {\n	color: #87c440;\n}\n\na:hover {\n	color: #0089d0;\n}\n\n.entry-title {\n	font-family: \'Montserrat\', sans-serif;\n	color: #0089d0;\n	font-size: 2.3rem;\n	font-weight: 300;\n	line-height: 1;\n}\n\n.entry-title a, .sidebar .widgettitle a {\n	color: #0089d0;\n}\n\n.entry-title a:hover {\n	color: #99cc33;\n}\n\nh1, h2, h3, h4, h5, h6 {\n	color: #87c440;\n	margin-bottom: 10px;\n}\n\n.entry-content a {\n	color: #0089d0;\n}\n\nbody {\n	color: rgb(84,84,84);\n	font-family: \'Lato\', sans-serif;\n	font-size: 1.6rem;\n	font-weight: 300;\n	line-height: 1.5;\n}\n\n#respond label {\n	color: #0089d0;\n}\n\n#reply-title {\n	border-bottom: medium double;\n	color: #0089d0;\n}\n\nbutton, input[type=\"button\"], input[type=\"reset\"], input[type=\"submit\"] {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\nbutton:hover, input[type=\"button\"]:hover, input[type=\"reset\"]:hover, input[type=\"submit\"]:hover {\n	background: none repeat scroll 0 0 #87c440;\n}\n\n.simple-social-icons ul li a, .simple-social-icons ul li a:hover {\n	background-color: #0089d0 !important;", "safecss", "Modern Blogger Child Theme", "inherit", "closed", "closed", "", "248-revision-v1", "", "", "2013-10-02 14:17:04", "2013-10-02 14:17:04", "", "248", "http://healthydoghq.com/248-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("293", "1", "2013-10-02 14:22:30", "2013-10-02 14:22:30", "/*\nWelcome to Custom CSS!\n\nCSS (Cascading Style Sheets) is a kind of code that tells the browser how\nto render a web page. You may delete these comments and get started with\nyour customizations.\n\nBy default, your stylesheet will be loaded after the theme stylesheets,\nwhich means that your rules can take precedence and override the theme CSS\nrules. Just write here what you want to change, you don\'t need to copy all\nyour theme\'s stylesheet content.\n*/\n.nav-primary {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\n.nav-primary a:hover, .nav-primary .current-menu-item > a {\n	background-color: #87c440;\n	color: rgb(255,255,255);\n}\n\na {\n	color: #87c440;\n}\n\na:hover {\n	color: #0089d0;\n}\n\n.entry-title {\n	font-family: \'Montserrat\', sans-serif;\n	color: #0089d0;\n	font-size: 2.3rem;\n	font-weight: 300;\n	line-height: 1;\n}\n\n.entry-title a, .sidebar .widgettitle a {\n	color: #0089d0;\n}\n\n.entry-title a:hover {\n	color: #99cc33;\n}\n\nh1, h2, h3, h4, h5, h6 {\n	color: #87c440;\n	margin-bottom: 10px;\n}\n\n.entry-content a {\n	color: #0089d0;\n}\n\nbody {\n	color: rgb(84,84,84);\n	font-family: \'Lato\', sans-serif;\n	font-size: 1.6rem;\n	font-weight: 300;\n	line-height: 1.5;\n}\n\n#respond label {\n	color: #0089d0;\n}\n\n#reply-title {\n	border-bottom: medium double;\n	color: #0089d0;\n}\n\nbutton, input[type=\"button\"], input[type=\"reset\"], input[type=\"submit\"] {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\nbutton:hover, input[type=\"button\"]:hover, input[type=\"reset\"]:hover, input[type=\"submit\"]:hover {\n	background: none repeat scroll 0 0 #87c440;\n}\n\n.simple-social-icons ul li a, .simple-social-icons ul li a:hover {\n	background-color: #0089d0 !important;", "safecss", "Modern Blogger Child Theme", "inherit", "closed", "closed", "", "248-revision-v1", "", "", "2013-10-02 14:22:30", "2013-10-02 14:22:30", "", "248", "http://healthydoghq.com/248-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("294", "1", "2013-10-02 14:24:01", "2013-10-02 14:24:01", "/*\nWelcome to Custom CSS!\n\nCSS (Cascading Style Sheets) is a kind of code that tells the browser how\nto render a web page. You may delete these comments and get started with\nyour customizations.\n\nBy default, your stylesheet will be loaded after the theme stylesheets,\nwhich means that your rules can take precedence and override the theme CSS\nrules. Just write here what you want to change, you don\'t need to copy all\nyour theme\'s stylesheet content.\n*/\n.nav-primary {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\n.nav-primary a:hover, .nav-primary .current-menu-item > a {\n	background-color: #87c440;\n	color: rgb(255,255,255);\n}\n\na {\n	color: #87c440;\n}\n\na:hover {\n	color: #0089d0;\n}\n\n.entry-title {\n	font-family: \'Montserrat\', sans-serif;\n	color: #0089d0;\n	font-size: 2.3rem;\n	font-weight: 300;\n	line-height: 1;\n}\n\n.entry-title a, .sidebar .widgettitle a {\n	color: #0089d0;\n}\n\n.entry-title a:hover {\n	color: #99cc33;\n}\n\nh1, h2, h3, h4, h5, h6 {\n	color: #87c440;\n	margin-bottom: 10px;\n}\n\n.entry-content a {\n	color: #0089d0;\n}\n\nbody {\n	color: rgb(84,84,84);\n	font-family: \'Lato\', sans-serif;\n	font-size: 1.6rem;\n	font-weight: 300;\n	line-height: 1.5;\n}\n\n#respond label {\n	color: #0089d0;\n}\n\n#reply-title {\n	border-bottom: medium double;\n	color: #0089d0;\n}\n\nbutton, input[type=\"button\"], input[type=\"reset\"], input[type=\"submit\"] {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\nbutton:hover, input[type=\"button\"]:hover, input[type=\"reset\"]:hover, input[type=\"submit\"]:hover {\n	background: none repeat scroll 0 0 #87c440;\n}\n\n.simple-social-icons ul li a {\n	background: #2cb1a3 !important;\n}\n\n.simple-social-icons ul li a:hover {\n	background-color: #ff8584 !important;\n}", "safecss", "Modern Blogger Child Theme", "inherit", "closed", "closed", "", "248-revision-v1", "", "", "2013-10-02 14:24:01", "2013-10-02 14:24:01", "", "248", "http://healthydoghq.com/248-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("295", "1", "2013-10-02 14:24:34", "2013-10-02 14:24:34", "/*\nWelcome to Custom CSS!\n\nCSS (Cascading Style Sheets) is a kind of code that tells the browser how\nto render a web page. You may delete these comments and get started with\nyour customizations.\n\nBy default, your stylesheet will be loaded after the theme stylesheets,\nwhich means that your rules can take precedence and override the theme CSS\nrules. Just write here what you want to change, you don\'t need to copy all\nyour theme\'s stylesheet content.\n*/\n.nav-primary {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\n.nav-primary a:hover, .nav-primary .current-menu-item > a {\n	background-color: #87c440;\n	color: rgb(255,255,255);\n}\n\na {\n	color: #87c440;\n}\n\na:hover {\n	color: #0089d0;\n}\n\n.entry-title {\n	font-family: \'Montserrat\', sans-serif;\n	color: #0089d0;\n	font-size: 2.3rem;\n	font-weight: 300;\n	line-height: 1;\n}\n\n.entry-title a, .sidebar .widgettitle a {\n	color: #0089d0;\n}\n\n.entry-title a:hover {\n	color: #99cc33;\n}\n\nh1, h2, h3, h4, h5, h6 {\n	color: #87c440;\n	margin-bottom: 10px;\n}\n\n.entry-content a {\n	color: #0089d0;\n}\n\nbody {\n	color: rgb(84,84,84);\n	font-family: \'Lato\', sans-serif;\n	font-size: 1.6rem;\n	font-weight: 300;\n	line-height: 1.5;\n}\n\n#respond label {\n	color: #0089d0;\n}\n\n#reply-title {\n	border-bottom: medium double;\n	color: #0089d0;\n}\n\nbutton, input[type=\"button\"], input[type=\"reset\"], input[type=\"submit\"] {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\nbutton:hover, input[type=\"button\"]:hover, input[type=\"reset\"]:hover, input[type=\"submit\"]:hover {\n	background: none repeat scroll 0 0 #87c440;\n}\n\n.simple-social-icons ul li a {\n	background: #87c440 !important;\n}\n\n.simple-social-icons ul li a:hover {\n	background-color: #0089d0 !important;\n}", "safecss", "Modern Blogger Child Theme", "inherit", "closed", "closed", "", "248-revision-v1", "", "", "2013-10-02 14:24:34", "2013-10-02 14:24:34", "", "248", "http://healthydoghq.com/248-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("297", "1", "2013-10-02 14:31:02", "2013-10-02 14:31:02", "/*\nWelcome to Custom CSS!\n\nCSS (Cascading Style Sheets) is a kind of code that tells the browser how\nto render a web page. You may delete these comments and get started with\nyour customizations.\n\nBy default, your stylesheet will be loaded after the theme stylesheets,\nwhich means that your rules can take precedence and override the theme CSS\nrules. Just write here what you want to change, you don\'t need to copy all\nyour theme\'s stylesheet content.\n*/\n.nav-primary {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\n.nav-primary a:hover, .nav-primary .current-menu-item > a {\n	background-color: #87c440;\n	color: rgb(255,255,255);\n}\n\na {\n	color: #87c440;\n}\n\na:hover {\n	color: #0089d0;\n}\n\n.entry-title {\n	font-family: \'Montserrat\', sans-serif;\n	color: #0089d0;\n	font-size: 2.3rem;\n	font-weight: 300;\n	line-height: 1;\n}\n\n.entry-title a, .sidebar .widgettitle a {\n	color: #0089d0;\n}\n\n.entry-title a:hover {\n	color: #99cc33;\n}\n\nh1, h2, h3, h4, h5, h6 {\n	color: #87c440;\n	margin-bottom: 10px;\n}\n\n.entry-content a {\n	color: #0089d0;\n}\n\nbody {\n	color: rgb(84,84,84);\n	font-family: \'Lato\', sans-serif;\n	font-size: 1.6rem;\n	font-weight: 300;\n	line-height: 1.5;\n}\n\n#respond label {\n	color: #0089d0;\n}\n\n#reply-title {\n	border-bottom: medium double;\n	color: #0089d0;\n}\n\nbutton, input[type=\"button\"], input[type=\"reset\"], input[type=\"submit\"] {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\nbutton:hover, input[type=\"button\"]:hover, input[type=\"reset\"]:hover, input[type=\"submit\"]:hover {\n	background: none repeat scroll 0 0 #87c440;\n}\n\n.simple-social-icons ul li a {\n	background: #87c440 !important;\n}\n\n.simple-social-icons ul li a:hover {\n	background-color: #0089d0 !important;\n}", "safecss", "Modern Blogger Child Theme", "inherit", "closed", "closed", "", "248-revision-v1", "", "", "2013-10-02 14:31:02", "2013-10-02 14:31:02", "", "248", "http://healthydoghq.com/248-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("296", "1", "2013-10-02 14:30:27", "2013-10-02 14:30:27", "/*\nWelcome to Custom CSS!\n\nCSS (Cascading Style Sheets) is a kind of code that tells the browser how\nto render a web page. You may delete these comments and get started with\nyour customizations.\n\nBy default, your stylesheet will be loaded after the theme stylesheets,\nwhich means that your rules can take precedence and override the theme CSS\nrules. Just write here what you want to change, you don\'t need to copy all\nyour theme\'s stylesheet content.\n*/\n.nav-primary {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\n.nav-primary a:hover, .nav-primary .current-menu-item > a {\n	background-color: #87c440;\n	color: rgb(255,255,255);\n}\n\na {\n	color: #87c440;\n}\n\na:hover {\n	color: #0089d0;\n}\n\n.entry-title {\n	font-family: \'Montserrat\', sans-serif;\n	color: #0089d0;\n	font-size: 2.3rem;\n	font-weight: 300;\n	line-height: 1;\n}\n\n.entry-title a, .sidebar .widgettitle a {\n	color: #0089d0;\n}\n\n.entry-title a:hover {\n	color: #99cc33;\n}\n\nh1, h2, h3, h4, h5, h6 {\n	color: #87c440;\n	margin-bottom: 10px;\n}\n\n.entry-content a {\n	color: #0089d0;\n}\n\nbody {\n	color: rgb(84,84,84);\n	font-family: \'Lato\', sans-serif;\n	font-size: 1.6rem;\n	font-weight: 300;\n	line-height: 1.5;\n}\n\n#respond label {\n	color: #0089d0;\n}\n\n#reply-title {\n	border-bottom: medium double;\n	color: #0089d0;\n}\n\nbutton, input[type=\"button\"], input[type=\"reset\"], input[type=\"submit\"] {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\nbutton:hover, input[type=\"button\"]:hover, input[type=\"reset\"]:hover, input[type=\"submit\"]:hover {\n	background: none repeat scroll 0 0 #87c440;\n}\n\n.simple-social-icons ul li a {\n	background: rgb(183,199,40) !important;\n}\n\n.simple-social-icons ul li a:hover {\n	background-color: #0089d0 !important;\n}", "safecss", "Modern Blogger Child Theme", "inherit", "closed", "closed", "", "248-revision-v1", "", "", "2013-10-02 14:30:27", "2013-10-02 14:30:27", "", "248", "http://healthydoghq.com/248-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("298", "1", "2013-10-02 14:33:17", "2013-10-02 14:33:17", "/*\nWelcome to Custom CSS!\n\nCSS (Cascading Style Sheets) is a kind of code that tells the browser how\nto render a web page. You may delete these comments and get started with\nyour customizations.\n\nBy default, your stylesheet will be loaded after the theme stylesheets,\nwhich means that your rules can take precedence and override the theme CSS\nrules. Just write here what you want to change, you don\'t need to copy all\nyour theme\'s stylesheet content.\n*/\n.nav-primary {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\n.nav-primary a:hover, .nav-primary .current-menu-item > a {\n	background-color: #87c440;\n	color: rgb(255,255,255);\n}\n\na {\n	color: #87c440;\n}\n\na:hover {\n	color: #0089d0;\n}\n\n.entry-title {\n	font-family: \'Montserrat\', sans-serif;\n	color: #0089d0;\n	font-size: 2.2rem;\n	font-weight: 300;\n	line-height: 1;\n}\n\n.entry-title a, .sidebar .widgettitle a {\n	color: #0089d0;\n}\n\n.entry-title a:hover {\n	color: #99cc33;\n}\n\nh1, h2, h3, h4, h5, h6 {\n	color: #87c440;\n	margin-bottom: 10px;\n}\n\n.entry-content a {\n	color: #0089d0;\n}\n\nbody {\n	color: rgb(84,84,84);\n	font-family: \'Lato\', sans-serif;\n	font-size: 1.6rem;\n	font-weight: 300;\n	line-height: 1.5;\n}\n\n#respond label {\n	color: #0089d0;\n}\n\n#reply-title {\n	border-bottom: medium double;\n	color: #0089d0;\n}\n\nbutton, input[type=\"button\"], input[type=\"reset\"], input[type=\"submit\"] {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\nbutton:hover, input[type=\"button\"]:hover, input[type=\"reset\"]:hover, input[type=\"submit\"]:hover {\n	background: none repeat scroll 0 0 #87c440;\n}\n\n.simple-social-icons ul li a {\n	background: #87c440 !important;\n}\n\n.simple-social-icons ul li a:hover {\n	background-color: #0089d0 !important;\n}", "safecss", "Modern Blogger Child Theme", "inherit", "closed", "closed", "", "248-revision-v1", "", "", "2013-10-02 14:33:17", "2013-10-02 14:33:17", "", "248", "http://healthydoghq.com/248-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("299", "1", "2013-10-02 14:33:30", "2013-10-02 14:33:30", "/*\nWelcome to Custom CSS!\n\nCSS (Cascading Style Sheets) is a kind of code that tells the browser how\nto render a web page. You may delete these comments and get started with\nyour customizations.\n\nBy default, your stylesheet will be loaded after the theme stylesheets,\nwhich means that your rules can take precedence and override the theme CSS\nrules. Just write here what you want to change, you don\'t need to copy all\nyour theme\'s stylesheet content.\n*/\n.nav-primary {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\n.nav-primary a:hover, .nav-primary .current-menu-item > a {\n	background-color: #87c440;\n	color: rgb(255,255,255);\n}\n\na {\n	color: #87c440;\n}\n\na:hover {\n	color: #0089d0;\n}\n\n.entry-title {\n	font-family: \'Montserrat\', sans-serif;\n	color: #0089d0;\n	font-size: 2.1rem;\n	font-weight: 300;\n	line-height: 1;\n}\n\n.entry-title a, .sidebar .widgettitle a {\n	color: #0089d0;\n}\n\n.entry-title a:hover {\n	color: #99cc33;\n}\n\nh1, h2, h3, h4, h5, h6 {\n	color: #87c440;\n	margin-bottom: 10px;\n}\n\n.entry-content a {\n	color: #0089d0;\n}\n\nbody {\n	color: rgb(84,84,84);\n	font-family: \'Lato\', sans-serif;\n	font-size: 1.6rem;\n	font-weight: 300;\n	line-height: 1.5;\n}\n\n#respond label {\n	color: #0089d0;\n}\n\n#reply-title {\n	border-bottom: medium double;\n	color: #0089d0;\n}\n\nbutton, input[type=\"button\"], input[type=\"reset\"], input[type=\"submit\"] {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\nbutton:hover, input[type=\"button\"]:hover, input[type=\"reset\"]:hover, input[type=\"submit\"]:hover {\n	background: none repeat scroll 0 0 #87c440;\n}\n\n.simple-social-icons ul li a {\n	background: #87c440 !important;\n}\n\n.simple-social-icons ul li a:hover {\n	background-color: #0089d0 !important;\n}", "safecss", "Modern Blogger Child Theme", "inherit", "closed", "closed", "", "248-revision-v1", "", "", "2013-10-02 14:33:30", "2013-10-02 14:33:30", "", "248", "http://healthydoghq.com/248-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("300", "1", "2013-10-02 15:02:18", "2013-10-02 15:02:18", "/*\nWelcome to Custom CSS!\n\nCSS (Cascading Style Sheets) is a kind of code that tells the browser how\nto render a web page. You may delete these comments and get started with\nyour customizations.\n\nBy default, your stylesheet will be loaded after the theme stylesheets,\nwhich means that your rules can take precedence and override the theme CSS\nrules. Just write here what you want to change, you don\'t need to copy all\nyour theme\'s stylesheet content.\n*/\n.nav-primary {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\n.nav-primary a:hover, .nav-primary .current-menu-item > a {\n	background-color: #87c440;\n	color: rgb(255,255,255);\n}\n\na {\n	color: #87c440;\n}\n\na:hover {\n	color: #0089d0;\n}\n\n.entry-title {\n	font-family: \'Montserrat\', sans-serif;\n	color: #0089d0;\n	font-size: 2.1rem;\n	font-weight: 300;\n	line-height: 1;\n}\n\n.entry-title a, .sidebar .widgettitle a {\n	color: #0089d0;\n}\n\n.entry-title a:hover {\n	color: #99cc33;\n}\n\nh1, h2, h3, h4, h5, h6 {\n	color: #87c440;\n	margin-bottom: 10px;\n}\n\n.entry-content a {\n	color: #0089d0;\n}\n\nbody {\n	color: rgb(84,84,84);\n	font-family: \'Lato\', sans-serif;\n	font-size: 1.6rem;\n	font-weight: 300;\n	line-height: 1.5;\n}\n\n#respond label {\n	color: #0089d0;\n}\n\n#reply-title {\n	border-bottom: medium double;\n	color: #0089d0;\n}\n\nbutton, input[type=\"button\"], input[type=\"reset\"], input[type=\"submit\"] {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\nbutton:hover, input[type=\"button\"]:hover, input[type=\"reset\"]:hover, input[type=\"submit\"]:hover {\n	background: none repeat scroll 0 0 #87c440;\n}\n\n.simple-social-icons ul li a, .simple-social-icons ul li a:hover {\n	background-color: rgb(241,107,16) !important;\n	border-radius: 300px 300px 300px 300px;\n}\n\n.simple-social-icons ul li a {\n	background: #87c440 !important;\n}\n\n.simple-social-icons ul li a:hover {\n	background-color: #0089d0 !important;\n}", "safecss", "Modern Blogger Child Theme", "inherit", "closed", "closed", "", "248-revision-v1", "", "", "2013-10-02 15:02:18", "2013-10-02 15:02:18", "", "248", "http://healthydoghq.com/248-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("301", "1", "2013-10-04 17:53:27", "2013-10-04 17:53:27", "/*\nWelcome to Custom CSS!\n\nCSS (Cascading Style Sheets) is a kind of code that tells the browser how\nto render a web page. You may delete these comments and get started with\nyour customizations.\n\nBy default, your stylesheet will be loaded after the theme stylesheets,\nwhich means that your rules can take precedence and override the theme CSS\nrules. Just write here what you want to change, you don\'t need to copy all\nyour theme\'s stylesheet content.\n*/\n.nav-primary {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\n.nav-primary a:hover, .nav-primary .current-menu-item > a {\n	background-color: #9dc172;\n	color: rgb(255,255,255);\n}\n\na {\n	color: #9dc172;\n}\n\na:hover {\n	color: #0089d0;\n}\n\n.entry-title {\n	font-family: \'Montserrat\', sans-serif;\n	color: #0089d0;\n	font-size: 2.1rem;\n	font-weight: 300;\n	line-height: 1;\n}\n\n.entry-title a, .sidebar .widgettitle a {\n	color: #0089d0;\n}\n\n.entry-title a:hover {\n	color: #99cc33;\n}\n\nh1, h2, h3, h4, h5, h6 {\n	color: #87c440;\n	margin-bottom: 10px;\n}\n\n.entry-content a {\n	color: #0089d0;\n}\n\nbody {\n	color: rgb(84,84,84);\n	font-family: \'Lato\', sans-serif;\n	font-size: 1.6rem;\n	font-weight: 300;\n	line-height: 1.5;\n}\n\n#respond label {\n	color: #0089d0;\n}\n\n#reply-title {\n	border-bottom: medium double;\n	color: #0089d0;\n}\n\nbutton, input[type=\"button\"], input[type=\"reset\"], input[type=\"submit\"] {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\nbutton:hover, input[type=\"button\"]:hover, input[type=\"reset\"]:hover, input[type=\"submit\"]:hover {\n	background: none repeat scroll 0 0 #87c440;\n}\n\n.simple-social-icons ul li a, .simple-social-icons ul li a:hover {\n	background-color: rgb(241,107,16) !important;\n	border-radius: 300px 300px 300px 300px;\n}\n\n.simple-social-icons ul li a {\n	background: #87c440 !important;\n}\n\n.simple-social-icons ul li a:hover {\n	background-color: #0089d0 !important;\n}", "safecss", "Modern Blogger Child Theme", "inherit", "closed", "closed", "", "248-revision-v1", "", "", "2013-10-04 17:53:27", "2013-10-04 17:53:27", "", "248", "http://healthydoghq.com/248-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("302", "1", "2013-10-04 17:54:09", "2013-10-04 17:54:09", "/*\nWelcome to Custom CSS!\n\nCSS (Cascading Style Sheets) is a kind of code that tells the browser how\nto render a web page. You may delete these comments and get started with\nyour customizations.\n\nBy default, your stylesheet will be loaded after the theme stylesheets,\nwhich means that your rules can take precedence and override the theme CSS\nrules. Just write here what you want to change, you don\'t need to copy all\nyour theme\'s stylesheet content.\n*/\n.nav-primary {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\n.nav-primary a:hover, .nav-primary .current-menu-item > a {\n	background-color: #9dc172;\n	color: rgb(255,255,255);\n}\n\na {\n	color: #9dc172;\n}\n\na:hover {\n	color: #0089d0;\n}\n\n.entry-title {\n	font-family: \'Montserrat\', sans-serif;\n	color: #0089d0;\n	font-size: 2.1rem;\n	font-weight: 300;\n	line-height: 1;\n}\n\n.entry-title a, .sidebar .widgettitle a {\n	color: #0089d0;\n}\n\n.entry-title a:hover {\n	color: #9dc172;\n}\n\nh1, h2, h3, h4, h5, h6 {\n	color: #9dc172;\n	margin-bottom: 10px;\n}\n\n.entry-content a {\n	color: #0089d0;\n}\n\nbody {\n	color: rgb(84,84,84);\n	font-family: \'Lato\', sans-serif;\n	font-size: 1.6rem;\n	font-weight: 300;\n	line-height: 1.5;\n}\n\n#respond label {\n	color: #0089d0;\n}\n\n#reply-title {\n	border-bottom: medium double;\n	color: #0089d0;\n}\n\nbutton, input[type=\"button\"], input[type=\"reset\"], input[type=\"submit\"] {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\nbutton:hover, input[type=\"button\"]:hover, input[type=\"reset\"]:hover, input[type=\"submit\"]:hover {\n	background: none repeat scroll 0 0 #9dc172;\n}\n\n.simple-social-icons ul li a, .simple-social-icons ul li a:hover {\n	background-color: rgb(241,107,16) !important;\n	border-radius: 300px 300px 300px 300px;\n}\n\n.simple-social-icons ul li a {\n	background: #9dc172 !important;\n}\n\n.simple-social-icons ul li a:hover {\n	background-color: #0089d0 !important;\n}", "safecss", "Modern Blogger Child Theme", "inherit", "closed", "closed", "", "248-revision-v1", "", "", "2013-10-04 17:54:09", "2013-10-04 17:54:09", "", "248", "http://healthydoghq.com/248-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("304", "1", "2013-10-04 18:00:54", "2013-10-04 18:00:54", "/*\nWelcome to Custom CSS!\n\nCSS (Cascading Style Sheets) is a kind of code that tells the browser how\nto render a web page. You may delete these comments and get started with\nyour customizations.\n\nBy default, your stylesheet will be loaded after the theme stylesheets,\nwhich means that your rules can take precedence and override the theme CSS\nrules. Just write here what you want to change, you don\'t need to copy all\nyour theme\'s stylesheet content.\n*/\n.nav-primary {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\n.nav-primary a:hover, .nav-primary .current-menu-item > a {\n	background-color: #b7c71e;\n	color: rgb(255,255,255);\n}\n\na {\n	color: #b7c71e;\n}\n\na:hover {\n	color: #0089d0;\n}\n\n.entry-title {\n	font-family: \'Montserrat\', sans-serif;\n	color: #0089d0;\n	font-size: 2.1rem;\n	font-weight: 300;\n	line-height: 1;\n}\n\n.entry-title a, .sidebar .widgettitle a {\n	color: #0089d0;\n}\n\n.entry-title a:hover {\n	color: #b7c71e;\n}\n\nh1, h2, h3, h4, h5, h6 {\n	color: #9dc172;\n	margin-bottom: 10px;\n}\n\n.entry-content a {\n	color: #0089d0;\n}\n\nbody {\n	color: rgb(84,84,84);\n	font-family: \'Lato\', sans-serif;\n	font-size: 1.6rem;\n	font-weight: 300;\n	line-height: 1.5;\n}\n\n#respond label {\n	color: #0089d0;\n}\n\n#reply-title {\n	border-bottom: medium double;\n	color: #0089d0;\n}\n\nbutton, input[type=\"button\"], input[type=\"reset\"], input[type=\"submit\"] {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\nbutton:hover, input[type=\"button\"]:hover, input[type=\"reset\"]:hover, input[type=\"submit\"]:hover {\n	background: none repeat scroll 0 0 #b7c71e;\n}\n\n.simple-social-icons ul li a, .simple-social-icons ul li a:hover {\n	background-color: #b7c71e !important;\n	border-radius: 300px 300px 300px 300px;\n}\n\n.simple-social-icons ul li a {\n	background: #b7c71e !important;\n}\n\n.simple-social-icons ul li a:hover {\n	background-color: #0089d0 !important;\n}", "safecss", "Modern Blogger Child Theme", "inherit", "closed", "closed", "", "248-revision-v1", "", "", "2013-10-04 18:00:54", "2013-10-04 18:00:54", "", "248", "http://healthydoghq.com/248-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("303", "1", "2013-10-04 17:56:26", "2013-10-04 17:56:26", "/*\nWelcome to Custom CSS!\n\nCSS (Cascading Style Sheets) is a kind of code that tells the browser how\nto render a web page. You may delete these comments and get started with\nyour customizations.\n\nBy default, your stylesheet will be loaded after the theme stylesheets,\nwhich means that your rules can take precedence and override the theme CSS\nrules. Just write here what you want to change, you don\'t need to copy all\nyour theme\'s stylesheet content.\n*/\n.nav-primary {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\n.nav-primary a:hover, .nav-primary .current-menu-item > a {\n	background-color: #9dc172;\n	color: rgb(255,255,255);\n}\n\na {\n	color: #9dc172;\n}\n\na:hover {\n	color: #0089d0;\n}\n\n.entry-title {\n	font-family: \'Montserrat\', sans-serif;\n	color: #0089d0;\n	font-size: 2.1rem;\n	font-weight: 300;\n	line-height: 1;\n}\n\n.entry-title a, .sidebar .widgettitle a {\n	color: #0089d0;\n}\n\n.entry-title a:hover {\n	color: #9dc172;\n}\n\nh1, h2, h3, h4, h5, h6 {\n	color: #9dc172;\n	margin-bottom: 10px;\n}\n\n.entry-content a {\n	color: #0089d0;\n}\n\nbody {\n	color: rgb(84,84,84);\n	font-family: \'Lato\', sans-serif;\n	font-size: 1.6rem;\n	font-weight: 300;\n	line-height: 1.5;\n}\n\n#respond label {\n	color: #0089d0;\n}\n\n#reply-title {\n	border-bottom: medium double;\n	color: #0089d0;\n}\n\nbutton, input[type=\"button\"], input[type=\"reset\"], input[type=\"submit\"] {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\nbutton:hover, input[type=\"button\"]:hover, input[type=\"reset\"]:hover, input[type=\"submit\"]:hover {\n	background: none repeat scroll 0 0 #9dc172;\n}\n\n.simple-social-icons ul li a, .simple-social-icons ul li a:hover {\n	background-color: rgb(183,199,40) !important;\n	border-radius: 300px 300px 300px 300px;\n}\n\n.simple-social-icons ul li a {\n	background: rgb(183,199,40) !important;\n}\n\n.simple-social-icons ul li a:hover {\n	background-color: #0089d0 !important;\n}", "safecss", "Modern Blogger Child Theme", "inherit", "closed", "closed", "", "248-revision-v1", "", "", "2013-10-04 17:56:26", "2013-10-04 17:56:26", "", "248", "http://healthydoghq.com/248-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("305", "1", "2013-10-04 18:02:41", "2013-10-04 18:02:41", "/*\nWelcome to Custom CSS!\n\nCSS (Cascading Style Sheets) is a kind of code that tells the browser how\nto render a web page. You may delete these comments and get started with\nyour customizations.\n\nBy default, your stylesheet will be loaded after the theme stylesheets,\nwhich means that your rules can take precedence and override the theme CSS\nrules. Just write here what you want to change, you don\'t need to copy all\nyour theme\'s stylesheet content.\n*/\n.nav-primary {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\n.nav-primary a:hover, .nav-primary .current-menu-item > a {\n	background-color: #b7c71e;\n	color: rgb(255,255,255);\n}\n\na {\n	color: #b7c71e;\n}\n\na:hover {\n	color: #0089d0;\n}\n\n.entry-title {\n	font-family: \'Montserrat\', sans-serif;\n	color: #0089d0;\n	font-size: 2.1rem;\n	font-weight: 300;\n	line-height: 1;\n}\n\n.entry-title a, .sidebar .widgettitle a {\n	color: #0089d0;\n}\n\n.entry-title a:hover {\n	color: #b7c71e;\n}\n\nh1, h2, h3, h4, h5, h6 {\n	color: #b7c71e;\n	margin-bottom: 10px;\n}\n\n.entry-content a {\n	color: #0089d0;\n}\n\nbody {\n	color: rgb(84,84,84);\n	font-family: \'Lato\', sans-serif;\n	font-size: 1.6rem;\n	font-weight: 300;\n	line-height: 1.5;\n}\n\n#respond label {\n	color: #0089d0;\n}\n\n#reply-title {\n	border-bottom: medium double;\n	color: #0089d0;\n}\n\nbutton, input[type=\"button\"], input[type=\"reset\"], input[type=\"submit\"] {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\nbutton:hover, input[type=\"button\"]:hover, input[type=\"reset\"]:hover, input[type=\"submit\"]:hover {\n	background: none repeat scroll 0 0 #b7c71e;\n}\n\n.simple-social-icons ul li a, .simple-social-icons ul li a:hover {\n	background-color: #b7c71e !important;\n	border-radius: 300px 300px 300px 300px;\n}\n\n.simple-social-icons ul li a {\n	background: #b7c71e !important;\n}\n\n.simple-social-icons ul li a:hover {\n	background-color: #0089d0 !important;\n}", "safecss", "Modern Blogger Child Theme", "inherit", "closed", "closed", "", "248-revision-v1", "", "", "2013-10-04 18:02:41", "2013-10-04 18:02:41", "", "248", "http://healthydoghq.com/248-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("306", "1", "2013-10-04 18:06:06", "2013-10-04 18:06:06", "/*\nWelcome to Custom CSS!\n\nCSS (Cascading Style Sheets) is a kind of code that tells the browser how\nto render a web page. You may delete these comments and get started with\nyour customizations.\n\nBy default, your stylesheet will be loaded after the theme stylesheets,\nwhich means that your rules can take precedence and override the theme CSS\nrules. Just write here what you want to change, you don\'t need to copy all\nyour theme\'s stylesheet content.\n*/\n.nav-primary {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\n.nav-primary a:hover, .nav-primary .current-menu-item > a {\n	background-color: #b7c71e;\n	color: rgb(255,255,255);\n}\n\na {\n	color: #b7c71e;\n}\n\na:hover {\n	color: #0089d0;\n}\n\n.entry-title {\n	font-family: \'Montserrat\', sans-serif;\n	color: #0089d0;\n	font-size: 2.1rem;\n	font-weight: 300;\n	line-height: 1;\n}\n\n.entry-title a, .sidebar .widgettitle a {\n	color: #0089d0;\n}\n\n.entry-title a:hover {\n	color: #b7c71e;\n}\n\nh1, h2, h3, h4, h5, h6 {\n	color: #b7c71e;\n	margin-bottom: 10px;\n}\n\n.entry-content a {\n	color: #0089d0;\n}\n\nbody {\n	color: rgb(84,84,84);\n	font-family: \'Lato\', sans-serif;\n	font-size: 1.6rem;\n	font-weight: 300;\n	line-height: 1.5;\n}\n\n#respond label {\n	color: #0089d0;\n}\n\n#reply-title {\n	border-bottom: medium double;\n	color: #0089d0;\n}\n\nbutton, input[type=\"button\"], input[type=\"reset\"], input[type=\"submit\"] {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\nbutton:hover, input[type=\"button\"]:hover, input[type=\"reset\"]:hover, input[type=\"submit\"]:hover {\n	background: none repeat scroll 0 0 #b7c71e;\n}\n\n.simple-social-icons ul li a, .simple-social-icons ul li a:hover {\n	background-color: #b7c71e !important;\n	border-radius: 300px 300px 300px 300px;\n}\n\n.simple-social-icons ul li a {\n	background: #b7c71e !important;\n}\n\n.simple-social-icons ul li a:hover {\n	background-color: #0089d0 !important;\n}\n\n.user-profile a {\n	display: block;\n	font-family: \'Montserrat\', sans-serif;\n}", "safecss", "Modern Blogger Child Theme", "inherit", "closed", "closed", "", "248-revision-v1", "", "", "2013-10-04 18:06:06", "2013-10-04 18:06:06", "", "248", "http://healthydoghq.com/248-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("309", "1", "2013-10-04 18:26:45", "2013-10-04 18:26:45", "/*\nWelcome to Custom CSS!\n\nCSS (Cascading Style Sheets) is a kind of code that tells the browser how\nto render a web page. You may delete these comments and get started with\nyour customizations.\n\nBy default, your stylesheet will be loaded after the theme stylesheets,\nwhich means that your rules can take precedence and override the theme CSS\nrules. Just write here what you want to change, you don\'t need to copy all\nyour theme\'s stylesheet content.\n*/\n.nav-primary {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\n.nav-primary a:hover, .nav-primary .current-menu-item > a {\n	background-color: #b7c71e;\n	color: rgb(255,255,255);\n}\n\na {\n	color: #b7c71e;\n}\n\na:hover {\n	color: #0089d0;\n}\n\n.entry-title {\n	font-family: \'Montserrat\', sans-serif;\n	color: #0089d0;\n	font-size: 2.1rem;\n	font-weight: 300;\n	line-height: 1;\n}\n\n.entry-title a, .sidebar .widgettitle a {\n	color: #0089d0;\n}\n\n.entry-title a:hover {\n	color: #b7c71e;\n}\n\nh1, h2, h3, h4, h5, h6 {\n	color: #b7c71e;\n	margin-bottom: 10px;\n}\n\n.entry-content a {\n	color: #0089d0;\n}\n\nbody {\n	color: rgb(84,84,84);\n	font-family: \'Lato\', sans-serif;\n	font-size: 1.6rem;\n	font-weight: 300;\n	line-height: 1.5;\n}\n\n#respond label {\n	color: #0089d0;\n}\n\n#reply-title {\n	border-bottom: medium double;\n	color: #0089d0;\n}\n\nbutton, input[type=\"button\"], input[type=\"reset\"], input[type=\"submit\"] {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\nbutton:hover, input[type=\"button\"]:hover, input[type=\"reset\"]:hover, input[type=\"submit\"]:hover {\n	background: none repeat scroll 0 0 #b7c71e;\n}\n\n.simple-social-icons ul li a, .simple-social-icons ul li a:hover {\n	background-color: #b7c71e !important;\n	border-radius: 300px 300px 300px 300px;\n}\n\n.simple-social-icons ul li a {\n	background: #b7c71e !important;\n}\n\n.simple-social-icons ul li a:hover {\n	background-color: #0089d0 !important;\n}\n\n.user-profile a {\n	display: block;\n	font-family: \'Montserrat\', sans-serif;\n}\n\n.site-container {\n	background: #fff url(\'\') repeat-x;\n	border: 10px solid #fff;\n	border-top-left-radius: 20px;\n	border-top-right-radius: 20px;\n	margin: 20px auto;\n	max-width: 1168px;\n}", "safecss", "Modern Blogger Child Theme", "inherit", "closed", "closed", "", "248-revision-v1", "", "", "2013-10-04 18:26:45", "2013-10-04 18:26:45", "", "248", "http://healthydoghq.com/248-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("310", "1", "2013-10-04 18:32:33", "2013-10-04 18:32:33", "<img alt=\"Sample Image\" src=\"http://www.genesisframework.com/wp-content/uploads/patagonia.jpg\" />\r\n\r\nThis is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind.\r\n\r\nThis is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind. This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind.\r\n\r\nThis is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind.\r\n\r\nThis is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind. This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind.", "Sample Post With Threaded Comments", "", "inherit", "closed", "closed", "", "91-revision-v1", "", "", "2013-10-04 18:32:33", "2013-10-04 18:32:33", "", "91", "http://healthydoghq.com/91-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("311", "1", "2013-10-04 18:36:08", "2013-10-04 18:36:08", "<a href=\"http://healthydoghq.com/wp-content/uploads/2013/09/POST-1024x682.png\"><img class=\" wp-image-13 alignright\" alt=\"POST-1024x682\" src=\"http://healthydoghq.com/wp-content/uploads/2013/09/POST-1024x682.png\" width=\"414\" height=\"276\" /></a>afsdfsdgasg fsdfsdgasg fsdfsdgasg fsdfsdgasg fsdfsdgasg fsdfsdgasg\r\n\r\nThis is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind.\r\n\r\nThis is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind. This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind.", "Second Post", "", "inherit", "closed", "closed", "", "10-revision-v1", "", "", "2013-10-04 18:36:08", "2013-10-04 18:36:08", "", "10", "http://healthydoghq.com/10-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("328", "1", "2013-10-24 14:11:40", "2013-10-24 14:11:40", "[caption id=\"\" align=\"alignright\" width=\"142\" caption=\"Here\'s a sample caption with an image aligned right.\"]<img alt=\"Here\'s a sample caption with a sample image aligned right.\" src=\"http://demo.studiopress.com/images/wordpress.png\" width=\"142\" height=\"142\" />[/caption]\n\nThis is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like.\n\nThis is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind. This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like.\n\nThis is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind.\n\nThis is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind. This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind.", "Sample Post With Image Aligned Right", "", "inherit", "closed", "closed", "", "89-revision-v1", "", "", "2013-10-24 14:11:40", "2013-10-24 14:11:40", "", "89", "http://healthydoghq.com/89-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("324", "1", "2013-10-23 20:42:58", "2013-10-23 20:42:58", "", "logox2", "", "inherit", "closed", "closed", "", "logox2-3", "", "", "2013-10-23 20:42:58", "2013-10-23 20:42:58", "", "0", "http://healthydoghq.com/wp-content/uploads/2013/10/logox22.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("326", "1", "2013-10-23 20:43:34", "2013-10-23 20:43:34", "", "logo", "", "inherit", "closed", "closed", "", "logo-3", "", "", "2013-10-23 20:43:34", "2013-10-23 20:43:34", "", "0", "http://healthydoghq.com/wp-content/uploads/2013/10/logo6.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("329", "1", "2013-10-24 14:11:40", "2013-10-24 14:11:40", "[caption id=\"\" align=\"aligncenter\" width=\"142\" caption=\"Here\'s a sample caption with an image centered.\"]<img alt=\"Here\'s a sample caption with a sample image centered.\" src=\"http://demo.studiopress.com/images/wordpress.png\" width=\"142\" height=\"142\" />[/caption]\n\nThis is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind.\n\nThis is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind. This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind.\n\nThis is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind.\n\nThis is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind. This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind.", "Sample Post With Image Centered", "", "inherit", "closed", "closed", "", "88-revision-v1", "", "", "2013-10-24 14:11:40", "2013-10-24 14:11:40", "", "88", "http://healthydoghq.com/88-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("330", "1", "2013-10-24 14:11:40", "2013-10-24 14:11:40", "This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind.\n\n<ul>\n<li>Unordered list item #1</li>\n<li>Unordered list item #2</li>\n<li>Unordered list item #3</li>\n<li>Unordered list item #4</li>\n<li>Unordered list item #5</li>\n</ul>\n\nThis is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind.\n\nThis is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind. This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind.", "Sample Post With an Unordered List", "", "inherit", "closed", "closed", "", "87-revision-v1", "", "", "2013-10-24 14:11:40", "2013-10-24 14:11:40", "", "87", "http://healthydoghq.com/87-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("331", "1", "2013-10-24 14:11:40", "2013-10-24 14:11:40", "This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind.\n\n<ol>\n<li>Ordered list item #1</li>\n<li>Ordered list item #2</li>\n<li>Ordered list item #3</li>\n<li>Ordered list item #4</li>\n<li>Ordered list item #5</li>\n</ol>\n\nThis is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind.\n\nThis is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind. This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind.", "Sample Post With an Ordered List", "", "inherit", "closed", "closed", "", "86-revision-v1", "", "", "2013-10-24 14:11:40", "2013-10-24 14:11:40", "", "86", "http://healthydoghq.com/86-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("332", "1", "2013-10-24 14:11:40", "2013-10-24 14:11:40", "This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind.\n\n<blockquote>This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what exactly is on your mind.</blockquote>\n\nThis is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind.\n\nThis is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind. This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind.", "Sample Post With a Blockquote", "", "inherit", "closed", "closed", "", "183-revision-v1", "", "", "2013-10-24 14:11:40", "2013-10-24 14:11:40", "", "183", "http://healthydoghq.com/183-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("333", "1", "2013-10-24 14:11:40", "2013-10-24 14:11:40", "<h1>Headline 1</h1>\n<h2>Headline 2</h2>\n<h3>Headline 3</h3>\n<h4>Headline 4</h4>\n<h5>Headline 5</h5>\n<h6>Headline 6</h6>", "Sample Post With Headlines", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2013-10-24 14:11:40", "2013-10-24 14:11:40", "", "5", "http://healthydoghq.com/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("422", "1", "2013-10-25 15:45:40", "2013-10-25 15:45:40", "<img class=\"alignright size-medium wp-image-409\" alt=\"golda-lure-coursing\" src=\"http://healthydoghq.com/wp-content/uploads/2013/10/golda-lure-coursing1-300x197.jpg\" width=\"300\" height=\"197\" />My husband, Norman and I, have had the privilege of owning whippets for twenty-five years. Over this space of time, we\'ve had a total of six of these sensitive, loving animals, each one with its own personality and way of doing things. Our first whippet, Devo, ruled the pack. Without a doubt, she was at the top of the pecking order at our house, after my husband. We lost her about ten years ago at the age of 15. Fortunately for us, all of our whippets have enjoyed long and healthy lives -- then we got Golda.\r\n\r\nGolda was originally owned by a good friend who owns and shows whippets. In 1992, our friend brought home a 12-week old red and white spitfire named \"Blue Skies Golden Pony\" and called her \"Golda\". The puppy was a gregarious fence jumper with a big heart and personality to match. Golda and Norman hit it off the first time they met. In many ways, Golda became his dog right from the start, and after retiring from the show ring, Golda came to live with us in 2004.\r\n\r\nFrom the first day we adopted her, life with Golda has been an absolute pleasure. She has always been active, friendly and loving, with no agenda, truly the best dog we\'ve ever known. Golda\'s great love in life was chasing the frisbee. Her speed and agility made her great at jumping to terrific heights and making spectacular catches in mid-air. In 2008, we noticed that she landed a bit funny after a routine jump, but she otherwise seemed fine. The next day, we awoke to find her paralyzed from the neck down. Frantically, we took her to several vets to find out that she had suffered from a Fibrocartilaginous Embolism (Canine FCE) -- a blockage in a blood vessel in the spinal cord. It’s often referred to as a spinal cord stroke. Our vet treated her with steroids and for the next six weeks, we became her legs, carrying her outside and holding her up as she went to the bathroom. Over time, she regained the use of her limbs and was eventually able to resume her favorite pastime of chasing the frisbee, albeit at a much reduced speed and intensity. She wasn\'t quite as coordinated as before, but we felt lucky that she was walking again. Little did we know it at the time, but the experience of dealing with Canine FCE would help prepare us for an equally devastating aliment: Canine Immune Mediated Hemolytic Anemia (IMHA) a few short years later.\r\n\r\n<img class=\"size-medium wp-image-408 alignleft\" alt=\"blood-transfusion\" src=\"http://healthydoghq.com/wp-content/uploads/2013/10/blood-transfusion-300x224.jpg\" width=\"288\" height=\"215\" />Even after her bout with Canine FCE, Golda\'s quality of life was very good, but in May of 2013, she had a set back. She once again was having trouble walking and maintaining her balance. We immediately assumed she had a reoccurrence of FCE. The symptoms were virtually the same, but this time, she began loosing weight and her gums were very pale in color. We took her to our vet, Dr. Bill Conley at Summer Animal Hospital, who examined her, ran a complete blood count (CBC) and a packed cell volume test (PCV). The results were staggering. The PCV test put her red blood cell count at 8%!!!  He said he had never seen a dog still alive with such a low blood count and that a normal dog\'s red blood cell volume is between 35 and 55%. Dr. Conley immediately recommended a blood transfusion. Needless to say, we were devastated at the news! How could we have missed all of the signs!? How could we have let Golda get into such a weakened state!? We agreed to the transfusion which \"stabilized\" her red blood cell volume to a still low 15%. As we were leaving his office, Dr. Conley prepared us for the worst by informing us that Golda was suffering from Immune Mediated Hemolytic Anemia (IMHA), formerly known as Canine Auto-Immune Hemolytic Anemia (AIHA), and that the recovery for this disease was \"very low\".  With a heavy heart, we thanked him and took Golda home for what we felt would surely be the last few days of her life.\r\n\r\nThe ride home from the vet\'s office seemed unusually long. On the way, we decided that we would do everything we could do, within reason, to give Golda the chance to recover. We owed that to her for all of the love and joy she had brought to us over the years. When we got home, we assessed our situation and began to formulate a plan to give her the opportunity to heal. Fortunately for us, and Golda, we had some great vets and quite a bit of luck on our side!\r\nGolda\'s Condition\r\n<ul>\r\n	<li>Weight: 19 pounds, normally 27</li>\r\n	<li>Red Blood Cell Volume: 8%, normal is between 35 and 55%</li>\r\n	<li>Appetite: None, normally she\'s a chow hound never turning down a meal</li>\r\n	<li>Ambulatory: Unable to walk or go to the bathroom on her own</li>\r\n	<li>Mental &amp; Emotional: Lethargic, extremely low energy level</li>\r\n	<li>Color: Pale gums - almost white, skin white, even freckles usually seen on legs &amp; tummy very faded and pale</li>\r\n	<li>Coat: Course, red coloring in coat pale</li>\r\n	<li>Nose: Dry and rough to the touch</li>\r\n	<li>Eyes: Third eye lid showing</li>\r\n</ul>\r\nFormulating a Plan\r\n<img class=\"alignright  wp-image-419\" alt=\"golda-skinny\" src=\"http://healthydoghq.com/wp-content/uploads/2013/10/golda-skinny.jpg\" width=\"234\" height=\"156\" />Once we assessed Golda\'s condition, we began to formulate a plan. First, we reached out to Dr. Kathy Mitchener at Angel Care, a veterinary clinic specializing in treating canine cancer to let her know about Golda\'s IMHA diagnosis. Dr. Mitchener had been performing weekly acupuncture sessions on Golda over the past couple of months in order to help her walk and move around better, with very good results. She also tested Golda\'s blood and confirmed Dr. Conley\'s diagnosis. Together, she and Dr. Conley, teamed up to administer a regimen of drugs to hopefully pull our beloved whippet out of the throws of IMHA.\r\n\r\nThe next step was research. I dedicated myself to find every stitch of information available online about IMHA. While there was a lot of information out there, it was a monumental task to compile. And as it turned out, no one had a strategy to combat the condition. That\'s when I decided to combine the information I found online and go with my gut -- of course, with input from our vets. To make matters worse, my husband had just sustained a ruptured achilles tendon, so in many ways, I was on my own in taking care of Golda. His inability to help carry her outside for potty brakes is what pushed me to design and develop the ___________. Without it, I never would have been able to handle the difficult task of taking Golda in and out of the house.\r\n\r\nMy online research lead me to _________ a supplement given to Chernobyl victims to help rebuild their damaged red blood cells. I also tracked down ________ a supplement that mimics mother\'s milk. Coconut water.\r\nExecuting the Plan\r\nOnce I had what I thought was the right supplements and nutrition for the battle ahead, I began to give put my plan into action. Golda\'s weight loss and lack of appetite was the number one priority. I had to make her eat and the only thing I could do was force feed her baby food.\r\n\r\nSherry to fill in everyday routine, feeding, etc.\r\n\r\n<img class=\"size-medium wp-image-415 alignleft\" alt=\"golda-acupunture\" src=\"http://healthydoghq.com/wp-content/uploads/2013/10/golda-acupunture-225x300.jpg\" width=\"225\" height=\"300\" />Throughout this process, we continued to visit Dr. Mitchener for Golda\'s weekly acupuncture sessions, this time targeting parts of the body to help her body\'s bone marrow generate new red blood cells. For the first two weeks, Golda was still weak and showing no signs of improvement. Dr. Mitchener took another packed cell volume test only to find that her red blood cell count had dropped even further. At this point, we wondered if we were doing the right thing by putting Golda through all of this heartache. But, Norman and I had seen something in Golda that led us to believe she was actually feeling better. Dr. Mitchener said that we should take Golda home and ask her what she wants to do…later that evening, we did just that and Golda gave us her answer: She was not ready to give up and neither were we! We continued on our regimen of drugs, supplements and nutritious food. Six weeks later, her PCV was 23! We were making progress, and are continuing to make progress to this day.\r\n\r\nI sincerely hope Healthy Dog Headquarters will help your dog as you go battle the effects of Canine IMHA. I\'ve worked diligently to provide the best information available, based on our own experience to help your dog fight and recover from this illness. Please look around our website and help make your dog a healthy dog!", "Golda\'s Story: Saving Our Dog from Immune Mediated Hemolytic Anemia", "", "inherit", "closed", "closed", "", "337-revision-v1", "", "", "2013-10-25 15:45:40", "2013-10-25 15:45:40", "", "337", "http://healthydoghq.com/337-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("336", "1", "2013-10-24 19:03:27", "0000-00-00 00:00:00", "", "Auto Draft", "", "auto-draft", "closed", "closed", "", "", "", "", "2013-10-24 19:03:27", "0000-00-00 00:00:00", "", "0", "http://healthydoghq.com/?p=336", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("337", "1", "2013-10-24 19:10:57", "2013-10-24 19:10:57", "<img class=\"alignright size-medium wp-image-409\" alt=\"golda-lure-coursing\" src=\"http://healthydoghq.com/wp-content/uploads/2013/10/golda-lure-coursing1-300x197.jpg\" width=\"300\" height=\"197\" />My husband, Norman and I, have had the privilege of owning whippets for twenty-five years. Over this space of time, we\'ve had a total of six of these sensitive, loving animals, each one with its own personality and way of doing things. Our first whippet, Devo, ruled the pack. Without a doubt, she was at the top of the pecking order at our house, after my husband. We lost her about ten years ago at the age of 15. Fortunately for us, all of our whippets have enjoyed long and healthy lives -- then we got Golda.\r\n\r\nGolda was originally owned by a good friend who owns and shows whippets. In 1992, our friend brought home a 12-week old red and white spitfire named \"Blue Skies Golden Pony\" and called her \"Golda\". The puppy was a gregarious fence jumper with a big heart and personality to match. Golda and Norman hit it off the first time they met. In many ways, Golda became his dog right from the start, and after retiring from the show ring, Golda came to live with us in 2004.\r\n\r\nFrom the first day we adopted her, life with Golda has been an absolute pleasure. She has always been active, friendly and loving, with no agenda, truly the best dog we\'ve ever known. Golda\'s great love in life was chasing the frisbee. Her speed and agility made her great at jumping to terrific heights and making spectacular catches in mid-air. In 2008, we noticed that she landed a bit funny after a routine jump, but she otherwise seemed fine. The next day, we awoke to find her paralyzed from the neck down. Frantically, we took her to several vets to find out that she had suffered from a Fibrocartilaginous Embolism (Canine FCE) -- a blockage in a blood vessel in the spinal cord. It’s often referred to as a spinal cord stroke. Our vet treated her with steroids and for the next six weeks, we became her legs, carrying her outside and holding her up as she went to the bathroom. Over time, she regained the use of her limbs and was eventually able to resume her favorite pastime of chasing the frisbee, albeit at a much reduced speed and intensity. She wasn\'t quite as coordinated as before, but we felt lucky that she was walking again. Little did we know it at the time, but the experience of dealing with Canine FCE would help prepare us for an equally devastating aliment: Canine Immune Mediated Hemolytic Anemia (IMHA) a few short years later.\r\n\r\n<img class=\"size-medium wp-image-408 alignleft\" alt=\"blood-transfusion\" src=\"http://healthydoghq.com/wp-content/uploads/2013/10/blood-transfusion-300x224.jpg\" width=\"288\" height=\"215\" />Even after her bout with Canine FCE, Golda\'s quality of life was very good, but in May of 2013, she had a set back. She once again was having trouble walking and maintaining her balance. We immediately assumed she had a reoccurrence of FCE. The symptoms were virtually the same, but this time, she began loosing weight and her gums were very pale in color. We took her to our vet, Dr. Bill Conley at Summer Animal Hospital, who examined her, ran a complete blood count (CBC) and a packed cell volume test (PCV). The results were staggering. The PCV test put her red blood cell count at 8%!!!  He said he had never seen a dog still alive with such a low blood count and that a normal dog\'s red blood cell volume is between 35 and 55%. Dr. Conley immediately recommended a blood transfusion. Needless to say, we were devastated at the news! How could we have missed all of the signs!? How could we have let Golda get into such a weakened state!? We agreed to the transfusion which \"stabilized\" her red blood cell volume to a still low 15%. As we were leaving his office, Dr. Conley prepared us for the worst by informing us that Golda was suffering from Immune Mediated Hemolytic Anemia (IMHA), formerly known as Canine Auto-Immune Hemolytic Anemia (AIHA), and that the recovery for this disease was \"very low\".  With a heavy heart, we thanked him and took Golda home for what we felt would surely be the last few days of her life.\r\n\r\nThe ride home from the vet\'s office seemed unusually long. On the way, we decided that we would do everything we could do, within reason, to give Golda the chance to recover. We owed that to her for all of the love and joy she had brought to us over the years. When we got home, we assessed our situation and began to formulate a plan to give her the opportunity to heal. Fortunately for us, and Golda, we had some great vets and quite a bit of luck on our side!\r\nGolda\'s Condition\r\n<ul>\r\n	<li>Weight: 19 pounds, normally 27</li>\r\n	<li>Red Blood Cell Volume: 8%, normal is between 35 and 55%</li>\r\n	<li>Appetite: None, normally she\'s a chow hound never turning down a meal</li>\r\n	<li>Ambulatory: Unable to walk or go to the bathroom on her own</li>\r\n	<li>Mental &amp; Emotional: Lethargic, extremely low energy level</li>\r\n	<li>Color: Pale gums - almost white, skin white, even freckles usually seen on legs &amp; tummy very faded and pale</li>\r\n	<li>Coat: Course, red coloring in coat pale</li>\r\n	<li>Nose: Dry and rough to the touch</li>\r\n	<li>Eyes: Third eye lid showing</li>\r\n</ul>\r\nFormulating a Plan\r\n<img class=\"alignright size-medium wp-image-419\" alt=\"golda-skinny\" src=\"http://healthydoghq.com/wp-content/uploads/2013/10/golda-skinny-300x200.jpg\" width=\"300\" height=\"200\" />Once we assessed Golda\'s condition, we began to formulate a plan. First, we reached out to Dr. Kathy Mitchener at Angel Care, a veterinary clinic specializing in treating canine cancer to let her know about Golda\'s IMHA diagnosis. Dr. Mitchener had been performing weekly acupuncture sessions on Golda over the past couple of months in order to help her walk and move around better, with very good results. She also tested Golda\'s blood and confirmed Dr. Conley\'s diagnosis. Together, she and Dr. Conley, teamed up to administer a regimen of drugs to hopefully pull our beloved whippet out of the throws of IMHA.\r\n\r\nThe next step was research. I dedicated myself to find every stitch of information available online about IMHA. While there was a lot of information out there, it was a monumental task to compile. And as it turned out, no one had a strategy to combat the condition. That\'s when I decided to combine the information I found online and go with my gut -- of course, with input from our vets. To make matters worse, my husband had just sustained a ruptured achilles tendon, so in many ways, I was on my own in taking care of Golda. His inability to help carry her outside for potty brakes is what pushed me to design and develop the ___________. Without it, I never would have been able to handle the difficult task of taking Golda in and out of the house.\r\n\r\nMy online research lead me to _________ a supplement given to Chernobyl victims to help rebuild their damaged red blood cells. I also tracked down ________ a supplement that mimics mother\'s milk. Coconut water.\r\nExecuting the Plan\r\nOnce I had what I thought was the right supplements and nutrition for the battle ahead, I began to give put my plan into action. Golda\'s weight loss and lack of appetite was the number one priority. I had to make her eat and the only thing I could do was force feed her baby food.\r\n\r\nSherry to fill in everyday routine, feeding, etc.\r\n\r\n<img class=\"size-medium wp-image-415 alignleft\" alt=\"golda-acupunture\" src=\"http://healthydoghq.com/wp-content/uploads/2013/10/golda-acupunture-225x300.jpg\" width=\"225\" height=\"300\" />Throughout this process, we continued to visit Dr. Mitchener for Golda\'s weekly acupuncture sessions, this time targeting parts of the body to help her body\'s bone marrow generate new red blood cells. For the first two weeks, Golda was still weak and showing no signs of improvement. Dr. Mitchener took another packed cell volume test only to find that her red blood cell count had dropped even further. At this point, we wondered if we were doing the right thing by putting Golda through all of this heartache. But, Norman and I had seen something in Golda that led us to believe she was actually feeling better. Dr. Mitchener said that we should take Golda home and ask her what she wants to do…later that evening, we did just that and Golda gave us her answer: She was not ready to give up and neither were we! We continued on our regimen of drugs, supplements and nutritious food. Six weeks later, her PCV was 23! We were making progress, and are continuing to make progress to this day.\r\n\r\nI sincerely hope Healthy Dog Headquarters will help your dog as you go battle the effects of Canine IMHA. I\'ve worked diligently to provide the best information available, based on our own experience to help your dog fight and recover from this illness. Please look around our website and help make your dog a healthy dog!", "Golda\'s Story: Saving Our Dog from Immune Mediated Hemolytic Anemia", "", "publish", "closed", "closed", "", "saving-dog-from-immune-mediated-hemolytic-anemia", "", "", "2013-10-25 15:46:40", "2013-10-25 15:46:40", "", "0", "http://healthydoghq.com/?p=337", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("338", "1", "2013-10-24 19:10:57", "2013-10-24 19:10:57", "My husband, Norman and I, have had the privilege of owning whippets for twenty-five years. Over this space of time, we\'ve had a total of six of these sensitive, loving animals, each one with its own personality and way of doing things. Our first whippet, Devo, ruled the pack. Without a doubt, she was at the top of the pecking order at our house, after my husband. We lost her about ten years ago at the age of 15. Fortunately for us, all of our whippets have enjoyed long and healthy lives -- then we got Golda.\r\n\r\nGolda was originally owned by a good friend who owns and shows whippets. In 1992, our friend brought home a 12-week old red and white spitfire named \"Blue Skies Golden Pony\" and called her \"Golda\". The puppy was a gregarious fence jumper with a big heart and personality to match. Golda and Norman hit it off the first time they met. In many ways, Golda became his dog right from the start, and after retiring from the show ring, Golda came to live with us in 2004.\r\n\r\nFrom the first day we adopted her, life with Golda has been an absolute pleasure. She has always been active, friendly and loving, with no agenda, truly the best dog we\'ve ever known. Golda\'s great love in life was chasing the frisbee. Her speed and agility made her great at jumping to terrific heights and making spectacular catches in mid-air. In 2008, we noticed that she landed a bit funny after a routine jump, but she otherwise seemed fine. The next day, we awoke to find her paralyzed from the neck down. Frantically, we took her to several vets to find out that she had suffered from a Fibrocartilaginous Embolism (Canine FCE) -- a blockage in a blood vessel in the spinal cord. It’s often referred to as a spinal cord stroke. Our vet treated her with steroids and for the next six weeks, we became her legs, carrying her outside and holding her up as she went to the bathroom. Over time, she regained the use of her limbs and was eventually able to resume her favorite pastime of chasing the frisbee, albeit at a much reduced speed and intensity. She wasn\'t quite as coordinated as before, but we felt lucky that she was walking again. Little did we know it at the time, but the experience of dealing with Canine FCE would help prepare us for an equally devastating aliment: Canine Immune Mediated Hemolytic Anemia (IMHA) a few short years later.\r\n\r\nEven after her bout with Canine FCE, Golda\'s quality of life was very good, but in May of 2013, she had a set back. She once again was having trouble walking and maintaining her balance. We immediately assumed she had a reoccurrence of FCE. The symptoms were virtually the same, but this time, she began loosing weight and her gums were very pale in color. We took her to our vet, Dr. Bill Conley at Summer Animal Hospital, who examined her, ran a complete blood count (CBC) and a packed cell volume test (PCV). The results were staggering. The PCV test put her red blood cell count at 8%!!!  He said he had never seen a dog still alive with such a low blood count and that a normal dog\'s red blood cell volume is between 35 and 55%. Dr. Conley immediately recommended a blood transfusion. Needless to say, we were devastated at the news! How could we have missed all of the signs!? How could we have let Golda get into such a weakened state!? We agreed to the transfusion which \"stabilized\" her red blood cell volume to a still low 15%. As we were leaving his office, Dr. Conley prepared us for the worst by informing us that Golda was suffering from Immune Mediated Hemolytic Anemia (IMHA), formerly known as Canine Auto-Immune Hemolytic Anemia (AIHA), and that the recovery for this disease was \"very low\".  With a heavy heart, we thanked him and took Golda home for what we felt would surely be the last few days of her life.\r\n\r\nThe ride home from the vet\'s office seemed unusually long. On the way, we decided that we would do everything we could do, within reason, to give Golda the chance to recover. We owed that to her for all of the love and joy she had brought to us over the years. When we got home, we assessed our situation and began to formulate a plan to give her the opportunity to heal. Fortunately for us, and Golda, we had some great vets and quite a bit of luck on our side!\r\nGolda\'s Condition\r\n<ul>\r\n	<li>Weight: 19 pounds, normally 27</li>\r\n	<li>Red Blood Cell Volume: 8%, normal is between 35 and 55%</li>\r\n	<li>Appetite: None, normally she\'s a chow hound never turning down a meal</li>\r\n	<li>Ambulatory: Unable to walk or go to the bathroom on her own</li>\r\n	<li>Mental &amp; Emotional: Lethargic, extremely low energy level</li>\r\n	<li>Color: Pale gums - almost white, skin white, even freckles usually seen on legs &amp; tummy very faded and pale</li>\r\n	<li>Coat: Course, red coloring in coat pale</li>\r\n	<li>Nose: Dry and rough to the touch</li>\r\n	<li>Eyes: Third eye lid showing</li>\r\n</ul>\r\nFormulating a Plan\r\nOnce we assessed Golda\'s condition, we began to formulate a plan. First, we reached out to Dr. Kathy Mitchener at Angel Care, a veterinary clinic specializing in treating canine cancer to let her know about Golda\'s IMHA diagnosis. Dr. Mitchener had been performing weekly acupuncture sessions on Golda over the past couple of months in order to help her walk and move around better, with very good results. She also tested Golda\'s blood and confirmed Dr. Conley\'s diagnosis. Together, she and Dr. Conley, teamed up to administer a regimen of drugs to hopefully pull our beloved whippet out of the throws of IMHA.\r\n\r\nThe next step was research. I dedicated myself to find every stitch of information available online about IMHA. While there was a lot of information out there, it was a monumental task to compile. And as it turned out, no one had a strategy to combat the condition. That\'s when I decided to combine the information I found online and go with my gut -- of course, with input from our vets. To make matters worse, my husband had just sustained a ruptured achilles tendon, so in many ways, I was on my own in taking care of Golda. His inability to help carry her outside for potty brakes is what pushed me to design and develop the ___________. Without it, I never would have been able to handle the difficult task of taking Golda in and out of the house.\r\n\r\nMy online research lead me to _________ a supplement given to Chernobyl victims to help rebuild their damaged red blood cells. I also tracked down ________ a supplement that mimics mother\'s milk. Coconut water.\r\nExecuting the Plan\r\nOnce I had what I thought was the right supplements and nutrition for the battle ahead, I began to give put my plan into action. Golda\'s weight loss and lack of appetite was the number one priority. I had to make her eat and the only thing I could do was force feed her baby food.\r\n\r\nSherry to fill in everyday routine, feeding, etc.\r\n\r\nThroughout this process, we continued to visit Dr. Mitchener for Golda\'s weekly acupuncture sessions, this time targeting parts of the body to help her body\'s bone marrow generate new red blood cells. For the first two weeks, Golda was still weak and showing no signs of improvement. Dr. Mitchener took another packed cell volume test only to find that her red blood cell count had dropped even further. At this point, we wondered if we were doing the right thing by putting Golda through all of this heartache. But, Norman and I had seen something in Golda that led us to believe she was actually feeling better. Dr. Mitchener said that we should take Golda home and ask her what she wants to do…later that evening, we did just that and Golda gave us her answer: She was not ready to give up and neither were we! We continued on our regimen of drugs, supplements and nutritious food. Six weeks later, her PCV was 23! We were making progress, and are continuing to make progress to this day.\r\n\r\nI sincerely hope Healthy Dog Headquarters will help your dog as you go battle the effects of Canine IMHA. I\'ve worked diligently to provide the best information available, based on our own experience to help your dog fight and recover from this illness. Please look around our website and help make your dog a healthy dog!", "Golda\'s Story: How we saved our dog from Immune Mediated Hemolytic Anemia (IMHA)", "", "inherit", "closed", "closed", "", "337-revision-v1", "", "", "2013-10-24 19:10:57", "2013-10-24 19:10:57", "", "337", "http://healthydoghq.com/337-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("339", "1", "2013-10-24 19:13:53", "2013-10-24 19:13:53", "Below is a list of 6 post/page layouts that come with the Genesis theme framework:\n\n<ul>\n	<li><a href=\"http://demo.studiopress.com/genesis/layouts/cs\">Content/Sidebar</a></li>\n	<li><a href=\"http://demo.studiopress.com/genesis/layouts/sc\">Sidebar/Content</a></li>\n	<li><a href=\"http://demo.studiopress.com/genesis/layouts/css\">Content/Sidebar/Sidebar</a></li>\n	<li><a href=\"http://demo.studiopress.com/genesis/layouts/ssc\">Sidebar/Sidebar/Content</a></li>\n	<li><a href=\"http://demo.studiopress.com/genesis/layouts/scs\">Sidebar/Content/Sidebar</a></li>\n	<li><a href=\"http://demo.studiopress.com/genesis/layouts/fwc\">Full Width Content</a></li>\n</ul>", "Page Layouts", "", "inherit", "closed", "closed", "", "78-revision-v1", "", "", "2013-10-24 19:13:53", "2013-10-24 19:13:53", "", "78", "http://healthydoghq.com/78-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("340", "1", "2013-10-24 19:13:53", "2013-10-24 19:13:53", "This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.", "Sidebar/Content/Sidebar", "", "inherit", "closed", "closed", "", "96-revision-v1", "", "", "2013-10-24 19:13:53", "2013-10-24 19:13:53", "", "96", "http://healthydoghq.com/96-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("341", "1", "2013-10-24 19:13:53", "2013-10-24 19:13:53", "This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.", "Sidebar/Sidebar/Content", "", "inherit", "closed", "closed", "", "95-revision-v1", "", "", "2013-10-24 19:13:53", "2013-10-24 19:13:53", "", "95", "http://healthydoghq.com/95-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("342", "1", "2013-10-24 19:13:53", "2013-10-24 19:13:53", "This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.", "Page Templates", "", "inherit", "closed", "closed", "", "98-revision-v1", "", "", "2013-10-24 19:13:53", "2013-10-24 19:13:53", "", "98", "http://healthydoghq.com/98-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("343", "1", "2013-10-24 19:13:53", "2013-10-24 19:13:53", "This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages as you like and manage all of your content inside of WordPress.", "Sample Page", "", "inherit", "closed", "closed", "", "67-revision-v1", "", "", "2013-10-24 19:13:53", "2013-10-24 19:13:53", "", "67", "http://healthydoghq.com/67-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("344", "1", "2013-10-24 19:13:53", "2013-10-24 19:13:53", "This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.", "Sub Page 1.1", "", "inherit", "closed", "closed", "", "69-revision-v1", "", "", "2013-10-24 19:13:53", "2013-10-24 19:13:53", "", "69", "http://healthydoghq.com/69-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("345", "1", "2013-10-24 19:13:53", "2013-10-24 19:13:53", "This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.", "Sub Page 2.1", "", "inherit", "closed", "closed", "", "72-revision-v1", "", "", "2013-10-24 19:13:53", "2013-10-24 19:13:53", "", "72", "http://healthydoghq.com/72-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("346", "1", "2013-10-24 19:13:53", "2013-10-24 19:13:53", "This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.", "Sub Page 3.1", "", "inherit", "closed", "closed", "", "75-revision-v1", "", "", "2013-10-24 19:13:53", "2013-10-24 19:13:53", "", "75", "http://healthydoghq.com/75-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("347", "1", "2013-10-24 19:13:53", "2013-10-24 19:13:53", "This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.", "Sub Page 3.2", "", "inherit", "closed", "closed", "", "76-revision-v1", "", "", "2013-10-24 19:13:53", "2013-10-24 19:13:53", "", "76", "http://healthydoghq.com/76-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("348", "1", "2013-10-24 19:13:53", "2013-10-24 19:13:53", "This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.", "Sub Page 3.3", "", "inherit", "closed", "closed", "", "77-revision-v1", "", "", "2013-10-24 19:13:53", "2013-10-24 19:13:53", "", "77", "http://healthydoghq.com/77-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("349", "1", "2013-10-24 19:13:53", "2013-10-24 19:13:53", "This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.", "Sub Page 2.2", "", "inherit", "closed", "closed", "", "73-revision-v1", "", "", "2013-10-24 19:13:53", "2013-10-24 19:13:53", "", "73", "http://healthydoghq.com/73-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("350", "1", "2013-10-24 19:13:53", "2013-10-24 19:13:53", "This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.", "Sub Page 2.3", "", "inherit", "closed", "closed", "", "74-revision-v1", "", "", "2013-10-24 19:13:53", "2013-10-24 19:13:53", "", "74", "http://healthydoghq.com/74-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("351", "1", "2013-10-24 19:13:53", "2013-10-24 19:13:53", "This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.", "Sub Page 1.2", "", "inherit", "closed", "closed", "", "70-revision-v1", "", "", "2013-10-24 19:13:53", "2013-10-24 19:13:53", "", "70", "http://healthydoghq.com/70-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("352", "1", "2013-10-24 19:13:53", "2013-10-24 19:13:53", "This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.", "Sub Page 1.3", "", "inherit", "closed", "closed", "", "71-revision-v1", "", "", "2013-10-24 19:13:53", "2013-10-24 19:13:53", "", "71", "http://healthydoghq.com/71-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("353", "1", "2013-10-24 19:14:08", "2013-10-24 19:14:08", "This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.", "Full Width Content", "", "inherit", "closed", "closed", "", "97-revision-v1", "", "", "2013-10-24 19:14:08", "2013-10-24 19:14:08", "", "97", "http://healthydoghq.com/97-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("354", "1", "2013-10-24 19:14:08", "2013-10-24 19:14:08", "This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.", "Sidebar/Content", "", "inherit", "closed", "closed", "", "93-revision-v1", "", "", "2013-10-24 19:14:08", "2013-10-24 19:14:08", "", "93", "http://healthydoghq.com/93-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("355", "1", "2013-10-24 19:14:50", "2013-10-24 19:14:50", "Below are examples of column classes that are available in the Genesis Framework style sheet.\n\n<h3>Two-Columns</h3>\n\n<div class=\"one-half first\">\n<p>This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what exactly is on your mind.</p>\n</div>\n\n<div class=\"one-half\">\n<p>This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what exactly is on your mind.</p>\n</div>\n\n<div class=\"clear-line\"></div>\n\n<h3>Three-Columns</h3>\n\n<div class=\"one-third first\">\n<p>This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind.</p>\n</div>\n\n<div class=\"one-third\">\n<p>This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind.</p>\n</div>\n\n<div class=\"one-third\">\n<p>This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind.</p>\n</div>\n\n<div class=\"clear-line\"></div>\n\n<h3>Four-Columns</h3>\n\n<div class=\"one-fourth first\">\n<p>This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what exactly is on your mind.</p>\n</div>\n\n<div class=\"one-fourth\">\n<p>This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what exactly is on your mind.</p>\n</div>\n\n<div class=\"one-fourth\">\n<p>This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what exactly is on your mind.</p>\n</div>\n\n<div class=\"one-fourth\">\n<p>This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what exactly is on your mind.</p>\n</div>\n\n<div class=\"clear-line\"></div>\n\n<h3>Five-Columns</h3>\n\n<div class=\"one-fifth first\">\n<p>This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what exactly is on your mind.</p>\n</div>\n\n<div class=\"one-fifth\">\n<p>This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what exactly is on your mind.</p>\n</div>\n\n<div class=\"one-fifth\">\n<p>This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what exactly is on your mind.</p>\n</div>\n\n<div class=\"one-fifth\">\n<p>This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what exactly is on your mind.</p>\n</div>\n\n<div class=\"one-fifth\">\n<p>This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what exactly is on your mind.</p>\n</div>\n\n<div class=\"clear-line\"></div>\n\n<h3>Six-Columns</h3>\n\n<div class=\"one-sixth first\">\n<p>This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind.</p>\n</div>\n\n<div class=\"one-sixth\">\n<p>This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind.</p>\n</div>\n\n<div class=\"one-sixth\">\n<p>This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind.</p>\n</div>\n\n<div class=\"one-sixth\">\n<p>This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind.</p>\n</div>\n\n<div class=\"one-sixth\">\n<p>This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind.</p>\n</div>\n\n<div class=\"one-sixth\">\n<p>This is an example of a WordPress post, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many posts as you like in order to share with your readers what is on your mind.</p>\n</div>", "Column Classes", "", "inherit", "closed", "closed", "", "181-revision-v1", "", "", "2013-10-24 19:14:50", "2013-10-24 19:14:50", "", "181", "http://healthydoghq.com/181-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("356", "1", "2013-10-24 19:14:50", "2013-10-24 19:14:50", "<div style=\"float:left;margin-right:4.166666666%;width:65.277777777%;\">\n    <p style=\"background-color: #1e1e1e;color: #fff;padding: 24px 0;text-align: center;\">Content (752px)</p>\n</div>\n<div style=\"float:left;width:30.555555555%;\">\n    <p style=\"background-color: #1e1e1e;color: #fff;padding: 24px 0;text-align: center;\">Sidebar (352px)</p>\n</div>\n\n<div class=\"clear\"></div>\n\n<div style=\"float:left;margin-right:4.166666666%;width:30.555555555%;\">\n    <p style=\"background-color: #1e1e1e;color: #fff;padding: 24px 0;text-align: center;\">Sidebar (352px)</p>\n</div>\n<div style=\"float:left;width:65.277777777%;\">\n    <p style=\"background-color: #1e1e1e;color: #fff;padding: 24px 0;text-align: center;\">Content (752px)</p>\n</div>\n\n<div class=\"clear\"></div>\n\n<div style=\"float:left;margin-right:4.166666666%;width:45.833333333%;\">\n    <p style=\"background-color: #1e1e1e;color: #fff;padding: 24px 0;text-align: center;\">Content (528px)</p>\n</div>\n<div style=\"float:left;margin-right:4.166666666%;width:30.555555555%;\">\n    <p style=\"background-color: #1e1e1e;color: #fff;padding: 24px 0;text-align: center;\">Sidebar (352px)</p>\n</div>\n<div style=\"float:left;width:15.277777777%;\">\n    <p style=\"background-color: #1e1e1e;color: #fff;padding: 24px 0;text-align: center;\">Sidebar-Alt (176px)</p>\n</div>\n\n<div class=\"clear\"></div>\n\n<div style=\"float:left;margin-right:4.166666666%;width:15.277777777%;\">\n    <p style=\"background-color: #1e1e1e;color: #fff;padding: 24px 0;text-align: center;\">Sidebar-Alt (176px)</p>\n</div>\n<div style=\"float:left;margin-right:4.166666666%;width:30.555555555%;\">\n    <p style=\"background-color: #1e1e1e;color: #fff;padding: 24px 0;text-align: center;\">Sidebar (352px)</p>\n</div>\n<div style=\"float:left;width:45.833333333%;\">\n    <p style=\"background-color: #1e1e1e;color: #fff;padding: 24px 0;text-align: center;\">Content (528px)</p>\n</div>\n\n<div style=\"float:left;margin-right:4.166666666%;width:15.277777777%;\">\n    <p style=\"background-color: #1e1e1e;color: #fff;padding: 24px 0;text-align: center;\">Sidebar-Alt (176px)</p>\n</div>\n<div style=\"float:left;margin-right:4.166666666%;width:45.833333333%;\">\n    <p style=\"background-color: #1e1e1e;color: #fff;padding: 24px 0;text-align: center;\">Content (528px)</p>\n</div>\n<div style=\"float:left;width:30.555555555%;\">\n    <p style=\"background-color: #1e1e1e;color: #fff;padding: 24px 0;text-align: center;\">Sidebar (352px)</p>\n</div>\n\n<div class=\"clear\"></div>\n\n<div style=\"float:left;width:100%;\">\n    <p style=\"background-color: #1e1e1e;color: #fff;padding: 24px 0;text-align: center;\">Content (1152px)</p>\n</div>\n\n<div class=\"clear\"></div>\n\n<div style=\"float:left;margin-right:4.166666666%;width:30.555555555%;\">\n    <p style=\"background-color: #1e1e1e;color: #fff;padding: 24px 0;text-align: center;\">Footer Widget (352px)</p>\n</div>\n<div style=\"float:left;margin-right:4.166666666%;width:30.555555555%;\">\n    <p style=\"background-color: #1e1e1e;color: #fff;padding: 24px 0;text-align: center;\">Footer Widget (352px)</p>\n</div>\n<div style=\"float:left;width:30.555555555%;\">\n    <p style=\"background-color: #1e1e1e;color: #fff;padding: 24px 0;text-align: center;\">Footer Widget (352px)</p>\n</div>", "", "", "inherit", "closed", "closed", "", "210-revision-v1", "", "", "2013-10-24 19:14:50", "2013-10-24 19:14:50", "", "210", "http://healthydoghq.com/210-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("357", "1", "2013-10-24 19:14:50", "2013-10-24 19:14:50", "This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.", "Content/Sidebar", "", "inherit", "closed", "closed", "", "92-revision-v1", "", "", "2013-10-24 19:14:50", "2013-10-24 19:14:50", "", "92", "http://healthydoghq.com/92-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("358", "1", "2013-10-24 19:14:50", "2013-10-24 19:14:50", "This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress. This is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.\n\nThis is an example of a WordPress page, you could edit this to put information about yourself or your site so readers know where you are coming from. You can create as many pages like this one or sub-pages as you like and manage all of your content inside of WordPress.", "Content/Sidebar/Sidebar", "", "inherit", "closed", "closed", "", "94-revision-v1", "", "", "2013-10-24 19:14:50", "2013-10-24 19:14:50", "", "94", "http://healthydoghq.com/94-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("359", "1", "2013-10-24 19:15:40", "2013-10-24 19:15:40", "", "Blog Page", "", "inherit", "closed", "closed", "", "101-revision-v1", "", "", "2013-10-24 19:15:40", "2013-10-24 19:15:40", "", "101", "http://healthydoghq.com/101-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("402", "1", "2013-10-25 13:41:49", "2013-10-25 13:41:49", "<a href=\"http://healthydoghq.com/wp-content/uploads/2013/10/welcome.jpg\"><img class=\"alignright\" alt=\"welcome\" src=\"http://healthydoghq.com/wp-content/uploads/2013/10/welcome.jpg\" width=\"350\" height=\"244\" /></a>Hi, I\'m really excited to introduce Healthy Dog Headquarters!\r\n\r\nHDHQ is the culmination of a year-long battle to help our beloved whippet, Golda, overcome the deadly illness of Immune Mediated Hemolytic Anemia (IMHA), formerly called Canine Auto-Immune Hemolytic Anemia (AIHA) and the closely related disorder Immune-Mediated Hemolytic Anemia (IMHA).\r\n\r\nMy husband, Norman and I have had the privilege of owning whippets for twenty five years. Over this space of time, we\'ve had a total of six of these sensitive, loving animals, each one with their own personality and way of doing things. We adopted Golda in 2004 and have enjoyed her companionship ever since. And as anyone who is a dog owner understands, we\'ve had our share of illnesses and accidents over the years, including Golda\'s bout with Fibrocartilaginous Embolism (Canine FCE) in 2008 -- the equivalent of a stroke in humans. Little did we know at the time, but her battle with FCE helped prepare us for combatting and winning against the illness of canine AIHA/IMHA.\r\n\r\nHDHQ is my quest for knowledge and documenting our experience of how we assessed, then attacked the disease. I share these strategies, as well as the products we used and developed for nutrition and mobility. (make links)\r\n\r\nOur goal is to bring you the best products and resources for Health Issues, Holistic, Nutrition, Training / Behavior, Fun &amp; Play\r\n\r\nIf your dog is suffering from any illness, I hope Healthy Dog Headquarters will help make your dog healthy again.\r\n\r\nTruly,\r\n\r\nSherry Henson", "Welcome to Healthy Dog Headquarters", "", "inherit", "closed", "closed", "", "399-revision-v1", "", "", "2013-10-25 13:41:49", "2013-10-25 13:41:49", "", "399", "http://healthydoghq.com/399-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("401", "1", "2013-10-25 13:41:33", "2013-10-25 13:41:33", "<a href=\"http://healthydoghq.com/wp-content/uploads/2013/10/welcome.jpg\"><img class=\"alignright\" alt=\"welcome\" src=\"http://healthydoghq.com/wp-content/uploads/2013/10/welcome.jpg\" width=\"350\" height=\"244\" /></a>Hi, I\'m really excited to introduce my new blog Healthy Dog Headquarters!\r\n\r\nHDHQ is the culmination of a year-long battle to help our beloved whippet, Golda, overcome the deadly illness of Immune Mediated Hemolytic Anemia (IMHA), formerly called Canine Auto-Immune Hemolytic Anemia (AIHA) and the closely related disorder Immune-Mediated Hemolytic Anemia (IMHA).\r\n\r\nMy husband, Norman and I have had the privilege of owning whippets for twenty five years. Over this space of time, we\'ve had a total of six of these sensitive, loving animals, each one with their own personality and way of doing things. We adopted Golda in 2004 and have enjoyed her companionship ever since. And as anyone who is a dog owner understands, we\'ve had our share of illnesses and accidents over the years, including Golda\'s bout with Fibrocartilaginous Embolism (Canine FCE) in 2008 -- the equivalent of a stroke in humans. Little did we know at the time, but her battle with FCE helped prepare us for combatting and winning against the illness of canine AIHA/IMHA.\r\n\r\nHDHQ is my quest for knowledge and documenting our experience of how we assessed, then attacked the disease. I share these strategies, as well as the products we used and developed for nutrition and mobility. (make links)\r\n\r\nOur goal is to bring you the best products and resources for Health Issues, Holistic, Nutrition, Training / Behavior, Fun &amp; Play\r\n\r\nIf your dog is suffering from any illness, I hope Healthy Dog Headquarters will help make your dog healthy again.\r\n\r\nTruly,\r\n\r\nSherry Henson", "Welcome to Healthy Dog Headquarters", "", "inherit", "closed", "closed", "", "399-revision-v1", "", "", "2013-10-25 13:41:33", "2013-10-25 13:41:33", "", "399", "http://healthydoghq.com/399-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("363", "1", "2013-10-24 20:08:23", "2013-10-24 20:08:23", "<a href=\"http://healthydoghq.com/wp-content/uploads/2013/10/what-is-imha.jpg\"><img class=\"alignright size-full wp-image-417\" alt=\"What is Canine Immune Mediated Hemolytic Anemia\" src=\"http://healthydoghq.com/wp-content/uploads/2013/10/what-is-imha.jpg\" width=\"300\" height=\"200\" /></a>In a nutshell, Canine Immune-Mediated Hemolytic Anemia (formerly called Canine Auto-Immune Hemolytic Anemia (AIHA)) occurs when your dog\'s red blood cells fall below the range that\'s considered normal, or the red blood cells aren\'t functioning properly.\r\nThere are two forms of IMHA - Primary IMHA, and Secondary IMHA\r\nWith Primary IMHA, your dog\'s immune system attacks its own red blood cells without any reason. This is the most common cause of anemia in dogs.\r\n\r\nSecondary IMHA is caused by an underlying cause - cancer, drug, or toxin causes your dogs red blood cells to become modified by an underlying disease process, drug, or toxin\r\n\r\nthrough a disease process, causing the body\'s immune system to destroy them. From the research I have done, there is no absolute known cause, although its theorized the condition can be caused by any number of factors, including: cancer, infection, exposure to chemicals, infection, blood parasites or even snake bites, to name a few.\r\n\r\nIn the case of our dog, Golda, her immune system was killing her red blood cells deep in the bone marrow. The vets deduced that the fall of her red blood cell count occurred gradually over an extended period of time. In fact, the symptoms came on so gradually, that we didn\'t notice she had a problem until it was almost too late. If her blood cell volume had fallen quickly over a short amount of time, the condition would surely have been fatal since her system would not have been able compensate. We were lucky her\'s dropped slowly over time.\r\n\r\nThis gradual drop in her packed cell level would certainly account for our not catching the condition until late into the condition.\r\n\r\nKnowing the symptoms and what to look for are key to a successful outcome in fighting MHA. If you think your dog may be suffering from any type of immunity disorder, please consult your vet. He/she will be able to assess your dog\'s condition  and answer any specific questions you may have.\r\n\r\nWe\'ll explore these symptoms of Canine Immune Mediated Hemolytic Anemia (IMHA) in the next post.", "What is Canine Immune Mediated Hemolytic Anemia (IMHA)?", "", "publish", "closed", "closed", "", "canine-immune-mediated-hemolytic-anemia-imha", "", "", "2013-10-25 15:43:00", "2013-10-25 15:43:00", "", "0", "http://healthydoghq.com/?p=363", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("364", "1", "2013-10-24 20:08:23", "2013-10-24 20:08:23", "In a nutshell, Canine Immune-Mediated Hemolytic Anemia (formerly called Canine Auto-Immune Hemolytic Anemia (AIHA)) occurs when your dog\'s red blood cells fall below the range that\'s considered normal, or the red blood cells aren\'t functioning properly.\r\nThere are two forms of IMHA - Primary IMHA, and Secondary IMHA\r\nWith Primary IMHA, your dog\'s immune system attacks its own red blood cells without any reason. This is the most common cause of anemia in dogs.\r\n\r\nSecondary IMHA is caused by an underlying cause - cancer, drug, or toxin causes your dogs red blood cells to become modified by an underlying disease process, drug, or toxin\r\n\r\nthrough a disease process, causing the body\'s immune system to destroy them. From the research I have done, there is no absolute known cause, although its theorized the condition can be caused by any number of factors, including: cancer, infection, exposure to chemicals, infection, blood parasites or even snake bites, to name a few.\r\n\r\nIn the case of our dog, Golda, her immune system was killing her red blood cells deep in the bone marrow. The vets deduced that the fall of her red blood cell count occurred gradually over an extended period of time. In fact, the symptoms came on so gradually, that we didn\'t notice she had a problem until it was almost too late. If her blood cell volume had fallen quickly over a short amount of time, the condition would surely have been fatal since her system would not have been able compensate. We were lucky her\'s dropped slowly over time.\r\n\r\nThis gradual drop in her packed cell level would certainly account for our not catching the condition until late into the condition.\r\n\r\nKnowing the symptoms and what to look for are key to a successful outcome in fighting MHA. If you think your dog may be suffering from any type of immunity disorder, please consult your vet. He/she will be able to assess your dog\'s condition  and answer any specific questions you may have.\r\n\r\nWe\'ll explore these symptoms of Canine Immune Mediated Hemolytic Anemia (IMHA) in the next post.", "What is Canine Immune Mediated Hemolytic Anemia (IMHA)?", "", "inherit", "closed", "closed", "", "363-revision-v1", "", "", "2013-10-24 20:08:23", "2013-10-24 20:08:23", "", "363", "http://healthydoghq.com/363-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("365", "1", "2013-10-24 20:09:25", "2013-10-24 20:09:25", "[caption id=\"attachment_427\" align=\"alignright\" width=\"300\"]<img class=\"size-full wp-image-427\" alt=\"Canine Immune Mediated Hemolytic Anemia Symptoms\" src=\"http://healthydoghq.com/wp-content/uploads/2013/10/Golda-pale-gums.jpg\" width=\"300\" height=\"200\" /> Canine Immune Mediated Hemolytic Anemia Symptoms[/caption]\r\n\r\nIn the case of our dog, Golda, the symptoms of Immune Mediated Hemolytic Anemia (IMHA) somewhat mimicked those of a Fibrocartilaginous Embolism (Canine FCE), resulting from an injury she suffered while playing frisbee several years ago. Read Golda\'s Story to learn more.\r\n\r\nGolda\'s symptoms started with the inability to maintain her balance, accompanied by an inability to walk or move her legs. It was only when she began to loose weight and became extremely lethargic did I suspect something else may be causing her problems. Then we noticed her pale gums and I got really scared and rush her to the vet.\r\n<h2>Here are the symptoms to look for with IMHA:</h2>\r\n<ul>\r\n	<li>Inability to balance</li>\r\n	<li>Inability to walk</li>\r\n	<li>Inability to move legs</li>\r\n	<li>Pale gums</li>\r\n	<li>Tired, weak &amp; listless</li>\r\n	<li>Shallow rapid breathing</li>\r\n	<li>Rapid heartbeat</li>\r\n	<li>Lack of appetite, accompanied by weight loss</li>\r\n	<li>Third eyelid</li>\r\n</ul>\r\nIn retrospect, these symptoms should have been easy to detect. In fact, Golda\'s symptoms seemed to come on gradually and we didn\'t notice she had a problem until it was almost too late. If her blood cell volume had fallen quickly over a short amount of time, the condition would surely have been fatal since her system would not have been able compensate. If your dog is having any of these symptoms, please see your vet!\r\n\r\nIn my next post, I\'ll discuss testing for Immune Mediated Hemolytic Anemia.", "Canine Immune Mediated Hemolytic Anemia (IMHA) Symptoms", "", "publish", "closed", "closed", "", "canine-imha-symptoms", "", "", "2013-10-25 16:05:10", "2013-10-25 16:05:10", "", "0", "http://healthydoghq.com/?p=365", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("366", "1", "2013-10-24 20:09:25", "2013-10-24 20:09:25", "In the case of our dog, Golda, the symptoms of AIHA/IMHA mimicked those of a Fibrocartilaginous Embolism (Canine FCE), resulting from an injury she suffered while playing frisbee several years ago. Read Golda\'s Story to learn more.\r\n\r\nGolda\'s symptoms started with the inability to maintain her balance, accompanied by an inability to walk or move her legs. I thought she had suffered a relapse of FCE and did not suspect anemia. It was only when she began to loose weight and became extremely lethargic did I suspect something else may be causing her problems.\r\n\r\nHere are the symptoms we experienced with AIHA/IMHA:\r\n\r\nInability to balance\r\nInability to walk\r\nInability to move legs\r\nPale gums\r\nTired, weak &amp; listless\r\nShallow rapid breathing\r\nRapid heartbeat\r\nLack of appetite, accompanied by weight loss\r\nThird eyelid\r\n\r\nIn retrospect, these symptoms should have been easy to detect. But we were focused on her having had the FCE injury mis-directed us until we took her to the vet. If your dog is having any of these symptoms, please see your vet!\r\n\r\nIn my next post, I\'ll discuss testing for AIHA/IMHA.", "Canine AIHA/IMHA: Symptoms", "", "inherit", "closed", "closed", "", "365-revision-v1", "", "", "2013-10-24 20:09:25", "2013-10-24 20:09:25", "", "365", "http://healthydoghq.com/365-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("399", "1", "2013-10-25 13:38:18", "2013-10-25 13:38:18", "<a href=\"http://healthydoghq.com/wp-content/uploads/2013/10/welcome.jpg\"><img class=\"alignright\" alt=\"welcome\" src=\"http://healthydoghq.com/wp-content/uploads/2013/10/welcome.jpg\" width=\"350\" height=\"244\" /></a>Hi, I\'m really excited to introduce Healthy Dog Headquarters!\r\n\r\nHDHQ is the culmination of a year-long battle to help our beloved whippet, Golda, overcome the deadly illness of Immune Mediated Hemolytic Anemia (IMHA), formerly called Canine Auto-Immune Hemolytic Anemia (AIHA) and the closely related disorder Immune-Mediated Hemolytic Anemia (IMHA).\r\n\r\nMy husband, Norman and I have had the privilege of owning whippets for twenty five years. Over this space of time, we\'ve had a total of six of these sensitive, loving animals, each one with their own personality and way of doing things. We adopted Golda in 2004 and have enjoyed her companionship ever since. And as anyone who is a dog owner understands, we\'ve had our share of illnesses and accidents over the years, including Golda\'s bout with Fibrocartilaginous Embolism (Canine FCE) in 2008 -- the equivalent of a stroke in humans. Little did we know at the time, but her battle with FCE helped prepare us for combatting and winning against the illness of canine AIHA/IMHA.\r\n\r\nHDHQ is my quest for knowledge and documenting our experience of how we assessed, then attacked the disease. I share these strategies, as well as the products we used and developed for nutrition and mobility. (make links)\r\n\r\nOur goal is to bring you the best products and resources for Health Issues, Holistic, Nutrition, Training / Behavior, Fun &amp; Play\r\n\r\nIf your dog is suffering from any illness, I hope Healthy Dog Headquarters will help make your dog healthy again.\r\n\r\nTruly,\r\n\r\nSherry Henson", "Welcome to Healthy Dog Headquarters", "", "publish", "closed", "closed", "", "welcome-healthy-dog-headquarters-2", "", "", "2013-10-25 13:41:49", "2013-10-25 13:41:49", "", "0", "http://healthydoghq.com/?page_id=399", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("400", "1", "2013-10-25 13:38:18", "2013-10-25 13:38:18", "<a href=\"http://healthydoghq.com/wp-content/uploads/2013/10/welcome.jpg\"><img class=\"alignright\" alt=\"welcome\" src=\"http://healthydoghq.com/wp-content/uploads/2013/10/welcome.jpg\" width=\"350\" height=\"244\" /></a>Hi, I\'m really excited to introduce my new blog Healthy Dog Headquarters!\r\n\r\nHDHQ is the culmination of a year-long battle to help our beloved whippet, Golda, overcome the deadly illness of Immune Mediated Hemolytic Anemia (IMHA), formerly called Canine Auto-Immune Hemolytic Anemia (AIHA) and the closely related disorder Immune-Mediated Hemolytic Anemia (IMHA).\r\n\r\nMy husband, Norman and I have had the privilege of owning whippets for twenty five years. Over this space of time, we\'ve had a total of six of these sensitive, loving animals, each one with their own personality and way of doing things. We adopted Golda in 2004 and have enjoyed her companionship ever since. And as anyone who is a dog owner understands, we\'ve had our share of illnesses and accidents over the years, including Golda\'s bout with Fibrocartilaginous Embolism (Canine FCE) in 2008 -- the equivalent of a stroke in humans. Little did we know at the time, but her battle with FCE helped prepare us for combatting and winning against the illness of canine AIHA/IMHA.\r\n\r\nHDHQ is my quest for knowledge and documenting our experience of how we assessed, then attacked the disease. I share these strategies, as well as the products we used and developed for nutrition and mobility. (make links)\r\n\r\nOur goal is to bring you the best products and resources for Health Issues, Holistic, Nutrition, Training / Behavior, Fun &amp; Play\r\n\r\nIf your dog is suffering from any illness, I hope Healthy Dog Headquarters will help make your dog healthy again.\r\n\r\nTruly,\r\n\r\nSherry Henson", "Welcome to Healthy Dog Headquarters!", "", "inherit", "closed", "closed", "", "399-revision-v1", "", "", "2013-10-25 13:38:18", "2013-10-25 13:38:18", "", "399", "http://healthydoghq.com/399-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("368", "1", "2013-10-24 20:39:00", "2013-10-24 20:39:00", "In the case of our dog, Golda, the symptoms of Canine Immune Mediated Hemolytic Anemia (IMHA) mimicked those of a Fibrocartilaginous Embolism (Canine FCE), resulting from an injury she suffered while playing frisbee several years ago. Read Golda\'s Story to learn more.\n\nGolda\'s symptoms started with the inability to maintain her balance, accompanied by an inability to walk or move her legs. I thought she had suffered a relapse of FCE and did not suspect anemia. It was only when she began to loose weight and became extremely lethargic did I suspect something else may be causing her problems.\n\nHere are the symptoms we experienced with Canine Immune Mediated Hemolytic Anemia (IMHA):\n<ul>\n	<li>Inability to balance</li>\n	<li>Inability to walk</li>\n	<li>Inability to move legs</li>\n	<li>Pale gums</li>\n	<li>Tired, weak &amp; listless</li>\n	<li>Shallow rapid breathing</li>\n	<li>Rapid heartbeat</li>\n	<li>Lack of appetite, accompanied by weight loss</li>\n	<li>Third eyelid</li>\n</ul>\nIn retrospect, these symptoms should have been easy to detect. But her previou had the FCE injury mis-directed us until we took her to the vet. If your dog is having any of these symptoms, please see your vet!\n\nIn my next post, I\'ll discuss testing for Canine Immune Mediated Hemolytic Anemia (IMHA).", "Canine Immune Mediated Hemolytic Anemia (IMHA) Symptoms", "", "inherit", "closed", "closed", "", "365-autosave-v1", "", "", "2013-10-24 20:39:00", "2013-10-24 20:39:00", "", "365", "http://healthydoghq.com/365-autosave-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("369", "1", "2013-10-24 20:39:38", "2013-10-24 20:39:38", "In the case of our dog, Golda, the symptoms of Canine Immune Mediated Hemolytic Anemia (IMHA) mimicked those of a Fibrocartilaginous Embolism (Canine FCE), resulting from an injury she suffered while playing frisbee several years ago. Read Golda\'s Story to learn more.\r\n\r\nGolda\'s symptoms started with the inability to maintain her balance, accompanied by an inability to walk or move her legs. I thought she had suffered a relapse of FCE and did not suspect anemia. It was only when she began to loose weight and became extremely lethargic did I suspect something else may be causing her problems.\r\n\r\nHere are the symptoms we experienced with Canine Immune Mediated Hemolytic Anemia (IMHA):\r\n<ul>\r\n	<li>Inability to balance</li>\r\n	<li>Inability to walk</li>\r\n	<li>Inability to move legs</li>\r\n	<li>Pale gums</li>\r\n	<li>Tired, weak &amp; listless</li>\r\n	<li>Shallow rapid breathing</li>\r\n	<li>Rapid heartbeat</li>\r\n	<li>Lack of appetite, accompanied by weight loss</li>\r\n	<li>Third eyelid</li>\r\n</ul>\r\nIn retrospect, these symptoms should have been easy to detect. But her past FCE injury mis-directed us until we took her to the vet. If your dog is having any of these symptoms, please see your vet as soon as possible!\r\n\r\nIn my next post, I\'ll discuss testing for Canine Immune Mediated Hemolytic Anemia (IMHA).", "Canine Immune Mediated Hemolytic Anemia (IMHA) Symptoms", "", "inherit", "closed", "closed", "", "365-revision-v1", "", "", "2013-10-24 20:39:38", "2013-10-24 20:39:38", "", "365", "http://healthydoghq.com/365-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("404", "1", "2013-10-25 13:58:32", "2013-10-25 13:58:32", "", "golda-feature", "", "inherit", "closed", "closed", "", "golda-feature", "", "", "2013-10-25 13:58:32", "2013-10-25 13:58:32", "", "337", "http://healthydoghq.com/wp-content/uploads/2013/10/golda-feature.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("405", "1", "2013-10-25 13:58:33", "2013-10-25 13:58:33", "", "golda-lure-coursing", "", "inherit", "closed", "closed", "", "golda-lure-coursing", "", "", "2013-10-25 13:58:33", "2013-10-25 13:58:33", "", "337", "http://healthydoghq.com/wp-content/uploads/2013/10/golda-lure-coursing.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("406", "1", "2013-10-25 13:58:50", "2013-10-25 13:58:50", "My husband, Norman and I, have had the privilege of owning whippets for twenty-five years. Over this space of time, we\'ve had a total of six of these sensitive, loving animals, each one with its own personality and way of doing things. Our first whippet, Devo, ruled the pack. Without a doubt, she was at the top of the pecking order at our house, after my husband. We lost her about ten years ago at the age of 15. Fortunately for us, all of our whippets have enjoyed long and healthy lives -- then we got Golda.\r\n\r\nGolda was originally owned by a good friend who owns and shows whippets. In 1992, our friend brought home a 12-week old red and white spitfire named \"Blue Skies Golden Pony\" and called her \"Golda\". The puppy was a gregarious fence jumper with a big heart and personality to match. Golda and Norman hit it off the first time they met. In many ways, Golda became his dog right from the start, and after retiring from the show ring, Golda came to live with us in 2004.\r\n\r\nFrom the first day we adopted her, life with Golda has been an absolute pleasure. She has always been active, friendly and loving, with no agenda, truly the best dog we\'ve ever known. Golda\'s great love in life was chasing the frisbee. Her speed and agility made her great at jumping to terrific heights and making spectacular catches in mid-air. In 2008, we noticed that she landed a bit funny after a routine jump, but she otherwise seemed fine. The next day, we awoke to find her paralyzed from the neck down. Frantically, we took her to several vets to find out that she had suffered from a Fibrocartilaginous Embolism (Canine FCE) -- a blockage in a blood vessel in the spinal cord. It’s often referred to as a spinal cord stroke. Our vet treated her with steroids and for the next six weeks, we became her legs, carrying her outside and holding her up as she went to the bathroom. Over time, she regained the use of her limbs and was eventually able to resume her favorite pastime of chasing the frisbee, albeit at a much reduced speed and intensity. She wasn\'t quite as coordinated as before, but we felt lucky that she was walking again. Little did we know it at the time, but the experience of dealing with Canine FCE would help prepare us for an equally devastating aliment: Canine Immune Mediated Hemolytic Anemia (IMHA) a few short years later.\r\n\r\nEven after her bout with Canine FCE, Golda\'s quality of life was very good, but in May of 2013, she had a set back. She once again was having trouble walking and maintaining her balance. We immediately assumed she had a reoccurrence of FCE. The symptoms were virtually the same, but this time, she began loosing weight and her gums were very pale in color. We took her to our vet, Dr. Bill Conley at Summer Animal Hospital, who examined her, ran a complete blood count (CBC) and a packed cell volume test (PCV). The results were staggering. The PCV test put her red blood cell count at 8%!!!  He said he had never seen a dog still alive with such a low blood count and that a normal dog\'s red blood cell volume is between 35 and 55%. Dr. Conley immediately recommended a blood transfusion. Needless to say, we were devastated at the news! How could we have missed all of the signs!? How could we have let Golda get into such a weakened state!? We agreed to the transfusion which \"stabilized\" her red blood cell volume to a still low 15%. As we were leaving his office, Dr. Conley prepared us for the worst by informing us that Golda was suffering from Immune Mediated Hemolytic Anemia (IMHA), formerly known as Canine Auto-Immune Hemolytic Anemia (AIHA), and that the recovery for this disease was \"very low\".  With a heavy heart, we thanked him and took Golda home for what we felt would surely be the last few days of her life.\r\n\r\nThe ride home from the vet\'s office seemed unusually long. On the way, we decided that we would do everything we could do, within reason, to give Golda the chance to recover. We owed that to her for all of the love and joy she had brought to us over the years. When we got home, we assessed our situation and began to formulate a plan to give her the opportunity to heal. Fortunately for us, and Golda, we had some great vets and quite a bit of luck on our side!\r\nGolda\'s Condition\r\n<ul>\r\n	<li>Weight: 19 pounds, normally 27</li>\r\n	<li>Red Blood Cell Volume: 8%, normal is between 35 and 55%</li>\r\n	<li>Appetite: None, normally she\'s a chow hound never turning down a meal</li>\r\n	<li>Ambulatory: Unable to walk or go to the bathroom on her own</li>\r\n	<li>Mental &amp; Emotional: Lethargic, extremely low energy level</li>\r\n	<li>Color: Pale gums - almost white, skin white, even freckles usually seen on legs &amp; tummy very faded and pale</li>\r\n	<li>Coat: Course, red coloring in coat pale</li>\r\n	<li>Nose: Dry and rough to the touch</li>\r\n	<li>Eyes: Third eye lid showing</li>\r\n</ul>\r\nFormulating a Plan\r\nOnce we assessed Golda\'s condition, we began to formulate a plan. First, we reached out to Dr. Kathy Mitchener at Angel Care, a veterinary clinic specializing in treating canine cancer to let her know about Golda\'s IMHA diagnosis. Dr. Mitchener had been performing weekly acupuncture sessions on Golda over the past couple of months in order to help her walk and move around better, with very good results. She also tested Golda\'s blood and confirmed Dr. Conley\'s diagnosis. Together, she and Dr. Conley, teamed up to administer a regimen of drugs to hopefully pull our beloved whippet out of the throws of IMHA.\r\n\r\nThe next step was research. I dedicated myself to find every stitch of information available online about IMHA. While there was a lot of information out there, it was a monumental task to compile. And as it turned out, no one had a strategy to combat the condition. That\'s when I decided to combine the information I found online and go with my gut -- of course, with input from our vets. To make matters worse, my husband had just sustained a ruptured achilles tendon, so in many ways, I was on my own in taking care of Golda. His inability to help carry her outside for potty brakes is what pushed me to design and develop the ___________. Without it, I never would have been able to handle the difficult task of taking Golda in and out of the house.\r\n\r\nMy online research lead me to _________ a supplement given to Chernobyl victims to help rebuild their damaged red blood cells. I also tracked down ________ a supplement that mimics mother\'s milk. Coconut water.\r\nExecuting the Plan\r\nOnce I had what I thought was the right supplements and nutrition for the battle ahead, I began to give put my plan into action. Golda\'s weight loss and lack of appetite was the number one priority. I had to make her eat and the only thing I could do was force feed her baby food.\r\n\r\nSherry to fill in everyday routine, feeding, etc.\r\n\r\nThroughout this process, we continued to visit Dr. Mitchener for Golda\'s weekly acupuncture sessions, this time targeting parts of the body to help her body\'s bone marrow generate new red blood cells. For the first two weeks, Golda was still weak and showing no signs of improvement. Dr. Mitchener took another packed cell volume test only to find that her red blood cell count had dropped even further. At this point, we wondered if we were doing the right thing by putting Golda through all of this heartache. But, Norman and I had seen something in Golda that led us to believe she was actually feeling better. Dr. Mitchener said that we should take Golda home and ask her what she wants to do…later that evening, we did just that and Golda gave us her answer: She was not ready to give up and neither were we! We continued on our regimen of drugs, supplements and nutritious food. Six weeks later, her PCV was 23! We were making progress, and are continuing to make progress to this day.\r\n\r\nI sincerely hope Healthy Dog Headquarters will help your dog as you go battle the effects of Canine IMHA. I\'ve worked diligently to provide the best information available, based on our own experience to help your dog fight and recover from this illness. Please look around our website and help make your dog a healthy dog!", "Golda\'s Story: Saving Our Dog from Immune Mediated Hemolytic Anemia", "", "inherit", "closed", "closed", "", "337-revision-v1", "", "", "2013-10-25 13:58:50", "2013-10-25 13:58:50", "", "337", "http://healthydoghq.com/337-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("407", "1", "2013-10-25 14:52:56", "2013-10-25 14:52:56", "", "golda-feature2", "", "inherit", "closed", "closed", "", "golda-feature2", "", "", "2013-10-25 14:52:56", "2013-10-25 14:52:56", "", "337", "http://healthydoghq.com/wp-content/uploads/2013/10/golda-feature2.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("408", "1", "2013-10-25 14:59:50", "2013-10-25 14:59:50", "", "blood-transfusion", "", "inherit", "closed", "closed", "", "blood-transfusion", "", "", "2013-10-25 14:59:50", "2013-10-25 14:59:50", "", "337", "http://healthydoghq.com/wp-content/uploads/2013/10/blood-transfusion.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("409", "1", "2013-10-25 15:00:24", "2013-10-25 15:00:24", "", "golda-lure-coursing", "", "inherit", "closed", "closed", "", "golda-lure-coursing-2", "", "", "2013-10-25 15:00:24", "2013-10-25 15:00:24", "", "337", "http://healthydoghq.com/wp-content/uploads/2013/10/golda-lure-coursing1.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("410", "1", "2013-10-25 15:01:48", "2013-10-25 15:01:48", "<a href=\"http://healthydoghq.com/wp-content/uploads/2013/10/golda-lure-coursing1.jpg\"><img class=\"alignright size-full wp-image-409\" alt=\"golda-lure-coursing\" src=\"http://healthydoghq.com/wp-content/uploads/2013/10/golda-lure-coursing1.jpg\" width=\"317\" height=\"209\" /></a>My husband, Norman and I, have had the privilege of owning whippets for twenty-five years. Over this space of time, we\'ve had a total of six of these sensitive, loving animals, each one with its own personality and way of doing things. Our first whippet, Devo, ruled the pack. Without a doubt, she was at the top of the pecking order at our house, after my husband. We lost her about ten years ago at the age of 15. Fortunately for us, all of our whippets have enjoyed long and healthy lives -- then we got Golda.\r\n\r\nGolda was originally owned by a good friend who owns and shows whippets. In 1992, our friend brought home a 12-week old red and white spitfire named \"Blue Skies Golden Pony\" and called her \"Golda\". The puppy was a gregarious fence jumper with a big heart and personality to match. Golda and Norman hit it off the first time they met. In many ways, Golda became his dog right from the start, and after retiring from the show ring, Golda came to live with us in 2004.\r\n\r\nFrom the first day we adopted her, life with Golda has been an absolute pleasure. She has always been active, friendly and loving, with no agenda, truly the best dog we\'ve ever known. Golda\'s great love in life was chasing the frisbee. Her speed and agility made her great at jumping to terrific heights and making spectacular catches in mid-air. In 2008, we noticed that she landed a bit funny after a routine jump, but she otherwise seemed fine. The next day, we awoke to find her paralyzed from the neck down. Frantically, we took her to several vets to find out that she had suffered from a Fibrocartilaginous Embolism (Canine FCE) -- a blockage in a blood vessel in the spinal cord. It’s often referred to as a spinal cord stroke. Our vet treated her with steroids and for the next six weeks, we became her legs, carrying her outside and holding her up as she went to the bathroom. Over time, she regained the use of her limbs and was eventually able to resume her favorite pastime of chasing the frisbee, albeit at a much reduced speed and intensity. She wasn\'t quite as coordinated as before, but we felt lucky that she was walking again. Little did we know it at the time, but the experience of dealing with Canine FCE would help prepare us for an equally devastating aliment: Canine Immune Mediated Hemolytic Anemia (IMHA) a few short years later.\r\n\r\n<a href=\"http://healthydoghq.com/wp-content/uploads/2013/10/blood-transfusion.jpg\"><img class=\"alignright size-medium wp-image-408\" alt=\"blood-transfusion\" src=\"http://healthydoghq.com/wp-content/uploads/2013/10/blood-transfusion-300x224.jpg\" width=\"300\" height=\"224\" /></a>Even after her bout with Canine FCE, Golda\'s quality of life was very good, but in May of 2013, she had a set back. She once again was having trouble walking and maintaining her balance. We immediately assumed she had a reoccurrence of FCE. The symptoms were virtually the same, but this time, she began loosing weight and her gums were very pale in color. We took her to our vet, Dr. Bill Conley at Summer Animal Hospital, who examined her, ran a complete blood count (CBC) and a packed cell volume test (PCV). The results were staggering. The PCV test put her red blood cell count at 8%!!!  He said he had never seen a dog still alive with such a low blood count and that a normal dog\'s red blood cell volume is between 35 and 55%. Dr. Conley immediately recommended a blood transfusion. Needless to say, we were devastated at the news! How could we have missed all of the signs!? How could we have let Golda get into such a weakened state!? We agreed to the transfusion which \"stabilized\" her red blood cell volume to a still low 15%. As we were leaving his office, Dr. Conley prepared us for the worst by informing us that Golda was suffering from Immune Mediated Hemolytic Anemia (IMHA), formerly known as Canine Auto-Immune Hemolytic Anemia (AIHA), and that the recovery for this disease was \"very low\".  With a heavy heart, we thanked him and took Golda home for what we felt would surely be the last few days of her life.\r\n\r\nThe ride home from the vet\'s office seemed unusually long. On the way, we decided that we would do everything we could do, within reason, to give Golda the chance to recover. We owed that to her for all of the love and joy she had brought to us over the years. When we got home, we assessed our situation and began to formulate a plan to give her the opportunity to heal. Fortunately for us, and Golda, we had some great vets and quite a bit of luck on our side!\r\nGolda\'s Condition\r\n<ul>\r\n	<li>Weight: 19 pounds, normally 27</li>\r\n	<li>Red Blood Cell Volume: 8%, normal is between 35 and 55%</li>\r\n	<li>Appetite: None, normally she\'s a chow hound never turning down a meal</li>\r\n	<li>Ambulatory: Unable to walk or go to the bathroom on her own</li>\r\n	<li>Mental &amp; Emotional: Lethargic, extremely low energy level</li>\r\n	<li>Color: Pale gums - almost white, skin white, even freckles usually seen on legs &amp; tummy very faded and pale</li>\r\n	<li>Coat: Course, red coloring in coat pale</li>\r\n	<li>Nose: Dry and rough to the touch</li>\r\n	<li>Eyes: Third eye lid showing</li>\r\n</ul>\r\nFormulating a Plan\r\nOnce we assessed Golda\'s condition, we began to formulate a plan. First, we reached out to Dr. Kathy Mitchener at Angel Care, a veterinary clinic specializing in treating canine cancer to let her know about Golda\'s IMHA diagnosis. Dr. Mitchener had been performing weekly acupuncture sessions on Golda over the past couple of months in order to help her walk and move around better, with very good results. She also tested Golda\'s blood and confirmed Dr. Conley\'s diagnosis. Together, she and Dr. Conley, teamed up to administer a regimen of drugs to hopefully pull our beloved whippet out of the throws of IMHA.\r\n\r\nThe next step was research. I dedicated myself to find every stitch of information available online about IMHA. While there was a lot of information out there, it was a monumental task to compile. And as it turned out, no one had a strategy to combat the condition. That\'s when I decided to combine the information I found online and go with my gut -- of course, with input from our vets. To make matters worse, my husband had just sustained a ruptured achilles tendon, so in many ways, I was on my own in taking care of Golda. His inability to help carry her outside for potty brakes is what pushed me to design and develop the ___________. Without it, I never would have been able to handle the difficult task of taking Golda in and out of the house.\r\n\r\nMy online research lead me to _________ a supplement given to Chernobyl victims to help rebuild their damaged red blood cells. I also tracked down ________ a supplement that mimics mother\'s milk. Coconut water.\r\nExecuting the Plan\r\nOnce I had what I thought was the right supplements and nutrition for the battle ahead, I began to give put my plan into action. Golda\'s weight loss and lack of appetite was the number one priority. I had to make her eat and the only thing I could do was force feed her baby food.\r\n\r\nSherry to fill in everyday routine, feeding, etc.\r\n\r\nThroughout this process, we continued to visit Dr. Mitchener for Golda\'s weekly acupuncture sessions, this time targeting parts of the body to help her body\'s bone marrow generate new red blood cells. For the first two weeks, Golda was still weak and showing no signs of improvement. Dr. Mitchener took another packed cell volume test only to find that her red blood cell count had dropped even further. At this point, we wondered if we were doing the right thing by putting Golda through all of this heartache. But, Norman and I had seen something in Golda that led us to believe she was actually feeling better. Dr. Mitchener said that we should take Golda home and ask her what she wants to do…later that evening, we did just that and Golda gave us her answer: She was not ready to give up and neither were we! We continued on our regimen of drugs, supplements and nutritious food. Six weeks later, her PCV was 23! We were making progress, and are continuing to make progress to this day.\r\n\r\nI sincerely hope Healthy Dog Headquarters will help your dog as you go battle the effects of Canine IMHA. I\'ve worked diligently to provide the best information available, based on our own experience to help your dog fight and recover from this illness. Please look around our website and help make your dog a healthy dog!", "Golda\'s Story: Saving Our Dog from Immune Mediated Hemolytic Anemia", "", "inherit", "closed", "closed", "", "337-revision-v1", "", "", "2013-10-25 15:01:48", "2013-10-25 15:01:48", "", "337", "http://healthydoghq.com/337-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("411", "1", "2013-10-25 15:03:33", "2013-10-25 15:03:33", "<a href=\"http://healthydoghq.com/wp-content/uploads/2013/10/golda-lure-coursing1.jpg\"><img class=\"alignright  wp-image-409\" alt=\"golda-lure-coursing\" src=\"http://healthydoghq.com/wp-content/uploads/2013/10/golda-lure-coursing1.jpg\" width=\"292\" height=\"191\" /></a>My husband, Norman and I, have had the privilege of owning whippets for twenty-five years. Over this space of time, we\'ve had a total of six of these sensitive, loving animals, each one with its own personality and way of doing things. Our first whippet, Devo, ruled the pack. Without a doubt, she was at the top of the pecking order at our house, after my husband. We lost her about ten years ago at the age of 15. Fortunately for us, all of our whippets have enjoyed long and healthy lives -- then we got Golda.\r\n\r\nGolda was originally owned by a good friend who owns and shows whippets. In 1992, our friend brought home a 12-week old red and white spitfire named \"Blue Skies Golden Pony\" and called her \"Golda\". The puppy was a gregarious fence jumper with a big heart and personality to match. Golda and Norman hit it off the first time they met. In many ways, Golda became his dog right from the start, and after retiring from the show ring, Golda came to live with us in 2004.\r\n\r\nFrom the first day we adopted her, life with Golda has been an absolute pleasure. She has always been active, friendly and loving, with no agenda, truly the best dog we\'ve ever known. Golda\'s great love in life was chasing the frisbee. Her speed and agility made her great at jumping to terrific heights and making spectacular catches in mid-air. In 2008, we noticed that she landed a bit funny after a routine jump, but she otherwise seemed fine. The next day, we awoke to find her paralyzed from the neck down. Frantically, we took her to several vets to find out that she had suffered from a Fibrocartilaginous Embolism (Canine FCE) -- a blockage in a blood vessel in the spinal cord. It’s often referred to as a spinal cord stroke. Our vet treated her with steroids and for the next six weeks, we became her legs, carrying her outside and holding her up as she went to the bathroom. Over time, she regained the use of her limbs and was eventually able to resume her favorite pastime of chasing the frisbee, albeit at a much reduced speed and intensity. She wasn\'t quite as coordinated as before, but we felt lucky that she was walking again. Little did we know it at the time, but the experience of dealing with Canine FCE would help prepare us for an equally devastating aliment: Canine Immune Mediated Hemolytic Anemia (IMHA) a few short years later.\r\n\r\n<a href=\"http://healthydoghq.com/wp-content/uploads/2013/10/blood-transfusion.jpg\"><img class=\"alignright size-medium wp-image-408\" alt=\"blood-transfusion\" src=\"http://healthydoghq.com/wp-content/uploads/2013/10/blood-transfusion-300x224.jpg\" width=\"288\" height=\"215\" /></a>Even after her bout with Canine FCE, Golda\'s quality of life was very good, but in May of 2013, she had a set back. She once again was having trouble walking and maintaining her balance. We immediately assumed she had a reoccurrence of FCE. The symptoms were virtually the same, but this time, she began loosing weight and her gums were very pale in color. We took her to our vet, Dr. Bill Conley at Summer Animal Hospital, who examined her, ran a complete blood count (CBC) and a packed cell volume test (PCV). The results were staggering. The PCV test put her red blood cell count at 8%!!!  He said he had never seen a dog still alive with such a low blood count and that a normal dog\'s red blood cell volume is between 35 and 55%. Dr. Conley immediately recommended a blood transfusion. Needless to say, we were devastated at the news! How could we have missed all of the signs!? How could we have let Golda get into such a weakened state!? We agreed to the transfusion which \"stabilized\" her red blood cell volume to a still low 15%. As we were leaving his office, Dr. Conley prepared us for the worst by informing us that Golda was suffering from Immune Mediated Hemolytic Anemia (IMHA), formerly known as Canine Auto-Immune Hemolytic Anemia (AIHA), and that the recovery for this disease was \"very low\".  With a heavy heart, we thanked him and took Golda home for what we felt would surely be the last few days of her life.\r\n\r\nThe ride home from the vet\'s office seemed unusually long. On the way, we decided that we would do everything we could do, within reason, to give Golda the chance to recover. We owed that to her for all of the love and joy she had brought to us over the years. When we got home, we assessed our situation and began to formulate a plan to give her the opportunity to heal. Fortunately for us, and Golda, we had some great vets and quite a bit of luck on our side!\r\nGolda\'s Condition\r\n<ul>\r\n	<li>Weight: 19 pounds, normally 27</li>\r\n	<li>Red Blood Cell Volume: 8%, normal is between 35 and 55%</li>\r\n	<li>Appetite: None, normally she\'s a chow hound never turning down a meal</li>\r\n	<li>Ambulatory: Unable to walk or go to the bathroom on her own</li>\r\n	<li>Mental &amp; Emotional: Lethargic, extremely low energy level</li>\r\n	<li>Color: Pale gums - almost white, skin white, even freckles usually seen on legs &amp; tummy very faded and pale</li>\r\n	<li>Coat: Course, red coloring in coat pale</li>\r\n	<li>Nose: Dry and rough to the touch</li>\r\n	<li>Eyes: Third eye lid showing</li>\r\n</ul>\r\nFormulating a Plan\r\nOnce we assessed Golda\'s condition, we began to formulate a plan. First, we reached out to Dr. Kathy Mitchener at Angel Care, a veterinary clinic specializing in treating canine cancer to let her know about Golda\'s IMHA diagnosis. Dr. Mitchener had been performing weekly acupuncture sessions on Golda over the past couple of months in order to help her walk and move around better, with very good results. She also tested Golda\'s blood and confirmed Dr. Conley\'s diagnosis. Together, she and Dr. Conley, teamed up to administer a regimen of drugs to hopefully pull our beloved whippet out of the throws of IMHA.\r\n\r\nThe next step was research. I dedicated myself to find every stitch of information available online about IMHA. While there was a lot of information out there, it was a monumental task to compile. And as it turned out, no one had a strategy to combat the condition. That\'s when I decided to combine the information I found online and go with my gut -- of course, with input from our vets. To make matters worse, my husband had just sustained a ruptured achilles tendon, so in many ways, I was on my own in taking care of Golda. His inability to help carry her outside for potty brakes is what pushed me to design and develop the ___________. Without it, I never would have been able to handle the difficult task of taking Golda in and out of the house.\r\n\r\nMy online research lead me to _________ a supplement given to Chernobyl victims to help rebuild their damaged red blood cells. I also tracked down ________ a supplement that mimics mother\'s milk. Coconut water.\r\nExecuting the Plan\r\nOnce I had what I thought was the right supplements and nutrition for the battle ahead, I began to give put my plan into action. Golda\'s weight loss and lack of appetite was the number one priority. I had to make her eat and the only thing I could do was force feed her baby food.\r\n\r\nSherry to fill in everyday routine, feeding, etc.\r\n\r\nThroughout this process, we continued to visit Dr. Mitchener for Golda\'s weekly acupuncture sessions, this time targeting parts of the body to help her body\'s bone marrow generate new red blood cells. For the first two weeks, Golda was still weak and showing no signs of improvement. Dr. Mitchener took another packed cell volume test only to find that her red blood cell count had dropped even further. At this point, we wondered if we were doing the right thing by putting Golda through all of this heartache. But, Norman and I had seen something in Golda that led us to believe she was actually feeling better. Dr. Mitchener said that we should take Golda home and ask her what she wants to do…later that evening, we did just that and Golda gave us her answer: She was not ready to give up and neither were we! We continued on our regimen of drugs, supplements and nutritious food. Six weeks later, her PCV was 23! We were making progress, and are continuing to make progress to this day.\r\n\r\nI sincerely hope Healthy Dog Headquarters will help your dog as you go battle the effects of Canine IMHA. I\'ve worked diligently to provide the best information available, based on our own experience to help your dog fight and recover from this illness. Please look around our website and help make your dog a healthy dog!", "Golda\'s Story: Saving Our Dog from Immune Mediated Hemolytic Anemia", "", "inherit", "closed", "closed", "", "337-revision-v1", "", "", "2013-10-25 15:03:33", "2013-10-25 15:03:33", "", "337", "http://healthydoghq.com/337-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("412", "1", "2013-10-25 15:04:03", "2013-10-25 15:04:03", "<a href=\"http://healthydoghq.com/wp-content/uploads/2013/10/golda-lure-coursing1.jpg\"><img class=\"alignright size-medium wp-image-409\" alt=\"golda-lure-coursing\" src=\"http://healthydoghq.com/wp-content/uploads/2013/10/golda-lure-coursing1-300x197.jpg\" width=\"300\" height=\"197\" /></a>My husband, Norman and I, have had the privilege of owning whippets for twenty-five years. Over this space of time, we\'ve had a total of six of these sensitive, loving animals, each one with its own personality and way of doing things. Our first whippet, Devo, ruled the pack. Without a doubt, she was at the top of the pecking order at our house, after my husband. We lost her about ten years ago at the age of 15. Fortunately for us, all of our whippets have enjoyed long and healthy lives -- then we got Golda.\r\n\r\nGolda was originally owned by a good friend who owns and shows whippets. In 1992, our friend brought home a 12-week old red and white spitfire named \"Blue Skies Golden Pony\" and called her \"Golda\". The puppy was a gregarious fence jumper with a big heart and personality to match. Golda and Norman hit it off the first time they met. In many ways, Golda became his dog right from the start, and after retiring from the show ring, Golda came to live with us in 2004.\r\n\r\nFrom the first day we adopted her, life with Golda has been an absolute pleasure. She has always been active, friendly and loving, with no agenda, truly the best dog we\'ve ever known. Golda\'s great love in life was chasing the frisbee. Her speed and agility made her great at jumping to terrific heights and making spectacular catches in mid-air. In 2008, we noticed that she landed a bit funny after a routine jump, but she otherwise seemed fine. The next day, we awoke to find her paralyzed from the neck down. Frantically, we took her to several vets to find out that she had suffered from a Fibrocartilaginous Embolism (Canine FCE) -- a blockage in a blood vessel in the spinal cord. It’s often referred to as a spinal cord stroke. Our vet treated her with steroids and for the next six weeks, we became her legs, carrying her outside and holding her up as she went to the bathroom. Over time, she regained the use of her limbs and was eventually able to resume her favorite pastime of chasing the frisbee, albeit at a much reduced speed and intensity. She wasn\'t quite as coordinated as before, but we felt lucky that she was walking again. Little did we know it at the time, but the experience of dealing with Canine FCE would help prepare us for an equally devastating aliment: Canine Immune Mediated Hemolytic Anemia (IMHA) a few short years later.\r\n\r\n<a href=\"http://healthydoghq.com/wp-content/uploads/2013/10/blood-transfusion.jpg\"><img class=\"alignright size-medium wp-image-408\" alt=\"blood-transfusion\" src=\"http://healthydoghq.com/wp-content/uploads/2013/10/blood-transfusion-300x224.jpg\" width=\"288\" height=\"215\" /></a>Even after her bout with Canine FCE, Golda\'s quality of life was very good, but in May of 2013, she had a set back. She once again was having trouble walking and maintaining her balance. We immediately assumed she had a reoccurrence of FCE. The symptoms were virtually the same, but this time, she began loosing weight and her gums were very pale in color. We took her to our vet, Dr. Bill Conley at Summer Animal Hospital, who examined her, ran a complete blood count (CBC) and a packed cell volume test (PCV). The results were staggering. The PCV test put her red blood cell count at 8%!!!  He said he had never seen a dog still alive with such a low blood count and that a normal dog\'s red blood cell volume is between 35 and 55%. Dr. Conley immediately recommended a blood transfusion. Needless to say, we were devastated at the news! How could we have missed all of the signs!? How could we have let Golda get into such a weakened state!? We agreed to the transfusion which \"stabilized\" her red blood cell volume to a still low 15%. As we were leaving his office, Dr. Conley prepared us for the worst by informing us that Golda was suffering from Immune Mediated Hemolytic Anemia (IMHA), formerly known as Canine Auto-Immune Hemolytic Anemia (AIHA), and that the recovery for this disease was \"very low\".  With a heavy heart, we thanked him and took Golda home for what we felt would surely be the last few days of her life.\r\n\r\nThe ride home from the vet\'s office seemed unusually long. On the way, we decided that we would do everything we could do, within reason, to give Golda the chance to recover. We owed that to her for all of the love and joy she had brought to us over the years. When we got home, we assessed our situation and began to formulate a plan to give her the opportunity to heal. Fortunately for us, and Golda, we had some great vets and quite a bit of luck on our side!\r\nGolda\'s Condition\r\n<ul>\r\n	<li>Weight: 19 pounds, normally 27</li>\r\n	<li>Red Blood Cell Volume: 8%, normal is between 35 and 55%</li>\r\n	<li>Appetite: None, normally she\'s a chow hound never turning down a meal</li>\r\n	<li>Ambulatory: Unable to walk or go to the bathroom on her own</li>\r\n	<li>Mental &amp; Emotional: Lethargic, extremely low energy level</li>\r\n	<li>Color: Pale gums - almost white, skin white, even freckles usually seen on legs &amp; tummy very faded and pale</li>\r\n	<li>Coat: Course, red coloring in coat pale</li>\r\n	<li>Nose: Dry and rough to the touch</li>\r\n	<li>Eyes: Third eye lid showing</li>\r\n</ul>\r\nFormulating a Plan\r\nOnce we assessed Golda\'s condition, we began to formulate a plan. First, we reached out to Dr. Kathy Mitchener at Angel Care, a veterinary clinic specializing in treating canine cancer to let her know about Golda\'s IMHA diagnosis. Dr. Mitchener had been performing weekly acupuncture sessions on Golda over the past couple of months in order to help her walk and move around better, with very good results. She also tested Golda\'s blood and confirmed Dr. Conley\'s diagnosis. Together, she and Dr. Conley, teamed up to administer a regimen of drugs to hopefully pull our beloved whippet out of the throws of IMHA.\r\n\r\nThe next step was research. I dedicated myself to find every stitch of information available online about IMHA. While there was a lot of information out there, it was a monumental task to compile. And as it turned out, no one had a strategy to combat the condition. That\'s when I decided to combine the information I found online and go with my gut -- of course, with input from our vets. To make matters worse, my husband had just sustained a ruptured achilles tendon, so in many ways, I was on my own in taking care of Golda. His inability to help carry her outside for potty brakes is what pushed me to design and develop the ___________. Without it, I never would have been able to handle the difficult task of taking Golda in and out of the house.\r\n\r\nMy online research lead me to _________ a supplement given to Chernobyl victims to help rebuild their damaged red blood cells. I also tracked down ________ a supplement that mimics mother\'s milk. Coconut water.\r\nExecuting the Plan\r\nOnce I had what I thought was the right supplements and nutrition for the battle ahead, I began to give put my plan into action. Golda\'s weight loss and lack of appetite was the number one priority. I had to make her eat and the only thing I could do was force feed her baby food.\r\n\r\nSherry to fill in everyday routine, feeding, etc.\r\n\r\nThroughout this process, we continued to visit Dr. Mitchener for Golda\'s weekly acupuncture sessions, this time targeting parts of the body to help her body\'s bone marrow generate new red blood cells. For the first two weeks, Golda was still weak and showing no signs of improvement. Dr. Mitchener took another packed cell volume test only to find that her red blood cell count had dropped even further. At this point, we wondered if we were doing the right thing by putting Golda through all of this heartache. But, Norman and I had seen something in Golda that led us to believe she was actually feeling better. Dr. Mitchener said that we should take Golda home and ask her what she wants to do…later that evening, we did just that and Golda gave us her answer: She was not ready to give up and neither were we! We continued on our regimen of drugs, supplements and nutritious food. Six weeks later, her PCV was 23! We were making progress, and are continuing to make progress to this day.\r\n\r\nI sincerely hope Healthy Dog Headquarters will help your dog as you go battle the effects of Canine IMHA. I\'ve worked diligently to provide the best information available, based on our own experience to help your dog fight and recover from this illness. Please look around our website and help make your dog a healthy dog!", "Golda\'s Story: Saving Our Dog from Immune Mediated Hemolytic Anemia", "", "inherit", "closed", "closed", "", "337-revision-v1", "", "", "2013-10-25 15:04:03", "2013-10-25 15:04:03", "", "337", "http://healthydoghq.com/337-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("382", "1", "2013-10-24 22:56:49", "2013-10-24 22:56:49", "My husband, Norman and I, have had the privilege of owning whippets for twenty-five years. Over this space of time, we\'ve had a total of six of these sensitive, loving animals, each one with its own personality and way of doing things. Our first whippet, Devo, ruled the pack. Without a doubt, she was at the top of the pecking order at our house, after my husband. We lost her about ten years ago at the age of 15. Fortunately for us, all of our whippets have enjoyed long and healthy lives -- then we got Golda.\r\n\r\nGolda was originally owned by a good friend who owns and shows whippets. In 1992, our friend brought home a 12-week old red and white spitfire named \"Blue Skies Golden Pony\" and called her \"Golda\". The puppy was a gregarious fence jumper with a big heart and personality to match. Golda and Norman hit it off the first time they met. In many ways, Golda became his dog right from the start, and after retiring from the show ring, Golda came to live with us in 2004.\r\n\r\nFrom the first day we adopted her, life with Golda has been an absolute pleasure. She has always been active, friendly and loving, with no agenda, truly the best dog we\'ve ever known. Golda\'s great love in life was chasing the frisbee. Her speed and agility made her great at jumping to terrific heights and making spectacular catches in mid-air. In 2008, we noticed that she landed a bit funny after a routine jump, but she otherwise seemed fine. The next day, we awoke to find her paralyzed from the neck down. Frantically, we took her to several vets to find out that she had suffered from a Fibrocartilaginous Embolism (Canine FCE) -- a blockage in a blood vessel in the spinal cord. It’s often referred to as a spinal cord stroke. Our vet treated her with steroids and for the next six weeks, we became her legs, carrying her outside and holding her up as she went to the bathroom. Over time, she regained the use of her limbs and was eventually able to resume her favorite pastime of chasing the frisbee, albeit at a much reduced speed and intensity. She wasn\'t quite as coordinated as before, but we felt lucky that she was walking again. Little did we know it at the time, but the experience of dealing with Canine FCE would help prepare us for an equally devastating aliment: Canine Immune Mediated Hemolytic Anemia (IMHA) a few short years later.\r\n\r\nEven after her bout with Canine FCE, Golda\'s quality of life was very good, but in May of 2013, she had a set back. She once again was having trouble walking and maintaining her balance. We immediately assumed she had a reoccurrence of FCE. The symptoms were virtually the same, but this time, she began loosing weight and her gums were very pale in color. We took her to our vet, Dr. Bill Conley at Summer Animal Hospital, who examined her, ran a complete blood count (CBC) and a packed cell volume test (PCV). The results were staggering. The PCV test put her red blood cell count at 8%!!!  He said he had never seen a dog still alive with such a low blood count and that a normal dog\'s red blood cell volume is between 35 and 55%. Dr. Conley immediately recommended a blood transfusion. Needless to say, we were devastated at the news! How could we have missed all of the signs!? How could we have let Golda get into such a weakened state!? We agreed to the transfusion which \"stabilized\" her red blood cell volume to a still low 15%. As we were leaving his office, Dr. Conley prepared us for the worst by informing us that Golda was suffering from Immune Mediated Hemolytic Anemia (IMHA), formerly known as Canine Auto-Immune Hemolytic Anemia (AIHA), and that the recovery for this disease was \"very low\".  With a heavy heart, we thanked him and took Golda home for what we felt would surely be the last few days of her life.\r\n\r\nThe ride home from the vet\'s office seemed unusually long. On the way, we decided that we would do everything we could do, within reason, to give Golda the chance to recover. We owed that to her for all of the love and joy she had brought to us over the years. When we got home, we assessed our situation and began to formulate a plan to give her the opportunity to heal. Fortunately for us, and Golda, we had some great vets and quite a bit of luck on our side!\r\n\r\nGolda\'s Condition\r\n\r\nWeight: 19 pounds, normally 27\r\nRed Blood Cell Volume: 8%, normal is between 35 and 55%\r\nAppetite: None, normally she\'s a chow hound never turning down a meal\r\nAmbulatory: Unable to walk or go to the bathroom on her own\r\nMental &amp; Emotional: Lethargic, extremely low energy level\r\nColor: Pale gums - almost white, skin white, even freckles usually seen on legs &amp; tummy very faded and pale\r\nCoat: Course, red coloring in coat pale\r\nNose: Dry and rough to the touch\r\nEyes: Third eye lid showing\r\n\r\nFormulating a Plan\r\n\r\nOnce we assessed Golda\'s condition, we began to formulate a plan. First, we reached out to Dr. Kathy Mitchener at Angel Care, a veterinary clinic specializing in treating canine cancer to let her know about Golda\'s IMHA diagnosis. Dr. Mitchener had been performing weekly acupuncture sessions on Golda over the past couple of months in order to help her walk and move around better, with very good results. She also tested Golda\'s blood and confirmed Dr. Conley\'s diagnosis. Together, she and Dr. Conley, teamed up to administer a regimen of drugs to hopefully pull our beloved whippet out of the throws of IMHA.\r\n\r\nThe next step was research. I dedicated myself to find every stitch of information available online about IMHA. While there was a lot of information out there, it was a monumental task to compile. And as it turned out, no one had a strategy to combat the condition. That\'s when I decided to combine the information I found online and go with my gut -- of course, with input from our vets. To make matters worse, my husband had just sustained a ruptured achilles tendon, so in many ways, I was on my own in taking care of Golda. His inability to help carry her outside for potty brakes is what pushed me to design and develop the ___________. Without it, I never would have been able to handle the difficult task of taking Golda in and out of the house.\r\n\r\nMy online research lead me to _________ a supplement given to Chernobyl victims to help rebuild their damaged red blood cells. I also tracked down ________ a supplement that mimics mother\'s milk. Coconut water.\r\n\r\nExecuting the Plan\r\n\r\nOnce I had what I thought was the right supplements and nutrition for the battle ahead, I began to give put my plan into action. Golda\'s weight loss and lack of appetite was the number one priority. I had to make her eat and the only thing I could do was force feed her baby food.\r\n\r\nSherry to fill in everyday routine, feeding, etc.\r\n\r\n\r\nThroughout this process, we continued to visit Dr. Mitchener for Golda\'s weekly acupuncture sessions, this time targeting parts of the body to help her body\'s bone marrow generate new red blood cells. For the first two weeks, Golda was still weak and showing no signs of improvement. Dr. Mitchener took another packed cell volume test only to find that her red blood cell count had dropped even further. At this point, we wondered if we were doing the right thing by putting Golda through all of this heartache. But, Norman and I had seen something in Golda that led us to believe she was actually feeling better. Dr. Mitchener said that we should take Golda home and ask her what she wants to do…later that evening, we did just that and Golda gave us her answer: She was not ready to give up and neither were we! We continued on our regimen of drugs, supplements and nutritious food. Six weeks later, her PCV was 23! We were making progress, and are continuing to make progress to this day.\r\n\r\nI sincerely hope Healthy Dog Headquarters will help your dog as you go battle the effects of Canine IMHA. I\'ve worked diligently to provide the best information available, based on our own experience to help your dog fight and recover from this illness. Please look around our website and help make your dog a healthy dog!", "Golda\'s Story: Saving Our Dog from Immune Mediated Hemolytic Anemia (IMHA)", "", "inherit", "closed", "closed", "", "381-revision-v1", "", "", "2013-10-24 22:56:49", "2013-10-24 22:56:49", "", "381", "http://healthydoghq.com/381-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("383", "1", "2013-10-24 22:57:58", "2013-10-24 22:57:58", "", "Golda\'s Story", "", "publish", "closed", "closed", "", "goldas-story-2", "", "", "2013-10-24 22:57:58", "2013-10-24 22:57:58", "", "0", "http://healthydoghq.com/?p=383", "2", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("386", "1", "2013-10-24 23:26:22", "2013-10-24 23:26:22", "", "welcome", "", "inherit", "closed", "closed", "", "welcome-2", "", "", "2013-10-24 23:26:22", "2013-10-24 23:26:22", "", "0", "http://healthydoghq.com/wp-content/uploads/2013/10/welcome.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("403", "1", "2013-10-25 15:01:28", "2013-10-25 15:01:28", "<a href=\"http://healthydoghq.com/wp-content/uploads/2013/10/golda-lure-coursing1.jpg\"><img class=\"alignright size-full wp-image-409\" alt=\"golda-lure-coursing\" src=\"http://healthydoghq.com/wp-content/uploads/2013/10/golda-lure-coursing1.jpg\" width=\"430\" height=\"283\" /></a>My husband, Norman and I, have had the privilege of owning whippets for twenty-five years. Over this space of time, we\'ve had a total of six of these sensitive, loving animals, each one with its own personality and way of doing things. Our first whippet, Devo, ruled the pack. Without a doubt, she was at the top of the pecking order at our house, after my husband. We lost her about ten years ago at the age of 15. Fortunately for us, all of our whippets have enjoyed long and healthy lives -- then we got Golda.\n\nGolda was originally owned by a good friend who owns and shows whippets. In 1992, our friend brought home a 12-week old red and white spitfire named \"Blue Skies Golden Pony\" and called her \"Golda\". The puppy was a gregarious fence jumper with a big heart and personality to match. Golda and Norman hit it off the first time they met. In many ways, Golda became his dog right from the start, and after retiring from the show ring, Golda came to live with us in 2004.\n\nFrom the first day we adopted her, life with Golda has been an absolute pleasure. She has always been active, friendly and loving, with no agenda, truly the best dog we\'ve ever known. Golda\'s great love in life was chasing the frisbee. Her speed and agility made her great at jumping to terrific heights and making spectacular catches in mid-air. In 2008, we noticed that she landed a bit funny after a routine jump, but she otherwise seemed fine. The next day, we awoke to find her paralyzed from the neck down. Frantically, we took her to several vets to find out that she had suffered from a Fibrocartilaginous Embolism (Canine FCE) -- a blockage in a blood vessel in the spinal cord. It’s often referred to as a spinal cord stroke. Our vet treated her with steroids and for the next six weeks, we became her legs, carrying her outside and holding her up as she went to the bathroom. Over time, she regained the use of her limbs and was eventually able to resume her favorite pastime of chasing the frisbee, albeit at a much reduced speed and intensity. She wasn\'t quite as coordinated as before, but we felt lucky that she was walking again. Little did we know it at the time, but the experience of dealing with Canine FCE would help prepare us for an equally devastating aliment: Canine Immune Mediated Hemolytic Anemia (IMHA) a few short years later.\n\n<a href=\"http://healthydoghq.com/wp-content/uploads/2013/10/blood-transfusion.jpg\"><img class=\"alignright size-medium wp-image-408\" alt=\"blood-transfusion\" src=\"http://healthydoghq.com/wp-content/uploads/2013/10/blood-transfusion-300x224.jpg\" width=\"300\" height=\"224\" /></a>Even after her bout with Canine FCE, Golda\'s quality of life was very good, but in May of 2013, she had a set back. She once again was having trouble walking and maintaining her balance. We immediately assumed she had a reoccurrence of FCE. The symptoms were virtually the same, but this time, she began loosing weight and her gums were very pale in color. We took her to our vet, Dr. Bill Conley at Summer Animal Hospital, who examined her, ran a complete blood count (CBC) and a packed cell volume test (PCV). The results were staggering. The PCV test put her red blood cell count at 8%!!!  He said he had never seen a dog still alive with such a low blood count and that a normal dog\'s red blood cell volume is between 35 and 55%. Dr. Conley immediately recommended a blood transfusion. Needless to say, we were devastated at the news! How could we have missed all of the signs!? How could we have let Golda get into such a weakened state!? We agreed to the transfusion which \"stabilized\" her red blood cell volume to a still low 15%. As we were leaving his office, Dr. Conley prepared us for the worst by informing us that Golda was suffering from Immune Mediated Hemolytic Anemia (IMHA), formerly known as Canine Auto-Immune Hemolytic Anemia (AIHA), and that the recovery for this disease was \"very low\".  With a heavy heart, we thanked him and took Golda home for what we felt would surely be the last few days of her life.\n\nThe ride home from the vet\'s office seemed unusually long. On the way, we decided that we would do everything we could do, within reason, to give Golda the chance to recover. We owed that to her for all of the love and joy she had brought to us over the years. When we got home, we assessed our situation and began to formulate a plan to give her the opportunity to heal. Fortunately for us, and Golda, we had some great vets and quite a bit of luck on our side!\nGolda\'s Condition\n<ul>\n	<li>Weight: 19 pounds, normally 27</li>\n	<li>Red Blood Cell Volume: 8%, normal is between 35 and 55%</li>\n	<li>Appetite: None, normally she\'s a chow hound never turning down a meal</li>\n	<li>Ambulatory: Unable to walk or go to the bathroom on her own</li>\n	<li>Mental &amp; Emotional: Lethargic, extremely low energy level</li>\n	<li>Color: Pale gums - almost white, skin white, even freckles usually seen on legs &amp; tummy very faded and pale</li>\n	<li>Coat: Course, red coloring in coat pale</li>\n	<li>Nose: Dry and rough to the touch</li>\n	<li>Eyes: Third eye lid showing</li>\n</ul>\nFormulating a Plan\nOnce we assessed Golda\'s condition, we began to formulate a plan. First, we reached out to Dr. Kathy Mitchener at Angel Care, a veterinary clinic specializing in treating canine cancer to let her know about Golda\'s IMHA diagnosis. Dr. Mitchener had been performing weekly acupuncture sessions on Golda over the past couple of months in order to help her walk and move around better, with very good results. She also tested Golda\'s blood and confirmed Dr. Conley\'s diagnosis. Together, she and Dr. Conley, teamed up to administer a regimen of drugs to hopefully pull our beloved whippet out of the throws of IMHA.\n\nThe next step was research. I dedicated myself to find every stitch of information available online about IMHA. While there was a lot of information out there, it was a monumental task to compile. And as it turned out, no one had a strategy to combat the condition. That\'s when I decided to combine the information I found online and go with my gut -- of course, with input from our vets. To make matters worse, my husband had just sustained a ruptured achilles tendon, so in many ways, I was on my own in taking care of Golda. His inability to help carry her outside for potty brakes is what pushed me to design and develop the ___________. Without it, I never would have been able to handle the difficult task of taking Golda in and out of the house.\n\nMy online research lead me to _________ a supplement given to Chernobyl victims to help rebuild their damaged red blood cells. I also tracked down ________ a supplement that mimics mother\'s milk. Coconut water.\nExecuting the Plan\nOnce I had what I thought was the right supplements and nutrition for the battle ahead, I began to give put my plan into action. Golda\'s weight loss and lack of appetite was the number one priority. I had to make her eat and the only thing I could do was force feed her baby food.\n\nSherry to fill in everyday routine, feeding, etc.\n\nThroughout this process, we continued to visit Dr. Mitchener for Golda\'s weekly acupuncture sessions, this time targeting parts of the body to help her body\'s bone marrow generate new red blood cells. For the first two weeks, Golda was still weak and showing no signs of improvement. Dr. Mitchener took another packed cell volume test only to find that her red blood cell count had dropped even further. At this point, we wondered if we were doing the right thing by putting Golda through all of this heartache. But, Norman and I had seen something in Golda that led us to believe she was actually feeling better. Dr. Mitchener said that we should take Golda home and ask her what she wants to do…later that evening, we did just that and Golda gave us her answer: She was not ready to give up and neither were we! We continued on our regimen of drugs, supplements and nutritious food. Six weeks later, her PCV was 23! We were making progress, and are continuing to make progress to this day.\n\nI sincerely hope Healthy Dog Headquarters will help your dog as you go battle the effects of Canine IMHA. I\'ve worked diligently to provide the best information available, based on our own experience to help your dog fight and recover from this illness. Please look around our website and help make your dog a healthy dog!", "Golda\'s Story: Saving Our Dog from Immune Mediated Hemolytic Anemia", "", "inherit", "closed", "closed", "", "337-autosave-v1", "", "", "2013-10-25 15:01:28", "2013-10-25 15:01:28", "", "337", "http://healthydoghq.com/337-autosave-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("413", "1", "2013-10-25 15:12:27", "2013-10-25 15:12:27", "", "Golda-chicken", "", "inherit", "closed", "closed", "", "golda-chicken", "", "", "2013-10-25 15:12:27", "2013-10-25 15:12:27", "", "337", "http://healthydoghq.com/wp-content/uploads/2013/10/Golda-chicken.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("414", "1", "2013-10-25 15:13:05", "2013-10-25 15:13:05", "<img class=\"alignright size-medium wp-image-409\" alt=\"golda-lure-coursing\" src=\"http://healthydoghq.com/wp-content/uploads/2013/10/golda-lure-coursing1-300x197.jpg\" width=\"300\" height=\"197\" />My husband, Norman and I, have had the privilege of owning whippets for twenty-five years. Over this space of time, we\'ve had a total of six of these sensitive, loving animals, each one with its own personality and way of doing things. Our first whippet, Devo, ruled the pack. Without a doubt, she was at the top of the pecking order at our house, after my husband. We lost her about ten years ago at the age of 15. Fortunately for us, all of our whippets have enjoyed long and healthy lives -- then we got Golda.\r\n\r\nGolda was originally owned by a good friend who owns and shows whippets. In 1992, our friend brought home a 12-week old red and white spitfire named \"Blue Skies Golden Pony\" and called her \"Golda\". The puppy was a gregarious fence jumper with a big heart and personality to match. Golda and Norman hit it off the first time they met. In many ways, Golda became his dog right from the start, and after retiring from the show ring, Golda came to live with us in 2004.\r\n\r\nFrom the first day we adopted her, life with Golda has been an absolute pleasure. She has always been active, friendly and loving, with no agenda, truly the best dog we\'ve ever known. Golda\'s great love in life was chasing the frisbee. Her speed and agility made her great at jumping to terrific heights and making spectacular catches in mid-air. In 2008, we noticed that she landed a bit funny after a routine jump, but she otherwise seemed fine. The next day, we awoke to find her paralyzed from the neck down. Frantically, we took her to several vets to find out that she had suffered from a Fibrocartilaginous Embolism (Canine FCE) -- a blockage in a blood vessel in the spinal cord. It’s often referred to as a spinal cord stroke. Our vet treated her with steroids and for the next six weeks, we became her legs, carrying her outside and holding her up as she went to the bathroom. Over time, she regained the use of her limbs and was eventually able to resume her favorite pastime of chasing the frisbee, albeit at a much reduced speed and intensity. She wasn\'t quite as coordinated as before, but we felt lucky that she was walking again. Little did we know it at the time, but the experience of dealing with Canine FCE would help prepare us for an equally devastating aliment: Canine Immune Mediated Hemolytic Anemia (IMHA) a few short years later.\r\n\r\n<img class=\"alignright size-medium wp-image-408\" alt=\"blood-transfusion\" src=\"http://healthydoghq.com/wp-content/uploads/2013/10/blood-transfusion-300x224.jpg\" width=\"288\" height=\"215\" />Even after her bout with Canine FCE, Golda\'s quality of life was very good, but in May of 2013, she had a set back. She once again was having trouble walking and maintaining her balance. We immediately assumed she had a reoccurrence of FCE. The symptoms were virtually the same, but this time, she began loosing weight and her gums were very pale in color. We took her to our vet, Dr. Bill Conley at Summer Animal Hospital, who examined her, ran a complete blood count (CBC) and a packed cell volume test (PCV). The results were staggering. The PCV test put her red blood cell count at 8%!!!  He said he had never seen a dog still alive with such a low blood count and that a normal dog\'s red blood cell volume is between 35 and 55%. Dr. Conley immediately recommended a blood transfusion. Needless to say, we were devastated at the news! How could we have missed all of the signs!? How could we have let Golda get into such a weakened state!? We agreed to the transfusion which \"stabilized\" her red blood cell volume to a still low 15%. As we were leaving his office, Dr. Conley prepared us for the worst by informing us that Golda was suffering from Immune Mediated Hemolytic Anemia (IMHA), formerly known as Canine Auto-Immune Hemolytic Anemia (AIHA), and that the recovery for this disease was \"very low\".  With a heavy heart, we thanked him and took Golda home for what we felt would surely be the last few days of her life.\r\n\r\nThe ride home from the vet\'s office seemed unusually long. On the way, we decided that we would do everything we could do, within reason, to give Golda the chance to recover. We owed that to her for all of the love and joy she had brought to us over the years. When we got home, we assessed our situation and began to formulate a plan to give her the opportunity to heal. Fortunately for us, and Golda, we had some great vets and quite a bit of luck on our side!\r\nGolda\'s Condition\r\n<ul>\r\n	<li>Weight: 19 pounds, normally 27</li>\r\n	<li>Red Blood Cell Volume: 8%, normal is between 35 and 55%</li>\r\n	<li>Appetite: None, normally she\'s a chow hound never turning down a meal</li>\r\n	<li>Ambulatory: Unable to walk or go to the bathroom on her own</li>\r\n	<li>Mental &amp; Emotional: Lethargic, extremely low energy level</li>\r\n	<li>Color: Pale gums - almost white, skin white, even freckles usually seen on legs &amp; tummy very faded and pale</li>\r\n	<li>Coat: Course, red coloring in coat pale</li>\r\n	<li>Nose: Dry and rough to the touch</li>\r\n	<li>Eyes: Third eye lid showing</li>\r\n</ul>\r\nFormulating a Plan\r\n<img class=\"alignright size-medium wp-image-413\" alt=\"Golda-chicken\" src=\"http://healthydoghq.com/wp-content/uploads/2013/10/Golda-chicken-300x225.jpg\" width=\"300\" height=\"225\" />Once we assessed Golda\'s condition, we began to formulate a plan. First, we reached out to Dr. Kathy Mitchener at Angel Care, a veterinary clinic specializing in treating canine cancer to let her know about Golda\'s IMHA diagnosis. Dr. Mitchener had been performing weekly acupuncture sessions on Golda over the past couple of months in order to help her walk and move around better, with very good results. She also tested Golda\'s blood and confirmed Dr. Conley\'s diagnosis. Together, she and Dr. Conley, teamed up to administer a regimen of drugs to hopefully pull our beloved whippet out of the throws of IMHA.\r\n\r\nThe next step was research. I dedicated myself to find every stitch of information available online about IMHA. While there was a lot of information out there, it was a monumental task to compile. And as it turned out, no one had a strategy to combat the condition. That\'s when I decided to combine the information I found online and go with my gut -- of course, with input from our vets. To make matters worse, my husband had just sustained a ruptured achilles tendon, so in many ways, I was on my own in taking care of Golda. His inability to help carry her outside for potty brakes is what pushed me to design and develop the ___________. Without it, I never would have been able to handle the difficult task of taking Golda in and out of the house.\r\n\r\nMy online research lead me to _________ a supplement given to Chernobyl victims to help rebuild their damaged red blood cells. I also tracked down ________ a supplement that mimics mother\'s milk. Coconut water.\r\nExecuting the Plan\r\nOnce I had what I thought was the right supplements and nutrition for the battle ahead, I began to give put my plan into action. Golda\'s weight loss and lack of appetite was the number one priority. I had to make her eat and the only thing I could do was force feed her baby food.\r\n\r\nSherry to fill in everyday routine, feeding, etc.\r\n\r\nThroughout this process, we continued to visit Dr. Mitchener for Golda\'s weekly acupuncture sessions, this time targeting parts of the body to help her body\'s bone marrow generate new red blood cells. For the first two weeks, Golda was still weak and showing no signs of improvement. Dr. Mitchener took another packed cell volume test only to find that her red blood cell count had dropped even further. At this point, we wondered if we were doing the right thing by putting Golda through all of this heartache. But, Norman and I had seen something in Golda that led us to believe she was actually feeling better. Dr. Mitchener said that we should take Golda home and ask her what she wants to do…later that evening, we did just that and Golda gave us her answer: She was not ready to give up and neither were we! We continued on our regimen of drugs, supplements and nutritious food. Six weeks later, her PCV was 23! We were making progress, and are continuing to make progress to this day.\r\n\r\nI sincerely hope Healthy Dog Headquarters will help your dog as you go battle the effects of Canine IMHA. I\'ve worked diligently to provide the best information available, based on our own experience to help your dog fight and recover from this illness. Please look around our website and help make your dog a healthy dog!", "Golda\'s Story: Saving Our Dog from Immune Mediated Hemolytic Anemia", "", "inherit", "closed", "closed", "", "337-revision-v1", "", "", "2013-10-25 15:13:05", "2013-10-25 15:13:05", "", "337", "http://healthydoghq.com/337-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("415", "1", "2013-10-25 15:15:26", "2013-10-25 15:15:26", "", "golda-acupunture", "", "inherit", "closed", "closed", "", "golda-acupunture", "", "", "2013-10-25 15:15:26", "2013-10-25 15:15:26", "", "337", "http://healthydoghq.com/wp-content/uploads/2013/10/golda-acupunture.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("416", "1", "2013-10-25 15:16:05", "2013-10-25 15:16:05", "<img class=\"alignright size-medium wp-image-409\" alt=\"golda-lure-coursing\" src=\"http://healthydoghq.com/wp-content/uploads/2013/10/golda-lure-coursing1-300x197.jpg\" width=\"300\" height=\"197\" />My husband, Norman and I, have had the privilege of owning whippets for twenty-five years. Over this space of time, we\'ve had a total of six of these sensitive, loving animals, each one with its own personality and way of doing things. Our first whippet, Devo, ruled the pack. Without a doubt, she was at the top of the pecking order at our house, after my husband. We lost her about ten years ago at the age of 15. Fortunately for us, all of our whippets have enjoyed long and healthy lives -- then we got Golda.\r\n\r\nGolda was originally owned by a good friend who owns and shows whippets. In 1992, our friend brought home a 12-week old red and white spitfire named \"Blue Skies Golden Pony\" and called her \"Golda\". The puppy was a gregarious fence jumper with a big heart and personality to match. Golda and Norman hit it off the first time they met. In many ways, Golda became his dog right from the start, and after retiring from the show ring, Golda came to live with us in 2004.\r\n\r\nFrom the first day we adopted her, life with Golda has been an absolute pleasure. She has always been active, friendly and loving, with no agenda, truly the best dog we\'ve ever known. Golda\'s great love in life was chasing the frisbee. Her speed and agility made her great at jumping to terrific heights and making spectacular catches in mid-air. In 2008, we noticed that she landed a bit funny after a routine jump, but she otherwise seemed fine. The next day, we awoke to find her paralyzed from the neck down. Frantically, we took her to several vets to find out that she had suffered from a Fibrocartilaginous Embolism (Canine FCE) -- a blockage in a blood vessel in the spinal cord. It’s often referred to as a spinal cord stroke. Our vet treated her with steroids and for the next six weeks, we became her legs, carrying her outside and holding her up as she went to the bathroom. Over time, she regained the use of her limbs and was eventually able to resume her favorite pastime of chasing the frisbee, albeit at a much reduced speed and intensity. She wasn\'t quite as coordinated as before, but we felt lucky that she was walking again. Little did we know it at the time, but the experience of dealing with Canine FCE would help prepare us for an equally devastating aliment: Canine Immune Mediated Hemolytic Anemia (IMHA) a few short years later.\r\n\r\n<img class=\"size-medium wp-image-408 alignleft\" alt=\"blood-transfusion\" src=\"http://healthydoghq.com/wp-content/uploads/2013/10/blood-transfusion-300x224.jpg\" width=\"288\" height=\"215\" />Even after her bout with Canine FCE, Golda\'s quality of life was very good, but in May of 2013, she had a set back. She once again was having trouble walking and maintaining her balance. We immediately assumed she had a reoccurrence of FCE. The symptoms were virtually the same, but this time, she began loosing weight and her gums were very pale in color. We took her to our vet, Dr. Bill Conley at Summer Animal Hospital, who examined her, ran a complete blood count (CBC) and a packed cell volume test (PCV). The results were staggering. The PCV test put her red blood cell count at 8%!!!  He said he had never seen a dog still alive with such a low blood count and that a normal dog\'s red blood cell volume is between 35 and 55%. Dr. Conley immediately recommended a blood transfusion. Needless to say, we were devastated at the news! How could we have missed all of the signs!? How could we have let Golda get into such a weakened state!? We agreed to the transfusion which \"stabilized\" her red blood cell volume to a still low 15%. As we were leaving his office, Dr. Conley prepared us for the worst by informing us that Golda was suffering from Immune Mediated Hemolytic Anemia (IMHA), formerly known as Canine Auto-Immune Hemolytic Anemia (AIHA), and that the recovery for this disease was \"very low\".  With a heavy heart, we thanked him and took Golda home for what we felt would surely be the last few days of her life.\r\n\r\nThe ride home from the vet\'s office seemed unusually long. On the way, we decided that we would do everything we could do, within reason, to give Golda the chance to recover. We owed that to her for all of the love and joy she had brought to us over the years. When we got home, we assessed our situation and began to formulate a plan to give her the opportunity to heal. Fortunately for us, and Golda, we had some great vets and quite a bit of luck on our side!\r\nGolda\'s Condition\r\n<ul>\r\n	<li>Weight: 19 pounds, normally 27</li>\r\n	<li>Red Blood Cell Volume: 8%, normal is between 35 and 55%</li>\r\n	<li>Appetite: None, normally she\'s a chow hound never turning down a meal</li>\r\n	<li>Ambulatory: Unable to walk or go to the bathroom on her own</li>\r\n	<li>Mental &amp; Emotional: Lethargic, extremely low energy level</li>\r\n	<li>Color: Pale gums - almost white, skin white, even freckles usually seen on legs &amp; tummy very faded and pale</li>\r\n	<li>Coat: Course, red coloring in coat pale</li>\r\n	<li>Nose: Dry and rough to the touch</li>\r\n	<li>Eyes: Third eye lid showing</li>\r\n</ul>\r\nFormulating a Plan\r\n<img class=\"alignright size-medium wp-image-413\" alt=\"Golda-chicken\" src=\"http://healthydoghq.com/wp-content/uploads/2013/10/Golda-chicken-300x225.jpg\" width=\"300\" height=\"225\" />Once we assessed Golda\'s condition, we began to formulate a plan. First, we reached out to Dr. Kathy Mitchener at Angel Care, a veterinary clinic specializing in treating canine cancer to let her know about Golda\'s IMHA diagnosis. Dr. Mitchener had been performing weekly acupuncture sessions on Golda over the past couple of months in order to help her walk and move around better, with very good results. She also tested Golda\'s blood and confirmed Dr. Conley\'s diagnosis. Together, she and Dr. Conley, teamed up to administer a regimen of drugs to hopefully pull our beloved whippet out of the throws of IMHA.\r\n\r\nThe next step was research. I dedicated myself to find every stitch of information available online about IMHA. While there was a lot of information out there, it was a monumental task to compile. And as it turned out, no one had a strategy to combat the condition. That\'s when I decided to combine the information I found online and go with my gut -- of course, with input from our vets. To make matters worse, my husband had just sustained a ruptured achilles tendon, so in many ways, I was on my own in taking care of Golda. His inability to help carry her outside for potty brakes is what pushed me to design and develop the ___________. Without it, I never would have been able to handle the difficult task of taking Golda in and out of the house.\r\n\r\nMy online research lead me to _________ a supplement given to Chernobyl victims to help rebuild their damaged red blood cells. I also tracked down ________ a supplement that mimics mother\'s milk. Coconut water.\r\nExecuting the Plan\r\nOnce I had what I thought was the right supplements and nutrition for the battle ahead, I began to give put my plan into action. Golda\'s weight loss and lack of appetite was the number one priority. I had to make her eat and the only thing I could do was force feed her baby food.\r\n\r\nSherry to fill in everyday routine, feeding, etc.\r\n\r\n<img class=\"size-medium wp-image-415 alignleft\" alt=\"golda-acupunture\" src=\"http://healthydoghq.com/wp-content/uploads/2013/10/golda-acupunture-225x300.jpg\" width=\"225\" height=\"300\" />Throughout this process, we continued to visit Dr. Mitchener for Golda\'s weekly acupuncture sessions, this time targeting parts of the body to help her body\'s bone marrow generate new red blood cells. For the first two weeks, Golda was still weak and showing no signs of improvement. Dr. Mitchener took another packed cell volume test only to find that her red blood cell count had dropped even further. At this point, we wondered if we were doing the right thing by putting Golda through all of this heartache. But, Norman and I had seen something in Golda that led us to believe she was actually feeling better. Dr. Mitchener said that we should take Golda home and ask her what she wants to do…later that evening, we did just that and Golda gave us her answer: She was not ready to give up and neither were we! We continued on our regimen of drugs, supplements and nutritious food. Six weeks later, her PCV was 23! We were making progress, and are continuing to make progress to this day.\r\n\r\nI sincerely hope Healthy Dog Headquarters will help your dog as you go battle the effects of Canine IMHA. I\'ve worked diligently to provide the best information available, based on our own experience to help your dog fight and recover from this illness. Please look around our website and help make your dog a healthy dog!", "Golda\'s Story: Saving Our Dog from Immune Mediated Hemolytic Anemia", "", "inherit", "closed", "closed", "", "337-revision-v1", "", "", "2013-10-25 15:16:05", "2013-10-25 15:16:05", "", "337", "http://healthydoghq.com/337-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("417", "1", "2013-10-25 15:30:56", "2013-10-25 15:30:56", "", "what-is-imha", "", "inherit", "closed", "closed", "", "what-is-imha", "", "", "2013-10-25 15:30:56", "2013-10-25 15:30:56", "", "363", "http://healthydoghq.com/wp-content/uploads/2013/10/what-is-imha.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("418", "1", "2013-10-25 15:32:16", "2013-10-25 15:32:16", "<a href=\"http://healthydoghq.com/wp-content/uploads/2013/10/what-is-imha.jpg\"><img class=\"alignright size-full wp-image-417\" alt=\"What is Canine Immune Mediated Hemolytic Anemia\" src=\"http://healthydoghq.com/wp-content/uploads/2013/10/what-is-imha.jpg\" width=\"300\" height=\"200\" /></a>In a nutshell, Canine Immune-Mediated Hemolytic Anemia (formerly called Canine Auto-Immune Hemolytic Anemia (AIHA)) occurs when your dog\'s red blood cells fall below the range that\'s considered normal, or the red blood cells aren\'t functioning properly.\r\nThere are two forms of IMHA - Primary IMHA, and Secondary IMHA\r\nWith Primary IMHA, your dog\'s immune system attacks its own red blood cells without any reason. This is the most common cause of anemia in dogs.\r\n\r\nSecondary IMHA is caused by an underlying cause - cancer, drug, or toxin causes your dogs red blood cells to become modified by an underlying disease process, drug, or toxin\r\n\r\nthrough a disease process, causing the body\'s immune system to destroy them. From the research I have done, there is no absolute known cause, although its theorized the condition can be caused by any number of factors, including: cancer, infection, exposure to chemicals, infection, blood parasites or even snake bites, to name a few.\r\n\r\nIn the case of our dog, Golda, her immune system was killing her red blood cells deep in the bone marrow. The vets deduced that the fall of her red blood cell count occurred gradually over an extended period of time. In fact, the symptoms came on so gradually, that we didn\'t notice she had a problem until it was almost too late. If her blood cell volume had fallen quickly over a short amount of time, the condition would surely have been fatal since her system would not have been able compensate. We were lucky her\'s dropped slowly over time.\r\n\r\nThis gradual drop in her packed cell level would certainly account for our not catching the condition until late into the condition.\r\n\r\nKnowing the symptoms and what to look for are key to a successful outcome in fighting MHA. If you think your dog may be suffering from any type of immunity disorder, please consult your vet. He/she will be able to assess your dog\'s condition  and answer any specific questions you may have.\r\n\r\nWe\'ll explore these symptoms of Canine Immune Mediated Hemolytic Anemia (IMHA) in the next post.", "What is Canine Immune Mediated Hemolytic Anemia (IMHA)?", "", "inherit", "closed", "closed", "", "363-revision-v1", "", "", "2013-10-25 15:32:16", "2013-10-25 15:32:16", "", "363", "http://healthydoghq.com/363-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("419", "1", "2013-10-25 15:43:47", "2013-10-25 15:43:47", "", "golda-skinny", "", "inherit", "closed", "closed", "", "golda-skinny", "", "", "2013-10-25 15:43:47", "2013-10-25 15:43:47", "", "337", "http://healthydoghq.com/wp-content/uploads/2013/10/golda-skinny.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("420", "1", "2013-10-25 15:44:12", "2013-10-25 15:44:12", "<img class=\"alignright size-medium wp-image-409\" alt=\"golda-lure-coursing\" src=\"http://healthydoghq.com/wp-content/uploads/2013/10/golda-lure-coursing1-300x197.jpg\" width=\"300\" height=\"197\" />My husband, Norman and I, have had the privilege of owning whippets for twenty-five years. Over this space of time, we\'ve had a total of six of these sensitive, loving animals, each one with its own personality and way of doing things. Our first whippet, Devo, ruled the pack. Without a doubt, she was at the top of the pecking order at our house, after my husband. We lost her about ten years ago at the age of 15. Fortunately for us, all of our whippets have enjoyed long and healthy lives -- then we got Golda.\r\n\r\nGolda was originally owned by a good friend who owns and shows whippets. In 1992, our friend brought home a 12-week old red and white spitfire named \"Blue Skies Golden Pony\" and called her \"Golda\". The puppy was a gregarious fence jumper with a big heart and personality to match. Golda and Norman hit it off the first time they met. In many ways, Golda became his dog right from the start, and after retiring from the show ring, Golda came to live with us in 2004.\r\n\r\nFrom the first day we adopted her, life with Golda has been an absolute pleasure. She has always been active, friendly and loving, with no agenda, truly the best dog we\'ve ever known. Golda\'s great love in life was chasing the frisbee. Her speed and agility made her great at jumping to terrific heights and making spectacular catches in mid-air. In 2008, we noticed that she landed a bit funny after a routine jump, but she otherwise seemed fine. The next day, we awoke to find her paralyzed from the neck down. Frantically, we took her to several vets to find out that she had suffered from a Fibrocartilaginous Embolism (Canine FCE) -- a blockage in a blood vessel in the spinal cord. It’s often referred to as a spinal cord stroke. Our vet treated her with steroids and for the next six weeks, we became her legs, carrying her outside and holding her up as she went to the bathroom. Over time, she regained the use of her limbs and was eventually able to resume her favorite pastime of chasing the frisbee, albeit at a much reduced speed and intensity. She wasn\'t quite as coordinated as before, but we felt lucky that she was walking again. Little did we know it at the time, but the experience of dealing with Canine FCE would help prepare us for an equally devastating aliment: Canine Immune Mediated Hemolytic Anemia (IMHA) a few short years later.\r\n\r\n<img class=\"size-medium wp-image-408 alignleft\" alt=\"blood-transfusion\" src=\"http://healthydoghq.com/wp-content/uploads/2013/10/blood-transfusion-300x224.jpg\" width=\"288\" height=\"215\" />Even after her bout with Canine FCE, Golda\'s quality of life was very good, but in May of 2013, she had a set back. She once again was having trouble walking and maintaining her balance. We immediately assumed she had a reoccurrence of FCE. The symptoms were virtually the same, but this time, she began loosing weight and her gums were very pale in color. We took her to our vet, Dr. Bill Conley at Summer Animal Hospital, who examined her, ran a complete blood count (CBC) and a packed cell volume test (PCV). The results were staggering. The PCV test put her red blood cell count at 8%!!!  He said he had never seen a dog still alive with such a low blood count and that a normal dog\'s red blood cell volume is between 35 and 55%. Dr. Conley immediately recommended a blood transfusion. Needless to say, we were devastated at the news! How could we have missed all of the signs!? How could we have let Golda get into such a weakened state!? We agreed to the transfusion which \"stabilized\" her red blood cell volume to a still low 15%. As we were leaving his office, Dr. Conley prepared us for the worst by informing us that Golda was suffering from Immune Mediated Hemolytic Anemia (IMHA), formerly known as Canine Auto-Immune Hemolytic Anemia (AIHA), and that the recovery for this disease was \"very low\".  With a heavy heart, we thanked him and took Golda home for what we felt would surely be the last few days of her life.\r\n\r\nThe ride home from the vet\'s office seemed unusually long. On the way, we decided that we would do everything we could do, within reason, to give Golda the chance to recover. We owed that to her for all of the love and joy she had brought to us over the years. When we got home, we assessed our situation and began to formulate a plan to give her the opportunity to heal. Fortunately for us, and Golda, we had some great vets and quite a bit of luck on our side!\r\nGolda\'s Condition\r\n<ul>\r\n	<li>Weight: 19 pounds, normally 27</li>\r\n	<li>Red Blood Cell Volume: 8%, normal is between 35 and 55%</li>\r\n	<li>Appetite: None, normally she\'s a chow hound never turning down a meal</li>\r\n	<li>Ambulatory: Unable to walk or go to the bathroom on her own</li>\r\n	<li>Mental &amp; Emotional: Lethargic, extremely low energy level</li>\r\n	<li>Color: Pale gums - almost white, skin white, even freckles usually seen on legs &amp; tummy very faded and pale</li>\r\n	<li>Coat: Course, red coloring in coat pale</li>\r\n	<li>Nose: Dry and rough to the touch</li>\r\n	<li>Eyes: Third eye lid showing</li>\r\n</ul>\r\nFormulating a Plan\r\n<img class=\"alignright size-full wp-image-419\" alt=\"golda-skinny\" src=\"http://healthydoghq.com/wp-content/uploads/2013/10/golda-skinny.jpg\" width=\"312\" height=\"208\" />Once we assessed Golda\'s condition, we began to formulate a plan. First, we reached out to Dr. Kathy Mitchener at Angel Care, a veterinary clinic specializing in treating canine cancer to let her know about Golda\'s IMHA diagnosis. Dr. Mitchener had been performing weekly acupuncture sessions on Golda over the past couple of months in order to help her walk and move around better, with very good results. She also tested Golda\'s blood and confirmed Dr. Conley\'s diagnosis. Together, she and Dr. Conley, teamed up to administer a regimen of drugs to hopefully pull our beloved whippet out of the throws of IMHA.\r\n\r\nThe next step was research. I dedicated myself to find every stitch of information available online about IMHA. While there was a lot of information out there, it was a monumental task to compile. And as it turned out, no one had a strategy to combat the condition. That\'s when I decided to combine the information I found online and go with my gut -- of course, with input from our vets. To make matters worse, my husband had just sustained a ruptured achilles tendon, so in many ways, I was on my own in taking care of Golda. His inability to help carry her outside for potty brakes is what pushed me to design and develop the ___________. Without it, I never would have been able to handle the difficult task of taking Golda in and out of the house.\r\n\r\nMy online research lead me to _________ a supplement given to Chernobyl victims to help rebuild their damaged red blood cells. I also tracked down ________ a supplement that mimics mother\'s milk. Coconut water.\r\nExecuting the Plan\r\nOnce I had what I thought was the right supplements and nutrition for the battle ahead, I began to give put my plan into action. Golda\'s weight loss and lack of appetite was the number one priority. I had to make her eat and the only thing I could do was force feed her baby food.\r\n\r\nSherry to fill in everyday routine, feeding, etc.\r\n\r\n<img class=\"size-medium wp-image-415 alignleft\" alt=\"golda-acupunture\" src=\"http://healthydoghq.com/wp-content/uploads/2013/10/golda-acupunture-225x300.jpg\" width=\"225\" height=\"300\" />Throughout this process, we continued to visit Dr. Mitchener for Golda\'s weekly acupuncture sessions, this time targeting parts of the body to help her body\'s bone marrow generate new red blood cells. For the first two weeks, Golda was still weak and showing no signs of improvement. Dr. Mitchener took another packed cell volume test only to find that her red blood cell count had dropped even further. At this point, we wondered if we were doing the right thing by putting Golda through all of this heartache. But, Norman and I had seen something in Golda that led us to believe she was actually feeling better. Dr. Mitchener said that we should take Golda home and ask her what she wants to do…later that evening, we did just that and Golda gave us her answer: She was not ready to give up and neither were we! We continued on our regimen of drugs, supplements and nutritious food. Six weeks later, her PCV was 23! We were making progress, and are continuing to make progress to this day.\r\n\r\nI sincerely hope Healthy Dog Headquarters will help your dog as you go battle the effects of Canine IMHA. I\'ve worked diligently to provide the best information available, based on our own experience to help your dog fight and recover from this illness. Please look around our website and help make your dog a healthy dog!", "Golda\'s Story: Saving Our Dog from Immune Mediated Hemolytic Anemia", "", "inherit", "closed", "closed", "", "337-revision-v1", "", "", "2013-10-25 15:44:12", "2013-10-25 15:44:12", "", "337", "http://healthydoghq.com/337-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("421", "1", "2013-10-25 15:44:46", "2013-10-25 15:44:46", "<img class=\"alignright size-medium wp-image-409\" alt=\"golda-lure-coursing\" src=\"http://healthydoghq.com/wp-content/uploads/2013/10/golda-lure-coursing1-300x197.jpg\" width=\"300\" height=\"197\" />My husband, Norman and I, have had the privilege of owning whippets for twenty-five years. Over this space of time, we\'ve had a total of six of these sensitive, loving animals, each one with its own personality and way of doing things. Our first whippet, Devo, ruled the pack. Without a doubt, she was at the top of the pecking order at our house, after my husband. We lost her about ten years ago at the age of 15. Fortunately for us, all of our whippets have enjoyed long and healthy lives -- then we got Golda.\r\n\r\nGolda was originally owned by a good friend who owns and shows whippets. In 1992, our friend brought home a 12-week old red and white spitfire named \"Blue Skies Golden Pony\" and called her \"Golda\". The puppy was a gregarious fence jumper with a big heart and personality to match. Golda and Norman hit it off the first time they met. In many ways, Golda became his dog right from the start, and after retiring from the show ring, Golda came to live with us in 2004.\r\n\r\nFrom the first day we adopted her, life with Golda has been an absolute pleasure. She has always been active, friendly and loving, with no agenda, truly the best dog we\'ve ever known. Golda\'s great love in life was chasing the frisbee. Her speed and agility made her great at jumping to terrific heights and making spectacular catches in mid-air. In 2008, we noticed that she landed a bit funny after a routine jump, but she otherwise seemed fine. The next day, we awoke to find her paralyzed from the neck down. Frantically, we took her to several vets to find out that she had suffered from a Fibrocartilaginous Embolism (Canine FCE) -- a blockage in a blood vessel in the spinal cord. It’s often referred to as a spinal cord stroke. Our vet treated her with steroids and for the next six weeks, we became her legs, carrying her outside and holding her up as she went to the bathroom. Over time, she regained the use of her limbs and was eventually able to resume her favorite pastime of chasing the frisbee, albeit at a much reduced speed and intensity. She wasn\'t quite as coordinated as before, but we felt lucky that she was walking again. Little did we know it at the time, but the experience of dealing with Canine FCE would help prepare us for an equally devastating aliment: Canine Immune Mediated Hemolytic Anemia (IMHA) a few short years later.\r\n\r\n<img class=\"size-medium wp-image-408 alignleft\" alt=\"blood-transfusion\" src=\"http://healthydoghq.com/wp-content/uploads/2013/10/blood-transfusion-300x224.jpg\" width=\"288\" height=\"215\" />Even after her bout with Canine FCE, Golda\'s quality of life was very good, but in May of 2013, she had a set back. She once again was having trouble walking and maintaining her balance. We immediately assumed she had a reoccurrence of FCE. The symptoms were virtually the same, but this time, she began loosing weight and her gums were very pale in color. We took her to our vet, Dr. Bill Conley at Summer Animal Hospital, who examined her, ran a complete blood count (CBC) and a packed cell volume test (PCV). The results were staggering. The PCV test put her red blood cell count at 8%!!!  He said he had never seen a dog still alive with such a low blood count and that a normal dog\'s red blood cell volume is between 35 and 55%. Dr. Conley immediately recommended a blood transfusion. Needless to say, we were devastated at the news! How could we have missed all of the signs!? How could we have let Golda get into such a weakened state!? We agreed to the transfusion which \"stabilized\" her red blood cell volume to a still low 15%. As we were leaving his office, Dr. Conley prepared us for the worst by informing us that Golda was suffering from Immune Mediated Hemolytic Anemia (IMHA), formerly known as Canine Auto-Immune Hemolytic Anemia (AIHA), and that the recovery for this disease was \"very low\".  With a heavy heart, we thanked him and took Golda home for what we felt would surely be the last few days of her life.\r\n\r\nThe ride home from the vet\'s office seemed unusually long. On the way, we decided that we would do everything we could do, within reason, to give Golda the chance to recover. We owed that to her for all of the love and joy she had brought to us over the years. When we got home, we assessed our situation and began to formulate a plan to give her the opportunity to heal. Fortunately for us, and Golda, we had some great vets and quite a bit of luck on our side!\r\nGolda\'s Condition\r\n<ul>\r\n	<li>Weight: 19 pounds, normally 27</li>\r\n	<li>Red Blood Cell Volume: 8%, normal is between 35 and 55%</li>\r\n	<li>Appetite: None, normally she\'s a chow hound never turning down a meal</li>\r\n	<li>Ambulatory: Unable to walk or go to the bathroom on her own</li>\r\n	<li>Mental &amp; Emotional: Lethargic, extremely low energy level</li>\r\n	<li>Color: Pale gums - almost white, skin white, even freckles usually seen on legs &amp; tummy very faded and pale</li>\r\n	<li>Coat: Course, red coloring in coat pale</li>\r\n	<li>Nose: Dry and rough to the touch</li>\r\n	<li>Eyes: Third eye lid showing</li>\r\n</ul>\r\nFormulating a Plan\r\n<img class=\"alignright size-full wp-image-419\" alt=\"golda-skinny\" src=\"http://healthydoghq.com/wp-content/uploads/2013/10/golda-skinny.jpg\" width=\"293\" height=\"195\" />Once we assessed Golda\'s condition, we began to formulate a plan. First, we reached out to Dr. Kathy Mitchener at Angel Care, a veterinary clinic specializing in treating canine cancer to let her know about Golda\'s IMHA diagnosis. Dr. Mitchener had been performing weekly acupuncture sessions on Golda over the past couple of months in order to help her walk and move around better, with very good results. She also tested Golda\'s blood and confirmed Dr. Conley\'s diagnosis. Together, she and Dr. Conley, teamed up to administer a regimen of drugs to hopefully pull our beloved whippet out of the throws of IMHA.\r\n\r\nThe next step was research. I dedicated myself to find every stitch of information available online about IMHA. While there was a lot of information out there, it was a monumental task to compile. And as it turned out, no one had a strategy to combat the condition. That\'s when I decided to combine the information I found online and go with my gut -- of course, with input from our vets. To make matters worse, my husband had just sustained a ruptured achilles tendon, so in many ways, I was on my own in taking care of Golda. His inability to help carry her outside for potty brakes is what pushed me to design and develop the ___________. Without it, I never would have been able to handle the difficult task of taking Golda in and out of the house.\r\n\r\nMy online research lead me to _________ a supplement given to Chernobyl victims to help rebuild their damaged red blood cells. I also tracked down ________ a supplement that mimics mother\'s milk. Coconut water.\r\nExecuting the Plan\r\nOnce I had what I thought was the right supplements and nutrition for the battle ahead, I began to give put my plan into action. Golda\'s weight loss and lack of appetite was the number one priority. I had to make her eat and the only thing I could do was force feed her baby food.\r\n\r\nSherry to fill in everyday routine, feeding, etc.\r\n\r\n<img class=\"size-medium wp-image-415 alignleft\" alt=\"golda-acupunture\" src=\"http://healthydoghq.com/wp-content/uploads/2013/10/golda-acupunture-225x300.jpg\" width=\"225\" height=\"300\" />Throughout this process, we continued to visit Dr. Mitchener for Golda\'s weekly acupuncture sessions, this time targeting parts of the body to help her body\'s bone marrow generate new red blood cells. For the first two weeks, Golda was still weak and showing no signs of improvement. Dr. Mitchener took another packed cell volume test only to find that her red blood cell count had dropped even further. At this point, we wondered if we were doing the right thing by putting Golda through all of this heartache. But, Norman and I had seen something in Golda that led us to believe she was actually feeling better. Dr. Mitchener said that we should take Golda home and ask her what she wants to do…later that evening, we did just that and Golda gave us her answer: She was not ready to give up and neither were we! We continued on our regimen of drugs, supplements and nutritious food. Six weeks later, her PCV was 23! We were making progress, and are continuing to make progress to this day.\r\n\r\nI sincerely hope Healthy Dog Headquarters will help your dog as you go battle the effects of Canine IMHA. I\'ve worked diligently to provide the best information available, based on our own experience to help your dog fight and recover from this illness. Please look around our website and help make your dog a healthy dog!", "Golda\'s Story: Saving Our Dog from Immune Mediated Hemolytic Anemia", "", "inherit", "closed", "closed", "", "337-revision-v1", "", "", "2013-10-25 15:44:46", "2013-10-25 15:44:46", "", "337", "http://healthydoghq.com/337-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("398", "1", "2013-10-25 13:34:12", "2013-10-25 13:34:12", "", "welcome-feature", "", "inherit", "closed", "closed", "", "welcome-feature-2", "", "", "2013-10-25 13:34:12", "2013-10-25 13:34:12", "", "0", "http://healthydoghq.com/wp-content/uploads/2013/10/welcome-feature1.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("423", "1", "2013-10-25 15:46:40", "2013-10-25 15:46:40", "<img class=\"alignright size-medium wp-image-409\" alt=\"golda-lure-coursing\" src=\"http://healthydoghq.com/wp-content/uploads/2013/10/golda-lure-coursing1-300x197.jpg\" width=\"300\" height=\"197\" />My husband, Norman and I, have had the privilege of owning whippets for twenty-five years. Over this space of time, we\'ve had a total of six of these sensitive, loving animals, each one with its own personality and way of doing things. Our first whippet, Devo, ruled the pack. Without a doubt, she was at the top of the pecking order at our house, after my husband. We lost her about ten years ago at the age of 15. Fortunately for us, all of our whippets have enjoyed long and healthy lives -- then we got Golda.\r\n\r\nGolda was originally owned by a good friend who owns and shows whippets. In 1992, our friend brought home a 12-week old red and white spitfire named \"Blue Skies Golden Pony\" and called her \"Golda\". The puppy was a gregarious fence jumper with a big heart and personality to match. Golda and Norman hit it off the first time they met. In many ways, Golda became his dog right from the start, and after retiring from the show ring, Golda came to live with us in 2004.\r\n\r\nFrom the first day we adopted her, life with Golda has been an absolute pleasure. She has always been active, friendly and loving, with no agenda, truly the best dog we\'ve ever known. Golda\'s great love in life was chasing the frisbee. Her speed and agility made her great at jumping to terrific heights and making spectacular catches in mid-air. In 2008, we noticed that she landed a bit funny after a routine jump, but she otherwise seemed fine. The next day, we awoke to find her paralyzed from the neck down. Frantically, we took her to several vets to find out that she had suffered from a Fibrocartilaginous Embolism (Canine FCE) -- a blockage in a blood vessel in the spinal cord. It’s often referred to as a spinal cord stroke. Our vet treated her with steroids and for the next six weeks, we became her legs, carrying her outside and holding her up as she went to the bathroom. Over time, she regained the use of her limbs and was eventually able to resume her favorite pastime of chasing the frisbee, albeit at a much reduced speed and intensity. She wasn\'t quite as coordinated as before, but we felt lucky that she was walking again. Little did we know it at the time, but the experience of dealing with Canine FCE would help prepare us for an equally devastating aliment: Canine Immune Mediated Hemolytic Anemia (IMHA) a few short years later.\r\n\r\n<img class=\"size-medium wp-image-408 alignleft\" alt=\"blood-transfusion\" src=\"http://healthydoghq.com/wp-content/uploads/2013/10/blood-transfusion-300x224.jpg\" width=\"288\" height=\"215\" />Even after her bout with Canine FCE, Golda\'s quality of life was very good, but in May of 2013, she had a set back. She once again was having trouble walking and maintaining her balance. We immediately assumed she had a reoccurrence of FCE. The symptoms were virtually the same, but this time, she began loosing weight and her gums were very pale in color. We took her to our vet, Dr. Bill Conley at Summer Animal Hospital, who examined her, ran a complete blood count (CBC) and a packed cell volume test (PCV). The results were staggering. The PCV test put her red blood cell count at 8%!!!  He said he had never seen a dog still alive with such a low blood count and that a normal dog\'s red blood cell volume is between 35 and 55%. Dr. Conley immediately recommended a blood transfusion. Needless to say, we were devastated at the news! How could we have missed all of the signs!? How could we have let Golda get into such a weakened state!? We agreed to the transfusion which \"stabilized\" her red blood cell volume to a still low 15%. As we were leaving his office, Dr. Conley prepared us for the worst by informing us that Golda was suffering from Immune Mediated Hemolytic Anemia (IMHA), formerly known as Canine Auto-Immune Hemolytic Anemia (AIHA), and that the recovery for this disease was \"very low\".  With a heavy heart, we thanked him and took Golda home for what we felt would surely be the last few days of her life.\r\n\r\nThe ride home from the vet\'s office seemed unusually long. On the way, we decided that we would do everything we could do, within reason, to give Golda the chance to recover. We owed that to her for all of the love and joy she had brought to us over the years. When we got home, we assessed our situation and began to formulate a plan to give her the opportunity to heal. Fortunately for us, and Golda, we had some great vets and quite a bit of luck on our side!\r\nGolda\'s Condition\r\n<ul>\r\n	<li>Weight: 19 pounds, normally 27</li>\r\n	<li>Red Blood Cell Volume: 8%, normal is between 35 and 55%</li>\r\n	<li>Appetite: None, normally she\'s a chow hound never turning down a meal</li>\r\n	<li>Ambulatory: Unable to walk or go to the bathroom on her own</li>\r\n	<li>Mental &amp; Emotional: Lethargic, extremely low energy level</li>\r\n	<li>Color: Pale gums - almost white, skin white, even freckles usually seen on legs &amp; tummy very faded and pale</li>\r\n	<li>Coat: Course, red coloring in coat pale</li>\r\n	<li>Nose: Dry and rough to the touch</li>\r\n	<li>Eyes: Third eye lid showing</li>\r\n</ul>\r\nFormulating a Plan\r\n<img class=\"alignright size-medium wp-image-419\" alt=\"golda-skinny\" src=\"http://healthydoghq.com/wp-content/uploads/2013/10/golda-skinny-300x200.jpg\" width=\"300\" height=\"200\" />Once we assessed Golda\'s condition, we began to formulate a plan. First, we reached out to Dr. Kathy Mitchener at Angel Care, a veterinary clinic specializing in treating canine cancer to let her know about Golda\'s IMHA diagnosis. Dr. Mitchener had been performing weekly acupuncture sessions on Golda over the past couple of months in order to help her walk and move around better, with very good results. She also tested Golda\'s blood and confirmed Dr. Conley\'s diagnosis. Together, she and Dr. Conley, teamed up to administer a regimen of drugs to hopefully pull our beloved whippet out of the throws of IMHA.\r\n\r\nThe next step was research. I dedicated myself to find every stitch of information available online about IMHA. While there was a lot of information out there, it was a monumental task to compile. And as it turned out, no one had a strategy to combat the condition. That\'s when I decided to combine the information I found online and go with my gut -- of course, with input from our vets. To make matters worse, my husband had just sustained a ruptured achilles tendon, so in many ways, I was on my own in taking care of Golda. His inability to help carry her outside for potty brakes is what pushed me to design and develop the ___________. Without it, I never would have been able to handle the difficult task of taking Golda in and out of the house.\r\n\r\nMy online research lead me to _________ a supplement given to Chernobyl victims to help rebuild their damaged red blood cells. I also tracked down ________ a supplement that mimics mother\'s milk. Coconut water.\r\nExecuting the Plan\r\nOnce I had what I thought was the right supplements and nutrition for the battle ahead, I began to give put my plan into action. Golda\'s weight loss and lack of appetite was the number one priority. I had to make her eat and the only thing I could do was force feed her baby food.\r\n\r\nSherry to fill in everyday routine, feeding, etc.\r\n\r\n<img class=\"size-medium wp-image-415 alignleft\" alt=\"golda-acupunture\" src=\"http://healthydoghq.com/wp-content/uploads/2013/10/golda-acupunture-225x300.jpg\" width=\"225\" height=\"300\" />Throughout this process, we continued to visit Dr. Mitchener for Golda\'s weekly acupuncture sessions, this time targeting parts of the body to help her body\'s bone marrow generate new red blood cells. For the first two weeks, Golda was still weak and showing no signs of improvement. Dr. Mitchener took another packed cell volume test only to find that her red blood cell count had dropped even further. At this point, we wondered if we were doing the right thing by putting Golda through all of this heartache. But, Norman and I had seen something in Golda that led us to believe she was actually feeling better. Dr. Mitchener said that we should take Golda home and ask her what she wants to do…later that evening, we did just that and Golda gave us her answer: She was not ready to give up and neither were we! We continued on our regimen of drugs, supplements and nutritious food. Six weeks later, her PCV was 23! We were making progress, and are continuing to make progress to this day.\r\n\r\nI sincerely hope Healthy Dog Headquarters will help your dog as you go battle the effects of Canine IMHA. I\'ve worked diligently to provide the best information available, based on our own experience to help your dog fight and recover from this illness. Please look around our website and help make your dog a healthy dog!", "Golda\'s Story: Saving Our Dog from Immune Mediated Hemolytic Anemia", "", "inherit", "closed", "closed", "", "337-revision-v1", "", "", "2013-10-25 15:46:40", "2013-10-25 15:46:40", "", "337", "http://healthydoghq.com/337-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("431", "1", "2013-10-25 16:18:34", "2013-10-25 16:18:34", "/*\nWelcome to Custom CSS!\n\nCSS (Cascading Style Sheets) is a kind of code that tells the browser how\nto render a web page. You may delete these comments and get started with\nyour customizations.\n\nBy default, your stylesheet will be loaded after the theme stylesheets,\nwhich means that your rules can take precedence and override the theme CSS\nrules. Just write here what you want to change, you don\'t need to copy all\nyour theme\'s stylesheet content.\n*/\n.nav-primary {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\n.nav-primary a:hover, .nav-primary .current-menu-item > a {\n	background-color: #b7c71e;\n	color: rgb(255,255,255);\n}\n\na {\n	color: #b7c71e;\n}\n\na:hover {\n	color: #0089d0;\n}\n\n.entry-title {\n	font-family: \'Montserrat\', sans-serif;\n	color: #0089d0;\n	font-size: 2.1rem;\n	font-weight: 300;\n	line-height: 1;\n}\n\n.entry-title a, .sidebar .widgettitle a {\n	color: #0089d0;\n}\n\n.entry-title a:hover {\n	color: #b7c71e;\n}\n\nh1, h2, h3, h4, h5, h6 {\n	color: #0089d0;\n	margin-bottom: 10px;\n	font-family: \'Montserrat\', sans-serif;\n}\n\n.entry-content a {\n	color: #0089d0;\n}\n\nbody {\n	color: rgb(84,84,84);\n	font-family: \'Lato\', sans-serif;\n	font-size: 1.6rem;\n	font-weight: 300;\n	line-height: 1.5;\n}\n\n#respond label {\n	color: #0089d0;\n}\n\n#reply-title {\n	border-bottom: medium double;\n	color: #0089d0;\n}\n\nbutton, input[type=\"button\"], input[type=\"reset\"], input[type=\"submit\"] {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\nbutton:hover, input[type=\"button\"]:hover, input[type=\"reset\"]:hover, input[type=\"submit\"]:hover {\n	background: none repeat scroll 0 0 #b7c71e;\n}\n\n.simple-social-icons ul li a, .simple-social-icons ul li a:hover {\n	background-color: #b7c71e !important;\n	border-radius: 300px 300px 300px 300px;\n}\n\n.simple-social-icons ul li a {\n	background: #b7c71e !important;\n}\n\n.simple-social-icons ul li a:hover {\n	background-color: #0089d0 !important;\n}\n\n.user-profile a {\n	display: block;\n	font-family: \'Montserrat\', sans-serif;\n}\n\n.site-container {\n	background: #fff url(\'\') repeat-x;\n	border: 10px solid #fff;\n	border-top-left-radius: 20px;\n	border-top-right-radius: 20px;\n	margin: 20px auto;\n	max-width: 1168px;\n}", "safecss", "Modern Blogger Child Theme", "inherit", "closed", "closed", "", "248-revision-v1", "", "", "2013-10-25 16:18:34", "2013-10-25 16:18:34", "", "248", "http://healthydoghq.com/248-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("430", "1", "2013-10-25 16:17:28", "2013-10-25 16:17:28", "/*\nWelcome to Custom CSS!\n\nCSS (Cascading Style Sheets) is a kind of code that tells the browser how\nto render a web page. You may delete these comments and get started with\nyour customizations.\n\nBy default, your stylesheet will be loaded after the theme stylesheets,\nwhich means that your rules can take precedence and override the theme CSS\nrules. Just write here what you want to change, you don\'t need to copy all\nyour theme\'s stylesheet content.\n*/\n.nav-primary {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\n.nav-primary a:hover, .nav-primary .current-menu-item > a {\n	background-color: #b7c71e;\n	color: rgb(255,255,255);\n}\n\na {\n	color: #b7c71e;\n}\n\na:hover {\n	color: #0089d0;\n}\n\n.entry-title {\n	font-family: \'Montserrat\', sans-serif;\n	color: #0089d0;\n	font-size: 2.1rem;\n	font-weight: 300;\n	line-height: 1;\n}\n\n.entry-title a, .sidebar .widgettitle a {\n	color: #0089d0;\n}\n\n.entry-title a:hover {\n	color: #b7c71e;\n}\n\nh1, h2, h3, h4, h5, h6 {\n	color: #b7c71e;\n	margin-bottom: 10px;\n	font-family: \'Montserrat\', sans-serif;\n}\n\n.entry-content a {\n	color: #0089d0;\n}\n\nbody {\n	color: rgb(84,84,84);\n	font-family: \'Lato\', sans-serif;\n	font-size: 1.6rem;\n	font-weight: 300;\n	line-height: 1.5;\n}\n\n#respond label {\n	color: #0089d0;\n}\n\n#reply-title {\n	border-bottom: medium double;\n	color: #0089d0;\n}\n\nbutton, input[type=\"button\"], input[type=\"reset\"], input[type=\"submit\"] {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\nbutton:hover, input[type=\"button\"]:hover, input[type=\"reset\"]:hover, input[type=\"submit\"]:hover {\n	background: none repeat scroll 0 0 #b7c71e;\n}\n\n.simple-social-icons ul li a, .simple-social-icons ul li a:hover {\n	background-color: #b7c71e !important;\n	border-radius: 300px 300px 300px 300px;\n}\n\n.simple-social-icons ul li a {\n	background: #b7c71e !important;\n}\n\n.simple-social-icons ul li a:hover {\n	background-color: #0089d0 !important;\n}\n\n.user-profile a {\n	display: block;\n	font-family: \'Montserrat\', sans-serif;\n}\n\n.site-container {\n	background: #fff url(\'\') repeat-x;\n	border: 10px solid #fff;\n	border-top-left-radius: 20px;\n	border-top-right-radius: 20px;\n	margin: 20px auto;\n	max-width: 1168px;\n}", "safecss", "Modern Blogger Child Theme", "inherit", "closed", "closed", "", "248-revision-v1", "", "", "2013-10-25 16:17:28", "2013-10-25 16:17:28", "", "248", "http://healthydoghq.com/248-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("427", "1", "2013-10-25 16:01:31", "2013-10-25 16:01:31", "Lethargy and pale gums are key symptoms of IMHA", "Golda-pale-gums", "Lethargy and pale gums are key symptoms of IMHA", "inherit", "closed", "closed", "", "golda-pale-gums", "", "", "2013-10-25 16:01:31", "2013-10-25 16:01:31", "", "365", "http://healthydoghq.com/wp-content/uploads/2013/10/Golda-pale-gums.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("429", "1", "2013-10-25 16:05:10", "2013-10-25 16:05:10", "[caption id=\"attachment_427\" align=\"alignright\" width=\"300\"]<img class=\"size-full wp-image-427\" alt=\"Canine Immune Mediated Hemolytic Anemia Symptoms\" src=\"http://healthydoghq.com/wp-content/uploads/2013/10/Golda-pale-gums.jpg\" width=\"300\" height=\"200\" /> Canine Immune Mediated Hemolytic Anemia Symptoms[/caption]\r\n\r\nIn the case of our dog, Golda, the symptoms of Immune Mediated Hemolytic Anemia (IMHA) somewhat mimicked those of a Fibrocartilaginous Embolism (Canine FCE), resulting from an injury she suffered while playing frisbee several years ago. Read Golda\'s Story to learn more.\r\n\r\nGolda\'s symptoms started with the inability to maintain her balance, accompanied by an inability to walk or move her legs. It was only when she began to loose weight and became extremely lethargic did I suspect something else may be causing her problems. Then we noticed her pale gums and I got really scared and rush her to the vet.\r\n<h2>Here are the symptoms to look for with IMHA:</h2>\r\n<ul>\r\n	<li>Inability to balance</li>\r\n	<li>Inability to walk</li>\r\n	<li>Inability to move legs</li>\r\n	<li>Pale gums</li>\r\n	<li>Tired, weak &amp; listless</li>\r\n	<li>Shallow rapid breathing</li>\r\n	<li>Rapid heartbeat</li>\r\n	<li>Lack of appetite, accompanied by weight loss</li>\r\n	<li>Third eyelid</li>\r\n</ul>\r\nIn retrospect, these symptoms should have been easy to detect. In fact, Golda\'s symptoms seemed to come on gradually and we didn\'t notice she had a problem until it was almost too late. If her blood cell volume had fallen quickly over a short amount of time, the condition would surely have been fatal since her system would not have been able compensate. If your dog is having any of these symptoms, please see your vet!\r\n\r\nIn my next post, I\'ll discuss testing for Immune Mediated Hemolytic Anemia.", "Canine Immune Mediated Hemolytic Anemia (IMHA) Symptoms", "", "inherit", "closed", "closed", "", "365-revision-v1", "", "", "2013-10-25 16:05:10", "2013-10-25 16:05:10", "", "365", "http://healthydoghq.com/365-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("432", "1", "2013-10-25 16:19:17", "2013-10-25 16:19:17", "/*\nWelcome to Custom CSS!\n\nCSS (Cascading Style Sheets) is a kind of code that tells the browser how\nto render a web page. You may delete these comments and get started with\nyour customizations.\n\nBy default, your stylesheet will be loaded after the theme stylesheets,\nwhich means that your rules can take precedence and override the theme CSS\nrules. Just write here what you want to change, you don\'t need to copy all\nyour theme\'s stylesheet content.\n*/\n.nav-primary {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\n.nav-primary a:hover, .nav-primary .current-menu-item > a {\n	background-color: #b7c71e;\n	color: rgb(255,255,255);\n}\n\na {\n	color: #b7c71e;\n}\n\na:hover {\n	color: #0089d0;\n}\n\n.entry-title {\n	font-family: \'Montserrat\', sans-serif;\n	color: #0089d0;\n	font-size: 2.1rem;\n	font-weight: 300;\n	line-height: 1;\n}\n\n.entry-title a, .sidebar .widgettitle a {\n	color: #0089d0;\n}\n\n.entry-title a:hover {\n	color: #b7c71e;\n}\n\nh1, h2, h3, h4, h5, h6 {\n	color: #0089d0;\n	margin-bottom: 10px;\n	font-family: \'Montserrat\', sans-serif;\n}\n\nh2 {\n	font-size: 2rem;\n}\n\n.entry-content a {\n	color: #0089d0;\n}\n\nbody {\n	color: rgb(84,84,84);\n	font-family: \'Lato\', sans-serif;\n	font-size: 1.6rem;\n	font-weight: 300;\n	line-height: 1.5;\n}\n\n#respond label {\n	color: #0089d0;\n}\n\n#reply-title {\n	border-bottom: medium double;\n	color: #0089d0;\n}\n\nbutton, input[type=\"button\"], input[type=\"reset\"], input[type=\"submit\"] {\n	background: none repeat scroll 0 0 #0089d0;\n}\n\nbutton:hover, input[type=\"button\"]:hover, input[type=\"reset\"]:hover, input[type=\"submit\"]:hover {\n	background: none repeat scroll 0 0 #b7c71e;\n}\n\n.simple-social-icons ul li a, .simple-social-icons ul li a:hover {\n	background-color: #b7c71e !important;\n	border-radius: 300px 300px 300px 300px;\n}\n\n.simple-social-icons ul li a {\n	background: #b7c71e !important;\n}\n\n.simple-social-icons ul li a:hover {\n	background-color: #0089d0 !important;\n}\n\n.user-profile a {\n	display: block;\n	font-family: \'Montserrat\', sans-serif;\n}\n\n.site-container {\n	background: #fff url(\'\') repeat-x;\n	border: 10px solid #fff;\n	border-top-left-radius: 20px;\n	border-top-right-radius: 20px;\n	margin: 20px auto;\n	max-width: 1168px;\n}", "safecss", "Modern Blogger Child Theme", "inherit", "closed", "closed", "", "248-revision-v1", "", "", "2013-10-25 16:19:17", "2013-10-25 16:19:17", "", "248", "http://healthydoghq.com/248-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("433", "1", "2013-10-25 16:35:35", "2013-10-25 16:35:35", "<img class=\"alignright size-full wp-image-434\" alt=\"canine-imha-pcv-test\" src=\"http://healthydoghq.com/wp-content/uploads/2013/10/imha-testing.jpg\" width=\"300\" height=\"200\" />Testing for Immune Mediated Hemolytic Anemia (IMHA) is a relatively simple procedure involving the drawing of blood to run a couple of important tests, including a complete blood count panel (CBC) and a packed cell volume test (PCV).\r\n\r\nIn layman\'s terms:\r\n<ul>\r\n	<li>A CBC is the measure of white blood cells, red blood cells and platelets.  This test helps to identify problems, such as infection, anemia, low platelet count, and bone marrow disease.</li>\r\n	<li>A PCV is a test to determine the percentage of red blood cells in the blood.</li>\r\n</ul>\r\nFortunately, these tests are easy, accurate and relatively inexpensive, and a valuable tool to let help you formulate a to attack AIHA/IMHA.\r\n\r\nIf your dog is having one or more of symptoms found in my last post (link to last post), please take it to your vet for testing soon!\r\n\r\nCheck out my next post, where I discuss strategies for attacking AIHA/IMHA.", "Canine IMHA: Testing", "", "publish", "closed", "closed", "", "canine-imha-testing", "", "", "2013-10-25 16:35:35", "2013-10-25 16:35:35", "", "0", "http://healthydoghq.com/?p=433", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("434", "1", "2013-10-25 16:34:28", "2013-10-25 16:34:28", "", "canine-imha-pcv-test", "", "inherit", "closed", "closed", "", "imha-testing", "", "", "2013-10-25 16:34:28", "2013-10-25 16:34:28", "", "433", "http://healthydoghq.com/wp-content/uploads/2013/10/imha-testing.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("435", "1", "2013-10-25 16:35:35", "2013-10-25 16:35:35", "<img class=\"alignright size-full wp-image-434\" alt=\"canine-imha-pcv-test\" src=\"http://healthydoghq.com/wp-content/uploads/2013/10/imha-testing.jpg\" width=\"300\" height=\"200\" />Testing for Immune Mediated Hemolytic Anemia (IMHA) is a relatively simple procedure involving the drawing of blood to run a couple of important tests, including a complete blood count panel (CBC) and a packed cell volume test (PCV).\r\n\r\nIn layman\'s terms:\r\n<ul>\r\n	<li>A CBC is the measure of white blood cells, red blood cells and platelets.  This test helps to identify problems, such as infection, anemia, low platelet count, and bone marrow disease.</li>\r\n	<li>A PCV is a test to determine the percentage of red blood cells in the blood.</li>\r\n</ul>\r\nFortunately, these tests are easy, accurate and relatively inexpensive, and a valuable tool to let help you formulate a to attack AIHA/IMHA.\r\n\r\nIf your dog is having one or more of symptoms found in my last post (link to last post), please take it to your vet for testing soon!\r\n\r\nCheck out my next post, where I discuss strategies for attacking AIHA/IMHA.", "Canine IMHA: Testing", "", "inherit", "closed", "closed", "", "433-revision-v1", "", "", "2013-10-25 16:35:35", "2013-10-25 16:35:35", "", "433", "http://healthydoghq.com/433-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("439", "1", "2013-10-25 17:02:03", "2013-10-25 17:02:03", "", "logo", "", "inherit", "closed", "closed", "", "logo-2", "", "", "2013-10-25 17:02:03", "2013-10-25 17:02:03", "", "0", "http://healthydoghq.com/wp-content/uploads/2013/10/logo1.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("437", "1", "2013-10-25 16:56:13", "2013-10-25 16:56:13", "", "logo", "", "inherit", "closed", "closed", "", "logo", "", "", "2013-10-25 16:56:13", "2013-10-25 16:56:13", "", "0", "http://healthydoghq.com/wp-content/uploads/2013/10/logo.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("438", "1", "2013-10-25 16:56:16", "2013-10-25 16:56:16", "", "logox2", "", "inherit", "closed", "closed", "", "logox2", "", "", "2013-10-25 16:56:16", "2013-10-25 16:56:16", "", "0", "http://healthydoghq.com/wp-content/uploads/2013/10/logox2.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("440", "1", "2013-10-25 17:12:24", "2013-10-25 17:12:24", "", "logox2", "", "inherit", "closed", "closed", "", "logox2-2", "", "", "2013-10-25 17:12:24", "2013-10-25 17:12:24", "", "0", "http://healthydoghq.com/wp-content/uploads/2013/10/logox21.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("441", "1", "2013-10-25 17:18:21", "2013-10-25 17:18:21", "", "logo-320", "", "inherit", "closed", "closed", "", "logo-320", "", "", "2013-10-25 17:18:21", "2013-10-25 17:18:21", "", "0", "http://healthydoghq.com/wp-content/uploads/2013/10/logo-320.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("442", "1", "2013-10-25 17:28:17", "2013-10-25 17:28:17", "", "logo-320", "", "inherit", "closed", "closed", "", "logo-320-2", "", "", "2013-10-25 17:28:17", "2013-10-25 17:28:17", "", "0", "http://healthydoghq.com/wp-content/uploads/2013/10/logo-3201.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("443", "1", "2013-10-25 17:28:18", "2013-10-25 17:28:18", "", "logo-728", "", "inherit", "closed", "closed", "", "logo-728", "", "", "2013-10-25 17:28:18", "2013-10-25 17:28:18", "", "0", "http://healthydoghq.com/wp-content/uploads/2013/10/logo-728.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("444", "1", "2013-10-25 17:50:58", "2013-10-25 17:50:58", "", "logo3", "", "inherit", "closed", "closed", "", "logo3", "", "", "2013-10-25 17:50:58", "2013-10-25 17:50:58", "", "0", "http://healthydoghq.com/wp-content/uploads/2013/10/logo3.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("445", "1", "2013-10-25 17:57:30", "2013-10-25 17:57:30", "", "logo650", "", "inherit", "closed", "closed", "", "logo650", "", "", "2013-10-25 17:57:30", "2013-10-25 17:57:30", "", "0", "http://healthydoghq.com/wp-content/uploads/2013/10/logo650.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("446", "1", "2013-10-25 18:10:16", "2013-10-25 18:10:16", "", "logo600", "", "inherit", "closed", "closed", "", "logo600", "", "", "2013-10-25 18:10:16", "2013-10-25 18:10:16", "", "0", "http://healthydoghq.com/wp-content/uploads/2013/10/logo600.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("447", "1", "2013-10-25 18:11:47", "2013-10-25 18:11:47", "", "logo580", "", "inherit", "closed", "closed", "", "logo580", "", "", "2013-10-25 18:11:47", "2013-10-25 18:11:47", "", "0", "http://healthydoghq.com/wp-content/uploads/2013/10/logo580.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("448", "1", "2013-10-25 18:23:37", "2013-10-25 18:23:37", "", "bowsiewowsie-ad", "", "inherit", "closed", "closed", "", "bowsiewowsie-ad", "", "", "2013-10-25 18:23:37", "2013-10-25 18:23:37", "", "0", "http://healthydoghq.com/wp-content/uploads/2013/10/bowsiewowsie-ad.jpg", "0", "attachment", "image/jpeg", "0");

/* INSERT TABLE DATA: wp_term_relationships */
INSERT INTO `wp_term_relationships` VALUES("10", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("24", "13", "0");
INSERT INTO `wp_term_relationships` VALUES("27", "13", "0");
INSERT INTO `wp_term_relationships` VALUES("238", "37", "0");
INSERT INTO `wp_term_relationships` VALUES("237", "37", "0");
INSERT INTO `wp_term_relationships` VALUES("236", "37", "0");
INSERT INTO `wp_term_relationships` VALUES("64", "36", "0");
INSERT INTO `wp_term_relationships` VALUES("65", "36", "0");
INSERT INTO `wp_term_relationships` VALUES("66", "36", "0");
INSERT INTO `wp_term_relationships` VALUES("241", "13", "0");
INSERT INTO `wp_term_relationships` VALUES("80", "39", "0");
INSERT INTO `wp_term_relationships` VALUES("81", "39", "0");
INSERT INTO `wp_term_relationships` VALUES("82", "39", "0");
INSERT INTO `wp_term_relationships` VALUES("83", "39", "0");
INSERT INTO `wp_term_relationships` VALUES("84", "39", "0");
INSERT INTO `wp_term_relationships` VALUES("85", "39", "0");
INSERT INTO `wp_term_relationships` VALUES("86", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("433", "41", "0");
INSERT INTO `wp_term_relationships` VALUES("5", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("337", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("363", "41", "0");
INSERT INTO `wp_term_relationships` VALUES("363", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("365", "41", "0");
INSERT INTO `wp_term_relationships` VALUES("365", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("337", "51", "0");
INSERT INTO `wp_term_relationships` VALUES("87", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("88", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("433", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("89", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("90", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("91", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("337", "41", "0");
INSERT INTO `wp_term_relationships` VALUES("183", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("239", "13", "0");
INSERT INTO `wp_term_relationships` VALUES("383", "13", "0");
INSERT INTO `wp_term_relationships` VALUES("211", "36", "0");
INSERT INTO `wp_term_relationships` VALUES("212", "36", "0");
INSERT INTO `wp_term_relationships` VALUES("213", "36", "0");
INSERT INTO `wp_term_relationships` VALUES("214", "36", "0");
INSERT INTO `wp_term_relationships` VALUES("215", "36", "0");
INSERT INTO `wp_term_relationships` VALUES("216", "36", "0");
INSERT INTO `wp_term_relationships` VALUES("217", "36", "0");
INSERT INTO `wp_term_relationships` VALUES("218", "36", "0");
INSERT INTO `wp_term_relationships` VALUES("219", "36", "0");
INSERT INTO `wp_term_relationships` VALUES("220", "36", "0");
INSERT INTO `wp_term_relationships` VALUES("221", "36", "0");
INSERT INTO `wp_term_relationships` VALUES("222", "36", "0");
INSERT INTO `wp_term_relationships` VALUES("223", "36", "0");
INSERT INTO `wp_term_relationships` VALUES("224", "36", "0");
INSERT INTO `wp_term_relationships` VALUES("225", "36", "0");
INSERT INTO `wp_term_relationships` VALUES("226", "36", "0");
INSERT INTO `wp_term_relationships` VALUES("227", "36", "0");
INSERT INTO `wp_term_relationships` VALUES("228", "36", "0");
INSERT INTO `wp_term_relationships` VALUES("229", "36", "0");
INSERT INTO `wp_term_relationships` VALUES("230", "36", "0");
INSERT INTO `wp_term_relationships` VALUES("231", "36", "0");
INSERT INTO `wp_term_relationships` VALUES("232", "38", "0");
INSERT INTO `wp_term_relationships` VALUES("233", "38", "0");
INSERT INTO `wp_term_relationships` VALUES("234", "38", "0");
INSERT INTO `wp_term_relationships` VALUES("235", "38", "0");

/* INSERT TABLE DATA: wp_term_taxonomy */
INSERT INTO `wp_term_taxonomy` VALUES("1", "1", "category", "", "0", "4");
INSERT INTO `wp_term_taxonomy` VALUES("2", "2", "product_type", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("3", "3", "product_type", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("4", "4", "product_type", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("5", "5", "product_type", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("6", "6", "shop_order_status", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("7", "7", "shop_order_status", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("8", "8", "shop_order_status", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("9", "9", "shop_order_status", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("10", "10", "shop_order_status", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("11", "11", "shop_order_status", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("12", "12", "shop_order_status", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("13", "13", "nav_menu", "", "0", "5");
INSERT INTO `wp_term_taxonomy` VALUES("44", "44", "category", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("41", "41", "post_tag", "Canine Immune-Mediated Hemolytic Anemia (IMHA) causes yourr dogs immune system to destroy its own red blood cells", "0", "4");
INSERT INTO `wp_term_taxonomy` VALUES("49", "48", "category", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("50", "49", "post_tag", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("51", "50", "category", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("42", "42", "category", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("43", "43", "category", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("45", "45", "category", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("46", "46", "category", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("36", "36", "nav_menu", "", "0", "24");
INSERT INTO `wp_term_taxonomy` VALUES("37", "37", "nav_menu", "", "0", "3");
INSERT INTO `wp_term_taxonomy` VALUES("38", "38", "nav_menu", "", "0", "4");
INSERT INTO `wp_term_taxonomy` VALUES("39", "39", "nav_menu", "", "0", "6");

/* INSERT TABLE DATA: wp_terms */
INSERT INTO `wp_terms` VALUES("1", "Canine Health", "canine-health", "0");
INSERT INTO `wp_terms` VALUES("2", "simple", "simple", "0");
INSERT INTO `wp_terms` VALUES("3", "grouped", "grouped", "0");
INSERT INTO `wp_terms` VALUES("4", "variable", "variable", "0");
INSERT INTO `wp_terms` VALUES("5", "external", "external", "0");
INSERT INTO `wp_terms` VALUES("6", "pending", "pending", "0");
INSERT INTO `wp_terms` VALUES("7", "failed", "failed", "0");
INSERT INTO `wp_terms` VALUES("8", "on-hold", "on-hold", "0");
INSERT INTO `wp_terms` VALUES("9", "processing", "processing", "0");
INSERT INTO `wp_terms` VALUES("10", "completed", "completed", "0");
INSERT INTO `wp_terms` VALUES("11", "refunded", "refunded", "0");
INSERT INTO `wp_terms` VALUES("12", "cancelled", "cancelled", "0");
INSERT INTO `wp_terms` VALUES("13", "Primary Navigation Menu", "primary-navigation-menu", "0");
INSERT INTO `wp_terms` VALUES("41", "Canine Immune-Mediated Hemolytic Anemia (IMHA)", "canine-immune-mediated-hemolytic-anemia-imha", "0");
INSERT INTO `wp_terms` VALUES("44", "Holistic Wellness", "holistic-wellness", "0");
INSERT INTO `wp_terms` VALUES("45", "Fun &amp; Play", "fun-play", "0");
INSERT INTO `wp_terms` VALUES("46", "Grooming", "grooming", "0");
INSERT INTO `wp_terms` VALUES("50", "Golda\'s Story", "goldas-story", "0");
INSERT INTO `wp_terms` VALUES("49", "c", "c", "0");
INSERT INTO `wp_terms` VALUES("48", "About Us", "about-us", "0");
INSERT INTO `wp_terms` VALUES("43", "Dog Training &amp; Behavior", "dog-training-behavior", "0");
INSERT INTO `wp_terms` VALUES("42", "Nutrition", "nutrition", "0");
INSERT INTO `wp_terms` VALUES("36", "Primary Navigation", "primary-navigation", "0");
INSERT INTO `wp_terms` VALUES("37", "Secondary Navigation", "secondary-navigation", "0");
INSERT INTO `wp_terms` VALUES("38", "Mobile Navigation", "mobile-navigation", "0");
INSERT INTO `wp_terms` VALUES("39", "Contributors", "contributors", "0");

/* INSERT TABLE DATA: wp_usermeta */
INSERT INTO `wp_usermeta` VALUES("1", "1", "first_name", "");
INSERT INTO `wp_usermeta` VALUES("2", "1", "last_name", "");
INSERT INTO `wp_usermeta` VALUES("3", "1", "nickname", "healthydog");
INSERT INTO `wp_usermeta` VALUES("4", "1", "description", "");
INSERT INTO `wp_usermeta` VALUES("5", "1", "rich_editing", "true");
INSERT INTO `wp_usermeta` VALUES("6", "1", "comment_shortcuts", "false");
INSERT INTO `wp_usermeta` VALUES("7", "1", "admin_color", "fresh");
INSERT INTO `wp_usermeta` VALUES("8", "1", "use_ssl", "0");
INSERT INTO `wp_usermeta` VALUES("9", "1", "show_admin_bar_front", "true");
INSERT INTO `wp_usermeta` VALUES("10", "1", "wp_capabilities", "a:1:{s:13:\"administrator\";b:1;}");
INSERT INTO `wp_usermeta` VALUES("11", "1", "wp_user_level", "10");
INSERT INTO `wp_usermeta` VALUES("12", "1", "dismissed_wp_pointers", "wp330_toolbar,wp330_saving_widgets,wp340_choose_image_from_library,wp340_customize_current_theme_link,wp350_media,wp360_revisions,wp360_locks");
INSERT INTO `wp_usermeta` VALUES("13", "1", "show_welcome_panel", "1");
INSERT INTO `wp_usermeta` VALUES("14", "1", "wp_dashboard_quick_press_last_post_id", "319");
INSERT INTO `wp_usermeta` VALUES("15", "1", "managenav-menuscolumnshidden", "a:3:{i:0;s:11:\"link-target\";i:1;s:3:\"xfn\";i:2;s:11:\"description\";}");
INSERT INTO `wp_usermeta` VALUES("16", "1", "metaboxhidden_nav-menus", "a:2:{i:0;s:8:\"add-post\";i:1;s:12:\"add-post_tag\";}");
INSERT INTO `wp_usermeta` VALUES("17", "1", "wp_user-settings", "libraryContent=browse&align=right&imgsize=medium&hidetb=1&ed_size=607&urlbutton=none");
INSERT INTO `wp_usermeta` VALUES("18", "1", "wp_user-settings-time", "1382715997");
INSERT INTO `wp_usermeta` VALUES("19", "1", "nav_menu_recently_edited", "13");
INSERT INTO `wp_usermeta` VALUES("20", "1", "_yoast_wpseo_profile_updated", "1381226321");

/* INSERT TABLE DATA: wp_users */
INSERT INTO `wp_users` VALUES("1", "healthydog", "$P$BNo9M8F6awIyyYP6XcRGp1EWu/dv6z0", "healthydog", "admin@healthydoghq.com", "", "2013-09-07 16:30:53", "", "0", "healthydog");

/* INSERT TABLE DATA: wp_woocommerce_termmeta */
INSERT INTO `wp_woocommerce_termmeta` VALUES("1", "13", "order", "0");
INSERT INTO `wp_woocommerce_termmeta` VALUES("24", "36", "order", "0");
INSERT INTO `wp_woocommerce_termmeta` VALUES("25", "37", "order", "0");
INSERT INTO `wp_woocommerce_termmeta` VALUES("26", "38", "order", "0");
INSERT INTO `wp_woocommerce_termmeta` VALUES("27", "39", "order", "0");

SET FOREIGN_KEY_CHECKS = 1;